
//
// @(#)btyaccpar, based on byacc 1.8 (Berkeley)
// Parser skeleton modified for use in the Firebird project by Nickolay Samofatov
//
#define YYBTYACC 1

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "dsql.tab.h"
#include "Parser.h"

#define YYERROR_DETAILED

/*
*	PROGRAM:	Dynamic SQL runtime support
*	MODULE:		parse.y
*	DESCRIPTION:	Dynamic SQL parser
*
* The contents of this file are subject to the Interbase Public
* License Version 1.0 (the "License"); you may not use this file
* except in compliance with the License. You may obtain a copy
* of the License at http://www.Inprise.com/IPL.html
*
* Software distributed under the License is distributed on an
* "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express
* or implied. See the License for the specific language governing
* rights and limitations under the License.
*
* The Original Code was created by Inprise Corporation
* and its predecessors. Portions created by Inprise Corporation are
* Copyright (C) Inprise Corporation.
*
* All Rights Reserved.
* Contributor(s): ______________________________________.
*
* 2002-02-24 Sean Leyne - Code Cleanup of old Win 3.1 port (WINDOWS_ONLY)
* 2001.05.20 Neil McCalden: Allow a udf to be used in a 'group by' clause.
* 2001.05.30 Claudio Valderrama: DROP TABLE and DROP VIEW lead now to two
*   different node types so DDL can tell which is which.
* 2001.06.13 Claudio Valderrama: SUBSTRING is being surfaced.
* 2001.06.30 Claudio valderrama: Feed (line,column) for each node. See node.h.
* 2001.07.10 Claudio Valderrama: Better (line,column) report and "--" for comments.
* 2001.07.28 John Bellardo: Changes to support parsing LIMIT and FIRST
* 2001.08.03 John Bellardo: Finalized syntax for LIMIT, change LIMIT to SKIP
* 2001.08.05 Claudio Valderrama: closed Bug #448062 and other spaces that appear
*   in rdb$*_source fields when altering domains plus one unexpected null pointer.
* 2001.08.12 Claudio Valderrama: adjust SUBSTRING's starting pos argument here
*   and not in gen.c; this closes Bug #450301.
* 2001.10.01 Claudio Valderrama: enable explicit GRANT...to ROLE role_name.
* 2001.10.06 Claudio Valderrama: Honor explicit USER keyword in GRANTs and REVOKEs.
* 2002.07.05 Mark O'Donohue: change keyword DEBUG to KW_DEBUG to avoid
*			clashes with normal DEBUG macro.
* 2002.07.30 Arno Brinkman:
* 2002.07.30 	Let IN predicate handle value_expressions
* 2002.07.30 	tokens CASE, NULLIF, COALESCE added
* 2002.07.30 	See block < CASE expression > what is added to value as case_expression
* 2002.07.30 	function is split up into aggregate_function, numeric_value_function, string_value_function, generate_value_function
* 2002.07.30 	new group_by_function and added to grp_column_elem
* 2002.07.30 	cast removed from function and added as cast_specification to value
* 2002.08.04 Claudio Valderrama: allow declaring and defining variables at the same time
* 2002.08.04 Dmitry Yemanov: ALTER VIEW
* 2002.08.06 Arno Brinkman: ordinal added to grp_column_elem for using positions in group by
* 2002.08.07 Dmitry Yemanov: INT64/LARGEINT are replaced with BIGINT and available in dialect 3 only
* 2002.08.31 Dmitry Yemanov: allowed user-defined index names for PK/FK/UK constraints
* 2002.09.01 Dmitry Yemanov: RECREATE VIEW
* 2002.09.28 Dmitry Yemanov: Reworked internal_info stuff, enhanced
*							exception handling in SPs/triggers,
*							implemented ROWS_AFFECTED system variable
* 2002.10.21 Nickolay Samofatov: Added support for explicit pessimistic locks
* 2002.10.29 Nickolay Samofatov: Added support for savepoints
* 2002.12.03 Dmitry Yemanov: Implemented ORDER BY clause in subqueries.
* 2002.12.18 Dmitry Yemanov: Added support for SQL-compliant labels and LEAVE statement
* 2002.12.28 Dmitry Yemanov: Added support for parametrized events.
* 2003.01.14 Dmitry Yemanov: Fixed bug with cursors in triggers.
* 2003.01.15 Dmitry Yemanov: Added support for runtime trigger action checks.
* 2003.02.10 Mike Nordell  : Undefined Microsoft introduced macros to get a clean compile.
* 2003.05.24 Nickolay Samofatov: Make SKIP and FIRST non-reserved keywords
* 2003.06.13 Nickolay Samofatov: Make INSERTING/UPDATING/DELETING non-reserved keywords
* 2003.07.01 Blas Rodriguez Somoza: Change DEBUG and IN to avoid conflicts in win32 build/bison
* 2003.08.11 Arno Brinkman: Changed GROUP BY to support all expressions and added "AS" support
*						   with table alias. Also removed group_by_function and ordinal.
* 2003.08.14 Arno Brinkman: Added support for derived tables.
* 2003.10.05 Dmitry Yemanov: Added support for explicit cursors in PSQL.
* 2004.01.16 Vlad Horsun: added support for default parameters and
*   EXECUTE BLOCK statement
* Adriano dos Santos Fernandes
*/

#include "firebird.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "../jrd/common.h"
#include <stdarg.h>

#include "gen/iberror.h"
#include "../dsql/dsql.h"
#include "../dsql/node.h"
#include "../jrd/ibase.h"
#include "../jrd/flags.h"
#include "../jrd/jrd.h"
#include "../dsql/errd_proto.h"
#include "../dsql/hsh_proto.h"
#include "../dsql/make_proto.h"
#include "../dsql/keywords.h"
#include "../dsql/misc_func.h"
#include "../jrd/gds_proto.h"
#include "../jrd/err_proto.h"
#include "../jrd/intlobj_new.h"
#include "../common/StatusArg.h"

/* since UNIX isn't standard, we have to define
  stuff which is in <limits.h> (which isn't available
  on all UNIXes... */

const long SHRT_POS_MAX			= 32767;
const long SHRT_UNSIGNED_MAX	= 65535;
const long SHRT_NEG_MAX			= 32768;
const long LONG_POS_MAX			= 2147483647;
const int POSITIVE	= 0;
const int NEGATIVE	= 1;
const int UNSIGNED	= 2;

/*const int MIN_CACHE_BUFFERS	= 250;*/
/*const int DEF_CACHE_BUFFERS	= 1000;*/

/* Fix 69th procedure problem - solution from Oleg Loa */
#define YYSTACKSIZE	2048
#define YYMAXDEPTH	2048

/* Make bison allocate static stack */
#define YYINITDEPTH 2048

/* Using this option causes build problems on Win32 with bison 1.28*/
/*#define YYSTACK_USE_ALLOCA 1*/

#define YYSTYPE YYSTYPE
#if defined(DEBUG) || defined(DEV_BUILD)
#define YYDEBUG		1
#endif

#define YYMALLOC gds__alloc
#define YYFREE gds__free

static const char INTERNAL_FIELD_NAME[] = "DSQL internal"; /* NTX: placeholder */

inline SLONG trigger_type_suffix(const int slot1, const int slot2, const int slot3)
{
	return ((slot1 << 1) | (slot2 << 3) | (slot3 << 5));
}


#include "../dsql/chars.h"

const int MAX_TOKEN_LEN = 256;

using namespace Jrd;
using namespace Dsql;
using namespace Firebird;

#ifdef NOT_USED_OR_REPLACED
static bool		long_int(dsql_nod*, SLONG*);
#endif
static dsql_fld*	make_field (dsql_nod*);
static dsql_fil*	make_file();
#ifdef NOT_USED_OR_REPLACED
static bool	short_int(dsql_nod*, SLONG*, SSHORT);
#endif
static void	stack_nodes (dsql_nod*, DsqlNodStack&);
static Firebird::MetaName toName(dsql_nod* node);

static void	yyabandon (SLONG, ISC_STATUS);

inline void check_bound(const char* const to, const char* const string)
{
	if ((to - string) >= MAX_TOKEN_LEN)
		yyabandon (-104, isc_token_too_long);
}

inline void check_copy_incr(char*& to, const char ch, const char* const string)
{
	check_bound(to, string);
	*to++ = ch;
}

static int yylhs[] = {                                        -1,
    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,   11,   11,   11,   25,   25,   24,
   24,   24,   35,   35,   30,   36,   36,   36,   36,   36,
   28,   28,   34,   34,   29,   29,   38,   38,   39,   31,
   17,   17,   17,   17,   42,   42,   43,   43,   27,   27,
   44,   44,   44,   44,   46,   46,   46,   46,   45,   45,
   47,   47,   47,   32,   32,   52,   33,   33,   40,   40,
    8,   53,   53,   55,   60,   60,   60,   57,   57,   57,
   64,   64,   65,   67,   67,   67,   67,   58,   58,   68,
   68,   69,   69,   69,   69,   69,   54,   71,   71,    6,
   74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
   74,   74,   74,   74,   74,   16,   92,   92,   92,   92,
   92,   92,    7,   99,   99,   99,   99,   75,   98,  103,
  105,   76,   76,   79,   79,   79,   88,  112,  112,  112,
  113,  113,  114,  114,  115,  115,  119,  119,   87,  122,
  122,  127,  124,  124,  125,  125,  130,  130,  131,  132,
  132,  133,  134,   85,   89,   90,  139,  139,  139,  140,
  140,  142,  142,  143,  143,  143,  144,  144,  145,  145,
  146,  146,  141,  141,  147,   86,  116,  116,  148,  149,
  149,  151,  151,  152,  152,  152,  152,  152,  150,  150,
  153,  153,  154,  154,  154,  154,  120,  155,  156,  156,
  157,  157,  158,  158,  159,  159,  159,  118,  118,  118,
   81,   94,   82,   95,  162,  162,  162,  160,  160,  160,
  161,  161,  163,  163,  164,  164,  164,  169,  170,  170,
  108,  108,  166,  166,  126,  126,  121,  172,  173,  173,
  173,  173,   66,  128,  128,  128,  128,  128,  128,  167,
  167,  181,  181,  182,  184,  184,  184,  184,  184,  165,
  183,  183,  187,  187,  187,  187,  189,  190,  191,  186,
  186,  185,  185,  185,  185,  185,  192,  193,  194,  194,
  194,  194,   80,   93,  100,  200,  195,  195,  196,  196,
  201,  201,  203,  202,  202,  206,  205,  205,  205,  198,
  198,  207,  207,  208,  212,  212,  213,  211,  211,  214,
  216,  216,  199,  218,  218,  218,  219,  219,  217,  217,
  209,  210,  221,  221,  221,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
  222,  222,  222,  222,  222,  233,  228,  228,  229,  236,
  225,  226,  237,  241,  241,  241,  243,  243,  245,  244,
  244,  247,  242,  242,  248,  248,  249,  249,  249,  249,
  249,  249,  250,  250,  251,  252,  253,  254,  254,  255,
  234,  234,  230,  256,  224,  257,  239,  239,  239,  239,
  235,  238,  238,  232,  232,  232,  240,  240,  220,  220,
  260,  261,  261,  262,  262,  262,  262,  231,  231,  231,
  264,  266,  265,  267,   14,  268,  268,  268,  269,  269,
  269,   15,  271,  271,  272,  272,  273,   84,   96,  102,
  277,  197,  109,  111,  129,  276,  276,   83,   83,   83,
   97,   97,   97,  101,  101,  101,  278,  278,  278,  279,
  279,  284,  284,  284,  284,  284,  282,  282,  283,  283,
  283,  283,  283,  283,  283,  283,  283,  283,  283,  283,
  283,  283,  283,  280,  280,  281,    2,  286,  286,  286,
  286,  286,  286,  286,  286,  286,  286,  286,  286,  286,
  292,  292,  298,  298,  298,  298,  298,  298,  298,  287,
  287,  299,  299,  299,  299,  299,  299,  299,  299,  299,
  299,  299,  291,  304,  304,  304,  304,  304,  304,  304,
  304,  304,  304,  304,  304,  304,  304,  304,  304,  304,
  304,  304,  304,  304,  304,  304,  304,  304,  304,  304,
  304,  304,  304,  304,  304,  304,  304,  304,  304,  304,
  304,  304,  304,  304,  304,  304,  304,  304,  304,  304,
  304,  304,  301,  301,  303,  303,  302,  300,  300,  300,
  293,  293,  294,  294,  294,  295,  296,  309,  309,  307,
  307,  308,  308,  289,  290,  290,  310,  310,  310,  310,
  310,  288,  311,  311,  312,  312,   10,  313,  313,  313,
  313,  313,  313,  313,  313,  313,  313,  313,  313,  313,
  313,  313,  123,  123,  204,  204,  318,  318,  319,  319,
  319,  168,  168,  317,  317,  322,  322,  324,  324,   61,
   61,  321,  321,  321,  321,  321,  321,  321,  321,  321,
  328,  328,  320,  320,  320,  320,  330,  330,  329,  329,
  329,   63,   63,  325,  325,  325,  323,  323,  323,  334,
  334,  334,  333,  333,  332,  332,  332,  326,  326,  335,
  335,  335,  336,  336,  327,  327,  327,  327,  337,  337,
   21,   21,   21,  339,  339,  339,   19,   19,   19,  341,
  342,  345,  345,  343,  347,  347,    5,   18,  346,  346,
  348,  348,  349,  349,  338,  350,  350,  351,  351,  352,
  352,  352,  352,  352,  352,  353,  353,  354,  354,  355,
  355,  359,  359,  359,  360,  360,  360,  361,  361,  361,
  356,  356,  356,  357,  358,  363,  363,  363,  364,  364,
  362,  362,  365,  367,  367,  366,  366,  340,    4,    4,
    4,  368,  370,  370,  370,  370,  370,  370,  370,  370,
  370,  370,  370,  370,  370,  370,  372,  372,  373,  369,
  369,   20,  374,  374,  376,  376,  375,  375,  275,  377,
  377,  377,  381,  381,  382,  385,  386,  378,  378,  378,
  387,  389,  390,  390,  390,  390,  398,  398,  398,  399,
  399,  399,  391,  391,  392,  392,  401,  401,  402,  402,
  403,  403,  393,  405,  405,  406,  406,  408,  408,  408,
  410,  411,  411,  384,  384,  412,  412,  407,  407,  407,
  413,  414,  415,  417,  417,  418,  419,  409,  409,  420,
  420,  421,  421,   26,  416,  416,  416,  416,  416,  422,
  422,  395,  395,  423,  423,  424,  396,  396,  394,  394,
  397,  397,  425,  426,  426,  426,  426,  426,  427,  427,
  428,  428,  429,  429,  430,  430,  430,  431,  431,  432,
  432,  379,  379,  433,  433,  434,   77,   77,   77,  435,
  435,  436,  436,  380,  380,  380,   12,   12,   12,   13,
  439,  439,  439,  439,  440,  441,  442,  443,    9,    9,
  445,  446,   22,   22,  448,  449,   23,  450,  450,  438,
  438,  438,  447,  444,  444,  223,  227,  227,    3,    3,
  455,  455,  455,  457,  457,  458,  456,  456,  459,  459,
   37,   37,  107,  106,  106,  437,  437,  451,  460,  460,
  258,  258,  258,  171,  452,  452,  135,  135,  135,  135,
  461,  461,  461,  461,  461,  461,  461,  461,  461,  461,
  461,  461,  461,  461,  462,  462,  462,  462,  462,  462,
  462,  462,  468,  468,  468,  468,  468,  468,  468,  468,
  468,  468,  468,  468,  468,  468,  468,  468,  475,  475,
  463,  463,  464,  464,  465,  465,  465,  465,  466,  466,
  470,  470,  471,  471,  471,  471,  472,  472,  472,  472,
  469,  473,  467,  467,  474,  474,  474,  476,  476,  477,
   91,  297,  297,  316,  478,  483,  483,  479,  479,  480,
  480,  481,  481,  484,  484,  484,  482,  482,  485,  486,
  110,  110,  110,  110,  110,  110,  110,  110,  110,  110,
  110,  110,  110,  110,  110,  110,  110,  110,  110,  110,
  110,  110,  110,  110,  110,  110,  110,  110,  180,  180,
  180,  493,  493,  487,  494,  494,  270,  270,  175,  175,
  495,  495,  495,  495,  495,  489,  489,  489,  489,  489,
  274,  176,  176,  177,  178,  178,  178,  178,  178,   59,
   59,   73,   73,  285,  496,   62,  331,  306,  306,  117,
  488,  488,  454,  454,  454,  497,  497,  497,  497,  497,
  497,  497,  497,  497,  497,  497,  497,  497,  501,  501,
  498,  498,  502,  503,  503,  503,  505,  506,  506,  507,
  500,  500,  508,  508,  508,  508,  508,  508,  508,  508,
  508,  508,  508,  508,  508,  508,  508,  508,  508,  508,
  508,  508,  508,  508,  508,  508,  508,  508,  508,  508,
  508,  508,  508,  508,  508,  508,  508,  508,  508,  508,
  508,  508,  508,  508,  508,  508,  508,  508,  508,  509,
  509,  509,  509,  509,  509,  509,  499,  499,  499,  499,
  510,  512,  512,  511,  511,  511,  511,  513,  513,  513,
  453,  453,  490,  491,  491,  515,  515,  515,  515,  515,
  516,  516,  518,  518,  521,  521,  519,  519,  524,  524,
  523,  520,  522,  517,  517,  492,  492,  504,  504,  504,
  504,  504,  504,  504,  504,  504,  504,  400,  400,  388,
  388,  179,  514,   56,   72,  138,  137,  174,  188,  215,
  315,  104,   70,  263,  136,   78,  404,  259,  371,   41,
   50,  383,  314,   48,   51,  246,   49,  344,  305,  305,
  525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
  525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
  525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
  525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
  525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
  525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
  525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
  525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
  525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
  525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
  525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
  525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
  525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
  525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
  525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
  525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
  525,  525,  525,  525,  525,  525,  525,  525,  525,  525,
};
static int yylen[] = {                                         2,
    1,    2,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    9,    9,    6,    1,    0,    1,
    2,    1,    1,    3,    1,    1,    1,    1,    2,    2,
    3,    0,    3,    0,    2,    0,    2,    1,    1,    1,
    9,    9,    6,    6,    3,    0,    3,    0,    1,    1,
    1,    3,    3,    3,    2,    2,    2,    2,    1,    3,
    1,    2,    2,    1,    3,    1,    1,    3,    1,    2,
    2,    2,    3,    8,    1,    1,    5,    0,    1,    3,
    1,    3,    3,    0,    2,    2,    1,    1,    3,    3,
    2,    0,    2,    2,    1,    3,    9,    1,    1,    2,
    2,    7,    2,    2,    4,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    4,    2,
    2,    2,    4,    2,    2,    2,    2,    2,    2,    2,
    2,    1,    0,    1,    1,    6,    6,    1,    1,    0,
    0,    1,    0,    4,    0,    1,    1,    2,    6,    1,
    0,    4,    1,    0,    1,    0,    1,    2,    1,    1,
    1,    2,    6,    1,    1,    6,    2,    5,    0,    0,
    1,    1,    2,    1,    1,    1,    2,    2,    2,    2,
    2,    2,    0,    1,    5,    3,    0,    1,    1,    0,
    1,    1,    2,    3,    4,    2,    2,    3,    0,    1,
    1,    2,    1,    4,    6,    3,    3,    1,    0,    1,
    1,    2,    3,    4,    0,    1,    2,    0,    1,    1,
    5,    5,    5,    5,    4,    4,    0,    3,    2,    0,
    1,    3,    1,    1,    5,    3,    2,    6,    1,    3,
    2,    1,    1,    1,    2,    0,    1,    1,    2,    3,
    6,    1,    0,    1,    1,    1,    1,    1,    1,    0,
    1,    1,    2,    2,    1,    1,    5,    2,    3,    2,
    2,    0,    1,    1,    1,    1,    3,    4,    8,    4,
    0,    1,    1,    2,    2,    0,    3,    3,    1,    2,
    2,    2,    8,    8,    8,    8,    3,    0,    4,    0,
    1,    3,    4,    1,    3,    3,    4,    4,    0,    1,
    0,    1,    2,    6,    1,    1,    4,    1,    0,    6,
    1,    1,    5,    1,    2,    0,    1,    2,    4,    3,
    0,    0,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    5,    2,    3,    1,    8,
    4,    6,   10,    1,    6,    6,    1,    3,    3,    1,
    3,    1,    1,    0,    2,    1,    1,    1,    1,    1,
    1,    1,    5,    3,    3,    2,    2,    3,    3,    3,
    8,    6,    3,    0,    3,    2,    1,    1,    3,    3,
    7,    2,    0,    1,    1,    2,    3,    0,    1,    2,
    4,    1,    3,    2,    2,    2,    1,    1,    1,    1,
    2,    2,    5,    0,    5,    1,    3,    0,    2,    4,
    0,    7,    3,    0,    1,    3,    3,    7,    7,    7,
    7,    0,    0,    0,    0,    3,    0,    6,    8,    8,
    6,    8,    8,    6,    8,    8,    1,    1,    0,    2,
    2,    1,    1,    2,    2,    2,    1,    1,    1,    1,
    1,    3,    3,    3,    3,    3,    3,    5,    5,    5,
    5,    5,    5,    2,    0,    4,    2,    2,    3,    2,
    2,    2,    3,    3,    2,    2,    3,    2,    2,    3,
    1,    2,    2,    3,    2,    2,    2,    2,    3,    1,
    3,    3,    3,    2,    2,    4,    4,    4,    5,    3,
    4,    4,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    2,    1,    1,    1,    1,    1,    0,
    2,    2,    4,    4,    5,    3,    5,    1,    1,    2,
    0,    2,    0,    0,    1,    2,    2,    4,    3,    2,
    2,    7,    1,    0,    1,    0,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    3,    2,    2,    2,    2,
    2,    2,    1,    1,    1,    3,    1,    1,    3,    6,
    1,    1,    1,    4,    5,    1,    3,    1,    3,    1,
    2,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    4,    4,    6,    5,    3,    0,    2,    2,
    0,    3,    0,    4,    1,    5,    4,    1,    4,    1,
    2,    2,    1,    1,    1,    2,    2,    2,    2,    0,
    3,    5,    1,    1,    2,    3,    1,    2,    3,    0,
    1,    1,    1,    5,    5,    6,    1,    1,    1,    2,
    4,    1,    0,    5,    1,    0,    3,    3,    1,    0,
    2,    0,    1,    0,    3,    1,    0,    1,    2,    1,
    1,    1,    1,    1,    1,    2,    2,    1,    2,    3,
    1,    1,    3,    3,    1,    2,    3,    1,    2,    0,
    3,    2,    2,    3,    2,    1,    1,    0,    1,    1,
    1,    3,    2,    3,    0,    1,    3,    4,    5,    6,
    7,    1,    1,    1,    1,    1,    1,    2,    1,    1,
    1,    1,    1,    1,    2,    1,    1,    1,    2,    1,
    1,    3,    3,    0,    2,    0,    2,    0,    4,    3,
    2,    0,    1,    3,    6,    4,    4,    1,    4,    4,
    1,    9,    2,    1,    1,    0,    2,    4,    2,    2,
    4,    2,    1,    1,    1,    1,    1,    3,    1,    3,
    1,    0,    2,    1,    3,    1,    1,    1,    1,    3,
    6,    1,    0,    3,    0,    1,    3,    1,    1,    1,
    4,    5,    5,    1,    1,    2,    4,    4,    2,    3,
    0,    1,    3,    1,    1,    2,    2,    2,    0,    1,
    0,    3,    0,    1,    3,    1,    2,    0,    2,    0,
    2,    0,    4,    1,    2,    1,    1,    0,    1,    3,
    2,    1,    1,    2,    1,    4,    3,    1,    3,    4,
    0,    3,    0,    1,    3,    3,    1,    1,    0,    2,
    0,    1,    1,    2,    4,    0,    9,    6,    6,    8,
    2,    2,    1,    1,    4,    5,    3,    6,    1,    1,
    8,    4,    1,    1,    9,    5,   12,    2,    0,    2,
    4,    0,    4,    1,    3,    3,    1,    1,    7,    7,
    5,    3,    0,    1,    1,    1,    2,    0,    1,    1,
    1,    0,    3,    1,    3,    1,    0,    3,    1,    3,
    1,    3,    3,    1,    1,    3,    1,    3,    3,    2,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    1,    1,
    5,    6,    5,    6,    3,    4,    5,    6,    3,    4,
    3,    4,    4,    5,    6,    7,    3,    4,    4,    5,
    4,    4,    3,    4,    1,    1,    1,    1,    3,    3,
    6,    6,    7,    1,    2,    1,    0,    2,    0,    2,
    0,    2,    0,    1,    1,    0,    1,    0,    3,    3,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    2,    2,    3,    3,    3,    3,    3,    3,    3,    3,
    1,    1,    1,    1,    3,    1,    1,    1,    1,    2,
    2,    3,    0,    4,    1,    0,    1,    3,    1,    2,
    1,    1,    1,    1,    1,    1,    1,    2,    2,    2,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    2,    1,    2,    1,    1,    1,    1,    1,    2,    1,
    1,    1,    1,    1,    1,    4,    5,    5,    5,    5,
    5,    5,    5,    5,    5,    5,    6,    6,    2,    0,
    1,    1,    6,    1,    1,    1,    4,    4,    4,    4,
    4,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    7,
    8,    8,    8,   10,    8,    6,    1,    1,    4,    4,
    7,    2,    0,    7,    6,    6,    4,    1,    1,    1,
    4,    3,    6,    1,    1,    6,    8,    6,    6,    8,
    1,    1,    4,    6,    4,    5,    3,    5,    4,    5,
    1,    1,    1,    3,    5,    4,    6,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    0,    1,
    0,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
};
static int yydefred[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    3,    4,    5,    6,    7,    8,    9,   10,
   11,   12,   13,   14,   15,   16,   17,   18,   19,   20,
   21,   22,   23,   24,    0,  701,  702,  703,  707,  708,
  709,    0,  929,  930,  933,  934,    0,  604,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  497,
  719,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  142,    0,    0,    0,    0,    0,    0,  110,    0,
    0,    0,   81,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  617,
    0,    0, 1422, 1423,    0, 1424, 1425, 1426, 1427, 1428,
 1429, 1430, 1431, 1432,   38, 1433, 1434, 1435, 1436, 1437,
   35, 1438, 1440, 1441, 1442, 1443, 1444,   37, 1445, 1446,
 1439, 1447, 1448, 1449, 1450, 1451, 1452, 1453, 1454, 1455,
 1456, 1457, 1458, 1459, 1460, 1461,    0, 1462, 1463, 1464,
   36, 1465, 1466, 1467, 1468, 1469, 1470, 1471, 1472, 1473,
 1474, 1475, 1476, 1477,    0, 1478, 1479, 1480, 1309, 1311,
 1312, 1313, 1314, 1315, 1316, 1337, 1338, 1317, 1319, 1318,
 1330, 1331, 1324, 1320, 1325, 1321, 1323, 1326, 1322, 1327,
 1328, 1329, 1333, 1334, 1332, 1335, 1336, 1340, 1339, 1341,
 1342, 1343, 1344, 1345, 1346, 1347, 1348, 1349, 1350, 1351,
 1352, 1353, 1354, 1355, 1356, 1357, 1358, 1359, 1360, 1361,
 1362, 1363, 1364, 1365, 1366, 1367, 1368, 1369, 1370, 1371,
 1372, 1373, 1374, 1375, 1376, 1377, 1378, 1379, 1380, 1381,
 1382, 1383, 1384, 1385, 1386, 1387, 1388, 1389, 1390, 1391,
 1392, 1393, 1394, 1395, 1396, 1397, 1398, 1399, 1400, 1401,
 1402, 1403, 1404, 1405, 1406, 1407, 1408, 1409, 1415, 1411,
 1410, 1412, 1413, 1414, 1416, 1417, 1418, 1419, 1420, 1421,
    0,    0,    0,    0,   33,   76,   74, 1301, 1310,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  862, 1303,    0,    0,    0, 1302,  801,
    0,    0,    0,    0,    0,    0,    0,    0,  126, 1308,
  710,    0,    0,    2,    0,    0,    0,    0,  808,  811,
    0,    0,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,  549,  550,  551,  552,
  553,  554,  555,  563,  557,  558,  556,  559,  560,  561,
  562,  564,  566,  569,  565,  567,  568,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,  582,
    0,  533,  534,    0,  498, 1292,    0,    0,  505, 1296,
    0,  502, 1300,    0,  864,    0,  501, 1304,    0,  509,
 1305,    0,  500, 1307,    0,  508,    0,  506, 1295,    0,
  717, 1130,    0,  199,  120,    0,  121,    0,  257,  974,
 1288,  111,    0,  118,  174,    0,    0,  113, 1134,    0,
  122, 1136,    0,  114,    0,  116,    0,  125,    0,  117,
  175,  123,  119,  124,    0, 1287,    0,  907,  908,    0,
    0,   82,    0, 1293,    0, 1291,  625,  618,    0,  624,
  629,  619,  620,  627,  621,  622, 1054,  632,  623,  628,
  630,  631,    0,    0,    0,   31,    0,   40,  961,   39,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  718,    0,    0,    0,
    0,    0,    0,    0,  738,    0,    0,    0,  725,    0,
  728,  730,  731,  732,  733,  734,  735,  741,  742,    0,
  831,    0,    0,  800,    0,    0,    0,  132,    0,    0,
  127,    0,  128,    0,  131,    0,  130,    0,    0,    0,
  772,  773,  780,    0,  779,  781,  783,  788,  776,  774,
  777,  775,  784,  787,  782,  786,    0,    0,    0,    0,
    0,  792,    0,    0,    0,    0,  815,    0,    0,    0,
    0,  510, 1286,    0,    0,    0,    0,    0,  605,    0,
    0,    0,    0,  263,    0,  511,  141,    0,  507, 1284,
  591,  592,    0,    0,    0,    0,    0,    0,  520,    0,
  467,  468,    0,    0,    0, 1056,    0,    0,  599,  598,
    0,    0,  723,  721, 1131,    0,    0,    0,    0,    0,
    0,    0,  202,  160,    0,  138,    0,    0,    0,    0,
  133,    0,  149,  148,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   83,    0,    0,    0,    0,  932,
  626,    0,    0,    0,    0, 1094, 1127,    0, 1282,    0,
 1096, 1195,    0,    0,    0, 1209, 1128,    0, 1122, 1113,
 1112, 1111,    0,    0,    0,    0, 1099,    0,    0, 1114,
 1115, 1123, 1124,    0, 1125, 1126,    0,    0,    0, 1129,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1121, 1117,    0,  971, 1091, 1092, 1093, 1098, 1097,
 1076,    0,    0,    0, 1075,    0,    0, 1080, 1142, 1072,
 1073, 1074, 1077, 1078, 1079, 1116, 1141, 1143, 1144, 1145,
 1161, 1162, 1164, 1165, 1166,    0, 1172, 1227, 1228,    0,
 1244, 1245, 1251, 1252,  258,    0,    0,    0,  445,    0,
    0,    0,  964,   28,    0,    0,    0,    0,   77,   79,
   75,   34,    0,    0,    0,    0,  966,    0,    0,    0,
   55,   57,    0,    0,    0,  715,    0,    0,  768,    0,
    0,  739,    0,  736,    0,  737,  766,    0,  761,    0,
    0,    0,  753,  752,  729,    0,  863,  975,  944,    0,
    0,    0,  804, 1297,  846,    0,    0,  139,    0,    0,
    0,    0,    0,    0,  712,  711,  785,  778,    0, 1299,
    0,    0,    0,  793,  797, 1140,    0,  817,  819,    0,
  820,  822, 1278,  823,    0,  824,  813,    0,    0, 1280,
    0,    0,  799,    0,  218,    0,    0,  157,    0,  610,
    0,  611,  606,  453,    0,  515,  517,  516,  453,  513,
  518,    0,  512,    0,    0,    0,    0,  311,    0,    0,
    0,  524,  525,    0,  584,    0,    0,    0,    0,    0,
    0,    0,  478,  477,    0,  613,    0,    0, 1055,    0,
    0,    0,  452,    0,    0,  198,    0,    0,  207,    0,
  206,    0,    0,  213,  196,    0,  211,  203,    0,    0,
  658,  693,  661,    0,  694,    0,    0,  662,    0,    0,
    0,  685,  697,  657,  680,  659,  660,  655,  642,    0,
  633,  634,  643,    0,    0,  652,  653,  654,  656,    0,
    0,    0,    0,  137,    0,    0,  134,    0,  135,    0,
  136,    0,  152,    0,    0,  239,    0,    0,    0,    0,
  452,    0,    0,  115,    0,  263,    0,    0,   91,    0,
    0,    0,  108,  109, 1132, 1285,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  977,  981,  982,  983,
  984,  985,  986,  987,  988,  989,  990,  991,  992,  993,
    0,    0,    0,    0,    0, 1118,    0,    0,    0,    0,
    0,    0,    0, 1119, 1120,    0, 1100, 1101,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  406, 1306,    0,    0,    0,
    0,    0,    0,    0,    0,  435,    0,    0,    0,    0,
    0,  637,  641,    0,    0,  638,  650,    0,    0,    0,
  443,    0,    0,    0,  963,    0,    0,   50,   80,    0,
    0,    0,    0,    0,  969,    0,    0,    0,    0,    0,
    0,  836,  837,  838,  839,  848,  849,  850,    0,    0,
    0,    0,    0,  714,  705,    0, 1138,  704,    0,  740,
  751,    0,  748,  744,  743,    0,    0,    0,  763,  747,
  754,    0,    0,    0,    0,  936,    0,    0,  844,    0,
    0,    0,    0,    0,  452,    0,  129,  791,  790,  769,
    0,    0,    0,    0,    0,    0,  826,    0,    0,    0,
  827,    0,    0,  904,  810,  809,    0,    0,    0,  158,
    0,  609,    0,  514,    0,  519,  600,    0,  596,    0,
    0,  307,  452,  281, 1289,    0,    0,  249,  253,    0,
    0,  247,    0,  254,    0,    0,    0,  286,  280,  283,
  284,  285,  523,  589,  588,  522,  521,    0,    0,    0,
    0,    0,    0,    0,  530,    0,  472,  473,  471,    0,
    0,    0,  470,    0,  453,    0, 1058,    0,    0,    0,
    0,  594,    0,  593,    0,  204,  208,    0,    0,  212,
    0,    0,    0,  681,  682,  698,    0,  695,    0,    0,
  688,  686,  687,    0,  163,    0,    0,    0,  651,    0,
    0,    0,    0,  689,  140,    0,    0,    0,    0,  452,
    0,  238,    0,  241,  243,  244,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  263,   86,    0,    0,
   85, 1135, 1133,    0,    0,    0,  980,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  884,  886,
    0,  881,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1268,
 1269, 1270, 1271, 1272, 1273, 1276, 1277, 1274, 1275,    0,
    0,    0,    0,    0,    0,    0,    0, 1257,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1238, 1240,
 1239,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1089,  437,    0, 1090, 1085,    0,
    0,    0,    0,    0,    0,    0,    0,  407,  408,    0,
    0, 1095,  973,  972,    0,    0, 1242,    0,    0,    0,
  316,    0,  447,  446,    0,  314,  341,    0,  322,  342,
  965,    0,    0,    0,   78,   48,    0,   27,    0,    0,
    0,    0,  919,    0,  968,    0,  918,    0,    0,    0,
    0,    0,    0,  865,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   54,    0,    0,
   61,   69,   71,    0,    0,   53,  706, 1139,  749,  762,
  757,  756,    0,  767,    0,  976,  945,    0,    0,  847,
    0,  452,    0,    0,    0,    0,    0,  770,  789,    0,
  818,  821,    0,    0,    0,    0,    0,    0,    0,    0,
  608,    0,    0,  217,    0,  221,    0,    0,  455,  264,
  265,  266,  267,  268,  269, 1109,  602,    0,  312,    0,
  251,    0,    0,  246,  453,    0,    0,    0,  526,  527,
  532,  531,    0,  586,  528,  475,  476,  474,    0,    0,
    0,  494,    0,    0, 1060,    0,    0,    0,  597,  595,
  229,  230,  205,    0,  216,  670,  669, 1137,    0,    0,
    0,    0,    0,  696,    0,    0,    0,    0,    0,  167,
  169,  170,  171,    0,    0,  646,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  452,    0,    0,    0,    0,
  231,    0,  453,    0,  454,    0,    0,    0,  177,    0,
    0,    0,    0,    0,    0,  182,  184,  185,  186,    0,
    0,   90,    0,    0,    0,    0,   98,   92,    0,    0,
   97,   93,    0,  943, 1290,    0,    0,  994,    0,    0,
    0, 1020, 1019,    0,    0,    0, 1029, 1048,    0, 1043,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  979,    0,  885,    0,    0,    0,    0,    0,
    0, 1146,    0,    0, 1229,    0,    0,    0,    0,    0,
    0,    0,    0, 1102,    0,    0,    0,    0,    0, 1253,
    0,    0,    0,    0,    0,    0,    0, 1266, 1167, 1168,
 1169, 1230, 1170,    0, 1237,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1104,    0,    0,    0,
 1171, 1241,    0,  639,  255,  636,    0,  309,  442,  342,
  323,    0,    0,    0,   43,   47,   45,   49,    0,    0,
    0,  950,    0,  970,    0,    0,  840,    0,    0,  870,
  868,  866,    0,    0,  867,    0,    0,  949,   73,   65,
   66,   72,   67,   68,    0,    0,    0,    0,  759,  760,
  764,    0,    0,  805,    0,  232,    0,    0,  454,    0,
    0,  771,  830,    0,    0,    0,    0,  828,    0,  906,
  905,    0,  195,    0,    0,    0,  222,    0, 1110,  162,
  453,  453,  313,  341,  250,    0,    0,  272,    0,    0,
    0,    0,    0,  287,  529,    0,    0,    0,    0,    0,
    0,  615,  454,    0, 1062,    0,    0, 1052, 1064, 1065,
    0,  454,    0,    0,    0,  664,    0,  663,  699,    0,
  691,  172,  159,  168,    0,    0,  644,  672,    0,    0,
  674,  677,  679,  452,    0,    0,    0,  341,    0,  147,
    0,  242,    0,    0,    0,  458, 1051, 1067,  454,    0,
  187,  190,  189,  192,  191,  188,  194,  176,  183,    0,
  112,    0,  145,    0,  101,    0,    0,    0,    0,   95,
   96,    0, 1041, 1042,    0,    0,    0,    0,    0,    0,
    0,    0, 1044,    0,    0,    0,    0,    0,    0,    0,
 1030,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  892,
    0,    0,    0,  931, 1152, 1151,    0,    0,  262,    0,
 1148, 1147,    0, 1156, 1155, 1154, 1153,    0, 1150, 1149,
    0,    0, 1259,    0,    0,    0, 1258,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  807,  440,  410,  409,    0,  315,
    0,    0,    0,    0,    0,  956,  955,    0,  954,  952,
  960,  959,  957,    0,    0,    0,  860,  858,    0,    0,
  920,    0,    0,  851,    0,   62,   63,   64,   70,    0,
    0,    0,    0,  341,    0,    0,  461,  454,    0,    0,
    0,    0,  912,  913,  910,    0,  227,  223,  454,    0,
    0,  454,  245,  273,    0,    0,    0,  275,  276,  274,
    0,    0,  288,    0,    0,    0,    0,    0,    0,    0,
  612, 1053,    0,    0,    0,  451,    0,  666,    0,  667,
    0,  649,  647,  645,  676,    0,    0,    0,  454,    0,
  454,    0,  454,  341,  454,  448,    0,    0,  233,  453,
   99,    0,    0,  105,  100,    0,    0,    0,    0,    0,
 1049,    0, 1050,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  894,  883,    0,    0,  895,
    0,  891,    0,  259, 1243, 1267, 1226, 1163,    0,    0,
 1255, 1254,    0, 1260, 1246, 1248,    0, 1235, 1236,    0,
    0,    0,    0,    0,    0,    0, 1249,    0, 1158, 1157,
    0,    0,    0,  328,    0,    0,   25,   26,    0,    0,
  917,  842,    0,  852,    0,    0,    0,  921,    0,  922,
    0,    0,  853,  854,  855,   51,   52,    0,  935,  454,
  454,  454,  449,  234,    0,    0,    0,    0,  224,  173,
  455,  455,  306,    0,    0,  278,    0,    0,    0,  492,
  493,  489,  488,  491,  490, 1070, 1069,  456,  215,  665,
  692,  341,    0,    0,  464,  454,  303,  154,  459,  496,
  460,  178,    0,    0,    0,  103,    0,   87,    0, 1006,
 1014,    0,    0, 1007, 1015, 1010, 1018,    0,    0,    0,
 1008, 1016, 1009, 1017,    0, 1003, 1011, 1004, 1012, 1005,
 1013,  890,    0,    0,    0,  260,    0, 1231, 1256,    0,
 1234, 1220,    0,    0,    0,    0,    0,    0,  640,  332,
  342,  337,  331,    0,    0,    0,    0,  325,  326,    0,
    0,   41,  951,  841,    0,    0,    0,    0,    0,  304,
  462,  463,    0,    0,  874,    0,  812,  317,  318,  279,
    0,  248,    0,  290,  454,  454,  454,  450,    0,    0,
    0,   84,  106,  107,  806,    0,    0,    0,    0,  897,
    0, 1247, 1221, 1222, 1223,    0, 1250,    0, 1225,    0,
  333,    0,  338,    0,  419,    0,  324,    0,    0,    0,
  925,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  305,  465,  466,  236,  235,    0,    0,  896,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  434,  348,  344,  345,  350,    0,
  346,  347,    0,  340,  343,  349,  351,  352,  353,  354,
  355,  356,  357,  358,  361,  362,  363,  364,  365,    0,
    0,  428,  429,  430,    0,  947,  948,  427,    0,    0,
    0,    0,  422,  420,    0,    0,    0,  926,    0,  857,
  938,  937,  875,    0,    0,  277,    0,  295,    0,  294,
  289,  146,  899,    0,  261, 1224,    0,    0,    0,    0,
    0,  416, 1298,  431,  432,    0,    0,  339,    0,    0,
  412,  426,  425, 1294,  424,  341,    0,  327,    0,    0,
    0,    0,    0,  299,  298,  297,  900,    0,    0,    0,
    0,    0,    0,  403,    0,    0,    0,    0,    0,  421,
  423,    0,    0,  302,  300,  301,    0,    0,    0,    0,
    0,    0,    0,    0,  386,  387,  388,  389,  390,  391,
  392,    0,  341,    0,    0,    0,    0,  330,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  385,  341,
  366,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  398,  400,  399,    0,    0,    0,    0,    0,  341,  928,
    0,    0,    0,  377,    0,  380,    0,    0,  341,    0,
    0,  341,  411,    0,  375,    0,  376,    0,    0,  401,
    0,  417,  370,  378,  381,    0,  341,  373,
};
static int yydgoto[] = {                                      21,
   22,   23,   24,   25,   26,   27,   28,   29,   30,   31,
   32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
   42,   43,   44,  291,  815,  314, 1508, 2044, 1478,  292,
 1137,  293,  818, 1142,  294,  295,  488, 1479, 1797,  819,
 1150,  307,  308, 1509, 1510, 1511, 1512,  406,  412,  296,
 1513,  297,   93,  462,  655,  598, 1027, 1665,  763, 1340,
  989,  440, 1309, 1028, 1029, 1030, 1672, 1667, 2145,  463,
 1032, 1033, 2046,   89,  432,   90,  460, 2377, 1941,  438,
  444, 1024,  446,  450,  434,  425,  427,  441,  452,  454,
  448,  329,  541,  543, 1197,  547,  545,  538,  641, 1007,
 1009, 1011, 1004,  394,  395,  812,  489, 1238, 1223, 1045,
 1926,  645, 1014, 1639, 1920,  957, 1167, 1603,  907,  908,
  931,  635,  990, 1304, 1618, 1461, 1305, 1559, 1860, 1619,
 1620, 1621, 1622, 1623, 1046,  435,  455,  581, 1332, 1654,
 1938, 1655, 1656, 1657, 1658, 1659,  582,  426,  631,  965,
  632,  633,  966,  967,  909, 1554, 1555, 1556, 1856,  647,
 1323, 2139, 1324, 1325, 1326, 1240, 1866, 1122, 1242, 1243,
  765,  806, 2000,  430, 1560,  766,  767,  768,  769,  770,
 1867, 1868,  934, 2100, 2407, 1874, 1249, 1234, 1250, 1251,
 1252, 2408, 2409, 2525,  604,  811, 1280, 1467, 2330,  402,
  927, 1465,  928, 1124, 1863,  807, 1468, 1469, 2331, 1792,
 2215, 2337, 2338, 2339, 1674, 2332, 2333, 2334, 2335, 2394,
 2443, 2444,  859, 2446, 2447, 2448, 2449, 2450, 2451, 2452,
 2453, 2454, 2455, 2456, 2457, 2458, 2459, 2460, 1447, 2598,
 2531, 2553, 2602, 2603, 2604, 2605, 2606, 2554, 2555, 2556,
 2557, 2558, 2559, 2560, 2561, 2534,  771,  772, 2461, 2395,
 2472, 2473, 2513, 2462, 2463, 2464, 2506,  773, 1116,  774,
  485,  808,  809,  775,   45, 1892,  413,  613,  946, 1275,
 1645,  947, 1273, 1269,  442,   70,  608,  407,  342,  588,
  391,  595,  399,  418,  599,  416,  410,  596,  609, 1256,
  610,  941, 1585,  392,  776, 1624,  925, 1229,  621,  589,
  948, 1883,  110,  405,  467,  478,  992, 1125, 1126,  993,
 1127, 1625, 1128, 1626,  996,  997,  998,  999, 1293, 1612,
 1610, 1000, 1001, 1002, 1301, 1003, 1298,   46,   47,   48,
   49,   50,   51,  331,  876,   72,  837,  421,  624,  519,
  520,  521,  522,  523,  524,  525,  526,  527,  528,  529,
 1174,  848, 1523, 1831,  849,  850, 1179,  567, 1200,  568,
  881,  569, 1203,  336,  572,  884, 1959,  338,  580,  903,
  320,  321,  777,  537, 1960, 1105,  339,  901,  340,  575,
  895, 1209, 1545,  659, 2082, 2248, 1062,  576,  577,  896,
 1210, 1211,  532,  865, 1844, 1151, 1152, 1153, 1154, 1155,
 2223,  866, 1156, 1157, 1158, 1500, 2233, 2234, 2235, 1492,
  317, 1811, 2354, 2355, 1990, 1373, 1991, 1992, 1993, 2182,
 2378, 2380, 1213, 1214, 1850, 2085,  826, 1483, 2061, 2062,
 2063, 2401, 2478,  861,   53,   54,  660,   55,   56, 2404,
  827,  862,  778,  779, 1481, 1802, 2048, 2049, 2053, 1146,
 1047, 1048, 1049, 1050, 1051, 1052, 1053, 1054, 1055, 1056,
 1057, 1058, 1059, 1060, 1685, 1687, 1688,  616,  952, 1279,
 1597, 1927,  617, 1888, 1889, 1890,  780,  781,  782,  783,
  784,  785, 1077, 1456,  786, 1343,  787,  788,  789,  790,
 2032,  791,  792, 1400,  793,  794,  795,  796,  797,  798,
  799, 2190, 1423,  800,  801,  802, 2030,  803,  804, 1083,
 1406, 1753, 1748, 1084,  299,
};
static int yysindex[] = {                                   4777,
 5304,  100, 3581,  834,  484, 5370, -153,64412,   86,  470,
  539,  -59,  100,  809,65836,66192, 1496,68684,  373,  576,
    0,  831,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  755,    0,    0,    0,    0,    0,
    0,  679,    0,    0,    0,    0,  693,    0,60852,68684,
  946,68684,68684,68684,68684,68684,68684,68684,68684,    0,
    0,  715,  -98,68684,68684,68684, 1018,68684,  981,68684,
68684,    0,68684,68684,68684,68684,68684,  868,    0,   71,
 1226,68684,    0,68684,68684,68684, 1240,68684,68684,68684,
68684,  981,68684,68684,68684,68684,68684,68684,68684,    0,
68684, 1537,    0,    0, 1179,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1542,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1542,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1224, 1251,  130, 1589,    0,    0,    0,    0,    0,68684,
68684,68684,68684, 1288, 1298, 1303, 2034,68684,  589,68684,
 1366, 2842, 1376,    0,    0, 1459, 1392,68684,    0,    0,
 1712, 1783,68684,68684,68684,68684,68684, 1247,    0,    0,
    0,68684, 3572,    0, 1417, 1448,    0, 1063,    0,    0,
68684, 1596,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1124,    0,    0,  -98,    0,    0,68684,  579,    0,    0,
 1877,    0,    0, 1415,    0,  736,    0,    0, 1363,    0,
    0, 1542,    0,    0,  553,    0, 1407,    0,    0, 1544,
    0,    0, 1521,    0,    0, 1244,    0, 1698,    0,    0,
    0,    0,  -98,    0,    0,  532, 1877,    0,    0,   35,
    0,    0, 1667,    0, 1047,    0, 1598,    0, 1542,    0,
    0,    0,    0,    0, 1679,    0, 1588,    0,    0, 1681,
68684,    0, 1693,    0, 1576,    0,    0,    0,68684,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,52509,68684, 1621,    0,68684,    0,    0,    0,
 1604, 1637,66548,68684, 1123, 1699,  218, 1545, 1724, 1786,
 1733, 1745, 1690, 1701,  419, 1584,    0, 1659,68684, 1736,
  -38,  656,68684, 1669,    0, 1571, 1577, 1587,    0, 2842,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1782,
    0,68684,68684,    0,68684,68684, 1866,    0,  -98, 1877,
    0, 1667,    0, 1219,    0, 1542,    0, 1710, 1761, 1732,
    0,    0,    0, 1824,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1821,68684,68684, 1792,
 1663,    0,  122,  174,  632,    0,    0, 1898, 1255, 1677,
 1788,    0,    0,  -74, 1705, 1686, 1711, 1596,    0,  619,
 1083, 1906,68684,    0, 1124,    0,    0, 1910,    0,    0,
    0,    0,68684, 1621,66904, 1735,67260, 2182,    0,60852,
    0,    0,  879,  -98, 1598,    0, 1646, 1957,    0,    0,
 1976, 1830,    0,    0,    0, 2209, 2209,  -98, 1920,  -98,
  516, 1244,    0,    0, 6527,    0,68684,68684,68684,68684,
    0, 1621,    0,    0, 1996,  869, 2249,68684,  879, 1646,
 2028,68684,68684,68684,    0, 2258,57310,43620, 1901,    0,
    0, 2259, 2276, 2284, 1874,    0,    0, 2287,    0, 2293,
    0,    0, 2294, 2296,    0,    0,    0, 2301,    0,    0,
    0,    0,    0, 2306, 1897, 1903,    0, 2309, 2309,    0,
    0,    0,    0, 2320,    0,    0,48768, 2323, 2326,    0,
 2332, 2023, 2334, 2335, 2337, 2345, 2351, 2353,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 2354, 2355, 2357,    0,    0,    0,
    0, 2367,    0,    0,    0,    0,    0,    0,    0, 2368,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,52905,52905,49341,
68684,    0,    0, 5028,    0,    0,    0,    0,    0,    0,
    0, 2325, 2014, 2373,    0,    0, 2377,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2388,    0,    0,    0, 2389,
    0,    0,    0,    0,    0,63344, 2369,  975,    0, 2392,
 2170, 1433,    0,    0,68684,68684,68684,  167,    0,    0,
    0,    0,68684, 2003,68684, 1347,    0,55526,68684, 2123,
    0,    0, 1604, 2045,66548,    0,68684,  152,    0, 1065,
 1917,    0, 2010,    0, 2010,    0,    0, 2405,    0, 2138,
 2035,  981,    0,    0,    0,68684,    0,    0,    0, 2409,
  201, 2396,    0,    0,    0, 1619, 2418,    0, 1621, 2420,
68684,  879, 2200,68684,    0,    0,    0,    0,  903,    0,
 2127, 2427,68684,    0,    0,    0,52905,    0,    0,52905,
    0,    0,    0,    0,49737,    0,    0,52905,  679,    0,
  679,52905,    0, 2185,    0, 2137, 2140,    0,  -98,    0,
 2141,    0,    0,    0, 2214,    0,    0,    0,    0,    0,
    0, 6527,    0,  -98, 2129,63344, 1826,    0, 2230,68684,
63700,    0,    0,  886,    0,68684,  917, 1415, 2114, 2081,
  508,    0,    0,    0,  480,    0,  540, 2125,    0, 1646,
  -98, 1912,    0, 2062,  244,    0, 2069,  981,    0,  -98,
    0, 2243, 2176,    0,    0,  516,    0,    0,  283, 2083,
    0,    0,    0, 2087,    0, 2132, 2486,    0, 2183, 2488,
   33,    0,    0,    0,    0,    0,    0,    0,    0, 1906,
    0,    0,    0, 2438,  184,    0,    0,    0,    0,  228,
 2492, 2493, 2488,    0,  -98, 1877,    0, 1227,    0, 1542,
    0, 2272,    0,  -98,  -98,    0,66904,  736, 2125, 1912,
    0, 2219, 2499,    0, 2167,    0, 2147, 2509,    0, 5949,
 2096, 2178,    0,    0,    0,    0, 2186, 2517,47976, 2520,
    0,    0,    0,44016,  669,  738,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   13, 2187, 1280,52905,  179,    0,68684,52905, 1348, 1409,
52905, 1426, 3469,    0,    0,  981,    0,    0,52905,47976,
49341, 5028, 2120,  654,52905,52905,47976, 2253,52905,52905,
52905,52905,52905,44412,43224, 3469,52905, 1479,52905,  514,
  514, 5028, 1836,  679, 2521,    0,    0,68684,52905,52905,
52905,52905,52905,52905,54814,    0,52905,56240,52905,50133,
 2195,    0,    0, 2303, 2215,    0,    0, 2311, 2525,68684,
    0,68684,    0,68684,    0, 2163, 2165,    0,    0, 2130,
66548,   99, 2280, 2067,    0, 1837, 2555, 2067,55170, 2561,
 2613,    0,    0,    0,    0,    0,    0,    0, 2280,65124,
68684,68684,   97,    0,    0,  796,    0,    0,    4,    0,
    0, 2171,    0,    0,    0,68684,  794,68684,    0,    0,
    0, 2571,68684,68684, 1901,    0,52905,68684,    0, 2168,
 2350,66904,  736, 2125,    0, 2575,    0,    0,    0,    0,
  903,68684, 2281, 2574, 2738, 3120,    0, 3832, 2304, 2578,
    0, 2862, 2579,    0,    0,    0, 1650, 2109,  -98,    0,
  468,    0, 2592,    0, 2939,    0,    0,  -98,    0, 2303,
68684,    0,    0,    0,    0, 2346, 2098,    0,    0, 1906,
  -87,    0, 2598,    0, 2300, 2310, 1542,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  981,68684, 2346,
 2339, 1906,64056, 2098,    0,  430,    0,    0,    0, 2274,
 2283, 2285,    0,  981,    0, 1912,    0,  -98, 2048, 2168,
 2053,    0,  812,    0,  902,    0,    0, 2247,  -98,    0,
57310,  138, 2252,    0,    0,    0,  981,    0, 2486,  124,
    0,    0,    0,   28,    0,  124, 2251,  124,    0, 2630,
  981,  981,  981,    0,    0, 1621,68684,  879, 2407,    0,
 2324,    0, 1855,    0,    0,    0,  879,  585, 2048, 2168,
67616,  519,66904,68684, 1864,  317,    0,    0, 2640,  572,
    0,    0,    0,57310,68684, 2168,    0, 2168, 1231,  139,
52905,52905,44808, 2641,  949,45204,52905,45600, 1099,45996,
46392,50529, 2256,46788,47184,47580,47976,47976,    0,    0,
 2329,    0, 2644, 1677,52905,52905, 4505,52905, 2645,52905,
 2649, 3163,52905,52905,52905,52905, 1062,52905,52905,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2380,
 2657, 2177,  505, 3251,52905,  759,52905,    0,47976, 2834,
 3806,  671,68684, 3301, 3326, 3867, 3874, 3907,    0,    0,
    0, 2080,50925,    0,    0,    0,    0, 1148, 2655,  688,
 5133,52905,52905,  136,    0,    0, 1063,    0,    0, 2423,
  791,  791,  514,  514, 1187,58045, 2658,    0,    0, 2659,
 5028,    0,    0,    0, 2373, 2660,    0, 1870,67972,68684,
    0, 2356,    0,    0, 1882,    0,    0,    0,    0,    0,
    0,65124,65124, 2331,    0,    0, 2437,    0,66548,  601,
 2358,52905,    0,68684,    0,52905,    0, 2675, 2677, 2676,
52905, 1459, 2340,    0, 2340, 1034,47976, 2340, 2385, 2394,
 2358,68684,68684,68684,68684,68684,70464,    0, 2690, 2691,
    0,    0,    0, 2424, 2425,    0,    0,    0,    0,    0,
    0,    0,  -61,    0, 2305,    0,    0, 2187, 5028,    0,
 2701,    0, 1889,  879,  829, 2168,66904,    0,    0,  903,
    0,    0,68684,55526, 2308,52905, 2255,52905,52905,68684,
    0, 2209, 2482,    0,  468,    0,47976, 2102,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  172,    0,    0,
    0, 2487, 2468,    0,    0, 1542, 1542, 2268,    0,    0,
    0,    0,  -87,    0,    0,    0,    0,    0,  -26,  -20,
 1256,    0, 2501, 2048,    0,  -98,  734, 2317,    0,    0,
    0,    0,    0,68684,    0,    0,    0,    0,  199, 1915,
 2352, 2311, 2722,    0, 2069, 1959, 2419, 2303,   28,    0,
    0,    0,    0, 2717, 1217,    0,68684, 1399,  981, 2735,
 2749, 2750, 2528,  736, 2125,    0,    0, 2209, 2140,66904,
    0, 2125,    0,68684,    0, 2470, 2317, 2754,    0, 2220,
 -202,  959, 2216,  -98,  519,    0,    0,    0,    0, 1982,
55882,    0,  981, 2411, 2494, 5949,    0,    0,  981,  383,
    0,    0, 2503,    0,    0, 2768, 2776,    0, 5160, 5028,
 2781,    0,    0, 5028, 2784,49341,    0,    0, 2510,    0,
   45, 2785, 5028, 2788, 2461, 2789, 5028, 2790,52905,52905,
 2641,52905,51321, 2412, 2793, 5028, 2795, 2796, 5028, 2797,
52905, 5028,52905, 2801, 5028, 2803, 2805, 5028, 2806, 2807,
 5028, 2809,    0, 2591,    0,65480, 2067, 3919, 3930,69040,
 3950,    0, 4003,52905,    0, 4276, 4387, 4413, 4444,52905,
 4455, 4488,52905,    0,52905,52905, 5028, 2430,52905,    0,
52905, 5028, 2552,  772,52905,52905,52905,    0,    0,    0,
    0,    0,    0,52905,    0,52905, 2248, 2434,52905,52905,
52905,52905, 5154, 5154,52905, 1677,    0, 2013,58045,56598,
    0,    0,68684,    0,    0,    0,68684,    0,    0,    0,
    0, 2566, 2421, 2421,    0,    0,    0,    0,  186,  186,
  165,    0,  261,    0, 2024, 1459,    0, 2029,68684,    0,
    0,    0, 2524,  609,    0,55526,55526,    0,    0,    0,
    0,    0,    0,    0,65124,65124,65124,65124,    0,    0,
    0, 2826, 1677,    0,    0,    0, 2125,68684,    0, 2317,
 2051,    0,    0, 2824, 2677,47976, 2545,    0, 1358,    0,
    0, 5028,    0, 2069, 2498, 2069,    0,  163,    0,    0,
    0,    0,    0,    0,    0, 2303, 2468,    0,  835,52905,
 2485, 2268,   71,    0,    0, 2513, 2514, 2515, 2529, 2531,
 2533,    0,    0,  734,    0, 2433, 2448,    0,    0,    0,
 2653,    0, 2403, 2894,  199,    0, 2491,    0,    0,  124,
    0,    0,    0,    0,  124,  124,    0,    0, 2311, 2895,
    0,    0,    0,    0,  879,  925, 2168,    0, 2069,    0,
 2140,    0, 2501,    0, 2501,    0,    0,    0,    0,  -98,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2568,
    0, 2574,    0, 2904,    0, 2905,  -98,  -34, 2908,    0,
    0,  -98,    0,    0,52905, 2168, 2168, 2056,  679, 2909,
52905, 2629,    0, 2168, 2168,52905, 2168, 2168, 5437, 5028,
    0, 2467,52905, 5028,52905, 2168, 2168, 2168, 2168, 5028,
 2500, 2168, 2168, 2168, 2168, 2168, 2168, 2329,68684,    0,
 2910, 2911,  892,    0,    0,    0, 2580, 6527,    0, 2915,
    0,    0, 4499,    0,    0,    0,    0, 4526,    0,    0,
 4534, 2158,    0,52905, 2648, 2532,    0,52905, 4552, 2058,
 5549, 4574, 4584,52905,52905, 5575, 1657, 5609, 5617, 2085,
52905, 2917, 2921, 2444,    0,    0,    0,    0, 2924,    0,
 2697, 2535, 2651,   99,   99,    0,    0, 2549,    0,    0,
    0,    0,    0,58045, 2067,70820,    0,    0,55526, -134,
    0, 2551, 2554,    0, 1844,    0,    0,    0,    0,   99,
   99,52905, 2067,    0, 2501, 2501,    0,    0, 2568,55526,
 2703, 2671,    0,    0,    0,  902,    0,    0,    0, 2939,
 2939,    0,    0,    0, 2661,68684, 2268,    0,    0,    0,
 5028,68684,    0, 2667, 2569, 2678, 2576, 2716, 2681, 2725,
    0,    0, 2587, 2593, 2643,    0,68684,    0, 2985,    0,
 2991,    0,    0,    0,    0,    0, 2125,68684,    0, 2317,
    0,  902,    0,    0,    0,    0, 2992, 2755,    0,    0,
    0, 2687,   -7,    0,    0, 2311, 2692, 5028, 2999, 3015,
    0, 1063,    0, 5028,52905, 3016, 3019, 5028, 3020, 3021,
52905,52905, 5028, 2582, 3027, 3028, 3029, 3030,52905, 3031,
 3032, 3033, 3034, 3035, 3043,    0,    0,65480, 3047,    0,
68684,    0,68328,    0,    0,    0,    0,    0,52905, 3050,
    0,    0,52905,    0,    0,    0,52905,    0,    0, 4857,
 4968,52905,52905,52905,52905,52905,    0, 5028,    0,    0,
52905,68684,    0,    0,68684, 2719,    0,    0,  186, 2658,
    0,    0, 1783,    0, 2536, 2668, 2726,    0, 2541,    0,
47976, 3052,    0,    0,    0,    0,    0, 2097,    0,    0,
    0,    0,    0,    0, 2677,52905,47976, 1901,    0,    0,
    0,    0,    0, 2268, 1542,    0, 3056, 1542,68684,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 2501, 2501,    0,    0,    0,    0,    0,    0,
    0,    0,  -91,52905,  -98,    0, 2654,    0,  -98,    0,
    0, 1677, 5028,    0,    0,    0,    0, 5028, 5028,52905,
    0,    0,    0,    0, 5028,    0,    0,    0,    0,    0,
    0,    0,68684, 2786,68684,    0, 5028,    0,    0, 4994,
    0,    0, 5046, 5075, 5086, 5028, 2771, 1895,    0,    0,
    0,    0,    0, 2813, 2672,63344, 3060,    0,    0, 2833,
    0,    0,    0,    0, 2704, 2694,  738,68684, 2563,    0,
    0,    0, 5028, 3090,    0,  738,    0,    0,    0,    0,
 2761,    0, 2761,    0,    0,    0,    0,    0, 2632, 2634,
 5028,    0,    0,    0,    0, 5028, 3093, 3104, 3107,    0,
 3105,    0,    0,    0,    0,52905,    0,52905,    0,62632,
    0, 1027,    0, 2672,    0, 2303,    0, 2845, 2823, 2756,
    0, 2143, 2571, 2067,52905,   -1, 2268, 2792, 2794, 2268,
    0,    0,    0,    0,    0, 3129,68684,    0,68684,68684,
 5028, 5107,68684,  -11,    0, 3131, 2584, 2838,52905,    0,
    0,68684,68684,68684,    0,    0,    0,    0,    0, 2839,
    0,    0, 3121,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  -36,
 3125,    0,    0,    0,    0,    0,    0,    0,68684,68684,
  199,  426,    0,    0,  172, 3144, 2571,    0,68684,    0,
    0,    0,    0,  530,  530,    0, 2889,    0, 2758,    0,
    0,    0,    0, 3146,    0,    0,52905,53301,47976, 2764,
 5028,    0,    0,    0,    0,68684,58045,    0,   30, 3153,
    0,    0,    0,    0,    0,    0, 1027,    0, 2168, 2765,
 3154, 2748,  803,    0,    0,    0,    0, 5028,49341, 5028,
 1457,  465, 2907,    0, 2874, 2658, 2714, 2878,47976,    0,
    0, 3175, 3177,    0,    0,    0, 5115, 2800, 2913,52905,
 1265,52905, 2887, 1457,    0,    0,    0,    0,    0,    0,
    0, 2802,    0,58045,53301,58045,  683,    0,52905, 3186,
52905,53697, 5028, 2812, 2854, 2821, 5028,58045,    0,    0,
    0, 2658, 1457,  156, 2930, 2151,52905, 5028, 2623, 5028,
    0,    0,    0, 2658, 2946, 2916, 2960, 2953,    0,    0,
 5028, 2184, 2199,    0, 2656,    0,    0,52905,    0,58045,
68684,    0,    0,68684,    0,52905,    0,52905, 5028,    0,
  454,    0,    0,    0,    0, 5028,    0,    0,
};
static int yyrindex[] = {                                   2847,
    0,  263, 1126,    0,    0,    0,    0,    0,    0,    0,
    0,64768,  224,    0,    0,    0,    0,    0,    0,    0,
    0, 3257,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  149,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1084,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2935,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   37,    0,    0, 2897,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  128,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  128,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 2898,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1084,    0,
    0, 1096,    0,    0,    0,42441,    0,    0,    0,    0,
 2861, 3009,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  802,51717,  885,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  482,    0,    0,    0,    0, 1447,    0,    0,  134,    0,
    0, 3012,    0,    0,    0,    0,    0,    0,    0, 1208,
    0,    0,    0,    0,    0,  282,    0, 7047,    0,    0,
    0,    0,    0,    0,    0,    0,  482,    0,    0,   15,
    0,    0, 3244,    0,  966,    0,    0,    0, 3012,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  160,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  272,    0, 3023,    0,    0,    0,    0,    0,
69396,    0,    0,    0,    0,    0, 1317,    0,    0,    0,
    0,    0,    0,    0,    0,69752,    0,    0,    0,    0,
    0,    0,    0,  515,    0,    0,    0,    0,    0, 1230,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  482,
    0, 3244,    0,  966,    0, 3012,    0,    0, 1333,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  175,
    0,    0,    0,    0,52113,48372,    0,    0, 2881,  340,
    0,    0,    0,    0,    0,    0,    0, 1411,    0,    0,
    0,    0,    0,    0, 1422,    0,    0,  252,    0,    0,
    0,    0,    0, 3023,  987,61208,    0, 1510,    0,    0,
    0,    0,  608,    0,  134,    0,  146,    0,    0,    0,
    0,    0,    0,    0,    0, 2849, 2849,    0,    0,    0,
 1511,  550,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 3023,    0,    0, 1154,    0,    0,    0,    0,  148,
    0,    0,    0,    0,    0, 5886,    0,    0,  279,    0,
    0,    0,    0,    0,    0,    0,    0,32268,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 3799,    0,    0,    0,    0, 3218, 3218,    0,
    0,    0,    0,29944,    0,    0,    0,32849,33430,    0,
34011,34592,    0,    0,    0,    0,    0,    0, 4380, 4961,
 5542, 6123, 6704, 7285, 7866, 8447, 9028, 9609,10190,10771,
11352,11933,12514,13095,30525,31106,35173,13676,14257,14838,
15419,35754,16000,16581,17162,17743,18324,18905,19486,31687,
20067,20648,21229,21810,22391,22972,23553,24134,24715,25296,
25877,26458,27039,27620,28201,28782,29363,    0,    0, 2847,
    0,    0,    0,  321,    0,    0,    0,    0,    0,    0,
    0,36916, 1517,  290,    0,36335,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  140,    0,    0,
    0,    0,    0,    0,    0, 2847,    0,    0,    0,    0,
    0,    0,69396,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1343,    0, 1343,    0,    0, 1312,    0, 1684,
 1973,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  160,    0,    0,    0,    0,    0,    0,    0, 3023,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1727,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1531,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  335,    0,  727,    0,
    0,  488,    0,    0,    0,    0,    0,  878,    0,  146,
    0,  142,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1575,    0,    0, 1362, 2873,
    0,    0,    0, 2919,    0,    0,57700,    0,    0,57713,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  775,
    0,    0,    0, 1297, 1345,    0,    0,    0,    0,57891,
 1785,    0,57713,    0,    0,  482,    0,  966,    0, 3012,
    0,    0,    0,    0,    0,    0,  987,  966,  979,  137,
    0,  222,    0,    0,    0,    0,    0, 2899,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1029,
 2359, 2711,43022, 2847,    0, 2798,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 3250,  195,54093,    0,54093,    0,    0,    0,54093,54093,
    0,54093,    0,    0,    0,    0,    0,    0,    0,    0,
 2847, 2864,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,54093,    0,38078,
38659, 3263,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 3254,    0,
 1137,    0,    0, 1811, 1703,    0,    0, 2546,    0,    0,
    0,    0,  786,    0,    0,    0,    0,    0,    0,    0,
    0, 1624,  170, 1644,    0,    0,    0, 1644, 2847,41373,
 2970,    0,    0,    0,    0,    0,    0,    0,  170,    0,
    0,    0, 1624,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1055,    0,    0,    0,
    0, 2875,    0,    0,  279,    0,    0,    0,    0, 2847,
    0,  987,  966,  979,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  458,    0,    0,    0,56954,    0, 2997,
    0, 1853, 1038,    0,    0,    0,  592,    0,    0,    0,
  267,    0,    0,    0,    0,    0,    0,    0,    0,  860,
    0,    0,    0,    0,    0, 3611, 4192,    0,    0, 5935,
 4773,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 3274,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  785,
  880, 1066,    0,    0,    0,  142,    0,    0,  188, 2847,
    0,    0,    0,    0, 1805,    0,    0,    0,    0,    0,
    0,    0, 1607,    0,    0,    0,    0,    0,57700,    0,
    0,    0,    0,  255,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 3023,    0,    0,    0,    0,
  176,    0,    0,    0,    0,    0,    0,    0,  405, 2847,
    0,  166,  987,    0,    0, 6467,    0,    0,    0,  268,
    0,    0,    0,    0,    0, 2847,    0, 2847,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 3275,    0,    0,  144,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1481, 1768, 2107, 2432,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  106,    0,    0,37497,
40402,40983,39240,39821,    0,    0, 1654,    0,    0,    0,
 1398,    0,    0,    0, 3277,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1267,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1670,    0,    0,    0,    0,    0,    0,    0, 2970, 2595,
    0,42085, 2981,    0, 2981, 2970,    0, 2981,    0,    0,
 1670,    0,    0,    0,    0,    0,  198,    0,  132,  159,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  195,  780,    0,
    0,    0,    0,    0,    0, 2847,  987,    0,    0,    0,
    0,    0,    0,    0, 2977,    0,  518,    0,    0,    0,
    0, 2849, 2876,    0,  999,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 2262,    0,  786,
    0,    0, 1169,    0,    0,    0,    0, 1369,    0,    0,
    0,    0, 1505,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1671,  188,    0,    0, 1675, 1687,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2074,    0,    0,    0,    0,    0, 1691,  287,    0,
    0,    0,    0, 1470,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  966,  979,    0,  786, 2849, 1714,  987,
    0, 3057,    0,    0,    0, 1765, 1687,    0,    0,    0,
    0,    0,    0, 1774,  187,    0,    0,    0,    0,    0,
    0,    0,    0, 6467,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,58375,
    0,    0,    0,58471,    0, 2847,    0,    0,    0,    0,
    0,    0,58631,    0,58676,    0,58770,    0,    0,    0,
    0,    0,    0,    0,    0,58802,    0,    0,58960,    0,
    0,58992,    0,    0,59086,    0,    0,59131,    0,    0,
59229,    0,    0,49084,    0, 3250, 1644,    0,    0, 7065,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2903,    0,    0,    0,
    0,  824,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 3281, 3281,    0, 3282,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  151,  151,    0,    0,    0,    0,    0,    0,
    0,    0, 1777,    0,    0,41729,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  144,    0,  786,    0, 3057,    0,    0, 1687,
    0,    0,    0,  490, 2278,    0, 2055,    0,    0,    0,
    0,  850,    0,    0, 2882,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1696, 1869,    0,    0,    0,
    0, 1369, 2935,    0,    0, 1408, 1586, 1631, 1661, 1689,
 1731,    0,    0, 1675,    0,    0,    0,    0,    0,    0,
    0,    0,  604,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 5354,    0,
    0,    0,    0,    0,    0,    0, 2847,    0,    0,    0,
 1780,    0,    0,  786,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1789,
    0, 1802,    0,    0,    0,    0,    0,  230,    0,    0,
    0,    0,    0,    0,    0, 2847, 2847,    0,    0,    0,
    0,    0,    0, 2847, 2847,    0, 2847, 2847,    0,59339,
    0,59435,    0,59545,    0, 2847, 2847, 2847, 2847,59641,
59699, 2847, 2847, 2847, 2847, 2847, 2847,54449, 1428,    0,
    0, 3290,    0,    0,    0,    0, 3291,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 3293,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,70108,    0, 1624, 1624,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1644,60697,    0,    0,    0,    0,
    0, 1803, 1816,    0, 2970,    0,    0,    0,    0, 1624,
 1624,    0, 1644,    0,    0,    0,    0,    0, 1789,    0,
    0, 2410,    0,    0,    0, 1064,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 6516,    0,    0,    0,
 3295,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  786, 3057,    0,    0, 1687,
    0,  350,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  782,    0,59793,    0,    0,
    0,  106,    0,59874,    0,    0,    0,59968,    0,    0,
    0,    0,60049,60172,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 3250,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 3298,    0,    0,
    0,    0,61920,    0,    0,    0,    0,    0,    0, 1834,
    0,    0,57625,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 2496,    0,    0,  168,    0,    0,
    0,    0,    0, 6516, 2647,    0,    0,  232,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  472,    0,    0,    0,
    0, 3282,60266,    0,    0,    0,    0,60347,60405,    0,
    0,    0,    0,    0,60501,    0,    0,    0,    0,    0,
    0,    0,    0, 2267,    0,    0, 3299,    0,    0,    0,
    0,    0,    0,    0,    0, 2271,    0,    0,    0,    0,
    0,    0,    0,    0,62276,    0,    0,    0,    0,    0,
62988,    0,    0,    0,    0,    0,59397,    0,  158,    0,
    0,    0, 1174, 2728,    0, 2497,    0,    0,    0,    0,
 2844,    0,  215,    0,    0,    0,    0,    0,    0,    0,
 3295,    0,    0,    0,    0,60595, 3300,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  411,
    0,    0,    0, 3045,    0,  707,    0,    0,    0,    0,
    0,    0,    0, 1644,    0,    0, 6516, 2968, 3188, 1369,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 2273,    0, 1905,    0, 2101,  306,    0,    0,    0, 2122,
 2206, 2210,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1708,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 3288,    0, 2875,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 3292,    0,    0,    0,
 3294,    0,    0,    0,    0,    0,    0,    0, 2847,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 2847,    0,
  153,    0,    0,    0,    0,    0,    0, 3302, 2847,  973,
  161,    0,    0,    0,    0, 3303,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 3304,  207,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 4228,
    0,    0, 1581,    0,    0,    0, 1583,    0,    0,    0,
    0, 3307, 3017, 3054,    0,    0,    0, 1843, 3647, 1978,
    0,    0,    0, 3315,61564,    0,    0,    0,    0,    0,
 2277,    0,    0,    0,    0,    0,  401,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 2012,    0,
    0,    0,    0,    0,    0, 2282,    0,    0,
};
static int yycindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 3098,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2850,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1006,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2892,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 3320,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 3011,    0, 3013,    0,    0,    0,    0, 3334,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 3340, 3342, 3343,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 3344,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2865,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 2799,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2866,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,
};
static int yygindex[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0, 1008,    0,
    0, 1011, 1013, 1014,    0,    0,    0,    0,    0,-2093,
    0, 1015, 1016, 3082, 2585,   41,-1045, 1602,-1069, 3101,
 2257, 3112, 2588,    0,    0, 2927, -169,    0,    0, -957,
   44,    0,    0,    0,    0,   61,   81,  -66,  -57,   -3,
  -43, 2933,    0,    0,    0, 1000,    0,    0,  -62, 1762,
 -903,  -72,-1469, 2404, 2092, -548,    0, 1767,    0, 3336,
 2091, 2145, -643,    0,    0,    0,-1097,  -53,    0,    0,
    0,    0,    0,    0, 3351,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  -70,    0, -862, -997, 1778, -878,  897,
41036,    0,    0,    0,    0, -546, -538,-1741, 1799, -594,
  -71,    0, -867, 2201,    0,-1182, -481, -120, -250,    0,
 1823,    0, 1574, -556, -916,  -25,  -97, -583,    0,    0,
    0,    0, 1791,    0,    0,    0,    0,    0,    0,    0,
    0, 2816,    0, 2478,    0,    0,    0, 1896,    0, 2912,
-1003, 1371, 1812, 2848, 2851,    0,    0, -602, -824,    0,
  -52, -473,    0, -793,    0,-1117,-1113,-1111,-1109,-1099,
    0, 1590,-1387,    0, 1092,-1711,    0, 2522,    0,    0,
    0, 1051, 1053,  978, -299, -486, -896,-1435,-1331,    0,
    0,    0, 2236, -901,  995,-1008,    0, 2005,-1013,-1651,
    0,    0,    0,    0,-2023,   65,    0,    0,    0,    0,
    0,    0,-1141,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,-1401,    0,
  906,  891,    0,    0,  865, 2720,  872,    0,  936,    0,
    0,    0,    0,    0,    0,    0,-1098,-1091, 1059, 1098,
    0,  976,    0,    0,    0,    0,    0,    0,    0, -744,
    0,    0, 2366, -554, -741,-1493,    0, -392, -610, -956,
-1416,    0,    0,    0, -639,    0,    0,    0,    0,    0,
 2900,    0,    0,    0,    0,    0,    0, 2902, 2570,    0,
    0,    0,    0,    0,   -8, -788,    0,    0,    0, 2923,
    0,    0,    0,  -14,    0,    0,    0,    0,    0,    0,
 -604, 2204, -603, 1601,    0,    0,    0,    0,    0,    0,
-1023,    0,    0,    0, 2511,    0, 2218,    0,    0,    0,
    0,    0,    0, -182,    0, 3511,    0, 3221,    0,    0,
    0, 3007,    0,    0,    0,    0,    0,    0, 2696,    0,
 2686,    0,    0,    0, 2361,    0,    0,    0,-1036,    0,
 -438,    0,    0,    0,    0,    0,    2, -995,-1034,-1268,
  400,    0,  -12, 1318, 3782,    0, 1030,    0,    0,    0,
    0,    0,    0, -751,    0,    0,-1114,    0, 2967, 1041,
    0, 2004,-1051, -923,    0,-1047, 2402,-1530,    0,    0,
    0,    0,    0,    0,    0, 2063,    0,    0,    0,    0,
  667,  362,    0, 1147, 2502,    0, 1382,    0, 1573,    0,
 -465,    0,    0, 2016,    0,    0,-1153,-1106,    0, 1502,
 1504,    0,    0, 1088,    0,    0, 2707,    0,    0,    0,
 1167, -712, 1185, 1190, 2428, 2076,-1637,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1625, 1890,    0, 3150, -477, -263,
-1068,    0, 2978, 1722,    0, 1961,    0,    0,-1096,    0,
    0,    0, 2925,    0, 2064,    0,    0,    0,    0,    0,
 1846,    0,    0, -708,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,-1523, 1872,    0,    0,
};
#define YYTABLESIZE 71434
static int yytable[] = {                                     298,
  316,   52,  428,  322,  433,  490,  315,  319,  398,  330,
  424,  482, 1123, 1034,  445, 1103, 1448, 1035,  889,  892,
 1204,  429,  409, 1449, 1230,  468,  449, 1374, 1525,  474,
  994,  995,  991,  916,  888,  891,  964,  476, 1019,  447,
 1225, 1487, 1527,  417, 1778,  922,  472, 1568,  479, 1168,
  393,  396,  649,  400,  403,  315,  408,  411,  414,  298,
  419,  477, 1328, 1239,  415,  431,  396,  419, 1022,  403,
 1528,  315,  408,  471,  411,  414,  298,  419,  456,  316,
  958,  451,  481,  464, 1148,  315,  466,  396,  475,  464,
  419,  400,  403, 1516,  315,  408,  411,  414,  298,  419,
  456, 1489,  403,  480,  404, 1727,  401, 1561, 1437, 1185,
  920, 1562, 1145, 1563, 1547, 1564, 1265,  929, 1839, 1470,
  443,  437, 1347, 1466, 1330, 1565, 1341, 1350, 1566,  926,
  882,   59, 1123, 1057, 1864, 1789, 1061,  642, 2041,   44,
 1141, 1061, 1898,  916,  473, 1059,  903, 1059,  794,  549,
   42,  872,  927, 1929,  483, 1012, 1543,  939,   60,  880,
 2103,  887, 2050, 1403, 1538,  180, 1284,  882, 1615,  953,
 1412,  962, 1020,  494,  796,  153, 1882, 1112, 1110, 1678,
 1111, 1609, 1113, 1475,  762, 1869,  181, 1063, 1533,  794,
   59, 2340, 1057, 1260,  903, 1061, 1166, 1315,   44, 1779,
 1061, 1918,  916, 2089, 1059, 2369, 1059,  794,  882,   42,
 1141,  927, 1181,  890,  296,  796,  939,   60,  880,  384,
 1379,  179, 2013,  720,  180, 2015,  882,  762,  953,  841,
 1031,  962, 1862,  796,  153, 2225,  762, 1535, 2143,  111,
  869, 1315,  618, 1031, 1184,  181, 1063,  496,  762, 1578,
  499,  601,  539,  903,  166,  296, 1315,  825,  296,  544,
 1646, 1194,  720,  305, 1530,  383,  219, 1311,  905,  546,
  102,  438,  962,  296, 1308,  962, 1878, 2509,  882,  651,
  179,  200,  720,  843,  508, 2064,  165,  316, 1283,  436,
  962,  431,  315,  315,  431, 2484, 2440,  150, 1536,  298,
  444,  419,  643,  914, 1117,  322, 1876, 1302,   94,  319,
  601,   94, 1220,  166,  396,  403,  315,  408,  414, 1226,
 1107,  720, 1292,  330, 1454,  219,  994,  995, 1241, 1660,
  438,  597,  583, 1829,  590,  458, 1570,  882, 2537,  916,
  200,  497, 2286, 1962, 2249,  165, 2078, 1448,  436,  228,
 1369, 1442,  422,  423, 1449,  112, 1664,  300, 1224, 1932,
 1476, 1107, 1476, 1442, 1107,  542, 1442,  540,  459, 1445,
  636,  964, 1303, 1370, 1455, 1458,  873, 1248,  590, 1107,
  916,  111, 1191, 1933, 1830, 2256, 1429, 1430,  600, 1526,
 2278, 1963,  644,  590,  306,   59, 1593, 1617,  916, 2074,
 1367,  842, 1776,   44, 1063, 1877, 2510, 1488,  228, 2504,
 2505, 1879, 1108, 1107,   42, 2538, 1574, 1109, 1285, 2597,
  301, 2144,   60, 1637, 1367, 2542, 1793, 1794, 1371,  906,
 2485,  805,  845, 2226,  813, 1903, 1401,  444,  893, 2124,
 1809, 1288, 1288, 1288, 1288, 1288, 1302, 1288, 1531,  820,
 1723, 1724,  600, 1790, 1470,  839, 1057,  795, 1307, 1061,
  600, 1315,  494, 1063, 1061,  150,  150, 1861, 1059, 2517,
 1059, 1264, 1276,   16, 2287,  431,  868, 1378,  431, 1869,
  858,  882, 2535,  794,  411,  298, 2498, 2370, 2134,  833,
 2191, 1288, 1754, 1833, 2194,  384, 1845, 1779,  795, 2129,
  400,  962,  882, 1842,  315, 2562, 2133, 2035, 2135,  796,
 1063, 1616,  104,  824,  745, 1368,  795,  911,  153,  857,
  860, 1798,  322,  319,  219, 1884,  319,  864, 2224,  953,
  833,  166, 2092, 1841,  102, 1057,  219,  880, 1598, 1368,
  921,  383, 2360, 1061,   71,  882,  880, 1059,  833,  201,
  805,  949,  429,  847,  937,  493, 1470,  939,  911,  880,
  880,  911,  219,  165, 2073,  959, 1005,  961,  219,  886,
  219,  886, 1008,  745, 1463,   59,  911,  200, 1871, 1872,
 1814, 2343, 1010, 1016,  431, 1608, 2131, 2622, 1647, 1063,
  179,  914,  794,  927,  431, 2054,  431,  882,  431,  886,
 1025,  942,   60,  214, 1676,  962, 1677,  614,  201,  219,
 1140,  882, 1608,  903,  601, 1318,  180,  180,  796, 1843,
 1994,  886,  720, 1470,  200, 1327, 1165, 1518,  396,  403,
  408,  414,  914,  439, 1592, 1835, 2276,  181,  181,  315,
 1858, 1315,  658,  583,  315,  400,  439, 1607, 1036,  720,
  914, 1035, 2220,  916, 1164, 1107,  882, 1613, 2241, 2242,
 1583,  720,  214, 1943, 1310, 1784,  614,  880,   94, 2319,
  916,  438,  179,  179,  916,  882, 2288, 1288, 1916, 2390,
 2037, 1006, 1288, 2093,  939, 1923,  880, 2038, 1018,  436,
 2272,  886,  228, 1023,  882, 2486, 1870, 1477, 2491, 1477,
 1034, 1663,  903, 1291, 1035,  296, 1316, 1635, 1586,  179,
 1112, 1110, 1775, 1111, 1757, 1113, 1642,  534, 1282, 1768,
 1107,  903,  962, 2585,  413, 2516, 1367, 1063, 1365, 1364,
 1366, 1771,   59, 1057,  835, 1057, 1057, 1803, 1061, 1917,
   44, 1805, 2240, 1061, 1518,  308, 1808, 1059, 1059, 1059,
 1059,   42, 1107, 2627, 2056,  179, 1329,  926, 1875,   60,
  465, 1104, 1341, 1539, 1924,  256, 1367,  256, 1288, 2065,
  219, 1804,  858, 1139,  164, 2104,  104, 2052, 2040,  946,
 1582, 2070, 2071,  916,  481,  200,  882, 1666, 1260, 1288,
 1108,  820,  795, 1847, 1840, 1109,  179,  431, 1942,   94,
 1534,  798, 2280,  833,  302,  882,  315,  403,  411, 1261,
  303,  962,  860,  833,  315,  833, 1199,  802, 1552,  403,
  315, 1470,  673,  946,  833,  673,  411,   52,  330, 1633,
  813,  911, 1112,  164, 1587,  601, 1270, 1113,  946,  637,
 1319, 1368,  798,  481, 1670,  201, 1221,  315, 1643,  915,
 1790,  745,  911,  413,  619, 1136, 2366, 2367,  905, 1138,
  798, 1227,  315, 1143, 1950,  315,  916,  833,  332, 1159,
 1367,  614, 1271, 2120,  431, 1288,  833,  495, 1244,  479,
 2075, 1368,  308,  745,  903, 1286, 1553, 1650, 1277,  334,
  915,  893,  201, 1951,  914, 1288, 1182, 1287, 2522,  214,
  256,  795,  915,  256, 1790,  914, 1266,  602,  915,  745,
 1470, 1193,  745,  534, 1196, 1262, 1799,  431, 1671,  833,
  256, 1235,  431, 1837,  638,  903,  914, 1235,  745, 1746,
  894,  833, 1367,  833,  863,  843,  495, 2523,  479, 1351,
 2365, 1958, 1315,  903, 1367, 1108,  214, 1288, 2221,  333,
 1109, 1321, 1322, 1352,  745, 1448, 1407, 1408, 1644,  639,
  620,  911, 1449, 2152,  429, 1894, 2239, 1263,  498, 1035,
  640, 1272, 1561, 1561, 2217, 2218, 1562, 1562, 1563, 1563,
 1564, 1564, 2090, 2091, 2524, 1368, 1454,  420, 1353, 2039,
 1565, 1565,  611, 1566, 1566,  614, 1354,  833,  220, 1367,
 2236, 2237,  256, 1770, 1355, 1854, 1651,  587,  431,  745,
 1439, 2020, 1594, 1306,  506, 1131,  833, 2126, 1130,  963,
 1893, 1588, 1356, 2375, 1357,  911, 1800, 1267,  587,  745,
  844,  374, 2245, 1367, 1268,  914, 1358,  902, 1359, 1360,
 1361, 1381,  745, 1908,  911, 1104, 1288, 1368,  481, 2060,
  164,  164, 1652,  201,  673,  321, 1886,  220,  419, 1368,
 1790, 1749, 1750,  228,  612,  480, 1264, 1108,  335, 1467,
 1467, 1467, 1109, 1467, 1467, 1467, 1518,  805,  902,  805,
  341, 1471, 1104,  722,  845,  337,  673, 1362, 1467, 1467,
 1467, 1919, 1643, 1653, 1409,  727,  902,  820, 2545,  456,
  341,  846, 1450, 1112, 1110, 2536, 1111,  214, 1113,  431,
  914, 2121, 1470,  420, 1368, 1666, 2122, 2292,  914, 1467,
 1790,  431,  228,  431,  480,  431, 1263, 1263,  673,  310,
 2184,  858,  411, 2357,  587, 1887,  798,  943, 1199,  429,
  403,  495,  722,  479,  164,   91,   92,  944, 1368, 2546,
   52,  411,  315,  403,  727,  256, 1551,  946,  481, 1035,
 1035,  914, 2582,  915, 2584, 1567,  946,  315,  270,  315,
 2273,  860,  481,  876,  431, 2130, 2594, 1316,  805,  864,
 1316, 1998,  673,  431,  915, 1579,  587, 1521, 1643, 1112,
 1110,   52, 1111,  880, 1113, 1316, 2018, 1316,  903, 1751,
 1245, 1514, 1838, 1522, 1617, 1138, 1580,  724, 2621,  270,
 1584, 1015,  270, 2475,  876, 1595,  847,  876, 1524,  903,
  946,  946,  431, 2179,  469, 2095, 1605,  270,  311,  726,
 1117, 2096,  876, 1649,  469,  312,  374,  673, 1630, 1631,
 1632, 1915,  495,  886, 2047, 2047, 2051, 1689, 2445, 1198,
  431, 2119,  945,  479,  431, 1035,  220, 2180, 1790,  886,
 1906, 2284,  282,  397, 1263, 2097,  724,  479,  220, 2181,
 1517, 1435, 1112, 1110, 1363, 1111, 1246, 1113,  436, 1777,
  429,   52, 1036, 1601, 1602,  587, 1600,  946,  726, 2468,
 1365, 1364, 1366,  915,  220, 1690,  650, 2482, 2128, 1467,
  220,  282,  220,  611, 2127, 1467,  946,  374,  315, 1907,
 1467,  755, 2099, 1467, 2347, 2086, 1247, 2088, 1691,  422,
  423,  228,  456, 2520,  431,  315, 1220, 2238,  903,  480,
 2356,   52,  713,  228, 2469, 1036, 1675,  650, 1108,  469,
  650,  220,  750, 1109,  673, 2470,  374,   52, 1467,   52,
 1493,  902,  495,  422,  423,  650, 1467, 1634,  374,  228,
  648,  671, 1785, 1494, 1467,  228,  917,  228,  291, 1699,
  755, 1254,  902, 1255, 1661,  612,  915,  282,  918,  764,
 2132,  590, 1467, 1700, 1467,  673, 1495, 1758,  673, 1740,
  143,  713,  903,  994,  995,  991, 1467, 1108, 1467, 1467,
 1467,  750,  671,  673,  419,  671,  228,  486, 1448,  291,
  503,  903,  291, 1316,  228, 1449,  374,  282, 2329,  125,
  671,  504,  671,  143, 1108,  591, 1701,  291,  439, 1109,
  374,  858, 1316, 1450, 2396,  820, 1498, 1821, 1108,  480,
  578, 1108, 1906, 2471,  282,  270,  469, 1467, 1823,  758,
  431,  456, 1853,  480, 1702,  138, 1108,  143, 1819, 1169,
  656, 1822,  457,  411,  411, 1448,  486, 1448,  661,  503,
  411,  860, 1449, 1135, 1449,  611, 1134, 1199,  514, 1448,
  504,  902,  228,  611,  429, 2402, 1449,  876,    6,    9,
 1108, 1909,  579,  411,  403,  408,  411,  414,  298,  876,
  758, 1351,  220, 1824,  585,  469, 1316, 1108,  876,  499,
  209, 1448, 1109,  648,  899, 1352,  441, 1703, 1449,  157,
 1934, 2381, 1337, 1337, 1276, 1337, 1337, 1337,  431,  161,
  603,  592,  871, 1885,  864,  403,  320,   52,  282,  893,
 1317,  456, 1123,  461, 1935,  902, 1820,  612,  585,  593,
 1353,  876, 1880,  900,  175,  612, 1910,  469, 1354,  282,
  876,  341,  648,  585,  902,  282, 1355,  228,  499,  209,
  486, 1337,  650,  650,  210,  441,  484,  650, 1375, 1035,
  650,  487, 2532,  594, 1356,  487, 1357,  429, 1881,  603,
 1945, 1937,  650, 1082,  626,  583, 1949,  491, 1358,  282,
 1359, 1360, 1361,  876,  151,  151,  668,  893,  813, 1390,
 1391, 1392, 1393, 1394, 1395, 1396, 1397,  876,  583,  671,
  673,  673, 2567,   46,  492,  673, 2495,  627,  673,  628,
  483,  431,  495,  210, 1467,  315,  671,  671,  671,  396,
  673,  397,  671,  942,  487,  671, 1383,  668,  755, 1362,
  668,  629,  431,  439, 1100, 1101, 1102,  671, 1999, 1189,
  482,  500, 1188,  671, 2047,  668,  650,  668,  893,  958,
  616,  486,  605,  501, 1066,  606,  630,  429,  502,  750,
  755,  876,   46,  765, 1925,  893,  457,  650,  485,  483,
  256, 1112, 1110,  650, 1111,  256, 1113,  509, 1112, 1110,
  876, 1111,  942, 1113, 1704,  469,  755, 1385,  530,  755,
  469, 1989,  439,  155,  673,  469,  607,  315, 1398,  482,
 2548,  431,  531,  967, 1388,  755,  607,  650,  958,  616,
  484,  671, 1108, 1066,  805,  673,  256,  750,  893,  256,
  750,  673,  765,  635, 1399,  457,  635,  485,  614,  256,
  967,  755,  671, 1302,  256,  535,  750, 1337,  671,  893,
  967,  635, 1337,  635, 1068, 1298, 1450,  671, 1288,  671,
  615,  431,  155,  193,  431,  673,  940, 1432,  431,  156,
 1147,  486,  750, 1205,  678,  607, 1206,  671,  237,  484,
   16, 1208,  671,  893, 1212,  486, 2058, 1108, 1217,  533,
  319,  144,  923,  323,  228,  893,  755,  403,  403, 1338,
 1338, 1277, 1338, 1338, 1338,  924,  411,  411,  411,  411,
  469,  671,  536, 1068, 2586,  678,  755, 2515,  678,  315,
 2549, 1035,  193,  941,  469,  940, 1363,  750,  156,  755,
 2083,  548, 2550,  678,  396,  678,  397,  237,  570,  487,
 2084,  256,  909,  584,  256,  650, 1812,  750, 1338, 1815,
  144,  923, 2574,  228,  668,  585, 1232, 2137,  271, 1231,
  750,  256, 2575, 2576,  924,  678, 1436, 1485, 2076, 1117,
 1484,  668,  668,  668, 2142, 2066, 2068,  668,  324, 2147,
  668,  571,  941,  909,  483, 1641,  909,  586, 1640,  587,
 2551,  395,  668,  673, 1662, 2067, 2069, 1337,  668,  271,
 1782,  909,  271, 1117, 2552,  396,  603,  397,   52,  325,
  671,  622, 1788,  326,  482, 1787, 1108,  271, 1215, 1836,
 1216, 1109, 1640, 1108,  327, 2389, 1112, 1110, 1109, 1111,
 1349, 1113, 1337, 1337, 1337, 1337, 1337, 1337, 1337, 1337,
 1437, 2493,  485, 2494,  396, 1896,  397,  623, 1895,  487,
 1377,  634, 1437,  369, 1382, 1437,  396, 1387,  397, 2251,
 2252,  625,  746,  487, 1989, 1402,  668, 1404,  646,  635,
  315, 1410, 1411,  614,  607, 1414, 1415, 1416, 1417, 1418,
 1422, 1428,  652, 1431,  484, 1434,  607,  668,  635, 1901,
 2358, 2359, 1900,  668,  483, 1440, 1441, 1442, 1443, 1444,
  764,  653,  654, 1451,  668,  764,  764,  658,  483, 2269,
  765,  810, 1940,  657,  396, 1640,  397,  814,  607,  816,
  607,  746,  668,  823,  482,  828,  394,  668,  396,  829,
  397, 1450,  678, 2222, 1338,  830,  831,  319,  482, 1338,
  403, 1337,  765, 2036,  873,  328, 1779,  678,  832,  678,
  678,  678,  485,  833, 2055,  678,  668, 1117,  678, 2057,
  393,  403, 1117,  673,  834, 1549,  485, 1337,  765,  836,
  678,  765, 2203, 1529,  838, 2361,  678,  315, 2363,  678,
  840, 2079,  851,  315, 1640,  873, 2151,  765, 2196, 1117,
  228, 1117,  852, 1376,  484, 1380,  395,  853,  456, 1384,
 1386, 2316, 1389,  873,  673,  854,  856,  673,  484,  315,
 1765, 1112, 1110,  765, 1111, 2207, 1113, 2314, 2206,  867,
  429,  678,  673,  874,  673,  875, 2255, 2349, 1433,  877,
 1117,  878, 2258, 2336,  282,  271, 1438,  228, 1383, 1383,
 1274, 1383, 1383, 1383,  678,  228,  879,  885, 1438,  360,
 1493, 1438,  429, 1989,  883,  668,  909, 1475, 2274,  315,
  898, 1108,  400, 1494,  431,  678, 1109,  395,  765, 1475,
  359,  678, 1475, 2480,  902,  678, 1134,  909,  228,  911,
  228, 2600,  678,  935, 1117,  904, 1495, 1383,  765, 1112,
 1110,  919, 1111,  431, 1113, 2364, 2341,  910, 2388, 1496,
  678,  765,  228,  912,  924,  678,  395, 2231, 1112, 1110,
  953, 1111, 2372, 1113, 2615,  938, 2374, 2614,  395, 1338,
 1338, 1338, 1338, 1338, 1338, 1338, 1338,  228,  282, 2617,
  678,  394, 2616,  954,  678,  951, 1498, 1679, 1680, 1684,
  400, 1317, 1693, 1695, 1697, 1322, 1706, 1709, 1712,  282,
 1715, 1718, 1721, 1317,  414,  282, 1317, 1322,  415,  956,
 1322, 1728, 1729,  955, 1731,  393, 1733,  834, 1013, 1736,
 1737, 1738, 1739,  960, 1741, 1742,  395, 1061, 1017, 1112,
 1110, 1021, 1111,  115, 1113,  813,  909, 1026, 1063,  282,
  395, 1747,  319, 1752,  400,  319,  431,  901,  228,  746,
  901, 1264,  394, 1265, 1264, 1064, 1265,  382,  834, 1767,
  382,  834,  379, 1065, 1066,  379, 1067,  431, 1773, 1774,
  125,  673, 1068, 1069, 2232, 1070,  834,  858, 1338,  431,
 1072,  746,  131,  678,  909, 1073,  393, 1074, 1076,  673,
  673,  394, 2497, 1075,  673, 1499, 1108,  673, 1045, 1079,
  909, 1109, 1085,  394, 1338, 1086,  138,  746,  873,  673,
  746, 1087, 1088, 1089, 1090,  673, 1091,  860,  764,  909,
  873, 2465,  764, 1383, 1092,  393,  746,  764, 1383,  873,
 1093,   52, 1094, 1095, 1096, 1764, 1097,  393, 2512, 2393,
 1327, 1327, 1045, 1327, 1327, 1327, 1098, 1099,  400,  878,
  400,  431,  746, 1115,  396, 1114, 1117, 1045, 1327, 1327,
 1327,  394, 1118, 2503, 1675, 1675,  858, 1119, 1120, 1129,
  157, 1132,  873, 1133, 1108,  394, 1144, 1162, 1160, 1109,
  161,  873, 1208,  673, 1212, 1852, 1171, 1173, 1176, 1327,
  878, 1177, 1180, 1108, 1183,  393, 1187, 1190, 1109, 1192,
  396, 2514, 1201, 1195,  673,  175,  860,  746,  878,  393,
  673, 2189, 1202, 1406, 1406, 1275, 1406, 1406, 1406, 1219,
 1218,  673,  905, 1222,  873, 1112, 1110,  746, 1111,  914,
 1113, 1228, 1745, 1233, 1450,  835,  877, 1675,  873,  673,
  746, 1258, 1112, 1110,  673, 1111, 1259, 1113, 1112, 1110,
   52, 1111, 1274, 1113, 1278, 1281,  886, 1288, 1289, 1294,
   52, 1296, 1406, 1295, 1108, 1297, 1299, 1300, 1306, 1109,
 1104, 1312, 1313,  673, 1331, 1320,  835,  877, 1333,  835,
 1334, 1112, 1110, 1342, 1111,  673, 1113, 1336,  680,  681,
  682, 1450, 1337, 1450,  835,  877, 1346, 1344, 1345, 1348,
 1405, 1438,  873, 2024,  578, 1450, 1413, 1459, 1383, 1383,
 1383, 1383, 1383, 1383, 1383, 1383,  690,  691, 2607, 1460,
 2540,  873,  764, 1474, 1462, 1307,  673,  762, 1472,  673,
 1473,  834, 1480, 1482, 1486, 1969, 1970, 1450, 1972, 1974,
 1491,  834, 1675,  834,  673, 1107,  673, 1980, 1519, 1981,
  825,   16,  834, 1532, 1537,  869, 1540, 1134, 1571, 1544,
 1045, 1546, 1548, 1112, 1110, 1550, 1111, 2581, 1113, 1327,
 2003, 1557,  673, 1572, 1581, 1327, 2008, 1575, 1576, 2011,
 1327, 2012, 1752, 1327, 2595, 1752,  962, 1747, 1577, 1596,
 1589, 2019,  764, 2021, 1604,  834, 1599, 1611, 1627, 1590,
 2022, 1591, 2023, 2613,  834, 2026, 2027, 2028, 2029, 1629,
 1636, 2034, 1045, 2620, 1638, 1045, 2623, 1383, 1327, 1669,
 1686, 1713, 1045, 1726, 1045, 1732, 1327,  962, 1045, 1725,
  962, 2628, 1734, 1045, 1327, 1743, 1045, 1744, 1769, 1108,
 1781, 1779, 1786, 1383, 1780,  962, 1795,  834, 1406, 1796,
 1046, 1045, 1327, 1406, 1327, 1806, 1807, 1801, 1810,  834,
 1108,  834, 1816,  878, 1045, 1109, 1327,  872, 1327, 1327,
 1327, 1817, 1045, 1825, 1826, 1045, 1045, 1108, 1832, 1827,
 1828, 1834, 1109, 1108,  878, 1045, 1849, 1855, 1109, 1846,
 1865,  930, 1328, 1328, 1046, 1328, 1328, 1328, 1873, 2211,
 1891, 1045, 1899, 1897, 1643, 1902, 2101, 1966,  872, 1046,
 1328, 1328, 1328, 2162, 1905, 1911, 1108, 1327, 1541, 1112,
 1110, 1109, 1111, 1045, 1113,  834,  872,  878, 1045, 1912,
 1913, 1914, 1886, 1930, 1931, 1663,  878,  879, 1947, 1045,
 1045, 1328, 1045,  673,  834, 1936, 2169, 1952, 1953,  835,
  877, 2387, 1112, 1110, 2386, 1111, 1954, 1113,  673,  835,
 1956,  835,  673, 1957, 1964, 1961,  673, 1965, 1967, 1968,
  835,  877, 1976,  869, 1977, 1978, 1979, 1975,  879,  878,
 1982,  673, 1983,  296, 1984, 1985, 1986,  673, 1987, 1045,
  673, 2148, 1367,  878, 2014, 2017,  879, 2154, 1108, 2025,
 2042, 2059, 2158, 1109, 2043, 2072, 1045, 2080, 2081, 2163,
 1045, 2164,  683,  835,  877, 1112, 1110, 1755, 1111, 2087,
 1113, 2102,  835,  877,  296, 1045, 2113,  296, 2300, 2105,
 2106, 2107,  673, 1406, 1406, 1406, 1406, 1406, 1406, 1406,
 1406, 2114,  296, 1112, 1110, 2108, 1111, 2109, 1113, 2110,
 1752,  836,  683,  683, 1752,  673,  683,  878,  684, 2117,
 2200, 2201,  962,  962,  836,  835,  877, 2208, 2115, 1493,
  962,  683,  836,  683, 2118, 2125,  878,  835, 1608,  835,
  877, 2138, 1494, 2140, 2155, 2141,  673,  836, 2146, 2153,
 2177, 2192, 2183,  673, 2178, 2185, 2193, 2209,  684,  684,
  836, 2210,  684,  683, 1327, 1495, 2213,  292,  764, 2212,
 2214,  673, 1046, 2216, 2219, 2246,  880,  684, 1496,  684,
 1694, 1328, 1698, 1558, 1707, 1710, 1497, 1328, 1716, 1719,
 1722, 2227, 1328, 1493, 2229, 1328, 2247,  836, 2259, 2254,
 2260,  673, 1406,  835,  877,  673, 1494, 2262,  292,  684,
 2261,  292, 2263, 2264, 1108, 1498,  962,  880, 2268, 1109,
  962, 2265,  835,  877, 1046, 2270,  292, 1046, 1406, 1495,
 1328, 2271, 2282, 2283, 1046,  880, 1046,  962, 1328, 2290,
 1046,  872, 1496,  962, 2266, 1046, 1328, 1108, 1046, 2285,
 2267, 2293, 1109,  872, 2289, 2291, 2294, 2298, 2299, 2295,
 2296, 2297,  872, 1046, 1328, 2305, 1328, 2301, 2302, 2303,
 2304, 2306, 2307, 2308, 2309, 2310, 1046,  962, 1328, 1498,
 1328, 1328, 1328, 2311, 1046, 2317, 2313, 1046, 1046, 1752,
 2318, 2348, 2346, 2320, 2342, 2225, 2362, 1046, 2323, 2324,
 2325, 2326, 2327, 2345,  673,  872,  836, 2328, 2226, 2373,
 1108,  879, 2392, 1046,  872, 1109, 2391, 2379, 2397,  296,
  296,  879, 2398,  879, 1499, 2400,  458,  296, 2399, 1328,
  683, 2403,  879, 2405, 2406, 1046, 2417,  962, 1108, 2414,
 1046, 2415, 2353, 1109, 2418,  683, 2419,  683,  683,  683,
 2420, 1046, 1046,  683, 1046, 2477,  683,  872, 2476,  459,
 1542, 1112, 1110, 2479, 1111, 2487, 1113, 2489,  683, 2492,
 2499,  872,  301, 2507,  683,  879,  684,  683,  510, 2508,
 2371, 2500, 2511, 2519,  879, 2484, 2527,  293, 1499, 2485,
 2533,  684, 2539,  684,  684,  684, 2376, 1184, 2543,  684,
 2544, 1046,  684, 1735, 1112, 1110, 2563, 1111, 2564, 1113,
  511, 2565, 2566,  296,  684, 2568, 2569, 1103, 1046,  683,
  684, 2578, 1046,  684, 2572, 2587, 2580,  879,  293, 2599,
  665,  293, 2571, 2608,  296,  872,  512, 1046, 2591,  513,
  296,  879,  683,  292,  292, 2592,  293, 2593, 2609, 2611,
 2610,  292, 2612,  802,  872,  514,    1,  667, 1103, 1103,
 1103, 1103, 1103,  683, 1103,  684,  909,  803, 2618,  683,
   30,   32,  845,  683,  296,  962, 1103, 1103, 1103, 1103,
  683,  515, 2421,  240, 2422,  669,  310, 1281,  684,  888,
  880, 1435, 1112, 1110, 1106, 1111,  197, 1113,  683,   89,
  880, 2353,  880,  683, 1262,  879, 1107,  869,  967,  684,
 1103,  880,  825,  252,  887,  684, 1328, 1105,  871,  684,
  495, 1160,  916,  225,  879, 2501,  684, 1261,  683,  226,
  889, 1316,  683, 1233,  296,  454,  516,  292, 1159, 1232,
  898, 1759, 1112, 1110,  684, 1111,  319, 1113,  335,  684,
  367,  384,  404,  418,  880,  677,  517,    0,  292,   15,
  368,  405,  371,  880,  292,  433, 1760, 1112, 1110,  518,
 1111,  679, 1113,  372,  684,   12,    2,   21,  684,   18,
   23,   18,   26,   29,   33,  680,  681,  682,  503,  422,
  423,   35,   42, 2528, 2530, 2045, 1108, 2436,  292,   39,
 2437, 1109, 2438, 2439, 2441, 2442,  880,  504,  685,  686,
  687,  688,  689,  690,  691,  692,  693, 1161, 1515,  505,
  880,  822, 1163,  695,  696, 2547,  821, 1948, 1668, 1335,
 1946,  683,  700,  470, 1673, 1606,  453, 1921, 1944, 1108,
 1573, 1904, 2098, 1290, 1109, 1939, 2573,  968, 2577, 2244,
 1857, 1922,  932,  870, 2410,  933, 2094, 1253,  292, 2490,
 2488, 2530, 2526,  293,  293,  764, 1569, 2588, 2590, 2518,
 2583,  293, 1791, 2596, 1103, 1103, 1103,  684, 2624, 1103,
 1106, 1103, 1103, 2601,  880, 1103, 1103, 2625, 1103, 2579,
 2502, 2474, 2541, 1103, 1103, 1464,  923, 1103, 1103, 1103,
 1103, 1103, 1103,  880, 2619, 1103, 2123, 1257, 1103,  940,
  913, 1628, 2601, 1314, 2626, 1103, 1614, 1103, 1103, 1103,
 1103, 1103, 1103,  309, 1103, 1103,  855, 1108, 1103,  507,
 1175, 1103, 1109, 1103, 1103, 1170, 1520, 1103, 1103, 1103,
 2344, 1103,  897, 1103, 1103, 1103, 1103, 1103, 1103, 1848,
 1490, 2483, 1103, 1103, 1103, 1103, 1103,  293, 1813, 2312,
 1103, 2176, 1372, 1851, 2230, 2228, 2521, 1186, 1103, 2481,
 1103, 1103, 1103, 1103, 2466, 1103, 1818, 1108,  293, 2467,
 1103, 1103, 1109, 1103,  293, 1103, 1501, 1103, 1103, 1103,
 1971, 1103,  950, 1103, 1103, 1103,  650, 1103, 1103, 1103,
 1103, 1103, 1108, 1103, 1103, 2112, 1928, 1109, 1103, 1103,
 1428, 1103, 1103, 1078, 1103, 1103, 1103, 1103,  293, 2033,
 1103, 1859, 2016, 1103,    0, 1103, 1103, 1103, 1103, 1103,
    0, 1103,    0, 1103,    0, 1103, 1103, 1103, 1103, 1103,
    0,    0, 1103, 1103, 1103,    0, 1103, 1103, 1103,    0,
  252, 1428,    0,    0, 1428,    0,    0, 1103, 1103, 1103,
    0, 1103, 1103, 1103,    0,    0,    0, 1103,    0, 1428,
 1103,    0, 1103, 1103, 1103, 1103,    0, 1103,  293, 1103,
 1103, 1103, 1103, 1103, 1103, 1103, 1103,    0, 1418, 1418,
    0, 1418, 1418, 1418,    0,    0, 1103, 1103,    0, 1103,
 1103, 1103,    0,    0,    0, 1418, 1103, 1103, 1103, 1103,
 1103,    0, 1103,    0,    0, 1103, 1103, 1103, 1103, 1103,
 1103, 1103,    0,    0,    0, 1103, 1103, 1103, 1103, 1103,
 1103, 1103, 1103,    0, 1103,    0,    0, 1418,    0,    0,
    0,    0,    0,    0, 1103, 1103, 1103, 1103, 1103, 1103,
 1103, 1103, 1103, 1103, 1103, 1103, 1103, 1103, 1103, 1103,
 1103, 1103, 1103, 1103, 1103,    0, 1103, 1103, 1103, 1103,
 1103, 1103,    0, 1103, 1103, 1103, 1103,    0, 1103,    0,
 1103, 1103, 1103, 1103, 1103, 1103, 1103, 1103, 1103, 1103,
 1103, 1103, 1103, 1103, 1103, 1103, 1103, 1103, 1309, 1103,
 1103, 1103, 1103,    0, 1103, 1103, 1103, 1103, 1103,    0,
 1103, 1103, 1103, 1103, 1103, 1103, 1103, 1103, 1103, 1103,
 1103, 1103, 1103, 1103, 1103, 1103, 1103, 1103, 1103, 1103,
    0, 1103,    0,    0,    0,    0,    0,    0, 1283, 1309,
 1309, 1309, 1309, 1309, 1309, 1309,  550, 1112, 1110, 1756,
 1111,    0, 1113,    0,    0,    0, 1309, 1309, 1309, 1309,
 1309,    0,  551,    0,    0,    0,    0,    0,    0,    0,
    0,   73,  552, 1112, 1110,    0, 1111,    0, 1113,  553,
    0,   74,    0,  554,  555,    0, 1428, 1428,   75, 1309,
    0, 1309,  556,    0, 1428,    0,    0,    0,    0,    0,
    0,   76,    0,  557,    0,    0, 1428, 1761, 1112, 1110,
 1418, 1111,    0, 1113, 1762, 1112, 1110,    0, 1111,    0,
 1113,    0,    0, 1418,    0,    0,    0,    0, 1418,    0,
 1390, 1391, 1392, 1393, 1394, 1395, 1396, 1397,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1763, 1112, 1110,
    0, 1111,    0, 1113,    0,    0,  558,   77,    0, 1995,
 1112, 1110,    0, 1111,  559, 1113,    0,    0,    0,    0,
 1996, 1112, 1110,   78, 1111,    0, 1113,    0,    0,    0,
 1428, 1418,    0,    0,    0,    0,    0,    0,    0,   79,
 2001, 1112, 1110,    0, 1111,  560, 1113,    0,    0,  561,
    0, 1428,    0,    0,   80,    0,    0, 1428,   81,    0,
  562,   82,    0,   83,    0,    0,    0,    0,    0,   84,
 1418,    0,    0,    0,    0,    0,    0,    0,    0,  563,
  564,    0, 1418,    0,    0,    0,    0,    0,   85, 1398,
    0, 1428,    0, 2002, 1112, 1110,    0, 1111,    0, 1113,
    0,    0,    0,    0,    0, 1309,    0, 1309,    0,    0,
 1309,    0, 1309, 1309,    0, 1399, 1309, 1309,    0, 1309,
    0,    0,    0,    0,    0, 1309,    0,    0, 1309, 1309,
 1309, 1309, 1108, 1309,    0,  565, 1309, 1109,  566, 1309,
 1418,    0,    0,    0,   86,  531, 1309,   87, 1309, 1309,
    0, 1309, 1309, 1309, 1418, 1309, 1309,    0, 1108, 1309,
    0,    0, 1309, 1109, 1309, 1309,    0,    0, 1309, 1309,
 1309,    0, 1309,    0, 1309, 1309, 1309, 1309, 1309, 1309,
    0,    0,    0, 1309, 1309, 1309, 1309, 1309,    0,    0,
   88, 1309,    0, 1108,    0,    0,    0,    0, 1109, 1309,
 1108, 1309, 1309, 1309, 1309, 1109, 1309,    0,    0,    0,
    0, 1309, 1309,    0, 1309,    0, 1309,    0, 1309, 1309,
 1309,    0, 1309,    0, 1309, 1309, 1309,    0, 1309, 1309,
 1309, 1309, 1309, 1108, 1309, 1309,    0,    0, 1109,    0,
 1309, 1373, 1309, 1309,    0, 1108, 1309, 1309, 1309,    0,
 1109, 1309,    0,    0, 1309,    0, 1108, 1309, 1309, 1309,
 1309, 1109, 1309,    0, 1309,    0, 1309, 1309, 1309, 1309,
 1309,    0,    0, 1309, 1309, 1309, 1108, 1309, 1309,    0,
    0, 1109, 1373,    0,    0, 1373,    0,    0, 1309, 1309,
 1309,    0, 1309, 1309, 1309,    0,    0,    0, 1309,    0,
 1373, 1309,    0, 1309, 1309, 1309, 1309,    0, 1309,    0,
 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309,    0, 1089,
 1089,    0, 1089,    0, 1089,    0,    0, 1309, 1309, 1108,
 1309, 1309, 1309,    0, 1109,    0, 1089, 1309, 1309, 1309,
 1309, 1309,    0, 1309,    0,    0, 1309, 1309, 1309, 1309,
 1309, 1309, 1309,    0,    0,    0, 1309, 1309, 1309, 1309,
 1309, 1309, 1309, 1309,    0, 1309, 2004, 1112, 1110,    0,
 1111,    0, 1113,    0,    0, 1309, 1309, 1309, 1309, 1309,
 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309,
 1309, 1309, 1309, 1309, 1309, 1309,    0, 1309, 1309, 1309,
 1309, 1309, 1309,    0, 1309, 1309, 1309, 1309,    0, 1309,
    0, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309,
 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1349,
 1309, 1309, 1309, 1309,    0, 1309, 1309, 1309, 1309, 1309,
    0, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309,
 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309, 1309,
 1309, 1309, 1309,    0,    0,    0,    0,    0,    0, 1173,
 1349, 1349, 1349, 1349, 1349, 1349, 1349, 2005, 1112, 1110,
    0, 1111,    0, 1113,    0,    0,    0, 1349, 1349, 1349,
 1349, 1349,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 2006, 1112, 1110,    0, 1111,    0, 1113,
    0,    0,    0,    0,    0,    0,    0, 1373, 1373,    0,
 1349,    0, 1349,    0,    0, 1373,    0,    0,    0,    0,
    0,    0,    0,    0, 2007, 1112, 1110, 1373, 1111,    0,
 1113, 1089,    0,    0,    0, 2009, 1112, 1110,    0, 1111,
    0, 1113,    0,    0, 1089,    0,    0,    0,    0, 1089,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 2010, 1112,
 1110,    0, 1111,    0, 1113,    0,    0,    0,    0, 2186,
 1112, 1110,    0, 1111,    0, 1113, 1112, 1110,    0, 1111,
    0, 1113, 1108,    0,    0,    0,    0, 1109,    0,    0,
    0, 1373, 1089,    0,    0,    0, 2187, 1112, 1110,    0,
 1111,    0, 1113,    0, 2188, 1112, 1110,    0, 1111,    0,
 1113,    0, 1373,    0,    0,    0,    0,    0, 1373,    0,
    0,    0, 2195, 1112, 1110,    0, 1111,    0, 1113,    0,
    0, 1089,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1089, 2198, 1112, 1110,    0, 1111,    0,
 1113,    0, 1373,    0, 2199, 1112, 1110,    0, 1111,    0,
 1113,    0,    0,    0,    0,    0, 1349,    0, 1349,    0,
    0, 1349,    0, 1349, 1349,    0,    0, 1349, 1349,    0,
 1349,    0,    0,    0,    0,    0, 1349,    0,    0, 1349,
 1349, 1349, 1349, 1108, 1349,    0,    0, 1349, 1109,    0,
 1349, 1089,    0,    0,    0,    0,    0, 1349,    0, 1349,
 1349,    0, 1349, 1349, 1349, 1089, 1349, 1349,    0, 1108,
 1349,    0,    0, 1349, 1109, 1349, 1349,    0,    0, 1349,
 1349, 1349,    0, 1349,    0, 1349, 1349, 1349, 1349, 1349,
 1349,    0,    0,    0, 1349, 1349, 1349, 1349, 1349,    0,
 1108,    0, 1349,    0,    0, 1109,    0,    0,    0,    0,
 1349, 1108, 1349, 1349, 1349, 1349, 1109, 1349,    0,    0,
    0,    0, 1349, 1349,    0, 1349,    0, 1349,    0, 1349,
 1349, 1349,    0, 1349,    0, 1349, 1349, 1349,    0, 1349,
 1349, 1349, 1349, 1349, 1108, 1349, 1349,    0, 1730, 1109,
    0, 1349,  633, 1349, 1349, 1108,    0, 1349, 1349, 1349,
 1109, 1108, 1349,    0,    0, 1349, 1109,    0, 1349, 1349,
 1349, 1349,    0, 1349,    0, 1349,    0, 1349, 1349, 1349,
 1349, 1349, 1108,    0, 1349, 1349, 1349, 1109, 1349, 1349,
 1108,    0,    0,  633,    0, 1109,  633,    0,    0, 1349,
 1349, 1349,    0, 1349, 1349, 1349,    0,    0, 1108, 1349,
    0,  633, 1349, 1109, 1349, 1349, 1349, 1349,    0, 1349,
    0, 1349, 1349, 1349, 1349, 1349, 1349, 1349, 1349,    0,
 1108,    0,    0,    0,    0, 1109,    0,    0, 1349, 1349,
 1108, 1349, 1349, 1349,    0, 1109,    0,    0, 1349, 1349,
 1349, 1349, 1349,    0, 1349,    0,    0, 1349, 1349, 1349,
 1349, 1349, 1349, 1349,    0,    0,    0, 1349, 1349, 1349,
 1349, 1349, 1349, 1349, 1349,    0, 1349, 2321, 1112, 1110,
    0, 1111,    0, 1113,    0,    0, 1349, 1349, 1349, 1349,
 1349, 1349, 1349, 1349, 1349, 1349, 1349, 1349, 1349, 1349,
 1349, 1349, 1349, 1349, 1349, 1349, 1349,    0, 1349, 1349,
 1349, 1349, 1349, 1349,    0, 1349, 1349, 1349, 1349,    0,
 1349,    0, 1349, 1349, 1349, 1349, 1349, 1349, 1349, 1349,
 1349, 1349, 1349, 1349, 1349, 1349, 1349, 1349, 1349, 1349,
 1351, 1349, 1349, 1349, 1349,    0, 1349, 1349, 1349, 1349,
 1349,    0, 1349, 1349, 1349, 1349, 1349, 1349, 1349, 1349,
 1349, 1349, 1349, 1349, 1349, 1349, 1349, 1349, 1349, 1349,
 1349, 1349, 1349, 1349,    0,    0,    0,    0,    0,    0,
 1174, 1351, 1351, 1351, 1351, 1351, 1351, 1351, 2322, 1112,
 1110,    0, 1111,    0, 1113,    0,    0,    0, 1351, 1351,
 1351, 1351, 1351,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 2382, 1112, 1110,    1, 1111,    0,
 1113,    0,    0,    0,    0,    0,    0,    0,  633,  633,
    0, 1351,    0, 1351,    0,    2,  633,    0,    0,    0,
    0,    0,    0,    3,    0,    0,    0,    0,  633, 1112,
 1110,    4, 1111,    5, 1113,    0,    0,    0,    6,    0,
    0,    0,    0,    0,    0,    7, 2383, 1112, 1110,    0,
 1111,    0, 1113,    0,    0,    0,    0,    0,    0,    8,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    9,
    0,    0,    0,    0,    0, 2384, 1112, 1110,    0, 1111,
    0, 1113,    0,    0,    0,    0, 2385, 1112, 1110,    0,
 1111,    0, 1113, 1108,    0,    0,    0,   10, 1109,    0,
    0,    0,  633,    0,    0,    0,    0, 2496, 1112, 1110,
    0, 1111,    0, 1113,    0, 2570, 1112, 1110,    0, 1111,
    0, 1113,    0,  633,    0,    0,    0,    0,    0,  633,
    0,   11,    0,    0, 1112, 1110, 1772, 1111,   12, 1113,
    0,   13,    0,    0,   14,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1112, 1110, 2031, 1111,    0,
 1113, 1112, 1110,  633, 1111,    0, 1113,    0,   15,    0,
    0,    0,    0,    0,    0,    0,    0, 1351,    0, 1351,
   16,    0, 1351,    0, 1351, 1351,    0,    0, 1351, 1351,
    0, 1351,    0,    0,    0,    0,    0, 1351,    0,    0,
 1351, 1351, 1351, 1351, 1108, 1351,    0,    0, 1351, 1109,
    0, 1351,    0,    0,    0,    0,    0,   17, 1351,    0,
 1351, 1351,    0, 1351, 1351, 1351,    0, 1351, 1351,    0,
 1108, 1351,   18,   19, 1351, 1109, 1351, 1351,    0,    0,
 1351, 1351, 1351,    0, 1351,    0, 1351, 1351, 1351, 1351,
 1351, 1351,    0,    0,   20, 1351, 1351, 1351, 1351, 1351,
    0,    0,    0, 1351, 1108,    0,    0,    0,    0, 1109,
    0, 1351,    0, 1351, 1351, 1351, 1351,    0, 1351,    0,
    0,    0, 1108, 1351, 1351,    0, 1351, 1109, 1351,    0,
 1351, 1351, 1351,    0, 1351,    0, 1351, 1351, 1351,    0,
 1351, 1351, 1351, 1351, 1351,    0, 1351, 1351,    0,    0,
    0, 1108, 1351,  673, 1351, 1351, 1109,    0, 1351, 1351,
 1351,    0, 1108, 1351,    0,    0, 1351, 1109,    0, 1351,
 1351, 1351, 1351,    0, 1351,    0, 1351,    0, 1351, 1351,
 1351, 1351, 1351, 1108,    0, 1351, 1351, 1351, 1109, 1351,
 1351, 1108,    0,    0,  673,    0, 1109,  673,    0,    0,
 1351, 1351, 1351,    0, 1351, 1351, 1351,    0,    0, 1108,
 1351,    0,  673, 1351, 1109, 1351, 1351, 1351, 1351,    0,
 1351, 1955, 1351, 1351, 1351, 1351, 1351, 1351, 1351, 1351,
 1108,    0,    0,    0,    0, 1109, 1108,    0,    0, 1351,
 1351, 1109, 1351, 1351, 1351,    0,    0,    0,    0, 1351,
 1351, 1351, 1351, 1351,    0, 1351,    0,    0, 1351, 1351,
 1351, 1351, 1351, 1351, 1351,    0,    0,    0, 1351, 1351,
 1351, 1351, 1351, 1351, 1351, 1351,    0, 1351, 1112, 1110,
    0, 1111,    0, 1113,    0,    0,    0, 1351, 1351, 1351,
 1351, 1351, 1351, 1351, 1351, 1351, 1351, 1351, 1351, 1351,
 1351, 1351, 1351, 1351, 1351, 1351, 1351, 1351,    0, 1351,
 1351, 1351, 1351, 1351, 1351,    0, 1351, 1351, 1351, 1351,
    0, 1351,    0, 1351, 1351, 1351, 1351, 1351, 1351, 1351,
 1351, 1351, 1351, 1351, 1351, 1351, 1351, 1351, 1351, 1351,
 1351, 1353, 1351, 1351, 1351, 1351,    0, 1351, 1351, 1351,
 1351, 1351,    0, 1351, 1351, 1351, 1351, 1351, 1351, 1351,
 1351, 1351, 1351, 1351, 1351, 1351, 1351, 1351, 1351, 1351,
 1351, 1351, 1351, 1351, 1351,    0,    0,    0,   57,    0,
    0, 1175, 1353, 1353, 1353, 1353, 1353, 1353, 1353,    0,
 1112, 1110, 2197, 1111,   58, 1113,    0,    0,    0, 1353,
 1353, 1353, 1353, 1353,   59,    0,    0,    0,    0,    0,
    0,   60,    0,    0,    0,   61, 1112, 1110, 2202, 1111,
    0, 1113,    0,    0,    0,    0,    0,    0,    0,  673,
  673,    0, 1353,    0, 1353,   62,    0,  673,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  673,
 1112, 1110, 2204, 1111,    0, 1113,    0,    0, 1112, 1110,
 2205, 1111,    0, 1113,    0,    0,    0,    0,    0,    0,
   95,    0,    0,    0,    0,    0,    0,   96,    0,    0,
    0,   97,   98,    0,    0,    0,    0,    0,    0,    0,
   99,    0,    0,    0,    0,    0,   63,    0, 2161,    0,
    0,  100,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1108,    0,    0,    0,    0, 1109,    0,
    0,    0,    0,  673,    0,    0,    0,   64,    0,    0,
    0,   65,    0,    0,    0,    0,   66, 2149, 2150,    0,
    0,    0,   67,    0,  673, 2156, 2157,    0, 2159, 2160,
  673,    0,    0,    0,    0,    0,    0, 2165, 2166, 2167,
 2168,   68,  101, 2170, 2171, 2172, 2173, 2174, 2175,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  102,    0,
    0,    0,    0,    0,  673,    0,    0,    0,    0,    0,
    0,    0,    0,  103,    0,    0,    0,  104, 1353,    0,
 1353,    0,  105, 1353,    0, 1353, 1353,    0,  106, 1353,
 1353,    0, 1353,    0,    0,    0,    0,   69, 1353,    0,
    0, 1353, 1353, 1353, 1353, 1108, 1353,  107,    0, 1353,
 1109,    0, 1353,    0,    0,    0,    0,    0,    0, 1353,
    0, 1353, 1353,    0, 1353, 1353, 1353,    0, 1353, 1353,
    0, 1108, 1353,    0,    0, 1353, 1109, 1353, 1353,    0,
    0, 1353, 1353, 1353,    0, 1353,    0, 1353, 1353, 1353,
 1353, 1353, 1353,    0,    0,    0, 1353, 1353, 1353, 1353,
 1353,    0,    0,  108, 1353, 1108,  109,    0,    0,    0,
 1109,    0, 1353, 1108, 1353, 1353, 1353, 1353, 1109, 1353,
    0,    0,    0,    0, 1353, 1353,    0, 1353,    0, 1353,
    0, 1353, 1353, 1353,    0, 1353,    0, 1353, 1353, 1353,
    0, 1353, 1353, 1353, 1353, 1353,    0, 1353, 1353,    0,
    0,    0,    0, 1353,  164, 1353, 1353,    0,    0, 1353,
 1353, 1353,    0,    0, 1353,    0,    0, 1353,    0,    0,
 1353, 1353, 1353, 1353,    0, 1353,    0, 1353,    0, 1353,
 1353, 1353, 1353, 1353,    0,    0, 1353, 1353, 1353,    0,
 1353, 1353,    0,    0,    0,  164,    0,    0,  164,    0,
    0, 1353, 1353, 1353,    0, 1353, 1353, 1353,    0,    0,
    0, 1353,    0,  164, 1353,    0, 1353, 1353, 1353, 1353,
    0, 1353,    0, 1353, 1353, 1353, 1353, 1353, 1353, 1353,
 1353,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1353, 1353,    0, 1353, 1353, 1353,    0,    0,    0,    0,
 1353, 1353, 1353, 1353, 1353,    0, 1353,    0,    0, 1353,
 1353, 1353, 1353, 1353, 1353, 1353,    0,    0,    0, 1353,
 1353, 1353, 1353, 1353, 1353, 1353, 1353,    0, 1353,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1353, 1353,
 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353,
 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353,    0,
 1353, 1353, 1353, 1353, 1353, 1353,    0, 1353, 1353, 1353,
 1353,    0, 1353,    0, 1353, 1353, 1353, 1353, 1353, 1353,
 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353,
 1353, 1353, 1354, 1353, 1353, 1353, 1353,    0, 1353, 1353,
 1353, 1353, 1353,    0, 1353, 1353, 1353, 1353, 1353, 1353,
 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353, 1353,
 1353, 1353, 1353, 1353, 1353, 1353,    0,  263,    0,    0,
  263,    0, 1176, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
    0,    0,    0,  263,    0,    0,    0,  263,    0,  263,
 1354, 1354, 1354, 1354, 1354,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  164,  164,    0, 1354,    0, 1354,    0,    0,  164,  263,
 1338,    0,    0,  970,    0,  263,  263,  263,    0,  263,
  263,  263,    0,  263,    0,    0, 1339,    0,    0,    0,
  971,    0,  972,    0,    0,    0,    0,    0,    0,    0,
  263,    0,  263,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  263,  973,    0,    0,    0,   88,    0,  974,  975,
  976,    0,  977,  978,  979,    0,  980,    0,  263,    0,
    0,    0,    0,    0,  164,    0,    0,    0,    0,    0,
    0,    0,    0,  981,    0,  982,    0,    0,    0,    0,
  263,    0,    0,    0,    0,  164,    0,    0,    0,    0,
    0,  164,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  983,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  263,  263,    0,    0,    0,
    0,  984,    0,    0,    0,  164,    0,    0,    0,    0,
    0,    0,  263,    0,    0,    0,    0,    0,    0, 1354,
    0, 1354,    0,  985, 1354,    0, 1354, 1354,    0,    0,
 1354, 1354,    0, 1354,    0,    0,    0,    0,    0, 1354,
    0,    0, 1354, 1354, 1354, 1354,    0, 1354,    0,    0,
 1354,    0,    0, 1354,    0,    0,    0,    0,  986,  987,
 1354,    0, 1354, 1354,    0, 1354, 1354, 1354,    0, 1354,
 1354,    0,    0, 1354,    0,  988, 1354,    0, 1354, 1354,
    0,    0, 1354, 1354, 1354,    0, 1354,    0, 1354, 1354,
 1354, 1354, 1354, 1354,    0,    0,    0, 1354, 1354, 1354,
 1354, 1354,    0,    0,    0, 1354,    0,    0,    0,    0,
    0,    0,    0, 1354,    0, 1354, 1354, 1354, 1354,    0,
 1354,    0,    0,    0,    0, 1354, 1354,    0, 1354,    0,
 1354,    0, 1354, 1354, 1354,    0, 1354,    0, 1354, 1354,
 1354,    0, 1354, 1354, 1354, 1354, 1354,    0, 1354, 1354,
    0,    0,    0,    0, 1354,  291, 1354, 1354,    0,    0,
 1354, 1354, 1354,    0,    0, 1354,    0,    0, 1354,    0,
    0, 1354, 1354, 1354, 1354,    0, 1354,    0, 1354,    0,
 1354, 1354, 1354, 1354, 1354,    0,    0, 1354, 1354, 1354,
    0, 1354, 1354,    0,    0,    0,  291,    0,    0,  291,
    0,    0, 1354, 1354, 1354,    0, 1354, 1354, 1354,    0,
    0,    0, 1354,    0,  291, 1354,    0, 1354, 1354, 1354,
 1354,    0, 1354,    0, 1354, 1354, 1354, 1354, 1354, 1354,
 1354, 1354,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1354, 1354,    0, 1354, 1354, 1354,    0,    0,    0,
    0, 1354, 1354, 1354, 1354, 1354,    0, 1354,    0,    0,
 1354, 1354, 1354, 1354, 1354, 1354, 1354,    0,    0,    0,
 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,    0, 1354,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1354,
 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
    0, 1354, 1354, 1354, 1354, 1354, 1354,    0, 1354, 1354,
 1354, 1354,    0, 1354,    0, 1354, 1354, 1354, 1354, 1354,
 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
 1354, 1354, 1354, 1355, 1354, 1354, 1354, 1354,    0, 1354,
 1354, 1354, 1354, 1354,    0, 1354, 1354, 1354, 1354, 1354,
 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354, 1354,
 1354, 1354, 1354, 1354, 1354, 1354, 1354,    0,  263,    0,
    0,  263,    0, 1177, 1355, 1355, 1355, 1355, 1355, 1355,
 1355,    0,    0,    0,  263,    0,    0,    0,  263,    0,
  263, 1355, 1355, 1355, 1355, 1355,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  291,  291,    0, 1355,    0, 1355,    0,  969,  291,
  263,  970,    0,    0,    0,    0,  263,  263,  263,    0,
  263,  263,  263,    0,  263,    0,    0,    0,  971,    0,
  972,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  263,    0,  263,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  973,    0,  263,    0,    0,    0,  974,  975,  976,    0,
  977,  978,  979,    0,  980,    0,    0,    0,    0,  263,
    0,    0,    0,    0,    0,  291,    0,    0,    0,    0,
    0,  981,    0,  982,    0,    0,    0,    0,    0,    0,
    0,  263,    0,    0,    0,    0,  291,    0,    0,    0,
    0,    0,  291,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  983,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  263,  263,    0,  984,
    0,    0,    0,    0,    0,    0,  291,    0,    0,    0,
    0,    0,    0,  263,    0,    0,    0,    0,    0,    0,
 1355,  985, 1355,    0,    0, 1355,    0, 1355, 1355,    0,
    0, 1355, 1355,    0, 1355,    0,    0,    0,    0,    0,
 1355,    0,    0, 1355, 1355, 1355, 1355,    0, 1355,    0,
    0, 1355,    0,    0, 1355,    0,  986,  987,    0,    0,
    0, 1355,    0, 1355, 1355,    0, 1355, 1355, 1355,    0,
 1355, 1355,    0,  988, 1355,    0,    0, 1355,    0, 1355,
 1355,    0,    0, 1355, 1355, 1355,    0, 1355,    0, 1355,
 1355, 1355, 1355, 1355, 1355,    0,    0,    0, 1355, 1355,
 1355, 1355, 1355,    0,    0,    0, 1355,    0,    0,    0,
    0,    0,    0,    0, 1355,    0, 1355, 1355, 1355, 1355,
    0, 1355,    0,    0,    0,    0, 1355, 1355,    0, 1355,
    0, 1355,    0, 1355, 1355, 1355,    0, 1355,    0, 1355,
 1355, 1355,    0, 1355, 1355, 1355, 1355, 1355,    0, 1355,
 1355,    0,    0,    0,    0, 1355,    0, 1355, 1355,    0,
    0, 1355, 1355, 1355,    0,    0, 1355,    0,    0, 1355,
    0,    0, 1355, 1355, 1355, 1355,    0, 1355,    0, 1355,
    0, 1355, 1355, 1355, 1355, 1355,    0,    0, 1355, 1355,
 1355,    0, 1355, 1355,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1355, 1355, 1355,    0, 1355, 1355, 1355,
    0,    0,    0, 1355,    0,    0, 1355,    0, 1355, 1355,
 1355, 1355,    0, 1355,    0, 1355, 1355, 1355, 1355, 1355,
 1355, 1355, 1355,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1355, 1355,    0, 1355, 1355, 1355,    0,    0,
    0,    0, 1355, 1355, 1355, 1355, 1355,    0, 1355,    0,
    0, 1355, 1355, 1355, 1355, 1355, 1355, 1355,    0,    0,
    0, 1355, 1355, 1355, 1355, 1355, 1355, 1355, 1355,    0,
 1355,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1355, 1355, 1355, 1355, 1355, 1355, 1355, 1355, 1355, 1355,
 1355, 1355, 1355, 1355, 1355, 1355, 1355, 1355, 1355, 1355,
 1355,    0, 1355, 1355, 1355, 1355, 1355, 1355,    0, 1355,
 1355, 1355, 1355,    0, 1355,    0, 1355, 1355, 1355, 1355,
 1355, 1355, 1355, 1355, 1355, 1355, 1355, 1355, 1355, 1355,
 1355, 1355, 1355, 1355, 1356, 1355, 1355, 1355, 1355,    0,
 1355, 1355, 1355, 1355, 1355,    0, 1355, 1355, 1355, 1355,
 1355, 1355, 1355, 1355, 1355, 1355, 1355, 1355, 1355, 1355,
 1355, 1355, 1355, 1355, 1355, 1355, 1355, 1355,  161,    0,
    0,  161,    0,    0, 1178, 1356, 1356, 1356, 1356, 1356,
 1356, 1356,    0,    0,    0,    0,  263,    0,  161,  263,
  161,    0, 1356, 1356, 1356, 1356, 1356,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  263,    0,  263,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1356,    0, 1356,    0,    0,
  161,    0,    0,    0,    0,    0,  161,  161,  161,    0,
  161,  161,  161,    0,  161,    0,    0,    0,  263,    0,
    0,    0,    0,    0,  263,  263,  263,    0,  263,  263,
  263,  161,  263,  161,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  263,
    0,  263,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  161,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  161,
  263,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  263,    0,    0,
    0,  161,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  263,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  161,  161,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  161,  263,  263,    0,    0,    0,    0,
    0, 1356,    0, 1356,    0,    0, 1356,    0, 1356, 1356,
    0,  263, 1356, 1356,    0, 1356,    0,    0,    0,    0,
    0, 1356,    0,    0, 1356, 1356, 1356, 1356,    0, 1356,
    0,    0, 1356,    0,    0, 1356,    0,    0,    0,    0,
    0,    0, 1356,    0, 1356, 1356,    0, 1356, 1356, 1356,
    0, 1356, 1356,    0,    0, 1356,    0,    0, 1356,    0,
 1356, 1356,    0,    0, 1356, 1356, 1356,    0, 1356,    0,
 1356, 1356, 1356, 1356, 1356, 1356,    0,    0,    0, 1356,
 1356, 1356, 1356, 1356,    0,    0,    0, 1356,    0,    0,
    0,    0,    0,    0,    0, 1356,    0, 1356, 1356, 1356,
 1356,    0, 1356,    0,    0,    0,    0, 1356, 1356,    0,
 1356,    0, 1356,    0, 1356, 1356, 1356,    0, 1356,    0,
 1356, 1356, 1356,    0, 1356, 1356, 1356, 1356, 1356,    0,
 1356, 1356,    0,    0,    0,    0, 1356,    0, 1356, 1356,
    0,    0, 1356, 1356, 1356,    0,    0, 1356,    0,    0,
 1356,    0,    0, 1356, 1356, 1356, 1356,    0, 1356,    0,
 1356,    0, 1356, 1356, 1356, 1356, 1356,    0,    0, 1356,
 1356, 1356,    0, 1356, 1356,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1356, 1356, 1356,    0, 1356, 1356,
 1356,    0,    0,    0, 1356,    0,    0, 1356,    0, 1356,
 1356, 1356, 1356,    0, 1356,    0, 1356, 1356, 1356, 1356,
 1356, 1356, 1356, 1356,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1356, 1356,    0, 1356, 1356, 1356,    0,
    0,    0,    0, 1356, 1356, 1356, 1356, 1356,    0, 1356,
    0,    0, 1356, 1356, 1356, 1356, 1356, 1356, 1356,    0,
    0,    0, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
    0, 1356,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
 1356, 1356,    0, 1356, 1356, 1356, 1356, 1356, 1356,    0,
 1356, 1356, 1356, 1356,    0, 1356,    0, 1356, 1356, 1356,
 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
 1356, 1356, 1356, 1356, 1356, 1357, 1356, 1356, 1356, 1356,
    0, 1356, 1356, 1356, 1356, 1356,    0, 1356, 1356, 1356,
 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,
 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356, 1356,    0,
    0,    0,    0,    0,    0, 1179, 1357, 1357, 1357, 1357,
 1357, 1357, 1357,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1357, 1357, 1357, 1357, 1357,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1357,    0, 1357,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1357,    0, 1357,    0,    0, 1357,    0, 1357,
 1357,    0,    0, 1357, 1357,    0, 1357,    0,    0,    0,
    0,    0, 1357,    0,    0, 1357, 1357, 1357, 1357,    0,
 1357,    0,    0, 1357,    0,    0, 1357,    0,    0,    0,
    0,    0,    0, 1357,    0, 1357, 1357,    0, 1357, 1357,
 1357,    0, 1357, 1357,    0,    0, 1357,    0,    0, 1357,
    0, 1357, 1357,    0,    0, 1357, 1357, 1357,    0, 1357,
    0, 1357, 1357, 1357, 1357, 1357, 1357,    0,    0,    0,
 1357, 1357, 1357, 1357, 1357,    0,    0,    0, 1357,    0,
    0,    0,    0,    0,    0,    0, 1357,    0, 1357, 1357,
 1357, 1357,    0, 1357,    0,    0,    0,    0, 1357, 1357,
    0, 1357,    0, 1357,    0, 1357, 1357, 1357,    0, 1357,
    0, 1357, 1357, 1357,    0, 1357, 1357, 1357, 1357, 1357,
    0, 1357, 1357,    0,    0,    0,    0, 1357,    0, 1357,
 1357,    0,    0, 1357, 1357, 1357,    0,    0, 1357,    0,
    0, 1357,    0,    0, 1357, 1357, 1357, 1357,    0, 1357,
    0, 1357,    0, 1357, 1357, 1357, 1357, 1357,    0,    0,
 1357, 1357, 1357,    0, 1357, 1357,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1357, 1357, 1357,    0, 1357,
 1357, 1357,    0,    0,    0, 1357,    0,    0, 1357,    0,
 1357, 1357, 1357, 1357,    0, 1357,    0, 1357, 1357, 1357,
 1357, 1357, 1357, 1357, 1357,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1357, 1357,    0, 1357, 1357, 1357,
    0,    0,    0,    0, 1357, 1357, 1357, 1357, 1357,    0,
 1357,    0,    0, 1357, 1357, 1357, 1357, 1357, 1357, 1357,
    0,    0,    0, 1357, 1357, 1357, 1357, 1357, 1357, 1357,
 1357,    0, 1357,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357,
 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357,
 1357, 1357, 1357,    0, 1357, 1357, 1357, 1357, 1357, 1357,
    0, 1357, 1357, 1357, 1357,    0, 1357,    0, 1357, 1357,
 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357,
 1357, 1357, 1357, 1357, 1357, 1357, 1358, 1357, 1357, 1357,
 1357,    0, 1357, 1357, 1357, 1357, 1357,    0, 1357, 1357,
 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357,
 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357, 1357,
    0,    0,    0,    0,    0,    0, 1180, 1358, 1358, 1358,
 1358, 1358, 1358, 1358,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1358, 1358, 1358, 1358, 1358,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1358,    0, 1358,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1358,    0, 1358,    0,    0, 1358,    0,
 1358, 1358,    0,    0, 1358, 1358,    0, 1358,    0,    0,
    0,    0,    0, 1358,    0,    0, 1358, 1358, 1358, 1358,
    0, 1358,    0,    0, 1358,    0,    0, 1358,    0,    0,
    0,    0,    0,    0, 1358,    0, 1358, 1358,    0, 1358,
 1358, 1358,    0, 1358, 1358,    0,    0, 1358,    0,    0,
 1358,    0, 1358, 1358,    0,    0, 1358, 1358, 1358,    0,
 1358,    0, 1358, 1358, 1358, 1358, 1358, 1358,    0,    0,
    0, 1358, 1358, 1358, 1358, 1358,    0,    0,    0, 1358,
    0,    0,    0,    0,    0,    0,    0, 1358,    0, 1358,
 1358, 1358, 1358,    0, 1358,    0,    0,    0,    0, 1358,
 1358,    0, 1358,    0, 1358,    0, 1358, 1358, 1358,    0,
 1358,    0, 1358, 1358, 1358,    0, 1358, 1358, 1358, 1358,
 1358,    0, 1358, 1358,    0,    0,    0,    0, 1358,    0,
 1358, 1358,    0,    0, 1358, 1358, 1358,    0,    0, 1358,
    0,    0, 1358,    0,    0, 1358, 1358, 1358, 1358,    0,
 1358,    0, 1358,    0, 1358, 1358, 1358, 1358, 1358,    0,
    0, 1358, 1358, 1358,    0, 1358, 1358,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1358, 1358, 1358,    0,
 1358, 1358, 1358,    0,    0,    0, 1358,    0,    0, 1358,
    0, 1358, 1358, 1358, 1358,    0, 1358,    0, 1358, 1358,
 1358, 1358, 1358, 1358, 1358, 1358,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1358, 1358,    0, 1358, 1358,
 1358,    0,    0,    0,    0, 1358, 1358, 1358, 1358, 1358,
    0, 1358,    0,    0, 1358, 1358, 1358, 1358, 1358, 1358,
 1358,    0,    0,    0, 1358, 1358, 1358, 1358, 1358, 1358,
 1358, 1358,    0, 1358,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
 1358, 1358, 1358, 1358,    0, 1358, 1358, 1358, 1358, 1358,
 1358,    0, 1358, 1358, 1358, 1358,    0, 1358,    0, 1358,
 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1359, 1358, 1358,
 1358, 1358,    0, 1358, 1358, 1358, 1358, 1358,    0, 1358,
 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358, 1358,
 1358,    0,    0,    0,    0,    0,    0, 1182, 1359, 1359,
 1359, 1359, 1359, 1359, 1359,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1359, 1359, 1359, 1359, 1359,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1359,    0,
 1359,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1359,    0, 1359,    0,    0, 1359,
    0, 1359, 1359,    0,    0, 1359, 1359,    0, 1359,    0,
    0,    0,    0,    0, 1359,    0,    0, 1359, 1359, 1359,
 1359,    0, 1359,    0,    0, 1359,    0,    0, 1359,    0,
    0,    0,    0,    0,    0, 1359,    0, 1359, 1359,    0,
 1359, 1359, 1359,    0, 1359, 1359,    0,    0, 1359,    0,
    0, 1359,    0, 1359, 1359,    0,    0, 1359, 1359, 1359,
    0, 1359,    0, 1359, 1359, 1359, 1359, 1359, 1359,    0,
    0,    0, 1359, 1359, 1359, 1359, 1359,    0,    0,    0,
 1359,    0,    0,    0,    0,    0,    0,    0, 1359,    0,
 1359, 1359, 1359, 1359,    0, 1359,    0,    0,    0,    0,
 1359, 1359,    0, 1359,    0, 1359,    0, 1359, 1359, 1359,
    0, 1359,    0, 1359, 1359, 1359,    0, 1359, 1359, 1359,
 1359, 1359,    0, 1359, 1359,    0,    0,    0,    0, 1359,
    0, 1359, 1359,    0,    0, 1359, 1359, 1359,    0,    0,
 1359,    0,    0, 1359,    0,    0, 1359, 1359, 1359, 1359,
    0, 1359,    0, 1359,    0, 1359, 1359, 1359, 1359, 1359,
    0,    0, 1359, 1359, 1359,    0, 1359, 1359,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1359, 1359, 1359,
    0, 1359, 1359, 1359,    0,    0,    0, 1359,    0,    0,
 1359,    0, 1359, 1359, 1359, 1359,    0, 1359,    0, 1359,
 1359, 1359, 1359, 1359, 1359, 1359, 1359,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1359, 1359,    0, 1359,
 1359, 1359,    0,    0,    0,    0, 1359, 1359, 1359, 1359,
 1359,    0, 1359,    0,    0, 1359, 1359, 1359, 1359, 1359,
 1359, 1359,    0,    0,    0, 1359, 1359, 1359, 1359, 1359,
 1359, 1359, 1359,    0, 1359,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1359, 1359, 1359, 1359, 1359, 1359,
 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359,
 1359, 1359, 1359, 1359, 1359,    0, 1359, 1359, 1359, 1359,
 1359, 1359,    0, 1359, 1359, 1359, 1359,    0, 1359,    0,
 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359,
 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1360, 1359,
 1359, 1359, 1359,    0, 1359, 1359, 1359, 1359, 1359,    0,
 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359,
 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359, 1359,
 1359, 1359,    0,    0,    0,    0,    0,    0, 1183, 1360,
 1360, 1360, 1360, 1360, 1360, 1360,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1360, 1360, 1360, 1360,
 1360,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1360,
    0, 1360,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1360,    0, 1360,    0,    0,
 1360,    0, 1360, 1360,    0,    0, 1360, 1360,    0, 1360,
    0,    0,    0,    0,    0, 1360,    0,    0, 1360, 1360,
 1360, 1360,    0, 1360,    0,    0, 1360,    0,    0, 1360,
    0,    0,    0,    0,    0,    0, 1360,    0, 1360, 1360,
    0, 1360, 1360, 1360,    0, 1360, 1360,    0,    0, 1360,
    0,    0, 1360,    0, 1360, 1360,    0,    0, 1360, 1360,
 1360,    0, 1360,    0, 1360, 1360, 1360, 1360, 1360, 1360,
    0,    0,    0, 1360, 1360, 1360, 1360, 1360,    0,    0,
    0, 1360,    0,    0,    0,    0,    0,    0,    0, 1360,
    0, 1360, 1360, 1360, 1360,    0, 1360,    0,    0,    0,
    0, 1360, 1360,    0, 1360,    0, 1360,    0, 1360, 1360,
 1360,    0, 1360,    0, 1360, 1360, 1360,    0, 1360, 1360,
 1360, 1360, 1360,    0, 1360, 1360,    0,    0,    0,    0,
 1360,    0, 1360, 1360,    0,    0, 1360, 1360, 1360,    0,
    0, 1360,    0,    0, 1360,    0,    0, 1360, 1360, 1360,
 1360,    0, 1360,    0, 1360,    0, 1360, 1360, 1360, 1360,
 1360,    0,    0, 1360, 1360, 1360,    0, 1360, 1360,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1360, 1360,
 1360,    0, 1360, 1360, 1360,    0,    0,    0, 1360,    0,
    0, 1360,    0, 1360, 1360, 1360, 1360,    0, 1360,    0,
 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1360, 1360,    0,
 1360, 1360, 1360,    0,    0,    0,    0, 1360, 1360, 1360,
 1360, 1360,    0, 1360,    0,    0, 1360, 1360, 1360, 1360,
 1360, 1360, 1360,    0,    0,    0, 1360, 1360, 1360, 1360,
 1360, 1360, 1360, 1360,    0, 1360,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1360, 1360, 1360, 1360, 1360,
 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
 1360, 1360, 1360, 1360, 1360, 1360,    0, 1360, 1360, 1360,
 1360, 1360, 1360,    0, 1360, 1360, 1360, 1360,    0, 1360,
    0, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1361,
 1360, 1360, 1360, 1360,    0, 1360, 1360, 1360, 1360, 1360,
    0, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360, 1360,
 1360, 1360, 1360,    0,    0,    0,    0,    0,    0, 1184,
 1361, 1361, 1361, 1361, 1361, 1361, 1361,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1361, 1361, 1361,
 1361, 1361,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1361,    0, 1361,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1361,    0, 1361,    0,
    0, 1361,    0, 1361, 1361,    0,    0, 1361, 1361,    0,
 1361,    0,    0,    0,    0,    0, 1361,    0,    0, 1361,
 1361, 1361, 1361,    0, 1361,    0,    0, 1361,    0,    0,
 1361,    0,    0,    0,    0,    0,    0, 1361,    0, 1361,
 1361,    0, 1361, 1361, 1361,    0, 1361, 1361,    0,    0,
 1361,    0,    0, 1361,    0, 1361, 1361,    0,    0, 1361,
 1361, 1361,    0, 1361,    0, 1361, 1361, 1361, 1361, 1361,
 1361,    0,    0,    0, 1361, 1361, 1361, 1361, 1361,    0,
    0,    0, 1361,    0,    0,    0,    0,    0,    0,    0,
 1361,    0, 1361, 1361, 1361, 1361,    0, 1361,    0,    0,
    0,    0, 1361, 1361,    0, 1361,    0, 1361,    0, 1361,
 1361, 1361,    0, 1361,    0, 1361, 1361, 1361,    0, 1361,
 1361, 1361, 1361, 1361,    0, 1361, 1361,    0,    0,    0,
    0, 1361,    0, 1361, 1361,    0,    0, 1361, 1361, 1361,
    0,    0, 1361,    0,    0, 1361,    0,    0, 1361, 1361,
 1361, 1361,    0, 1361,    0, 1361,    0, 1361, 1361, 1361,
 1361, 1361,    0,    0, 1361, 1361, 1361,    0, 1361, 1361,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1361,
 1361, 1361,    0, 1361, 1361, 1361,    0,    0,    0, 1361,
    0,    0, 1361,    0, 1361, 1361, 1361, 1361,    0, 1361,
    0, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1361, 1361,
    0, 1361, 1361, 1361,    0,    0,    0,    0, 1361, 1361,
 1361, 1361, 1361,    0, 1361,    0,    0, 1361, 1361, 1361,
 1361, 1361, 1361, 1361,    0,    0,    0, 1361, 1361, 1361,
 1361, 1361, 1361, 1361, 1361,    0, 1361,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1361, 1361, 1361, 1361,
 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361,
 1361, 1361, 1361, 1361, 1361, 1361, 1361,    0, 1361, 1361,
 1361, 1361, 1361, 1361,    0, 1361, 1361, 1361, 1361,    0,
 1361,    0, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361,
 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361,
 1362, 1361, 1361, 1361, 1361,    0, 1361, 1361, 1361, 1361,
 1361,    0, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361,
 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361, 1361,
 1361, 1361, 1361, 1361,    0,    0,    0,    0,    0,    0,
 1185, 1362, 1362, 1362, 1362, 1362, 1362, 1362,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1362, 1362,
 1362, 1362, 1362,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1362,    0, 1362,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1362,    0, 1362,
    0,    0, 1362,    0, 1362, 1362,    0,    0, 1362, 1362,
    0, 1362,    0,    0,    0,    0,    0, 1362,    0,    0,
 1362, 1362, 1362, 1362,    0, 1362,    0,    0, 1362,    0,
    0, 1362,    0,    0,    0,    0,    0,    0, 1362,    0,
 1362, 1362,    0, 1362, 1362, 1362,    0, 1362, 1362,    0,
    0, 1362,    0,    0, 1362,    0, 1362, 1362,    0,    0,
 1362, 1362, 1362,    0, 1362,    0, 1362, 1362, 1362, 1362,
 1362, 1362,    0,    0,    0, 1362, 1362, 1362, 1362, 1362,
    0,    0,    0, 1362,    0,    0,    0,    0,    0,    0,
    0, 1362,    0, 1362, 1362, 1362, 1362,    0, 1362,    0,
    0,    0,    0, 1362, 1362,    0, 1362,    0, 1362,    0,
 1362, 1362, 1362,    0, 1362,    0, 1362, 1362, 1362,    0,
 1362, 1362, 1362, 1362, 1362,    0, 1362, 1362,    0,    0,
    0,    0, 1362,    0, 1362, 1362,    0,    0, 1362, 1362,
 1362,    0,    0, 1362,    0,    0, 1362,    0,    0, 1362,
 1362, 1362, 1362,    0, 1362,    0, 1362,    0, 1362, 1362,
 1362, 1362, 1362,    0,    0, 1362, 1362, 1362,    0, 1362,
 1362,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1362, 1362, 1362,    0, 1362, 1362, 1362,    0,    0,    0,
 1362,    0,    0, 1362,    0, 1362, 1362, 1362, 1362,    0,
 1362,    0, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1362,
 1362,    0, 1362, 1362, 1362,    0,    0,    0,    0, 1362,
 1362, 1362, 1362, 1362,    0, 1362,    0,    0, 1362, 1362,
 1362, 1362, 1362, 1362, 1362,    0,    0,    0, 1362, 1362,
 1362, 1362, 1362, 1362, 1362, 1362,    0, 1362,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1362, 1362, 1362,
 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,    0, 1362,
 1362, 1362, 1362, 1362, 1362,    0, 1362, 1362, 1362, 1362,
    0, 1362,    0, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
 1362, 1363, 1362, 1362, 1362, 1362,    0, 1362, 1362, 1362,
 1362, 1362,    0, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362, 1362,
 1362, 1362, 1362, 1362, 1362,    0,    0,    0,    0,    0,
    0, 1186, 1363, 1363, 1363, 1363, 1363, 1363, 1363,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1363,
 1363, 1363, 1363, 1363,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1363,    0, 1363,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1363,    0,
 1363,    0,    0, 1363,    0, 1363, 1363,    0,    0, 1363,
 1363,    0, 1363,    0,    0,    0,    0,    0, 1363,    0,
    0, 1363, 1363, 1363, 1363,    0, 1363,    0,    0, 1363,
    0,    0, 1363,    0,    0,    0,    0,    0,    0, 1363,
    0, 1363, 1363,    0, 1363, 1363, 1363,    0, 1363, 1363,
    0,    0, 1363,    0,    0, 1363,    0, 1363, 1363,    0,
    0, 1363, 1363, 1363,    0, 1363,    0, 1363, 1363, 1363,
 1363, 1363, 1363,    0,    0,    0, 1363, 1363, 1363, 1363,
 1363,    0,    0,    0, 1363,    0,    0,    0,    0,    0,
    0,    0, 1363,    0, 1363, 1363, 1363, 1363,    0, 1363,
    0,    0,    0,    0, 1363, 1363,    0, 1363,    0, 1363,
    0, 1363, 1363, 1363,    0, 1363,    0, 1363, 1363, 1363,
    0, 1363, 1363, 1363, 1363, 1363,    0, 1363, 1363,    0,
    0,    0,    0, 1363,    0, 1363, 1363,    0,    0, 1363,
 1363, 1363,    0,    0, 1363,    0,    0, 1363,    0,    0,
 1363, 1363, 1363, 1363,    0, 1363,    0, 1363,    0, 1363,
 1363, 1363, 1363, 1363,    0,    0, 1363, 1363, 1363,    0,
 1363, 1363,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1363, 1363, 1363,    0, 1363, 1363, 1363,    0,    0,
    0, 1363,    0,    0, 1363,    0, 1363, 1363, 1363, 1363,
    0, 1363,    0, 1363, 1363, 1363, 1363, 1363, 1363, 1363,
 1363,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1363, 1363,    0, 1363, 1363, 1363,    0,    0,    0,    0,
 1363, 1363, 1363, 1363, 1363,    0, 1363,    0,    0, 1363,
 1363, 1363, 1363, 1363, 1363, 1363,    0,    0,    0, 1363,
 1363, 1363, 1363, 1363, 1363, 1363, 1363,    0, 1363,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1363, 1363,
 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363,
 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363,    0,
 1363, 1363, 1363, 1363, 1363, 1363,    0, 1363, 1363, 1363,
 1363,    0, 1363,    0, 1363, 1363, 1363, 1363, 1363, 1363,
 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363,
 1363, 1363, 1364, 1363, 1363, 1363, 1363,    0, 1363, 1363,
 1363, 1363, 1363,    0, 1363, 1363, 1363, 1363, 1363, 1363,
 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363, 1363,
 1363, 1363, 1363, 1363, 1363, 1363,    0,    0,    0,    0,
    0,    0, 1188, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1364, 1364, 1364, 1364, 1364,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1364,    0, 1364,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1364,
    0, 1364,    0,    0, 1364,    0, 1364, 1364,    0,    0,
 1364, 1364,    0, 1364,    0,    0,    0,    0,    0, 1364,
    0,    0, 1364, 1364, 1364, 1364,    0, 1364,    0,    0,
 1364,    0,    0, 1364,    0,    0,    0,    0,    0,    0,
 1364,    0, 1364, 1364,    0, 1364, 1364, 1364,    0, 1364,
 1364,    0,    0, 1364,    0,    0, 1364,    0, 1364, 1364,
    0,    0, 1364, 1364, 1364,    0, 1364,    0, 1364, 1364,
 1364, 1364, 1364, 1364,    0,    0,    0, 1364, 1364, 1364,
 1364, 1364,    0,    0,    0, 1364,    0,    0,    0,    0,
    0,    0,    0, 1364,    0, 1364, 1364, 1364, 1364,    0,
 1364,    0,    0,    0,    0, 1364, 1364,    0, 1364,    0,
 1364,    0, 1364, 1364, 1364,    0, 1364,    0, 1364, 1364,
 1364,    0, 1364, 1364, 1364, 1364, 1364,    0, 1364, 1364,
    0,    0,    0,    0, 1364,    0, 1364, 1364,    0,    0,
 1364, 1364, 1364,    0,    0, 1364,    0,    0, 1364,    0,
    0, 1364, 1364, 1364, 1364,    0, 1364,    0, 1364,    0,
 1364, 1364, 1364, 1364, 1364,    0,    0, 1364, 1364, 1364,
    0, 1364, 1364,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1364, 1364, 1364,    0, 1364, 1364, 1364,    0,
    0,    0, 1364,    0,    0, 1364,    0, 1364, 1364, 1364,
 1364,    0, 1364,    0, 1364, 1364, 1364, 1364, 1364, 1364,
 1364, 1364,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1364, 1364,    0, 1364, 1364, 1364,    0,    0,    0,
    0, 1364, 1364, 1364, 1364, 1364,    0, 1364,    0,    0,
 1364, 1364, 1364, 1364, 1364, 1364, 1364,    0,    0,    0,
 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,    0, 1364,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1364,
 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
    0, 1364, 1364, 1364, 1364, 1364, 1364,    0, 1364, 1364,
 1364, 1364,    0, 1364,    0, 1364, 1364, 1364, 1364, 1364,
 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
 1364, 1364, 1364, 1365, 1364, 1364, 1364, 1364,    0, 1364,
 1364, 1364, 1364, 1364,    0, 1364, 1364, 1364, 1364, 1364,
 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364, 1364,
 1364, 1364, 1364, 1364, 1364, 1364, 1364,    0,    0,    0,
    0,    0,    0, 1189, 1365, 1365, 1365, 1365, 1365, 1365,
 1365,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1365, 1365, 1365, 1365, 1365,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1365,    0, 1365,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1365,    0, 1365,    0,    0, 1365,    0, 1365, 1365,    0,
    0, 1365, 1365,    0, 1365,    0,    0,    0,    0,    0,
 1365,    0,    0, 1365, 1365, 1365, 1365,    0, 1365,    0,
    0, 1365,    0,    0, 1365,    0,    0,    0,    0,    0,
    0, 1365,    0, 1365, 1365,    0, 1365, 1365, 1365,    0,
 1365, 1365,    0,    0, 1365,    0,    0, 1365,    0, 1365,
 1365,    0,    0, 1365, 1365, 1365,    0, 1365,    0, 1365,
 1365, 1365, 1365, 1365, 1365,    0,    0,    0, 1365, 1365,
 1365, 1365, 1365,    0,    0,    0, 1365,    0,    0,    0,
    0,    0,    0,    0, 1365,    0, 1365, 1365, 1365, 1365,
    0, 1365,    0,    0,    0,    0, 1365, 1365,    0, 1365,
    0, 1365,    0, 1365, 1365, 1365,    0, 1365,    0, 1365,
 1365, 1365,    0, 1365, 1365, 1365, 1365, 1365,    0, 1365,
 1365,    0,    0,    0,    0, 1365,    0, 1365, 1365,    0,
    0, 1365, 1365, 1365,    0,    0, 1365,    0,    0, 1365,
    0,    0, 1365, 1365, 1365, 1365,    0, 1365,    0, 1365,
    0, 1365, 1365, 1365, 1365, 1365,    0,    0, 1365, 1365,
 1365,    0, 1365, 1365,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1365, 1365, 1365,    0, 1365, 1365, 1365,
    0,    0,    0, 1365,    0,    0, 1365,    0, 1365, 1365,
 1365, 1365,    0, 1365,    0, 1365, 1365, 1365, 1365, 1365,
 1365, 1365, 1365,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1365, 1365,    0, 1365, 1365, 1365,    0,    0,
    0,    0, 1365, 1365, 1365, 1365, 1365,    0, 1365,    0,
    0, 1365, 1365, 1365, 1365, 1365, 1365, 1365,    0,    0,
    0, 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365,    0,
 1365,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365,
 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365,
 1365,    0, 1365, 1365, 1365, 1365, 1365, 1365,    0, 1365,
 1365, 1365, 1365,    0, 1365,    0, 1365, 1365, 1365, 1365,
 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365,
 1365, 1365, 1365, 1365, 1366, 1365, 1365, 1365, 1365,    0,
 1365, 1365, 1365, 1365, 1365,    0, 1365, 1365, 1365, 1365,
 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365,
 1365, 1365, 1365, 1365, 1365, 1365, 1365, 1365,    0,    0,
    0,    0,    0,    0, 1190, 1366, 1366, 1366, 1366, 1366,
 1366, 1366,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1366, 1366, 1366, 1366, 1366,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1366,    0, 1366,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1366,    0, 1366,    0,    0, 1366,    0, 1366, 1366,
    0,    0, 1366, 1366,    0, 1366,    0,    0,    0,    0,
    0, 1366,    0,    0, 1366, 1366, 1366, 1366,    0, 1366,
    0,    0, 1366,    0,    0, 1366,    0,    0,    0,    0,
    0,    0, 1366,    0, 1366, 1366,    0, 1366, 1366, 1366,
    0, 1366, 1366,    0,    0, 1366,    0,    0, 1366,    0,
 1366, 1366,    0,    0, 1366, 1366, 1366,    0, 1366,    0,
 1366, 1366, 1366, 1366, 1366, 1366,    0,    0,    0, 1366,
 1366, 1366, 1366, 1366,    0,    0,    0, 1366,    0,    0,
    0,    0,    0,    0,    0, 1366,    0, 1366, 1366, 1366,
 1366,    0, 1366,    0,    0,    0,    0, 1366, 1366,    0,
 1366,    0, 1366,    0, 1366, 1366, 1366,    0, 1366,    0,
 1366, 1366, 1366,    0, 1366, 1366, 1366, 1366, 1366,    0,
 1366, 1366,    0,    0,    0,    0, 1366,    0, 1366, 1366,
    0,    0, 1366, 1366, 1366,    0,    0, 1366,    0,    0,
 1366,    0,    0, 1366, 1366, 1366, 1366,    0, 1366,    0,
 1366,    0, 1366, 1366, 1366, 1366, 1366,    0,    0, 1366,
 1366, 1366,    0, 1366, 1366,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1366, 1366, 1366,    0, 1366, 1366,
 1366,    0,    0,    0, 1366,    0,    0, 1366,    0, 1366,
 1366, 1366, 1366,    0, 1366,    0, 1366, 1366, 1366, 1366,
 1366, 1366, 1366, 1366,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1366, 1366,    0, 1366, 1366, 1366,    0,
    0,    0,    0, 1366, 1366, 1366, 1366, 1366,    0, 1366,
    0,    0, 1366, 1366, 1366, 1366, 1366, 1366, 1366,    0,
    0,    0, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
    0, 1366,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
 1366, 1366,    0, 1366, 1366, 1366, 1366, 1366, 1366,    0,
 1366, 1366, 1366, 1366,    0, 1366,    0, 1366, 1366, 1366,
 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
 1366, 1366, 1366, 1366, 1366, 1370, 1366, 1366, 1366, 1366,
    0, 1366, 1366, 1366, 1366, 1366,    0, 1366, 1366, 1366,
 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,
 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366, 1366,    0,
    0,    0,    0,    0,    0, 1191, 1370, 1370, 1370, 1370,
 1370, 1370, 1370,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1370, 1370, 1370, 1370, 1370,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1370,    0, 1370,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1370,    0, 1370,    0,    0, 1370,    0, 1370,
 1370,    0,    0, 1370, 1370,    0, 1370,    0,    0,    0,
    0,    0, 1370,    0,    0, 1370, 1370, 1370, 1370,    0,
 1370,    0,    0, 1370,    0,    0, 1370,    0,    0,    0,
    0,    0,    0, 1370,    0, 1370, 1370,    0, 1370, 1370,
 1370,    0, 1370, 1370,    0,    0, 1370,    0,    0, 1370,
    0, 1370, 1370,    0,    0, 1370, 1370, 1370,    0, 1370,
    0, 1370, 1370, 1370, 1370, 1370, 1370,    0,    0,    0,
 1370, 1370, 1370, 1370, 1370,    0,    0,    0, 1370,    0,
    0,    0,    0,    0,    0,    0, 1370,    0, 1370, 1370,
 1370, 1370,    0, 1370,    0,    0,    0,    0, 1370, 1370,
    0, 1370,    0, 1370,    0, 1370, 1370, 1370,    0, 1370,
    0, 1370, 1370, 1370,    0, 1370, 1370, 1370, 1370, 1370,
    0, 1370, 1370,    0,    0,    0,    0, 1370,    0, 1370,
 1370,    0,    0, 1370, 1370, 1370,    0,    0, 1370,    0,
    0, 1370,    0,    0, 1370, 1370, 1370, 1370,    0, 1370,
    0, 1370,    0, 1370, 1370, 1370, 1370, 1370,    0,    0,
 1370, 1370, 1370,    0, 1370, 1370,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1370, 1370, 1370,    0, 1370,
 1370, 1370,    0,    0,    0, 1370,    0,    0, 1370,    0,
 1370, 1370, 1370, 1370,    0, 1370,    0, 1370, 1370, 1370,
 1370, 1370, 1370, 1370, 1370,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1370, 1370,    0, 1370, 1370, 1370,
    0,    0,    0,    0, 1370, 1370, 1370, 1370, 1370,    0,
 1370,    0,    0, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
    0,    0,    0, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
 1370,    0, 1370,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
 1370, 1370, 1370,    0, 1370, 1370, 1370, 1370, 1370, 1370,
    0, 1370, 1370, 1370, 1370,    0, 1370,    0, 1370, 1370,
 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
 1370, 1370, 1370, 1370, 1370, 1370, 1371, 1370, 1370, 1370,
 1370,    0, 1370, 1370, 1370, 1370, 1370,    0, 1370, 1370,
 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370, 1370,
    0,    0,    0,    0,    0,    0, 1192, 1371, 1371, 1371,
 1371, 1371, 1371, 1371,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1371, 1371, 1371, 1371, 1371,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1371,    0, 1371,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1371,    0, 1371,    0,    0, 1371,    0,
 1371, 1371,    0,    0, 1371, 1371,    0, 1371,    0,    0,
    0,    0,    0, 1371,    0,    0, 1371, 1371, 1371, 1371,
    0, 1371,    0,    0, 1371,    0,    0, 1371,    0,    0,
    0,    0,    0,    0, 1371,    0, 1371, 1371,    0, 1371,
 1371, 1371,    0, 1371, 1371,    0,    0, 1371,    0,    0,
 1371,    0, 1371, 1371,    0,    0, 1371, 1371, 1371,    0,
 1371,    0, 1371, 1371, 1371, 1371, 1371, 1371,    0,    0,
    0, 1371, 1371, 1371, 1371, 1371,    0,    0,    0, 1371,
    0,    0,    0,    0,    0,    0,    0, 1371,    0, 1371,
 1371, 1371, 1371,    0, 1371,    0,    0,    0,    0, 1371,
 1371,    0, 1371,    0, 1371,    0, 1371, 1371, 1371,    0,
 1371,    0, 1371, 1371, 1371,    0, 1371, 1371, 1371, 1371,
 1371,    0, 1371, 1371,    0,    0,    0,    0, 1371,    0,
 1371, 1371,    0,    0, 1371, 1371, 1371,    0,    0, 1371,
    0,    0, 1371,    0,    0, 1371, 1371, 1371, 1371,    0,
 1371,    0, 1371,    0, 1371, 1371, 1371, 1371, 1371,    0,
    0, 1371, 1371, 1371,    0, 1371, 1371,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1371, 1371, 1371,    0,
 1371, 1371, 1371,    0,    0,    0, 1371,    0,    0, 1371,
    0, 1371, 1371, 1371, 1371,    0, 1371,    0, 1371, 1371,
 1371, 1371, 1371, 1371, 1371, 1371,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1371, 1371,    0, 1371, 1371,
 1371,    0,    0,    0,    0, 1371, 1371, 1371, 1371, 1371,
    0, 1371,    0,    0, 1371, 1371, 1371, 1371, 1371, 1371,
 1371,    0,    0,    0, 1371, 1371, 1371, 1371, 1371, 1371,
 1371, 1371,    0, 1371,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1371, 1371, 1371, 1371, 1371, 1371, 1371,
 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371,
 1371, 1371, 1371, 1371,    0, 1371, 1371, 1371, 1371, 1371,
 1371,    0, 1371, 1371, 1371, 1371,    0, 1371,    0, 1371,
 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371,
 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1372, 1371, 1371,
 1371, 1371,    0, 1371, 1371, 1371, 1371, 1371,    0, 1371,
 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371,
 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371, 1371,
 1371,    0,    0,    0,    0,    0,    0, 1193, 1372, 1372,
 1372, 1372, 1372, 1372, 1372,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1372, 1372, 1372, 1372, 1372,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1372,    0,
 1372,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1372,    0, 1372,    0,    0, 1372,
    0, 1372, 1372,    0,    0, 1372, 1372,    0, 1372,    0,
    0,    0,    0,    0, 1372,    0,    0, 1372, 1372, 1372,
 1372,    0, 1372,    0,    0, 1372,    0,    0, 1372,    0,
    0,    0,    0,    0,    0, 1372,    0, 1372, 1372,    0,
 1372, 1372, 1372,    0, 1372, 1372,    0,    0, 1372,    0,
    0, 1372,    0, 1372, 1372,    0,    0, 1372, 1372, 1372,
    0, 1372,    0, 1372, 1372, 1372, 1372, 1372, 1372,    0,
    0,    0, 1372, 1372, 1372, 1372, 1372,    0,    0,    0,
 1372,    0,    0,    0,    0,    0,    0,    0, 1372,    0,
 1372, 1372, 1372, 1372,    0, 1372,    0,    0,    0,    0,
 1372, 1372,    0, 1372,    0, 1372,    0, 1372, 1372, 1372,
    0, 1372,    0, 1372, 1372, 1372,    0, 1372, 1372, 1372,
 1372, 1372,    0, 1372, 1372,    0,    0,    0,    0, 1372,
    0, 1372, 1372,    0,    0, 1372, 1372, 1372,    0,    0,
 1372,    0,    0, 1372,    0,    0, 1372, 1372, 1372, 1372,
    0, 1372,    0, 1372,    0, 1372, 1372, 1372, 1372, 1372,
    0,    0, 1372, 1372, 1372,    0, 1372, 1372,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1372, 1372, 1372,
    0, 1372, 1372, 1372,    0,    0,    0, 1372,    0,    0,
 1372,    0, 1372, 1372, 1372, 1372,    0, 1372,    0, 1372,
 1372, 1372, 1372, 1372, 1372, 1372, 1372,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1372, 1372,    0, 1372,
 1372, 1372,    0,    0,    0,    0, 1372, 1372, 1372, 1372,
 1372,    0, 1372,    0,    0, 1372, 1372, 1372, 1372, 1372,
 1372, 1372,    0,    0,    0, 1372, 1372, 1372, 1372, 1372,
 1372, 1372, 1372,    0, 1372,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1372, 1372, 1372, 1372, 1372, 1372,
 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
 1372, 1372, 1372, 1372, 1372,    0, 1372, 1372, 1372, 1372,
 1372, 1372,    0, 1372, 1372, 1372, 1372,    0, 1372,    0,
 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1374, 1372,
 1372, 1372, 1372,    0, 1372, 1372, 1372, 1372, 1372,    0,
 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372, 1372,
 1372, 1372,    0,    0,    0,    0,    0,    0, 1194, 1374,
 1374, 1374, 1374, 1374, 1374, 1374,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1374, 1374, 1374, 1374,
 1374,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1374,
    0, 1374,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1374,    0, 1374,    0,    0,
 1374,    0, 1374, 1374,    0,    0, 1374, 1374,    0, 1374,
    0,    0,    0,    0,    0, 1374,    0,    0, 1374, 1374,
 1374, 1374,    0, 1374,    0,    0, 1374,    0,    0, 1374,
    0,    0,    0,    0,    0,    0, 1374,    0, 1374, 1374,
    0, 1374, 1374, 1374,    0, 1374, 1374,    0,    0, 1374,
    0,    0, 1374,    0, 1374, 1374,    0,    0, 1374, 1374,
 1374,    0, 1374,    0, 1374, 1374, 1374, 1374, 1374, 1374,
    0,    0,    0, 1374, 1374, 1374, 1374, 1374,    0,    0,
    0, 1374,    0,    0,    0,    0,    0,    0,    0, 1374,
    0, 1374, 1374, 1374, 1374,    0, 1374,    0,    0,    0,
    0, 1374, 1374,    0, 1374,    0, 1374,    0, 1374, 1374,
 1374,    0, 1374,    0, 1374, 1374, 1374,    0, 1374, 1374,
 1374, 1374, 1374,    0, 1374, 1374,    0,    0,    0,    0,
 1374,    0, 1374, 1374,    0,    0, 1374, 1374, 1374,    0,
    0, 1374,    0,    0, 1374,    0,    0, 1374, 1374, 1374,
 1374,    0, 1374,    0, 1374,    0, 1374, 1374, 1374, 1374,
 1374,    0,    0, 1374, 1374, 1374,    0, 1374, 1374,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1374, 1374,
 1374,    0, 1374, 1374, 1374,    0,    0,    0, 1374,    0,
    0, 1374,    0, 1374, 1374, 1374, 1374,    0, 1374,    0,
 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1374, 1374,    0,
 1374, 1374, 1374,    0,    0,    0,    0, 1374, 1374, 1374,
 1374, 1374,    0, 1374,    0,    0, 1374, 1374, 1374, 1374,
 1374, 1374, 1374,    0,    0,    0, 1374, 1374, 1374, 1374,
 1374, 1374, 1374, 1374,    0, 1374,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1374, 1374, 1374, 1374, 1374,
 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
 1374, 1374, 1374, 1374, 1374, 1374,    0, 1374, 1374, 1374,
 1374, 1374, 1374,    0, 1374, 1374, 1374, 1374,    0, 1374,
    0, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1376,
 1374, 1374, 1374, 1374,    0, 1374, 1374, 1374, 1374, 1374,
    0, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374, 1374,
 1374, 1374, 1374,    0,    0,    0,    0,    0,    0, 1196,
 1376, 1376, 1376, 1376, 1376, 1376, 1376,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1376, 1376, 1376,
 1376, 1376,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1376,    0, 1376,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1376,    0, 1376,    0,
    0, 1376,    0, 1376, 1376,    0,    0, 1376, 1376,    0,
 1376,    0,    0,    0,    0,    0, 1376,    0,    0, 1376,
 1376, 1376, 1376,    0, 1376,    0,    0, 1376,    0,    0,
 1376,    0,    0,    0,    0,    0,    0, 1376,    0, 1376,
 1376,    0, 1376, 1376, 1376,    0, 1376, 1376,    0,    0,
 1376,    0,    0, 1376,    0, 1376, 1376,    0,    0, 1376,
 1376, 1376,    0, 1376,    0, 1376, 1376, 1376, 1376, 1376,
 1376,    0,    0,    0, 1376, 1376, 1376, 1376, 1376,    0,
    0,    0, 1376,    0,    0,    0,    0,    0,    0,    0,
 1376,    0, 1376, 1376, 1376, 1376,    0, 1376,    0,    0,
    0,    0, 1376, 1376,    0, 1376,    0, 1376,    0, 1376,
 1376, 1376,    0, 1376,    0, 1376, 1376, 1376,    0, 1376,
 1376, 1376, 1376, 1376,    0, 1376, 1376,    0,    0,    0,
    0, 1376,    0, 1376, 1376,    0,    0, 1376, 1376, 1376,
    0,    0, 1376,    0,    0, 1376,    0,    0, 1376, 1376,
 1376, 1376,    0, 1376,    0, 1376,    0, 1376, 1376, 1376,
 1376, 1376,    0,    0, 1376, 1376, 1376,    0, 1376, 1376,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1376,
 1376, 1376,    0, 1376, 1376, 1376,    0,    0,    0, 1376,
    0,    0, 1376,    0, 1376, 1376, 1376, 1376,    0, 1376,
    0, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1376, 1376,
    0, 1376, 1376, 1376,    0,    0,    0,    0, 1376, 1376,
 1376, 1376, 1376,    0, 1376,    0,    0, 1376, 1376, 1376,
 1376, 1376, 1376, 1376,    0,    0,    0, 1376, 1376, 1376,
 1376, 1376, 1376, 1376, 1376,    0, 1376,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1376, 1376, 1376, 1376,
 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
 1376, 1376, 1376, 1376, 1376, 1376, 1376,    0, 1376, 1376,
 1376, 1376, 1376, 1376,    0, 1376, 1376, 1376, 1376,    0,
 1376,    0, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
 1377, 1376, 1376, 1376, 1376,    0, 1376, 1376, 1376, 1376,
 1376,    0, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376, 1376,
 1376, 1376, 1376, 1376,    0,    0,    0,    0,    0,    0,
 1197, 1377, 1377, 1377, 1377, 1377, 1377, 1377,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1377, 1377,
 1377, 1377, 1377,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1377,    0, 1377,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1377,    0, 1377,
    0,    0, 1377,    0, 1377, 1377,    0,    0, 1377, 1377,
    0, 1377,    0,    0,    0,    0,    0, 1377,    0,    0,
 1377, 1377, 1377, 1377,    0, 1377,    0,    0, 1377,    0,
    0, 1377,    0,    0,    0,    0,    0,    0, 1377,    0,
 1377, 1377,    0, 1377, 1377, 1377,    0, 1377, 1377,    0,
    0, 1377,    0,    0, 1377,    0, 1377, 1377,    0,    0,
 1377, 1377, 1377,    0, 1377,    0, 1377, 1377, 1377, 1377,
 1377, 1377,    0,    0,    0, 1377, 1377, 1377, 1377, 1377,
    0,    0,    0, 1377,    0,    0,    0,    0,    0,    0,
    0, 1377,    0, 1377, 1377, 1377, 1377,    0, 1377,    0,
    0,    0,    0, 1377, 1377,    0, 1377,    0, 1377,    0,
 1377, 1377, 1377,    0, 1377,    0, 1377, 1377, 1377,    0,
 1377, 1377, 1377, 1377, 1377,    0, 1377, 1377,    0,    0,
    0,    0, 1377,    0, 1377, 1377,    0,    0, 1377, 1377,
 1377,    0,    0, 1377,    0,    0, 1377,    0,    0, 1377,
 1377, 1377, 1377,    0, 1377,    0, 1377,    0, 1377, 1377,
 1377, 1377, 1377,    0,    0, 1377, 1377, 1377,    0, 1377,
 1377,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1377, 1377, 1377,    0, 1377, 1377, 1377,    0,    0,    0,
 1377,    0,    0, 1377,    0, 1377, 1377, 1377, 1377,    0,
 1377,    0, 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1377,
 1377,    0, 1377, 1377, 1377,    0,    0,    0,    0, 1377,
 1377, 1377, 1377, 1377,    0, 1377,    0,    0, 1377, 1377,
 1377, 1377, 1377, 1377, 1377,    0,    0,    0, 1377, 1377,
 1377, 1377, 1377, 1377, 1377, 1377,    0, 1377,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1377, 1377, 1377,
 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377,
 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377,    0, 1377,
 1377, 1377, 1377, 1377, 1377,    0, 1377, 1377, 1377, 1377,
    0, 1377,    0, 1377, 1377, 1377, 1377, 1377, 1377, 1377,
 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377,
 1377, 1378, 1377, 1377, 1377, 1377,    0, 1377, 1377, 1377,
 1377, 1377,    0, 1377, 1377, 1377, 1377, 1377, 1377, 1377,
 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377, 1377,
 1377, 1377, 1377, 1377, 1377,    0,    0,    0,    0,    0,
    0, 1198, 1378, 1378, 1378, 1378, 1378, 1378, 1378,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1378,
 1378, 1378, 1378, 1378,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1378,    0, 1378,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1378,    0,
 1378,    0,    0, 1378,    0, 1378, 1378,    0,    0, 1378,
 1378,    0, 1378,    0,    0,    0,    0,    0, 1378,    0,
    0, 1378, 1378, 1378, 1378,    0, 1378,    0,    0, 1378,
    0,    0, 1378,    0,    0,    0,    0,    0,    0, 1378,
    0, 1378, 1378,    0, 1378, 1378, 1378,    0, 1378, 1378,
    0,    0, 1378,    0,    0, 1378,    0, 1378, 1378,    0,
    0, 1378, 1378, 1378,    0, 1378,    0, 1378, 1378, 1378,
 1378, 1378, 1378,    0,    0,    0, 1378, 1378, 1378, 1378,
 1378,    0,    0,    0, 1378,    0,    0,    0,    0,    0,
    0,    0, 1378,    0, 1378, 1378, 1378, 1378,    0, 1378,
    0,    0,    0,    0, 1378, 1378,    0, 1378,    0, 1378,
    0, 1378, 1378, 1378,    0, 1378,    0, 1378, 1378, 1378,
    0, 1378, 1378, 1378, 1378, 1378,    0, 1378, 1378,    0,
    0,    0,    0, 1378,    0, 1378, 1378,    0,    0, 1378,
 1378, 1378,    0,    0, 1378,    0,    0, 1378,    0,    0,
 1378, 1378, 1378, 1378,    0, 1378,    0, 1378,    0, 1378,
 1378, 1378, 1378, 1378,    0,    0, 1378, 1378, 1378,    0,
 1378, 1378,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1378, 1378, 1378,    0, 1378, 1378, 1378,    0,    0,
    0, 1378,    0,    0, 1378,    0, 1378, 1378, 1378, 1378,
    0, 1378,    0, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
 1378,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1378, 1378,    0, 1378, 1378, 1378,    0,    0,    0,    0,
 1378, 1378, 1378, 1378, 1378,    0, 1378,    0,    0, 1378,
 1378, 1378, 1378, 1378, 1378, 1378,    0,    0,    0, 1378,
 1378, 1378, 1378, 1378, 1378, 1378, 1378,    0, 1378,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1378, 1378,
 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,    0,
 1378, 1378, 1378, 1378, 1378, 1378,    0, 1378, 1378, 1378,
 1378,    0, 1378,    0, 1378, 1378, 1378, 1378, 1378, 1378,
 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
 1378, 1378, 1379, 1378, 1378, 1378, 1378,    0, 1378, 1378,
 1378, 1378, 1378,    0, 1378, 1378, 1378, 1378, 1378, 1378,
 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378, 1378,
 1378, 1378, 1378, 1378, 1378, 1378,    0,    0,    0,    0,
    0,    0, 1199, 1379, 1379, 1379, 1379, 1379, 1379, 1379,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1379, 1379, 1379, 1379, 1379,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1379,    0, 1379,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1379,
    0, 1379,    0,    0, 1379,    0, 1379, 1379,    0,    0,
 1379, 1379,    0, 1379,    0,    0,    0,    0,    0, 1379,
    0,    0, 1379, 1379, 1379, 1379,    0, 1379,    0,    0,
 1379,    0,    0, 1379,    0,    0,    0,    0,    0,    0,
 1379,    0, 1379, 1379,    0, 1379, 1379, 1379,    0, 1379,
 1379,    0,    0, 1379,    0,    0, 1379,    0, 1379, 1379,
    0,    0, 1379, 1379, 1379,    0, 1379,    0, 1379, 1379,
 1379, 1379, 1379, 1379,    0,    0,    0, 1379, 1379, 1379,
 1379, 1379,    0,    0,    0, 1379,    0,    0,    0,    0,
    0,    0,    0, 1379,    0, 1379, 1379, 1379, 1379,    0,
 1379,    0,    0,    0,    0, 1379, 1379,    0, 1379,    0,
 1379,    0, 1379, 1379, 1379,    0, 1379,    0, 1379, 1379,
 1379,    0, 1379, 1379, 1379, 1379, 1379,    0, 1379, 1379,
    0,    0,    0,    0, 1379,    0, 1379, 1379,    0,    0,
 1379, 1379, 1379,    0,    0, 1379,    0,    0, 1379,    0,
    0, 1379, 1379, 1379, 1379,    0, 1379,    0, 1379,    0,
 1379, 1379, 1379, 1379, 1379,    0,    0, 1379, 1379, 1379,
    0, 1379, 1379,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1379, 1379, 1379,    0, 1379, 1379, 1379,    0,
    0,    0, 1379,    0,    0, 1379,    0, 1379, 1379, 1379,
 1379,    0, 1379,    0, 1379, 1379, 1379, 1379, 1379, 1379,
 1379, 1379,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1379, 1379,    0, 1379, 1379, 1379,    0,    0,    0,
    0, 1379, 1379, 1379, 1379, 1379,    0, 1379,    0,    0,
 1379, 1379, 1379, 1379, 1379, 1379, 1379,    0,    0,    0,
 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379,    0, 1379,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1379,
 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379,
 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379,
    0, 1379, 1379, 1379, 1379, 1379, 1379,    0, 1379, 1379,
 1379, 1379,    0, 1379,    0, 1379, 1379, 1379, 1379, 1379,
 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379,
 1379, 1379, 1379, 1382, 1379, 1379, 1379, 1379,    0, 1379,
 1379, 1379, 1379, 1379,    0, 1379, 1379, 1379, 1379, 1379,
 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379, 1379,
 1379, 1379, 1379, 1379, 1379, 1379, 1379,    0,    0,    0,
    0,    0,    0, 1200, 1382, 1382, 1382, 1382, 1382, 1382,
 1382,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1382, 1382, 1382, 1382, 1382,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1382,    0, 1382,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1382,    0, 1382,    0,    0, 1382,    0, 1382, 1382,    0,
    0, 1382, 1382,    0, 1382,    0,    0,    0,    0,    0,
 1382,    0,    0, 1382, 1382, 1382, 1382,    0, 1382,    0,
    0, 1382,    0,    0, 1382,    0,    0,    0,    0,    0,
    0, 1382,    0, 1382, 1382,    0, 1382, 1382, 1382,    0,
 1382, 1382,    0,    0, 1382,    0,    0, 1382,    0, 1382,
 1382,    0,    0, 1382, 1382, 1382,    0, 1382,    0, 1382,
 1382, 1382, 1382, 1382, 1382,    0,    0,    0, 1382, 1382,
 1382, 1382, 1382,    0,    0,    0, 1382,    0,    0,    0,
    0,    0,    0,    0, 1382,    0, 1382, 1382, 1382, 1382,
    0, 1382,    0,    0,    0,    0, 1382, 1382,    0, 1382,
    0, 1382,    0, 1382, 1382, 1382,    0, 1382,    0, 1382,
 1382, 1382,    0, 1382, 1382, 1382, 1382, 1382,    0, 1382,
 1382,    0,    0,    0,    0, 1382,    0, 1382, 1382,    0,
    0, 1382, 1382, 1382,    0,    0, 1382,    0,    0, 1382,
    0,    0, 1382, 1382, 1382, 1382,    0, 1382,    0, 1382,
    0, 1382, 1382, 1382, 1382, 1382,    0,    0, 1382, 1382,
 1382,    0, 1382, 1382,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1382, 1382, 1382,    0, 1382, 1382, 1382,
    0,    0,    0, 1382,    0,    0, 1382,    0, 1382, 1382,
 1382, 1382,    0, 1382,    0, 1382, 1382, 1382, 1382, 1382,
 1382, 1382, 1382,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1382, 1382,    0, 1382, 1382, 1382,    0,    0,
    0,    0, 1382, 1382, 1382, 1382, 1382,    0, 1382,    0,
    0, 1382, 1382, 1382, 1382, 1382, 1382, 1382,    0,    0,
    0, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,    0,
 1382,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
 1382,    0, 1382, 1382, 1382, 1382, 1382, 1382,    0, 1382,
 1382, 1382, 1382,    0, 1382,    0, 1382, 1382, 1382, 1382,
 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
 1382, 1382, 1382, 1382, 1384, 1382, 1382, 1382, 1382,    0,
 1382, 1382, 1382, 1382, 1382,    0, 1382, 1382, 1382, 1382,
 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,
 1382, 1382, 1382, 1382, 1382, 1382, 1382, 1382,    0,    0,
    0,    0,    0,    0, 1201, 1384, 1384, 1384, 1384, 1384,
 1384, 1384,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1384, 1384, 1384, 1384, 1384,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1384,    0, 1384,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1384,    0, 1384,    0,    0, 1384,    0, 1384, 1384,
    0,    0, 1384, 1384,    0, 1384,    0,    0,    0,    0,
    0, 1384,    0,    0, 1384, 1384, 1384, 1384,    0, 1384,
    0,    0, 1384,    0,    0, 1384,    0,    0,    0,    0,
    0,    0, 1384,    0, 1384, 1384,    0, 1384, 1384, 1384,
    0, 1384, 1384,    0,    0, 1384,    0,    0, 1384,    0,
 1384, 1384,    0,    0, 1384, 1384, 1384,    0, 1384,    0,
 1384, 1384, 1384, 1384, 1384, 1384,    0,    0,    0, 1384,
 1384, 1384, 1384, 1384,    0,    0,    0, 1384,    0,    0,
    0,    0,    0,    0,    0, 1384,    0, 1384, 1384, 1384,
 1384,    0, 1384,    0,    0,    0,    0, 1384, 1384,    0,
 1384,    0, 1384,    0, 1384, 1384, 1384,    0, 1384,    0,
 1384, 1384, 1384,    0, 1384, 1384, 1384, 1384, 1384,    0,
 1384, 1384,    0,    0,    0,    0, 1384,    0, 1384, 1384,
    0,    0, 1384, 1384, 1384,    0,    0, 1384,    0,    0,
 1384,    0,    0, 1384, 1384, 1384, 1384,    0, 1384,    0,
 1384,    0, 1384, 1384, 1384, 1384, 1384,    0,    0, 1384,
 1384, 1384,    0, 1384, 1384,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1384, 1384, 1384,    0, 1384, 1384,
 1384,    0,    0,    0, 1384,    0,    0, 1384,    0, 1384,
 1384, 1384, 1384,    0, 1384,    0, 1384, 1384, 1384, 1384,
 1384, 1384, 1384, 1384,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1384, 1384,    0, 1384, 1384, 1384,    0,
    0,    0,    0, 1384, 1384, 1384, 1384, 1384,    0, 1384,
    0,    0, 1384, 1384, 1384, 1384, 1384, 1384, 1384,    0,
    0,    0, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
    0, 1384,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
 1384, 1384,    0, 1384, 1384, 1384, 1384, 1384, 1384,    0,
 1384, 1384, 1384, 1384,    0, 1384,    0, 1384, 1384, 1384,
 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
 1384, 1384, 1384, 1384, 1384, 1385, 1384, 1384, 1384, 1384,
    0, 1384, 1384, 1384, 1384, 1384,    0, 1384, 1384, 1384,
 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,
 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384, 1384,    0,
    0,    0,    0,    0,    0, 1202, 1385, 1385, 1385, 1385,
 1385, 1385, 1385,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1385, 1385, 1385, 1385, 1385,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1385,    0, 1385,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1385,    0, 1385,    0,    0, 1385,    0, 1385,
 1385,    0,    0, 1385, 1385,    0, 1385,    0,    0,    0,
    0,    0, 1385,    0,    0, 1385, 1385, 1385, 1385,    0,
 1385,    0,    0, 1385,    0,    0, 1385,    0,    0,    0,
    0,    0,    0, 1385,    0, 1385, 1385,    0, 1385, 1385,
 1385,    0, 1385, 1385,    0,    0, 1385,    0,    0, 1385,
    0, 1385, 1385,    0,    0, 1385, 1385, 1385,    0, 1385,
    0, 1385, 1385, 1385, 1385, 1385, 1385,    0,    0,    0,
 1385, 1385, 1385, 1385, 1385,    0,    0,    0, 1385,    0,
    0,    0,    0,    0,    0,    0, 1385,    0, 1385, 1385,
 1385, 1385,    0, 1385,    0,    0,    0,    0, 1385, 1385,
    0, 1385,    0, 1385,    0, 1385, 1385, 1385,    0, 1385,
    0, 1385, 1385, 1385,    0, 1385, 1385, 1385, 1385, 1385,
    0, 1385, 1385,    0,    0,    0,    0, 1385,    0, 1385,
 1385,    0,    0, 1385, 1385, 1385,    0,    0, 1385,    0,
    0, 1385,    0,    0, 1385, 1385, 1385, 1385,    0, 1385,
    0, 1385,    0, 1385, 1385, 1385, 1385, 1385,    0,    0,
 1385, 1385, 1385,    0, 1385, 1385,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1385, 1385, 1385,    0, 1385,
 1385, 1385,    0,    0,    0, 1385,    0,    0, 1385,    0,
 1385, 1385, 1385, 1385,    0, 1385,    0, 1385, 1385, 1385,
 1385, 1385, 1385, 1385, 1385,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1385, 1385,    0, 1385, 1385, 1385,
    0,    0,    0,    0, 1385, 1385, 1385, 1385, 1385,    0,
 1385,    0,    0, 1385, 1385, 1385, 1385, 1385, 1385, 1385,
    0,    0,    0, 1385, 1385, 1385, 1385, 1385, 1385, 1385,
 1385,    0, 1385,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385,
 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385,
 1385, 1385, 1385,    0, 1385, 1385, 1385, 1385, 1385, 1385,
    0, 1385, 1385, 1385, 1385,    0, 1385,    0, 1385, 1385,
 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385,
 1385, 1385, 1385, 1385, 1385, 1385, 1388, 1385, 1385, 1385,
 1385,    0, 1385, 1385, 1385, 1385, 1385,    0, 1385, 1385,
 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385,
 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385, 1385,
    0,    0,    0,    0,    0,    0, 1203, 1388, 1388, 1388,
 1388, 1388, 1388, 1388,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1388, 1388, 1388, 1388, 1388,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1388,    0, 1388,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1388,    0, 1388,    0,    0, 1388,    0,
 1388, 1388,    0,    0, 1388, 1388,    0, 1388,    0,    0,
    0,    0,    0, 1388,    0,    0, 1388, 1388, 1388, 1388,
    0, 1388,    0,    0, 1388,    0,    0, 1388,    0,    0,
    0,    0,    0,    0, 1388,    0, 1388, 1388,    0, 1388,
 1388, 1388,    0, 1388, 1388,    0,    0, 1388,    0,    0,
 1388,    0, 1388, 1388,    0,    0, 1388, 1388, 1388,    0,
 1388,    0, 1388, 1388, 1388, 1388, 1388, 1388,    0,    0,
    0, 1388, 1388, 1388, 1388, 1388,    0,    0,    0, 1388,
    0,    0,    0,    0,    0,    0,    0, 1388,    0, 1388,
 1388, 1388, 1388,    0, 1388,    0,    0,    0,    0, 1388,
 1388,    0, 1388,    0, 1388,    0, 1388, 1388, 1388,    0,
 1388,    0, 1388, 1388, 1388,    0, 1388, 1388, 1388, 1388,
 1388,    0, 1388, 1388,    0,    0,    0,    0, 1388,    0,
 1388, 1388,    0,    0, 1388, 1388, 1388,    0,    0, 1388,
    0,    0, 1388,    0,    0, 1388, 1388, 1388, 1388,    0,
 1388,    0, 1388,    0, 1388, 1388, 1388, 1388, 1388,    0,
    0, 1388, 1388, 1388,    0, 1388, 1388,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1388, 1388, 1388,    0,
 1388, 1388, 1388,    0,    0,    0, 1388,    0,    0, 1388,
    0, 1388, 1388, 1388, 1388,    0, 1388,    0, 1388, 1388,
 1388, 1388, 1388, 1388, 1388, 1388,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1388, 1388,    0, 1388, 1388,
 1388,    0,    0,    0,    0, 1388, 1388, 1388, 1388, 1388,
    0, 1388,    0,    0, 1388, 1388, 1388, 1388, 1388, 1388,
 1388,    0,    0,    0, 1388, 1388, 1388, 1388, 1388, 1388,
 1388, 1388,    0, 1388,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
 1388, 1388, 1388, 1388,    0, 1388, 1388, 1388, 1388, 1388,
 1388,    0, 1388, 1388, 1388, 1388,    0, 1388,    0, 1388,
 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1390, 1388, 1388,
 1388, 1388,    0, 1388, 1388, 1388, 1388, 1388,    0, 1388,
 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388, 1388,
 1388,    0,    0,    0,    0,    0,    0, 1205, 1390, 1390,
 1390, 1390, 1390, 1390, 1390,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1390, 1390, 1390, 1390, 1390,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1390,    0,
 1390,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1390,    0, 1390,    0,    0, 1390,
    0, 1390, 1390,    0,    0, 1390, 1390,    0, 1390,    0,
    0,    0,    0,    0, 1390,    0,    0, 1390, 1390, 1390,
 1390,    0, 1390,    0,    0, 1390,    0,    0, 1390,    0,
    0,    0,    0,    0,    0, 1390,    0, 1390, 1390,    0,
 1390, 1390, 1390,    0, 1390, 1390,    0,    0, 1390,    0,
    0, 1390,    0, 1390, 1390,    0,    0, 1390, 1390, 1390,
    0, 1390,    0, 1390, 1390, 1390, 1390, 1390, 1390,    0,
    0,    0, 1390, 1390, 1390, 1390, 1390,    0,    0,    0,
 1390,    0,    0,    0,    0,    0,    0,    0, 1390,    0,
 1390, 1390, 1390, 1390,    0, 1390,    0,    0,    0,    0,
 1390, 1390,    0, 1390,    0, 1390,    0, 1390, 1390, 1390,
    0, 1390,    0, 1390, 1390, 1390,    0, 1390, 1390, 1390,
 1390, 1390,    0, 1390, 1390,    0,    0,    0,    0, 1390,
    0, 1390, 1390,    0,    0, 1390, 1390, 1390,    0,    0,
 1390,    0,    0, 1390,    0,    0, 1390, 1390, 1390, 1390,
    0, 1390,    0, 1390,    0, 1390, 1390, 1390, 1390, 1390,
    0,    0, 1390, 1390, 1390,    0, 1390, 1390,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1390, 1390, 1390,
    0, 1390, 1390, 1390,    0,    0,    0, 1390,    0,    0,
 1390,    0, 1390, 1390, 1390, 1390,    0, 1390,    0, 1390,
 1390, 1390, 1390, 1390, 1390, 1390, 1390,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1390, 1390,    0, 1390,
 1390, 1390,    0,    0,    0,    0, 1390, 1390, 1390, 1390,
 1390,    0, 1390,    0,    0, 1390, 1390, 1390, 1390, 1390,
 1390, 1390,    0,    0,    0, 1390, 1390, 1390, 1390, 1390,
 1390, 1390, 1390,    0, 1390,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1390, 1390, 1390, 1390, 1390, 1390,
 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
 1390, 1390, 1390, 1390, 1390,    0, 1390, 1390, 1390, 1390,
 1390, 1390,    0, 1390, 1390, 1390, 1390,    0, 1390,    0,
 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1392, 1390,
 1390, 1390, 1390,    0, 1390, 1390, 1390, 1390, 1390,    0,
 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390, 1390,
 1390, 1390,    0,    0,    0,    0,    0,    0, 1206, 1392,
 1392, 1392, 1392, 1392, 1392, 1392,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1392, 1392, 1392, 1392,
 1392,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1392,
    0, 1392,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1392,    0, 1392,    0,    0,
 1392,    0, 1392, 1392,    0,    0, 1392, 1392,    0, 1392,
    0,    0,    0,    0,    0, 1392,    0,    0, 1392, 1392,
 1392, 1392,    0, 1392,    0,    0, 1392,    0,    0, 1392,
    0,    0,    0,    0,    0,    0, 1392,    0, 1392, 1392,
    0, 1392, 1392, 1392,    0, 1392, 1392,    0,    0, 1392,
    0,    0, 1392,    0, 1392, 1392,    0,    0, 1392, 1392,
 1392,    0, 1392,    0, 1392, 1392, 1392, 1392, 1392, 1392,
    0,    0,    0, 1392, 1392, 1392, 1392, 1392,    0,    0,
    0, 1392,    0,    0,    0,    0,    0,    0,    0, 1392,
    0, 1392, 1392, 1392, 1392,    0, 1392,    0,    0,    0,
    0, 1392, 1392,    0, 1392,    0, 1392,    0, 1392, 1392,
 1392,    0, 1392,    0, 1392, 1392, 1392,    0, 1392, 1392,
 1392, 1392, 1392,    0, 1392, 1392,    0,    0,    0,    0,
 1392,    0, 1392, 1392,    0,    0, 1392, 1392, 1392,    0,
    0, 1392,    0,    0, 1392,    0,    0, 1392, 1392, 1392,
 1392,    0, 1392,    0, 1392,    0, 1392, 1392, 1392, 1392,
 1392,    0,    0, 1392, 1392, 1392,    0, 1392, 1392,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1392, 1392,
 1392,    0, 1392, 1392, 1392,    0,    0,    0, 1392,    0,
    0, 1392,    0, 1392, 1392, 1392, 1392,    0, 1392,    0,
 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1392, 1392,    0,
 1392, 1392, 1392,    0,    0,    0,    0, 1392, 1392, 1392,
 1392, 1392,    0, 1392,    0,    0, 1392, 1392, 1392, 1392,
 1392, 1392, 1392,    0,    0,    0, 1392, 1392, 1392, 1392,
 1392, 1392, 1392, 1392,    0, 1392,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1392, 1392, 1392, 1392, 1392,
 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
 1392, 1392, 1392, 1392, 1392, 1392,    0, 1392, 1392, 1392,
 1392, 1392, 1392,    0, 1392, 1392, 1392, 1392,    0, 1392,
    0, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1393,
 1392, 1392, 1392, 1392,    0, 1392, 1392, 1392, 1392, 1392,
    0, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392, 1392,
 1392, 1392, 1392,    0,    0,    0,    0,    0,    0, 1207,
 1393, 1393, 1393, 1393, 1393, 1393, 1393,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1393, 1393, 1393,
 1393, 1393,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1393,    0, 1393,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1393,    0, 1393,    0,
    0, 1393,    0, 1393, 1393,    0,    0, 1393, 1393,    0,
 1393,    0,    0,    0,    0,    0, 1393,    0,    0, 1393,
 1393, 1393, 1393,    0, 1393,    0,    0, 1393,    0,    0,
 1393,    0,    0,    0,    0,    0,    0, 1393,    0, 1393,
 1393,    0, 1393, 1393, 1393,    0, 1393, 1393,    0,    0,
 1393,    0,    0, 1393,    0, 1393, 1393,    0,    0, 1393,
 1393, 1393,    0, 1393,    0, 1393, 1393, 1393, 1393, 1393,
 1393,    0,    0,    0, 1393, 1393, 1393, 1393, 1393,    0,
    0,    0, 1393,    0,    0,    0,    0,    0,    0,    0,
 1393,    0, 1393, 1393, 1393, 1393,    0, 1393,    0,    0,
    0,    0, 1393, 1393,    0, 1393,    0, 1393,    0, 1393,
 1393, 1393,    0, 1393,    0, 1393, 1393, 1393,    0, 1393,
 1393, 1393, 1393, 1393,    0, 1393, 1393,    0,    0,    0,
    0, 1393,    0, 1393, 1393,    0,    0, 1393, 1393, 1393,
    0,    0, 1393,    0,    0, 1393,    0,    0, 1393, 1393,
 1393, 1393,    0, 1393,    0, 1393,    0, 1393, 1393, 1393,
 1393, 1393,    0,    0, 1393, 1393, 1393,    0, 1393, 1393,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1393,
 1393, 1393,    0, 1393, 1393, 1393,    0,    0,    0, 1393,
    0,    0, 1393,    0, 1393, 1393, 1393, 1393,    0, 1393,
    0, 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1393, 1393,
    0, 1393, 1393, 1393,    0,    0,    0,    0, 1393, 1393,
 1393, 1393, 1393,    0, 1393,    0,    0, 1393, 1393, 1393,
 1393, 1393, 1393, 1393,    0,    0,    0, 1393, 1393, 1393,
 1393, 1393, 1393, 1393, 1393,    0, 1393,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1393, 1393, 1393, 1393,
 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393,
 1393, 1393, 1393, 1393, 1393, 1393, 1393,    0, 1393, 1393,
 1393, 1393, 1393, 1393,    0, 1393, 1393, 1393, 1393,    0,
 1393,    0, 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393,
 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393,
 1394, 1393, 1393, 1393, 1393,    0, 1393, 1393, 1393, 1393,
 1393,    0, 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393,
 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393, 1393,
 1393, 1393, 1393, 1393,    0,    0,    0,    0,    0,    0,
 1208, 1394, 1394, 1394, 1394, 1394, 1394, 1394,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1394, 1394,
 1394, 1394, 1394,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1394,    0, 1394,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1394,    0, 1394,
    0,    0, 1394,    0, 1394, 1394,    0,    0, 1394, 1394,
    0, 1394,    0,    0,    0,    0,    0, 1394,    0,    0,
 1394, 1394, 1394, 1394,    0, 1394,    0,    0, 1394,    0,
    0, 1394,    0,    0,    0,    0,    0,    0, 1394,    0,
 1394, 1394,    0, 1394, 1394, 1394,    0, 1394, 1394,    0,
    0, 1394,    0,    0, 1394,    0, 1394, 1394,    0,    0,
 1394, 1394, 1394,    0, 1394,    0, 1394, 1394, 1394, 1394,
 1394, 1394,    0,    0,    0, 1394, 1394, 1394, 1394, 1394,
    0,    0,    0, 1394,    0,    0,    0,    0,    0,    0,
    0, 1394,    0, 1394, 1394, 1394, 1394,    0, 1394,    0,
    0,    0,    0, 1394, 1394,    0, 1394,    0, 1394,    0,
 1394, 1394, 1394,    0, 1394,    0, 1394, 1394, 1394,    0,
 1394, 1394, 1394, 1394, 1394,    0, 1394, 1394,    0,    0,
    0,    0, 1394,    0, 1394, 1394,    0,    0, 1394, 1394,
 1394,    0,    0, 1394,    0,    0, 1394,    0,    0, 1394,
 1394, 1394, 1394,    0, 1394,    0, 1394,    0, 1394, 1394,
 1394, 1394, 1394,    0,    0, 1394, 1394, 1394,    0, 1394,
 1394,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1394, 1394, 1394,    0, 1394, 1394, 1394,    0,    0,    0,
 1394,    0,    0, 1394,    0, 1394, 1394, 1394, 1394,    0,
 1394,    0, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1394,
 1394,    0, 1394, 1394, 1394,    0,    0,    0,    0, 1394,
 1394, 1394, 1394, 1394,    0, 1394,    0,    0, 1394, 1394,
 1394, 1394, 1394, 1394, 1394,    0,    0,    0, 1394, 1394,
 1394, 1394, 1394, 1394, 1394, 1394,    0, 1394,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1394, 1394, 1394,
 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,    0, 1394,
 1394, 1394, 1394, 1394, 1394,    0, 1394, 1394, 1394, 1394,
    0, 1394,    0, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
 1394, 1395, 1394, 1394, 1394, 1394,    0, 1394, 1394, 1394,
 1394, 1394,    0, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394, 1394,
 1394, 1394, 1394, 1394, 1394,    0,    0,    0,    0,    0,
    0, 1210, 1395, 1395, 1395, 1395, 1395, 1395, 1395,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1395,
 1395, 1395, 1395, 1395,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1395,    0, 1395,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1395,    0,
 1395,    0,    0, 1395,    0, 1395, 1395,    0,    0, 1395,
 1395,    0, 1395,    0,    0,    0,    0,    0, 1395,    0,
    0, 1395, 1395, 1395, 1395,    0, 1395,    0,    0, 1395,
    0,    0, 1395,    0,    0,    0,    0,    0,    0, 1395,
    0, 1395, 1395,    0, 1395, 1395, 1395,    0, 1395, 1395,
    0,    0, 1395,    0,    0, 1395,    0, 1395, 1395,    0,
    0, 1395, 1395, 1395,    0, 1395,    0, 1395, 1395, 1395,
 1395, 1395, 1395,    0,    0,    0, 1395, 1395, 1395, 1395,
 1395,    0,    0,    0, 1395,    0,    0,    0,    0,    0,
    0,    0, 1395,    0, 1395, 1395, 1395, 1395,    0, 1395,
    0,    0,    0,    0, 1395, 1395,    0, 1395,    0, 1395,
    0, 1395, 1395, 1395,    0, 1395,    0, 1395, 1395, 1395,
    0, 1395, 1395, 1395, 1395, 1395,    0, 1395, 1395,    0,
    0,    0,    0, 1395,    0, 1395, 1395,    0,    0, 1395,
 1395, 1395,    0,    0, 1395,    0,    0, 1395,    0,    0,
 1395, 1395, 1395, 1395,    0, 1395,    0, 1395,    0, 1395,
 1395, 1395, 1395, 1395,    0,    0, 1395, 1395, 1395,    0,
 1395, 1395,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1395, 1395, 1395,    0, 1395, 1395, 1395,    0,    0,
    0, 1395,    0,    0, 1395,    0, 1395, 1395, 1395, 1395,
    0, 1395,    0, 1395, 1395, 1395, 1395, 1395, 1395, 1395,
 1395,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1395, 1395,    0, 1395, 1395, 1395,    0,    0,    0,    0,
 1395, 1395, 1395, 1395, 1395,    0, 1395,    0,    0, 1395,
 1395, 1395, 1395, 1395, 1395, 1395,    0,    0,    0, 1395,
 1395, 1395, 1395, 1395, 1395, 1395, 1395,    0, 1395,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1395, 1395,
 1395, 1395, 1395, 1395, 1395, 1395, 1395, 1395, 1395, 1395,
 1395, 1395, 1395, 1395, 1395, 1395, 1395, 1395, 1395,    0,
 1395, 1395, 1395, 1395, 1395, 1395,    0, 1395, 1395, 1395,
 1395,    0, 1395,    0, 1395, 1395, 1395, 1395, 1395, 1395,
 1395, 1395, 1395, 1395, 1395, 1395, 1395, 1395, 1395, 1395,
 1395, 1395, 1396, 1395, 1395, 1395, 1395,    0, 1395, 1395,
 1395, 1395, 1395,    0, 1395, 1395, 1395, 1395, 1395, 1395,
 1395, 1395, 1395, 1395, 1395, 1395, 1395, 1395, 1395, 1395,
 1395, 1395, 1395, 1395, 1395, 1395,    0,    0,    0,    0,
    0,    0, 1211, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1396, 1396, 1396, 1396, 1396,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1396,    0, 1396,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1396,
    0, 1396,    0,    0, 1396,    0, 1396, 1396,    0,    0,
 1396, 1396,    0, 1396,    0,    0,    0,    0,    0, 1396,
    0,    0, 1396, 1396, 1396, 1396,    0, 1396,    0,    0,
 1396,    0,    0, 1396,    0,    0,    0,    0,    0,    0,
 1396,    0, 1396, 1396,    0, 1396, 1396, 1396,    0, 1396,
 1396,    0,    0, 1396,    0,    0, 1396,    0, 1396, 1396,
    0,    0, 1396, 1396, 1396,    0, 1396,    0, 1396, 1396,
 1396, 1396, 1396, 1396,    0,    0,    0, 1396, 1396, 1396,
 1396, 1396,    0,    0,    0, 1396,    0,    0,    0,    0,
    0,    0,    0, 1396,    0, 1396, 1396, 1396, 1396,    0,
 1396,    0,    0,    0,    0, 1396, 1396,    0, 1396,    0,
 1396,    0, 1396, 1396, 1396,    0, 1396,    0, 1396, 1396,
 1396,    0, 1396, 1396, 1396, 1396, 1396,    0, 1396, 1396,
    0,    0,    0,    0, 1396,    0, 1396, 1396,    0,    0,
 1396, 1396, 1396,    0,    0, 1396,    0,    0, 1396,    0,
    0, 1396, 1396, 1396, 1396,    0, 1396,    0, 1396,    0,
 1396, 1396, 1396, 1396, 1396,    0,    0, 1396, 1396, 1396,
    0, 1396, 1396,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1396, 1396, 1396,    0, 1396, 1396, 1396,    0,
    0,    0, 1396,    0,    0, 1396,    0, 1396, 1396, 1396,
 1396,    0, 1396,    0, 1396, 1396, 1396, 1396, 1396, 1396,
 1396, 1396,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1396, 1396,    0, 1396, 1396, 1396,    0,    0,    0,
    0, 1396, 1396, 1396, 1396, 1396,    0, 1396,    0,    0,
 1396, 1396, 1396, 1396, 1396, 1396, 1396,    0,    0,    0,
 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,    0, 1396,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1396,
 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
    0, 1396, 1396, 1396, 1396, 1396, 1396,    0, 1396, 1396,
 1396, 1396,    0, 1396,    0, 1396, 1396, 1396, 1396, 1396,
 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
 1396, 1396, 1396, 1397, 1396, 1396, 1396, 1396,    0, 1396,
 1396, 1396, 1396, 1396,    0, 1396, 1396, 1396, 1396, 1396,
 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396, 1396,
 1396, 1396, 1396, 1396, 1396, 1396, 1396,    0,    0,    0,
    0,    0,    0, 1212, 1397, 1397, 1397, 1397, 1397, 1397,
 1397,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1397, 1397, 1397, 1397, 1397,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1397,    0, 1397,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1397,    0, 1397,    0,    0, 1397,    0, 1397, 1397,    0,
    0, 1397, 1397,    0, 1397,    0,    0,    0,    0,    0,
 1397,    0,    0, 1397, 1397, 1397, 1397,    0, 1397,    0,
    0, 1397,    0,    0, 1397,    0,    0,    0,    0,    0,
    0, 1397,    0, 1397, 1397,    0, 1397, 1397, 1397,    0,
 1397, 1397,    0,    0, 1397,    0,    0, 1397,    0, 1397,
 1397,    0,    0, 1397, 1397, 1397,    0, 1397,    0, 1397,
 1397, 1397, 1397, 1397, 1397,    0,    0,    0, 1397, 1397,
 1397, 1397, 1397,    0,    0,    0, 1397,    0,    0,    0,
    0,    0,    0,    0, 1397,    0, 1397, 1397, 1397, 1397,
    0, 1397,    0,    0,    0,    0, 1397, 1397,    0, 1397,
    0, 1397,    0, 1397, 1397, 1397,    0, 1397,    0, 1397,
 1397, 1397,    0, 1397, 1397, 1397, 1397, 1397,    0, 1397,
 1397,    0,    0,    0,    0, 1397,    0, 1397, 1397,    0,
    0, 1397, 1397, 1397,    0,    0, 1397,    0,    0, 1397,
    0,    0, 1397, 1397, 1397, 1397,    0, 1397,    0, 1397,
    0, 1397, 1397, 1397, 1397, 1397,    0,    0, 1397, 1397,
 1397,    0, 1397, 1397,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1397, 1397, 1397,    0, 1397, 1397, 1397,
    0,    0,    0, 1397,    0,    0, 1397,    0, 1397, 1397,
 1397, 1397,    0, 1397,    0, 1397, 1397, 1397, 1397, 1397,
 1397, 1397, 1397,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1397, 1397,    0, 1397, 1397, 1397,    0,    0,
    0,    0, 1397, 1397, 1397, 1397, 1397,    0, 1397,    0,
    0, 1397, 1397, 1397, 1397, 1397, 1397, 1397,    0,    0,
    0, 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397,    0,
 1397,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397,
 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397,
 1397,    0, 1397, 1397, 1397, 1397, 1397, 1397,    0, 1397,
 1397, 1397, 1397,    0, 1397,    0, 1397, 1397, 1397, 1397,
 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397,
 1397, 1397, 1397, 1397, 1398, 1397, 1397, 1397, 1397,    0,
 1397, 1397, 1397, 1397, 1397,    0, 1397, 1397, 1397, 1397,
 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397,
 1397, 1397, 1397, 1397, 1397, 1397, 1397, 1397,    0,    0,
    0,    0,    0,    0, 1213, 1398, 1398, 1398, 1398, 1398,
 1398, 1398,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1398, 1398, 1398, 1398, 1398,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1398,    0, 1398,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1398,    0, 1398,    0,    0, 1398,    0, 1398, 1398,
    0,    0, 1398, 1398,    0, 1398,    0,    0,    0,    0,
    0, 1398,    0,    0, 1398, 1398, 1398, 1398,    0, 1398,
    0,    0, 1398,    0,    0, 1398,    0,    0,    0,    0,
    0,    0, 1398,    0, 1398, 1398,    0, 1398, 1398, 1398,
    0, 1398, 1398,    0,    0, 1398,    0,    0, 1398,    0,
 1398, 1398,    0,    0, 1398, 1398, 1398,    0, 1398,    0,
 1398, 1398, 1398, 1398, 1398, 1398,    0,    0,    0, 1398,
 1398, 1398, 1398, 1398,    0,    0,    0, 1398,    0,    0,
    0,    0,    0,    0,    0, 1398,    0, 1398, 1398, 1398,
 1398,    0, 1398,    0,    0,    0,    0, 1398, 1398,    0,
 1398,    0, 1398,    0, 1398, 1398, 1398,    0, 1398,    0,
 1398, 1398, 1398,    0, 1398, 1398, 1398, 1398, 1398,    0,
 1398, 1398,    0,    0,    0,    0, 1398,    0, 1398, 1398,
    0,    0, 1398, 1398, 1398,    0,    0, 1398,    0,    0,
 1398,    0,    0, 1398, 1398, 1398, 1398,    0, 1398,    0,
 1398,    0, 1398, 1398, 1398, 1398, 1398,    0,    0, 1398,
 1398, 1398,    0, 1398, 1398,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1398, 1398, 1398,    0, 1398, 1398,
 1398,    0,    0,    0, 1398,    0,    0, 1398,    0, 1398,
 1398, 1398, 1398,    0, 1398,    0, 1398, 1398, 1398, 1398,
 1398, 1398, 1398, 1398,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1398, 1398,    0, 1398, 1398, 1398,    0,
    0,    0,    0, 1398, 1398, 1398, 1398, 1398,    0, 1398,
    0,    0, 1398, 1398, 1398, 1398, 1398, 1398, 1398,    0,
    0,    0, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
    0, 1398,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
 1398, 1398,    0, 1398, 1398, 1398, 1398, 1398, 1398,    0,
 1398, 1398, 1398, 1398,    0, 1398,    0, 1398, 1398, 1398,
 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
 1398, 1398, 1398, 1398, 1398, 1399, 1398, 1398, 1398, 1398,
    0, 1398, 1398, 1398, 1398, 1398,    0, 1398, 1398, 1398,
 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,
 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398, 1398,    0,
    0,    0,    0,    0,    0, 1214, 1399, 1399, 1399, 1399,
 1399, 1399, 1399,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1399, 1399, 1399, 1399, 1399,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1399,    0, 1399,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1399,    0, 1399,    0,    0, 1399,    0, 1399,
 1399,    0,    0, 1399, 1399,    0, 1399,    0,    0,    0,
    0,    0, 1399,    0,    0, 1399, 1399, 1399, 1399,    0,
 1399,    0,    0, 1399,    0,    0, 1399,    0,    0,    0,
    0,    0,    0, 1399,    0, 1399, 1399,    0, 1399, 1399,
 1399,    0, 1399, 1399,    0,    0, 1399,    0,    0, 1399,
    0, 1399, 1399,    0,    0, 1399, 1399, 1399,    0, 1399,
    0, 1399, 1399, 1399, 1399, 1399, 1399,    0,    0,    0,
 1399, 1399, 1399, 1399, 1399,    0,    0,    0, 1399,    0,
    0,    0,    0,    0,    0,    0, 1399,    0, 1399, 1399,
 1399, 1399,    0, 1399,    0,    0,    0,    0, 1399, 1399,
    0, 1399,    0, 1399,    0, 1399, 1399, 1399,    0, 1399,
    0, 1399, 1399, 1399,    0, 1399, 1399, 1399, 1399, 1399,
    0, 1399, 1399,    0,    0,    0,    0, 1399,    0, 1399,
 1399,    0,    0, 1399, 1399, 1399,    0,    0, 1399,    0,
    0, 1399,    0,    0, 1399, 1399, 1399, 1399,    0, 1399,
    0, 1399,    0, 1399, 1399, 1399, 1399, 1399,    0,    0,
 1399, 1399, 1399,    0, 1399, 1399,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1399, 1399, 1399,    0, 1399,
 1399, 1399,    0,    0,    0, 1399,    0,    0, 1399,    0,
 1399, 1399, 1399, 1399,    0, 1399,    0, 1399, 1399, 1399,
 1399, 1399, 1399, 1399, 1399,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1399, 1399,    0, 1399, 1399, 1399,
    0,    0,    0,    0, 1399, 1399, 1399, 1399, 1399,    0,
 1399,    0,    0, 1399, 1399, 1399, 1399, 1399, 1399, 1399,
    0,    0,    0, 1399, 1399, 1399, 1399, 1399, 1399, 1399,
 1399,    0, 1399,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1399, 1399, 1399, 1399, 1399, 1399, 1399, 1399,
 1399, 1399, 1399, 1399, 1399, 1399, 1399, 1399, 1399, 1399,
 1399, 1399, 1399,    0, 1399, 1399, 1399, 1399, 1399, 1399,
    0, 1399, 1399, 1399, 1399,    0, 1399,    0, 1399, 1399,
 1399, 1399, 1399, 1399, 1399, 1399, 1399, 1399, 1399, 1399,
 1399, 1399, 1399, 1399, 1399, 1399, 1401, 1399, 1399, 1399,
 1399,    0, 1399, 1399, 1399, 1399, 1399,    0, 1399, 1399,
 1399, 1399, 1399, 1399, 1399, 1399, 1399, 1399, 1399, 1399,
 1399, 1399, 1399, 1399, 1399, 1399, 1399, 1399, 1399, 1399,
    0,    0,    0,    0,    0,    0, 1215, 1401, 1401, 1401,
 1401, 1401, 1401, 1401,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1401, 1401, 1401, 1401, 1401,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1401,    0, 1401,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1401,    0, 1401,    0,    0, 1401,    0,
 1401, 1401,    0,    0, 1401, 1401,    0, 1401,    0,    0,
    0,    0,    0, 1401,    0,    0, 1401, 1401, 1401, 1401,
    0, 1401,    0,    0, 1401,    0,    0, 1401,    0,    0,
    0,    0,    0,    0, 1401,    0, 1401, 1401,    0, 1401,
 1401, 1401,    0, 1401, 1401,    0,    0, 1401,    0,    0,
 1401,    0, 1401, 1401,    0,    0, 1401, 1401, 1401,    0,
 1401,    0, 1401, 1401, 1401, 1401, 1401, 1401,    0,    0,
    0, 1401, 1401, 1401, 1401, 1401,    0,    0,    0, 1401,
    0,    0,    0,    0,    0,    0,    0, 1401,    0, 1401,
 1401, 1401, 1401,    0, 1401,    0,    0,    0,    0, 1401,
 1401,    0, 1401,    0, 1401,    0, 1401, 1401, 1401,    0,
 1401,    0, 1401, 1401, 1401,    0, 1401, 1401, 1401, 1401,
 1401,    0, 1401, 1401,    0,    0,    0,    0, 1401,    0,
 1401, 1401,    0,    0, 1401, 1401, 1401,    0,    0, 1401,
    0,    0, 1401,    0,    0, 1401, 1401, 1401, 1401,    0,
 1401,    0, 1401,    0, 1401, 1401, 1401, 1401, 1401,    0,
    0, 1401, 1401, 1401,    0, 1401, 1401,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1401, 1401, 1401,    0,
 1401, 1401, 1401,    0,    0,    0, 1401,    0,    0, 1401,
    0, 1401, 1401, 1401, 1401,    0, 1401,    0, 1401, 1401,
 1401, 1401, 1401, 1401, 1401, 1401,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1401, 1401,    0, 1401, 1401,
 1401,    0,    0,    0,    0, 1401, 1401, 1401, 1401, 1401,
    0, 1401,    0,    0, 1401, 1401, 1401, 1401, 1401, 1401,
 1401,    0,    0,    0, 1401, 1401, 1401, 1401, 1401, 1401,
 1401, 1401,    0, 1401,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1401, 1401, 1401, 1401, 1401, 1401, 1401,
 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401,
 1401, 1401, 1401, 1401,    0, 1401, 1401, 1401, 1401, 1401,
 1401,    0, 1401, 1401, 1401, 1401,    0, 1401,    0, 1401,
 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401,
 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1402, 1401, 1401,
 1401, 1401,    0, 1401, 1401, 1401, 1401, 1401,    0, 1401,
 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401,
 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401, 1401,
 1401,    0,    0,    0,    0,    0,    0, 1216, 1402, 1402,
 1402, 1402, 1402, 1402, 1402,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1402, 1402, 1402, 1402, 1402,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1402,    0,
 1402,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1402,    0, 1402,    0,    0, 1402,
    0, 1402, 1402,    0,    0, 1402, 1402,    0, 1402,    0,
    0,    0,    0,    0, 1402,    0,    0, 1402, 1402, 1402,
 1402,    0, 1402,    0,    0, 1402,    0,    0, 1402,    0,
    0,    0,    0,    0,    0, 1402,    0, 1402, 1402,    0,
 1402, 1402, 1402,    0, 1402, 1402,    0,    0, 1402,    0,
    0, 1402,    0, 1402, 1402,    0,    0, 1402, 1402, 1402,
    0, 1402,    0, 1402, 1402, 1402, 1402, 1402, 1402,    0,
    0,    0, 1402, 1402, 1402, 1402, 1402,    0,    0,    0,
 1402,    0,    0,    0,    0,    0,    0,    0, 1402,    0,
 1402, 1402, 1402, 1402,    0, 1402,    0,    0,    0,    0,
 1402, 1402,    0, 1402,    0, 1402,    0, 1402, 1402, 1402,
    0, 1402,    0, 1402, 1402, 1402,    0, 1402, 1402, 1402,
 1402, 1402,    0, 1402, 1402,    0,    0,    0,    0, 1402,
    0, 1402, 1402,    0,    0, 1402, 1402, 1402,    0,    0,
 1402,    0,    0, 1402,    0,    0, 1402, 1402, 1402, 1402,
    0, 1402,    0, 1402,    0, 1402, 1402, 1402, 1402, 1402,
    0,    0, 1402, 1402, 1402,    0, 1402, 1402,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1402, 1402, 1402,
    0, 1402, 1402, 1402,    0,    0,    0, 1402,    0,    0,
 1402,    0, 1402, 1402, 1402, 1402,    0, 1402,    0, 1402,
 1402, 1402, 1402, 1402, 1402, 1402, 1402,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1402, 1402,    0, 1402,
 1402, 1402,    0,    0,    0,    0, 1402, 1402, 1402, 1402,
 1402,    0, 1402,    0,    0, 1402, 1402, 1402, 1402, 1402,
 1402, 1402,    0,    0,    0, 1402, 1402, 1402, 1402, 1402,
 1402, 1402, 1402,    0, 1402,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1402, 1402, 1402, 1402, 1402, 1402,
 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
 1402, 1402, 1402, 1402, 1402,    0, 1402, 1402, 1402, 1402,
 1402, 1402,    0, 1402, 1402, 1402, 1402,    0, 1402,    0,
 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1403, 1402,
 1402, 1402, 1402,    0, 1402, 1402, 1402, 1402, 1402,    0,
 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402, 1402,
 1402, 1402,    0,    0,    0,    0,    0,    0, 1217, 1403,
 1403, 1403, 1403, 1403, 1403, 1403,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1403, 1403, 1403, 1403,
 1403,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1403,
    0, 1403,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1403,    0, 1403,    0,    0,
 1403,    0, 1403, 1403,    0,    0, 1403, 1403,    0, 1403,
    0,    0,    0,    0,    0, 1403,    0,    0, 1403, 1403,
 1403, 1403,    0, 1403,    0,    0, 1403,    0,    0, 1403,
    0,    0,    0,    0,    0,    0, 1403,    0, 1403, 1403,
    0, 1403, 1403, 1403,    0, 1403, 1403,    0,    0, 1403,
    0,    0, 1403,    0, 1403, 1403,    0,    0, 1403, 1403,
 1403,    0, 1403,    0, 1403, 1403, 1403, 1403, 1403, 1403,
    0,    0,    0, 1403, 1403, 1403, 1403, 1403,    0,    0,
    0, 1403,    0,    0,    0,    0,    0,    0,    0, 1403,
    0, 1403, 1403, 1403, 1403,    0, 1403,    0,    0,    0,
    0, 1403, 1403,    0, 1403,    0, 1403,    0, 1403, 1403,
 1403,    0, 1403,    0, 1403, 1403, 1403,    0, 1403, 1403,
 1403, 1403, 1403,    0, 1403, 1403,    0,    0,    0,    0,
 1403,    0, 1403, 1403,    0,    0, 1403, 1403, 1403,    0,
    0, 1403,    0,    0, 1403,    0,    0, 1403, 1403, 1403,
 1403,    0, 1403,    0, 1403,    0, 1403, 1403, 1403, 1403,
 1403,    0,    0, 1403, 1403, 1403,    0, 1403, 1403,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1403, 1403,
 1403,    0, 1403, 1403, 1403,    0,    0,    0, 1403,    0,
    0, 1403,    0, 1403, 1403, 1403, 1403,    0, 1403,    0,
 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1403, 1403,    0,
 1403, 1403, 1403,    0,    0,    0,    0, 1403, 1403, 1403,
 1403, 1403,    0, 1403,    0,    0, 1403, 1403, 1403, 1403,
 1403, 1403, 1403,    0,    0,    0, 1403, 1403, 1403, 1403,
 1403, 1403, 1403, 1403,    0, 1403,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1403, 1403, 1403, 1403, 1403,
 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403,
 1403, 1403, 1403, 1403, 1403, 1403,    0, 1403, 1403, 1403,
 1403, 1403, 1403,    0, 1403, 1403, 1403, 1403,    0, 1403,
    0, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403,
 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1405,
 1403, 1403, 1403, 1403,    0, 1403, 1403, 1403, 1403, 1403,
    0, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403,
 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403, 1403,
 1403, 1403, 1403,    0,    0,    0,    0,    0,    0, 1218,
 1405, 1405, 1405, 1405, 1405, 1405, 1405,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1405, 1405, 1405,
 1405, 1405,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1405,    0, 1405,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1405,    0, 1405,    0,
    0, 1405,    0, 1405, 1405,    0,    0, 1405, 1405,    0,
 1405,    0,    0,    0,    0,    0, 1405,    0,    0, 1405,
 1405, 1405, 1405,    0, 1405,    0,    0, 1405,    0,    0,
 1405,    0,    0,    0,    0,    0,    0, 1405,    0, 1405,
 1405,    0, 1405, 1405, 1405,    0, 1405, 1405,    0,    0,
 1405,    0,    0, 1405,    0, 1405, 1405,    0,    0, 1405,
 1405, 1405,    0, 1405,    0, 1405, 1405, 1405, 1405, 1405,
 1405,    0,    0,    0, 1405, 1405, 1405, 1405, 1405,    0,
    0,    0, 1405,    0,    0,    0,    0,    0,    0,    0,
 1405,    0, 1405, 1405, 1405, 1405,    0, 1405,    0,    0,
    0,    0, 1405, 1405,    0, 1405,    0, 1405,    0, 1405,
 1405, 1405,    0, 1405,    0, 1405, 1405, 1405,    0, 1405,
 1405, 1405, 1405, 1405,    0, 1405, 1405,    0,    0,    0,
    0, 1405,    0, 1405, 1405,    0,    0, 1405, 1405, 1405,
    0,    0, 1405,    0,    0, 1405,    0,    0, 1405, 1405,
 1405, 1405,    0, 1405,    0, 1405,    0, 1405, 1405, 1405,
 1405, 1405,    0,    0, 1405, 1405, 1405,    0, 1405, 1405,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1405,
 1405, 1405,    0, 1405, 1405, 1405,    0,    0,    0, 1405,
    0,    0, 1405,    0, 1405, 1405, 1405, 1405,    0, 1405,
    0, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1405, 1405,
    0, 1405, 1405, 1405,    0,    0,    0,    0, 1405, 1405,
 1405, 1405, 1405,    0, 1405,    0,    0, 1405, 1405, 1405,
 1405, 1405, 1405, 1405,    0,    0,    0, 1405, 1405, 1405,
 1405, 1405, 1405, 1405, 1405,    0, 1405,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1405, 1405, 1405, 1405,
 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405,
 1405, 1405, 1405, 1405, 1405, 1405, 1405,    0, 1405, 1405,
 1405, 1405, 1405, 1405,    0, 1405, 1405, 1405, 1405,    0,
 1405,    0, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405,
 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405,
 1408, 1405, 1405, 1405, 1405,    0, 1405, 1405, 1405, 1405,
 1405,    0, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405,
 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405, 1405,
 1405, 1405, 1405, 1405,    0,    0,    0,    0,    0,    0,
 1187, 1408, 1408, 1408, 1408, 1408, 1408, 1408,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1408, 1408,
 1408, 1408, 1408,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1408,    0, 1408,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1408,    0, 1408,
    0,    0, 1408,    0, 1408, 1408,    0,    0, 1408, 1408,
    0, 1408,    0,    0,    0,    0,    0, 1408,    0,    0,
 1408, 1408, 1408, 1408,    0, 1408,    0,    0, 1408,    0,
    0, 1408,    0,    0,    0,    0,    0,    0, 1408,    0,
 1408, 1408,    0, 1408, 1408, 1408,    0, 1408, 1408,    0,
    0, 1408,    0,    0, 1408,    0, 1408, 1408,    0,    0,
 1408, 1408, 1408,    0, 1408,    0, 1408, 1408, 1408, 1408,
 1408, 1408,    0,    0,    0, 1408, 1408, 1408, 1408, 1408,
    0,    0,    0, 1408,    0,    0,    0,    0,    0,    0,
    0, 1408,    0, 1408, 1408, 1408, 1408,    0, 1408,    0,
    0,    0,    0, 1408, 1408,    0, 1408,    0, 1408,    0,
 1408, 1408, 1408,    0, 1408,    0, 1408, 1408, 1408,    0,
 1408, 1408, 1408, 1408, 1408,    0, 1408, 1408,    0,    0,
    0,    0, 1408,    0, 1408, 1408,    0,    0, 1408, 1408,
 1408,    0,    0, 1408,    0,    0, 1408,    0,    0, 1408,
 1408, 1408, 1408,    0, 1408,    0, 1408,    0, 1408, 1408,
 1408, 1408, 1408,    0,    0, 1408, 1408, 1408,    0, 1408,
 1408,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1408, 1408, 1408,    0, 1408, 1408, 1408,    0,    0,    0,
 1408,    0,    0, 1408,    0, 1408, 1408, 1408, 1408,    0,
 1408,    0, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1408,
 1408,    0, 1408, 1408, 1408,    0,    0,    0,    0, 1408,
 1408, 1408, 1408, 1408,    0, 1408,    0,    0, 1408, 1408,
 1408, 1408, 1408, 1408, 1408,    0,    0,    0, 1408, 1408,
 1408, 1408, 1408, 1408, 1408, 1408,    0, 1408,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1408, 1408, 1408,
 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,    0, 1408,
 1408, 1408, 1408, 1408, 1408,    0, 1408, 1408, 1408, 1408,
    0, 1408,    0, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
 1408, 1414, 1408, 1408, 1408, 1408,    0, 1408, 1408, 1408,
 1408, 1408,    0, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408, 1408,
 1408, 1408, 1408, 1408, 1408,    0,    0,    0,    0,    0,
    0, 1219, 1414, 1414, 1414, 1414, 1414, 1414, 1414,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1414,
 1414, 1414, 1414, 1414,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1414,    0, 1414,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1414,    0,
 1414,    0,    0, 1414,    0, 1414, 1414,    0,    0, 1414,
 1414,    0, 1414,    0,    0,    0,    0,    0, 1414,    0,
    0, 1414, 1414, 1414, 1414,    0, 1414,    0,    0, 1414,
    0,    0, 1414,    0,    0,    0,    0,    0,    0, 1414,
    0, 1414, 1414,    0, 1414, 1414, 1414,    0, 1414, 1414,
    0,    0, 1414,    0,    0, 1414,    0, 1414, 1414,    0,
    0, 1414, 1414, 1414,    0, 1414,    0, 1414, 1414, 1414,
 1414, 1414, 1414,    0,    0,    0, 1414, 1414, 1414, 1414,
 1414,    0,    0,    0, 1414,    0,    0,    0,    0,    0,
    0,    0, 1414,    0, 1414, 1414, 1414, 1414,    0, 1414,
    0,    0,    0,    0, 1414, 1414,    0, 1414,    0, 1414,
    0, 1414, 1414, 1414,    0, 1414,    0, 1414, 1414, 1414,
    0, 1414, 1414, 1414, 1414, 1414,    0, 1414, 1414,    0,
    0,    0,    0, 1414,    0, 1414, 1414,    0,    0, 1414,
 1414, 1414,    0,    0, 1414,    0,    0, 1414,    0,    0,
 1414, 1414, 1414, 1414,    0, 1414,    0, 1414,    0, 1414,
 1414, 1414, 1414, 1414,    0,    0, 1414, 1414, 1414,    0,
 1414, 1414,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1414, 1414, 1414,    0, 1414, 1414, 1414,    0,    0,
    0, 1414,    0,    0, 1414,    0, 1414, 1414, 1414, 1414,
    0, 1414,    0, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
 1414,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1414, 1414,    0, 1414, 1414, 1414,    0,    0,    0,    0,
 1414, 1414, 1414, 1414, 1414,    0, 1414,    0,    0, 1414,
 1414, 1414, 1414, 1414, 1414, 1414,    0,    0,    0, 1414,
 1414, 1414, 1414, 1414, 1414, 1414, 1414,    0, 1414,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1414, 1414,
 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,    0,
 1414, 1414, 1414, 1414, 1414, 1414,    0, 1414, 1414, 1414,
 1414,    0, 1414,    0, 1414, 1414, 1414, 1414, 1414, 1414,
 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
 1414, 1414, 1421, 1414, 1414, 1414, 1414,    0, 1414, 1414,
 1414, 1414, 1414,    0, 1414, 1414, 1414, 1414, 1414, 1414,
 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414, 1414,
 1414, 1414, 1414, 1414, 1414, 1414,    0,    0,    0,    0,
    0,    0, 1181, 1421, 1421, 1421, 1421, 1421, 1421, 1421,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1421, 1421, 1421, 1421, 1421,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1421,    0, 1421,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1421,
    0, 1421,    0,    0, 1421,    0, 1421, 1421,    0,    0,
 1421, 1421,    0, 1421,    0,    0,    0,    0,    0, 1421,
    0,    0, 1421, 1421, 1421, 1421,    0, 1421,    0,    0,
 1421,    0,    0, 1421,    0,    0,    0,    0,    0,    0,
 1421,    0, 1421, 1421,    0, 1421, 1421, 1421,    0, 1421,
 1421,    0,    0, 1421,    0,    0, 1421,    0, 1421, 1421,
    0,    0, 1421, 1421, 1421,    0, 1421,    0, 1421, 1421,
 1421, 1421, 1421, 1421,    0,    0,    0, 1421, 1421, 1421,
 1421, 1421,    0,    0,    0, 1421,    0,    0,    0,    0,
    0,    0,    0, 1421,    0, 1421, 1421, 1421, 1421,    0,
 1421,    0,    0,    0,    0, 1421, 1421,    0, 1421,    0,
 1421,    0, 1421, 1421, 1421,    0, 1421,    0, 1421, 1421,
 1421,    0, 1421, 1421, 1421, 1421, 1421,    0, 1421, 1421,
    0,    0,    0,    0, 1421,    0, 1421, 1421,    0,    0,
 1421, 1421, 1421,    0,    0, 1421,    0,    0, 1421,    0,
    0, 1421, 1421, 1421, 1421,    0, 1421,    0, 1421,    0,
 1421, 1421, 1421, 1421, 1421,    0,    0, 1421, 1421, 1421,
    0, 1421, 1421,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1421, 1421, 1421,    0, 1421, 1421, 1421,    0,
    0,    0, 1421,    0,    0, 1421,    0, 1421, 1421, 1421,
 1421,    0, 1421,    0, 1421, 1421, 1421, 1421, 1421, 1421,
 1421, 1421,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1421, 1421,    0, 1421, 1421, 1421,    0,    0,    0,
    0, 1421, 1421, 1421, 1421, 1421,    0, 1421,    0,    0,
 1421, 1421, 1421, 1421, 1421, 1421, 1421,    0,    0,    0,
 1421, 1421, 1421, 1421, 1421, 1421, 1421, 1421,    0, 1421,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1421,
 1421, 1421, 1421, 1421, 1421, 1421, 1421, 1421, 1421, 1421,
 1421, 1421, 1421, 1421, 1421, 1421, 1421, 1421, 1421, 1421,
    0, 1421, 1421, 1421, 1421, 1421, 1421,    0, 1421, 1421,
 1421, 1421,    0, 1421,    0, 1421, 1421, 1421, 1421, 1421,
 1421, 1421, 1421, 1421, 1421, 1421, 1421, 1421, 1421, 1421,
 1421, 1421, 1421, 1319, 1421, 1421, 1421, 1421,    0, 1421,
 1421, 1421, 1421, 1421,    0, 1421, 1421, 1421, 1421, 1421,
 1421, 1421, 1421, 1421, 1421, 1421, 1421, 1421, 1421, 1421,
 1421, 1421, 1421, 1421, 1421, 1421, 1421,    0,    0,    0,
    0,    0,    0,    0, 1319, 1319, 1319, 1319, 1319, 1319,
 1319,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1319, 1319, 1319, 1319, 1319,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1319,    0, 1319,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1319,    0, 1319,    0,    0, 1319,    0, 1319, 1319,    0,
    0, 1319, 1319,    0, 1319,    0,    0,    0,    0,    0,
 1319,    0,    0, 1319, 1319, 1319, 1319,    0, 1319,    0,
    0, 1319,    0,    0, 1319,    0,    0,    0,    0,    0,
    0, 1319,    0, 1319, 1319,    0, 1319, 1319, 1319,    0,
 1319, 1319,    0,    0, 1319,    0,    0, 1319,    0, 1319,
 1319,    0,    0, 1319, 1319, 1319,    0, 1319,    0, 1319,
 1319, 1319, 1319, 1319, 1319,    0,    0,    0, 1319, 1319,
 1319, 1319, 1319,    0,    0,    0, 1319,    0,    0,    0,
    0,    0,    0,    0, 1319,    0, 1319, 1319, 1319, 1319,
    0, 1319,    0,    0,    0,    0, 1319, 1319,    0, 1319,
    0, 1319,    0, 1319, 1319, 1319,    0, 1319,    0, 1319,
 1319, 1319,    0, 1319, 1319, 1319, 1319, 1319,    0, 1319,
 1319,    0,    0,    0,    0, 1319,    0, 1319, 1319,    0,
    0, 1319, 1319, 1319,    0,    0, 1319,    0,    0, 1319,
    0,    0, 1319, 1319, 1319, 1319,    0, 1319,    0, 1319,
    0, 1319, 1319, 1319, 1319, 1319,    0,    0, 1319, 1319,
 1319,    0, 1319, 1319,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1319, 1319, 1319,    0, 1319, 1319, 1319,
    0,    0,    0, 1319,    0,    0, 1319,    0, 1319, 1319,
 1319, 1319,    0, 1319,    0, 1319, 1319, 1319, 1319, 1319,
 1319, 1319, 1319,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1319, 1319,    0, 1319, 1319, 1319,    0,    0,
    0,    0, 1319, 1319, 1319, 1319, 1319,    0, 1319,    0,
    0, 1319, 1319, 1319, 1319, 1319, 1319, 1319,    0,    0,
    0, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319,    0,
 1319,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319,
 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319,
 1319,    0, 1319, 1319, 1319, 1319, 1319, 1319,    0, 1319,
 1319, 1319, 1319,    0, 1319,    0, 1319, 1319, 1319, 1319,
 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319,
 1319, 1319, 1319, 1319, 1367, 1319, 1319, 1319, 1319,    0,
 1319, 1319, 1319, 1319, 1319,    0, 1319, 1319, 1319, 1319,
 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319,
 1319, 1319, 1319, 1319, 1319, 1319, 1319, 1319,    0,    0,
    0,    0,    0,    0,    0, 1367, 1367, 1367, 1367, 1367,
 1367, 1367,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1367, 1367, 1367, 1367, 1367,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1367,    0, 1367,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1367,    0, 1367,    0,    0, 1367,    0, 1367, 1367,
    0,    0, 1367, 1367,    0, 1367,    0,    0,    0,    0,
    0, 1367,    0,    0, 1367, 1367, 1367, 1367,    0, 1367,
    0,    0, 1367,    0,    0, 1367,    0,    0,    0,    0,
    0,    0, 1367,    0, 1367, 1367,    0, 1367, 1367, 1367,
    0, 1367, 1367,    0,    0, 1367,    0,    0, 1367,    0,
 1367, 1367,    0,    0, 1367, 1367, 1367,    0, 1367,    0,
 1367, 1367, 1367, 1367, 1367, 1367,    0,    0,    0, 1367,
 1367, 1367, 1367, 1367,    0,    0,    0, 1367,    0,    0,
    0,    0,    0,    0,    0, 1367,    0, 1367, 1367, 1367,
 1367,    0, 1367,    0,    0,    0,    0, 1367, 1367,    0,
 1367,    0, 1367,    0, 1367, 1367, 1367,    0, 1367,    0,
 1367, 1367, 1367,    0, 1367, 1367, 1367, 1367, 1367,    0,
 1367, 1367,    0,    0,    0,    0, 1367,    0, 1367, 1367,
    0,    0, 1367, 1367, 1367,    0,    0, 1367,    0,    0,
 1367,    0,    0, 1367, 1367, 1367, 1367,    0, 1367,    0,
 1367,    0, 1367, 1367, 1367, 1367, 1367,    0,    0, 1367,
 1367, 1367,    0, 1367, 1367,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1367, 1367, 1367,    0, 1367, 1367,
 1367,    0,    0,    0, 1367,    0,    0, 1367,    0, 1367,
 1367, 1367, 1367,    0, 1367,    0, 1367, 1367, 1367, 1367,
 1367, 1367, 1367, 1367,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1367, 1367,    0, 1367, 1367, 1367,    0,
    0,    0,    0, 1367, 1367, 1367, 1367, 1367,    0, 1367,
    0,    0, 1367, 1367, 1367, 1367, 1367, 1367, 1367,    0,
    0,    0, 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367,
    0, 1367,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367,
 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367,
 1367, 1367,    0, 1367, 1367, 1367, 1367, 1367, 1367,    0,
 1367, 1367, 1367, 1367,    0, 1367,    0, 1367, 1367, 1367,
 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367,
 1367, 1367, 1367, 1367, 1367, 1368, 1367, 1367, 1367, 1367,
    0, 1367, 1367, 1367, 1367, 1367,    0, 1367, 1367, 1367,
 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367,
 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367, 1367,    0,
    0,    0,    0,    0,    0,    0, 1368, 1368, 1368, 1368,
 1368, 1368, 1368,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1368, 1368, 1368, 1368, 1368,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1368,    0, 1368,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1368,    0, 1368,    0,    0, 1368,    0, 1368,
 1368,    0,    0, 1368, 1368,    0, 1368,    0,    0,    0,
    0,    0, 1368,    0,    0, 1368, 1368, 1368, 1368,    0,
 1368,    0,    0, 1368,    0,    0, 1368,    0,    0,    0,
    0,    0,    0, 1368,    0, 1368, 1368,    0, 1368, 1368,
 1368,    0, 1368, 1368,    0,    0, 1368,    0,    0, 1368,
    0, 1368, 1368,    0,    0, 1368, 1368, 1368,    0, 1368,
    0, 1368, 1368, 1368, 1368, 1368, 1368,    0,    0,    0,
 1368, 1368, 1368, 1368, 1368,    0,    0,    0, 1368,    0,
    0,    0,    0,    0,    0,    0, 1368,    0, 1368, 1368,
 1368, 1368,    0, 1368,    0,    0,    0,    0, 1368, 1368,
    0, 1368,    0, 1368,    0, 1368, 1368, 1368,    0, 1368,
    0, 1368, 1368, 1368,    0, 1368, 1368, 1368, 1368, 1368,
    0, 1368, 1368,    0,    0,    0,    0, 1368,    0, 1368,
 1368,    0,    0, 1368, 1368, 1368,    0,    0, 1368,    0,
    0, 1368,    0,    0, 1368, 1368, 1368, 1368,    0, 1368,
    0, 1368,    0, 1368, 1368, 1368, 1368, 1368,    0,    0,
 1368, 1368, 1368,    0, 1368, 1368,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1368, 1368, 1368,    0, 1368,
 1368, 1368,    0,    0,    0, 1368,    0,    0, 1368,    0,
 1368, 1368, 1368, 1368,    0, 1368,    0, 1368, 1368, 1368,
 1368, 1368, 1368, 1368, 1368,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1368, 1368,    0, 1368, 1368, 1368,
    0,    0,    0,    0, 1368, 1368, 1368, 1368, 1368,    0,
 1368,    0,    0, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
    0,    0,    0, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
 1368,    0, 1368,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
 1368, 1368, 1368,    0, 1368, 1368, 1368, 1368, 1368, 1368,
    0, 1368, 1368, 1368, 1368,    0, 1368,    0, 1368, 1368,
 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
 1368, 1368, 1368, 1368, 1368, 1368, 1386, 1368, 1368, 1368,
 1368,    0, 1368, 1368, 1368, 1368, 1368,    0, 1368, 1368,
 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368, 1368,
    0,    0,    0,    0,    0,    0,    0, 1386, 1386, 1386,
 1386, 1386, 1386, 1386,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1386, 1386, 1386, 1386, 1386,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1386,    0, 1386,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1386,    0, 1386,    0,    0, 1386,    0,
 1386, 1386,    0,    0, 1386, 1386,    0, 1386,    0,    0,
    0,    0,    0, 1386,    0,    0, 1386, 1386, 1386, 1386,
    0, 1386,    0,    0, 1386,    0,    0, 1386,    0,    0,
    0,    0,    0,    0, 1386,    0, 1386, 1386,    0, 1386,
 1386, 1386,    0, 1386, 1386,    0,    0, 1386,    0,    0,
 1386,    0, 1386, 1386,    0,    0, 1386, 1386, 1386,    0,
 1386,    0, 1386, 1386, 1386, 1386, 1386, 1386,    0,    0,
    0, 1386, 1386, 1386, 1386, 1386,    0,    0,    0, 1386,
    0,    0,    0,    0,    0,    0,    0, 1386,    0, 1386,
 1386, 1386, 1386,    0, 1386,    0,    0,    0,    0, 1386,
 1386,    0, 1386,    0, 1386,    0, 1386, 1386, 1386,    0,
 1386,    0, 1386, 1386, 1386,    0, 1386, 1386, 1386, 1386,
 1386,    0, 1386, 1386,    0,    0,    0,    0, 1386,    0,
 1386, 1386,    0,    0, 1386, 1386, 1386,    0,    0, 1386,
    0,    0, 1386,    0,    0, 1386, 1386, 1386, 1386,    0,
 1386,    0, 1386,    0, 1386, 1386, 1386, 1386, 1386,    0,
    0, 1386, 1386, 1386,    0, 1386, 1386,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1386, 1386, 1386,    0,
 1386, 1386, 1386,    0,    0,    0, 1386,    0,    0, 1386,
    0, 1386, 1386, 1386, 1386,    0, 1386,    0, 1386, 1386,
 1386, 1386, 1386, 1386, 1386, 1386,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1386, 1386,    0, 1386, 1386,
 1386,    0,    0,    0,    0, 1386, 1386, 1386, 1386, 1386,
    0, 1386,    0,    0, 1386, 1386, 1386, 1386, 1386, 1386,
 1386,    0,    0,    0, 1386, 1386, 1386, 1386, 1386, 1386,
 1386, 1386,    0, 1386,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
 1386, 1386, 1386, 1386,    0, 1386, 1386, 1386, 1386, 1386,
 1386,    0, 1386, 1386, 1386, 1386,    0, 1386,    0, 1386,
 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1441, 1386, 1386,
 1386, 1386,    0, 1386, 1386, 1386, 1386, 1386,    0, 1386,
 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386, 1386,
 1386,    0,    0,    0,    0,    0,    0,    0, 1441, 1441,
 1441, 1441, 1441, 1441, 1441,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1441, 1441, 1441, 1441,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1441,    0,
 1441,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1441,    0, 1441,    0,    0, 1441,
    0, 1441, 1441,    0,    0, 1441, 1441,    0, 1441,    0,
    0,    0,    0,    0, 1441,    0,    0, 1441, 1441, 1441,
 1441,    0, 1441,    0,    0, 1441,    0,    0, 1441,    0,
    0,    0,    0,    0,    0, 1441,    0, 1441, 1441,    0,
 1441, 1441, 1441,    0, 1441, 1441,    0,    0, 1441,    0,
    0, 1441,    0, 1441, 1441,    0,    0, 1441, 1441, 1441,
    0, 1441,    0, 1441, 1441, 1441, 1441, 1441, 1441,    0,
    0,    0, 1441, 1441, 1441, 1441, 1441,    0,    0,    0,
 1441,    0,    0,    0,    0,    0,    0,    0, 1441,    0,
 1441, 1441, 1441, 1441,    0, 1441,    0,    0,    0,    0,
 1441, 1441,    0, 1441,    0, 1441,    0, 1441, 1441, 1441,
    0, 1441,    0, 1441, 1441, 1441,    0, 1441, 1441, 1441,
 1441, 1441,    0, 1441, 1441,    0,    0,    0,    0, 1441,
    0, 1441, 1441,    0,    0, 1441, 1441, 1441,    0,    0,
 1441,    0,    0, 1441,    0,    0, 1441, 1441, 1441, 1441,
    0, 1441,    0, 1441,    0, 1441, 1441, 1441, 1441, 1441,
    0,    0, 1441, 1441, 1441,    0, 1441, 1441,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1441, 1441, 1441,
    0, 1441, 1441, 1441,    0,    0,    0, 1441,    0,    0,
 1441,    0, 1441, 1441, 1441, 1441,    0, 1441,    0, 1441,
 1441, 1441, 1441, 1441, 1441, 1441, 1441,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1441, 1441,    0, 1441,
 1441, 1441,    0,    0,    0,    0, 1441, 1441, 1441, 1441,
 1441,    0, 1441,    0,    0, 1441, 1441, 1441, 1441, 1441,
 1441, 1441,    0,    0,    0, 1441, 1441, 1441, 1441, 1441,
 1441, 1441, 1441,    0, 1441,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1441, 1441, 1441, 1441, 1441, 1441,
 1441, 1441, 1441, 1441, 1441, 1441, 1441, 1441, 1441, 1441,
 1441, 1441, 1441, 1441, 1441,    0, 1441, 1441, 1441, 1441,
 1441, 1441,    0, 1441, 1441, 1441, 1441,    0, 1441,    0,
 1441, 1441, 1441, 1441, 1441, 1441, 1441, 1441, 1441, 1441,
 1441, 1441, 1441, 1441, 1441, 1441, 1441, 1441, 1324, 1441,
 1441, 1441, 1441,    0, 1441, 1441, 1441, 1441, 1441,    0,
 1441, 1441, 1441, 1441, 1441, 1441, 1441, 1441, 1441, 1441,
 1441, 1441, 1441, 1441, 1441, 1441, 1441, 1441, 1441, 1441,
 1441, 1441,    0,    0,    0,    0,    0,    0,    0, 1324,
 1324, 1324, 1324, 1324, 1324, 1324,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1324, 1324, 1324,
 1324,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1324,
    0, 1324,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1324,    0, 1324,    0,    0,
 1324,    0, 1324, 1324,    0,    0, 1324, 1324,    0, 1324,
    0,    0,    0,    0,    0, 1324,    0,    0, 1324, 1324,
 1324, 1324,    0, 1324,    0,    0, 1324,    0,    0, 1324,
    0,    0,    0,    0,    0,    0, 1324,    0, 1324, 1324,
    0, 1324, 1324, 1324,    0, 1324, 1324,    0,    0, 1324,
    0,    0, 1324,    0, 1324, 1324,    0,    0, 1324, 1324,
 1324,    0, 1324,    0, 1324, 1324, 1324, 1324, 1324, 1324,
    0,    0,    0, 1324, 1324, 1324, 1324, 1324,    0,    0,
    0, 1324,    0,    0,    0,    0,    0,    0,    0, 1324,
    0, 1324, 1324, 1324, 1324,    0, 1324,    0,    0,    0,
    0, 1324, 1324,    0, 1324,    0, 1324,    0, 1324, 1324,
 1324,    0, 1324,    0, 1324, 1324, 1324,    0, 1324, 1324,
 1324, 1324, 1324,    0, 1324, 1324,    0,    0,    0,    0,
 1324,    0, 1324, 1324,    0,    0, 1324, 1324, 1324,    0,
    0, 1324,    0,    0, 1324,    0,    0, 1324, 1324, 1324,
 1324,    0, 1324,    0, 1324,    0, 1324, 1324, 1324, 1324,
 1324,    0,    0, 1324, 1324, 1324,    0, 1324, 1324,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1324, 1324,
 1324,    0, 1324, 1324, 1324,    0,    0,    0, 1324,    0,
    0, 1324,    0, 1324, 1324, 1324, 1324,    0, 1324,    0,
 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1324, 1324,    0,
 1324, 1324, 1324,    0,    0,    0,    0, 1324, 1324, 1324,
 1324, 1324,    0, 1324,    0,    0, 1324, 1324, 1324, 1324,
 1324, 1324, 1324,    0,    0,    0, 1324, 1324, 1324, 1324,
 1324, 1324, 1324, 1324,    0, 1324,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1324, 1324, 1324, 1324, 1324,
 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
 1324, 1324, 1324, 1324, 1324, 1324,    0, 1324, 1324, 1324,
 1324, 1324, 1324,    0, 1324, 1324, 1324, 1324,    0, 1324,
    0, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1320,
 1324, 1324, 1324, 1324,    0, 1324, 1324, 1324, 1324, 1324,
    0, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324, 1324,
 1324, 1324, 1324,    0,    0,    0,    0,    0,    0,    0,
 1320, 1320, 1320, 1320, 1320, 1320, 1320,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1320, 1320,
 1320, 1320,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1320,    0, 1320,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1320,    0, 1320,    0,
    0, 1320,    0, 1320, 1320,    0,    0, 1320, 1320,    0,
 1320,    0,    0,    0,    0,    0, 1320,    0,    0, 1320,
 1320, 1320, 1320,    0, 1320,    0,    0, 1320,    0,    0,
 1320,    0,    0,    0,    0,    0,    0, 1320,    0, 1320,
 1320,    0, 1320, 1320, 1320,    0, 1320, 1320,    0,    0,
 1320,    0,    0, 1320,    0, 1320, 1320,    0,    0, 1320,
 1320, 1320,    0, 1320,    0, 1320, 1320, 1320, 1320, 1320,
 1320,    0,    0,    0, 1320, 1320, 1320, 1320, 1320,    0,
    0,    0, 1320,    0,    0,    0,    0,    0,    0,    0,
 1320,    0, 1320, 1320, 1320, 1320,    0, 1320,    0,    0,
    0,    0, 1320, 1320,    0, 1320,    0, 1320,    0, 1320,
 1320, 1320,    0, 1320,    0, 1320, 1320, 1320,    0, 1320,
 1320, 1320, 1320, 1320,    0, 1320, 1320,    0,    0,    0,
    0, 1320,    0, 1320, 1320,    0,    0, 1320, 1320, 1320,
    0,    0, 1320,    0,    0, 1320,    0,    0, 1320, 1320,
 1320, 1320,    0, 1320,    0, 1320,    0, 1320, 1320, 1320,
 1320, 1320,    0,    0, 1320, 1320, 1320,    0, 1320, 1320,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1320,
 1320, 1320,    0, 1320, 1320, 1320,    0,    0,    0, 1320,
    0,    0, 1320,    0, 1320, 1320, 1320, 1320,    0, 1320,
    0, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1320, 1320,
    0, 1320, 1320, 1320,    0,    0,    0,    0, 1320, 1320,
 1320, 1320, 1320,    0, 1320,    0,    0, 1320, 1320, 1320,
 1320, 1320, 1320, 1320,    0,    0,    0, 1320, 1320, 1320,
 1320, 1320, 1320, 1320, 1320,    0, 1320,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1320, 1320, 1320, 1320,
 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
 1320, 1320, 1320, 1320, 1320, 1320, 1320,    0, 1320, 1320,
 1320, 1320, 1320, 1320,    0, 1320, 1320, 1320, 1320,    0,
 1320,    0, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
 1335, 1320, 1320, 1320, 1320,    0, 1320, 1320, 1320, 1320,
 1320,    0, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320, 1320,
 1320, 1320, 1320, 1320,    0,    0,    0,    0,    0,    0,
    0, 1335, 1335, 1335, 1335, 1335, 1335, 1335,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1335,
 1335, 1335, 1335,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1335,    0, 1335,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1335,    0, 1335,
    0,    0, 1335,    0, 1335, 1335,    0,    0, 1335, 1335,
    0, 1335,    0,    0,    0,    0,    0, 1335,    0,    0,
 1335, 1335, 1335, 1335,    0, 1335,    0,    0, 1335,    0,
    0, 1335,    0,    0,    0,    0,    0,    0, 1335,    0,
 1335, 1335,    0, 1335, 1335, 1335,    0, 1335, 1335,    0,
    0, 1335,    0,    0, 1335,    0, 1335, 1335,    0,    0,
 1335, 1335, 1335,    0, 1335,    0, 1335, 1335, 1335, 1335,
 1335, 1335,    0,    0,    0, 1335, 1335, 1335, 1335, 1335,
    0,    0,    0, 1335,    0,    0,    0,    0,    0,    0,
    0, 1335,    0, 1335, 1335, 1335, 1335,    0, 1335,    0,
    0,    0,    0, 1335, 1335,    0, 1335,    0, 1335,    0,
 1335, 1335, 1335,    0, 1335,    0, 1335, 1335, 1335,    0,
 1335, 1335, 1335, 1335, 1335,    0, 1335, 1335,    0,    0,
    0,    0, 1335,    0, 1335, 1335,    0,    0, 1335, 1335,
 1335,    0,    0, 1335,    0,    0, 1335,    0,    0, 1335,
 1335, 1335, 1335,    0, 1335,    0, 1335,    0, 1335, 1335,
 1335, 1335, 1335,    0,    0, 1335, 1335, 1335,    0, 1335,
 1335,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1335, 1335, 1335,    0, 1335, 1335, 1335,    0,    0,    0,
 1335,    0,    0, 1335,    0, 1335, 1335, 1335, 1335,    0,
 1335,    0, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1335,
 1335,    0, 1335, 1335, 1335,    0,    0,    0,    0, 1335,
 1335, 1335, 1335, 1335,    0, 1335,    0,    0, 1335, 1335,
 1335, 1335, 1335, 1335, 1335,    0,    0,    0, 1335, 1335,
 1335, 1335, 1335, 1335, 1335, 1335,    0, 1335,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1335, 1335, 1335,
 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335,
 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335,    0, 1335,
 1335, 1335, 1335, 1335, 1335,    0, 1335, 1335, 1335, 1335,
    0, 1335,    0, 1335, 1335, 1335, 1335, 1335, 1335, 1335,
 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335,
 1335, 1340, 1335, 1335, 1335, 1335,    0, 1335, 1335, 1335,
 1335, 1335,    0, 1335, 1335, 1335, 1335, 1335, 1335, 1335,
 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335, 1335,
 1335, 1335, 1335, 1335, 1335,    0,    0,    0,    0,    0,
    0,    0, 1340, 1340, 1340, 1340, 1340, 1340, 1340,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1340, 1340, 1340, 1340,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1340,    0, 1340,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1340,    0,
 1340,    0,    0, 1340,    0, 1340, 1340,    0,    0, 1340,
 1340,    0, 1340,    0,    0,    0,    0,    0, 1340,    0,
    0, 1340, 1340, 1340, 1340,    0, 1340,    0,    0, 1340,
    0,    0, 1340,    0,    0,    0,    0,    0,    0, 1340,
    0, 1340, 1340,    0, 1340, 1340, 1340,    0, 1340, 1340,
    0,    0, 1340,    0,    0, 1340,    0, 1340, 1340,    0,
    0, 1340, 1340, 1340,    0, 1340,    0, 1340, 1340, 1340,
 1340, 1340, 1340,    0,    0,    0, 1340, 1340, 1340, 1340,
 1340,    0,    0,    0, 1340,    0,    0,    0,    0,    0,
    0,    0, 1340,    0, 1340, 1340, 1340, 1340,    0, 1340,
    0,    0,    0,    0, 1340, 1340,    0, 1340,    0, 1340,
    0, 1340, 1340, 1340,    0, 1340,    0, 1340, 1340, 1340,
    0, 1340, 1340, 1340, 1340, 1340,    0, 1340, 1340,    0,
    0,    0,    0, 1340,    0, 1340, 1340,    0,    0, 1340,
 1340, 1340,    0,    0, 1340,    0,    0, 1340,    0,    0,
 1340, 1340, 1340, 1340,    0, 1340,    0, 1340,    0, 1340,
 1340, 1340, 1340, 1340,    0,    0, 1340, 1340, 1340,    0,
 1340, 1340,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1340, 1340, 1340,    0, 1340, 1340, 1340,    0,    0,
    0, 1340,    0,    0, 1340,    0, 1340, 1340, 1340, 1340,
    0, 1340,    0, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
 1340,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1340, 1340,    0, 1340, 1340, 1340,    0,    0,    0,    0,
 1340, 1340, 1340, 1340, 1340,    0, 1340,    0,    0, 1340,
 1340, 1340, 1340, 1340, 1340, 1340,    0,    0,    0, 1340,
 1340, 1340, 1340, 1340, 1340, 1340, 1340,    0, 1340,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1340, 1340,
 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,    0,
 1340, 1340, 1340, 1340, 1340, 1340,    0, 1340, 1340, 1340,
 1340,    0, 1340,    0, 1340, 1340, 1340, 1340, 1340, 1340,
 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
 1340, 1340, 1369, 1340, 1340, 1340, 1340,    0, 1340, 1340,
 1340, 1340, 1340,    0, 1340, 1340, 1340, 1340, 1340, 1340,
 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340, 1340,
 1340, 1340, 1340, 1340, 1340, 1340,    0,    0,    0,    0,
    0,    0,    0, 1369, 1369, 1369, 1369, 1369, 1369, 1369,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1369, 1369, 1369, 1369,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1369,    0, 1369,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1369,
    0, 1369,    0,    0, 1369,    0, 1369, 1369,    0,    0,
 1369, 1369,    0, 1369,    0,    0,    0,    0,    0, 1369,
    0,    0, 1369, 1369, 1369, 1369,    0, 1369,    0,    0,
 1369,    0,    0, 1369,    0,    0,    0,    0,    0,    0,
 1369,    0, 1369, 1369,    0, 1369, 1369, 1369,    0, 1369,
 1369,    0,    0, 1369,    0,    0, 1369,    0, 1369, 1369,
    0,    0, 1369, 1369, 1369,    0, 1369,    0, 1369, 1369,
 1369, 1369, 1369, 1369,    0,    0,    0, 1369, 1369, 1369,
 1369, 1369,    0,    0,    0, 1369,    0,    0,    0,    0,
    0,    0,    0, 1369,    0, 1369, 1369, 1369, 1369,    0,
 1369,    0,    0,    0,    0, 1369, 1369,    0, 1369,    0,
 1369,    0, 1369, 1369, 1369,    0, 1369,    0, 1369, 1369,
 1369,    0, 1369, 1369, 1369, 1369, 1369,    0, 1369, 1369,
    0,    0,    0,    0, 1369,    0, 1369, 1369,    0,    0,
 1369, 1369, 1369,    0,    0, 1369,    0,    0, 1369,    0,
    0, 1369, 1369, 1369, 1369,    0, 1369,    0, 1369,    0,
 1369, 1369, 1369, 1369, 1369,    0,    0, 1369, 1369, 1369,
    0, 1369, 1369,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1369, 1369, 1369,    0, 1369, 1369, 1369,    0,
    0,    0, 1369,    0,    0, 1369,    0, 1369, 1369, 1369,
 1369,    0, 1369,    0, 1369, 1369, 1369, 1369, 1369, 1369,
 1369, 1369,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1369, 1369,    0, 1369, 1369, 1369,    0,    0,    0,
    0, 1369, 1369, 1369, 1369, 1369,    0, 1369,    0,    0,
 1369, 1369, 1369, 1369, 1369, 1369, 1369,    0,    0,    0,
 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369,    0, 1369,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1369,
 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369,
 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369,
    0, 1369, 1369, 1369, 1369, 1369, 1369,    0, 1369, 1369,
 1369, 1369,    0, 1369,    0, 1369, 1369, 1369, 1369, 1369,
 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369,
 1369, 1369, 1369, 1375, 1369, 1369, 1369, 1369,    0, 1369,
 1369, 1369, 1369, 1369,    0, 1369, 1369, 1369, 1369, 1369,
 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369, 1369,
 1369, 1369, 1369, 1369, 1369, 1369, 1369,    0,    0,    0,
    0,    0,    0,    0, 1375, 1375, 1375, 1375, 1375, 1375,
 1375,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1375, 1375, 1375, 1375,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1375,    0, 1375,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1375,    0, 1375,    0,    0, 1375,    0, 1375, 1375,    0,
    0, 1375, 1375,    0, 1375,    0,    0,    0,    0,    0,
 1375,    0,    0, 1375, 1375, 1375, 1375,    0, 1375,    0,
    0, 1375,    0,    0, 1375,    0,    0,    0,    0,    0,
    0, 1375,    0, 1375, 1375,    0, 1375, 1375, 1375,    0,
 1375, 1375,    0,    0, 1375,    0,    0, 1375,    0, 1375,
 1375,    0,    0, 1375, 1375, 1375,    0, 1375,    0, 1375,
 1375, 1375, 1375, 1375, 1375,    0,    0,    0, 1375, 1375,
 1375, 1375, 1375,    0,    0,    0, 1375,    0,    0,    0,
    0,    0,    0,    0, 1375,    0, 1375, 1375, 1375, 1375,
    0, 1375,    0,    0,    0,    0, 1375, 1375,    0, 1375,
    0, 1375,    0, 1375, 1375, 1375,    0, 1375,    0, 1375,
 1375, 1375,    0, 1375, 1375, 1375, 1375, 1375,    0, 1375,
 1375,    0,    0,    0,    0, 1375,    0, 1375, 1375,    0,
    0, 1375, 1375, 1375,    0,    0, 1375,    0,    0, 1375,
    0,    0, 1375, 1375, 1375, 1375,    0, 1375,    0, 1375,
    0, 1375, 1375, 1375, 1375, 1375,    0,    0, 1375, 1375,
 1375,    0, 1375, 1375,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1375, 1375, 1375,    0, 1375, 1375, 1375,
    0,    0,    0, 1375,    0,    0, 1375,    0, 1375, 1375,
 1375, 1375,    0, 1375,    0, 1375, 1375, 1375, 1375, 1375,
 1375, 1375, 1375,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1375, 1375,    0, 1375, 1375, 1375,    0,    0,
    0,    0, 1375, 1375, 1375, 1375, 1375,    0, 1375,    0,
    0, 1375, 1375, 1375, 1375, 1375, 1375, 1375,    0,    0,
    0, 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375,    0,
 1375,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375,
 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375,
 1375,    0, 1375, 1375, 1375, 1375, 1375, 1375,    0, 1375,
 1375, 1375, 1375,    0, 1375,    0, 1375, 1375, 1375, 1375,
 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375,
 1375, 1375, 1375, 1375, 1288, 1375, 1375, 1375, 1375,    0,
 1375, 1375, 1375, 1375, 1375,    0, 1375, 1375, 1375, 1375,
 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375,
 1375, 1375, 1375, 1375, 1375, 1375, 1375, 1375,    0,    0,
    0,    0,    0,    0,    0, 1288, 1288, 1288, 1288, 1288,
 1302, 1288,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1288, 1288, 1288, 1288,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1288,    0, 1288,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1288,    0, 1288,    0,    0, 1288,    0, 1288, 1288,
    0,    0, 1288, 1288,    0, 1288,    0,    0,    0,    0,
    0, 1288,    0,    0, 1288, 1288, 1288, 1288,    0, 1288,
    0,    0, 1288,    0,    0, 1288,    0,    0,    0,    0,
    0,    0, 1288,    0, 1288, 1288,    0, 1288, 1288, 1288,
    0, 1288, 1288,    0,    0, 1288,    0,    0, 1288,    0,
 1288, 1288,    0,    0, 1288, 1288, 1288,    0, 1288,    0,
 1288, 1288, 1288, 1288, 1288, 1288,    0,    0,    0, 1288,
 1288, 1288, 1288, 1288,    0,    0,    0, 1288,    0,    0,
    0,    0,    0,    0,    0, 1288,    0, 1288, 1288, 1288,
 1288,    0, 1288,    0,    0,    0,    0, 1288, 1288,    0,
 1288,    0, 1288,    0, 1288, 1288, 1288,    0, 1288,    0,
 1288, 1288, 1288,    0, 1288, 1288, 1288, 1288, 1288,    0,
 1288, 1288,    0,    0,    0,    0, 1288,    0, 1288, 1288,
    0,    0, 1288, 1288, 1288,    0,    0, 1288,    0,    0,
 1288,    0,    0, 1288, 1288, 1288, 1288,    0, 1288,    0,
 1288,    0, 1288, 1288, 1288, 1288, 1288,    0,    0, 1288,
 1288, 1288,    0, 1288, 1288,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1288, 1288, 1288,    0, 1288, 1288,
 1288,    0,    0,    0, 1288,    0,    0, 1288,    0, 1288,
 1288, 1288, 1288,    0, 1288,    0, 1288, 1288, 1288, 1288,
 1288, 1288, 1288, 1288,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1288, 1288,    0, 1288, 1288, 1288,    0,
    0,    0,    0, 1288, 1288, 1288, 1288, 1288,    0, 1288,
    0,    0, 1288, 1288, 1288, 1288, 1288, 1288, 1288,    0,
    0,    0, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
    0, 1288,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
 1288, 1288,    0, 1288, 1288, 1288, 1288, 1288, 1288,    0,
 1288, 1288, 1288, 1288,    0, 1288,    0, 1288, 1288, 1288,
 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
 1288, 1288, 1288, 1288, 1288, 1071, 1288, 1288, 1288, 1288,
    0, 1288, 1288, 1288, 1288, 1288,    0, 1288, 1288, 1288,
 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
 1288, 1288, 1288, 1288, 1288, 1288, 1288,    0, 1288,    0,
    0,    0,    0,    0,    0,    0, 1071, 1071, 1071, 1071,
 1071,    0, 1071,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1071, 1071, 1071, 1071,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1071,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1071,    0, 1071,    0,    0, 1071,    0, 1071,
 1071,    0,    0, 1071, 1071,    0, 1071,    0,    0,    0,
    0,    0, 1071,    0,    0, 1071, 1071, 1071, 1071,    0,
 1071,    0,    0, 1071,    0,    0, 1071,    0,    0,    0,
    0,    0,    0, 1071,    0, 1071, 1071,    0, 1071, 1071,
 1071,    0, 1071, 1071,    0,    0, 1071,    0,    0, 1071,
    0, 1071, 1071,    0,    0, 1071, 1071, 1071,    0, 1071,
    0, 1071, 1071, 1071, 1071, 1071, 1071,    0,    0,    0,
 1071, 1071, 1071, 1071, 1071,    0,    0,    0, 1071,    0,
    0,    0,    0,    0,    0,    0, 1071,    0, 1071, 1071,
 1071, 1071,    0, 1071,    0,    0,    0,    0, 1071, 1071,
    0, 1071,    0, 1071,    0, 1071, 1071, 1071,    0, 1071,
    0, 1071, 1071, 1071,    0, 1071, 1071, 1071, 1071, 1071,
    0, 1071, 1071,    0,    0,    0,    0, 1071,    0, 1071,
 1071,    0,    0, 1071, 1071, 1071,    0,    0, 1071,    0,
    0, 1071,    0,    0, 1071, 1071, 1071, 1071,    0, 1071,
    0, 1071,    0, 1071, 1071, 1071, 1071, 1071,    0,    0,
 1071, 1071, 1071,    0, 1071, 1071,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1071, 1071, 1071,    0, 1071,
 1071, 1071,    0,    0,    0, 1071,    0,    0, 1071,    0,
 1071, 1071, 1071, 1071,    0, 1071,    0, 1071, 1071, 1071,
 1071, 1071, 1071, 1071, 1071,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1071, 1071,    0, 1071, 1071, 1071,
    0,    0,    0,    0, 1071, 1071, 1071, 1071, 1071,    0,
 1071,    0,    0, 1071, 1071, 1071, 1071, 1071, 1071, 1071,
    0,    0,    0, 1071, 1071, 1071, 1071, 1071, 1071, 1071,
 1071,    0, 1071,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1071, 1071, 1071, 1071, 1071, 1071, 1071, 1071,
 1071, 1071, 1071, 1071, 1071, 1071, 1071, 1071, 1071, 1071,
 1071, 1071, 1071,    0, 1071, 1071, 1071, 1071, 1071, 1071,
    0, 1071, 1071, 1071, 1071,    0, 1071,    0, 1071, 1071,
 1071, 1071, 1071, 1071, 1071, 1071, 1071, 1071, 1071, 1071,
 1071, 1071, 1071, 1071, 1071, 1071, 1084, 1071, 1071, 1071,
 1071,    0, 1071, 1071, 1071, 1071, 1071,    0, 1071, 1071,
 1071, 1071, 1071, 1071, 1071, 1071, 1071, 1071, 1071, 1071,
 1071, 1071, 1071, 1071, 1071, 1071, 1071, 1071,    0, 1071,
    0,    0,    0,    0,    0,    0,    0, 1084, 1084, 1084,
 1084, 1084,    0, 1084,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1084, 1084, 1084, 1084,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1084,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1084,    0, 1084,    0,    0, 1084,    0,
 1084, 1084,    0,    0, 1084, 1084,    0, 1084,    0,    0,
    0,    0,    0,    0,    0,    0, 1084, 1084, 1084, 1084,
    0, 1084,    0,    0, 1084,    0,    0, 1084,    0,    0,
    0,    0,    0,    0, 1084,    0, 1084, 1084,    0, 1084,
 1084, 1084,    0, 1084, 1084,    0,    0, 1084,    0,    0,
 1084,    0, 1084, 1084,    0,    0, 1084, 1084, 1084,    0,
 1084,    0, 1084, 1084, 1084, 1084, 1084, 1084,    0,    0,
    0, 1084, 1084, 1084, 1084, 1084,    0,    0,    0, 1084,
    0,    0,    0,    0,    0,    0,    0, 1084,    0, 1084,
 1084, 1084, 1084,    0, 1084,    0,    0,    0,    0, 1084,
 1084,    0, 1084,    0, 1084,    0, 1084, 1084, 1084,    0,
 1084,    0, 1084, 1084, 1084,    0, 1084, 1084, 1084, 1084,
 1084,    0, 1084, 1084,    0,    0,    0,    0, 1084,    0,
 1084, 1084,    0,    0, 1084, 1084, 1084,    0,    0, 1084,
    0,    0, 1084,    0,    0, 1084, 1084, 1084, 1084,    0,
 1084,    0, 1084,    0, 1084, 1084, 1084, 1084, 1084,    0,
    0, 1084, 1084, 1084,    0, 1084, 1084,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1084, 1084, 1084,    0,
 1084, 1084, 1084,    0,    0,    0, 1084,    0,    0, 1084,
    0, 1084, 1084, 1084, 1084,    0, 1084,    0, 1084, 1084,
 1084, 1084, 1084, 1084, 1084, 1084,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1084, 1084,    0, 1084, 1084,
 1084,    0,    0,    0,    0, 1084, 1084, 1084, 1084, 1084,
    0, 1084,    0,    0, 1084, 1084, 1084, 1084, 1084, 1084,
 1084,    0,    0,    0, 1084, 1084, 1084, 1084, 1084, 1084,
 1084, 1084,    0, 1084,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
 1084, 1084, 1084, 1084,    0, 1084, 1084, 1084, 1084, 1084,
 1084,    0, 1084, 1084, 1084, 1084,    0, 1084,    0, 1084,
 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1082, 1084, 1084,
 1084, 1084,    0, 1084, 1084, 1084, 1084, 1084,    0, 1084,
 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,
 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084, 1084,    0,
 1084,    0,    0,    0,    0,    0,    0,    0, 1082, 1082,
 1082, 1082, 1082,    0, 1082,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1082, 1082, 1082, 1082,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1082,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1082,    0, 1082,    0,    0, 1082,
    0, 1082, 1082,    0,    0, 1082, 1082,    0, 1082,    0,
    0,    0,    0,    0,    0,    0,    0, 1082, 1082,    0,
 1082,    0, 1082,    0,    0, 1082,    0,    0, 1082,    0,
    0,    0,    0,    0,    0, 1082,    0, 1082, 1082,    0,
 1082, 1082, 1082,    0, 1082, 1082,    0,    0, 1082,    0,
    0, 1082,    0, 1082, 1082,    0,    0, 1082, 1082, 1082,
    0, 1082,    0, 1082, 1082, 1082, 1082, 1082, 1082,    0,
    0,    0, 1082, 1082, 1082, 1082, 1082,    0,    0,    0,
 1082,    0,    0,    0,    0,    0,    0,    0, 1082,    0,
 1082, 1082, 1082, 1082,    0, 1082,    0,    0,    0,    0,
 1082, 1082,    0, 1082,    0, 1082,    0, 1082, 1082, 1082,
    0, 1082,    0, 1082, 1082, 1082,    0, 1082, 1082, 1082,
 1082, 1082,    0, 1082, 1082,    0,    0,    0,    0, 1082,
    0, 1082, 1082,    0,    0, 1082, 1082, 1082,    0,    0,
 1082,    0,    0, 1082,    0,    0, 1082, 1082, 1082, 1082,
    0, 1082,    0, 1082,    0, 1082, 1082, 1082, 1082, 1082,
    0,    0, 1082, 1082, 1082,    0, 1082, 1082,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1082, 1082, 1082,
    0, 1082, 1082, 1082,    0,    0,    0, 1082,    0,    0,
 1082,    0, 1082, 1082, 1082, 1082,    0, 1082,    0, 1082,
 1082, 1082, 1082, 1082, 1082, 1082, 1082,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1082, 1082,    0, 1082,
 1082, 1082,    0,    0,    0,    0, 1082, 1082, 1082, 1082,
 1082,    0, 1082,    0,    0, 1082, 1082, 1082, 1082, 1082,
 1082, 1082,    0,    0,    0, 1082, 1082, 1082, 1082, 1082,
 1082, 1082, 1082,    0, 1082,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1082, 1082, 1082, 1082, 1082, 1082,
 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
 1082, 1082, 1082, 1082, 1082,    0, 1082, 1082, 1082, 1082,
 1082, 1082,    0, 1082, 1082, 1082, 1082,    0, 1082,    0,
 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1081, 1082,
 1082, 1082, 1082,    0, 1082, 1082, 1082, 1082, 1082,    0,
 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082, 1082,
    0, 1082,    0,    0,    0,    0,    0,    0,    0, 1081,
 1081, 1081, 1081, 1081,    0, 1081,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1081, 1081, 1081,
 1081,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1081,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1081,    0, 1081,    0,    0,
 1081,    0, 1081, 1081,    0,    0, 1081, 1081,    0, 1081,
    0,    0,    0,    0,    0,    0,    0,    0, 1081, 1081,
    0, 1081,    0, 1081,    0,    0, 1081,    0,    0, 1081,
    0,    0,    0,    0,    0,    0, 1081,    0, 1081, 1081,
    0, 1081, 1081, 1081,    0, 1081, 1081,    0,    0, 1081,
    0,    0, 1081,    0, 1081, 1081,    0,    0, 1081, 1081,
 1081,    0, 1081,    0, 1081, 1081, 1081, 1081, 1081, 1081,
    0,    0,    0, 1081, 1081, 1081, 1081, 1081,    0,    0,
    0, 1081,    0,    0,    0,    0,    0,    0,    0, 1081,
    0, 1081, 1081, 1081, 1081,    0, 1081,    0,    0,    0,
    0, 1081, 1081,    0, 1081,    0, 1081,    0, 1081, 1081,
 1081,    0, 1081,    0, 1081, 1081, 1081,    0, 1081, 1081,
 1081, 1081, 1081,    0, 1081, 1081,    0,    0,    0,    0,
 1081,    0, 1081, 1081,    0,    0, 1081, 1081, 1081,    0,
    0, 1081,    0,    0, 1081,    0,    0, 1081, 1081, 1081,
 1081,    0, 1081,    0, 1081,    0, 1081, 1081, 1081, 1081,
 1081,    0,    0, 1081, 1081, 1081,    0, 1081, 1081,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1081, 1081,
 1081,    0, 1081, 1081, 1081,    0,    0,    0, 1081,    0,
    0, 1081,    0, 1081, 1081, 1081, 1081,    0, 1081,    0,
 1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1081, 1081,    0,
 1081, 1081, 1081,    0,    0,    0,    0, 1081, 1081, 1081,
 1081, 1081,    0, 1081,    0,    0, 1081, 1081, 1081, 1081,
 1081, 1081, 1081,    0,    0,    0, 1081, 1081, 1081, 1081,
 1081, 1081, 1081, 1081,    0, 1081,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1081, 1081, 1081, 1081, 1081,
 1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081,
 1081, 1081, 1081, 1081, 1081, 1081,    0, 1081, 1081, 1081,
 1081, 1081, 1081,    0, 1081, 1081, 1081, 1081,    0, 1081,
    0, 1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081,
 1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081, 1087,
 1081, 1081, 1081, 1081,    0, 1081, 1081, 1081, 1081, 1081,
    0, 1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081,
 1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081, 1081,
 1081,    0, 1081,    0,    0,    0,    0,    0,    0,    0,
 1087, 1087, 1087, 1087, 1087,    0, 1087,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1087, 1087,
 1087, 1087,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1087,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1087,    0, 1087,    0,
    0, 1087,    0, 1087, 1087,    0,    0, 1087, 1087,    0,
 1087,    0,    0,    0,    0,    0,    0,    0,    0, 1087,
 1087,    0, 1087,    0, 1087,    0,    0, 1087,    0,    0,
 1087,    0,    0,    0,    0,    0,    0, 1087,    0, 1087,
 1087,    0, 1087, 1087, 1087,    0, 1087, 1087,    0,    0,
 1087,    0,    0, 1087,    0, 1087, 1087,    0,    0, 1087,
 1087, 1087,    0, 1087,    0, 1087, 1087, 1087, 1087, 1087,
 1087,    0,    0,    0, 1087, 1087, 1087, 1087, 1087,    0,
    0,    0, 1087,    0,    0,    0,    0,    0,    0,    0,
 1087,    0, 1087, 1087, 1087, 1087,    0, 1087,    0,    0,
    0,    0, 1087, 1087,    0, 1087,    0, 1087,    0, 1087,
 1087, 1087,    0, 1087,    0, 1087, 1087, 1087,    0, 1087,
 1087, 1087, 1087, 1087,    0, 1087, 1087,    0,    0,    0,
    0, 1087,    0, 1087, 1087,    0,    0, 1087, 1087, 1087,
    0,    0, 1087,    0,    0, 1087,    0,    0, 1087, 1087,
 1087, 1087,    0, 1087,    0, 1087,    0, 1087, 1087, 1087,
 1087, 1087,    0,    0, 1087, 1087, 1087,    0, 1087, 1087,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1087,
 1087, 1087,    0, 1087, 1087, 1087,    0,    0,    0, 1087,
    0,    0, 1087,    0, 1087, 1087, 1087, 1087,    0, 1087,
    0, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1087, 1087,
    0, 1087, 1087, 1087,    0,    0,    0,    0, 1087, 1087,
 1087, 1087, 1087,    0, 1087,    0,    0, 1087, 1087, 1087,
 1087, 1087, 1087, 1087,    0,    0,    0, 1087, 1087, 1087,
 1087, 1087, 1087, 1087, 1087,    0, 1087,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1087, 1087, 1087, 1087,
 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087,
 1087, 1087, 1087, 1087, 1087, 1087, 1087,    0, 1087, 1087,
 1087, 1087, 1087, 1087,    0, 1087, 1087, 1087, 1087,    0,
 1087,    0, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087,
 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087,
 1088, 1087, 1087, 1087, 1087,    0, 1087, 1087, 1087, 1087,
 1087,    0, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087,
 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087, 1087,
 1087, 1087,    0, 1087,    0,    0,    0,    0,    0,    0,
    0, 1088, 1088, 1088, 1088, 1088,    0, 1088,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1088,
 1088, 1088, 1088,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1088,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1088,    0, 1088,
    0,    0, 1088,    0, 1088, 1088,    0,    0, 1088, 1088,
    0, 1088,    0,    0,    0,    0,    0,    0,    0,    0,
 1088, 1088,    0, 1088,    0, 1088,    0,    0, 1088,    0,
    0, 1088,    0,    0,    0,    0,    0,    0, 1088,    0,
 1088, 1088,    0, 1088, 1088, 1088,    0, 1088, 1088,    0,
    0, 1088,    0,    0, 1088,    0, 1088, 1088,    0,    0,
 1088, 1088, 1088,    0, 1088,    0, 1088, 1088, 1088, 1088,
 1088, 1088,    0,    0,    0, 1088, 1088, 1088, 1088, 1088,
    0,    0,    0, 1088,    0,    0,    0,    0,    0,    0,
    0, 1088,    0, 1088, 1088, 1088, 1088,    0, 1088,    0,
    0,    0,    0, 1088, 1088,    0, 1088,    0, 1088,    0,
 1088, 1088, 1088,    0, 1088,    0, 1088, 1088, 1088,    0,
 1088, 1088, 1088, 1088, 1088,    0, 1088, 1088,    0,    0,
    0,    0, 1088,    0, 1088, 1088,    0,    0, 1088, 1088,
 1088,    0,    0, 1088,    0,    0, 1088,    0,    0, 1088,
 1088, 1088, 1088,    0, 1088,    0, 1088,    0, 1088, 1088,
 1088, 1088, 1088,    0,    0, 1088, 1088, 1088,    0, 1088,
 1088,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1088, 1088, 1088,    0, 1088, 1088, 1088,    0,    0,    0,
 1088,    0,    0, 1088,    0, 1088, 1088, 1088, 1088,    0,
 1088,    0, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1088,
 1088,    0, 1088, 1088, 1088,    0,    0,    0,    0, 1088,
 1088, 1088, 1088, 1088,    0, 1088,    0,    0, 1088, 1088,
 1088, 1088, 1088, 1088, 1088,    0,    0,    0, 1088, 1088,
 1088, 1088, 1088, 1088, 1088, 1088,    0, 1088,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1088, 1088, 1088,
 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,    0, 1088,
 1088, 1088, 1088, 1088, 1088,    0, 1088, 1088, 1088, 1088,
    0, 1088,    0, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
 1088, 1083, 1088, 1088, 1088, 1088,    0, 1088, 1088, 1088,
 1088, 1088,    0, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088, 1088,
 1088, 1088, 1088,    0, 1088,    0,    0,    0,    0,    0,
    0,    0, 1083,    0, 1083, 1083, 1083,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1083, 1083, 1083, 1083,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1083,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1083,    0,
 1083,    0,    0, 1083,    0, 1083, 1083,    0,    0, 1083,
 1083,    0, 1083,    0,    0,    0,    0,    0,    0,    0,
    0, 1083, 1083,    0, 1083,    0, 1083,    0,    0, 1083,
    0,    0, 1083,    0,    0,    0,    0,    0,    0, 1083,
    0, 1083, 1083,    0, 1083, 1083, 1083,    0, 1083, 1083,
    0,    0, 1083,    0,    0, 1083,    0, 1083, 1083,    0,
    0, 1083, 1083, 1083,    0, 1083,    0, 1083, 1083, 1083,
 1083, 1083, 1083,    0,    0,    0, 1083, 1083, 1083, 1083,
 1083,    0,    0,    0, 1083,    0,    0,    0,    0,    0,
    0,    0, 1083,    0, 1083, 1083, 1083, 1083,    0, 1083,
    0,    0,    0,    0, 1083, 1083,    0, 1083,    0, 1083,
    0, 1083, 1083, 1083,    0, 1083,    0, 1083, 1083, 1083,
    0, 1083, 1083, 1083, 1083, 1083,    0, 1083, 1083,    0,
    0,    0,    0, 1083,    0, 1083, 1083,    0,    0, 1083,
 1083, 1083,    0,    0, 1083,    0,    0, 1083,    0,    0,
 1083, 1083, 1083, 1083,    0, 1083,    0, 1083,    0, 1083,
 1083, 1083, 1083, 1083,    0,    0, 1083, 1083, 1083,    0,
 1083, 1083,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1083, 1083, 1083,    0, 1083, 1083, 1083,    0,    0,
    0, 1083,    0,    0, 1083,    0, 1083, 1083, 1083, 1083,
    0, 1083,    0, 1083, 1083, 1083, 1083, 1083, 1083, 1083,
 1083,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1083, 1083,    0, 1083, 1083, 1083,    0,    0,    0,    0,
 1083, 1083, 1083, 1083, 1083,    0, 1083,    0,    0, 1083,
 1083, 1083, 1083, 1083, 1083, 1083,    0,    0,    0, 1083,
 1083, 1083, 1083, 1083, 1083, 1083, 1083,    0, 1083,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1083, 1083,
 1083, 1083, 1083, 1083, 1083, 1083, 1083, 1083, 1083, 1083,
 1083, 1083, 1083, 1083, 1083, 1083, 1083, 1083, 1083,    0,
 1083, 1083, 1083, 1083, 1083, 1083,    0, 1083, 1083, 1083,
 1083,    0, 1083,    0, 1083, 1083, 1083, 1083, 1083, 1083,
 1083, 1083, 1083, 1083, 1083, 1083, 1083, 1083, 1083, 1083,
 1083, 1083, 1086, 1083, 1083, 1083, 1083,    0, 1083, 1083,
 1083, 1083, 1083,    0, 1083, 1083, 1083, 1083, 1083, 1083,
 1083, 1083, 1083, 1083, 1083, 1083, 1083, 1083, 1083, 1083,
 1083, 1083, 1083, 1083,    0, 1083,    0,    0,    0,    0,
    0,    0,    0, 1086,    0, 1086, 1086, 1086,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1086, 1086, 1086, 1086,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1086,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1086,
    0, 1086,    0,    0, 1086,    0, 1086, 1086,    0,    0,
 1086, 1086,    0, 1086,    0,    0,    0,    0,    0,    0,
    0,    0, 1086, 1086,    0, 1086,    0, 1086,    0,    0,
 1086,    0,    0, 1086,    0,    0,    0,    0,    0,    0,
 1086,    0, 1086, 1086,    0, 1086, 1086, 1086,    0, 1086,
 1086,    0,    0, 1086,    0,    0, 1086,    0, 1086, 1086,
    0,    0, 1086, 1086, 1086,    0, 1086,    0, 1086, 1086,
 1086, 1086, 1086, 1086,    0,    0,    0, 1086, 1086, 1086,
 1086, 1086,    0,    0,    0, 1086,    0,    0,    0,    0,
    0,    0,    0, 1086,    0, 1086, 1086, 1086, 1086,    0,
 1086,    0,    0,    0,    0, 1086, 1086,    0, 1086,    0,
 1086,    0, 1086, 1086, 1086,    0, 1086,    0, 1086, 1086,
 1086,    0, 1086, 1086, 1086, 1086, 1086,    0, 1086, 1086,
    0,    0,  861,    0, 1086,    0, 1086, 1086,    0,    0,
 1086, 1086, 1086,    0,    0, 1086,    0,    0, 1086,    0,
    0, 1086, 1086, 1086, 1086,    0, 1086,    0, 1086,    0,
 1086, 1086, 1086, 1086, 1086,    0,    0, 1086, 1086, 1086,
    0, 1086, 1086,  861,    0,    0,  861,    0,    0,    0,
    0,    0, 1086, 1086, 1086,    0, 1086, 1086, 1086,    0,
    0,  861, 1086,    0,    0, 1086,    0, 1086, 1086, 1086,
 1086,    0, 1086,    0, 1086, 1086, 1086, 1086, 1086, 1086,
 1086, 1086,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1086, 1086,    0, 1086, 1086, 1086,    0,    0,    0,
    0, 1086, 1086, 1086, 1086, 1086,    0, 1086,    0,    0,
 1086, 1086, 1086, 1086, 1086, 1086, 1086,    0,    0,    0,
 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,    0, 1086,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1086,
 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
    0, 1086, 1086, 1086, 1086, 1086, 1086,    0, 1086, 1086,
 1086, 1086,    0, 1086,    0, 1086, 1086, 1086, 1086, 1086,
 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
 1086, 1086, 1086,    0, 1086, 1086, 1086, 1086,    0, 1086,
 1086, 1086, 1086, 1086,    0, 1086, 1086, 1086, 1086, 1086,
 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086, 1086,
 1086, 1086, 1086, 1086, 1086,    0, 1086,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  861,
    0,  861,    0,    0,    0,    0,  861,  861,    0,    0,
  861,  861,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  861,  861,    0,  861,    0,  861,    0,    0,
  861,    0,    0,  861,    0,    0,    0,    0,    0,    0,
  861,    0,  861,  861,    0,    0,    0,  861,    0,    0,
  861,    0,    0,  861,    0,    0,  861,    0,    0,  861,
    0,    0,    0,  861,  861,    0,  861,    0,  861,  861,
    0,  861,  861,  861,    0,    0,    0,  861,    0,  861,
  861,  861,    0,    0,    0,  861,    0,    0,    0,    0,
    0,    0,    0,  861,    0,  861,    0,  861,  832,    0,
  861,    0,    0,    0,    0,  861,  861,    0,  861,    0,
    0,    0,    0,    0,    0,    0,  861,    0,  861,    0,
  861,    0,  861,  861,  861,  861,  861,    0,  861,  861,
    0,    0,    0,    0,  861,    0,  861,  861,  832,  832,
  861,  861,  832,    0,    0,  861,    0,    0,  861,    0,
    0,  861,  861,  861,  861,    0,  861,  832,  861,    0,
  861,  861,  861,  861,  861,    0,    0,    0,    0,  861,
    0,  861,  861,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  861,    0,  861,    0,  861,  861,  861,    0,
    0,    0,  861,    0,    0,  861,    0,  861,  861,  861,
  861,    0,  861,    0,    0,    0,    0,    0,    0,    0,
  861,  861,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  861,  861,    0,  861,  861,  861,    0,    0,    0,
    0,  861,  861,  861,  861,  861,    0,  861,    0,    0,
  861,  861,  861,  861,  861,  861,  861,    0,    0,    0,
  861,  861,  861,  861,  861,  861,  861,  861,    0,  861,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  861,
  861,  861,  861,  861,  861,  861,  861,  861,  861,  861,
  861,  861,  861,  861,  861,  861,  861,  861,  861,  861,
    0,  861,  861,  861,  861,  861,  861,    0,  861,  861,
  861,  861,    0,  861,    0,  861,  861,  861,  861,  861,
  861,  861,  861,  861,  861,  861,  861,  861,  861,  861,
  861,  861,  861,    0,  861,  861,  861,  861,    0,  861,
  861,  861,  861,  861,    0,  861,  861,  861,  861,  861,
  861,  861,  861,  861,  861,  861,  861,  861,    0,  861,
  861,  861,  861,  861,  861,  832,  861,  832,    0,    0,
    0,    0,    0,  832,    0,    0,  832,  832,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  832,  832,
    0,  832,    0,  832,    0,    0,  832,    0,    0,  832,
    0,    0,    0,    0,    0,    0,  832,    0,  832,  832,
    0,    0,    0,  832,    0,    0,  832,    0,    0,  832,
    0,    0,  832,    0,    0,  832,    0,    0,    0,  832,
  832,    0,  832,    0,  832,  832,    0,  832,  832,  832,
    0,    0,    0,  832,    0,  832,  832,  832,    0,    0,
    0,  832,    0,    0,    0,    0,    0,    0,    0,  832,
    0,  832,    0,  832,  859,    0,  832,    0,    0,    0,
    0,  832,  832,    0,  832,    0,    0,    0,    0,    0,
    0,    0,  832,    0,  832,    0,  832,    0,  832,  832,
  832,  832,  832,    0,  832,  832,    0,    0,    0,    0,
  832,    0,  832,  832,    0,  859,  832,  832,  859,    0,
    0,  832,    0,    0,  832,    0,    0,  832,  832,  832,
  832,    0,  832,  859,  832,    0,  832,  832,  832,  832,
  832,    0,    0,    0,    0,  832,    0,  832,  832,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  832,    0,
  832,    0,  832,  832,  832,    0,    0,    0,  832,    0,
    0,  832,    0,  832,  832,  832,  832,    0,  832,    0,
    0,    0,    0,    0,    0,    0,  832,  832,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  832,  832,    0,
  832,  832,  832,    0,    0,    0,    0,  832,  832,  832,
  832,  832,    0,  832,    0,    0,  832,  832,  832,  832,
  832,  832,  832,    0,    0,    0,  832,  832,  832,  832,
  832,  832,  832,  832,    0,  832,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  832,  832,  832,  832,  832,
  832,  832,  832,  832,  832,  832,  832,  832,  832,  832,
  832,  832,  832,  832,  832,  832,    0,  832,  832,  832,
  832,  832,  832,    0,  832,  832,  832,  832,    0,  832,
    0,  832,  832,  832,  832,  832,  832,  832,  832,  832,
  832,  832,  832,  832,  832,  832,  832,  832,  832,    0,
  832,  832,  832,  832,    0,  832,  832,  832,  832,  832,
    0,  832,  832,  832,  832,  832,  832,  832,  832,  832,
  832,  832,  832,  832,    0,  832,  832,  832,  832,  832,
  832,  832,  832,  832,    0,    0,    0,    0,    0,  832,
    0,    0,  832,  832,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  832,  832,    0,  832,    0,  832,
    0,    0,  832,    0,    0,  832,    0,    0,    0,    0,
    0,    0,  832,    0,  832,  832,    0,    0,    0,  832,
    0,    0,  832,    0,    0,  832,    0,    0,  859,    0,
    0,  859,    0,    0,    0,  832,  832,    0,  859,    0,
  859,  832,    0,  832,  859,  832,    0,    0,    0,  859,
    0,  832,  859,  832,    0,    0,    0,  832,    0,    0,
    0,    0,    0,    0,    0,  832,    0,  859,    0,  832,
  864,    0,  832,    0,    0,    0,    0,  832,  832,    0,
  859,    0,    0,    0,    0,    0,    0,    0,  859,    0,
  832,    0,  859,    0,  832,  832,  832,  832,  832,    0,
  832,  859,    0,    0,    0,    0,  832,    0,  832,  832,
    0,    0,  832,  832,    0,    0,    0,  859,    0,    0,
  832,    0,    0,  832,  832,  832,  832,    0,  832,  864,
  832,    0,  832,  832,  832,  832,  832,    0,    0,    0,
    0,  832,    0,  832,  859,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  832,    0,  859,    0,  859,  832,
  832,    0,    0,    0,  832,    0,    0,  832,    0,  832,
  832,  832,  832,    0,  832,    0,    0,    0,    0,    0,
    0,    0,  832,  832,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  832,  832,    0,  832,  832,  832,    0,
    0,    0,    0,  832,  832,  859,  832,  832,    0,  832,
    0,    0,  832,  832,  832,  832,  832,  832,  832,    0,
    0,    0,  859,  832,  832,  832,  859,  832,  832,  832,
    0,  832,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  832,  832,  832,  832,  832,  832,  832,  832,
  832,  832,  832,  832,  832,  832,  832,  832,  832,  832,
  832,  832,    0,  832,  832,  832,  832,  832,  832,    0,
  832,  832,  832,  832,    0,  832,    0,  832,  832,  832,
  832,  832,  832,  832,  832,  832,  832,  832,  832,  832,
  832,  832,  832,  832,  832,    0,  832,  832,  832,  832,
    0,  832,  832,  832,  832,  832,    0,  832,  832,  832,
  832,  832,  832,  832,  832,  832,  832,  832,  832,  832,
    0,  832,  832,  832,  832,  832,  832,  832,  832,  832,
    0,    0,    0,    0,    0,  832,    0,    0,  832,  832,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  832,  832,    0,  832,    0,  832,    0,    0,  832,    0,
    0,  832,    0,    0,    0,    0,    0,    0,  832,    0,
  832,  832,    0,    0,    0,  832,    0,    0,  832,    0,
    0,  832,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  832,  832,    0,    0,    0,    0,  832,    0,  832,
    0,  832,    0,    0,    0,    0,    0,  832,    0,  832,
    0,    0,    0,  832,    0,    0,    0,    0,    0,    0,
    0,  832,    0,    0,    0,  832,    0,    0,  832,    0,
    0,    0,    0,  832,  832,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  832,    0,  864,    0,
  832,  832,  832,  832,  832,    0,  832,  864,    0,    0,
    0,    0,  832,    0,  832,  832,    0,    0,  832,  832,
    0,    0,    0,    0,    0,    0,  832,    0,  864,  832,
  832,  832,  832,    0,  832,    0,  832,    0,  832,  832,
  832,  832,  832,    0,    0,    0,    0,  832,    0,  832,
    0,    0,    0,    0, 2077,    0,    0,    0,    0,    0,
  832,    0,  864,    0,    0,  832,  832,    0,    0,    0,
  832,    0,    0,  832,    0,  832,  832,  832,  832,    0,
  832,    0,    0,    0,    0,    0,    0,    0,  832,  832,
    0,    0,    0,    0,    0,    0,    0,    0, 2111,  832,
  832,    0,  832,  832,  832,    0,    0, 2116,    0,  832,
  832,  864,  832,  832,    0,  832,    0,    0,  832,  832,
  832,  832,  832,  832,  832,    0,    0,    0,  864,  832,
  832,  832,    0,  832,  832,  832,    0,  832,    0,    0,
    0,    0,    0,    0, 2136,    0,    0,    0,  832,  832,
  832,  832,  832,  832,  832,  832,  832,  832,  832,  832,
  832,  832,  832,  832,  832,  832,  832,  832,    0,  832,
  832,  832,  832,  832,  832,    0,  832,  832,  832,  832,
    0,  832,    0,  832,  832,  832,  832,  832,  832,  832,
  832,  832,  832,  832,  832,  832,  832,  832,  832,  832,
  832, 1047,  832,  832,  832,  832,    0,  832,  832,  832,
  832,  832,    0,  832,  832,  832,  832,  832,  832,  832,
  832,  832,  832,  832,  832,  832,    0,  832,  832,  832,
  832,  832,  832,    0,  832,    0,    0,    0,    0,    0,
    0,    0,    0, 1329, 1329, 1047, 1329, 1329, 1329,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1047, 1329, 1329, 1329,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1329, 2243,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 2250,    0,    0, 2253,    0,    0,
    0,    0,    0,    0,    0,    0, 2257,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 2275,    0, 2277,    0, 2279,    0,
 2281,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1081,    0,    0,  758,    0,  759,    0,
    0,    0,    0,    0,    0, 2350, 2351, 2352,    0,    0,
    0,  761,    0, 1047,    0,    0,  762,    0,    0,    0,
    0,    0, 1329,    0,    0,    0,    0,    0, 1329,    0,
    0,    0,    0, 1329,    0,    0, 1329,    0,    0,    0,
    0, 2368,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1047,    0,    0, 1047,    0,
    0, 1329,    0,    0,    0, 1047,    0, 1047,    0, 1329,
    0, 1047,    0,    0,    0,    0, 1047, 1329,    0, 1047,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1047, 1329,    0, 1329,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1047,    0, 1329,
    0, 1329, 1329, 1329,    0, 1047,    0,    0, 1047, 1047,
 2411, 2412, 2413,    0,    0,    0, 2416,    0, 1047,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1047,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1329,    0,    0,    0,    0,    0, 1047,    0,    0,    0,
    0, 1047,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1047, 1047,    0, 1047,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  113,    0,  114,    0,    0,    0,    0,    0,  116,    0,
  662,  117,  118,    0,    0,    0,    0,  663,    0,    0,
    0,    0,    0,  119,  120,    0,  121,    0,  122,  664,
    0,  123, 1047,    0,  124,  665,  666,    0,    0,    0,
    0,  126,    0,  127,  128,    0,    0,    0,  129, 1047,
    0,  130,    0, 1047,  132,    0,    0,    0,    0,    0,
    0,    0,  667,    0,  133,  668,    0,    0, 1047,    0,
  135,    0,  136,    0,  137,    0,    0,    0,    0,    0,
  139,    0,  140,    0,    0,    0,  141,    0,    0,    0,
  669,    0,  670,  671,  142,    0,  672,    0,  143,    0,
    0,  144,  673,    0,    0,  674,  145,  146,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  147,
    0,    0,    0,  148,  149,  150,  151,  152,    0,  153,
    0,  675,    0,    0,    0,  154,    0,  155,  156,    0,
    0,  158,  159,    0,    0,    0,  676, 1329,    0,  160,
    0,    0,  162,  163,  164,  165,    0,  166,    0,  167,
  677,  168,  169,  170,  171,  172,  678,    0,    0,    0,
  173,    0,  174,    0,    0,    0,  679,    0,    0, 1044,
    0,    0,  758,  176,  759,    0,    0,    0,  177,  178,
  680,  681,  682,  683,  422,  423,  180,  761,  181,  182,
  183,  184,  762,  185,  684, 1390, 1391, 1392, 1393, 1394,
 1395, 1424, 1425,  685,  686,  687,  688,  689,  690,  691,
  692,  693,  188,  694,    0,  190,  191,  192,  695,  696,
    0,  697,  698,  699,    0,  195,  196,  700,  197,    0,
    0,  198,  199,  200,  201,  202,  203,  204,    0,    0,
    0,    0,  205,  701,  207,    0,  702,  209,  210,    0,
  211,    0,  703,  704,  705,    0,  706,  707,    0,  708,
  212,  213,  214,  215,  216,  217,  709,  219,  710,  221,
  711,  712,  713,  714,  715,  716,  717,  718,  719,  720,
  721,    0,  722,  723,  724,  725,  726,  727,    0,  728,
  729,  730,  242,    0,  731,    0,  732,  733,  734,  735,
  736,  249,  250,  737, 1426,  738,  739,  740,  256,  741,
  258,  742,  260,  743,    0,  744,  745,  746,  747,    0,
  748,  749,  750,  269,  751,    0,  752,  753,  273,  754,
 1427,  276,  755,  278,  279,  280,  281,  282,  283,    0,
  756,  285,  286,  287,  288,  289,    0,  757,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  113,    0,  114,    0,
    0,    0,    0,    0,  116,    0,  662,  117,  118,    0,
    0,    0,    0,  663,    0,    0,    0,    0,    0,  119,
  120,    0,  121,    0,  122,  664,    0,  123, 1037,    0,
  124,  665,  666,    0,    0,    0,    0,  126,    0,  127,
  128,    0,    0,    0,  129,    0,    0,  130,    0, 1038,
  132,    0,    0,    0,    0,    0,    0,    0,  667,    0,
  133,  668,    0,    0,    0,    0,  135,    0,  136,    0,
  137,    0,    0,    0,    0,    0,  139,    0,  140,    0,
    0,    0,  141,    0,    0,    0,  669,    0,  670,  671,
  142,    0,  672,    0,  143,    0,    0,  144,  673,    0,
    0,  674,  145,  146,    0,    0,    0,    0,    0, 1039,
    0,    0,    0,    0,    0,  147,    0,    0,    0,  148,
  149,  150,  151,  152,    0,  153,    0,  675,    0,    0,
    0,  154,    0,  155,  156,    0,    0,  158,  159,    0,
    0,    0,  676,    0,    0,  160,    0,    0,  162,  163,
 1040,  165,    0,  166,    0,  167,  677,  168,  169,  170,
  171,  172,  678,    0,    0,    0,  173,    0,  174,    0,
    0,    0,  679,    0,    0, 1044,    0,    0,  758,  176,
  759,    0,    0,    0,  177,  178,  680,  681,  682,  683,
  422,  423,  180,  761,  181,  182,  183,  184,  762,  185,
  684,    0,    0,    0,    0,    0,    0,  186,  187,  685,
  686,  687,  688,  689,  690,  691,  692,  693,  188,  694,
    0,  190,  191,  192,  695,  696,    0,  697,  698,  699,
    0,  195,  196,  700,  197,    0,    0,  198,  199, 1041,
 1042, 1043,  203,  204,    0,    0,    0,    0,  205,  701,
  207,    0,  702,  209,  210,    0,  211,    0,  703,  704,
  705,    0,  706,  707,    0,  708,  212,  213,  214,  215,
  216,  217,  709,  219,  710,  221,  711,  712,  713,  714,
  715,  716,  717,  718,  719,  720,  721,    0,  722,  723,
  724,  725,  726,  727,    0,  728,  729,  730,  242,    0,
  731,    0,  732,  733,  734,  735,  736,  249,  250,  737,
  252,  738,  739,  740,  256,  741,  258,  742,  260,  743,
    0,  744,  745,  746,  747,    0,  748,  749,  750,  269,
  751,    0,  752,  753,  273,  754,  275,  276,  755,  278,
  279,  280,  281,  282,  283,    0,  756,  285,  286,  287,
  288,  289,    0,  757,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  113,    0,  114,    0,    0,    0,    0,    0,
  116,    0,  662,  117,  118,    0,    0,    0,    0,  663,
    0,    0,    0,    0,    0,  119,  120,    0,  121,    0,
  122,  664,    0,  123,    0,    0,  124,  665,  666,    0,
    0,    0,    0,  126,    0,  127,  128,    0,    0,    0,
  129,    0,    0,  130,    0, 1038,  132,    0,    0,    0,
    0,    0,    0,    0,  667,    0,  133,  668,    0,    0,
    0,    0,  135,    0,  136,    0,  137,    0,    0,    0,
    0,    0,  139,    0,  140,    0,    0,    0,  141,    0,
    0,    0,  669,    0,  670,  671,  142,    0,  672,    0,
  143,    0,    0,  144,  673,    0,    0,  674,  145,  146,
    0,    0,    0,    0,    0, 1039,    0,    0,    0,    0,
    0,  147,    0,    0,    0,  148,  149,  150,  151,  152,
    0,  153,    0,  675,    0,    0,    0,  154,    0,  155,
  156,    0,    0,  158,  159,    0,    0,    0,  676,    0,
    0,  160,    0,    0,  162,  163, 1040,  165,    0,  166,
    0,  167,  677,  168,  169,  170,  171,  172,  678,    0,
    0,    0,  173,    0,  174,    0,    0,    0,  679,    0,
    0, 1081,    0,    0,  758,  176,  759,    0,    0,   16,
  177,  178,  680,  681,  682,  683,  422,  423,  180,  761,
  181,  182,  183,  184,  762,  185,  684,    0,    0,    0,
    0,    0,    0,  186,  187,  685,  686,  687,  688,  689,
  690,  691,  692,  693,  188,  694,    0,  190,  191,  192,
  695,  696,    0,  697,  698,  699,    0,  195,  196,  700,
  197,    0,    0,  198,  199, 1041, 1042, 1043,  203,  204,
    0,    0,    0,    0,  205,  701,  207,    0,  702,  209,
  210,    0,  211,    0,  703,  704,  705,    0,  706,  707,
    0,  708,  212,  213,  214,  215,  216,  217,  709,  219,
  710,  221,  711,  712,  713,  714,  715,  716,  717,  718,
  719,  720,  721,    0,  722,  723,  724,  725,  726,  727,
    0,  728,  729,  730,  242,    0,  731,    0,  732,  733,
  734,  735,  736,  249,  250,  737,  252,  738,  739,  740,
  256,  741,  258,  742,  260,  743,    0,  744,  745,  746,
  747,    0,  748,  749,  750,  269,  751,    0,  752,  753,
  273,  754,  275,  276,  755,  278,  279,  280,  281,  282,
  283,    0,  756,  285,  286,  287,  288,  289,    0,  757,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  113,    0,
  114,    0,    0,    0,    0,    0,  116,    0,  662,  117,
  118,    0,    0,    0,    0,  663,    0,    0,    0,    0,
    0,  119,  120,    0,  121,    0,  122,  664,    0,  123,
    0,    0,  124,  665,  666,    0,    0,    0,    0,  126,
    0,  127,  128,    0,    0,    0,  129,    0,    0,  130,
    0,    0,  132,    0,    0,    0,    0,    0,    0,    0,
  667,    0,  133,  668,    0,    0,    0,    0,  135,    0,
  136,    0,  137,    0,    0,    0,    0,    0,  139,    0,
  140,    0,    0,    0,  141,    0,    0,    0,  669,    0,
  670,  671,  142,    0,  672,    0,  143,    0,    0,  144,
  673,    0,    0,  674,  145,  146,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  147,    0,    0,
    0,  148,  149,  150,  151,  152,    0,  153,    0,  675,
    0,    0,    0,  154,    0,  155,  156,    0,    0,  158,
  159,    0,    0,    0,  676,    0,    0,  160,    0,    0,
  162,  163,  164,  165,    0,  166,    0,  167,  677,  168,
  169,  170,  171,  172,  678,    0,    0,    0,  173,    0,
  174,    0,    0,    0,  679,    0,    0, 1081,    0,    0,
  758,  176,  759,    0,    0,    0,  177,  178,  680,  681,
  682,  683,  422,  423,  180,  761,  181,  182,  183,  184,
  762,  185,  684,    0,    0,    0,    0,    0,    0,  186,
  187,  685,  686,  687,  688,  689,  690,  691,  692,  693,
  188,  694,    0,  190,  191,  192,  695,  696,    0,  697,
  698,  699,    0,  195,  196,  700,  197,    0,    0,  198,
  199,  200,  201,  202,  203,  204,    0,    0,    0,    0,
  205,  701,  207,    0,  702,  209,  210, 1419,  211,    0,
  703,  704,  705, 1420,  706,  707, 1421,  708,  212,  213,
  214,  215,  216,  217,  709,  219,  710,  221,  711,  712,
  713,  714,  715,  716,  717,  718,  719,  720,  721,    0,
  722,  723,  724,  725,  726,  727,    0,  728,  729,  730,
  242,    0,  731,    0,  732,  733,  734,  735,  736,  249,
  250,  737,  252,  738,  739,  740,  256,  741,  258,  742,
  260,  743,    0,  744,  745,  746,  747,    0,  748,  749,
  750,  269,  751,    0,  752,  753,  273,  754,  275,  276,
  755,  278,  279,  280,  281,  282,  283,    0,  756,  285,
  286,  287,  288,  289,    0,  757,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  113,    0,  114, 1681,    0,    0,
 1682,    0,  116,    0,  662,  117,  118,    0,    0,    0,
    0,  663,    0,    0,    0,    0,    0,  119,  120,    0,
  121,    0,  122,  664,    0,  123,    0,    0,  124,  665,
  666,    0,    0,    0,    0,  126,    0,  127,  128,    0,
    0,    0,  129,    0,    0,  130,    0,    0,  132,    0,
    0,    0,    0,    0,    0,    0,  667,    0,  133,  668,
    0,    0,    0,    0,  135,    0,  136,    0,  137,    0,
    0,    0,    0,    0,  139,    0,  140,    0,    0,    0,
  141,    0,    0,    0,  669,    0,  670,  671,  142,    0,
  672,    0,  143,    0,    0,  144,  673,    0,    0,  674,
  145,  146,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  147,    0,    0,    0,  148,  149,  150,
  151,  152,    0,  153,    0,  675,    0,    0,    0,  154,
    0,  155,  156,    0,    0,  158,  159,    0,    0,    0,
  676,    0,    0,  160,    0,    0,  162,  163,  164,  165,
    0,  166, 1683,  167,  677,  168,  169,  170,  171,  172,
  678,    0,    0,    0,  173,    0,  174,    0,    0,    0,
  679,    0,    0, 1081,    0,    0,  758,  176,  759,    0,
    0,    0,  177,  178,  680,  681,  682,  683,  422,  423,
  180,  761,  181,  182,  183,  184,  762,  185,  684,    0,
    0,    0,    0,    0,    0,  186,  187,  685,  686,  687,
  688,  689,  690,  691,  692,  693,  188,  694,    0,  190,
  191,  192,  695,  696,    0,  697,  698,  699,    0,  195,
  196,  700,  197,    0,    0,  198,  199,  200,  201,  202,
  203,  204,    0,    0,    0,    0,  205,  701,  207,    0,
  702,  209,  210,    0,  211,    0,  703,  704,  705,    0,
  706,  707,    0,  708,  212,  213,  214,  215,  216,  217,
  709,  219,  710,  221,  711,  712,  713,  714,  715,  716,
  717,  718,  719,  720,  721,    0,  722,  723,  724,  725,
  726,  727,    0,  728,  729,  730,  242,    0,  731,    0,
  732,  733,  734,  735,  736,  249,  250,  737,  252,  738,
  739,  740,  256,  741,  258,  742,  260,  743,    0,  744,
  745,  746,  747,    0,  748,  749,  750,  269,  751,    0,
  752,  753,  273,  754,  275,  276,  755,  278,  279,  280,
  281,  282,  283,    0,  756,  285,  286,  287,  288,  289,
    0,  757,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  113,    0,  114, 1692,    0,    0, 1682,    0,  116,    0,
  662,  117,  118,    0,    0,    0,    0,  663,    0,    0,
    0,    0,    0,  119,  120,    0,  121,    0,  122,  664,
    0,  123,    0,    0,  124,  665,  666,    0,    0,    0,
    0,  126,    0,  127,  128,    0,    0,    0,  129,    0,
    0,  130,    0,    0,  132,    0,    0,    0,    0,    0,
    0,    0,  667,    0,  133,  668,    0,    0,    0,    0,
  135,    0,  136,    0,  137,    0,    0,    0,    0,    0,
  139,    0,  140,    0,    0,    0,  141,    0,    0,    0,
  669,    0,  670,  671,  142,    0,  672,    0,  143,    0,
    0,  144,  673,    0,    0,  674,  145,  146,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  147,
    0,    0,    0,  148,  149,  150,  151,  152,    0,  153,
    0,  675,    0,    0,    0,  154,    0,  155,  156,    0,
    0,  158,  159,    0,    0,    0,  676,    0,    0,  160,
    0,    0,  162,  163,  164,  165,    0,  166, 1683,  167,
  677,  168,  169,  170,  171,  172,  678,    0,    0,    0,
  173,    0,  174,    0,    0,    0,  679,    0,    0, 1081,
    0,    0,  758,  176,  759,    0,    0,    0,  177,  178,
  680,  681,  682,  683,  422,  423,  180,  761,  181,  182,
  183,  184,  762,  185,  684,    0,    0,    0,    0,    0,
    0,  186,  187,  685,  686,  687,  688,  689,  690,  691,
  692,  693,  188,  694,    0,  190,  191,  192,  695,  696,
    0,  697,  698,  699,    0,  195,  196,  700,  197,    0,
    0,  198,  199,  200,  201,  202,  203,  204,    0,    0,
    0,    0,  205,  701,  207,    0,  702,  209,  210,    0,
  211,    0,  703,  704,  705,    0,  706,  707,    0,  708,
  212,  213,  214,  215,  216,  217,  709,  219,  710,  221,
  711,  712,  713,  714,  715,  716,  717,  718,  719,  720,
  721,    0,  722,  723,  724,  725,  726,  727,    0,  728,
  729,  730,  242,    0,  731,    0,  732,  733,  734,  735,
  736,  249,  250,  737,  252,  738,  739,  740,  256,  741,
  258,  742,  260,  743,    0,  744,  745,  746,  747,    0,
  748,  749,  750,  269,  751,    0,  752,  753,  273,  754,
  275,  276,  755,  278,  279,  280,  281,  282,  283,    0,
  756,  285,  286,  287,  288,  289,    0,  757,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  113,    0,  114, 1696,
    0,    0, 1682,    0,  116,    0,  662,  117,  118,    0,
    0,    0,    0,  663,    0,    0,    0,    0,    0,  119,
  120,    0,  121,    0,  122,  664,    0,  123,    0,    0,
  124,  665,  666,    0,    0,    0,    0,  126,    0,  127,
  128,    0,    0,    0,  129,    0,    0,  130,    0,    0,
  132,    0,    0,    0,    0,    0,    0,    0,  667,    0,
  133,  668,    0,    0,    0,    0,  135,    0,  136,    0,
  137,    0,    0,    0,    0,    0,  139,    0,  140,    0,
    0,    0,  141,    0,    0,    0,  669,    0,  670,  671,
  142,    0,  672,    0,  143,    0,    0,  144,  673,    0,
    0,  674,  145,  146,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  147,    0,    0,    0,  148,
  149,  150,  151,  152,    0,  153,    0,  675,    0,    0,
    0,  154,    0,  155,  156,    0,    0,  158,  159,    0,
    0,    0,  676,    0,    0,  160,    0,    0,  162,  163,
  164,  165,    0,  166, 1683,  167,  677,  168,  169,  170,
  171,  172,  678,    0,    0,    0,  173,    0,  174,    0,
    0,    0,  679,    0,    0, 1081,    0,    0,  758,  176,
  759,    0,    0,    0,  177,  178,  680,  681,  682,  683,
  422,  423,  180,  761,  181,  182,  183,  184,  762,  185,
  684,    0,    0,    0,    0,    0,    0,  186,  187,  685,
  686,  687,  688,  689,  690,  691,  692,  693,  188,  694,
    0,  190,  191,  192,  695,  696,    0,  697,  698,  699,
    0,  195,  196,  700,  197,    0,    0,  198,  199,  200,
  201,  202,  203,  204,    0,    0,    0,    0,  205,  701,
  207,    0,  702,  209,  210,    0,  211,    0,  703,  704,
  705,    0,  706,  707,    0,  708,  212,  213,  214,  215,
  216,  217,  709,  219,  710,  221,  711,  712,  713,  714,
  715,  716,  717,  718,  719,  720,  721,    0,  722,  723,
  724,  725,  726,  727,    0,  728,  729,  730,  242,    0,
  731,    0,  732,  733,  734,  735,  736,  249,  250,  737,
  252,  738,  739,  740,  256,  741,  258,  742,  260,  743,
    0,  744,  745,  746,  747,    0,  748,  749,  750,  269,
  751,    0,  752,  753,  273,  754,  275,  276,  755,  278,
  279,  280,  281,  282,  283,    0,  756,  285,  286,  287,
  288,  289,    0,  757,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  113,    0,  114, 1705,    0,    0, 1682,    0,
  116,    0,  662,  117,  118,    0,    0,    0,    0,  663,
    0,    0,    0,    0,    0,  119,  120,    0,  121,    0,
  122,  664,    0,  123,    0,    0,  124,  665,  666,    0,
    0,    0,    0,  126,    0,  127,  128,    0,    0,    0,
  129,    0,    0,  130,    0,    0,  132,    0,    0,    0,
    0,    0,    0,    0,  667,    0,  133,  668,    0,    0,
    0,    0,  135,    0,  136,    0,  137,    0,    0,    0,
    0,    0,  139,    0,  140,    0,    0,    0,  141,    0,
    0,    0,  669,    0,  670,  671,  142,    0,  672,    0,
  143,    0,    0,  144,  673,    0,    0,  674,  145,  146,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  147,    0,    0,    0,  148,  149,  150,  151,  152,
    0,  153,    0,  675,    0,    0,    0,  154,    0,  155,
  156,    0,    0,  158,  159,    0,    0,    0,  676,    0,
    0,  160,    0,    0,  162,  163,  164,  165,    0,  166,
 1683,  167,  677,  168,  169,  170,  171,  172,  678,    0,
    0,    0,  173,    0,  174,    0,    0,    0,  679,    0,
    0, 1081,    0,    0,  758,  176,  759,    0,    0,    0,
  177,  178,  680,  681,  682,  683,  422,  423,  180,  761,
  181,  182,  183,  184,  762,  185,  684,    0,    0,    0,
    0,    0,    0,  186,  187,  685,  686,  687,  688,  689,
  690,  691,  692,  693,  188,  694,    0,  190,  191,  192,
  695,  696,    0,  697,  698,  699,    0,  195,  196,  700,
  197,    0,    0,  198,  199,  200,  201,  202,  203,  204,
    0,    0,    0,    0,  205,  701,  207,    0,  702,  209,
  210,    0,  211,    0,  703,  704,  705,    0,  706,  707,
    0,  708,  212,  213,  214,  215,  216,  217,  709,  219,
  710,  221,  711,  712,  713,  714,  715,  716,  717,  718,
  719,  720,  721,    0,  722,  723,  724,  725,  726,  727,
    0,  728,  729,  730,  242,    0,  731,    0,  732,  733,
  734,  735,  736,  249,  250,  737,  252,  738,  739,  740,
  256,  741,  258,  742,  260,  743,    0,  744,  745,  746,
  747,    0,  748,  749,  750,  269,  751,    0,  752,  753,
  273,  754,  275,  276,  755,  278,  279,  280,  281,  282,
  283,    0,  756,  285,  286,  287,  288,  289,    0,  757,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  113,    0,
  114, 1708,    0,    0, 1682,    0,  116,    0,  662,  117,
  118,    0,    0,    0,    0,  663,    0,    0,    0,    0,
    0,  119,  120,    0,  121,    0,  122,  664,    0,  123,
    0,    0,  124,  665,  666,    0,    0,    0,    0,  126,
    0,  127,  128,    0,    0,    0,  129,    0,    0,  130,
    0,    0,  132,    0,    0,    0,    0,    0,    0,    0,
  667,    0,  133,  668,    0,    0,    0,    0,  135,    0,
  136,    0,  137,    0,    0,    0,    0,    0,  139,    0,
  140,    0,    0,    0,  141,    0,    0,    0,  669,    0,
  670,  671,  142,    0,  672,    0,  143,    0,    0,  144,
  673,    0,    0,  674,  145,  146,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  147,    0,    0,
    0,  148,  149,  150,  151,  152,    0,  153,    0,  675,
    0,    0,    0,  154,    0,  155,  156,    0,    0,  158,
  159,    0,    0,    0,  676,    0,    0,  160,    0,    0,
  162,  163,  164,  165,    0,  166, 1683,  167,  677,  168,
  169,  170,  171,  172,  678,    0,    0,    0,  173,    0,
  174,    0,    0,    0,  679,    0,    0, 1081,    0,    0,
  758,  176,  759,    0,    0,    0,  177,  178,  680,  681,
  682,  683,  422,  423,  180,  761,  181,  182,  183,  184,
  762,  185,  684,    0,    0,    0,    0,    0,    0,  186,
  187,  685,  686,  687,  688,  689,  690,  691,  692,  693,
  188,  694,    0,  190,  191,  192,  695,  696,    0,  697,
  698,  699,    0,  195,  196,  700,  197,    0,    0,  198,
  199,  200,  201,  202,  203,  204,    0,    0,    0,    0,
  205,  701,  207,    0,  702,  209,  210,    0,  211,    0,
  703,  704,  705,    0,  706,  707,    0,  708,  212,  213,
  214,  215,  216,  217,  709,  219,  710,  221,  711,  712,
  713,  714,  715,  716,  717,  718,  719,  720,  721,    0,
  722,  723,  724,  725,  726,  727,    0,  728,  729,  730,
  242,    0,  731,    0,  732,  733,  734,  735,  736,  249,
  250,  737,  252,  738,  739,  740,  256,  741,  258,  742,
  260,  743,    0,  744,  745,  746,  747,    0,  748,  749,
  750,  269,  751,    0,  752,  753,  273,  754,  275,  276,
  755,  278,  279,  280,  281,  282,  283,    0,  756,  285,
  286,  287,  288,  289,    0,  757,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  113,    0,  114, 1714,    0,    0,
 1682,    0,  116,    0,  662,  117,  118,    0,    0,    0,
    0,  663,    0,    0,    0,    0,    0,  119,  120,    0,
  121,    0,  122,  664,    0,  123,    0,    0,  124,  665,
  666,    0,    0,    0,    0,  126,    0,  127,  128,    0,
    0,    0,  129,    0,    0,  130,    0,    0,  132,    0,
    0,    0,    0,    0,    0,    0,  667,    0,  133,  668,
    0,    0,    0,    0,  135,    0,  136,    0,  137,    0,
    0,    0,    0,    0,  139,    0,  140,    0,    0,    0,
  141,    0,    0,    0,  669,    0,  670,  671,  142,    0,
  672,    0,  143,    0,    0,  144,  673,    0,    0,  674,
  145,  146,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  147,    0,    0,    0,  148,  149,  150,
  151,  152,    0,  153,    0,  675,    0,    0,    0,  154,
    0,  155,  156,    0,    0,  158,  159,    0,    0,    0,
  676,    0,    0,  160,    0,    0,  162,  163,  164,  165,
    0,  166, 1683,  167,  677,  168,  169,  170,  171,  172,
  678,    0,    0,    0,  173,    0,  174,    0,    0,    0,
  679,    0,    0, 1081,    0,    0,  758,  176,  759,    0,
    0,    0,  177,  178,  680,  681,  682,  683,  422,  423,
  180,  761,  181,  182,  183,  184,  762,  185,  684,    0,
    0,    0,    0,    0,    0,  186,  187,  685,  686,  687,
  688,  689,  690,  691,  692,  693,  188,  694,    0,  190,
  191,  192,  695,  696,    0,  697,  698,  699,    0,  195,
  196,  700,  197,    0,    0,  198,  199,  200,  201,  202,
  203,  204,    0,    0,    0,    0,  205,  701,  207,    0,
  702,  209,  210,    0,  211,    0,  703,  704,  705,    0,
  706,  707,    0,  708,  212,  213,  214,  215,  216,  217,
  709,  219,  710,  221,  711,  712,  713,  714,  715,  716,
  717,  718,  719,  720,  721,    0,  722,  723,  724,  725,
  726,  727,    0,  728,  729,  730,  242,    0,  731,    0,
  732,  733,  734,  735,  736,  249,  250,  737,  252,  738,
  739,  740,  256,  741,  258,  742,  260,  743,    0,  744,
  745,  746,  747,    0,  748,  749,  750,  269,  751,    0,
  752,  753,  273,  754,  275,  276,  755,  278,  279,  280,
  281,  282,  283,    0,  756,  285,  286,  287,  288,  289,
    0,  757,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  113,    0,  114, 1717,    0,    0, 1682,    0,  116,    0,
  662,  117,  118,    0,    0,    0,    0,  663,    0,    0,
    0,    0,    0,  119,  120,    0,  121,    0,  122,  664,
    0,  123,    0,    0,  124,  665,  666,    0,    0,    0,
    0,  126,    0,  127,  128,    0,    0,    0,  129,    0,
    0,  130,    0,    0,  132,    0,    0,    0,    0,    0,
    0,    0,  667,    0,  133,  668,    0,    0,    0,    0,
  135,    0,  136,    0,  137,    0,    0,    0,    0,    0,
  139,    0,  140,    0,    0,    0,  141,    0,    0,    0,
  669,    0,  670,  671,  142,    0,  672,    0,  143,    0,
    0,  144,  673,    0,    0,  674,  145,  146,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  147,
    0,    0,    0,  148,  149,  150,  151,  152,    0,  153,
    0,  675,    0,    0,    0,  154,    0,  155,  156,    0,
    0,  158,  159,    0,    0,    0,  676,    0,    0,  160,
    0,    0,  162,  163,  164,  165,    0,  166, 1683,  167,
  677,  168,  169,  170,  171,  172,  678,    0,    0,    0,
  173,    0,  174,    0,    0,    0,  679,    0,    0, 1081,
    0,    0,  758,  176,  759,    0,    0,    0,  177,  178,
  680,  681,  682,  683,  422,  423,  180,  761,  181,  182,
  183,  184,  762,  185,  684,    0,    0,    0,    0,    0,
    0,  186,  187,  685,  686,  687,  688,  689,  690,  691,
  692,  693,  188,  694,    0,  190,  191,  192,  695,  696,
    0,  697,  698,  699,    0,  195,  196,  700,  197,    0,
    0,  198,  199,  200,  201,  202,  203,  204,    0,    0,
    0,    0,  205,  701,  207,    0,  702,  209,  210,    0,
  211,    0,  703,  704,  705,    0,  706,  707,    0,  708,
  212,  213,  214,  215,  216,  217,  709,  219,  710,  221,
  711,  712,  713,  714,  715,  716,  717,  718,  719,  720,
  721,    0,  722,  723,  724,  725,  726,  727,    0,  728,
  729,  730,  242,    0,  731,    0,  732,  733,  734,  735,
  736,  249,  250,  737,  252,  738,  739,  740,  256,  741,
  258,  742,  260,  743,    0,  744,  745,  746,  747,    0,
  748,  749,  750,  269,  751,    0,  752,  753,  273,  754,
  275,  276,  755,  278,  279,  280,  281,  282,  283,    0,
  756,  285,  286,  287,  288,  289,    0,  757,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  113,    0,  114, 1720,
    0,    0, 1682,    0,  116,    0,  662,  117,  118,    0,
    0,    0,    0,  663,    0,    0,    0,    0,    0,  119,
  120,    0,  121,    0,  122,  664,    0,  123,    0,    0,
  124,  665,  666,    0,    0,    0,    0,  126,    0,  127,
  128,    0,    0,    0,  129,    0,    0,  130,    0,    0,
  132,    0,    0,    0,    0,    0,    0,    0,  667,    0,
  133,  668,    0,    0,    0,    0,  135,    0,  136,    0,
  137,    0,    0,    0,    0,    0,  139,    0,  140,    0,
    0,    0,  141,    0,    0,    0,  669,    0,  670,  671,
  142,    0,  672,    0,  143,    0,    0,  144,  673,    0,
    0,  674,  145,  146,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  147,    0,    0,    0,  148,
  149,  150,  151,  152,    0,  153,    0,  675,    0,    0,
    0,  154,    0,  155,  156,    0,    0,  158,  159,    0,
    0,    0,  676,    0,    0,  160,    0,    0,  162,  163,
  164,  165,    0,  166, 1683,  167,  677,  168,  169,  170,
  171,  172,  678,    0,    0,    0,  173,    0,  174,    0,
    0,    0,  679,    0,    0, 1044,    0,    0,  758,  176,
  759,    0,    0,    0,  177,  178,  680,  681,  682,  683,
  422,  423,  180,  761,  181,  182,  183,  184,  762,  185,
  684,    0,    0,    0,    0,    0,    0,  186,  187,  685,
  686,  687,  688,  689,  690,  691,  692,  693,  188,  694,
    0,  190,  191,  192,  695,  696,    0,  697,  698,  699,
    0,  195,  196,  700,  197,    0,    0,  198,  199,  200,
  201,  202,  203,  204,    0,    0,    0,    0,  205,  701,
  207,    0,  702,  209,  210,    0,  211,    0,  703,  704,
  705,    0,  706,  707,    0,  708,  212,  213,  214,  215,
  216,  217,  709,  219,  710,  221,  711,  712,  713,  714,
  715,  716,  717,  718,  719,  720,  721,    0,  722,  723,
  724,  725,  726,  727,    0,  728,  729,  730,  242,    0,
  731,    0,  732,  733,  734,  735,  736,  249,  250,  737,
  252,  738,  739,  740,  256,  741,  258,  742,  260,  743,
    0,  744,  745,  746,  747,    0,  748,  749,  750,  269,
  751,    0,  752,  753,  273,  754,  275,  276,  755,  278,
  279,  280,  281,  282,  283,    0,  756,  285,  286,  287,
  288,  289,    0,  757,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  113,    0,  114,    0,    0,    0,    0,    0,
  116,    0,  662,  117,  118,    0,    0,    0,    0,  663,
    0,    0,    0,    0,    0,  119,  120,    0,  121,    0,
  122,  664,    0,  123,    0,    0,  124,  665,  666,    0,
    0,    0,    0,  126,    0,  127,  128,    0,    0,    0,
  129,    0,    0,  130,    0, 1038,  132,    0,    0,    0,
    0,    0,    0,    0,  667,    0,  133,  668,    0,    0,
    0,    0,  135,    0,  136,    0,  137,    0,    0,    0,
    0,    0,  139,    0,  140,    0,    0,    0,  141,    0,
    0,    0,  669,    0,  670,  671,  142,    0,  672,    0,
  143,    0,    0,  144,  673,    0,    0,  674,  145,  146,
    0,    0,    0,    0,    0, 1039,    0,    0,    0,    0,
    0,  147,    0,    0,    0,  148,  149,  150,  151,  152,
    0,  153,    0,  675,    0,    0,    0,  154,    0,  155,
  156,    0,    0,  158,  159,    0,    0,    0,  676,    0,
    0,  160,    0,    0,  162,  163, 1040,  165,    0,  166,
    0,  167,  677,  168,  169,  170,  171,  172,  678,    0,
    0,    0,  173,    0,  174,    0,    0,    0,  679,    0,
    0,  814,    0,  814,  814,  176,  814,    0,    0,    0,
  177,  178,  680,  681,  682,  683,  422,  423,  180,  814,
  181,  182,  183,  184,  814,  185,  684,    0,    0,    0,
    0,    0,    0,  186,  187,  685,  686,  687,  688,  689,
  690,  691,  692,  693,  188,  694,    0,  190,  191,  192,
  695,  696,    0,  697,  698,  699,    0,  195,  196,  700,
  197,    0,    0,  198,  199, 1041, 1042, 1043,  203,  204,
    0,    0,    0,    0,  205,  701,  207,    0,  702,  209,
  210,    0,  211,    0,  703,  704,  705,    0,  706,  707,
    0,  708,  212,  213,  214,  215,  216,  217,  709,  219,
  710,  221,  711,  712,  713,  714,  715,  716,  717,  718,
  719,  720,  721,    0,  722,  723,  724,  725,  726,  727,
    0,  728,  729,  730,  242,    0,  731,    0,  732,  733,
  734,  735,  736,  249,  250,  737,  252,  738,  739,  740,
  256,  741,  258,  742,  260,  743,    0,  744,  745,  746,
  747,    0,  748,  749,  750,  269,  751,    0,  752,  753,
  273,  754,  275,  276,  755,  278,  279,  280,  281,  282,
  283,    0,  756,  285,  286,  287,  288,  289,    0,  757,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  814,    0,
  814,  814,    0,    0,    0,    0,  814,    0,  814,  814,
  814,    0,    0,    0,    0,  814,    0,    0,    0,    0,
    0,  814,  814,    0,  814,    0,  814,  814,    0,  814,
    0,    0,  814,  814,  814,    0,    0,    0,    0,  814,
  814,  814,  814,    0,    0,    0,  814,    0,    0,  814,
    0,    0,  814,    0,    0,    0,    0,    0,    0,    0,
  814,    0,  814,  814,    0,    0,    0,    0,  814,    0,
  814,    0,  814,    0,    0,    0,    0,    0,  814,    0,
  814,    0,    0,    0,  814,    0,    0,    0,  814,    0,
  814,  814,  814,    0,  814,    0,  814,    0,    0,  814,
  814,    0,    0,  814,  814,  814,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  814,    0,    0,
    0,  814,  814,  814,  814,  814,    0,  814,    0,  814,
    0,    0,    0,  814,    0,  814,  814,    0,    0,  814,
  814,    0,    0,    0,  814,    0,    0,  814,    0,    0,
  814,  814,  814,  814,    0,  814,    0,  814,  814,  814,
  814,  814,  814,  814,  814,    0,    0,    0,  814,    0,
  814,    0,    0,    0,  814,    0,    0, 1081,    0,    0,
  758,  814,  759,    0,    0,    0,  814,  814,  814,  814,
  814,  814,  814,  814,  814,  761,  814,  814,  814,  814,
  762,  814,  814,    0,    0,    0,    0,    0,    0,  814,
  814,  814,  814,  814,  814,  814,  814,  814,  814,  814,
  814,  814,    0,  814,  814,    0,  814,  814,    0,  814,
  814,  814,    0,  814,  814,  814,  814,    0,    0,  814,
  814,  814,  814,  814,  814,  814,    0,    0,    0,    0,
  814,  814,  814,    0,  814,  814,  814,    0,  814,    0,
  814,  814,  814,    0,  814,  814,    0,  814,  814,  814,
  814,  814,  814,  814,  814,  814,  814,  814,  814,  814,
  814,  814,  814,  814,  814,  814,  814,  814,  814,    0,
  814,  814,  814,  814,  814,  814,    0,  814,  814,  814,
  814,    0,  814,    0,  814,  814,  814,  814,  814,  814,
  814,  814,  814,  814,  814,  814,  814,  814,  814,  814,
  814,  814,    0,  814,  814,  814,  814,    0,  814,  814,
  814,  814,  814,    0,  814,  814,  814,  814,  814,  814,
  814,  814,  814,  814,  814,  814,  814,    0,  814,  814,
  814,  814,  814,  814,    0,  814,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  113,    0,  114,    0,    0,    0,
    0,    0,  116,    0,  662,  117,  118,    0,    0,    0,
    0,  663,    0,    0,    0,    0,    0,  119,  120,    0,
  121,    0,  122,  664,    0,  123,    0,    0,  124,  665,
  666,    0,    0,    0,    0,  126,    0,  127,  128,    0,
    0,    0,  129,    0,    0,  130,    0,    0,  132,    0,
    0,    0,    0,  978,    0,    0,  667,    0,  133,  668,
    0,    0,    0,    0,  135,    0,  136,    0,  137,    0,
    0,    0,    0,    0,  139,    0,  140,    0,    0,    0,
  141,    0,    0,    0,  669,    0,  670,  671,  142,    0,
  672,    0,  143,    0,  978,  144,  673,  978,    0,  674,
  145,  146,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  978,  147,    0,    0,    0,  148,  149,  150,
  151,  152,    0,  153,    0,  675,    0,    0,    0,  154,
    0,  155,  156,    0,    0,  158,  159,    0,    0,    0,
  676,    0,    0,  160,    0,    0,  162,  163,  164,  165,
    0,  166,    0,  167,  677,  168,  169,  170,  171,  172,
  678,    0,    0,    0,  173,    0,  174,    0,    0,    0,
  679,    0,    0,    0,    0,    0,    0,  176, 1080,    0,
    0,    0,  177,  178,  680,  681,  682,  683,  422,  423,
  180,    0,  181,  182,  183,  184,    0,  185,  684,    0,
    0,    0,    0,    0,    0,  186,  187,  685,  686,  687,
  688,  689,  690,  691,  692,  693,  188,  694,    0,  190,
  191,  192,  695,  696,    0,  697,  698,  699,    0,  195,
  196,  700,  197,    0,    0,  198,  199,  200,  201,  202,
  203,  204,    0,    0,    0,    0,  205,  701,  207,    0,
  702,  209,  210,    0,  211,    0,  703,  704,  705,    0,
  706,  707,    0,  708,  212,  213,  214,  215,  216,  217,
  709,  219,  710,  221,  711,  712,  713,  714,  715,  716,
  717,  718,  719,  720,  721,    0,  722,  723,  724,  725,
  726,  727,    0,  728,  729,  730,  242,    0,  731,    0,
  732,  733,  734,  735,  736,  249,  250,  737,  252,  738,
  739,  740,  256,  741,  258,  742,  260,  743,    0,  744,
  745,  746,  747,    0,  748,  749,  750,  269,  751,    0,
  752,  753,  273,  754,  275,  276,  755,  278,  279,  280,
  281,  282,  283,    0,  756,  285,  286,  287,  288,  289,
 1081,  757,    0,  758,    0,  759,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  978,  761,    0,
  978,    0,    0,  762,    0,    0,    0,  978,    0,  978,
    0,    0,    0,  978,    0,    0,    0,    0,  978,    0,
    0,  978,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  978,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  978,
    0,    0,    0,    0,    0,    0,    0,  978,    0,    0,
  978,  978,    0,    0,    0,    0,    0,    0,    0,    0,
  978,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  978,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  978,    0,
    0,    0,    0,  978,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  978,  978,    0,  978,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  978,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  978,    0,    0,    0,  978,    0,  113,    0,  114,
    0,    0,    0,    0,    0,  116,    0,  662,  117,  118,
  978,    0,    0,    0,  663,    0,    0,    0,    0,    0,
  119,  120,    0,  121,    0,  122,  664,    0,  123,    0,
    0,  124,  665,  666,    0,    0,    0,    0,  126,    0,
  127,  128,    0,    0,    0,  129,    0,    0,  130,    0,
    0,  132,    0,    0,    0,    0,    0,    0,    0,  667,
    0,  133,  668,    0,    0,    0,    0,  135,    0,  136,
    0,  137,    0,    0,    0,    0,    0,  139,    0,  140,
    0,    0,    0,  141,    0,    0,    0,  669,    0,  670,
  671,  142,    0,  672,    0,  143,    0,    0,  144,  673,
    0,    0,  674,  145,  146,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  147,    0,    0,    0,
  148,  149,  150,  151,  152,    0,  153,    0,  675,    0,
    0,    0,  154,    0,  155,  156,    0,    0,  158,  159,
    0,    0,    0,  676,    0,    0,  160,    0,    0,  162,
  163,  164,  165,    0,  166,    0,  167,  677,  168,  169,
  170,  171,  172,  678,    0,    0,    0,  173,    0,  174,
    0,    0,    0,  679,    0,    0, 1081,    0, 1207,  758,
  176,  759,    0,    0,   16,  177,  178,  680,  681,  682,
  683,  422,  423,  180,  761,  181,  182,  183,  184,  762,
  185,  684,    0,    0,    0,    0,    0,    0,  186,  187,
  685,  686,  687,  688,  689,  690,  691,  692,  693,  188,
  694,    0,  190,  191,  192,  695,  696,    0,  697,  698,
  699,    0,  195,  196,  700,  197,    0,    0,  198,  199,
  200,  201,  202,  203,  204,    0,    0,    0,    0,  205,
  701,  207,    0,  702,  209,  210,    0,  211,    0,  703,
  704,  705,    0,  706,  707,    0,  708,  212,  213,  214,
  215,  216,  217,  709,  219,  710,  221,  711,  712,  713,
  714,  715,  716,  717,  718,  719,  720,  721,    0,  722,
  723,  724,  725,  726,  727,    0,  728,  729,  730,  242,
    0,  731,    0,  732,  733,  734,  735,  736,  249,  250,
  737,  252,  738,  739,  740,  256,  741,  258,  742,  260,
  743,    0,  744,  745,  746,  747,    0,  748,  749,  750,
  269,  751,    0,  752,  753,  273,  754,  275,  276,  755,
  278,  279,  280,  281,  282,  283,    0,  756,  285,  286,
  287,  288,  289,    0,  757,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  113,    0,  114,    0,    0,    0,    0,
    0,  116,    0,  662,  117,  118,    0,    0,    0,    0,
  663,    0,    0,    0,    0,    0,  119,  120,    0,  121,
    0,  122,  664,    0,  123,    0,    0,  124,  665,  666,
    0,    0,    0,    0,  126,    0,  127,  128,    0,    0,
    0,  129,    0,    0,  130,    0,    0,  132,    0,    0,
    0,    0,    0,    0,    0,  667,    0,  133,  668,    0,
    0,    0,    0,  135,    0,  136,    0,  137,    0,    0,
    0,    0,    0,  139,    0,  140,    0,    0,    0,  141,
    0,    0,    0,  669,    0,  670,  671,  142,    0,  672,
    0,  143,    0,    0,  144,  673,    0,    0,  674,  145,
  146,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  147,    0,    0,    0,  148,  149,  150,  151,
  152,    0,  153,    0,  675,    0,    0,    0,  154,    0,
  155,  156,    0,    0,  158,  159,    0,    0,    0,  676,
    0,    0,  160,    0,    0,  162,  163,  164,  165,    0,
  166,    0,  167,  677,  168,  169,  170,  171,  172,  678,
    0,    0,    0,  173,    0,  174,    0,    0,    0,  679,
    0,    0, 1081, 1457,    0,  758,  176,  759,    0,    0,
    0,  177,  178,  680,  681,  682,  683,  422,  423,  180,
  761,  181,  182,  183,  184,  762,  185,  684,    0,    0,
    0,    0,    0,    0,  186,  187,  685,  686,  687,  688,
  689,  690,  691,  692,  693,  188,  694,    0,  190,  191,
  192,  695,  696,    0,  697,  698,  699,    0,  195,  196,
  700,  197,    0,    0,  198,  199,  200,  201,  202,  203,
  204,    0,    0,    0,    0,  205,  701,  207,    0,  702,
  209,  210,    0,  211,    0,  703,  704,  705,    0,  706,
  707,    0,  708,  212,  213,  214,  215,  216,  217,  709,
  219,  710,  221,  711,  712,  713,  714,  715,  716,  717,
  718,  719,  720,  721,    0,  722,  723,  724,  725,  726,
  727,    0,  728,  729,  730,  242,    0,  731,    0,  732,
  733,  734,  735,  736,  249,  250,  737,  252,  738,  739,
  740,  256,  741,  258,  742,  260,  743,    0,  744,  745,
  746,  747,    0,  748,  749,  750,  269,  751,    0,  752,
  753,  273,  754,  275,  276,  755,  278,  279,  280,  281,
  282,  283,    0,  756,  285,  286,  287,  288,  289,    0,
  757,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  113,
    0,  114,    0,    0,    0,    0,    0,  116,    0,  662,
  117,  118,    0,    0,    0,    0,  663,    0,    0,    0,
    0,    0,  119,  120,    0,  121,    0,  122,  664,    0,
  123,    0,    0,  124,  665,  666,    0,    0,    0,    0,
  126,    0,  127,  128,    0,    0,    0,  129,    0,    0,
  130,    0,    0,  132,    0,    0,    0,    0,    0,    0,
    0,  667,    0,  133,  668,    0,    0,    0,    0,  135,
    0,  136,    0,  137,    0,    0,    0,    0,    0,  139,
    0,  140,    0,    0,    0,  141,    0,    0,    0,  669,
    0,  670,  671,  142,    0,  672,    0,  143,    0,    0,
  144,  673,    0,    0,  674,  145,  146,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  147,    0,
    0,    0,  148,  149,  150,  151,  152,    0,  153,    0,
  675,    0,    0,    0,  154,    0,  155,  156,    0,    0,
  158,  159,    0,    0,    0,  676,    0,    0,  160,    0,
    0,  162,  163,  164,  165,    0,  166,    0,  167,  677,
  168,  169,  170,  171,  172,  678,    0,    0,    0,  173,
    0,  174,    0,    0,    0,  679,    0,    0, 1081,    0,
    0,  758,  176,  759,    0,    0,    0,  177,  178,  680,
  681,  682,  683,  422,  423,  180,  761,  181,  182,  183,
  184,  762,  185,  684,    0,    0,    0,    0,    0,    0,
  186,  187,  685,  686,  687,  688,  689,  690,  691,  692,
  693,  188,  694,    0,  190,  191,  192,  695,  696,    0,
  697,  698,  699,    0,  195,  196,  700,  197,    0,    0,
  198,  199,  200,  201,  202,  203,  204,    0,    0,    0,
    0,  205,  701,  207,    0,  702,  209,  210,    0,  211,
    0,  703,  704,  705,    0,  706,  707,    0,  708,  212,
  213,  214,  215,  216,  217,  709,  219,  710,  221,  711,
  712,  713,  714,  715,  716,  717,  718,  719,  720,  721,
    0,  722,  723,  724,  725,  726,  727,    0,  728,  729,
  730,  242,    0,  731,    0,  732,  733,  734,  735,  736,
  249,  250,  737,  252,  738,  739,  740,  256,  741,  258,
  742,  260,  743,    0,  744,  745,  746,  747,    0,  748,
  749,  750,  269,  751,    0,  752,  753,  273,  754,  275,
  276,  755,  278,  279,  280,  281,  282,  283,    0,  756,
  285,  286,  287,  288,  289,    0,  757,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  113,    0,  114,    0,    0,
    0,    0,    0,  116,    0,  662,  117,  118,    0,    0,
    0,    0,  663,    0,    0,    0,    0,    0,  119,  120,
    0,  121,    0,  122,  664,    0,  123,    0,    0,  124,
  665,  666,    0,    0,    0,    0,  126,    0,  127,  128,
    0,    0,    0,  129,    0,    0,  130,    0,    0,  132,
    0,    0,    0,    0,    0,    0,    0,  667,    0,  133,
  668,    0,    0,    0,    0,  135,    0,  136,    0,  137,
    0,    0,    0,    0,    0,  139,    0,  140,    0,    0,
    0,  141,    0,    0,    0,  669,    0,  670,  671,  142,
    0,  672,    0,  143,    0,    0,  144,  673,    0,    0,
  674,  145,  146,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  147,    0,    0,    0,  148,  149,
  150,  151,  152,    0,  153,    0,  675,    0,    0,    0,
  154,    0,  155,  156,    0,    0,  158,  159,    0,    0,
    0,  676,    0,    0,  160,    0,    0,  162,  163,  164,
  165,    0,  166,    0,  167,  677,  168,  169,  170,  171,
  172,  678,    0,    0,    0,  173,    0,  174,    0,    0,
    0,  679,    0,    0, 1081,    0,    0,  758,  176,  759,
    0,    0, 1711,  177,  178,  680,  681,  682,  683,  422,
  423,  180,  761,  181,  182,  183,  184,  762,  185,  684,
    0,    0,    0,    0,    0,    0,  186,  187,  685,  686,
  687,  688,  689,  690,  691,  692,  693,  188,  694,    0,
  190,  191,  192,  695,  696,    0,  697,  698,  699,    0,
  195,  196,  700,  197,    0,    0,  198,  199,  200,  201,
  202,  203,  204,    0,    0,    0,    0,  205,  701,  207,
    0,  702,  209,  210,    0,  211,    0,  703,  704,  705,
    0,  706,  707,    0,  708,  212,  213,  214,  215,  216,
  217,  709,  219,  710,  221,  711,  712,  713,  714,  715,
  716,  717,  718,  719,  720,  721,    0,  722,  723,  724,
  725,  726,  727,    0,  728,  729,  730,  242,    0,  731,
    0,  732,  733,  734,  735,  736,  249,  250,  737,  252,
  738,  739,  740,  256,  741,  258,  742,  260,  743,    0,
  744,  745,  746,  747,    0,  748,  749,  750,  269,  751,
    0,  752,  753,  273,  754,  275,  276,  755,  278,  279,
  280,  281,  282,  283,    0,  756,  285,  286,  287,  288,
  289,    0,  757,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  113,    0,  114,    0,    0,    0,    0,    0,  116,
    0,  662,  117,  118,    0,    0,    0,    0,  663,    0,
    0,    0,    0,    0,  119,  120,    0,  121,    0,  122,
  664,    0,  123,    0,    0,  124,  665,  666,    0,    0,
    0,    0,  126,    0,  127,  128,    0,    0,    0,  129,
    0,    0,  130,    0,    0,  132,    0,    0,    0,    0,
 1766,    0,    0,  667,    0,  133,  668,    0,    0,    0,
    0,  135,    0,  136,    0,  137,    0,    0,    0,    0,
    0,  139,    0,  140,    0,    0,    0,  141,    0,    0,
    0,  669,    0,  670,  671,  142,    0,  672,    0,  143,
    0,    0,  144,  673,    0,    0,  674,  145,  146,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  147,    0,    0,    0,  148,  149,  150,  151,  152,    0,
  153,    0,  675,    0,    0,    0,  154,    0,  155,  156,
    0,    0,  158,  159,    0,    0,    0,  676,    0,    0,
  160,    0,    0,  162,  163,  164,  165,    0,  166,    0,
  167,  677,  168,  169,  170,  171,  172,  678,    0,    0,
    0,  173,    0,  174,    0,    0,    0,  679,    0,    0,
 1081,    0,    0,  758,  176,  759,    0,    0,    0,  177,
  178,  680,  681,  682,  683,  422,  423,  180,  761,  181,
  182,  183,  184,  762,  185,  684,    0,    0,    0,    0,
    0,    0,  186,  187,  685,  686,  687,  688,  689,  690,
  691,  692,  693,  188,  694,    0,  190,  191,  192,  695,
  696,    0,  697,  698,  699,    0,  195,  196,  700,  197,
    0,    0,  198,  199,  200,  201,  202,  203,  204,    0,
    0,    0,    0,  205,  701,  207,    0,  702,  209,  210,
    0,  211,    0,  703,  704,  705,    0,  706,  707,    0,
  708,  212,  213,  214,  215,  216,  217,  709,  219,  710,
  221,  711,  712,  713,  714,  715,  716,  717,  718,  719,
  720,  721,    0,  722,  723,  724,  725,  726,  727,    0,
  728,  729,  730,  242,    0,  731,    0,  732,  733,  734,
  735,  736,  249,  250,  737,  252,  738,  739,  740,  256,
  741,  258,  742,  260,  743,    0,  744,  745,  746,  747,
    0,  748,  749,  750,  269,  751,    0,  752,  753,  273,
  754,  275,  276,  755,  278,  279,  280,  281,  282,  283,
    0,  756,  285,  286,  287,  288,  289,    0,  757,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  113,    0,  114,
    0,    0,    0,    0,    0,  116,    0,  662,  117,  118,
    0,    0,    0,    0,  663,    0,    0,    0,    0,    0,
  119,  120,    0,  121,    0,  122,  664,    0,  123,    0,
    0,  124,  665,  666,    0,    0,    0,    0,  126,    0,
  127,  128,    0,    0,    0,  129,    0,    0,  130,    0,
    0,  132,    0,    0,    0,    0,    0,    0,    0,  667,
    0,  133,  668,    0,    0,    0,    0,  135,    0,  136,
    0,  137,    0,    0,    0,    0,    0,  139,    0,  140,
    0,    0,    0,  141,    0,    0,    0,  669,    0,  670,
  671,  142,    0,  672,    0,  143,    0,    0,  144,  673,
    0,    0,  674,  145,  146,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  147,    0,    0,    0,
  148,  149,  150,  151,  152,    0,  153,    0,  675,    0,
    0,    0,  154,    0,  155,  156,    0,    0,  158,  159,
    0,    0,    0,  676,    0,    0,  160,    0,    0,  162,
  163,  164,  165,    0,  166,    0,  167,  677,  168,  169,
  170,  171,  172,  678,    0,    0,    0,  173,    0,  174,
    0,    0,    0,  679,    0,    0,  816,    0,  816,  816,
  176,  816,    0,    0, 1973,  177,  178,  680,  681,  682,
  683,  422,  423,  180,  816,  181,  182,  183,  184,  816,
  185,  684,    0,    0,    0,    0,    0,    0,  186,  187,
  685,  686,  687,  688,  689,  690,  691,  692,  693,  188,
  694,    0,  190,  191,  192,  695,  696,    0,  697,  698,
  699,    0,  195,  196,  700,  197,    0,    0,  198,  199,
  200,  201,  202,  203,  204,    0,    0,    0,    0,  205,
  701,  207,    0,  702,  209,  210,    0,  211,    0,  703,
  704,  705,    0,  706,  707,    0,  708,  212,  213,  214,
  215,  216,  217,  709,  219,  710,  221,  711,  712,  713,
  714,  715,  716,  717,  718,  719,  720,  721,    0,  722,
  723,  724,  725,  726,  727,    0,  728,  729,  730,  242,
    0,  731,    0,  732,  733,  734,  735,  736,  249,  250,
  737,  252,  738,  739,  740,  256,  741,  258,  742,  260,
  743,    0,  744,  745,  746,  747,    0,  748,  749,  750,
  269,  751,    0,  752,  753,  273,  754,  275,  276,  755,
  278,  279,  280,  281,  282,  283,    0,  756,  285,  286,
  287,  288,  289,    0,  757,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  816,    0,  816,  816,    0,    0,    0,
    0,  816,    0,  816,  816,  816,    0,    0,    0,    0,
  816,    0,    0,    0,    0,    0,  816,  816,    0,  816,
    0,  816,  816,    0,  816,    0,    0,  816,  816,  816,
    0,    0,    0,    0,  816,  816,  816,  816,    0,    0,
    0,  816,    0,    0,  816,    0,    0,  816,    0,    0,
    0,    0,    0,    0,    0,  816,    0,  816,  816,    0,
    0,    0,    0,  816,    0,  816,    0,  816,    0,    0,
    0,    0,    0,  816,    0,  816,    0,    0,    0,  816,
    0,    0,    0,  816,    0,  816,  816,  816,    0,  816,
    0,  816,    0,    0,  816,  816,    0,    0,  816,  816,
  816,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  816,    0,    0,    0,  816,  816,  816,  816,
  816,    0,  816,    0,  816,    0,    0,    0,  816,    0,
  816,  816,    0,    0,  816,  816,    0,    0,    0,  816,
    0,    0,  816,    0,    0,  816,  816,  816,  816,    0,
  816,    0,  816,  816,  816,  816,  816,  816,  816,  816,
    0,    0,    0,  816,    0,  816,    0,    0,    0,  816,
    0,    0, 1279,    0, 1279, 1279,  816, 1279,    0,    0,
    0,  816,  816,  816,  816,  816,  816,  816,  816,  816,
 1279,  816,  816,  816,  816, 1279,  816,  816,    0,    0,
    0,    0,    0,    0,  816,  816,  816,  816,  816,  816,
  816,  816,  816,  816,  816,  816,  816,    0,  816,    0,
    0,  816,  816,    0,  816,  816,  816,    0,  816,  816,
  816,  816,    0,    0,  816,  816,  816,  816,  816,  816,
  816,    0,    0,    0,    0,  816,  816,  816,    0,  816,
  816,  816,    0,  816,    0,  816,  816,  816,    0,  816,
  816,    0,  816,  816,  816,  816,  816,  816,  816,  816,
  816,  816,  816,  816,  816,  816,  816,  816,  816,  816,
  816,  816,  816,  816,    0,  816,  816,  816,  816,  816,
  816,    0,  816,  816,  816,  816,    0,  816,    0,  816,
  816,  816,  816,  816,  816,  816,  816,  816,  816,  816,
  816,  816,  816,  816,  816,  816,  816,    0,  816,  816,
  816,  816,    0,  816,  816,  816,  816,  816,    0,  816,
  816,  816,  816,  816,  816,  816,  816,  816,  816,  816,
  816,  816,    0,  816,  816,  816,  816,  816,  816,    0,
  816,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1279,
    0, 1279,    0,    0,    0,    0,    0, 1279,    0, 1279,
 1279, 1279,    0,    0,    0,    0, 1279,    0,    0,    0,
    0,    0, 1279, 1279,    0, 1279,    0, 1279, 1279,    0,
 1279,    0,    0, 1279, 1279, 1279,    0,    0,    0,    0,
 1279,    0, 1279, 1279,    0,    0,    0, 1279,    0,    0,
 1279,    0,    0, 1279,    0,    0,    0,    0,    0,    0,
    0, 1279,    0, 1279, 1279,    0,    0,    0,    0, 1279,
    0, 1279,    0, 1279,    0,    0,    0,    0,    0, 1279,
    0, 1279,    0,    0,    0, 1279,    0,    0,    0, 1279,
    0, 1279, 1279, 1279,    0, 1279,    0, 1279,    0,    0,
 1279, 1279,    0,    0, 1279, 1279, 1279,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1279,    0,
    0,    0, 1279, 1279, 1279, 1279, 1279,    0, 1279,    0,
 1279,    0,    0,    0, 1279,    0, 1279, 1279,    0,    0,
 1279, 1279,    0,    0,    0, 1279,    0,    0, 1279,    0,
    0, 1279, 1279, 1279, 1279,    0, 1279,    0, 1279, 1279,
 1279, 1279, 1279, 1279, 1279, 1279,    0,    0,    0, 1279,
    0, 1279,    0,    0,    0, 1279,    0,    0,  760,    0,
    0,  758, 1279,  759,    0,    0,    0, 1279, 1279, 1279,
 1279, 1279, 1279, 1279, 1279, 1279,  761, 1279, 1279, 1279,
 1279,  762, 1279, 1279,    0,    0,    0,    0,    0,    0,
 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,
 1279, 1279, 1279,    0, 1279, 1279, 1279, 1279, 1279,    0,
 1279, 1279, 1279,    0, 1279, 1279, 1279, 1279,    0,    0,
 1279, 1279, 1279, 1279, 1279, 1279, 1279,    0,    0,    0,
    0, 1279, 1279, 1279,    0, 1279, 1279, 1279,    0, 1279,
    0, 1279, 1279, 1279,    0, 1279, 1279,    0, 1279, 1279,
 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,
 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,
    0, 1279, 1279, 1279, 1279, 1279, 1279,    0, 1279, 1279,
 1279, 1279,    0, 1279,    0, 1279, 1279, 1279, 1279, 1279,
 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,
 1279, 1279, 1279,    0, 1279, 1279, 1279, 1279,    0, 1279,
 1279, 1279, 1279, 1279,    0, 1279, 1279, 1279, 1279, 1279,
 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,    0, 1279,
 1279, 1279, 1279, 1279, 1279,    0, 1279,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  113,    0,  114,    0,    0,
    0,    0,    0,  116,    0,  662,  117,  118,    0,    0,
    0,    0,  663,    0,    0,    0,    0,    0,  119,  120,
    0,  121,    0,  122,  664,    0,  123,    0,    0,  124,
  665,  666,    0,    0,    0,    0,  126,    0,  127,  128,
    0,    0,    0,  129,    0,    0,  130,    0,    0,  132,
    0,    0,    0,    0,    0,    0,    0,  667,    0,  133,
  668,    0,    0,    0,    0,  135,    0,  136,    0,  137,
    0,    0,    0,    0,    0,  139,    0,  140,    0,    0,
    0,  141,    0,    0,    0,  669,    0,  670,  671,  142,
    0,  672,    0,  143,    0,    0,  144,  673,    0,    0,
  674,  145,  146,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  147,    0,    0,    0,  148,  149,
  150,  151,  152,    0,  153,    0,  675,    0,    0,    0,
  154,    0,  155,  156,    0,    0,  158,  159,    0,    0,
    0,  676,    0,    0,  160,    0,    0,  162,  163,  164,
  165,    0,  166,    0,  167,  677,  168,  169,  170,  171,
  172,  678,    0,    0,    0,  173,    0,  174,    0,    0,
    0,  679,    0,    0, 1081,    0,    0,  758,  176,  759,
    0,    0,    0,  177,  178,  680,  681,  682,  683,  422,
  423,  180,  761,  181,  182,  183,  184,  762,  185,  684,
    0,    0,    0,    0,    0,    0,  186,  187,  685,  686,
  687,  688,  689,  690,  691,  692,  693,  188,  694,    0,
  190,  191,  192,  695,  696,    0,  697,  698,  699,    0,
  195,  196,  700,  197,    0,    0,  198,  199,  200,  201,
  202,  203,  204,    0,    0,    0,    0,  205,  701,  207,
    0,  702,  209,  210,    0,  211,    0,  703,  704,  705,
    0,  706,  707,    0,  708,  212,  213,  214,  215,  216,
  217,  709,  219,  710,  221,  711,  712,  713,  714,  715,
  716,  717,  718,  719,  720,  721,    0,  722,  723,  724,
  725,  726,  727,    0,  728,  729,  730,  242,    0,  731,
    0,  732,  733,  734,  735,  736,  249,  250,  737,  252,
  738,  739,  740,  256,  741,  258,  742,  260,  743,    0,
  744,  745,  746,  747,    0,  748,  749,  750,  269,  751,
    0,  752,  753,  273,  754,  275,  276,  755,  278,  279,
  280,  281,  282,  283,    0,  756,  285,  286,  287,  288,
  289,    0,  757,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  113,    0,  114,    0,    0,    0,    0,    0,  116,
    0,  662,  117,  118,    0,    0,    0,    0,  663,    0,
    0,    0,    0,    0,  119,  120,    0,  121,    0,  122,
  664,    0,  123,    0,    0,  124,  665,  666,    0,    0,
    0,    0,  126,    0,  127,  128,    0,    0,    0,  129,
    0,    0,  130,    0,    0,  132,    0,    0,    0,    0,
    0,    0,    0,  667,    0,  133,  668,    0,    0,    0,
    0,  135,    0,  136,    0,  137,    0,    0,    0,    0,
    0,  139,    0,  140,    0,    0,    0,  141,    0,    0,
    0,  669,    0,  670,  671,  142,    0,  672,    0,  143,
    0,    0,  144,  673,    0,    0,  674,  145,  146,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  147,    0,    0,    0,  148,  149,  150,  151,  152,    0,
  153,    0,  675,    0,    0,    0,  154,    0,  155,  156,
    0,    0,  158,  159,    0,    0,    0,  676,    0,    0,
  160,    0,    0,  162,  163,  164,  165,    0,  166,    0,
  167,  677,  168,  169,  170,  171,  172,  678,    0,    0,
    0,  173,    0,  174,    0,    0,    0,  679,    0,    0,
 2529,    0,    0,  758,  176,  759,    0,    0,    0,  177,
  178,  680,  681,  682,  683,  422,  423,  180,  761,  181,
  182,  183,  184,  762,  185,  684,    0,    0,    0,    0,
    0,    0,  186,  187,  685,  686,  687,  688,  689,  690,
  691,  692,  693,  188,  694,    0,  190,  191,  192,  695,
  696,    0,  697,  698,  699,    0,  195,  196,  700,  197,
    0,    0,  198,  199,  200,  201,  202,  203,  204,    0,
    0,    0,    0,  205,  701,  207,    0,  702,  209,  210,
    0,  211,    0,  703,  704,  705,    0,  706,  707,    0,
  708,  212,  213,  214,  215,  216,  217,  709,  219,  710,
  221,  711,  712,  713,  714,  715,  716,  717,  718,  719,
  720,  721,    0,  722,  723,  724,  725,  726,  727,    0,
  728,  729,  730,  242,    0,  731,    0,  732,  733,  734,
  735,  736,  249,  250,  737,  252,  738,  739,  740,  256,
  741,  258,  742,  260,  743,    0,  744,  745,  746,  747,
    0,  748,  749,  750,  269,  751,    0,  752,  753,  273,
  754,  275,  276,  755,  278,  279,  280,  281,  282,  283,
    0,  756,  285,  286,  287,  288,  289,    0,  757,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  113,    0,  114,
    0,    0,    0,    0,    0,  116,    0,  662,  117,  118,
    0,    0,    0,    0,  663,    0,    0,    0,    0,    0,
  119,  120,    0,  121,    0,  122,  664,    0,  123,    0,
    0,  124,  665,  666,    0,    0,    0,    0,  126,    0,
  127,  128,    0,    0,    0,  129,    0,    0,  130,    0,
    0,  132,    0,    0,    0,    0,    0,    0,    0,  667,
    0,  133,  668,    0,    0,    0,    0,  135,    0,  136,
    0,  137,    0,    0,    0,    0,    0,  139,    0,  140,
    0,    0,    0,  141,    0,    0,    0,  669,    0,  670,
  671,  142,    0,  672,    0,  143,    0,    0,  144,  673,
    0,    0,  674,  145,  146,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  147,    0,    0,    0,
  148,  149,  150,  151,  152,    0,  153,    0,  675,    0,
    0,    0,  154,    0,  155,  156,    0,    0,  158,  159,
    0,    0,    0,  676,    0,    0,  160,    0,    0,  162,
  163,  164,  165,    0,  166,    0,  167,  677,  168,  169,
  170,  171,  172,  678,    0,    0,    0,  173,    0,  174,
    0,    0,    0,  679,    0,    0, 1081,    0,    0,  758,
  176,  759,    0,    0,    0,  177,  178,  680,  681,  682,
  683,  422,  423,  180,  761,  181,  182,  183,  184,  762,
  185,  684,    0,    0,    0,    0,    0,    0,  186,  187,
  685,  686,  687,  688,  689,  690,  691,  692,  693,  188,
  694,    0,  190,  191,  192,  695,  696,    0,  697,  698,
  699,    0,  195,  196,  700,  197,    0,    0,  198,  199,
  200,  201,  202,  203,  204,    0,    0,    0,    0,  205,
  701,  207,    0,  702,  209,  210,    0,  211,    0,  703,
  704,  705,    0,  706,  707,    0,  708,  212,  213,  214,
  215,  216,  217,  709,  219,  710,  221,  711,  712,  713,
  714,  715,  716,  717,  718,  719,  720,  721,    0,  722,
  723,  724,  725,  726,  727,    0,  728,  729,  730,  242,
    0,  731,    0,  732,  733,  734,  735,  736,  249,  250,
  737,  252,  738,  739,  740,  256,  741,  258,  742,  260,
  743,    0,  744,  745,  746,  747,    0,  748,  749,  750,
  269,  751,    0,  752,  753,  273,  754,  275,  276,  755,
  278,  279,  280,  281,  282,  283,    0,  756,  285,  286,
  287,  288,  289,    0,  757,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  113,    0,  114,    0,    0,    0,    0,
    0,  116,    0,  662,  117,  118,    0,    0,    0,    0,
  663,    0,    0,    0,    0,    0,  119,  120,    0,  121,
    0,  122,  664,    0,  123,    0,    0,  124,  665,  666,
    0,    0,    0,    0,  126,    0,  127,  128,    0,    0,
    0,  129,    0,    0,  130,    0,    0,  132,    0,    0,
    0,    0,    0,    0,    0,  667,    0,  133,  668,    0,
    0,    0,    0,  135,    0,  136,    0,  137,    0,    0,
    0,    0,    0,  139,    0,  140,    0,    0,    0,  141,
    0,    0,    0,  669,    0,  670,  671,  142,    0,  672,
    0,  143,    0,    0,  144,  673,    0,    0,  674,  145,
  146,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  147,    0,    0,    0,  148,  149,  150,  151,
  152,    0,  153,    0,  675,    0,    0,    0,  154,    0,
  155,  156,    0,    0,  158,  159,    0,    0,    0,  676,
    0,    0,  160,    0,    0,  162,  163,  164,  165,    0,
  166,    0,  167,  677,  168,  169,  170,  171,  172,  678,
    0,    0,    0,  173,    0,  174,    0,    0,    0,  679,
    0,    0, 1279,    0,    0, 1279,  176, 1279,    0,    0,
    0,  177,  178,  680,  681,  682,  683,  422,  423,  180,
 1279,  181,  182,  183,  184, 1279,  185,  684,    0,    0,
    0,    0,    0,    0,  186,  187,  685,  686,  687,  688,
  689,  690,  691,  692,  693,  188,  694,    0,  190,  191,
  192,  695,  696,    0,  697,  698,  699,    0,  195,  196,
  700,  197,    0,    0,  198,  199,  200,  201,  202,  203,
  204,    0,    0,    0,    0,  205,  701,  207,    0,  702,
  209,  210,    0,  211,    0,  703,  704,  705,    0,  706,
  707,    0,  708,  212,  213,  214,  215,  216,  217,  709,
  219,  710,  221,  711,  712,  713,  714,  715,  716,  717,
  718,  719,  720,  721,    0,  722,  723,  724,  725,  726,
  727,    0,  728,  729,  730,  242,    0,  731,    0,  732,
  733,  734,  735,  736,  249,  250,  737,  252,  738,  739,
  740,  256,  741,  258,  742,  260,  743,    0,  744,  745,
  746,  747,    0,  748,  749,  750,  269,  751,    0,  752,
  753,  273,  754,  275,  276,  755,  278,  279,  280,  281,
  282,  283,    0,  756,  285,  286, 2589,  288,  289,    0,
  757,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1279,
    0, 1279,    0,    0,    0,    0,    0, 1279,    0, 1279,
 1279, 1279,    0,    0,    0,    0, 1279,    0,    0,    0,
    0,    0, 1279, 1279,    0, 1279,    0, 1279, 1279,    0,
 1279,    0,    0, 1279, 1279, 1279,    0,    0,    0,    0,
 1279,    0, 1279, 1279,    0,    0,    0, 1279,    0,    0,
 1279,    0,    0, 1279,    0,    0,    0,    0,    0,    0,
    0, 1279,    0, 1279, 1279,    0,    0,    0,    0, 1279,
    0, 1279,    0, 1279,    0,    0,    0,    0,    0, 1279,
    0, 1279,    0,    0,    0, 1279,    0,    0,    0, 1279,
    0, 1279, 1279, 1279,    0, 1279,    0, 1279,    0,    0,
 1279, 1279,    0,    0, 1279, 1279, 1279,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1279,    0,
    0,    0, 1279, 1279, 1279, 1279, 1279,    0, 1279,    0,
 1279,    0,    0,    0, 1279,    0, 1279, 1279,  887,    0,
 1279, 1279,    0,    0,    0, 1279,    0,    0, 1279,    0,
    0, 1279, 1279, 1279, 1279,    0, 1279,    0, 1279, 1279,
 1279, 1279, 1279, 1279, 1279, 1279,    0,    0,    0, 1279,
    0, 1279,    0,    0,    0, 1279,    0,    0,    0,    0,
    0,    0, 1279,    0,    0,    0,    0, 1279, 1279, 1279,
 1279, 1279, 1279, 1279, 1279, 1279,    0, 1279, 1279, 1279,
 1279,    0, 1279, 1279,    0,    0,    0,    0,    0,    0,
 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,
 1279, 1279, 1279,    0, 1279, 1279, 1279, 1279, 1279,    0,
 1279, 1279, 1279,    0, 1279, 1279, 1279, 1279,    0,    0,
 1279, 1279, 1279, 1279, 1279, 1279, 1279,    0,    0,    0,
    0, 1279, 1279, 1279,    0, 1279, 1279, 1279,    0, 1279,
    0, 1279, 1279, 1279,    0, 1279, 1279,    0, 1279, 1279,
 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,
 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,
    0, 1279, 1279, 1279, 1279, 1279, 1279,    0, 1279, 1279,
 1279, 1279,    0, 1279,    0, 1279, 1279, 1279, 1279, 1279,
 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,
 1279, 1279, 1279,    0, 1279, 1279, 1279, 1279,    0, 1279,
 1279, 1279, 1279, 1279,    0, 1279, 1279, 1279, 1279, 1279,
 1279, 1279, 1279, 1279, 1279, 1279, 1279, 1279,    0, 1279,
 1279, 1279, 1279, 1279, 1279, 1470, 1279, 1470,    0,    0,
    0,    0,    0, 1470,    0,    0, 1470, 1470,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1470, 1470,
    0, 1470,    0, 1470,    0,    0, 1470,    0,    0, 1470,
    0,    0,    0,    0,    0,    0, 1470,    0, 1470, 1470,
    0,    0,    0, 1470,    0,    0, 1470,    0,    0, 1470,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1470,
 1470,    0,    0,    0,    0, 1470,    0, 1470,    0, 1470,
 1470,    0,    0,    0,    0, 1470,    0, 1470,    0,    0,
    0, 1470,    0,    0,    0,    0,    0,    0,    0, 1470,
    0,    0,    0, 1470,    0,    0, 1470,    0,    0,    0,
    0, 1470, 1470,    0, 1470,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1470,    0, 1470,    0, 1470, 1470,
 1470, 1470, 1470,    0, 1470,    0,    0,    0,    0,    0,
 1470,    0, 1470, 1470,    0,    0, 1470, 1470,    0,    0,
    0,    0,    0, 1446, 1470,    0,    0, 1470, 1470, 1470,
 1470,    0, 1470,    0, 1470,    0, 1470, 1470, 1470, 1470,
 1470,  761,    0,    0,    0, 1470,    0, 1470,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1470,    0,
    0,    0,    0, 1470, 1470,    0,    0,    0, 1470,    0,
    0, 1470,    0, 1470, 1470, 1470, 1470,    0, 1470,    0,
    0,    0,    0,    0,    0,    0, 1470, 1470,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1470, 1470,    0,
 1470, 1470, 1470,    0,    0,    0,    0, 1470, 1470,    0,
 1470, 1470,    0, 1470,    0,    0, 1470, 1470, 1470, 1470,
 1470, 1470, 1470,    0,    0,    0,    0, 1470, 1470, 1470,
    0, 1470, 1470, 1470,    0, 1470,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1470, 1470, 1470, 1470, 1470,
 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
 1470, 1470, 1470, 1470, 1470, 1470,    0, 1470, 1470, 1470,
 1470, 1470, 1470,    0, 1470, 1470, 1470, 1470,    0, 1470,
    0, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,    0,
 1470, 1470, 1470, 1470,    0, 1470, 1470, 1470, 1470, 1470,
    0, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470, 1470,
 1470, 1470, 1470, 1470,    0, 1470, 1470, 1470, 1470, 1470,
 1470,    0, 1470,    0,    0,    0,    0,    0,    0,    0,
  113,    0,  114,    0,    0,    0,    0,    0,  116,    0,
    0,  117,  118,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  119,  120,    0,  121,    0,  122,    0,
    0,  123,    0,    0,  124,    0,    0,    0,    0,    0,
    0,  126,    0,  127,  128,    0,    0,    0,  129,    0,
    0,  130,    0,    0,  132,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  133,  134,    0,    0,    0,    0,
  135,    0,  136,    0,  137,    0,    0,    0,    0,    0,
  139,    0,  140,    0,    0,    0,  141,    0,    0,    0,
    0,    0,    0,    0,  142,    0,    0,    0,  143,    0,
    0,  144,    0,    0,    0,    0,  145,  146,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  147,
    0,    0,    0,  148,  149,  150,  151,  152,    0,  153,
    0,    0,    0,    0,    0,  154,    0,  155,  156, 1149,
    0,  158,  159,    0,    0,    0,    0,    0,    0,  160,
    0,    0,  162,  163,  164,  165,    0,  166,    0,  167,
    0,  168,  169,  170,  171,  172,    0,    0,    0,    0,
  173,    0,  174,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  176,    0,    0,    0,    0,  177,  178,
    0,    0,    0,  179,    0,    0,  180,    0,  181,  182,
  183,  184,    0,  185,    0,    0,    0,    0,    0,    0,
    0,  186,  187,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  188,  189,    0,  190,  191,  192,    0,    0,
    0,    0,  193,  194,    0,  195,  196,    0,  197,    0,
    0,  198,  199,  200,  201,  202,  203,  204,    0,    0,
    0,    0,  205,  206,  207,    0,  208,  209,  210,    0,
  211,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
  222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
  232,    0,  233,  234,  235,  236,  237,  238,    0,  239,
  240,  241,  242,    0,  243,    0,  244,  245,  246,  247,
  248,  249,  250,  251,  252,  253,  254,  255,  256,  257,
  258,  259,  260,  261,    0,  262,  263,  264,  265,    0,
  266,  267,  268,  269,  270,    0,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,    0,
  284,  285,  286,  287,  288,  289,  113,  290,  114,    0,
    0,    0,    0,    0,  116,    0,    0,  117,  118,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  119,
  120,    0,  121,    0,  122,    0,    0,  123,    0,    0,
  124,    0,    0,    0,    0,    0,    0,  126,    0,  127,
  128,    0,    0,    0,  129,    0,    0,  130,    0,    0,
  132,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  133,  134,    0,    0,    0,    0,  135,    0,  136,    0,
  137,    0,    0,    0,    0,    0,  139,    0,  140,    0,
    0,    0,  141,    0,    0,    0,    0,    0,    0,    0,
  142,    0,    0,    0,  143,    0,    0,  144,    0,    0,
    0,    0,  145,  146,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  147,    0,    0,    0,  148,
  149,  150,  151,  152,    0,  153,    0,    0,    0,    0,
    0,  154,    0,  155,  156, 1149,    0,  158,  159,    0,
    0,    0,    0,    0,    0,  160,    0,    0,  162,  163,
  164,  165,    0,  166,    0,  167,    0,  168,  169,  170,
  171,  172,    0,    0,    0,    0,  173,    0,  174,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  176,
    0,    0,    0,   16,  177,  178,    0,    0,    0,  179,
    0,    0,  180,    0,  181,  182,  183,  184,    0,  185,
    0,    0,    0,    0,    0,    0,    0,  186,  187,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  188,  189,
    0,  190,  191,  192,    0,    0,    0,    0,  193,  194,
    0,  195,  196,    0,  197,    0,    0,  198,  199,  200,
  201,  202,  203,  204,    0,    0,    0,    0,  205,  206,
  207,    0,  208,  209,  210,    0,  211,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  212,  213,  214,  215,
  216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,    0,  233,  234,
  235,  236,  237,  238,    0,  239,  240,  241,  242,    0,
  243,    0,  244,  245,  246,  247,  248,  249,  250,  251,
  252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
    0,  262,  263,  264,  265,    0,  266,  267,  268,  269,
  270,    0,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,    0,  284,  285,  286,  287,
  288,  289,  113,  290,  114,    0,    0,    0,    0,    0,
  116,    0,    0,  117,  118,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  119,  120,    0,  121,    0,
  122,    0,    0,  123,    0,    0,  124,    0,    0,    0,
    0,    0,    0,  126,    0,  127,  128,    0,    0,    0,
  129,    0,    0,  130,    0,    0,  132,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  133,  134,    0,    0,
    0,    0,  135,    0,  136,    0,  137,    0,    0,    0,
    0,    0,  139,    0,  140,    0,    0,    0,  141,    0,
    0,    0,    0,    0,    0,    0,  142,    0,    0,    0,
  143,    0,    0,  144,    0,    0,    0,    0,  145,  146,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  147,    0,    0,    0,  148,  149,  150,  151,  152,
    0,  153,    0,    0,    0,    0,    0,  154,    0,  155,
  156,  487,    0,  158,  159,    0,    0,    0,    0,    0,
    0,  160,    0,    0,  162,  163,  164,  165,    0,  166,
    0,  167,    0,  168,  169,  170,  171,  172,    0,    0,
    0,    0,  173,    0,  174,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  176,    0,    0,    0,    0,
  177,  178,    0,    0,    0,  179,    0,    0,  180,    0,
  181,  182,  183,  184,    0,  185,    0,    0,    0,    0,
    0,    0,    0,  186,  187,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  188,  189,    0,  190,  191,  192,
    0,    0,    0,    0,  193,  194,    0,  195,  196,    0,
  197,    0,    0,  198,  199,  200,  201,  202,  203,  204,
    0,    0,    0,    0,  205,  206,  207,    0,  208,  209,
  210,    0,  211,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  212,  213,  214,  215,  216,  217,  218,  219,
  220,  221,  222,  223,  224,  225,  226,  227,  228,  229,
  230,  231,  232,    0,  233,  234,  235,  236,  237,  238,
    0,  239,  240,  241,  242,    0,  243,    0,  244,  245,
  246,  247,  248,  249,  250,  251,  252,  253,  254,  255,
  256,  257,  258,  259,  260,  261,    0,  262,  263,  264,
  265,    0,  266,  267,  268,  269,  270,    0,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,    0,  284,  285,  286,  287,  288,  289,  113,  290,
  114,    0,    0,    0,    0,    0,  116,    0,    0,  117,
  118,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  119, 1236,    0,  121,    0,  122,    0,    0,  123,
    0,    0,  124,    0,    0,    0,    0,    0,    0,  126,
    0,  127,  128,    0,    0,    0,  129,    0,    0,  130,
    0,    0,  132,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  133,  134,    0,    0,    0,    0,  135,    0,
  136,    0,  137,    0,    0,    0,    0,    0,  139,    0,
  140,    0,    0,    0,  141,    0,    0,    0,    0,    0,
    0,    0,  142,    0,    0,    0,  143,    0,    0,  144,
    0,    0,    0,    0,  145,  146,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  147,    0,    0,
    0,  148,  149,  150,  151,  152,    0,  153,    0,    0,
    0,    0,    0,  154,    0,  155,  156,    0,    0,  158,
  159, 1453,    0,    0,    0,    0,    0,  160,    0,    0,
  162,  163,  164,  165,    0,  166,    0,  167,    0,  168,
  169,  170,  171,  172,    0,    0,    0,    0,  173,    0,
  174,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  176,    0,    0,    0,    0,  177,  178,    0,    0,
    0,  179,    0,    0,  180,    0,  181,  182,  183,  184,
    0,  185,    0,    0,    0,    0,    0,    0,    0,  186,
  187,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  188,  189,    0,  190,  191,  192,    0,    0,    0,    0,
  193,  194,    0,  195,  196,    0,  197,    0,    0,  198,
  199,  200,  201,  202,  203,  204,    0,    0,    0,    0,
  205,  206,  207,    0,  208,  209,  210,    0,  211,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  212,  213,
  214,  215,  216,  217,  218,  219,  220,  221,  222,  223,
  224,  225,  226,  227,  228,  229,  230,  231,  232,    0,
  233,  234,  235,  236,  237,  238,    0,  239,  240,  241,
  242,    0,  243,    0,  244,  245,  246,  247,  248,  249,
  250,  251,  252,  253,  254,  255,  256,  257,  258,  259,
  260,  261,    0,  262,  263,  264,  265,    0,  266,  267,
  268,  269,  270,    0,  271,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,  283,    0,  284,  285,
  286,  287,  288,  289,    0,  290,  113,    0,  114,    0,
    0,    0,    0,    0,  116,    0,    0,  117,  118,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  119,
  120,    0,  121,    0,  122,    0,    0,  123,    0,    0,
  124,    0, 1452,    0,    0,    0,    0,  126,    0,  127,
  128,    0,    0,    0,  129,    0,    0,  130,    0,    0,
  132,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  133,  134,    0,    0,    0,    0,  135,    0,  136,    0,
  137,    0,    0,    0,    0,    0,  139,    0,  140,    0,
    0,    0,  141,    0,    0,    0,    0,    0,    0,    0,
  142,    0,    0,    0,  143,    0,    0,  144,    0,    0,
    0,    0,  145,  146,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  147,    0,    0,    0,  148,
  149,  150,  151,  152,    0,  153,    0,    0,    0,    0,
    0,  154,    0,  155,  156,    0,    0,  158,  159, 1453,
    0,    0,    0,    0,    0,  160,    0,    0,  162,  163,
  164,  165,    0,  166,    0,  167,    0,  168,  169,  170,
  171,  172,    0,    0,    0,    0,  173,    0,  174,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  176,
    0,    0,    0,    0,  177,  178,    0,    0,    0,  179,
    0,    0,  180,    0,  181,  182,  183,  184,    0,  185,
    0,    0,    0,    0,    0,    0,    0,  186,  187,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  188,  189,
    0,  190,  191,  192,    0,    0,    0,    0,  193,  194,
    0,  195,  196,    0,  197,    0,    0,  198,  199,  200,
  201,  202,  203,  204,    0,    0,    0,    0,  205,  206,
  207,    0,  208,  209,  210,    0,  211,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  212,  213,  214,  215,
  216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,    0,  233,  234,
  235,  236,  237,  238,    0,  239,  240,  241,  242,    0,
  243,    0,  244,  245,  246,  247,  248,  249,  250,  251,
  252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
    0,  262,  263,  264,  265,    0,  266,  267,  268,  269,
  270,    0,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,    0,  284,  285,  286,  287,
  288,  289,    0,  290,  113,    0,  114,    0,    0,    0,
    0,    0,  116,    0,    0,  117,  118,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  119,  120,    0,
  121,    0,  122,    0,    0,  123,    0,    0,  124,    0,
    0,    0,    0,    0,    0,  126,    0,  127,  128,    0,
    0,    0,  129,    0,    0,  130,    0,    0,  132,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  133,  134,
    0,    0,    0,    0,  135,    0,  136,    0,  137,    0,
    0,    0,    0,    0,  139,    0,  140,    0,    0,    0,
  141,    0,    0,    0,    0,    0,    0,    0,  142,    0,
    0,    0,  143,    0,    0,  144,    0,    0,    0,    0,
  145,  146,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  147,    0,    0,    0,  148,  149,  150,
  151,  152,    0,  153,    0,    0,    0,    0,    0,  154,
    0,  155,  156,    0,    0,  158,  159,  829,    0,    0,
    0,    0,    0,  160,    0,    0,  162,  163,  164,  165,
    0,  166,    0,  167,    0,  168,  169,  170,  171,  172,
    0,    0,    0,    0,  173,    0,  174,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  176,    0,    0,
    0,    0,  177,  178,    0,    0,    0,  179,    0,    0,
  180,    0,  181,  182,  183,  184,    0,  185,    0,    0,
    0,    0,    0,    0,    0,  186,  187,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  188,  189,    0,  190,
  191,  192,    0,    0,    0,    0,  193,  194,    0,  195,
  196,    0,  197,    0,    0,  198,  199,  200,  201,  202,
  203,  204,    0,    0,    0,    0,  205,  206,  207,    0,
  208,  209,  210,    0,  211,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  212,  213,  214,  215,  216,  217,
  218,  219,  220,  221,  222,  223,  224,  225,  226,  227,
  228,  229,  230,  231,  232,    0,  233,  234,  235,  236,
  237,  238,    0,  239,  240,  241,  242,    0,  243,    0,
  244,  245,  246,  247,  248,  249,  250,  251,  252,  253,
  254,  255,  256,  257,  258,  259,  260,  261,    0,  262,
  263,  264,  265,    0,  266,  267,  268,  269,  270,    0,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,    0,  284,  285,  286,  287,  288,  289,
  832,  290,  832,    0,    0,    0,    0,    0,  832,    0,
    0,  832,  832,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  832,  832,    0,  832,    0,  832,    0,
    0,  832,    0,    0,  832,    0,    0,    0,    0,    0,
    0,  832,    0,  832,  832,    0,    0,    0,  832,    0,
    0,  832,    0,    0,  832,    0,    0,    0,    0,  829,
    0,    0,    0,    0,  832,  832,    0,    0,    0,    0,
  832,    0,  832,    0,  832,    0,    0,    0,    0,    0,
  832,    0,  832,    0,    0,    0,  832,    0,    0,    0,
    0,    0,    0,    0,  832,    0,    0,    0,  832,    0,
    0,  832,    0,    0,    0,    0,  832,  832,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  832,
    0,    0,    0,  832,  832,  832,  832,  832,    0,  832,
    0,    0,    0,    0,    0,  832,    0,  832,  832,    0,
    0,  832,  832,    0, 1031,    0,    0,    0,    0,  832,
    0,    0,  832,  832,  832,  832,    0,  832,    0,  832,
    0,  832,  832,  832,  832,  832,    0,    0,    0,    0,
  832,    0,  832,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  832,    0,    0,    0,    0,  832,  832,
    0,    0,    0,  832,    0,    0,  832,    0,  832,  832,
  832,  832,    0,  832,    0,    0,    0,    0,    0,    0,
    0,  832,  832,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  832,  832,    0,  832,  832,  832,    0,    0,
    0,    0,  832,  832,    0,  832,  832,    0,  832,    0,
    0,  832,  832,  832,  832,  832,  832,  832,    0,    0,
    0,    0,  832,  832,  832,    0,  832,  832,  832,    0,
  832,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  832,  832,  832,  832,  832,  832,  832,  832,  832,  832,
  832,  832,  832,  832,  832,  832,  832,  832,  832,  832,
  832,    0,  832,  832,  832,  832,  832,  832,    0,  832,
  832,  832,  832,    0,  832,    0,  832,  832,  832,  832,
  832,  832,  832,  832,  832,  832,  832,  832,  832,  832,
  832,  832,  832,  832,    0,  832,  832,  832,  832,    0,
  832,  832,  832,  832,  832,    0,  832,  832,  832,  832,
  832,  832,  832,  832,  832,  832,  832,  832,  832,    0,
  832,  832,  832,  832,  832,  832,  113,  832,  114,    0,
    0,    0,    0,    0,  116,    0,    0,  117,  118,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  119,
  120,    0,  121,    0,  122,    0,    0,  123,    0,    0,
  124,    0,    0,    0,    0,    0,    0,  126,    0,  127,
  128,    0,    0,    0,  129,    0,    0,  130,    0,    0,
  132,    0,    0,    0,  845,    0,    0,    0,    0,    0,
  133,  134,    0,    0,    0,    0,  135,    0,  136,    0,
  137,    0,    0,    0,    0,    0,  139,    0,  140,    0,
    0,    0,  141,    0,    0,    0,    0,    0,    0,    0,
  142,    0,    0,    0,  143,  845,    0,  144,  845,    0,
    0,    0,  145,  146,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  845,    0,  147,    0,    0,    0,  148,
  149,  150,  151,  152,    0,  153,    0,    0,    0,  700,
    0,  154,    0,  155,  156,    0,    0,  158,  159,    0,
    0,    0,  690,    0,    0,  160,    0,    0,  162,  163,
  164,  165,    0,  166,    0,  167,    0,  168,  169,  170,
  171,  172,    0,    0,    0,    0,  173,    0,  174,    0,
  700,    0,    0,  700,    0,    0,    0,    0,    0,  176,
    0,    0,    0,  690,  177,  178,  690,  439,  700,  179,
  700,    0,  180,    0,  181,  182,  183,  184,    0,  185,
    0,  690,    0,  690,    0,    0,    0,  186,  187,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  188,  189,
  700,  190,  191,  192,    0,    0,    0,    0,  193,  194,
    0,  195,  196,  690,  197,    0,    0,  198,  199,  200,
  201,  202,  203,  204,    0,    0,    0,    0,  205,  206,
  207,    0,  208,  209,  210,    0,  211,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  212,  213,  214,  215,
  216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,    0,  233,  234,
  235,  236,  237,  238,    0,  239,  240,  241,  242,    0,
  243,    0,  244,  245,  246,  247,  248,  249,  250,  251,
  252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
  675,  262,  263,  264,  265,    0,  266,  267,  268,  269,
  270,    0,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,    0,  284,  285,  286,  287,
  288,  289,    0,  290,    0,    0,    0,    0,    0,    0,
    0,  675,    0,    0,  675,    0,    0,    0,  845,    0,
    0,  845,    0,    0,    0,    0,    0,    0,  845,  675,
  845,  675,    0,    0,  845,    0,    0,  700,    0,  845,
    0,    0,  845,    0,    0,    0,    0,    0,    0,    0,
  690,    0,  700,    0,    0,  700,  700,  845,    0,    0,
  700,  675,    0,  700,    0,  690,    0,    0,  690,  690,
  845,    0,    0,  690,    0,  700,  690,    0,  845,    0,
    0,  700,  845,    0,  700,    0,    0,    0,  690,    0,
    0,  845,    0,    0,  690,    0,    0,  690,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  845,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  700,    0,    0,    0,
    0,    0,    0,    0,  845,    0,    0,    0,    0,  690,
    0,    0,    0,    0,    0,    0,  845,    0,  845,  700,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  690,    0,    0,    0,    0,    0,    0,    0,
  700,    0,    0,    0,    0,    0,  700,    0,    0,    0,
  700,    0,  761,  690,    0,    0,    0,  700,    0,  690,
    0,    0,    0,  690,    0,  845,    0,    0,    0,    0,
  690,    0,    0,    0,    0,  700,    0,    0,    0,    0,
  700,    0,  845,    0,    0,    0,  845,    0,  690,    0,
    0,    0,    0,  690,    0,    0,    0,    0,  675,    0,
    0,  845,    0,    0,    0,  700,    0,    0,    0,  700,
    0,    0,    0,  675,    0,    0,  675,  675,  690,    0,
    0,  675,  690,    0,  675,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  675,    0,    0,    0,
    0,    0,  675,    0,    0,  675,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  675,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  700,    0,
  675,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  690,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  675,    0,    0,    0,    0,    0,  675,    0,    0,
    0,  675,    0,    0,    0,    0,    0,    0,  675,    0,
    0,  113,    0,  114,    0,    0,    0,    0,    0,  116,
    0,    0,  117,  118,    0,    0,  675,    0,    0,    0,
    0,  675,    0,    0,  119,  120,    0,  121,    0,  122,
    0,    0,  123,    0,    0,  124,    0,    0,    0,    0,
    0,    0,  126,    0,  127,  128,  675,    0,    0,  129,
  675,    0,  130,    0,    0,  132,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  133,  134,    0,    0,    0,
    0,  135,    0,  136, 1031,  137,    0,    0,    0,    0,
    0,  139,    0,  140,    0,    0,    0,  141,    0,    0,
    0,    0,    0,    0,    0,  142,    0,    0,    0,  143,
    0,    0,  144,    0,    0,    0,    0,  145,  146,    0,
    0,    0,    0,    0,    0, 1031,    0,    0, 1031,    0,
  147,    0,    0,    0,  148,  149,  150,  151,  152,    0,
  153,    0,    0, 1031,    0,    0,  154,    0,  155,  156,
    0,    0,  158,  159,    0,    0,    0,    0,    0,  675,
  160,    0,    0,  162,  163,  164,  165,    0,  166,    0,
  167,    0,  168,  169,  170,  171,  172,    0,    0,    0,
  998,  173,    0,  174,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  176,    0,    0,    0,    0,  177,
  178,    0,    0,    0,  179,    0,    0,  180,    0,  181,
  182,  183,  184,    0,  185,    0,    0,    0,    0,    0,
    0,  998,  186,  187,  998,    0,    0,    0,    0,    0,
    0,    0,    0,  188,  189,    0,  190,  191,  192,  998,
    0,    0,    0,  193,  194,    0,  195,  196,    0,  197,
    0,    0,  198,  199,  200,  201,  202,  203,  204,    0,
    0,    0,    0,  205,  206,  207,    0,  208,  209,  210,
    0,  211,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  212,  213,  214,  215,  216,  217,  218,  219,  220,
  221,  222,  223,  224,  225,  226,  227,  228,  229,  230,
  231,  232,    0,  233,  234,  235,  236,  237,  238,    0,
  239,  240,  241,  242,    0,  243,    0,  244,  245,  246,
  247,  248,  249,  250,  251,  252,  253,  254,  255,  256,
  257,  258,  259,  260,  261,    0,  262,  263,  264,  265,
  999,  266,  267,  268,  269,  270, 1031,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
    0,  284,  285,  286,  287,  288,  289,    0,  290,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  999,    0,    0,  999, 1025,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1031,  999,
    0, 1031,    0,    0,    0,    0,    0,    0, 1031,    0,
 1031,    0,    0,    0, 1031,    0,    0,    0,    0, 1031,
    0,    0, 1031,    0,    0,    0, 1025,    0,    0, 1025,
    0,    0,    0,    0,    0,    0,    0, 1031,    0,    0,
    0,    0,  998,    0, 1025,    0,    0,    0,    0,    0,
 1031,    0,    0,    0,    0,    0,    0,    0, 1031,    0,
    0, 1031, 1031,    0,    0,    0,    0,    0,    0,    0,
    0, 1031,    0,    0,    0,    0,    0,    0,    0, 1002,
    0,    0,    0,    0,    0,    0,    0, 1031,    0,    0,
    0,    0,    0,    0,  998,    0,    0,  998,    0,    0,
    0,    0,    0,    0,  998,    0,  998,    0,    0, 1031,
  998, 1000,    0,    0, 1031,  998,    0,    0,  998,    0,
 1002,    0,    0, 1002,    0, 1031, 1031,    0, 1031,    0,
    0,    0,    0,  998,    0,    0,    0,    0, 1002,    0,
    0,    0,    0,    0,    0,    0,  998,    0,    0,    0,
    0,    0, 1000,    0,  998, 1000,    0,  998,  998,    0,
    0,    0,    0,    0,    0,    0,    0,  998,    0,    0,
 1000,    0,    0,    0,    0, 1031,    0,    0,    0,    0,
    0,    0,    0,  998,    0,    0,    0,    0,    0,    0,
    0,    0, 1031,    0,    0,    0, 1031,    0,    0,    0,
    0,    0,  999,    0,    0,  998,    0,    0,    0,    0,
  998, 1031,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  998,  998,    0,  998,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1025,    0,    0,
    0,    0,    0,    0,  999,    0,    0,  999,    0,    0,
    0,    0,    0,    0,  999,    0,  999,    0,    0, 1001,
  999,  998,    0,    0,    0,  999,    0,    0,  999,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  998,    0,
    0,    0,  998,  999,    0,    0,    0,    0,    0, 1025,
    0, 1037, 1025,    0,    0,    0,  999,  998,    0, 1025,
 1001, 1025,    0, 1001,  999, 1025,    0,  999,  999,    0,
 1025,    0,    0, 1025,    0,    0,    0,  999, 1001,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1025,    0,
    0, 1002, 1037,  999,    0, 1037,    0,    0,    0,    0,
    0, 1025,    0,    0,    0,    0,    0,    0,    0, 1025,
 1037,    0, 1025, 1025,    0,  999,    0,    0,    0,    0,
  999,    0, 1025, 1000,    0,    0,    0,    0,    0,    0,
    0,  999,  999,    0,  999,    0,    0,    0, 1025,    0,
    0,    0,    0, 1002,    0,  995, 1002,    0,    0,    0,
    0,    0,    0, 1002,    0, 1002,    0,    0,    0, 1002,
 1025,    0,    0,    0, 1002, 1025,    0, 1002,    0,    0,
    0,    0,    0,    0,    0, 1000, 1025, 1025, 1000, 1025,
    0,  999, 1002,    0,    0, 1000,  995, 1000,    0,  995,
  996, 1000,    0,    0,    0, 1002, 1000,    0,  999, 1000,
    0,    0,  999, 1002,  995,    0, 1002, 1002,    0,    0,
    0,    0,    0,    0, 1000,    0, 1002,  999,    0,    0,
    0,    0,    0,    0,    0,    0, 1025, 1000,    0,    0,
    0,  996, 1002,    0,  996, 1000,    0,    0, 1000, 1000,
    0,    0,    0, 1025,    0,    0,    0, 1025, 1000,  996,
    0,    0,    0,    0, 1002,    0,    0,    0,    0, 1002,
    0,    0, 1025,    0, 1000,    0,    0,    0,    0,    0,
 1002, 1002,    0, 1002,    0,    0,    0,    0,    0,    0,
    0, 1001,    0,    0,    0,    0, 1000,    0,  997,    0,
    0, 1000,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1000, 1000,    0, 1000,    0,    0,    0,    0,
    0,    0,    0, 1037,    0,    0,    0,    0,    0,    0,
 1002,    0,    0,    0,    0,    0,    0,    0,    0,  997,
    0,    0,  997, 1001,    0,    0, 1001, 1002,    0,    0,
    0, 1002,    0, 1001,    0, 1001,    0,  997,    0, 1001,
    0,    0, 1000,    0, 1001,    0, 1002, 1001,    0,    0,
    0,    0,    0,    0,    0, 1037,    0,    0, 1037, 1000,
    0,    0, 1001, 1000,    0, 1037,    0, 1037,    0,    0,
    0, 1037,    0,    0,    0, 1001, 1037,    0, 1000, 1037,
    0,    0,    0, 1001,    0,    0, 1001, 1001, 1032,    0,
    0,    0,    0,    0, 1037,    0, 1001,  995,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1037,    0,    0,
    0,    0, 1001,    0,    0, 1037,    0,    0, 1037, 1037,
    0,    0,    0,    0,    0,    0,    0,    0, 1037, 1032,
    0,    0, 1032,    0, 1001,    0,    0,    0,    0, 1001,
    0,    0,  996,    0, 1037,    0,  856, 1032,    0,  995,
 1001, 1001,  995, 1001,    0,    0,    0,    0,    0,  995,
    0,  995,    0,    0,    0,  995, 1037,    0,    0,    0,
  995, 1037,    0,  995,    0,    0,    0,    0,    0,    0,
    0,    0, 1037, 1037, 1026, 1037,    0,  856,  995,    0,
  856,    0,    0,    0,  996,    0,    0,  996,    0,    0,
 1001,  995,    0,    0,  996,  856,  996,    0,    0,  995,
  996,    0,  995,  995,    0,  996,    0, 1001,  996,    0,
    0, 1001,  995,    0,    0, 1026,    0,    0, 1026,    0,
    0,    0, 1037,  996,    0,    0, 1001,    0,  995,    0,
  997,    0,    0, 1026,    0,    0,  996,    0,    0, 1037,
    0,    0,    0, 1037,  996,    0,    0,  996,  996,    0,
  995,    0,    0,    0,    0,  995,    0,  996, 1037,    0,
    0,    0,    0,    0,    0,    0,  995,  995,    0,  995,
    0,    0,    0,  996,    0,    0,    0,    0,    0,    0,
    0,    0,  997,    0, 1038,  997,    0,    0,    0,    0,
    0,    0,  997,    0,  997,  996,    0,    0,  997,    0,
  996,    0,    0,  997,    0,    0,  997,    0,    0,    0,
    0,  996,  996,    0,  996,    0,  995,    0,    0,    0,
    0,  997,    0,    0,    0, 1038,    0,    0, 1038,    0,
    0,    0,    0,  995,  997,    0,    0,  995,    0,    0,
 1032,    0,  997, 1038,    0,  997,  997,    0,    0,    0,
    0,    0,  995,    0,    0,  997,    0,    0,    0,    0,
    0,  996,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  997,    0,    0,    0,    0,    0,    0,  996,    0,
 1039,    0,  996,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1032,  997,    0, 1032,    0,  996,  997,    0,
    0,    0, 1032,    0, 1032,    0,    0,    0, 1032,  997,
  997,    0,  997, 1032,    0,    0, 1032,    0,    0,    0,
    0, 1039,    0,    0, 1039,    0,    0,    0,    0,    0,
    0, 1032,    0,    0,    0,    0, 1026,    0, 1033, 1039,
    0,    0,    0,    0, 1032,    0,    0,    0,    0,    0,
  856,    0, 1032,  856,    0, 1032, 1032,    0,    0,  997,
  856,    0,  856,    0,    0, 1032,  856,    0,    0,    0,
    0,  856,    0,    0,  856,    0,  997,    0,    0, 1033,
  997, 1032, 1033,    0,    0,    0,    0,    0, 1026,  856,
    0, 1026,    0,    0,    0,  997,    0, 1033, 1026,    0,
 1026,    0,  856, 1032, 1026,    0,    0,    0, 1032, 1026,
  856,    0, 1026,    0,  856,    0,    0,    0,    0, 1032,
 1032,    0, 1032,  856,    0,    0,    0, 1026,    0,    0,
    0,    0, 1023,    0,    0,    0,    0,    0,    0,  856,
 1026,    0,    0,    0,    0,    0, 1038,    0, 1026,    0,
    0, 1026, 1026,    0,    0,    0,    0,    0,    0,    0,
    0, 1026,    0,    0,    0,    0,  856,    0,    0, 1032,
    0,    0,    0, 1023,    0,    0, 1023, 1026,  856,    0,
  856,    0,    0,    0,    0,    0, 1032,    0,    0,    0,
 1032, 1023,    0,    0,    0,    0,    0,    0, 1038, 1026,
    0, 1038,    0,    0, 1026, 1032,    0,    0, 1038,    0,
 1038,    0,    0, 1021, 1038, 1026, 1026,    0, 1026, 1038,
    0,    0, 1038,    0,    0,    0,    0,  856,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1038,    0,    0,
    0,    0, 1039,    0,  856,    0,    0,    0,  856,    0,
 1038,    0,    0,    0, 1021,    0,    0, 1021, 1038,    0,
    0, 1038, 1038,  856,    0, 1026,    0,    0,    0,    0,
    0, 1038, 1021,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1026,    0,    0,    0, 1026, 1038,    0,    0,
    0,    0,    0,    0, 1039,    0,    0, 1039,    0,    0,
 1033, 1026,    0,    0, 1039,    0, 1039, 1027,    0, 1038,
 1039,    0,    0,    0, 1038, 1039,    0,    0, 1039,    0,
    0,    0,    0,    0,    0, 1038, 1038,    0, 1038,    0,
    0,    0,    0, 1039,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1039,    0, 1027,    0,
    0, 1027, 1033,    0, 1039, 1033,    0, 1039, 1039,    0,
    0,    0, 1033,    0, 1033,    0, 1027, 1039, 1033,    0,
    0,    0,    0, 1033,    0, 1038, 1033,    0,    0,    0,
    0,    0,    0, 1039,    0,    0,    0,    0, 1040,    0,
    0, 1033, 1038,    0, 1023,    0, 1038,    0,    0,    0,
    0,    0,    0,    0, 1033, 1039,    0,    0,    0,    0,
 1039, 1038, 1033,    0,    0, 1033, 1033,    0,    0,    0,
    0, 1039, 1039,    0, 1039, 1033,    0,    0,    0, 1040,
    0,    0, 1040,    0,    0,    0,    0,    0,    0,    0,
    0, 1033,    0,    0,    0,    0, 1023, 1040,    0, 1023,
    0,    0,    0,    0,    0,    0, 1023,    0, 1023,    0,
    0,    0, 1023, 1033,    0,    0,    0, 1023, 1033,    0,
 1023, 1039,    0,    0,    0, 1021,    0,    0,    0, 1033,
 1033,    0, 1033,    0,    0, 1023,    0,    0, 1039,    0,
    0,    0, 1039,    0,    0,    0,    0,    0, 1023,    0,
    0,    0,    0,    0,    0,    0, 1023, 1039,    0, 1023,
 1023, 1034,    0,    0,    0,    0,    0,    0,    0, 1023,
    0,    0,    0,    0,    0,    0,    0, 1021,    0, 1033,
 1021,    0,    0,    0,    0, 1023,    0, 1021,    0, 1021,
    0,    0,    0, 1021,    0,    0, 1033,    0, 1021,    0,
 1033, 1021, 1034,    0,    0, 1034,    0, 1023,    0,    0,
    0,    0, 1023,    0,    0, 1033, 1021,    0,    0, 1027,
 1034,    0,    0, 1023, 1023,    0, 1023,    0,    0, 1021,
    0,    0,    0,    0,    0,    0,    0, 1021,    0,    0,
 1021, 1021,    0,    0,    0,    0,    0,    0,    0,    0,
 1021,    0,    0,    0,    0, 1022,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1021,    0,    0,    0,
    0, 1027,    0, 1023, 1027,    0,    0,    0,    0,    0,
    0, 1027,    0, 1027,    0,    0,    0, 1027, 1021,    0,
 1023,    0, 1027, 1021, 1023, 1027, 1022,    0,    0, 1022,
 1040,    0,    0,    0, 1021, 1021,    0, 1021,    0, 1023,
 1027,    0,    0,    0, 1022,    0,    0,    0,    0,    0,
    0,    0,    0, 1027,    0,    0,    0,    0,    0,    0,
    0, 1027,    0,    0, 1027, 1027, 1024,    0,    0,    0,
    0,    0,    0,    0, 1027,    0,    0,    0,    0,    0,
    0,    0, 1040,    0, 1021, 1040,    0,    0,    0,    0,
 1027,    0, 1040,    0, 1040,    0,    0,    0, 1040,    0,
    0, 1021,    0, 1040,    0, 1021, 1040, 1024,    0,    0,
 1024,    0, 1027,    0,    0,    0,    0, 1027,    0,    0,
 1021, 1040,    0,    0, 1028, 1024,    0,    0, 1027, 1027,
    0, 1027,    0,    0, 1040,    0,    0,    0,    0,    0,
    0,    0, 1040,    0,    0, 1040, 1040,    0,    0,    0,
    0,    0,    0, 1034,    0, 1040,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1028,    0,    0, 1028,    0,
    0, 1040,    0,    0,    0,    0,    0,    0, 1027,    0,
    0,    0,    0, 1028,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1040,    0, 1027,    0,    0, 1040, 1027,
    0,    0,    0,    0,    0, 1034,    0,    0, 1034, 1040,
 1040,    0, 1040,    0, 1027, 1034,    0, 1034,    0,    0,
 1035, 1034,    0,    0,    0,    0, 1034,    0,    0, 1034,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1034,    0,    0, 1022,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1034,    0, 1040,
    0, 1035,    0,    0, 1035, 1034,    0,    0, 1034, 1034,
    0,    0,    0,    0,    0,    0, 1040,    0, 1034, 1035,
 1040,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1034, 1040,    0,    0,    0, 1022,
    0,    0, 1022,    0,    0,    0,    0,    0,    0, 1022,
    0, 1022,    0,    0, 1036, 1022, 1034,    0,    0,    0,
 1022, 1034,    0, 1022,    0,    0,    0,    0, 1024,    0,
    0,    0, 1034, 1034,    0, 1034,    0,    0, 1022,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1022,    0,    0,    0, 1036,    0,    0, 1036, 1022,
    0,    0, 1022, 1022,    0,    0,    0,    0,    0,    0,
    0,    0, 1022, 1036,    0,    0,    0,    0,    0,    0,
 1024,    0, 1034, 1024,    0,    0, 1028,    0, 1022,    0,
 1024,    0, 1024,    0,    0,    0, 1024,    0,    0, 1034,
    0, 1024,    0, 1034, 1024,    0,    0,    0,    0,    0,
 1022,    0,    0,    0,    0, 1022,  843,    0, 1034, 1024,
    0,    0,    0,    0,    0,    0, 1022, 1022,    0, 1022,
    0,    0, 1024,    0,    0,    0,    0,    0, 1028,    0,
 1024, 1028,    0, 1024, 1024,    0,    0,    0, 1028,    0,
 1028,    0,    0, 1024, 1028,    0,  843,  843,    0, 1028,
  843,    0, 1028,    0,    0,    0,    0,    0,    0, 1024,
    0,    0,    0,    0,    0,  843, 1022, 1028,    0,    0,
    0,    0, 1035,    0,    0,    0,    0,    0,    0,    0,
 1028, 1024,    0, 1022,    0,    0, 1024, 1022, 1028,    0,
    0, 1028, 1028,    0,    0,    0,    0, 1024, 1024,    0,
 1024, 1028, 1022,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1028,    0,    0,
    0,    0,    0,    0, 1035,    0,    0, 1035,    0,    0,
    0,    0,    0,    0, 1035,    0, 1035,    0,    0, 1028,
 1035,    0,    0,    0, 1028, 1035,    0, 1024, 1035,    0,
    0,    0,    0,    0,    0, 1028, 1028,    0, 1028,    0,
    0,    0,    0, 1035, 1024,    0, 1036,    0, 1024,    0,
    0,    0,    0,    0,    0,    0, 1035,    0,    0,    0,
    0,    0,    0, 1024, 1035,    0,    0, 1035, 1035,    0,
    0,    0,    0,    0,    0,    0,    0, 1035,    0,    0,
    0,    0,    0,    0,    0, 1028,    0,    0,    0,    0,
    0,    0,    0, 1035,    0,    0,    0,    0, 1036,    0,
    0, 1036, 1028,    0,    0,    0, 1028,    0, 1036,    0,
 1036,    0,    0,    0, 1036, 1035,    0,    0,    0, 1036,
 1035, 1028, 1036,    0,    0,    0,    0,    0,    0,    0,
    0, 1035, 1035,    0, 1035,    0,    0, 1036,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1036,    0,    0,    0,    0,    0,    0,    0, 1036,    0,
    0, 1036, 1036,    0,    0,    0,    0,    0,    0,    0,
    0, 1036,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1035,    0,    0,    0,    0,    0, 1036,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1035,    0,
  843,    0, 1035,  843,    0,    0,    0,    0,    0, 1036,
  843,    0,  843,    0, 1036,    0,  843, 1035,    0,    0,
    0,  843,    0,    0,  843, 1036, 1036,    0, 1036,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  843,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  843,    0,    0,    0,    0,    0,    0,    0,
  843,    0,    0,    0,  843,    0,    0,    0,    0,    0,
    0,    0,    0,  843,    0, 1036,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  843,
    0,    0, 1036,    0,    0,    0, 1036,    0,  113,    0,
  114,    0,    0,    0,    0,    0,  116,    0,    0,  117,
  118, 1036,    0,    0,    0,    0,  843,    0,    0,    0,
    0,  119,  120,    0,  121,    0,  122,    0,  843,  123,
  843,    0,  124,    0,    0,    0,    0,    0,    0,  126,
    0,  127,  128,    0,    0,    0,  129,    0,    0,  130,
    0,    0,  132,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  133,  134,    0,    0,    0,    0,  135,    0,
  136,    0,  137,    0,    0,    0,    0,  843,  139,    0,
  140,    0,    0,    0,  141,    0,    0,    0,    0,    0,
    0,    0,  142,    0,  843,    0,  143,    0,  843,  144,
    0,    0,    0,    0,  145,  146,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  147,    0,    0,
    0,  148,  149,  150,  151,  152,    0,  153,    0,    0,
    0,    0,    0,  154,    0,  155,  156,    0,    0,  158,
  159,    0,    0,    0,    0,    0,    0,  160,    0,    0,
  162,  163,  164,  165,    0,  166,    0,  167,    0,  168,
  169,  170,  171,  172,    0,    0,    0,    0,  173,    0,
  174,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  176,    0,    0,    0,    0,  177,  178,    0,    0,
    0,  179,    0,    0,  180,  343,  181,  182,  183,  184,
  344,  185,  345,  346,  347,  348,  349,  350,  351,  186,
  187,  352,  353,  354,  355,  356,    0,    0,  357,  358,
  188,  189,  359,  190,  191,  192,  360,  361,  362,  363,
  193,  194,  364,  195,  196,  365,  197,  366,  367,  198,
  199,  200,  201,  202,  203,  204,  368,  369,  370,  371,
  205,  206,  207,  372,  208,  209,  210,  373,  211,  374,
  375,  376,  377,  378,  379,  380,  381,  382,  212,  213,
  214,  215,  216,  217,  218,  219,  220,  221,  222,  223,
  224,  225,  226,  227,  228,  229,  230,  231,  232,  383,
  233,  234,  235,  236,  237,  238,  384,  239,  240,  241,
  242,  385,  243,  386,  244,  245,  246,  247,  248,  249,
  250,  251,  252,  253,  254,  255,  256,  257,  258,  259,
  260,  261,  387,  262,  263,  264,  265,  388,  266,  267,
  268,  269,  270,  389,  271,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,  283,  390,  284,  285,
  286,  287,  288,  289,  583,  290,  583,    0,    0,    0,
    0,    0,  583,    0,    0,  583,  583,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  583,  583,    0,
  583,    0,  583,    0,    0,  583,    0,    0,  583,    0,
    0,    0,    0,    0,    0,  583,    0,  583,  583,    0,
    0,    0,  583,    0,    0,  583,    0,    0,  583,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  583,  583,
    0,    0,    0,    0,  583,    0,  583,    0,  583,    0,
    0,    0,    0,    0,  583,    0,  583,    0,    0,    0,
  583,    0,    0,    0,    0,    0,    0,    0,  583,    0,
    0,    0,  583,    0,    0,  583,    0,    0,    0,    0,
  583,  583,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  583,    0,    0,    0,  583,  583,  583,
  583,  583,    0,  583,    0,    0,    0,    0,    0,  583,
    0,  583,  583,    0,    0,  583,  583,    0,    0,    0,
    0,    0,    0,  583,    0,    0,  583,  583,  583,  583,
    0,  583,    0,  583,    0,  583,  583,  583,  583,  583,
    0,    0,    0,    0,  583,    0,  583,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  583,    0,    0,
    0,    0,  583,  583,    0,    0,    0,  583,    0,    0,
  583,  583,  583,  583,  583,  583,    0,  583,  583,  583,
  583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
  583,  583,    0,    0,  583,  583,  583,  583,  583,  583,
  583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
  583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
  583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
  583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
  583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
  583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
  583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
  583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
  583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
  583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
  583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
  583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
  583,  583,  583,  583,  583,  583,  583,  583,  583,  583,
  402,  583,  402,    0,    0,    0,    0,    0,  402,    0,
    0,  402,  402,  402,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  402,  402,    0,  402,    0,  402,    0,
    0,  402,    0,    0,  402,    0,    0,    0,    0,    0,
  402,  402,    0,  402,  402,    0,    0,  402,  402,    0,
    0,  402,  402,    0,  402,    0,    0,  402,    0,    0,
    0,    0,    0,    0,  402,  402,    0,    0,    0,    0,
  402,  402,  402,    0,  402,    0,  402,    0,    0,    0,
  402,    0,  402,    0,    0,    0,  402,    0,    0,    0,
    0,    0,  402,    0,  402,    0,  402,    0,  402,    0,
    0,  402,    0,    0,  402,    0,  402,  402,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  402,
    0,    0,    0,  402,  402,  402,  402,  402,    0,  402,
    0,  402,  402,    0,    0,  402,    0,  402,  402,    0,
    0,  402,  402,    0,    0,    0,  402,    0,    0,  402,
  402,    0,  402,  402,  402,  402,    0,  402,    0,  402,
    0,  402,  402,  402,  402,  402,    0,    0,    0,    0,
  402,    0,  402,    0,    0,  402,    0,    0,    0,    0,
    0,    0,    0,  402,  402,    0,  402,  402,  402,  402,
    0,    0,    0,  402,    0,    0,  402,    0,  402,  402,
  402,  402,    0,  402,  402,    0,    0,    0,    0,    0,
    0,  402,  402,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  402,  402,    0,  402,  402,  402,    0,    0,
    0,    0,  402,  402,    0,  402,  402,    0,  402,    0,
    0,  402,  402,  402,  402,  402,  402,  402,  402,  402,
  402,    0,  402,  402,  402,    0,  402,  402,  402,    0,
  402,    0,  402,  402,  402,    0,  402,  402,    0,  402,
  402,  402,  402,  402,  402,  402,  402,  402,  402,  402,
  402,  402,  402,  402,  402,  402,  402,  402,  402,  402,
  402,    0,  402,  402,  402,  402,  402,  402,    0,  402,
  402,  402,  402,    0,  402,    0,  402,  402,  402,  402,
  402,  402,  402,  402,  402,  402,  402,  402,  402,  402,
  402,  402,  402,  402,    0,  402,  402,  402,  402,    0,
  402,  402,  402,  402,  402,    0,  402,  402,  402,  402,
  402,  402,  402,  402,  402,  402,  402,  402,  402,    0,
  402,  402,  402,  402,  402,  402,  341,  402,  341,    0,
    0,    0,    0,    0,  341,    0,    0,  341,  341,  341,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  341,
  341,    0,  341,    0,  341,    0,    0,  341,    0,    0,
  341,    0,    0,    0,    0,    0,  341,  341,    0,  341,
  341,    0,    0,  336,  341,    0,    0,  341,  341,    0,
  341,    0,    0,  341,    0,    0,    0,    0,    0,    0,
  341,  341,    0,    0,    0,    0,  341,  341,  341,    0,
  341,    0,  341,    0,    0,    0,  341,    0,  341,    0,
    0,    0,  341,    0,    0,    0,    0,    0,  341,    0,
  341,    0,  341,    0,  341,    0,    0,  341,    0,    0,
  341,    0,  341,  341,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  341,    0,    0,    0,  341,
  341,  341,  341,  341,    0,  341,    0,  341,  341,    0,
    0,  341,    0,  341,  341,    0,    0,  341,  341,    0,
    0,    0,  341,    0,    0,  341,  341,    0,  341,  341,
  341,  341,    0,  341,    0,  341,    0,  341,  341,  341,
  341,  341,    0,    0,    0,    0,  341,    0,  341,    0,
    0,  341,    0,    0,    0,    0,    0,    0,    0,  341,
    0,    0,  341,  341,  341,  341,    0,    0,    0,  341,
    0,    0,  341,    0,  341,  341,  341,  341,    0,  341,
  341,    0,    0,    0,    0,    0,    0,  341,  341,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  341,  341,
    0,  341,  341,  341,    0,    0,    0,    0,  341,  341,
    0,  341,  341,    0,  341,    0,    0,  341,  341,  341,
  341,  341,  341,  341,  341,  341,  341,    0,  341,  341,
  341,    0,  341,  341,  341,    0,  341,    0,  341,  341,
  341,    0,  341,  341,    0,  341,  341,  341,  341,  341,
  341,  341,  341,  341,  341,  341,  341,  341,  341,  341,
  341,  341,  341,  341,  341,  341,  341,    0,  341,  341,
  341,  341,  341,  341,    0,  341,  341,  341,  341,    0,
  341,    0,  341,  341,  341,  341,  341,  341,  341,  341,
  341,  341,  341,  341,  341,  341,  341,  341,  341,  341,
    0,  341,  341,  341,  341,    0,  341,  341,  341,  341,
  341,    0,  341,  341,  341,  341,  341,  341,  341,  341,
  341,  341,  341,  341,  341,    0,  341,  341,  341,  341,
  341,  341,  341,  341,  341,    0,    0,    0,    0,    0,
  341,    0,    0,  341,  341,  341,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  341,  341,    0,  341,    0,
  341,    0,    0,  341,    0,    0,  341,    0,    0,    0,
    0,    0,  341,  341,    0,  341,  341,    0,    0,  334,
  341,    0,    0,  341,  341,    0,  341,    0,    0,  341,
    0,    0,    0,    0,    0,    0,  341,  341,    0,    0,
    0,    0,  341,  341,  341,    0,  341,    0,  341,    0,
    0,    0,  341,    0,  341,    0,    0,    0,  341,    0,
    0,    0,    0,    0,  341,    0,  341,    0,  341,    0,
  341,    0,    0,  341,    0,    0,  341,    0,  341,  341,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  341,    0,    0,    0,  341,  341,  341,  341,  341,
    0,  341,    0,  341,  341,    0,    0,  341,    0,  341,
  341,    0,    0,  341,  341,    0,    0,    0,  341,    0,
    0,  341,  341,    0,  341,  341,  341,  341,    0,  341,
    0,  341,    0,  341,  341,  341,  341,  341,    0,    0,
    0,    0,  341,    0,  341,    0,    0,  341,    0,    0,
    0,    0,    0,    0,    0,  341,    0,    0,  341,  341,
  341,  341,    0,    0,    0,  341,    0,    0,  341,    0,
  341,  341,  341,  341,    0,  341,  341,    0,    0,    0,
    0,    0,    0,  341,  341,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  341,  341,    0,  341,  341,  341,
    0,    0,    0,    0,  341,  341,    0,  341,  341,    0,
  341,    0,    0,  341,  341,  341,  341,  341,  341,  341,
  341,  341,  341,    0,  341,  341,  341,    0,  341,  341,
  341,    0,  341,    0,  341,  341,  341,    0,  341,  341,
    0,  341,  341,  341,  341,  341,  341,  341,  341,  341,
  341,  341,  341,  341,  341,  341,  341,  341,  341,  341,
  341,  341,  341,    0,  341,  341,  341,  341,  341,  341,
    0,  341,  341,  341,  341,    0,  341,    0,  341,  341,
  341,  341,  341,  341,  341,  341,  341,  341,  341,  341,
  341,  341,  341,  341,  341,  341,    0,  341,  341,  341,
  341,    0,  341,  341,  341,  341,  341,    0,  341,  341,
  341,  341,  341,  341,  341,  341,  341,  341,  341,  341,
  341,    0,  341,  341,  341,  341,  341,  341,  113,  341,
  114,    0,    0,    0,    0,    0,  116,    0,    0,  117,
  118, 2213,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  119,  120,    0,  121,    0,  122,    0,    0,  123,
    0,    0,  124,    0,    0,    0,    0,    0,    5,  126,
    0,  127,  128,    0,    0,    0,  129,    0,    0, 2423,
 2424,    0, 2425,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  133,  134,    0,    0,    0,    0, 2426, 2427,
  136,    0,  137,    0, 2428,    0,    0,    0,  139,    0,
  140,    0,    0,    0,  141,    0,    0,    0,    0,    0,
  670,    0,  142,    0,  672,    0,  143,    0,    0,  144,
    0,    0,   10,    0,  145,  146,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  147,    0,    0,
    0,  148,  149,  150,  151,  152,    0,  153,    0,  675,
 2429,    0,    0,  154,    0,  155,  156,    0,    0,  158,
  159,    0,    0,    0,  676,    0,    0,  160,    0,    0,
  162,  163,  164,  165,    0,  166,    0,  167,    0,  168,
  169,  170,  171, 2430,    0,    0,    0,    0,  173,    0,
  174,    0,    0,   15,    0,    0,    0,    0,    0,    0,
    0,  176,    0,    0,    0,   16,  177,  178,    0,    0,
    0,  683,    0,    0,  180,    0,  181,  182,  183,  184,
    0,  185,  684,    0,    0,    0,    0,    0,    0,  186,
  187,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 2431,  694,    0,  190,  191,  192,    0,    0,    0,    0,
  193,  194,    0,  195,  196,    0,  197,    0,    0,  198,
 2432,  200,  201,  202,  203,  204, 2433, 2434, 2435,    0,
  205,  206,  207,    0,  208,  209,  210,    0,  211,    0,
  703,  704,  705,    0,  706,  707,    0,  708,  212,  213,
  214,  215,  216,  217,  709,  219,  710,  221,  711,  712,
  713,  714,  715,  716,  717,  718,  719,  720,  721,    0,
  722,  723,  724,  725,  726,  238,    0,  728,  729,  730,
  242,    0,  731,    0,  244,  733,  734,  735,  736,  249,
  250,  737,  252,  738,  739,  740,  256,  741,  258,  742,
  260,  743,    0,  744,  745,  746,  747,    0,  748,  749,
  750,  269,  751,    0,  752,  753,  273,  754,  275,  276,
  755,  278,  279,  280,  281,  282,  283,    0,  756,  285,
  286,  287,  288,  289, 1288,  757, 1288,    0,    0,    0,
    0,    0, 1288,    0,    0, 1288, 1288,    0,    0, 1288,
    0,    0, 1288,    0,    0,    0,    0, 1288, 1288,    0,
 1288,    0, 1288,    0,    0, 1288,    0, 1290, 1288, 1288,
    0, 1288,    0,    0,    0, 1288,    0, 1288, 1288,    0,
    0,    0, 1288,    0,    0, 1288,    0,    0, 1288,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1288, 1288,
    0,    0,    0,    0, 1288,    0, 1288,    0, 1288,    0,
    0, 1288,    0,    0, 1288,    0, 1288, 1288, 1288, 1288,
 1288, 1288, 1288, 1288,    0, 1288,    0,    0, 1288,    0,
    0,    0, 1288,    0,    0, 1288,    0,    0,    0,    0,
 1288, 1288, 1288,    0, 1288,    0,    0,    0,    0,    0,
    0,    0,    0, 1288,    0,    0,    0, 1288, 1288, 1288,
 1288, 1288,    0, 1288,    0,    0,    0,    0,    0, 1288,
    0, 1288, 1288, 1288,    0, 1288, 1288,    0,    0,    0,
    0,    0,    0, 1288,    0,    0, 1288, 1288, 1288, 1288,
 1288, 1288,    0, 1288,    0, 1288, 1288, 1288, 1288, 1288,
    0,    0,    0,    0, 1288,    0, 1288,    0,    0,    0,
    0,    0, 1288,    0,    0,    0,    0, 1288,    0,    0,
    0,    0, 1288, 1288,    0,    0,    0, 1288,    0,    0,
 1288,    0, 1288, 1288, 1288, 1288,    0, 1288,    0,    0,
    0,    0,    0,    0,    0, 1288, 1288, 1288, 1288,    0,
    0,    0,    0,    0,    0,    0, 1288, 1288,    0, 1288,
 1288, 1288,    0,    0, 1288,    0, 1288, 1288,    0, 1288,
 1288,    0, 1288,    0,    0, 1288, 1288, 1288, 1288, 1288,
 1288, 1288,    0,    0,    0,    0, 1288, 1288, 1288,    0,
 1288, 1288, 1288,    0, 1288,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1288, 1288, 1288, 1288, 1288, 1288,
 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
 1288, 1288, 1288, 1288, 1288,    0, 1288, 1288, 1288, 1288,
 1288, 1288,    0, 1288, 1288, 1288, 1288,    0, 1288,    0,
 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,    0, 1288,
 1288, 1288, 1288,    0, 1288, 1288, 1288, 1288, 1288,    0,
 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288, 1288,
 1288, 1288, 1288,    0, 1288, 1288, 1288, 1288, 1288, 1288,
  113, 1288,  114,    0,    0,    0,    0,    0,  116,    0,
    0,  117,  118,    0,    0,  969,    0,    0,  970,    0,
    0,    0,    0,  119,  120,    0,  121,    0,  122,    0,
    0,  123,    0,    0,  124,  971,    0,  972,    0,    0,
    0,  126,    0,  127,  128,    0,    0,    0,  129,    0,
    0,  130,    0,    0,  132,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  133,  134,    0,    0,    0,    0,
  135,    0,  136,    0,  137,    0,    0,  973,    0,    0,
  139,    0,  140,  974,  975,  976,  141,  977,  978,  979,
    0,  980,    0,    0,  142,    0,    0,    0,  143,    0,
    0,  144,    0,    0,    0,    0,  145,  146,  981,    0,
  982,    0,    0,    0,    0,    0,    0,    0,    0,  147,
    0,    0,    0,  148,  149,  150,  151,  152,    0,  153,
    0,    0,    0,    0,    0,  154,    0,  155,  156,  983,
    0,  158,  159,    0,    0,    0,    0,    0,    0,  160,
    0,    0,  162,  163,  164,  165,  984,  166,    0,  167,
    0,  168,  169,  170,  171,  172,    0,    0,    0,    0,
  173,    0,  174,    0,    0,    0,    0,    0,  985,    0,
    0,    0,    0,  176,    0,    0,    0,    0,  177,  178,
    0,    0,    0,  179,    0,    0,  180,    0,  181,  182,
  183,  184,    0, 1121,    0,    0,    0,    0,    0,    0,
    0,  186,  187,  986,  987,    0,    0,    0,    0,    0,
    0,    0,  188,  189,    0,  190,  191,  192,    0,    0,
  988,    0,  193,  194,    0,  195,  196,    0,  197,    0,
    0,  198,  199,  200,  201,  202,  203,  204,    0,    0,
    0,    0,  205,  206,  207,    0,  208,  209,  210,    0,
  211,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
  222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
  232,    0,  233,  234,  235,  236,  237,  238,    0,  239,
  240,  241,  242,    0,  243,    0,  244,  245,  246,  247,
  248,  249,  250,  251,  252,  253,  254,  255,  256,  257,
  258,  259,  260,  261,    0,  262,  263,  264,  265,    0,
  266,  267,  268,  269,  270,    0,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,    0,
  284,  285,  286,  287,  288,  289,  113,  290,  114,    0,
    0,    0,    0,    0,  116,    0,    0,  117,  118,    0,
    0,  969,    0,    0,  970,    0,    0,    0,    0,  119,
 1236,    0,  121,    0,  122,    0,    0,  123,    0,    0,
  124,  971,    0,  972,    0,    0,    0,  126,    0,  127,
  128,    0,    0,    0,  129,    0,    0,  130,    0,    0,
  132,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  133,  134,    0,    0,    0,    0,  135,    0,  136,    0,
  137,    0,    0,  973,    0,    0,  139,    0,  140,  974,
  975,  976,  141,  977,  978,  979,    0,  980,    0,    0,
  142,    0,    0,    0,  143,    0,    0,  144,    0,    0,
    0,    0,  145,  146,  981,    0,  982,    0,    0,    0,
    0,    0,    0,    0,    0,  147,    0,    0,    0,  148,
  149,  150,  151,  152,    0,  153,    0,    0,    0,    0,
    0,  154,    0,  155,  156,  983,    0,  158,  159,    0,
    0,    0,    0,    0,    0,  160,    0,    0,  162,  163,
  164,  165,  984,  166,    0,  167,    0,  168,  169,  170,
  171,  172,    0,    0,    0,    0,  173,    0,  174,    0,
    0,    0,    0,    0,  985,    0,    0,    0,    0,  176,
    0,    0,    0,    0,  177,  178,    0,    0,    0,  179,
    0,    0,  180,    0,  181,  182,  183,  184,    0,  185,
    0,    0,    0,    0,    0,    0,    0,  186,  187,  986,
  987,    0,    0,    0,    0,    0,    0,    0,  188,  189,
    0,  190,  191,  192,    0,    0,  988,    0,  193,  194,
    0,  195,  196,    0,  197,    0,    0,  198,  199,  200,
  201,  202,  203,  204,    0,    0,    0,    0,  205,  206,
  207,    0,  208,  209,  210,    0,  211,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  212,  213,  214,  215,
  216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,    0,  233,  234,
  235,  236,  237,  238,    0,  239,  240,  241, 1237,    0,
  243,    0,  244,  245,  246,  247,  248,  249,  250,  251,
  252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
    0,  262,  263,  264,  265,    0,  266,  267,  268,  269,
  270,    0,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,    0,  284,  285,  286,  287,
  288,  289,  113,  290,  114,    0,    0,    0,    0,    0,
  116,    0,    0,  117,  118,    0,    0,  969,    0,    0,
  970,    0,    0,    0,    0,  119,  120,    0,  121,    0,
  122,    0,    0,  123,    0,    0,  124,  971,    0,  972,
    0,    0,    0,  126,    0,  127,  128,    0,    0,    0,
  129,    0,    0,  130,    0,    0,  132,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  133,  134,    0,    0,
    0,    0,  135,    0,  136,    0,  137,    0,    0,  973,
    0,    0,  139,    0,  140,  974,  975,  976,  141,  977,
  978,  979,    0,  980,    0,    0,  142,    0,    0,    0,
  143,    0,    0,  144,    0,    0,    0,    0,  145,  146,
  981,    0,  982,    0,    0,    0,    0,    0,    0,    0,
    0,  147,    0,    0,    0,  148,  149,  150,  151,  152,
    0,  153,    0,    0,    0,    0,    0,  154,    0,  155,
  156,  983,    0,  158,  159,    0,    0,    0,    0,    0,
    0,  160,    0,    0,  162,  163,  164,  165,  984,  166,
    0,  167,    0,  168,  169,  170,  171,  172,    0,    0,
    0,    0,  173,    0,  174,    0,    0,    0,    0,    0,
  985,    0,    0,    0,    0,  176,    0,    0,    0,    0,
  177,  178,    0,    0,    0,  179,    0,    0,  180,    0,
  181,  182,  183,  184,    0,  185,    0,    0,    0,    0,
    0,    0,    0,  186,  187,  986,  987,    0,    0,    0,
    0,    0,    0,    0,  188,  189,    0,  190,  191,  192,
    0,    0,  988,    0,  193,  194,    0,  195,  196,    0,
  197,    0,    0,  198,  199,  200,  201,  202,  203,  204,
    0,    0,    0,    0,  205,  206,  207,    0,  208,  209,
  210,    0,  211,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  212,  213,  214,  215,  216,  217,  218,  219,
  220,  221,  222,  223,  224,  225,  226,  227,  228,  229,
  230,  231,  232,    0,  233,  234,  235,  236,  237,  238,
    0,  239,  240,  241,  242,    0,  243,    0,  244,  245,
  246,  247,  248,  249,  250,  251,  252,  253,  254,  255,
  256,  257,  258,  259,  260,  261,    0,  262,  263,  264,
  265,    0,  266,  267,  268,  269,  270,    0,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,    0,  284,  285,  286,  287,  288,  289,  113,  290,
  114,  115,    0,    0,    0,    0,  116,    0,    0,  117,
  118,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  119,  120,    0,  121,    0,  122,    0,    0,  123,
    0,    0,  124,    0,    0,    0,    0,    0,  125,  126,
    0,  127,  128,    0,    0,    0,  129,    0,    0,  130,
  131,    0,  132,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  133,  134,    0,    0,    0,    0,  135,    0,
  136,    0,  137,    0,  138,    0,    0,    0,  139,    0,
  140,    0,    0,    0,  141,    0,    0,    0,    0,    0,
    0,    0,  142,    0,    0,    0,  143,    0,    0,  144,
    0,    0,    0,    0,  145,  146,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  147,    0,    0,
    0,  148,  149,  150,  151,  152,    0,  153,    0,    0,
    0,    0,    0,  154,    0,  155,  156,    0,  157,  158,
  159,    0,    0,    0,    0,    0,    0,  160,  161,    0,
  162,  163,  164,  165,    0,  166,    0,  167,    0,  168,
  169,  170,  171,  172,    0,    0,    0,    0,  173,    0,
  174,    0,    0,  175,    0,    0,    0,    0,    0,    0,
    0,  176,    0,    0,    0,    0,  177,  178,    0,    0,
    0,  179,    0,    0,  180,    0,  181,  182,  183,  184,
    0,  185,    0,    0,    0,    0,    0,    0,    0,  186,
  187,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  188,  189,    0,  190,  191,  192,    0,    0,    0,    0,
  193,  194,    0,  195,  196,    0,  197,    0,    0,  198,
  199,  200,  201,  202,  203,  204,    0,    0,    0,    0,
  205,  206,  207,    0,  208,  209,  210,    0,  211,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  212,  213,
  214,  215,  216,  217,  218,  219,  220,  221,  222,  223,
  224,  225,  226,  227,  228,  229,  230,  231,  232,    0,
  233,  234,  235,  236,  237,  238,    0,  239,  240,  241,
  242,    0,  243,    0,  244,  245,  246,  247,  248,  249,
  250,  251,  252,  253,  254,  255,  256,  257,  258,  259,
  260,  261,    0,  262,  263,  264,  265,    0,  266,  267,
  268,  269,  270,    0,  271,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,  283,    0,  284,  285,
  286,  287,  288,  289,   58,  290,   58,    0,    0,    0,
    0,    0,   58,    0,    0,   58,   58,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   58,   58,    0,
   58,    0,   58,    0,    0,   58,    0,    0,   58,    0,
    0,    0,    0,    0,   56,   58,    0,   58,   58,    0,
    0,    0,   58,    0,    0,   58,   56,    0,   58,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   58,   58,
    0,    0,    0,    0,   58,    0,   58,    0,   58,    0,
   56,    0,    0,    0,   58,    0,   58,    0,    0,    0,
   58,    0,    0,    0,    0,    0,    0,    0,   58,    0,
    0,    0,   58,    0,    0,   58,    0,    0,    0,    0,
   58,   58,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   58,    0,    0,    0,   58,   58,   58,
   58,   58,    0,   58,    0,    0,    0,    0,    0,   58,
    0,   58,   58,    0,   56,   58,   58,    0,    0,    0,
    0,    0,    0,   58,   56,    0,   58,   58,   58,   58,
    0,   58,    0,   58,    0,   58,   58,   58,   58,   58,
    0,    0,    0,    0,   58,    0,   58,    0,    0,   56,
    0,    0,    0,    0,    0,    0,    0,   58,    0,    0,
    0,    0,   58,   58,    0,    0,    0,   58,    0,    0,
   58,    0,   58,   58,   58,   58,    0,   58,    0,    0,
    0,    0,    0,    0,    0,   58,   58,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   58,   58,    0,   58,
   58,   58,    0,    0,    0,    0,   58,   58,    0,   58,
   58,    0,   58,    0,    0,   58,   58,   58,   58,   58,
   58,   58,    0,    0,    0,    0,   58,   58,   58,    0,
   58,   58,   58,    0,   58,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   58,   58,   58,   58,   58,   58,
   58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
   58,   58,   58,   58,   58,    0,   58,   58,   58,   58,
   58,   58,    0,   58,   58,   58,   58,    0,   58,    0,
   58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
   58,   58,   58,   58,   58,   58,   58,   58,    0,   58,
   58,   58,   58,    0,   58,   58,   58,   58,   58,    0,
   58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
   58,   58,   58,    0,   58,   58,   58,   58,   58,   58,
  113,   58,  114,    0,    0,    0,    0,    0,  116,    0,
    0,  117,  118,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  119,  120,    0,  121,    0,  122,    0,
    0,  123,    0,    0,  124,    0,    0,    0,    0,    0,
    0,  126,    0,  127,  128,    0,    0,    0,  129,    0,
    0,  130,    0,    0,  132,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  133,  134,    0, 1502,    0,    0,
  135,    0,  136,    0,  137,    0,    0,    0,    0,    0,
  139,    0,  140,    0,    0,    0,  141,    0,    0,    0,
    0,    0,    0,    0,  142,    0,    0,    0,  143,    0,
    0,  144,    0,    0,    0,    0,  145,  146,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  147,
    0,    0,    0,  148,  149,  150,  151,  152,    0,  153,
    0,    0,    0,    0,    0,  154, 1503,  155,  156,    0,
    0,  158,  159,    0,    0,    0,    0,    0,    0,  160,
    0,    0,  162,  163,  164,  165,    0,  166,    0,  167,
    0,  168,  169,  170,  171,  172,    0,    0,    0,    0,
  173, 1504,  174,    0,    0,    0, 1505,    0,    0,    0,
    0,    0, 1506,  176,    0,    0,    0,    0,  177,  178,
    0,    0,    0,  179,    0,    0,  180,    0,  181,  182,
  183, 1507,    0,  185,    0,    0,    0,    0,    0,    0,
    0,  186,  187,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  188,  189,    0,  190,  191,  192,    0,    0,
    0,    0,  193,  194,    0,  195,  196,    0,  197,    0,
    0,  198,  199,  200,  201,  202,  203,  204,    0,    0,
    0,    0,  205,  206,  207,    0,  208,  209,  210,    0,
  211,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
  222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
  232,    0,  233,  234,  235,  236,  237,  238,    0,  239,
  240,  241,  242,    0,  243,    0,  244,  245,  246,  247,
  248,  249,  250,  251,  252,  253,  254,  255,  256,  257,
  258,  259,  260,  261,    0,  262,  263,  264,  265,    0,
  266,  267,  268,  269,  270,    0,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,    0,
  284,  285,  286,  287,  288,  289,  113,  290,  114,    0,
    0,    0,    0,    0,  116,    0,    0,  117,  118,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  119,
  120,    0,  121,    0,  122,    0,    0,  123,    0,    0,
  124,    0,    0,    0,    0,    0,    0,  126,    0,  127,
  128,    0,    0,    0,  129,    0,    0,  130,    0,    0,
  132,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  133,  134,    0,    0,    0,    0,  135,    0,  136,    0,
  137,    0,    0,    0,    0,    0,  139, 1369,  140,    0,
    0,    0,  141,    0,    0,    0,    0,    0,    0,    0,
  142,    0,    0,    0,  143,    0,    0,  144,    0,    0,
 1370,    0,  145,  146,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  147,    0,    0,    0,  148,
  149,  150,  151,  152,    0,  153,    0,    0,    0,    0,
    0,  154,    0,  155,  156,    0,    0,  158,  159,    0,
    0,    0,    0,    0,    0,  160,    0,    0,  162,  163,
  164,  165,    0,  166,    0, 1988,    0,  168,  169,  170,
  171,  172,    0,    0,    0,    0,  173,    0,  174,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  176,
    0,    0,    0,    0,  177,  178,    0,    0,    0,  179,
    0,    0,  180,    0,  181,  182,  183,  184,    0,  185,
    0,    0,    0,    0,    0,    0,    0,  186,  187,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  188,  189,
    0,  190,  191,  192,    0,    0,    0,    0,  193,  194,
    0,  195,  196,    0,  197,    0,    0,  198,  199,  200,
  201,  202,  203,  204,    0,    0,    0,    0,  205,  206,
  207,    0,  208,  209,  210,    0,  211,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  212,  213,  214,  215,
  216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,    0,  233,  234,
  235,  236,  237,  238,    0,  239,  240,  241,  242,    0,
  243,    0,  244,  245,  246,  247,  248,  249,  250,  251,
  252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
    0,  262,  263,  264,  265,    0,  266,  267,  268,  269,
  270,    0,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,    0,  284,  285,  286,  287,
  288,  289,  113,  290,  114,    0,    0,    0,    0,    0,
  116,    0,    0,  117,  118,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  119,  120,    0,  121,    0,
  122,    0,    0,  123,    0,    0,  124,    0,    0,    0,
    0,    0,    0,  126,    0,  127,  128,    0,    0,    0,
  129,    0,    0,  130,    0,    0,  132,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  133,  134,    0,    0,
    0,    0,  135,    0,  136,    0,  137,    0,    0,    0,
    0,    0,  139,    0,  140,    0,    0,    0,  141,    0,
    0,    0,    0,    0,    0,    0,  142,    0,    0,    0,
  143,    0,    0,  144,    0,    0,    0,    0,  145,  146,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  147,  313,    0,    0,  148,  149,  150,  151,  152,
    0,  153,    0,    0,    0,    0,    0,  154,    0,  155,
  156,    0,    0,  158,  159,    0,    0,    0,    0,    0,
    0,  160,    0,    0,  162,  163,  164,  165,    0,  166,
    0,  167,    0,  168,  169,  170,  171,  172,    0,    0,
    0,    0,  173,    0,  174,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  176,    0,    0,    0,    0,
  177,  178,    0,    0,    0,  179,    0,    0,  180,    0,
  181,  182,  183,  184,    0,  185,    0,    0,    0,    0,
    0,    0,    0,  186,  187,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  188,  189,    0,  190,  191,  192,
    0,    0,    0,    0,  193,  194,    0,  195,  196,    0,
  197,    0,    0,  198,  199,  200,  201,  202,  203,  204,
    0,    0,    0,    0,  205,  206,  207,    0,  208,  209,
  210,    0,  211,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  212,  213,  214,  215,  216,  217,  218,  219,
  220,  221,  222,  223,  224,  225,  226,  227,  228,  229,
  230,  231,  232,    0,  233,  234,  235,  236,  237,  238,
    0,  239,  240,  241,  242,    0,  243,    0,  244,  245,
  246,  247,  248,  249,  250,  251,  252,  253,  254,  255,
  256,  257,  258,  259,  260,  261,    0,  262,  263,  264,
  265,    0,  266,  267,  268,  269,  270,    0,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,    0,  284,  285,  286,  287,  288,  289,  113,  290,
  114,    0,    0,    0,    0,    0,  116,    0,    0,  117,
  118,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  119,  120,    0,  121,    0,  122,    0,    0,  123,
    0,    0,  124,    0,    0,    0,    0,    0,    0,  126,
    0,  127,  128,    0,    0,    0,  129,    0,    0,  130,
    0,    0,  132,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  133,  134,    0,    0,    0,    0,  135,    0,
  136,    0,  137,    0,    0,    0,    0,    0,  139,    0,
  140,    0,    0,    0,  141,    0,    0,    0,    0,    0,
    0,    0,  142,    0,    0,    0,  143,    0,    0,  144,
    0,    0,    0,    0,  145,  146,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  147,    0,    0,
    0,  148,  149,  150,  151,  152,    0,  153,    0,    0,
    0,    0,    0,  154,    0,  155,  156,    0,    0,  158,
  159,    0,    0,    0,    0,    0,    0,  160,    0,    0,
  162,  163,  164,  165,    0,  166,    0,  167,    0,  168,
  169,  170,  171,  172,    0,    0,    0,    0,  173,    0,
  174,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  176,    0,    0,    0,    0,  177,  178,    0,    0,
    0,  179,    0,    0,  180,    0,  181,  182,  183,  184,
    0,  185,    0,    0,    0,    0,    0,    0,    0,  186,
  187,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  188,  189,    0,  190,  191,  192,    0,    0,    0,    0,
  193,  194,    0,  195,  196,    0,  197,    0,    0,  198,
  199,  200,  201,  202,  203,  204,    0,    0,    0,    0,
  205,  206,  207,    0,  208,  209,  210,    0,  211,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  212,  213,
  214,  215,  216,  217,  218,  219,  220,  221,  222,  223,
  224,  225,  226,  227,  228,  229,  230,  231,  232,    0,
  233,  234,  235,  236,  237,  238,    0,  239,  240,  241,
  242,    0,  243,    0,  244,  245,  246,  247,  248,  249,
  250,  251,  252,  253,  254,  255,  256,  257,  258,  259,
  260,  261,  318,  262,  263,  264,  265,    0,  266,  267,
  268,  269,  270,    0,  271,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,  283,    0,  284,  285,
  286,  287,  288,  289,  113,  290,  114,    0,    0,    0,
    0,    0,  116,    0,    0,  117,  118,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  119,  120,    0,
  121,    0,  122,    0,    0,  123,    0,    0,  124,    0,
    0,    0,    0,    0,    0,  126,    0,  127,  128,    0,
    0,    0,  129,    0,    0,  130,    0,    0,  132,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  133,  134,
    0,    0,    0,    0,  135,    0,  136,    0,  137,    0,
    0,    0,    0,    0,  139,    0,  140,    0,    0,    0,
  141,    0,    0,    0,    0,    0,    0,    0,  142,    0,
    0,    0,  143,    0,    0,  144,    0,    0,    0,    0,
  145,  146,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  147,    0,    0,    0,  148,  149,  150,
  151,  152,    0,  153,    0,    0,    0,    0,    0,  154,
    0,  155,  156,    0,    0,  158,  159,    0,    0,    0,
    0,    0,    0,  160,    0,    0,  162,  163,  164,  165,
    0,  166,    0,  167,    0,  168,  169,  170,  171,  172,
    0,    0,    0,    0,  173,    0,  174,    0,    0,    0,
  817,    0,    0,    0,    0,    0,    0,  176,    0,    0,
    0,    0,  177,  178,    0,    0,    0,  179,    0,    0,
  180,    0,  181,  182,  183,  184,    0,  185,    0,    0,
    0,    0,    0,    0,    0,  186,  187,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  188,  189,    0,  190,
  191,  192,    0,    0,    0,    0,  193,  194,    0,  195,
  196,    0,  197,    0,    0,  198,  199,  200,  201,  202,
  203,  204,    0,    0,    0,    0,  205,  206,  207,    0,
  208,  209,  210,    0,  211,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  212,  213,  214,  215,  216,  217,
  218,  219,  220,  221,  222,  223,  224,  225,  226,  227,
  228,  229,  230,  231,  232,    0,  233,  234,  235,  236,
  237,  238,    0,  239,  240,  241,  242,    0,  243,    0,
  244,  245,  246,  247,  248,  249,  250,  251,  252,  253,
  254,  255,  256,  257,  258,  259,  260,  261,    0,  262,
  263,  264,  265,    0,  266,  267,  268,  269,  270,    0,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,    0,  284,  285,  286,  287,  288,  289,
  113,  290,  114,    0,    0,    0,    0,    0,  116,    0,
    0,  117,  118,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  119,  120,    0,  121,  930,  122,    0,
    0,  123,    0,    0,  124,    0,    0,    0,    0,    0,
    0,  126,    0,  127,  128,    0,    0,    0,  129,    0,
    0,  130,    0,    0,  132,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  133,  134,    0,    0,    0,    0,
  135,    0,  136,    0,  137,    0,    0,    0,    0,    0,
  139,    0,  140,    0,    0,    0,  141,    0,    0,    0,
    0,    0,    0,    0,  142,    0,    0,    0,  143,    0,
    0,  144,    0,    0,    0,    0,  145,  146,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  147,
    0,    0,    0,  148,  149,  150,  151,  152,    0,  153,
    0,    0,    0,    0,    0,  154,    0,  155,  156,    0,
    0,  158,  159,    0,    0,    0,    0,    0,    0,  160,
    0,    0,  162,  163,  164,  165,    0,  166,    0,  167,
    0,  168,  169,  170,  171,  172,    0,    0,    0,    0,
  173,    0,  174,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  176,    0,    0,    0,    0,  177,  178,
    0,    0,    0,  179,    0,    0,  180,    0,  181,  182,
  183,  184,    0,  185,    0,    0,    0,    0,    0,    0,
    0,  186,  187,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  188,  189,    0,  190,  191,  192,    0,    0,
    0,    0,  193,  194,    0,  195,  196,    0,  197,    0,
    0,  198,  199,  200,  201,  202,  203,  204,    0,    0,
    0,    0,  205,  206,  207,    0,  208,  209,  210,    0,
  211,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
  222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
  232,    0,  233,  234,  235,  236,  237,  238,    0,  239,
  240,  241,  242,    0,  243,    0,  244,  245,  246,  247,
  248,  249,  250,  251,  252,  253,  254,  255,  256,  257,
  258,  259,  260,  261,    0,  262,  263,  264,  265,    0,
  266,  267,  268,  269,  270,    0,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,    0,
  284,  285,  286,  287,  288,  289,  113,  290,  114,    0,
    0,    0,    0,    0,  116,    0,    0,  117,  118,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  119,
  120,    0,  121,  936,  122,    0,    0,  123,    0,    0,
  124,    0,    0,    0,    0,    0,    0,  126,    0,  127,
  128,    0,    0,    0,  129,    0,    0,  130,    0,    0,
  132,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  133,  134,    0,    0,    0,    0,  135,    0,  136,    0,
  137,    0,    0,    0,    0,    0,  139,    0,  140,    0,
    0,    0,  141,    0,    0,    0,    0,    0,    0,    0,
  142,    0,    0,    0,  143,    0,    0,  144,    0,    0,
    0,    0,  145,  146,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  147,    0,    0,    0,  148,
  149,  150,  151,  152,    0,  153,    0,    0,    0,    0,
    0,  154,    0,  155,  156,    0,    0,  158,  159,    0,
    0,    0,    0,    0,    0,  160,    0,    0,  162,  163,
  164,  165,    0,  166,    0,  167,    0,  168,  169,  170,
  171,  172,    0,    0,    0,    0,  173,    0,  174,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  176,
    0,    0,    0,    0,  177,  178,    0,    0,    0,  179,
    0,    0,  180,    0,  181,  182,  183,  184,    0,  185,
    0,    0,    0,    0,    0,    0,    0,  186,  187,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  188,  189,
    0,  190,  191,  192,    0,    0,    0,    0,  193,  194,
    0,  195,  196,    0,  197,    0,    0,  198,  199,  200,
  201,  202,  203,  204,    0,    0,    0,    0,  205,  206,
  207,    0,  208,  209,  210,    0,  211,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  212,  213,  214,  215,
  216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,    0,  233,  234,
  235,  236,  237,  238,    0,  239,  240,  241,  242,    0,
  243,    0,  244,  245,  246,  247,  248,  249,  250,  251,
  252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
    0,  262,  263,  264,  265,    0,  266,  267,  268,  269,
  270,    0,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,    0,  284,  285,  286,  287,
  288,  289,  113,  290,  114,    0,    0,    0,    0,    0,
  116,    0,    0,  117,  118,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  119,  120,    0,  121,    0,
  122,    0,    0,  123,    0,    0,  124,    0,    0,    0,
    0,    0,    0,  126,    0,  127,  128,    0,    0,    0,
  129,    0,    0,  130,    0,    0,  132, 1648,    0,    0,
    0,    0,    0,    0,    0,    0,  133,  134,    0,    0,
    0,    0,  135,    0,  136,    0,  137,    0,    0,    0,
    0,    0,  139,    0,  140,    0,    0,    0,  141,    0,
    0,    0,    0,    0,    0,    0,  142,    0,    0,    0,
  143,    0,    0,  144,    0,    0,    0,    0,  145,  146,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  147,    0,    0,    0,  148,  149,  150,  151,  152,
    0,  153,    0,    0,    0,    0,    0,  154,    0,  155,
  156,    0,    0,  158,  159,    0,    0,    0,    0,    0,
    0,  160,    0,    0,  162,  163,  164,  165,    0,  166,
    0,  167,    0,  168,  169,  170,  171,  172,    0,    0,
    0,    0,  173,    0,  174,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  176,    0,    0,    0,    0,
  177,  178,    0,    0,    0,  179,    0,    0,  180,    0,
  181,  182,  183,  184,    0,  185,    0,    0,    0,    0,
    0,    0,    0,  186,  187,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  188,  189,    0,  190,  191,  192,
    0,    0,    0,    0,  193,  194,    0,  195,  196,    0,
  197,    0,    0,  198,  199,  200,  201,  202,  203,  204,
    0,    0,    0,    0,  205,  206,  207,    0,  208,  209,
  210,    0,  211,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  212,  213,  214,  215,  216,  217,  218,  219,
  220,  221,  222,  223,  224,  225,  226,  227,  228,  229,
  230,  231,  232,    0,  233,  234,  235,  236,  237,  238,
    0,  239,  240,  241,  242,    0,  243,    0,  244,  245,
  246,  247,  248,  249,  250,  251,  252,  253,  254,  255,
  256,  257,  258,  259,  260,  261,    0,  262,  263,  264,
  265,    0,  266,  267,  268,  269,  270,    0,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,    0,  284,  285,  286,  287,  288,  289,  113,  290,
  114,    0,    0,    0,    0,    0,  116,    0,    0,  117,
  118,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  119,  120,    0,  121,    0,  122,    0,    0,  123,
    0,    0,  124,    0,    0,    0,    0,    0,    0,  126,
    0,  127,  128,    0,    0,    0,  129,    0,    0,  130,
    0,    0,  132,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  133,  134,    0,    0,    0,    0,  135,    0,
  136,    0,  137,    0,    0,    0,    0,    0,  139,    0,
  140,    0,    0,    0,  141,    0,    0,    0,    0,    0,
    0,    0,  142,    0,    0,    0,  143,    0,    0,  144,
    0,    0,    0,    0,  145,  146,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  147,    0,    0,
    0,  148,  149,  150,  151,  152,    0,  153,    0,    0,
    0,    0,    0,  154,    0,  155,  156,    0,    0,  158,
  159,    0,    0,    0,    0,    0,    0,  160,    0,    0,
  162,  163,  164,  165,    0,  166,    0,  167,    0,  168,
  169,  170,  171,  172,    0,    0,    0,    0,  173,    0,
  174,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  176,    0,    0,    0,    0,  177,  178,    0,    0,
    0,  179,    0,    0,  180,    0,  181,  182,  183,  184,
 1783,  185,    0,    0,    0,    0,    0,    0,    0,  186,
  187,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  188,  189,    0,  190,  191,  192,    0,    0,    0,    0,
  193,  194,    0,  195,  196,    0,  197,    0,    0,  198,
  199,  200,  201,  202,  203,  204,    0,    0,    0,    0,
  205,  206,  207,    0,  208,  209,  210,    0,  211,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  212,  213,
  214,  215,  216,  217,  218,  219,  220,  221,  222,  223,
  224,  225,  226,  227,  228,  229,  230,  231,  232,    0,
  233,  234,  235,  236,  237,  238,    0,  239,  240,  241,
  242,    0,  243,    0,  244,  245,  246,  247,  248,  249,
  250,  251,  252,  253,  254,  255,  256,  257,  258,  259,
  260,  261,    0,  262,  263,  264,  265,    0,  266,  267,
  268,  269,  270,    0,  271,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,  283,    0,  284,  285,
  286,  287,  288,  289,  113,  290,  114,    0,    0,    0,
    0,    0,  116,    0,    0,  117,  118,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  119,  120,    0,
  121,    0,  122,    0,    0,  123,    0,    0,  124,    0,
    0,    0,    0,    0,    0,  126,    0,  127,  128,    0,
    0,    0,  129,    0,    0,  130,    0,    0,  132,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  133,  134,
    0,    0,    0,    0,  135,    0,  136,    0,  137,    0,
    0,    0,    0,    0,  139,    0,  140,    0,    0,    0,
  141,    0,    0,    0,    0,    0,    0,    0,  142,    0,
    0,    0,  143,    0,    0,  144,    0,    0,    0,    0,
  145,  146,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  147,    0,    0,    0,  148,  149,  150,
  151,  152,    0,  153,    0,    0,    0,    0,    0,  154,
    0,  155,  156,    0,    0,  158,  159,    0,    0,    0,
    0,    0,    0,  160,    0,    0,  162,  163,  164,  165,
    0,  166,    0,  167,    0,  168,  169,  170,  171,  172,
    0,    0,    0,    0,  173,    0,  174,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  176,    0,    0,
    0,    0,  177,  178,    0,    0,    0,  179,    0,    0,
  180,    0,  181,  182,  183,  184, 2315,  185,    0,    0,
    0,    0,    0,    0,    0,  186,  187,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  188,  189,    0,  190,
  191,  192,    0,    0,    0,    0,  193,  194,    0,  195,
  196,    0,  197,    0,    0,  198,  199,  200,  201,  202,
  203,  204,    0,    0,    0,    0,  205,  206,  207,    0,
  208,  209,  210,    0,  211,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  212,  213,  214,  215,  216,  217,
  218,  219,  220,  221,  222,  223,  224,  225,  226,  227,
  228,  229,  230,  231,  232,    0,  233,  234,  235,  236,
  237,  238,    0,  239,  240,  241,  242,    0,  243,    0,
  244,  245,  246,  247,  248,  249,  250,  251,  252,  253,
  254,  255,  256,  257,  258,  259,  260,  261,    0,  262,
  263,  264,  265,    0,  266,  267,  268,  269,  270,    0,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,    0,  284,  285,  286,  287,  288,  289,
  113,  290,  114,    0,    0,    0,    0,    0,  116,    0,
    0,  117,  118,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  119,  120,    0,  121,    0,  122,    0,
    0,  123,    0,    0,  124,    0,    0,    0,    0,    0,
    0,  126,    0,  127,  128,    0,    0,    0,  129,    0,
    0,  130,    0,    0,  132,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  133,  134,    0,    0,    0,    0,
  135,    0,  136,    0,  137,    0,    0,    0,    0,    0,
  139,    0,  140,    0,    0,    0,  141,    0,    0,    0,
    0,    0,    0,    0,  142,    0,    0,    0,  143,    0,
    0,  144,    0,    0,    0,    0,  145,  146,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  147,
    0,    0,    0,  148,  149,  150,  151,  152,    0,  153,
    0,    0,    0,    0,    0,  154,    0,  155,  156,    0,
    0,  158,  159,    0,    0,    0,    0,    0,    0,  160,
    0,    0,  162,  163,  164,  165,    0,  166,    0,  167,
    0,  168,  169,  170,  171,  172,    0,    0,    0,    0,
  173,    0,  174,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  176,    0,    0,    0,    0,  177,  178,
    0,    0,    0,  179,    0,    0,  180,    0,  181,  182,
  183,  184,    0,  185,    0,    0,    0,    0,    0,    0,
    0,  186,  187,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  188,  189,    0,  190,  191,  192,    0,    0,
    0,    0,  193,  194,    0,  195,  196,    0,  197,    0,
    0,  198,  199,  200,  201,  202,  203,  204,    0,    0,
    0,    0,  205,  206,  207,    0,  208,  209,  210,    0,
  211,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
  222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
  232,    0,  233,  234,  235,  236,  237,  238,    0,  239,
  240,  241,  242,    0,  243,    0,  244,  245,  246,  247,
  248,  249,  250,  251,  252,  253,  254,  255,  256,  257,
  258,  259,  260,  261,    0,  262,  263,  264,  265,    0,
  266,  267,  268,  269,  270,    0,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,    0,
  284,  285,  286,  287,  288,  289,  113,  290,  114,    0,
    0,    0,    0,    0,  116,    0,    0,  117,  118,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  119,
  120,    0,  121,    0,  122,    0,    0,  123,    0,    0,
  124,    0,    0,    0,    0,    0,    0,  126,    0,  127,
  128,    0,    0,    0,  129,    0,    0,  130,    0,    0,
  132,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  133,  134,    0,    0,    0,    0,  135,    0,  136,    0,
  137,    0,    0,    0,    0,    0,  139,    0,  140,    0,
    0,    0,  141,    0,    0,    0,    0,    0,    0,    0,
  142,    0,    0,    0,  143,    0,    0,  144,    0,    0,
    0,    0,  145,  146,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  147,    0,    0,    0,  148,
  149,  150,  151,  152,    0,  153,    0,    0,    0,    0,
    0,  154,    0,  155,  156,    0,    0,  158,  159,    0,
    0,    0,    0,    0,    0,  160,    0,    0,  162,  163,
  164,  165,    0,  166,    0,  167,    0,  168,  169,  170,
  171,  172,    0,    0,    0,    0,  173,    0,  174,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  176,
    0,    0,    0,    0,  177,  178,    0,    0,    0,  179,
    0,    0,  180,    0,  181,  182,  183,  184,    0, 1997,
    0,    0,    0,    0,    0,    0,    0,  186,  187,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  188,  189,
    0,  190,  191,  192,    0,    0,    0,    0,  193,  194,
    0,  195,  196,    0,  197,    0,    0,  198,  199,  200,
  201,  202,  203,  204,    0,    0,    0,    0,  205,  206,
  207,    0,  208,  209,  210,    0,  211,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  212,  213,  214,  215,
  216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,    0,  233,  234,
  235,  236,  237,  238,    0,  239,  240,  241,  242,    0,
  243,    0,  244,  245,  246,  247,  248,  249,  250,  251,
  252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
    0,  262,  263,  264,  265,    0,  266,  267,  268,  269,
  270,    0,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,    0,  284,  285,  286,  287,
  288,  289,   29,  290,   29,    0,    0,    0,    0,    0,
   29,    0,    0,   29,   29,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   29,   29,    0,   29,    0,
   29,    0,    0,   29,    0,    0,   29,    0,    0,    0,
    0,    0,    0,   29,    0,   29,   29,    0,    0,    0,
   29,    0,    0,   29,    0,    0,   29,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   29,   29,    0,    0,
    0,    0,   29,    0,   29,    0,   29,    0,    0,    0,
    0,    0,   29,    0,   29,    0,    0,    0,   29,    0,
    0,    0,    0,    0,    0,    0,   29,    0,    0,    0,
   29,    0,    0,   29,    0,    0,    0,    0,   29,   29,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   29,    0,    0,    0,   29,   29,   29,   29,   29,
    0,   29,    0,    0,    0,    0,    0,   29,    0,   29,
   29,    0,    0,   29,   29,    0,    0,    0,    0,    0,
    0,   29,    0,    0,   29,   29,   29,   29,    0,   29,
    0,   29,    0,   29,   29,   29,   29,   29,    0,    0,
    0,    0,   29,    0,   29,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   29,    0,    0,    0,    0,
   29,   29,    0,    0,    0,   29,    0,    0,   29,    0,
   29,   29,   29,   29,    0,   29,    0,    0,    0,    0,
    0,    0,    0,   29,   29,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   29,   29,    0,   29,   29,   29,
    0,    0,    0,    0,   29,   29,    0,   29,   29,    0,
   29,    0,    0,   29,   29,   29,   29,   29,   29,   29,
    0,    0,    0,    0,   29,   29,   29,    0,   29,   29,
   29,    0,   29,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   29,   29,   29,   29,   29,   29,   29,   29,
   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
   29,   29,   29,    0,   29,   29,   29,   29,   29,   29,
    0,   29,   29,   29,   29,    0,   29,    0,   29,   29,
   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
   29,   29,   29,   29,   29,   29,    0,   29,   29,   29,
   29,    0,   29,   29,   29,   29,   29,    0,   29,   29,
   29,   29,   29,   29,   29,   29,   29,   29,   29,   29,
   29,    0,   29,   29,   29,   29,   29,   29,  716,   29,
  716,    0,    0,    0,    0,    0,  716,    0,    0,  716,
  716,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  716,  716,    0,  716,    0,  716,    0,    0,  716,
    0,    0,  716,    0,    0,    0,    0,    0,    0,  716,
    0,  716,  716,    0,    0,    0,  716,    0,    0,  716,
    0,    0,  716,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  716,  716,    0,    0,    0,    0,  716,    0,
  716,    0,  716,    0,    0,    0,    0,    0,  716,    0,
  716,    0,    0,    0,  716,    0,    0,    0,    0,    0,
    0,    0,  716,    0,    0,    0,  716,    0,    0,  716,
    0,    0,    0,    0,  716,  716,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  716,    0,    0,
    0,  716,  716,  716,  716,  716,    0,  716,    0,    0,
    0,    0,    0,  716,    0,  716,  716,    0,    0,  716,
  716,    0,    0,    0,    0,    0,    0,  716,    0,    0,
  716,  716,  716,  716,    0,  716,    0,  716,    0,  716,
  716,  716,  716,  716,    0,    0,    0,    0,  716,    0,
  716,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  716,    0,    0,    0,    0,  716,  716,    0,    0,
    0,  716,    0,    0,  716,    0,  716,  716,  716,  716,
    0,  716,    0,    0,    0,    0,    0,    0,    0,  716,
  716,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  716,  716,    0,  716,  716,  716,    0,    0,    0,    0,
  716,  716,    0,  716,  716,    0,  716,    0,    0,  716,
  716,  716,  716,  716,  716,  716,    0,    0,    0,    0,
  716,  716,  716,    0,  716,  716,  716,    0,  716,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  716,  716,
  716,  716,  716,  716,  716,  716,  716,  716,  716,  716,
  716,  716,  716,  716,  716,  716,  716,  716,  716,    0,
  716,  716,  716,  716,  716,  716,    0,  716,  716,  716,
  716,    0,  716,    0,  716,  716,  716,  716,  716,  716,
  716,  716,  716,  716,  716,  716,  716,  716,  716,  716,
  716,  716,    0,  716,  716,  716,  716,    0,  716,  716,
  716,  716,  716,    0,  716,  716,  716,  716,  716,  716,
  716,  716,  716,  716,  716,  716,  716,    0,  716,  716,
  716,  716,  716,  716,  329,  716,  329,    0,    0,    0,
    0,    0,  329,    0,    0,  329,  329,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  329,  329,    0,
  329,    0,  329,    0,    0,  329,    0,    0,  329,    0,
    0,    0,    0,    0,    0,  329,    0,  329,  329,    0,
    0,    0,  329,    0,    0,  329,    0,    0,  329,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  329,  329,
    0,    0,    0,    0,  329,    0,  329,    0,  329,    0,
    0,    0,    0,    0,  329,    0,  329,    0,    0,    0,
  329,    0,    0,    0,    0,    0,    0,    0,  329,    0,
    0,    0,  329,    0,    0,  329,    0,    0,    0,    0,
  329,  329,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  329,    0,    0,    0,  329,  329,  329,
  329,  329,    0,  329,    0,    0,    0,    0,    0,  329,
    0,  329,  329,    0,    0,  329,  329,    0,    0,    0,
    0,    0,    0,  329,    0,    0,  329,  329,  329,  329,
    0,  329,    0,  329,    0,  329,  329,  329,  329,  329,
    0,    0,    0,    0,  329,    0,  329,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  329,    0,    0,
    0,    0,  329,  329,    0,    0,    0,  329,    0,    0,
  329,    0,  329,  329,  329,  329,    0,  329,    0,    0,
    0,    0,    0,    0,    0,  329,  329,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  329,  329,    0,  329,
  329,  329,    0,    0,    0,    0,  329,  329,    0,  329,
  329,    0,  329,    0,    0,  329,  329,  329,  329,  329,
  329,  329,    0,    0,    0,    0,  329,  329,  329,    0,
  329,  329,  329,    0,  329,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  329,  329,  329,  329,  329,  329,
  329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
  329,  329,  329,  329,  329,    0,  329,  329,  329,  329,
  329,  329,    0,  329,  329,  329,  329,    0,  329,    0,
  329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
  329,  329,  329,  329,  329,  329,  329,  329,    0,  329,
  329,  329,  329,    0,  329,  329,  329,  329,  329,    0,
  329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
  329,  329,  329,    0,  329,  329,  329,  329,  329,  329,
  113,  329,  114,    0,    0,    0,    0,    0,  116,    0,
    0,  117,  118,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  119,  120,    0,  121,    0,  122,    0,
    0,  123,    0,    0,  124,    0,    0,    0,    0,    0,
    0,  126,    0,  127,  128,    0,    0,    0,  129,    0,
    0,  130,    0,    0,  132,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  133,  134,    0,    0,    0,    0,
  135,    0,  136,    0,  137,    0,    0,    0,    0,    0,
  139,    0,  140,    0,    0,    0,  141,    0,    0,    0,
    0,    0,    0,    0,  142,    0,    0,    0,  143,    0,
    0,  144,    0,    0,    0,    0,  145,  146,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  147,
    0,    0,    0,  148,  149,  150,  151,  152,    0,  153,
    0,    0,    0,    0,    0,  154,    0,  155,  156,    0,
    0,  158,  159,    0,    0,    0,    0,    0,    0,  160,
    0,    0,  162,  163,  164,  165,    0,  166,    0,  167,
    0,  168,  169,  170,  171,  172,    0,    0,    0,    0,
  173,    0,  174,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  176,    0,    0,    0,    0,  177,  178,
    0,    0,    0,  179,    0,    0,  180,    0,  181,  182,
  183,  184,    0,  185,    0,    0,    0,    0,    0,    0,
    0,  186,  187,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  188,  189,    0,  190,  191,  192,    0,    0,
    0,    0,  193,  194,    0,  195,  196,    0,  197,    0,
    0,  198,  199,  200,  201,  202,  203,  204,    0,    0,
    0,    0,  205,  206,  207,    0,  208,  209,  210,    0,
  211,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  212,  213,  214,  215,  216,  217,  218,  219,  220,  221,
  222,  223,  224,  225,  226,  227,  228,  229,  230,  231,
  232,    0,  233,  234,  235,  236,  237,  238,    0,  239,
  240,  241,  242,    0,  243,    0,  244,  245,  246,  247,
  248,  249,  250,  251,  252,  253,  254,  255,  256,  257,
  258,  259,  260,  261,    0,  262,  263,  264,  265,    0,
  266,  267,  268,  269,  270,    0,  271,  272,  273,  274,
  275,  276,  277,  278,    0,  280,  281,  282,  283,    0,
  284,  285,  286,  287,  288,  289,  113,  290,  114,    0,
    0,    0,    0,    0,  116,    0,    0,  117,  118,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  119,
  120,    0,  121,    0,  122,    0,    0,  123,    0,    0,
  124,    0,    0,    0,    0,    0,    0,  126,    0,  127,
  128,    0,    0,    0,  129,    0,    0,  130,    0,    0,
  132,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  133,  134,    0,    0,    0,    0,  135,    0,  136,    0,
  137,    0,    0,    0,    0,    0,  139,    0,  140,    0,
    0,    0,  141,    0,    0,    0,    0,    0,    0,    0,
  142,    0,    0,    0,  143,    0,    0,  144,    0,    0,
    0,    0,  145,  146,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  147,    0,    0,    0,  148,
  149,  150,  151,  152,    0,  153,    0,    0,    0,    0,
    0,  154,    0,  155,  156,    0,    0,  158,  159,    0,
    0,    0,    0,    0,    0,  160,    0,    0,  162,  163,
  164,  165,    0,  166,    0,  167,    0,  168,  169,  170,
  171,  172,    0,    0,    0,    0,  173,    0,  174,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  176,
    0,    0,    0,    0,  177,  178,    0,    0,    0,  179,
    0,    0,  180,    0,  181,  182,  183,  184,    0,  185,
    0,    0,    0,    0,    0,    0,    0,  186,  187,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  188,  189,
    0,  190,  191,  192,    0,    0,    0,    0,  193,  194,
    0,  195,  196,    0,  197,    0,    0,  198,  199,  200,
  201,  202,  203,  204,    0,    0,    0,    0,  205,  206,
  207,    0,  208,  209,  210,    0,  211,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  213,  214,  215,
  216,  217,  218,  219,  220,  221,  222,  223,  224,  225,
  226,  227,  228,  229,  230,  231,  232,    0,  233,  234,
  235,  236,  237,  238,    0,  239,  240,  241,  242,    0,
  243,    0,  244,  245,  246,  247,  248,  249,  250,  251,
  252,  253,  254,  255,  256,  257,  258,  259,  260,  261,
    0,  262,  263,  264,  265,    0,  266,  267,  268,  269,
  270,    0,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,    0,  284,  285,  286,  287,
  288,  289,    0,  290,
};
static int yycheck[] = {                                       8,
   15,    0,   74,   16,   75,  175,   15,   16,   62,   18,
   73,  109,  806,  657,   81,  760, 1115,  657,  573,  574,
  883,   74,   66, 1115,  926,   96,   84, 1062, 1182,  102,
  635,  635,  635,  590,  573,  574,  631,  104,  649,   83,
  919, 1148, 1184,   69, 1446,  594,  100, 1230,  106,  838,
   59,   60,  445,   62,   63,   64,   65,   66,   67,   68,
   69,  105, 1019,  931,   68,   74,   75,   76,  652,   78,
 1185,   80,   81,   99,   83,   84,   85,   86,   87,   94,
  627,   85,  108,   92,  826,   94,   95,   96,  103,   98,
   99,  100,  101, 1163,  103,  104,  105,  106,  107,  108,
  109, 1149,  111,  107,   64, 1374,   63, 1225, 1104,  861,
  592, 1225,  825, 1225, 1212, 1225,  941,  604, 1535, 1133,
   80,   78, 1039, 1132, 1021, 1225, 1030, 1044, 1225,  603,
  569,    0,  926,    0, 1570, 1467,    0,  437, 1790,    0,
   44,    0, 1612,    0,  101,    0,   41,    0,    0,  332,
    0,  544,    0, 1647,  111,  642, 1208,    0,    0,    0,
 1872,   40, 1800, 1080, 1201,    0,  955,    0,   45,    0,
 1087,   44,  650,   44,    0,    0, 1593,   42,   43,   41,
   45,   44,   47, 1141,   63, 1573,    0,    0, 1192,   41,
   59, 2215,   59,  281,    0,   59,   45,    0,   59,   44,
   59, 1637,   59,   41,   59,  297,   59,   59,   41,   59,
   44,   59,  852,   40,    0,   41,   59,   59,   59,   59,
   42,    0, 1746,    0,   59, 1749,   59,   63,   59,  268,
   45,    0,   61,   59,   59,  370,   63, 1194,  273,  393,
  540,   44,  412,   45,   44,   59,   59,  300,   63, 1247,
  303,    0,  323,   59,    0,   41,   59,   40,   44,  326,
 1329,  872,    0,  323, 1188,   59,    0,   40,  343,  327,
   41,    0,   41,   59,   91,   44,  297,  314,    0,  449,
   59,    0,   59,  280,  310, 1816,    0,  302,   45,    0,
   59,  300,  301,  302,  303,  297, 2390,  283, 1195,  308,
  264,  310,  268,  276,   44,  318,  333,  275,   41,  318,
   59,   44,  907,   59,  323,  324,  325,  326,  327,  922,
    0,   59,   40,  332, 1118,   59,  931,  931,  931, 1333,
   59,  394,  341,  395,    0,  265, 1233,   59,  309,    0,
   59,  301,  350,  299, 2086,   59, 1840, 1446,   59,    0,
  338,   46,  451,  452, 1446,  509,   40,  272,  915,  562,
  264,   41,  264,   58,   44,  325,   61,  324,  298, 1114,
  433,  966,  340,  361, 1119, 1120,  546,  934,   44,   59,
   41,  393,  869,  586,  446, 2097, 1095, 1096,  397, 1183,
 2132,  347,  358,   59,  454,  264, 1275,  370,   59, 1835,
  262,  440, 1437,  264,    0,  432,  443, 1149,   59, 2433,
 2434,  432,  277,   93,  264, 2509, 1241,  282,  957,  264,
  335,  456,  264, 1320,  262, 2519, 1472, 1473,  416,  504,
  432,  484,  429,  568,  487, 1618, 1076,  401,  260, 1909,
 1492,   41,   42,   43,   44,   45,   46,   47, 1190,  493,
 1367, 1368,  461, 1467, 1468,  509,  323,    0,  275,  323,
  469,  264,   44,   59,  323,  451,  452,  296,  323,   44,
  323,  559,  950,  444,  482,  484,  539,  299,  487, 1867,
  533,  314, 2506,  335,  493,  494,  498,  579, 1924,    0,
 2014,   91, 1409, 1528, 2018,  335, 1544,   44,   41, 1916,
  509,  374,  335, 1540,  513,   41, 1923, 1776, 1925,  335,
  323, 1300,   41,  296,    0,  377,   59,    0,  343,  532,
  533, 1479,  535,  532,  258, 1594,  535,  536, 2059,  360,
   41,  277, 1864, 1537,  305,  402,  270,  378, 1280,  377,
  593,  335, 2254,  402,  445,  378,  387,  402,   59,    0,
  603,  614,  605,  513,  607,  426, 1570,  610,   41,  568,
  569,   44,  296,  277, 1833,  628,  637,  630,  302,  448,
  304,  448,  639,   59, 1129,  444,   59,  296, 1576, 1577,
 1497, 2219,  640,  646,  593,  448, 1918, 2611, 1330,  402,
  369,    0,  444,  441,  603,  335,  605,  430,  607,  448,
  654,  610,  444,    0, 1346,  374, 1348,    0,   59,  343,
  444,  444,  448,  508,  363, 1008,  451,  452,  444, 1543,
 1727,  448,  399, 1637,  343, 1018,  475, 1166,  637,  638,
  639,  640,   41,  448, 1274, 1532, 2130,  451,  452,  648,
 1557,  444,  442,  652,  653,  654,  448, 1291,  657,  426,
   59, 1291, 2054,  314,  837,  335,  378, 1297, 2075, 2076,
 1263,  399,   59, 1661,  437, 1459,   59,  508,  401, 2193,
  527,  400,  451,  452,  335,  508, 2146,  277, 1635, 2331,
 1779,  638,  282, 1866,  527, 1642,  527, 1779,  648,  400,
 2126,  448,  343,  653,  527, 2407, 1575,  601, 2410,  601,
 1344,  385,  508,  421, 1344,  491, 1006, 1318,  279,  488,
   42,   43,  577,   45,   44,   47, 1327,  318,  475, 1428,
  400,  527,  491,   41,  314,  300,  262,  323,   60,   61,
   62,   44,  601,  600,  316,  602,  603, 1482,  602, 1636,
  601, 1486, 2074,  602, 1283,  264, 1491,  602,  603,  602,
  603,  601,  761,  300, 1806,  534, 1020, 1231, 1583,  601,
   94,  760, 1666, 1202, 1643,   59,  262,   61,  281, 1817,
  504, 1484,  825,  817,    0, 1873,  305, 1801, 1787,    0,
 1262, 1827, 1828,  444,    0,  504,  508, 1336,  281,  302,
  277,  835,  335, 1545, 1536,  282,  575,  806, 1661,  316,
 1193,    0, 2134,  314,  335,  527,  815,  816,  817,  302,
  272,  296,  825,  324,  823,  326,  879,  407,  351,  828,
  829, 1835,   41,   44,  335,   44,  835,  826,  837, 1316,
  883,  314,   42,   59,  405,  257,  297,   47,   59,  308,
 1010,  377,   41,   59,  273,  296,  909,  856,  264,    0,
 1864,  337,  335,  443,  302,  815, 2273, 2274,  343,  816,
   59,  924,  871,  823,  482,  874,  527,  378,  496,  829,
  262,  264,  333, 1897,  883,  388,  387,    0,  931,    0,
 1837,  377,  401,  369,    0,  958,  419,  369,  951,   59,
   41,  260,  343,  511,  276,  408,  856,  960,  369,  296,
   41,  444,  284,   44, 1918,  314,  427,  329,   59,  395,
 1924,  871,  398,  426,  874,  408,  316,  926,  347,  430,
   61,  930,  931, 1534,  393,   41,  335,  936,  414,  425,
  299,  442,  262,  444,  535,  280,   59,  408,   59,  271,
 2272, 1686, 1005,   59,  262,  277,  343,  460, 2055,  374,
  282, 1014, 1015,  285,  440, 2054,  303,  304,  374,  428,
  408,  444, 2054, 1959, 1017, 1609, 2073,  460,  302, 1609,
  439,  432, 2090, 2091, 2044, 2045, 2090, 2091, 2090, 2091,
 2090, 2091, 1861, 1862,  455,  377, 1780,  399,  320, 1783,
 2090, 2091,  257, 2090, 2091,  388,  328,  508,    0,  262,
 2070, 2071,  296,  316,  336, 1552,  488,  281, 1017,  495,
 1108, 1756, 1276,  613,  426,   41,  527, 1914,   44,  504,
 1604,  592,  354, 2292,  356,  508,  426,  548,  302,  515,
  375,   59, 2080,  262,  555,  444,  368,    0,  370,  371,
  372, 1067,  528, 1627,  527, 1044,  559,  377,  264,  441,
  276,  277,  534,  504,  273,  270,  323,   59, 1067,  377,
 2074,  303,  304,    0,  329,    0,  559,  277,  314,   41,
   42,   43,  282,   45,   46,   47, 1615, 1130,   41, 1132,
  295, 1134, 1081,    0,  429,  407,  305,  419,   60,   61,
   62, 1638,  264,  575,  441,    0,   59, 1141,  296, 1108,
  408,  446, 1115,   42,   43, 2507,   45,  504,   47, 1118,
  276, 1900, 2126,  399,  377, 1664, 1905, 2152,  527,   91,
 2134, 1130,   59, 1132,   59, 1134,  303,  304,  347,  321,
 1998, 1184, 1141, 2248,  408,  402,  335,  259, 1201, 1192,
 1149,  264,   59,  264,  370,  312,  313,  269,  377,  347,
 1149, 1160, 1161, 1162,   59,  296, 1219,  378,  374, 1799,
 1800,  276, 2564,  314, 2566, 1228,  387, 1176,    0, 1178,
 2127, 1184,  388,    0, 1183, 1917, 2578,   41, 1231, 1188,
   44, 1730,  401, 1192,  335, 1258,  460,  394,  264,   42,
   43, 1190,   45, 1202,   47,   59,  425,   61,  314,  441,
  315, 1161,  374,  410,  370, 1162, 1259,    0, 2610,   41,
 1263,  343,   44, 2396,   41, 1278, 1176,   44, 1178,  335,
  441,  442, 1231,  332,  259,  391, 1289,   59,  420,    0,
   44,  397,   59, 1331,  269,  427,  264,  456, 1311, 1312,
 1313, 1634,  264,  448, 1799, 1800, 1801,  299, 2390,  347,
 1259, 1895,  374,  374, 1263, 1895,  258,  366, 2272,  448,
   44, 2140,  276,  318,  441,  431,   59,  388,  270,  378,
  475,   41,   42,   43,  606,   45,  391,   47,  261,   93,
 1333, 1280, 1291,  382,  383,  559,  475,  508,   59,  263,
   60,   61,   62,  444,  296,  347,    0, 2404,  374,  271,
  302,  315,  304,  257, 1915,  277,  527,  335, 1317,   93,
  282,    0, 1869,  285, 2231, 1854,  431, 1856,  370,  451,
  452,  258, 1331, 2477, 1333, 1334, 1921, 2072,  444,  264,
 2247, 1330,    0,  270,  308, 1344, 1345,   41,  277,  374,
   44,  343,    0,  282,    0,  319,  374, 1346,  320, 1348,
  317,  314,  374,  451,  452,   59,  328, 1317,  386,  296,
  314,    0, 1460,  330,  336,  302,  284,  304,    0,  271,
   59,  455,  335,  457, 1334,  329,  527,  391,  296,  483,
 1919,  258,  354,  285,  356,   41,  353, 1413,   44,  328,
  265,   59,  508, 1998, 1998, 1998,  368,    0,  370,  371,
  372,   59,   41,   59, 1413,   44,  343,    0, 2507,   41,
    0,  527,   44,  277,  351, 2507,  444,  431, 2212,  297,
   59,    0,   61,  298,  277,  302,  328,   59,  448,  282,
  458, 1484,  296, 1446, 2336, 1479,  403, 1504,   41,  374,
  378,   44,   44,  417,  276,  277,    0,  419, 1506,  395,
 1459, 1460, 1550,  388,  356,  333,   59,  332, 1502,  395,
  461, 1505,  595, 1472, 1473, 2564,   59, 2566,  469,   59,
 1479, 1484, 2564,   41, 2566,  257,   44, 1540,  414, 2578,
   59,  444,  419,  257, 1537, 2348, 2578,  314,  483,  484,
   93,   93,  430, 1502, 1503, 1504, 1505, 1506, 1507,  326,
  446,  271,  504, 1507,    0,   59,  370,  277,  335,    0,
    0, 2610,  282,   44,  260,  285,    0,  419, 2610,  397,
  562, 2315,   42,   43,   44,   45,   46,   47, 1537,  407,
    0,  408,  314, 1596, 1543, 1544,  270, 1536,  370,  260,
  314, 1550, 2336,  318,  586,  508, 1503,  329,   44,  426,
  320,  378,  297,  299,  432,  329, 1629,  318,  328,  391,
  387,  295,   93,   59,  527,  397,  336,  504,   59,   59,
  392,   91,  276,  277,    0,   59,   40,  281,  299, 2219,
  284,   40, 2499,  460,  354,    0,  356, 1640,  333,   59,
 1663, 1654,  296,  697,  351, 1604, 1669,  374,  368,  431,
  370,  371,  372,  430,  451,  452,    0,  260, 1661,  462,
  463,  464,  465,  466,  467,  468,  469,  444, 1627,  258,
  276,  277, 2539,    0,  374,  281, 2420,  384,  284,  386,
    0, 1640,   44,   59,  606, 1644,  275,  276,  277,   59,
  296,   59,  281,    0,   59,  284,  299,   41,  337,  419,
   44,  408, 1661,    0,  758,  759,  760,  296, 1730,   41,
    0,  374,   44,  302, 2219,   59,  370,   61,  260,    0,
    0,  264,  258,  376,    0,  261,  433, 1730,  376,  337,
  369,  508,   59,    0, 1644,  260,    0,  391,    0,   59,
    0,   42,   43,  397,   45,    0,   47,  332,   42,   43,
  527,   45,   59,   47,  606,  259,  395,  299,  333,  398,
  264, 1726,   59,    0,  370,  269,  302, 1726,  571,   59,
  264, 1730,  264,  407,  299,  414,    0,  431,   59,   59,
    0,  370,  335,   59, 1787,  391,   41,  395,  260,   44,
  398,  397,   59,   41,  597,   59,   44,   59,  386,   59,
  434,  440,  391,   46,   59,   44,  414,  277,  397,  332,
  444,   59,  282,   61,    0,   58, 1779,  406,   61,  408,
  408, 1780,   59,    0, 1783,  431,    0,  299, 1787,    0,
  434,  374,  440,  887,    0,   59,  890,  426,    0,   59,
  444,  895,  431,  366,  898,  388, 1809,  400,  902,  408,
 1809,    0,    0,  308,    0,  378,  495, 1816, 1817,   42,
   43,   44,   45,   46,   47,    0, 1825, 1826, 1827, 1828,
  374,  460,   40,   59, 2569,   41,  515, 2471,   44, 1838,
  374, 2471,   59,    0,  388,   59,  606,  495,   59,  528,
  483,  595,  386,   59,  264,   61,  264,   59,  432,  264,
  493,   41,    0,  258,   44,  559, 1495,  515,   91, 1498,
   59,   59,  598,   59,  258,  270,   41, 1930,    0,   44,
  528,   61,  608,  609,   59,   91,   41,   41, 1838,   44,
   44,  275,  276,  277, 1947, 1825, 1826,  281,  393, 1952,
  284,  444,   59,   41,  264,   41,   44,  302,   44,  304,
  444,   59,  296,  559,   41, 1825, 1826,   44,  302,   41,
   41,   59,   44,   44,  458,  335,   40,  335, 1917,  424,
  559,  515,   41,  428,  264,   44,  277,   59,  899,   41,
  901,  282,   44,  277,  439,   41,   42,   43,  282,   45,
 1044,   47,  462,  463,  464,  465,  466,  467,  468,  469,
   46, 2417,  264, 2419,  374,   41,  374,  414,   44,  374,
 1064,  264,   58,   59, 1068,   61,  386, 1071,  386, 2090,
 2091,  451,    0,  388, 1989, 1079,  370, 1081,  312,  277,
 1989, 1085, 1086,  386,  258, 1089, 1090, 1091, 1092, 1093,
 1094, 1095,  314, 1097,  264, 1099,  270,  391,  296,   41,
 2251, 2252,   44,  397,  374, 1109, 1110, 1111, 1112, 1113,
 1114,  424,  332, 1117,  408, 1119, 1120,  442,  388, 2117,
  337,  401,   41,  331,  444,   44,  444,  424,  302,  393,
  304,   59,  426,  335,  374,  491,   59,  431,  458,  316,
  458, 2054,  258, 2056,  277,  260,  314, 2056,  388,  282,
 2059,  571,  369,   41,    0,  560,   44,  273,  314,  275,
  276,  277,  374,  374,   41,  281,  460,   44,  284,   41,
   59, 2080,   44,    0,  374,  426,  388,  597,  395,  496,
  296,  398,  426, 1187,  426, 2255,  302, 2096, 2258,  305,
  355,   41,  424, 2102,   44,   41,   41,  414,   41,   44,
  296,   44,  532, 1063,  374, 1065,  264,  531, 2117, 1069,
 1070, 2183, 1072,   59,   41,  529,  335,   44,  388, 2128,
   41,   42,   43,  440,   45,   41,   47, 2181,   44,  264,
 2183,  347,   59,  424,   61,  375, 2096,   41, 1098,  408,
   44,  318, 2102, 2215,  276,  277,   46,  343,   42,   43,
   44,   45,   46,   47,  370,  351,  336,  495,   58,   59,
  317,   61, 2215, 2178,  373,  559,  314,   46, 2128, 2178,
  273,  277, 2181,  330, 2183,  391,  282,  335,  495,   58,
   59,  397,   61,   41,  508,  401,   44,  335,  384,  504,
  386,   41,  408,  459,   44,  408,  353,   91,  515,   42,
   43,  296,   45, 2212,   47, 2259, 2215,  503,  314,  366,
  426,  528,  408,  503,  305,  431,  374,  374,   42,   43,
  264,   45, 2285,   47,   41,   44, 2289,   44,  386,  462,
  463,  464,  465,  466,  467,  468,  469,  433,  370,   41,
  456,  264,   44,  268,  460,  600,  403, 1351, 1352, 1353,
 2259,   46, 1356, 1357, 1358,   46, 1360, 1361, 1362,  391,
 1364, 1365, 1366,   58,   59,  397,   61,   58,   59,   61,
   61, 1375, 1376,  444, 1378,  264, 1380,    0,  283, 1383,
 1384, 1385, 1386,  364, 1388, 1389,  444,  387,   40,   42,
   43,  264,   45,  260,   47, 2348,  444,   40,   40,  431,
  458, 1405,   41, 1407, 2313,   44, 2315,   41,  504,  337,
   44,   41,  335,   41,   44,   40,   44,   41,   41, 1423,
   44,   44,   41,   40,  451,   44,   40, 2336, 1432, 1433,
  297,  258,   40,   40,  491,   40,   59, 2390,  571, 2348,
   40,  369,  309,  559,  492,   40,  335,  451,   40,  276,
  277,  374, 2423,  451,  281,  512,  277,  284,    0,   40,
  508,  282,   40,  386,  597,   40,  333,  395,  314,  296,
  398,   40,  350,   40,   40,  302,   40, 2390, 1482,  527,
  326, 2390, 1486,  277,   40,  374,  414, 1491,  282,  335,
   40, 2390,   40,   40,   40,  316,   40,  386, 2469, 2335,
   42,   43,   44,   45,   46,   47,   40,   40, 2417,    0,
 2419, 2420,  440,  400, 2423,   91,   44,   59,   60,   61,
   62,  444,   46, 2432, 2433, 2434, 2479,   40,   40,   61,
  397,   40,  378,  264,  277,  458,  434,  393,  316,  282,
  407,  387, 1546,  370, 1548, 1549,  530,  438,   44,   91,
   41,  314,  418,  277,   46,  444,   61,   40,  282,   40,
 2469, 2470,  336,  264,  391,  432, 2479,  495,   59,  458,
  397,  314,   46,   42,   43,   44,   45,   46,   47,  343,
  296,  408,  343,  343,  430,   42,   43,  515,   45,  276,
   47,  363,  316,  264, 2507,    0,    0, 2506,  444,  426,
  528,  388,   42,   43,  431,   45,  426,   47,   42,   43,
 2509,   45,  388,   47,  603,  454,  448,  275,  343,  437,
 2519,  390,   91,  437,  277,   40,  344,   40,   91,  282,
 2529,   40,   40,  460,  316,  264,   41,   41,   40,   44,
  374,   42,   43,  448,   45,    0,   47,  401,  447,  448,
  449, 2564,   44, 2566,   59,   59,   40,  380,  373,   40,
  441,   41,  508,  316,  378, 2578,  314,  373,  462,  463,
  464,  465,  466,  467,  468,  469,  475,  476, 2587,  277,
 2516,  527, 1686,  454,  370,  275,   41,   63,  426,   44,
  426,  314,  313,  527,   40, 1699, 1700, 2610, 1702, 1703,
   40,  324, 2611,  326,   59, 2614,   61, 1711,  438, 1713,
   40,  444,  335,  264,   40,  338,  336,   44,  273,  316,
  262,   44,   44,   42,   43,  517,   45, 2563,   47,  271,
 1734,   40,  559,  536,  296,  277, 1740,   40,  339, 1743,
  282, 1745, 1746,  285, 2580, 1749,    0, 1751,  339,  602,
  377, 1755, 1756, 1757,  408,  378,  604,  406,  408,  377,
 1764,  377, 1766, 2599,  387, 1769, 1770, 1771, 1772,   40,
  264, 1775,  314, 2609,  351,  317, 2612,  571,  320,   40,
   40,  426,  324,   40,  326,   41,  328,   41,  330,  361,
   44, 2627,   44,  335,  336,  316,  338,   41,   44,  277,
   41,   44,  347,  597,   46,   59,  376,  430,  277,  273,
    0,  353,  354,  282,  356,   41,   41,  360,  379,  442,
  277,  444,  338,  314,  366,  282,  368,    0,  370,  371,
  372,  338,  374,   44,   44,  377,  378,  277,  434,  316,
  316,   41,  282,  277,  335,  387,  492,  266,  282,  442,
  264,  284,   42,   43,   44,   45,   46,   47,  491,  316,
  444,  403,   41,  412,  264,  347, 1870,  307,   41,   59,
   60,   61,   62,  307,   58,   41,  277,  419,   41,   42,
   43,  282,   45,  425,   47,  508,   59,  378,  430,   41,
   41,  264,  323,   40,  575,  385,  387,    0,  305,  441,
  442,   91,  444,  258,  527,  590,  307,  305,   41,  314,
  314,   41,   42,   43,   44,   45,   41,   47,  273,  324,
   40,  326,  277,   40,   40,  316,  281,   40,   40,   40,
  335,  335,   40,  338,   40,   40,   40,  426,   41,  430,
   40,  296,   40,    0,   40,   40,   40,  302,   40,  491,
  305, 1955,  262,  444,  425,  304,   59, 1961,  277,  426,
  295,  338, 1966,  282,  444,   40,  508,   44,  324, 1973,
  512, 1975,    0,  378,  378,   42,   43,   44,   45,  382,
   47,  397,  387,  387,   41,  527,  454,   44,  307,  377,
  377,  377,  347,  462,  463,  464,  465,  466,  467,  468,
  469,  454,   59,   42,   43,  377,   45,  377,   47,  377,
 2014,  317,   40,   41, 2018,  370,   44,  508,    0,  517,
 2024, 2025,  276,  277,  330,  430,  430, 2031,  276,  317,
  284,   59,  338,   61,   41,   41,  527,  442,  448,  444,
  444,  374,  330,   40,  316,   41,  401,  353,   41,   41,
   41,  304,  373,  408,   44,   41,  425,   41,   40,   41,
  366,   41,   44,   91,  606,  353,  270,    0, 2072,   46,
  436,  426,  262,  323,  426,  273,    0,   59,  366,   61,
 1356,  271, 1358,   45, 1360, 1361,  374,  277, 1364, 1365,
 1366,  441,  282,  317,  441,  285,  326,  403,  332,  339,
  432,  456,  571,  508,  508,  460,  330,  432,   41,   91,
  333,   44,  297,  333,  277,  403,  370,   41,  376,  282,
  374,  297,  527,  527,  314,   41,   59,  317,  597,  353,
  320,   41,   41,  279,  324,   59,  326,  391,  328,   41,
  330,  314,  366,  397,  458,  335,  336,  277,  338,  363,
  458, 2155,  282,  326,  363,   41,   41, 2161, 2162,   41,
   41,   41,  335,  353,  354, 2169,  356,   41,   41,   41,
   41,   41,   41,   41,   41,   41,  366,  431,  368,  403,
  370,  371,  372,   41,  374, 2189,   40,  377,  378, 2193,
   41,   40,  425, 2197,  376,  370,   41,  387, 2202, 2203,
 2204, 2205, 2206,  568,  559,  378,  512, 2211,  568,  456,
  277,  314,  441,  403,  387,  282,  304,  332,   59,  276,
  277,  324,  290,  326,  512,  432,  265,  284,  425,  419,
  258,  569,  335,   44,  374,  425,   44,  491,  277,  508,
  430,  508, 2246,  282,   41,  273,   40,  275,  276,  277,
   46,  441,  442,  281,  444,  333,  284,  430,  314,  298,
   41,   42,   43,  408,   45,  374,   47,  374,  296,   41,
   40,  444,  335,  335,  302,  378,  258,  305,  337,   59,
 2284,  598,   58,   40,  387,  297,   41,    0,  512,  432,
  427,  273,   40,  275,  276,  277, 2300,   44,  434,  281,
  453,  491,  284,   41,   42,   43,  300,   45,  335,   47,
  369,  498,  335,  370,  296,   41,   40,    0,  508,  347,
  302,  335,  512,  305,  312,   40,  425,  430,   41,  300,
  292,   44,  433,  611,  391,  508,  395,  527,  427,  398,
  397,  444,  370,  276,  277,  392,   59,  427,  303,  290,
  335,  284,  300,  407,  527,  414,    0,  319,   41,   42,
   43,   44,   45,  391,   47,  347,  332,  407,  613,  397,
  374,  374,  264,  401,  431,  264,   59,   60,   61,   62,
  408,  440, 2386,   40, 2388,  347,  264,  407,  370,   40,
  314,   41,   42,   43,   41,   45,  448,   47,  426,  401,
  324, 2405,  326,  431,  441,  508,   44,  338,  434,  391,
   93,  335,  316,   40,   40,  397,  606,   41,  338,  401,
  264,   41,   41,  448,  527, 2429,  408,  425,  456,  448,
   41,   41,  460,   41,  491,   41,  495,  370,   41,   41,
   41,   41,   42,   43,  426,   45,   59,   47,  304,  431,
   59,  335,   59,  300,  378,  417,  515,  260,  391,   40,
   59,   59,   59,  387,  397,   59,   41,   42,   43,  528,
   45,  433,   47,   59,  456,  484,  527,   44,  460,  369,
   41,  369,   41,   41,   41,  447,  448,  449,  307,  451,
  452,  527,  527, 2497, 2498, 1794,  277, 2390,  431,  601,
 2390,  282, 2390, 2390, 2390, 2390,  430,  307,  470,  471,
  472,  473,  474,  475,  476,  477,  478,  833, 1162,  308,
  444,  495,  835,  485,  486, 2529,  494, 1666, 1337, 1026,
 1664,  559,  494,   98, 1344, 1291,   86, 1639, 1661,  277,
 1240, 1619, 1869,  966,  282, 1655, 2550,  632, 2552, 2079,
 1555, 1640,  605,  542, 2363,  605, 1867,  936,  491, 2409,
 2408, 2565, 2485,  276,  277, 2569, 1231, 2571, 2572, 2475,
 2565,  284, 1468, 2583,  257,  258,  259,  559, 2614,  262,
  761,  264,  265, 2587,  508,  268,  269, 2616,  271, 2554,
 2432, 2394, 2517,  276,  277, 1130,  595,  280,  281,  282,
  283,  284,  285,  527, 2608,  288, 1906,  938,  291,  610,
  588, 1308, 2616, 1003, 2618,  298, 1299,  300,  301,  302,
  303,  304,  305,   13,  307,  308,  520,  277,  311,  309,
  845,  314,  282,  316,  317,  840, 1176,  320,  321,  322,
 2223,  324,  576,  326,  327,  328,  329,  330,  331, 1546,
 1149, 2405,  335,  336,  337,  338,  339,  370, 1496, 2178,
  343, 1989, 1061, 1548, 2063, 2062, 2479,  861,  351, 2403,
  353,  354,  355,  356, 2390,  358, 1501,  277,  391, 2390,
  363,  364,  282,  366,  397,  368, 1159,  370,  371,  372,
 1701,  374,  615,  376,  377,  378,  447,  380,  381,  382,
  383,  384,  277,  386,  387, 1884, 1646,  282,  391,  392,
    0,  394,  395,  689,  397,  398,  399,  400,  431, 1774,
  403, 1558, 1751,  406,   -1,  408,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,  425,  426,  427,   -1,  429,  430,  431,   -1,
   40,   41,   -1,   -1,   44,   -1,   -1,  440,  441,  442,
   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,   59,
  453,   -1,  455,  456,  457,  458,   -1,  460,  491,  462,
  463,  464,  465,  466,  467,  468,  469,   -1,   42,   43,
   -1,   45,   46,   47,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   59,  489,  490,  491,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,
  513,  514,  515,   -1,  517,   -1,   -1,   91,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,    0,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,  606,  607,  608,  609,  610,  611,  612,
   -1,  614,   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,  275,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  291,  301,   42,   43,   -1,   45,   -1,   47,  308,
   -1,  301,   -1,  312,  313,   -1,  276,  277,  308,   91,
   -1,   93,  321,   -1,  284,   -1,   -1,   -1,   -1,   -1,
   -1,  321,   -1,  332,   -1,   -1,  296,   41,   42,   43,
  264,   45,   -1,   47,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,
  462,  463,  464,  465,  466,  467,  468,  469,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,  385,  377,   -1,   41,
   42,   43,   -1,   45,  393,   47,   -1,   -1,   -1,   -1,
   41,   42,   43,  393,   45,   -1,   47,   -1,   -1,   -1,
  370,  335,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  409,
   41,   42,   43,   -1,   45,  424,   47,   -1,   -1,  428,
   -1,  391,   -1,   -1,  424,   -1,   -1,  397,  428,   -1,
  439,  431,   -1,  433,   -1,   -1,   -1,   -1,   -1,  439,
  374,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  458,
  459,   -1,  386,   -1,   -1,   -1,   -1,   -1,  458,  571,
   -1,  431,   -1,   41,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,
  262,   -1,  264,  265,   -1,  597,  268,  269,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,
  282,  283,  277,  285,   -1,  514,  288,  282,  517,  291,
  444,   -1,   -1,   -1,  514,  264,  298,  517,  300,  301,
   -1,  303,  304,  305,  458,  307,  308,   -1,  277,  311,
   -1,   -1,  314,  282,  316,  317,   -1,   -1,  320,  321,
  322,   -1,  324,   -1,  326,  327,  328,  329,  330,  331,
   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,
  560,  343,   -1,  277,   -1,   -1,   -1,   -1,  282,  351,
  277,  353,  354,  355,  356,  282,  358,   -1,   -1,   -1,
   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,
  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,
  382,  383,  384,  277,  386,  387,   -1,   -1,  282,   -1,
  392,    0,  394,  395,   -1,  277,  398,  399,  400,   -1,
  282,  403,   -1,   -1,  406,   -1,  277,  409,  410,  411,
  412,  282,  414,   -1,  416,   -1,  418,  419,  420,  421,
  422,   -1,   -1,  425,  426,  427,  277,  429,  430,   -1,
   -1,  282,   41,   -1,   -1,   44,   -1,   -1,  440,  441,
  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,
   59,  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,
  462,  463,  464,  465,  466,  467,  468,  469,   -1,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,  479,  480,  277,
  482,  483,  484,   -1,  282,   -1,   59,  489,  490,  491,
  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,
  512,  513,  514,  515,   -1,  517,   41,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,    0,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,  606,  607,  608,  609,  610,  611,
  612,  613,  614,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  276,  277,   -1,
   91,   -1,   93,   -1,   -1,  284,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   41,   42,   43,  296,   45,   -1,
   47,  264,   -1,   -1,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   42,   43,   -1,   45,
   -1,   47,  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,
   -1,  370,  335,   -1,   -1,   -1,   41,   42,   43,   -1,
   45,   -1,   47,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,  391,   -1,   -1,   -1,   -1,   -1,  397,   -1,
   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,  374,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  386,   41,   42,   43,   -1,   45,   -1,
   47,   -1,  431,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,
  281,  282,  283,  277,  285,   -1,   -1,  288,  282,   -1,
  291,  444,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,  303,  304,  305,  458,  307,  308,   -1,  277,
  311,   -1,   -1,  314,  282,  316,  317,   -1,   -1,  320,
  321,  322,   -1,  324,   -1,  326,  327,  328,  329,  330,
  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,
  277,   -1,  343,   -1,   -1,  282,   -1,   -1,   -1,   -1,
  351,  277,  353,  354,  355,  356,  282,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,
  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,
  381,  382,  383,  384,  277,  386,  387,   -1,  264,  282,
   -1,  392,    0,  394,  395,  277,   -1,  398,  399,  400,
  282,  277,  403,   -1,   -1,  406,  282,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,  277,   -1,  425,  426,  427,  282,  429,  430,
  277,   -1,   -1,   41,   -1,  282,   44,   -1,   -1,  440,
  441,  442,   -1,  444,  445,  446,   -1,   -1,  277,  450,
   -1,   59,  453,  282,  455,  456,  457,  458,   -1,  460,
   -1,  462,  463,  464,  465,  466,  467,  468,  469,   -1,
  277,   -1,   -1,   -1,   -1,  282,   -1,   -1,  479,  480,
  277,  482,  483,  484,   -1,  282,   -1,   -1,  489,  490,
  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,
  511,  512,  513,  514,  515,   -1,  517,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
    0,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  606,  607,  608,  609,  610,
  611,  612,  613,  614,   -1,   -1,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,   41,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   41,   42,   43,  261,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  276,  277,
   -1,   91,   -1,   93,   -1,  279,  284,   -1,   -1,   -1,
   -1,   -1,   -1,  287,   -1,   -1,   -1,   -1,  296,   42,
   43,  295,   45,  297,   47,   -1,   -1,   -1,  302,   -1,
   -1,   -1,   -1,   -1,   -1,  309,   41,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,  323,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  333,
   -1,   -1,   -1,   -1,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,   41,   42,   43,   -1,
   45,   -1,   47,  277,   -1,   -1,   -1,  361,  282,   -1,
   -1,   -1,  370,   -1,   -1,   -1,   -1,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   -1,  391,   -1,   -1,   -1,   -1,   -1,  397,
   -1,  395,   -1,   -1,   42,   43,   44,   45,  402,   47,
   -1,  405,   -1,   -1,  408,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   42,   43,   44,   45,   -1,
   47,   42,   43,  431,   45,   -1,   47,   -1,  432,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,
  444,   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
  280,  281,  282,  283,  277,  285,   -1,   -1,  288,  282,
   -1,  291,   -1,   -1,   -1,   -1,   -1,  481,  298,   -1,
  300,  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,
  277,  311,  496,  497,  314,  282,  316,  317,   -1,   -1,
  320,  321,  322,   -1,  324,   -1,  326,  327,  328,  329,
  330,  331,   -1,   -1,  518,  335,  336,  337,  338,  339,
   -1,   -1,   -1,  343,  277,   -1,   -1,   -1,   -1,  282,
   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,
   -1,   -1,  277,  363,  364,   -1,  366,  282,  368,   -1,
  370,  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,
  380,  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,
   -1,  277,  392,    0,  394,  395,  282,   -1,  398,  399,
  400,   -1,  277,  403,   -1,   -1,  406,  282,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,
  420,  421,  422,  277,   -1,  425,  426,  427,  282,  429,
  430,  277,   -1,   -1,   41,   -1,  282,   44,   -1,   -1,
  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,  277,
  450,   -1,   59,  453,  282,  455,  456,  457,  458,   -1,
  460,  262,  462,  463,  464,  465,  466,  467,  468,  469,
  277,   -1,   -1,   -1,   -1,  282,  277,   -1,   -1,  479,
  480,  282,  482,  483,  484,   -1,   -1,   -1,   -1,  489,
  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,
  510,  511,  512,  513,  514,  515,   -1,  517,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,    0,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,  606,  607,  608,  609,
  610,  611,  612,  613,  614,   -1,   -1,   -1,  275,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,   -1,
   42,   43,   44,   45,  291,   47,   -1,   -1,   -1,   58,
   59,   60,   61,   62,  301,   -1,   -1,   -1,   -1,   -1,
   -1,  308,   -1,   -1,   -1,  312,   42,   43,   44,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  276,
  277,   -1,   91,   -1,   93,  332,   -1,  284,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  296,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
  301,   -1,   -1,   -1,   -1,   -1,   -1,  308,   -1,   -1,
   -1,  312,  313,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  321,   -1,   -1,   -1,   -1,   -1,  393,   -1,  262,   -1,
   -1,  332,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,   -1,   -1,  282,   -1,
   -1,   -1,   -1,  370,   -1,   -1,   -1,  424,   -1,   -1,
   -1,  428,   -1,   -1,   -1,   -1,  433, 1956, 1957,   -1,
   -1,   -1,  439,   -1,  391, 1964, 1965,   -1, 1967, 1968,
  397,   -1,   -1,   -1,   -1,   -1,   -1, 1976, 1977, 1978,
 1979,  458,  393, 1982, 1983, 1984, 1985, 1986, 1987,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  409,   -1,
   -1,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  424,   -1,   -1,   -1,  428,  257,   -1,
  259,   -1,  433,  262,   -1,  264,  265,   -1,  439,  268,
  269,   -1,  271,   -1,   -1,   -1,   -1,  514,  277,   -1,
   -1,  280,  281,  282,  283,  277,  285,  458,   -1,  288,
  282,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,  308,
   -1,  277,  311,   -1,   -1,  314,  282,  316,  317,   -1,
   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,  328,
  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,
  339,   -1,   -1,  514,  343,  277,  517,   -1,   -1,   -1,
  282,   -1,  351,  277,  353,  354,  355,  356,  282,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,
   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,  378,
   -1,  380,  381,  382,  383,  384,   -1,  386,  387,   -1,
   -1,   -1,   -1,  392,    0,  394,  395,   -1,   -1,  398,
  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,
  429,  430,   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,
   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,
   -1,  450,   -1,   59,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,  462,  463,  464,  465,  466,  467,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,
  509,  510,  511,  512,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,    0,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,  606,  607,  608,
  609,  610,  611,  612,  613,  614,   -1,  272,   -1,   -1,
  275,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,   -1,  288,   -1,   -1,   -1,  292,   -1,  294,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  276,  277,   -1,   91,   -1,   93,   -1,   -1,  284,  334,
  272,   -1,   -1,  275,   -1,  340,  341,  342,   -1,  344,
  345,  346,   -1,  348,   -1,   -1,  288,   -1,   -1,   -1,
  292,   -1,  294,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  365,   -1,  367,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  396,  334,   -1,   -1,   -1,  401,   -1,  340,  341,
  342,   -1,  344,  345,  346,   -1,  348,   -1,  413,   -1,
   -1,   -1,   -1,   -1,  370,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  365,   -1,  367,   -1,   -1,   -1,   -1,
  435,   -1,   -1,   -1,   -1,  391,   -1,   -1,   -1,   -1,
   -1,  397,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  396,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  470,  471,   -1,   -1,   -1,
   -1,  413,   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,
   -1,   -1,  487,   -1,   -1,   -1,   -1,   -1,   -1,  257,
   -1,  259,   -1,  435,  262,   -1,  264,  265,   -1,   -1,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,  470,  471,
  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,
  308,   -1,   -1,  311,   -1,  487,  314,   -1,  316,  317,
   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,
  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,
  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,
  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,
  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,
  378,   -1,  380,  381,  382,  383,  384,   -1,  386,  387,
   -1,   -1,   -1,   -1,  392,    0,  394,  395,   -1,   -1,
  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,
  418,  419,  420,  421,  422,   -1,   -1,  425,  426,  427,
   -1,  429,  430,   -1,   -1,   -1,   41,   -1,   -1,   44,
   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,
   -1,   -1,  450,   -1,   59,  453,   -1,  455,  456,  457,
  458,   -1,  460,   -1,  462,  463,  464,  465,  466,  467,
  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,
   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
  508,  509,  510,  511,  512,  513,  514,  515,   -1,  517,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,    0,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,  606,  607,
  608,  609,  610,  611,  612,  613,  614,   -1,  272,   -1,
   -1,  275,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,  288,   -1,   -1,   -1,  292,   -1,
  294,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  276,  277,   -1,   91,   -1,   93,   -1,  272,  284,
  334,  275,   -1,   -1,   -1,   -1,  340,  341,  342,   -1,
  344,  345,  346,   -1,  348,   -1,   -1,   -1,  292,   -1,
  294,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  365,   -1,  367,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  334,   -1,  396,   -1,   -1,   -1,  340,  341,  342,   -1,
  344,  345,  346,   -1,  348,   -1,   -1,   -1,   -1,  413,
   -1,   -1,   -1,   -1,   -1,  370,   -1,   -1,   -1,   -1,
   -1,  365,   -1,  367,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  435,   -1,   -1,   -1,   -1,  391,   -1,   -1,   -1,
   -1,   -1,  397,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  470,  471,   -1,  413,
   -1,   -1,   -1,   -1,   -1,   -1,  431,   -1,   -1,   -1,
   -1,   -1,   -1,  487,   -1,   -1,   -1,   -1,   -1,   -1,
  257,  435,  259,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,  470,  471,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,
  307,  308,   -1,  487,  311,   -1,   -1,  314,   -1,  316,
  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,
  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,
  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,
   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,
  377,  378,   -1,  380,  381,  382,  383,  384,   -1,  386,
  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,  426,
  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,  462,  463,  464,  465,  466,
  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,  508,  509,  510,  511,  512,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,    0,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,  606,
  607,  608,  609,  610,  611,  612,  613,  614,  272,   -1,
   -1,  275,   -1,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,   -1,   -1,   -1,   -1,  272,   -1,  292,  275,
  294,   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  292,   -1,  294,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,
  334,   -1,   -1,   -1,   -1,   -1,  340,  341,  342,   -1,
  344,  345,  346,   -1,  348,   -1,   -1,   -1,  334,   -1,
   -1,   -1,   -1,   -1,  340,  341,  342,   -1,  344,  345,
  346,  365,  348,  367,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  365,
   -1,  367,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  413,
  396,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  413,   -1,   -1,
   -1,  435,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  435,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  470,  471,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  487,  470,  471,   -1,   -1,   -1,   -1,
   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,
   -1,  487,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,
   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,
   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,
   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,
  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,
  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,
  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,
  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,
  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,
  376,  377,  378,   -1,  380,  381,  382,  383,  384,   -1,
  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,
  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,
  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,
  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,
  456,  457,  458,   -1,  460,   -1,  462,  463,  464,  465,
  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,
   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,  508,  509,  510,  511,  512,  513,  514,  515,
   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,    0,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
  606,  607,  608,  609,  610,  611,  612,  613,  614,   -1,
   -1,   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,
  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,
   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,
   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,
  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,
  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,
   -1,  376,  377,  378,   -1,  380,  381,  382,  383,  384,
   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,  462,  463,  464,
  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,    0,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,  606,  607,  608,  609,  610,  611,  612,  613,  614,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,
   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,
   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,
  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,
  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,
  324,   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,
   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,
  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,
  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,
  374,   -1,  376,  377,  378,   -1,  380,  381,  382,  383,
  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,
  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,
  414,   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,
   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,
  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,
   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,  463,
  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,
  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,
   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,
  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,    0,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,  606,  607,  608,  609,  610,  611,  612,  613,
  614,   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,
   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,
   -1,  324,   -1,  326,  327,  328,  329,  330,  331,   -1,
   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,
   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,  382,
  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,
  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,
   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,
  463,  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,    0,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,  606,  607,  608,  609,  610,  611,  612,
  613,  614,   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,
   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,
  282,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,
   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,
   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,
  322,   -1,  324,   -1,  326,  327,  328,  329,  330,  331,
   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,
   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,
   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,
  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,
  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,
   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,
  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,
  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,
   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,
  462,  463,  464,  465,  466,  467,  468,  469,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,
  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,
  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,
  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,    0,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,  606,  607,  608,  609,  610,  611,
  612,  613,  614,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,
  281,  282,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,
  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,
  321,  322,   -1,  324,   -1,  326,  327,  328,  329,  330,
  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,
  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,
  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,
   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,  462,  463,  464,  465,  466,  467,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,
  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
    0,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  606,  607,  608,  609,  610,
  611,  612,  613,  614,   -1,   -1,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,   -1,
   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,
   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,
  320,  321,  322,   -1,  324,   -1,  326,  327,  328,  329,
  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,
   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,
  370,  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,
  380,  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,
  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,
  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,
  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,
  460,   -1,  462,  463,  464,  465,  466,  467,  468,  469,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,
  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,
  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,
  510,  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,    0,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,  606,  607,  608,  609,
  610,  611,  612,  613,  614,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,
  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,
  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,  308,
   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,
   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,  328,
  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,
   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,  378,
   -1,  380,  381,  382,  383,  384,   -1,  386,  387,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,
  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,  462,  463,  464,  465,  466,  467,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,
  509,  510,  511,  512,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,    0,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,  606,  607,  608,
  609,  610,  611,  612,  613,  614,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,
  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,
   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,
  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,
  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,
  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,
  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,
  378,   -1,  380,  381,  382,  383,  384,   -1,  386,  387,
   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,
  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,
  418,  419,  420,  421,  422,   -1,   -1,  425,  426,  427,
   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,
   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,
  458,   -1,  460,   -1,  462,  463,  464,  465,  466,  467,
  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,
   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
  508,  509,  510,  511,  512,  513,  514,  515,   -1,  517,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,    0,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,  606,  607,
  608,  609,  610,  611,  612,  613,  614,   -1,   -1,   -1,
   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,
  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,
  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,
  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,
  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,
   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,
  377,  378,   -1,  380,  381,  382,  383,  384,   -1,  386,
  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,  426,
  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,  462,  463,  464,  465,  466,
  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,  508,  509,  510,  511,  512,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,    0,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,  606,
  607,  608,  609,  610,  611,  612,  613,  614,   -1,   -1,
   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,
   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,
   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,
   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,
   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,
  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,
  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,
  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,
  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,
  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,
  376,  377,  378,   -1,  380,  381,  382,  383,  384,   -1,
  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,
  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,
  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,
  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,
  456,  457,  458,   -1,  460,   -1,  462,  463,  464,  465,
  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,
   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,  508,  509,  510,  511,  512,  513,  514,  515,
   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,    0,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
  606,  607,  608,  609,  610,  611,  612,  613,  614,   -1,
   -1,   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,
  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,
   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,
   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,
  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,
  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,
   -1,  376,  377,  378,   -1,  380,  381,  382,  383,  384,
   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,  462,  463,  464,
  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,    0,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,  606,  607,  608,  609,  610,  611,  612,  613,  614,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,
   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,
   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,
  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,
  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,
  324,   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,
   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,
  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,
  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,
  374,   -1,  376,  377,  378,   -1,  380,  381,  382,  383,
  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,
  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,
  414,   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,
   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,
  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,
   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,  463,
  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,
  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,
   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,
  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,    0,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,  606,  607,  608,  609,  610,  611,  612,  613,
  614,   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,
   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,
   -1,  324,   -1,  326,  327,  328,  329,  330,  331,   -1,
   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,
   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,  382,
  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,
  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,
   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,
  463,  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,    0,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,  606,  607,  608,  609,  610,  611,  612,
  613,  614,   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,
   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,
  282,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,
   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,
   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,
  322,   -1,  324,   -1,  326,  327,  328,  329,  330,  331,
   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,
   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,
   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,
  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,
  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,
   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,
  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,
  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,
   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,
  462,  463,  464,  465,  466,  467,  468,  469,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,
  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,
  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,
  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,    0,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,  606,  607,  608,  609,  610,  611,
  612,  613,  614,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,
  281,  282,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,
  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,
  321,  322,   -1,  324,   -1,  326,  327,  328,  329,  330,
  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,
  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,
  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,
   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,  462,  463,  464,  465,  466,  467,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,
  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
    0,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  606,  607,  608,  609,  610,
  611,  612,  613,  614,   -1,   -1,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,   -1,
   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,
   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,
  320,  321,  322,   -1,  324,   -1,  326,  327,  328,  329,
  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,
   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,
  370,  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,
  380,  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,
  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,
  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,
  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,
  460,   -1,  462,  463,  464,  465,  466,  467,  468,  469,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,
  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,
  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,
  510,  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,    0,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,  606,  607,  608,  609,
  610,  611,  612,  613,  614,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,
  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,
  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,  308,
   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,
   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,  328,
  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,
   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,  378,
   -1,  380,  381,  382,  383,  384,   -1,  386,  387,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,
  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,  462,  463,  464,  465,  466,  467,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,
  509,  510,  511,  512,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,    0,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,  606,  607,  608,
  609,  610,  611,  612,  613,  614,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,
  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,
   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,
  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,
  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,
  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,
  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,
  378,   -1,  380,  381,  382,  383,  384,   -1,  386,  387,
   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,
  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,
  418,  419,  420,  421,  422,   -1,   -1,  425,  426,  427,
   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,
   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,
  458,   -1,  460,   -1,  462,  463,  464,  465,  466,  467,
  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,
   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
  508,  509,  510,  511,  512,  513,  514,  515,   -1,  517,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,    0,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,  606,  607,
  608,  609,  610,  611,  612,  613,  614,   -1,   -1,   -1,
   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,
  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,
  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,
  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,
  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,
   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,
  377,  378,   -1,  380,  381,  382,  383,  384,   -1,  386,
  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,  426,
  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,  462,  463,  464,  465,  466,
  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,  508,  509,  510,  511,  512,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,    0,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,  606,
  607,  608,  609,  610,  611,  612,  613,  614,   -1,   -1,
   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,
   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,
   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,
   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,
   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,
  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,
  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,
  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,
  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,
  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,
  376,  377,  378,   -1,  380,  381,  382,  383,  384,   -1,
  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,
  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,
  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,
  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,
  456,  457,  458,   -1,  460,   -1,  462,  463,  464,  465,
  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,
   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,  508,  509,  510,  511,  512,  513,  514,  515,
   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,    0,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
  606,  607,  608,  609,  610,  611,  612,  613,  614,   -1,
   -1,   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,
  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,
   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,
   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,
  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,
  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,
   -1,  376,  377,  378,   -1,  380,  381,  382,  383,  384,
   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,  462,  463,  464,
  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,    0,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,  606,  607,  608,  609,  610,  611,  612,  613,  614,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,
   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,
   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,
  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,
  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,
  324,   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,
   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,
  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,
  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,
  374,   -1,  376,  377,  378,   -1,  380,  381,  382,  383,
  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,
  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,
  414,   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,
   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,
  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,
   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,  463,
  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,
  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,
   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,
  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,    0,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,  606,  607,  608,  609,  610,  611,  612,  613,
  614,   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,
   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,
   -1,  324,   -1,  326,  327,  328,  329,  330,  331,   -1,
   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,
   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,  382,
  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,
  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,
   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,
  463,  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,    0,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,  606,  607,  608,  609,  610,  611,  612,
  613,  614,   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,
   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,
  282,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,
   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,
   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,
  322,   -1,  324,   -1,  326,  327,  328,  329,  330,  331,
   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,
   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,
   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,
  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,
  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,
   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,
  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,
  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,
   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,
  462,  463,  464,  465,  466,  467,  468,  469,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,
  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,
  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,
  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,    0,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,  606,  607,  608,  609,  610,  611,
  612,  613,  614,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,
  281,  282,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,
  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,
  321,  322,   -1,  324,   -1,  326,  327,  328,  329,  330,
  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,
  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,
  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,
   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,  462,  463,  464,  465,  466,  467,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,
  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
    0,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  606,  607,  608,  609,  610,
  611,  612,  613,  614,   -1,   -1,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,   -1,
   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,
   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,
  320,  321,  322,   -1,  324,   -1,  326,  327,  328,  329,
  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,
   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,
  370,  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,
  380,  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,
  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,
  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,
  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,
  460,   -1,  462,  463,  464,  465,  466,  467,  468,  469,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,
  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,
  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,
  510,  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,    0,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,  606,  607,  608,  609,
  610,  611,  612,  613,  614,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,
  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,
  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,  308,
   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,
   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,  328,
  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,
   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,  378,
   -1,  380,  381,  382,  383,  384,   -1,  386,  387,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,
  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,  462,  463,  464,  465,  466,  467,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,
  509,  510,  511,  512,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,    0,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,  606,  607,  608,
  609,  610,  611,  612,  613,  614,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,
  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,
   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,
  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,
  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,
  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,
  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,
  378,   -1,  380,  381,  382,  383,  384,   -1,  386,  387,
   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,
  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,
  418,  419,  420,  421,  422,   -1,   -1,  425,  426,  427,
   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,
   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,
  458,   -1,  460,   -1,  462,  463,  464,  465,  466,  467,
  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,
   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
  508,  509,  510,  511,  512,  513,  514,  515,   -1,  517,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,    0,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,  606,  607,
  608,  609,  610,  611,  612,  613,  614,   -1,   -1,   -1,
   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,
  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,
  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,
  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,
  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,
   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,
  377,  378,   -1,  380,  381,  382,  383,  384,   -1,  386,
  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,  426,
  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,  462,  463,  464,  465,  466,
  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,  508,  509,  510,  511,  512,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,    0,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,  606,
  607,  608,  609,  610,  611,  612,  613,  614,   -1,   -1,
   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,   45,
   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,
   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,
   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,
   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,
   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,
  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,
  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,
  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,
  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,
  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,
  376,  377,  378,   -1,  380,  381,  382,  383,  384,   -1,
  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,
  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,
  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,
  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,
  456,  457,  458,   -1,  460,   -1,  462,  463,  464,  465,
  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,
   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,  508,  509,  510,  511,  512,  513,  514,  515,
   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,    0,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
  606,  607,  608,  609,  610,  611,  612,  613,  614,   -1,
   -1,   -1,   -1,   -1,   -1,   40,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,
  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,
   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,
   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,
  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,
  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,
   -1,  376,  377,  378,   -1,  380,  381,  382,  383,  384,
   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,  462,  463,  464,
  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,    0,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,  606,  607,  608,  609,  610,  611,  612,  613,  614,
   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,   42,   43,
   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,
   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,
   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,
  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,
  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,
  324,   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,
   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,
  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,
  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,
  374,   -1,  376,  377,  378,   -1,  380,  381,  382,  383,
  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,
  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,
  414,   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,
   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,
  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,
   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,  463,
  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,
  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,
   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,
  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,    0,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,  606,  607,  608,  609,  610,  611,  612,  613,
  614,   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,
   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,
   -1,  324,   -1,  326,  327,  328,  329,  330,  331,   -1,
   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,
   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,  382,
  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,
  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,
   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,
  463,  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,    0,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,  606,  607,  608,  609,  610,  611,  612,
  613,  614,   -1,   -1,   -1,   -1,   -1,   -1,   40,   41,
   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,
   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,
  282,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,
   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,
   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,
  322,   -1,  324,   -1,  326,  327,  328,  329,  330,  331,
   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,
   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,
   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,
  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,
  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,
   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,
  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,
  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,
   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,
  462,  463,  464,  465,  466,  467,  468,  469,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,
  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,
  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,
  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,    0,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,  606,  607,  608,  609,  610,  611,
  612,  613,  614,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,
  281,  282,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,
  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,
  321,  322,   -1,  324,   -1,  326,  327,  328,  329,  330,
  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,
  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,
  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,
   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,  462,  463,  464,  465,  466,  467,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,
  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
    0,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  606,  607,  608,  609,  610,
  611,  612,  613,  614,   -1,   -1,   -1,   -1,   -1,   -1,
   40,   41,   42,   43,   44,   45,   46,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,   -1,
   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,
   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,
  320,  321,  322,   -1,  324,   -1,  326,  327,  328,  329,
  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,
   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,
  370,  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,
  380,  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,
  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,
  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,
  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,
  460,   -1,  462,  463,  464,  465,  466,  467,  468,  469,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,
  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,
  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,
  510,  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,    0,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,  606,  607,  608,  609,
  610,  611,  612,  613,  614,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,
  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,
  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,  308,
   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,
   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,  328,
  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,
   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,  378,
   -1,  380,  381,  382,  383,  384,   -1,  386,  387,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,
  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,  462,  463,  464,  465,  466,  467,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,
  509,  510,  511,  512,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,    0,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,  606,  607,  608,
  609,  610,  611,  612,  613,  614,   -1,   -1,   -1,   -1,
   -1,   -1,   40,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,
  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,
   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,
  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,
  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,
  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,
  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,
  378,   -1,  380,  381,  382,  383,  384,   -1,  386,  387,
   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,
  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,
  418,  419,  420,  421,  422,   -1,   -1,  425,  426,  427,
   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,
   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,
  458,   -1,  460,   -1,  462,  463,  464,  465,  466,  467,
  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,
   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
  508,  509,  510,  511,  512,  513,  514,  515,   -1,  517,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,    0,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,  606,  607,
  608,  609,  610,  611,  612,  613,  614,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,
  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,
  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,
  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,
  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,
   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,
  377,  378,   -1,  380,  381,  382,  383,  384,   -1,  386,
  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,  426,
  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,  462,  463,  464,  465,  466,
  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,  508,  509,  510,  511,  512,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,    0,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,  606,
  607,  608,  609,  610,  611,  612,  613,  614,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   41,   42,   43,   44,   45,
   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,
   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,
   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,
   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,
   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,
  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,
  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,
  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,
  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,
  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,
  376,  377,  378,   -1,  380,  381,  382,  383,  384,   -1,
  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,
  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,
  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,
  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,
  456,  457,  458,   -1,  460,   -1,  462,  463,  464,  465,
  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,
   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,  508,  509,  510,  511,  512,  513,  514,  515,
   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,    0,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
  606,  607,  608,  609,  610,  611,  612,  613,  614,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,   43,   44,
   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,
  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,
   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,
   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,
  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,
  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,
   -1,  376,  377,  378,   -1,  380,  381,  382,  383,  384,
   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,  462,  463,  464,
  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,    0,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,  606,  607,  608,  609,  610,  611,  612,  613,  614,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,   43,
   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   58,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,
   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,
   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,
   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,
  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,
  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,
  324,   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,
   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,
  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,
  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,
  374,   -1,  376,  377,  378,   -1,  380,  381,  382,  383,
  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,
  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,
  414,   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,
   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,
  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,
   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,  463,
  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,
  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,
   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,
  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,    0,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,  606,  607,  608,  609,  610,  611,  612,  613,
  614,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,
   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,
   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,  282,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,
   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,
   -1,  324,   -1,  326,  327,  328,  329,  330,  331,   -1,
   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,
   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,  382,
  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,
  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,
   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,
  463,  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,    0,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,  606,  607,  608,  609,  610,  611,  612,
  613,  614,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,
   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   91,
   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,
   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,  281,
  282,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,
   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,
   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,
  322,   -1,  324,   -1,  326,  327,  328,  329,  330,  331,
   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,
   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,
   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,
  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,
  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,
   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,
  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,
  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,
   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,
  462,  463,  464,  465,  466,  467,  468,  469,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,
  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,
  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,
  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,    0,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,  606,  607,  608,  609,  610,  611,
  612,  613,  614,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   41,   42,   43,   44,   45,   46,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,
  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,  280,
  281,  282,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,
  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,
  321,  322,   -1,  324,   -1,  326,  327,  328,  329,  330,
  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,
  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,
  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,
   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,  462,  463,  464,  465,  466,  467,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,
  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
    0,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  606,  607,  608,  609,  610,
  611,  612,  613,  614,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   41,   42,   43,   44,   45,   46,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,   -1,
  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,   -1,
   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,
   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,
  320,  321,  322,   -1,  324,   -1,  326,  327,  328,  329,
  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,
   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,
  370,  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,
  380,  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,
  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,
  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,
  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,
  460,   -1,  462,  463,  464,  465,  466,  467,  468,  469,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,
  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,
  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,
  510,  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,    0,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,  606,  607,  608,  609,
  610,  611,  612,  613,  614,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,
  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,
  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,  308,
   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,
   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,  328,
  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,
   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,  378,
   -1,  380,  381,  382,  383,  384,   -1,  386,  387,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,
  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,  462,  463,  464,  465,  466,  467,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,
  509,  510,  511,  512,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,    0,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,  606,  607,  608,
  609,  610,  611,  612,  613,  614,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   41,   42,   43,   44,   45,   46,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,
   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,   -1,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,
  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,
   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,
  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,
  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,
  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,
  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,
  378,   -1,  380,  381,  382,  383,  384,   -1,  386,  387,
   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,
  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,
  418,  419,  420,  421,  422,   -1,   -1,  425,  426,  427,
   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,
   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,
  458,   -1,  460,   -1,  462,  463,  464,  465,  466,  467,
  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,
   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
  508,  509,  510,  511,  512,  513,  514,  515,   -1,  517,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,    0,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,  606,  607,
  608,  609,  610,  611,  612,  613,  614,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   41,   42,   43,   44,   45,   46,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,   60,   61,   62,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,
   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,
  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,
  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,
  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,
  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,
  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,
   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,
  377,  378,   -1,  380,  381,  382,  383,  384,   -1,  386,
  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,  426,
  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,  462,  463,  464,  465,  466,
  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,  508,  509,  510,  511,  512,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,    0,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,  606,
  607,  608,  609,  610,  611,  612,  613,  614,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   41,   42,   43,   44,   45,
   46,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   59,   60,   61,   62,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   91,   -1,   93,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,  265,
   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,   -1,
   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,  285,
   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,
   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,  305,
   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,
  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,   -1,
  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,  335,
  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,  355,
  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,
  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,   -1,
  376,  377,  378,   -1,  380,  381,  382,  383,  384,   -1,
  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,
  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,  425,
  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,  445,
  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,
  456,  457,  458,   -1,  460,   -1,  462,  463,  464,  465,
  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,
   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,  508,  509,  510,  511,  512,  513,  514,  515,
   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,    0,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
  606,  607,  608,  609,  610,  611,  612,   -1,  614,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   59,   60,   61,   62,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,  264,
  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,   -1,
   -1,   -1,  277,   -1,   -1,  280,  281,  282,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,  304,
  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,  314,
   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,  324,
   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,   -1,
  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,  354,
  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,  374,
   -1,  376,  377,  378,   -1,  380,  381,  382,  383,  384,
   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,  444,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,  462,  463,  464,
  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,    0,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,  606,  607,  608,  609,  610,  611,  612,   -1,  614,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   59,   60,   61,   62,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,   -1,
  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,  282,  283,
   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,
   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,  303,
  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,   -1,
  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,   -1,
  324,   -1,  326,  327,  328,  329,  330,  331,   -1,   -1,
   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,  343,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,
  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,  363,
  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,   -1,
  374,   -1,  376,  377,  378,   -1,  380,  381,  382,  383,
  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,   -1,
  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,  403,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,
  414,   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,
   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,   -1,
  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,
   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,  463,
  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,
  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,  493,
   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,  513,
  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,    0,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,  606,  607,  608,  609,  610,  611,  612,   -1,
  614,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,   61,   62,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,  262,
   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,   -1,
   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,  322,
   -1,  324,   -1,  326,  327,  328,  329,  330,  331,   -1,
   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,  372,
   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,  382,
  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,   -1,
  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,  442,
   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,  462,
  463,  464,  465,  466,  467,  468,  469,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,  512,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,    0,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,  606,  607,  608,  609,  610,  611,  612,
   -1,  614,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,   61,
   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,
  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,  271,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,
   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,
   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,  311,
   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,  321,
  322,   -1,  324,   -1,  326,  327,  328,  329,  330,  331,
   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,
   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,   -1,
   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,  371,
  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,  381,
  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,   -1,
   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,
  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,
  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,
   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,
  462,  463,  464,  465,  466,  467,  468,  469,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,
  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,
  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,
  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,    0,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,  606,  607,  608,  609,  610,  611,
  612,   -1,  614,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   41,   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   60,
   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,
   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,   -1,
  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,   -1,
  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,  320,
  321,  322,   -1,  324,   -1,  326,  327,  328,  329,  330,
  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,  370,
  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,  380,
  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,  400,
   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,  430,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,  462,  463,  464,  465,  466,  467,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,
  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
    0,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  606,  607,  608,  609,  610,
  611,  612,   -1,  614,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   41,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,
   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   93,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,
   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,  269,
   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,
   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,  303,  304,  305,   -1,  307,  308,   -1,
   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,   -1,
  320,  321,  322,   -1,  324,   -1,  326,  327,  328,  329,
  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,   -1,
   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,   -1,
  370,  371,  372,   -1,  374,   -1,  376,  377,  378,   -1,
  380,  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,
  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,  429,
  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,   -1,
  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,
  460,   -1,  462,  463,  464,  465,  466,  467,  468,  469,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,
  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,
  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,
  510,  511,  512,  513,  514,  515,   -1,  517,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,    0,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,  606,  607,  608,  609,
  610,  611,  612,   -1,  614,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   41,   -1,   43,   44,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   93,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,
  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,  268,
  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,  308,
   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,   -1,
   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,  328,
  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,  338,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,  368,
   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,  378,
   -1,  380,  381,  382,  383,  384,   -1,  386,  387,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,  425,  426,  427,   -1,
  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,  462,  463,  464,  465,  466,  467,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,
  509,  510,  511,  512,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,    0,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,  606,  607,  608,
  609,  610,  611,  612,   -1,  614,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   41,   -1,   43,   44,   45,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
   -1,  259,   -1,   -1,  262,   -1,  264,  265,   -1,   -1,
  268,  269,   -1,  271,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,  303,  304,  305,   -1,  307,
  308,   -1,   -1,  311,   -1,   -1,  314,   -1,  316,  317,
   -1,   -1,  320,  321,  322,   -1,  324,   -1,  326,  327,
  328,  329,  330,  331,   -1,   -1,   -1,  335,  336,  337,
  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  351,   -1,  353,  354,  355,  356,   -1,
  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,
  368,   -1,  370,  371,  372,   -1,  374,   -1,  376,  377,
  378,   -1,  380,  381,  382,  383,  384,   -1,  386,  387,
   -1,   -1,    0,   -1,  392,   -1,  394,  395,   -1,   -1,
  398,  399,  400,   -1,   -1,  403,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,
  418,  419,  420,  421,  422,   -1,   -1,  425,  426,  427,
   -1,  429,  430,   41,   -1,   -1,   44,   -1,   -1,   -1,
   -1,   -1,  440,  441,  442,   -1,  444,  445,  446,   -1,
   -1,   59,  450,   -1,   -1,  453,   -1,  455,  456,  457,
  458,   -1,  460,   -1,  462,  463,  464,  465,  466,  467,
  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,
   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
  508,  509,  510,  511,  512,  513,  514,  515,   -1,  517,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,   -1,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,  606,  607,
  608,  609,  610,  611,  612,   -1,  614,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
   -1,  259,   -1,   -1,   -1,   -1,  264,  265,   -1,   -1,
  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,
  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,
  308,   -1,   -1,  311,   -1,   -1,  314,   -1,   -1,  317,
   -1,   -1,   -1,  321,  322,   -1,  324,   -1,  326,  327,
   -1,  329,  330,  331,   -1,   -1,   -1,  335,   -1,  337,
  338,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  351,   -1,  353,   -1,  355,    0,   -1,
  358,   -1,   -1,   -1,   -1,  363,  364,   -1,  366,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  374,   -1,  376,   -1,
  378,   -1,  380,  381,  382,  383,  384,   -1,  386,  387,
   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   40,   41,
  398,  399,   44,   -1,   -1,  403,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   59,  416,   -1,
  418,  419,  420,  421,  422,   -1,   -1,   -1,   -1,  427,
   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  440,   -1,  442,   -1,  444,  445,  446,   -1,
   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,
  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,
   -1,  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
  508,  509,  510,  511,  512,  513,  514,  515,   -1,  517,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,   -1,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,   -1,  607,
  608,  609,  610,  611,  612,  257,  614,  259,   -1,   -1,
   -1,   -1,   -1,  265,   -1,   -1,  268,  269,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,
   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,
   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,
   -1,   -1,  314,   -1,   -1,  317,   -1,   -1,   -1,  321,
  322,   -1,  324,   -1,  326,  327,   -1,  329,  330,  331,
   -1,   -1,   -1,  335,   -1,  337,  338,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,
   -1,  353,   -1,  355,    0,   -1,  358,   -1,   -1,   -1,
   -1,  363,  364,   -1,  366,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  374,   -1,  376,   -1,  378,   -1,  380,  381,
  382,  383,  384,   -1,  386,  387,   -1,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   41,  398,  399,   44,   -1,
   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   59,  416,   -1,  418,  419,  420,  421,
  422,   -1,   -1,   -1,   -1,  427,   -1,  429,  430,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,   -1,
  442,   -1,  444,  445,  446,   -1,   -1,   -1,  450,   -1,
   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,
  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,  491,
  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,  508,  509,  510,  511,
  512,  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,   -1,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,   -1,  607,  608,  609,  610,  611,
  612,  257,  614,  259,   -1,   -1,   -1,   -1,   -1,  265,
   -1,   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,
   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,
   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,
   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,  314,   -1,
   -1,  317,   -1,   -1,   -1,  321,  322,   -1,  324,   -1,
  326,  327,   -1,  329,  330,  331,   -1,   -1,   -1,  335,
   -1,  337,  338,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  351,   -1,  353,   -1,  355,
    0,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,
  366,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  374,   -1,
  376,   -1,  378,   -1,  380,  381,  382,  383,  384,   -1,
  386,  387,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,   -1,   -1,   -1,  403,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   59,
  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,   -1,
   -1,  427,   -1,  429,  430,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  440,   -1,  442,   -1,  444,  445,
  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,
  456,  457,  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,
   -1,   -1,   -1,  489,  490,  491,  492,  493,   -1,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,  508,  509,  510,  511,  512,  513,  514,  515,
   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,   -1,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
   -1,  607,  608,  609,  610,  611,  612,  257,  614,  259,
   -1,   -1,   -1,   -1,   -1,  265,   -1,   -1,  268,  269,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,
   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,
   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  351,   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,
   -1,   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,  378,   -1,
  380,  381,  382,  383,  384,   -1,  386,  387,   -1,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
   -1,   -1,   -1,   -1,   -1,   -1,  406,   -1,  408,  409,
  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,
  420,  421,  422,   -1,   -1,   -1,   -1,  427,   -1,  429,
   -1,   -1,   -1,   -1, 1839,   -1,   -1,   -1,   -1,   -1,
  440,   -1,  442,   -1,   -1,  445,  446,   -1,   -1,   -1,
  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,
  460,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1, 1883,  479,
  480,   -1,  482,  483,  484,   -1,   -1, 1892,   -1,  489,
  490,  491,  492,  493,   -1,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,  508,  509,
  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,   -1,
   -1,   -1,   -1,   -1, 1929,   -1,   -1,   -1,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,    0,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,   -1,  607,  608,  609,
  610,  611,  612,   -1,  614,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   59,   60,   61,   62,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   91, 2078,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1, 2089,   -1,   -1, 2092,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1, 2101,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1, 2129,   -1, 2131,   -1, 2133,   -1,
 2135,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   40,   -1,   -1,   43,   -1,   45,   -1,
   -1,   -1,   -1,   -1,   -1, 2240, 2241, 2242,   -1,   -1,
   -1,   58,   -1,  262,   -1,   -1,   63,   -1,   -1,   -1,
   -1,   -1,  271,   -1,   -1,   -1,   -1,   -1,  277,   -1,
   -1,   -1,   -1,  282,   -1,   -1,  285,   -1,   -1,   -1,
   -1, 2276,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  314,   -1,   -1,  317,   -1,
   -1,  320,   -1,   -1,   -1,  324,   -1,  326,   -1,  328,
   -1,  330,   -1,   -1,   -1,   -1,  335,  336,   -1,  338,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  353,  354,   -1,  356,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  366,   -1,  368,
   -1,  370,  371,  372,   -1,  374,   -1,   -1,  377,  378,
 2365, 2366, 2367,   -1,   -1,   -1, 2371,   -1,  387,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  403,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  419,   -1,   -1,   -1,   -1,   -1,  425,   -1,   -1,   -1,
   -1,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  441,  442,   -1,  444,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,
  267,  268,  269,   -1,   -1,   -1,   -1,  274,   -1,   -1,
   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,  286,
   -1,  288,  491,   -1,  291,  292,  293,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,  508,
   -1,  308,   -1,  512,  311,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  319,   -1,  321,  322,   -1,   -1,  527,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,
  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
  347,   -1,  349,  350,  351,   -1,  353,   -1,  355,   -1,
   -1,  358,  359,   -1,   -1,  362,  363,  364,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,
   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,
   -1,  388,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,   -1,   -1,   -1,  403,  606,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
  417,  418,  419,  420,  421,  422,  423,   -1,   -1,   -1,
  427,   -1,  429,   -1,   -1,   -1,  433,   -1,   -1,   40,
   -1,   -1,   43,  440,   45,   -1,   -1,   -1,  445,  446,
  447,  448,  449,  450,  451,  452,  453,   58,  455,  456,
  457,  458,   63,  460,  461,  462,  463,  464,  465,  466,
  467,  468,  469,  470,  471,  472,  473,  474,  475,  476,
  477,  478,  479,  480,   -1,  482,  483,  484,  485,  486,
   -1,  488,  489,  490,   -1,  492,  493,  494,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,
  517,   -1,  519,  520,  521,   -1,  523,  524,   -1,  526,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,   -1,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,   -1,
  607,  608,  609,  610,  611,  612,   -1,  614,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,
   -1,   -1,   -1,   -1,  265,   -1,  267,  268,  269,   -1,
   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,  286,   -1,  288,  289,   -1,
  291,  292,  293,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,  310,
  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  319,   -1,
  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,  347,   -1,  349,  350,
  351,   -1,  353,   -1,  355,   -1,   -1,  358,  359,   -1,
   -1,  362,  363,  364,   -1,   -1,   -1,   -1,   -1,  370,
   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,
  381,  382,  383,  384,   -1,  386,   -1,  388,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,
   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,  417,  418,  419,  420,
  421,  422,  423,   -1,   -1,   -1,  427,   -1,  429,   -1,
   -1,   -1,  433,   -1,   -1,   40,   -1,   -1,   43,  440,
   45,   -1,   -1,   -1,  445,  446,  447,  448,  449,  450,
  451,  452,  453,   58,  455,  456,  457,  458,   63,  460,
  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,  470,
  471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
   -1,  482,  483,  484,  485,  486,   -1,  488,  489,  490,
   -1,  492,  493,  494,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,
  511,   -1,  513,  514,  515,   -1,  517,   -1,  519,  520,
  521,   -1,  523,  524,   -1,  526,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
   -1,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,   -1,  607,  608,  609,  610,
  611,  612,   -1,  614,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,  259,   -1,   -1,   -1,   -1,   -1,
  265,   -1,  267,  268,  269,   -1,   -1,   -1,   -1,  274,
   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,
  285,  286,   -1,  288,   -1,   -1,  291,  292,  293,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,
  305,   -1,   -1,  308,   -1,  310,  311,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  319,   -1,  321,  322,   -1,   -1,
   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,  347,   -1,  349,  350,  351,   -1,  353,   -1,
  355,   -1,   -1,  358,  359,   -1,   -1,  362,  363,  364,
   -1,   -1,   -1,   -1,   -1,  370,   -1,   -1,   -1,   -1,
   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,
   -1,  386,   -1,  388,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,   -1,   -1,   -1,  403,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,  417,  418,  419,  420,  421,  422,  423,   -1,
   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,  433,   -1,
   -1,   40,   -1,   -1,   43,  440,   45,   -1,   -1,  444,
  445,  446,  447,  448,  449,  450,  451,  452,  453,   58,
  455,  456,  457,  458,   63,  460,  461,   -1,   -1,   -1,
   -1,   -1,   -1,  468,  469,  470,  471,  472,  473,  474,
  475,  476,  477,  478,  479,  480,   -1,  482,  483,  484,
  485,  486,   -1,  488,  489,  490,   -1,  492,  493,  494,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,
  515,   -1,  517,   -1,  519,  520,  521,   -1,  523,  524,
   -1,  526,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,   -1,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,   -1,  607,  608,  609,  610,  611,  612,   -1,  614,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,
  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,  267,  268,
  269,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,
   -1,  280,  281,   -1,  283,   -1,  285,  286,   -1,  288,
   -1,   -1,  291,  292,  293,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,
   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  319,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,  347,   -1,
  349,  350,  351,   -1,  353,   -1,  355,   -1,   -1,  358,
  359,   -1,   -1,  362,  363,  364,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,
   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,  388,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,   -1,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,  417,  418,
  419,  420,  421,  422,  423,   -1,   -1,   -1,  427,   -1,
  429,   -1,   -1,   -1,  433,   -1,   -1,   40,   -1,   -1,
   43,  440,   45,   -1,   -1,   -1,  445,  446,  447,  448,
  449,  450,  451,  452,  453,   58,  455,  456,  457,  458,
   63,  460,  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,
  469,  470,  471,  472,  473,  474,  475,  476,  477,  478,
  479,  480,   -1,  482,  483,  484,  485,  486,   -1,  488,
  489,  490,   -1,  492,  493,  494,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,
  509,  510,  511,   -1,  513,  514,  515,  516,  517,   -1,
  519,  520,  521,  522,  523,  524,  525,  526,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,   -1,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,   -1,  607,  608,
  609,  610,  611,  612,   -1,  614,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,   -1,  259,  260,   -1,   -1,
  263,   -1,  265,   -1,  267,  268,  269,   -1,   -1,   -1,
   -1,  274,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,
  283,   -1,  285,  286,   -1,  288,   -1,   -1,  291,  292,
  293,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  319,   -1,  321,  322,
   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,  347,   -1,  349,  350,  351,   -1,
  353,   -1,  355,   -1,   -1,  358,  359,   -1,   -1,  362,
  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,
  383,  384,   -1,  386,   -1,  388,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,
  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,  415,  416,  417,  418,  419,  420,  421,  422,
  423,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,
  433,   -1,   -1,   40,   -1,   -1,   43,  440,   45,   -1,
   -1,   -1,  445,  446,  447,  448,  449,  450,  451,  452,
  453,   58,  455,  456,  457,  458,   63,  460,  461,   -1,
   -1,   -1,   -1,   -1,   -1,  468,  469,  470,  471,  472,
  473,  474,  475,  476,  477,  478,  479,  480,   -1,  482,
  483,  484,  485,  486,   -1,  488,  489,  490,   -1,  492,
  493,  494,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,
  513,  514,  515,   -1,  517,   -1,  519,  520,  521,   -1,
  523,  524,   -1,  526,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,   -1,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,   -1,  607,  608,  609,  610,  611,  612,
   -1,  614,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,  260,   -1,   -1,  263,   -1,  265,   -1,
  267,  268,  269,   -1,   -1,   -1,   -1,  274,   -1,   -1,
   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,  286,
   -1,  288,   -1,   -1,  291,  292,  293,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,
   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  319,   -1,  321,  322,   -1,   -1,   -1,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,
  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
  347,   -1,  349,  350,  351,   -1,  353,   -1,  355,   -1,
   -1,  358,  359,   -1,   -1,  362,  363,  364,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,
   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,
   -1,  388,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,   -1,   -1,   -1,  403,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,  415,  416,
  417,  418,  419,  420,  421,  422,  423,   -1,   -1,   -1,
  427,   -1,  429,   -1,   -1,   -1,  433,   -1,   -1,   40,
   -1,   -1,   43,  440,   45,   -1,   -1,   -1,  445,  446,
  447,  448,  449,  450,  451,  452,  453,   58,  455,  456,
  457,  458,   63,  460,  461,   -1,   -1,   -1,   -1,   -1,
   -1,  468,  469,  470,  471,  472,  473,  474,  475,  476,
  477,  478,  479,  480,   -1,  482,  483,  484,  485,  486,
   -1,  488,  489,  490,   -1,  492,  493,  494,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,
  517,   -1,  519,  520,  521,   -1,  523,  524,   -1,  526,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,   -1,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,   -1,
  607,  608,  609,  610,  611,  612,   -1,  614,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,  260,
   -1,   -1,  263,   -1,  265,   -1,  267,  268,  269,   -1,
   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,  286,   -1,  288,   -1,   -1,
  291,  292,  293,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,
  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  319,   -1,
  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,  347,   -1,  349,  350,
  351,   -1,  353,   -1,  355,   -1,   -1,  358,  359,   -1,
   -1,  362,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,
  381,  382,  383,  384,   -1,  386,   -1,  388,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,
   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,  415,  416,  417,  418,  419,  420,
  421,  422,  423,   -1,   -1,   -1,  427,   -1,  429,   -1,
   -1,   -1,  433,   -1,   -1,   40,   -1,   -1,   43,  440,
   45,   -1,   -1,   -1,  445,  446,  447,  448,  449,  450,
  451,  452,  453,   58,  455,  456,  457,  458,   63,  460,
  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,  470,
  471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
   -1,  482,  483,  484,  485,  486,   -1,  488,  489,  490,
   -1,  492,  493,  494,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,
  511,   -1,  513,  514,  515,   -1,  517,   -1,  519,  520,
  521,   -1,  523,  524,   -1,  526,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
   -1,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,   -1,  607,  608,  609,  610,
  611,  612,   -1,  614,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,  259,  260,   -1,   -1,  263,   -1,
  265,   -1,  267,  268,  269,   -1,   -1,   -1,   -1,  274,
   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,
  285,  286,   -1,  288,   -1,   -1,  291,  292,  293,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,
  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  319,   -1,  321,  322,   -1,   -1,
   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,  347,   -1,  349,  350,  351,   -1,  353,   -1,
  355,   -1,   -1,  358,  359,   -1,   -1,  362,  363,  364,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,
   -1,  386,   -1,  388,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,   -1,   -1,   -1,  403,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
  415,  416,  417,  418,  419,  420,  421,  422,  423,   -1,
   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,  433,   -1,
   -1,   40,   -1,   -1,   43,  440,   45,   -1,   -1,   -1,
  445,  446,  447,  448,  449,  450,  451,  452,  453,   58,
  455,  456,  457,  458,   63,  460,  461,   -1,   -1,   -1,
   -1,   -1,   -1,  468,  469,  470,  471,  472,  473,  474,
  475,  476,  477,  478,  479,  480,   -1,  482,  483,  484,
  485,  486,   -1,  488,  489,  490,   -1,  492,  493,  494,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,
  515,   -1,  517,   -1,  519,  520,  521,   -1,  523,  524,
   -1,  526,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,   -1,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,   -1,  607,  608,  609,  610,  611,  612,   -1,  614,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,
  259,  260,   -1,   -1,  263,   -1,  265,   -1,  267,  268,
  269,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,
   -1,  280,  281,   -1,  283,   -1,  285,  286,   -1,  288,
   -1,   -1,  291,  292,  293,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,
   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  319,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,  347,   -1,
  349,  350,  351,   -1,  353,   -1,  355,   -1,   -1,  358,
  359,   -1,   -1,  362,  363,  364,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,
   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,  388,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,   -1,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,  415,  416,  417,  418,
  419,  420,  421,  422,  423,   -1,   -1,   -1,  427,   -1,
  429,   -1,   -1,   -1,  433,   -1,   -1,   40,   -1,   -1,
   43,  440,   45,   -1,   -1,   -1,  445,  446,  447,  448,
  449,  450,  451,  452,  453,   58,  455,  456,  457,  458,
   63,  460,  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,
  469,  470,  471,  472,  473,  474,  475,  476,  477,  478,
  479,  480,   -1,  482,  483,  484,  485,  486,   -1,  488,
  489,  490,   -1,  492,  493,  494,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,
  509,  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,
  519,  520,  521,   -1,  523,  524,   -1,  526,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,   -1,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,   -1,  607,  608,
  609,  610,  611,  612,   -1,  614,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,   -1,  259,  260,   -1,   -1,
  263,   -1,  265,   -1,  267,  268,  269,   -1,   -1,   -1,
   -1,  274,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,
  283,   -1,  285,  286,   -1,  288,   -1,   -1,  291,  292,
  293,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  319,   -1,  321,  322,
   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,  347,   -1,  349,  350,  351,   -1,
  353,   -1,  355,   -1,   -1,  358,  359,   -1,   -1,  362,
  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,
  383,  384,   -1,  386,   -1,  388,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,
  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,  415,  416,  417,  418,  419,  420,  421,  422,
  423,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,
  433,   -1,   -1,   40,   -1,   -1,   43,  440,   45,   -1,
   -1,   -1,  445,  446,  447,  448,  449,  450,  451,  452,
  453,   58,  455,  456,  457,  458,   63,  460,  461,   -1,
   -1,   -1,   -1,   -1,   -1,  468,  469,  470,  471,  472,
  473,  474,  475,  476,  477,  478,  479,  480,   -1,  482,
  483,  484,  485,  486,   -1,  488,  489,  490,   -1,  492,
  493,  494,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,
  513,  514,  515,   -1,  517,   -1,  519,  520,  521,   -1,
  523,  524,   -1,  526,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,   -1,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,   -1,  607,  608,  609,  610,  611,  612,
   -1,  614,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,  260,   -1,   -1,  263,   -1,  265,   -1,
  267,  268,  269,   -1,   -1,   -1,   -1,  274,   -1,   -1,
   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,  286,
   -1,  288,   -1,   -1,  291,  292,  293,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,
   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  319,   -1,  321,  322,   -1,   -1,   -1,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,
  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
  347,   -1,  349,  350,  351,   -1,  353,   -1,  355,   -1,
   -1,  358,  359,   -1,   -1,  362,  363,  364,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,
   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,
   -1,  388,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,   -1,   -1,   -1,  403,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,  415,  416,
  417,  418,  419,  420,  421,  422,  423,   -1,   -1,   -1,
  427,   -1,  429,   -1,   -1,   -1,  433,   -1,   -1,   40,
   -1,   -1,   43,  440,   45,   -1,   -1,   -1,  445,  446,
  447,  448,  449,  450,  451,  452,  453,   58,  455,  456,
  457,  458,   63,  460,  461,   -1,   -1,   -1,   -1,   -1,
   -1,  468,  469,  470,  471,  472,  473,  474,  475,  476,
  477,  478,  479,  480,   -1,  482,  483,  484,  485,  486,
   -1,  488,  489,  490,   -1,  492,  493,  494,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,
  517,   -1,  519,  520,  521,   -1,  523,  524,   -1,  526,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,   -1,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,   -1,
  607,  608,  609,  610,  611,  612,   -1,  614,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,  260,
   -1,   -1,  263,   -1,  265,   -1,  267,  268,  269,   -1,
   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,  286,   -1,  288,   -1,   -1,
  291,  292,  293,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,
  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  319,   -1,
  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,  347,   -1,  349,  350,
  351,   -1,  353,   -1,  355,   -1,   -1,  358,  359,   -1,
   -1,  362,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,
  381,  382,  383,  384,   -1,  386,   -1,  388,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,
   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,  415,  416,  417,  418,  419,  420,
  421,  422,  423,   -1,   -1,   -1,  427,   -1,  429,   -1,
   -1,   -1,  433,   -1,   -1,   40,   -1,   -1,   43,  440,
   45,   -1,   -1,   -1,  445,  446,  447,  448,  449,  450,
  451,  452,  453,   58,  455,  456,  457,  458,   63,  460,
  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,  470,
  471,  472,  473,  474,  475,  476,  477,  478,  479,  480,
   -1,  482,  483,  484,  485,  486,   -1,  488,  489,  490,
   -1,  492,  493,  494,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,
  511,   -1,  513,  514,  515,   -1,  517,   -1,  519,  520,
  521,   -1,  523,  524,   -1,  526,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
   -1,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,   -1,  607,  608,  609,  610,
  611,  612,   -1,  614,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  257,   -1,  259,   -1,   -1,   -1,   -1,   -1,
  265,   -1,  267,  268,  269,   -1,   -1,   -1,   -1,  274,
   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,
  285,  286,   -1,  288,   -1,   -1,  291,  292,  293,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,
  305,   -1,   -1,  308,   -1,  310,  311,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  319,   -1,  321,  322,   -1,   -1,
   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,  347,   -1,  349,  350,  351,   -1,  353,   -1,
  355,   -1,   -1,  358,  359,   -1,   -1,  362,  363,  364,
   -1,   -1,   -1,   -1,   -1,  370,   -1,   -1,   -1,   -1,
   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,
   -1,  386,   -1,  388,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,   -1,   -1,   -1,  403,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,  417,  418,  419,  420,  421,  422,  423,   -1,
   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,  433,   -1,
   -1,   40,   -1,   42,   43,  440,   45,   -1,   -1,   -1,
  445,  446,  447,  448,  449,  450,  451,  452,  453,   58,
  455,  456,  457,  458,   63,  460,  461,   -1,   -1,   -1,
   -1,   -1,   -1,  468,  469,  470,  471,  472,  473,  474,
  475,  476,  477,  478,  479,  480,   -1,  482,  483,  484,
  485,  486,   -1,  488,  489,  490,   -1,  492,  493,  494,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,
  515,   -1,  517,   -1,  519,  520,  521,   -1,  523,  524,
   -1,  526,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,   -1,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,   -1,  607,  608,  609,  610,  611,  612,   -1,  614,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,
  259,  260,   -1,   -1,   -1,   -1,  265,   -1,  267,  268,
  269,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,
   -1,  280,  281,   -1,  283,   -1,  285,  286,   -1,  288,
   -1,   -1,  291,  292,  293,   -1,   -1,   -1,   -1,  298,
  299,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,
   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  319,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,  347,   -1,
  349,  350,  351,   -1,  353,   -1,  355,   -1,   -1,  358,
  359,   -1,   -1,  362,  363,  364,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,
   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,  388,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,   -1,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,  417,  418,
  419,  420,  421,  422,  423,   -1,   -1,   -1,  427,   -1,
  429,   -1,   -1,   -1,  433,   -1,   -1,   40,   -1,   -1,
   43,  440,   45,   -1,   -1,   -1,  445,  446,  447,  448,
  449,  450,  451,  452,  453,   58,  455,  456,  457,  458,
   63,  460,  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,
  469,  470,  471,  472,  473,  474,  475,  476,  477,  478,
  479,  480,   -1,  482,  483,   -1,  485,  486,   -1,  488,
  489,  490,   -1,  492,  493,  494,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,
  509,  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,
  519,  520,  521,   -1,  523,  524,   -1,  526,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,   -1,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,   -1,  607,  608,
  609,  610,  611,  612,   -1,  614,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,   -1,
   -1,   -1,  265,   -1,  267,  268,  269,   -1,   -1,   -1,
   -1,  274,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,
  283,   -1,  285,  286,   -1,  288,   -1,   -1,  291,  292,
  293,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,
   -1,   -1,   -1,    0,   -1,   -1,  319,   -1,  321,  322,
   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,  347,   -1,  349,  350,  351,   -1,
  353,   -1,  355,   -1,   41,  358,  359,   44,   -1,  362,
  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   59,  376,   -1,   -1,   -1,  380,  381,  382,
  383,  384,   -1,  386,   -1,  388,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,
  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,  417,  418,  419,  420,  421,  422,
  423,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,
  433,   -1,   -1,   -1,   -1,   -1,   -1,  440,  441,   -1,
   -1,   -1,  445,  446,  447,  448,  449,  450,  451,  452,
  453,   -1,  455,  456,  457,  458,   -1,  460,  461,   -1,
   -1,   -1,   -1,   -1,   -1,  468,  469,  470,  471,  472,
  473,  474,  475,  476,  477,  478,  479,  480,   -1,  482,
  483,  484,  485,  486,   -1,  488,  489,  490,   -1,  492,
  493,  494,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,
  513,  514,  515,   -1,  517,   -1,  519,  520,  521,   -1,
  523,  524,   -1,  526,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,   -1,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,   -1,  607,  608,  609,  610,  611,  612,
   40,  614,   -1,   43,   -1,   45,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  314,   58,   -1,
  317,   -1,   -1,   63,   -1,   -1,   -1,  324,   -1,  326,
   -1,   -1,   -1,  330,   -1,   -1,   -1,   -1,  335,   -1,
   -1,  338,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  353,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  366,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  374,   -1,   -1,
  377,  378,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  387,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  403,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  425,   -1,
   -1,   -1,   -1,  430,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  441,  442,   -1,  444,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  491,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  508,   -1,   -1,   -1,  512,   -1,  257,   -1,  259,
   -1,   -1,   -1,   -1,   -1,  265,   -1,  267,  268,  269,
  527,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,
  280,  281,   -1,  283,   -1,  285,  286,   -1,  288,   -1,
   -1,  291,  292,  293,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,
   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  319,
   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,  347,   -1,  349,
  350,  351,   -1,  353,   -1,  355,   -1,   -1,  358,  359,
   -1,   -1,  362,  363,  364,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,
  380,  381,  382,  383,  384,   -1,  386,   -1,  388,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
   -1,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,  417,  418,  419,
  420,  421,  422,  423,   -1,   -1,   -1,  427,   -1,  429,
   -1,   -1,   -1,  433,   -1,   -1,   40,   -1,   42,   43,
  440,   45,   -1,   -1,  444,  445,  446,  447,  448,  449,
  450,  451,  452,  453,   58,  455,  456,  457,  458,   63,
  460,  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,
  470,  471,  472,  473,  474,  475,  476,  477,  478,  479,
  480,   -1,  482,  483,  484,  485,  486,   -1,  488,  489,
  490,   -1,  492,  493,  494,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,
  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,  519,
  520,  521,   -1,  523,  524,   -1,  526,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,   -1,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,   -1,  607,  608,  609,
  610,  611,  612,   -1,  614,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,   -1,   -1,
   -1,  265,   -1,  267,  268,  269,   -1,   -1,   -1,   -1,
  274,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,
   -1,  285,  286,   -1,  288,   -1,   -1,  291,  292,  293,
   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,
   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  319,   -1,  321,  322,   -1,
   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,
   -1,   -1,   -1,  347,   -1,  349,  350,  351,   -1,  353,
   -1,  355,   -1,   -1,  358,  359,   -1,   -1,  362,  363,
  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,
  384,   -1,  386,   -1,  388,   -1,   -1,   -1,  392,   -1,
  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,  403,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,
  414,   -1,  416,  417,  418,  419,  420,  421,  422,  423,
   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,  433,
   -1,   -1,   40,   41,   -1,   43,  440,   45,   -1,   -1,
   -1,  445,  446,  447,  448,  449,  450,  451,  452,  453,
   58,  455,  456,  457,  458,   63,  460,  461,   -1,   -1,
   -1,   -1,   -1,   -1,  468,  469,  470,  471,  472,  473,
  474,  475,  476,  477,  478,  479,  480,   -1,  482,  483,
  484,  485,  486,   -1,  488,  489,  490,   -1,  492,  493,
  494,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,
  514,  515,   -1,  517,   -1,  519,  520,  521,   -1,  523,
  524,   -1,  526,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,   -1,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,   -1,  607,  608,  609,  610,  611,  612,   -1,
  614,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
   -1,  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,  267,
  268,  269,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,
   -1,   -1,  280,  281,   -1,  283,   -1,  285,  286,   -1,
  288,   -1,   -1,  291,  292,  293,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,
  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  319,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,
   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,  347,
   -1,  349,  350,  351,   -1,  353,   -1,  355,   -1,   -1,
  358,  359,   -1,   -1,  362,  363,  364,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,
   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,
  388,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,
  398,  399,   -1,   -1,   -1,  403,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,  417,
  418,  419,  420,  421,  422,  423,   -1,   -1,   -1,  427,
   -1,  429,   -1,   -1,   -1,  433,   -1,   -1,   40,   -1,
   -1,   43,  440,   45,   -1,   -1,   -1,  445,  446,  447,
  448,  449,  450,  451,  452,  453,   58,  455,  456,  457,
  458,   63,  460,  461,   -1,   -1,   -1,   -1,   -1,   -1,
  468,  469,  470,  471,  472,  473,  474,  475,  476,  477,
  478,  479,  480,   -1,  482,  483,  484,  485,  486,   -1,
  488,  489,  490,   -1,  492,  493,  494,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,  517,
   -1,  519,  520,  521,   -1,  523,  524,   -1,  526,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,   -1,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,   -1,  607,
  608,  609,  610,  611,  612,   -1,  614,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,
   -1,   -1,   -1,  265,   -1,  267,  268,  269,   -1,   -1,
   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,  280,  281,
   -1,  283,   -1,  285,  286,   -1,  288,   -1,   -1,  291,
  292,  293,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  319,   -1,  321,
  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,  347,   -1,  349,  350,  351,
   -1,  353,   -1,  355,   -1,   -1,  358,  359,   -1,   -1,
  362,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,
  382,  383,  384,   -1,  386,   -1,  388,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,
   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,  417,  418,  419,  420,  421,
  422,  423,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,
   -1,  433,   -1,   -1,   40,   -1,   -1,   43,  440,   45,
   -1,   -1,  444,  445,  446,  447,  448,  449,  450,  451,
  452,  453,   58,  455,  456,  457,  458,   63,  460,  461,
   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,  470,  471,
  472,  473,  474,  475,  476,  477,  478,  479,  480,   -1,
  482,  483,  484,  485,  486,   -1,  488,  489,  490,   -1,
  492,  493,  494,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,
   -1,  513,  514,  515,   -1,  517,   -1,  519,  520,  521,
   -1,  523,  524,   -1,  526,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,   -1,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,   -1,  607,  608,  609,  610,  611,
  612,   -1,  614,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,   -1,  259,   -1,   -1,   -1,   -1,   -1,  265,
   -1,  267,  268,  269,   -1,   -1,   -1,   -1,  274,   -1,
   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,
  286,   -1,  288,   -1,   -1,  291,  292,  293,   -1,   -1,
   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,
   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,
  316,   -1,   -1,  319,   -1,  321,  322,   -1,   -1,   -1,
   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,
   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,  347,   -1,  349,  350,  351,   -1,  353,   -1,  355,
   -1,   -1,  358,  359,   -1,   -1,  362,  363,  364,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,
  386,   -1,  388,   -1,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,   -1,   -1,   -1,  403,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,
  416,  417,  418,  419,  420,  421,  422,  423,   -1,   -1,
   -1,  427,   -1,  429,   -1,   -1,   -1,  433,   -1,   -1,
   40,   -1,   -1,   43,  440,   45,   -1,   -1,   -1,  445,
  446,  447,  448,  449,  450,  451,  452,  453,   58,  455,
  456,  457,  458,   63,  460,  461,   -1,   -1,   -1,   -1,
   -1,   -1,  468,  469,  470,  471,  472,  473,  474,  475,
  476,  477,  478,  479,  480,   -1,  482,  483,  484,  485,
  486,   -1,  488,  489,  490,   -1,  492,  493,  494,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,
   -1,  517,   -1,  519,  520,  521,   -1,  523,  524,   -1,
  526,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,   -1,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
   -1,  607,  608,  609,  610,  611,  612,   -1,  614,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,
   -1,   -1,   -1,   -1,   -1,  265,   -1,  267,  268,  269,
   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,
  280,  281,   -1,  283,   -1,  285,  286,   -1,  288,   -1,
   -1,  291,  292,  293,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,
   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  319,
   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,  347,   -1,  349,
  350,  351,   -1,  353,   -1,  355,   -1,   -1,  358,  359,
   -1,   -1,  362,  363,  364,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,
  380,  381,  382,  383,  384,   -1,  386,   -1,  388,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
   -1,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,  417,  418,  419,
  420,  421,  422,  423,   -1,   -1,   -1,  427,   -1,  429,
   -1,   -1,   -1,  433,   -1,   -1,   40,   -1,   42,   43,
  440,   45,   -1,   -1,  444,  445,  446,  447,  448,  449,
  450,  451,  452,  453,   58,  455,  456,  457,  458,   63,
  460,  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,
  470,  471,  472,  473,  474,  475,  476,  477,  478,  479,
  480,   -1,  482,  483,  484,  485,  486,   -1,  488,  489,
  490,   -1,  492,  493,  494,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,
  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,  519,
  520,  521,   -1,  523,  524,   -1,  526,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,   -1,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,   -1,  607,  608,  609,
  610,  611,  612,   -1,  614,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,   -1,  259,  260,   -1,   -1,   -1,
   -1,  265,   -1,  267,  268,  269,   -1,   -1,   -1,   -1,
  274,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,
   -1,  285,  286,   -1,  288,   -1,   -1,  291,  292,  293,
   -1,   -1,   -1,   -1,  298,  299,  300,  301,   -1,   -1,
   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  319,   -1,  321,  322,   -1,
   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,
   -1,   -1,   -1,  347,   -1,  349,  350,  351,   -1,  353,
   -1,  355,   -1,   -1,  358,  359,   -1,   -1,  362,  363,
  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,
  384,   -1,  386,   -1,  388,   -1,   -1,   -1,  392,   -1,
  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,  403,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,
  414,   -1,  416,  417,  418,  419,  420,  421,  422,  423,
   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,  433,
   -1,   -1,   40,   -1,   42,   43,  440,   45,   -1,   -1,
   -1,  445,  446,  447,  448,  449,  450,  451,  452,  453,
   58,  455,  456,  457,  458,   63,  460,  461,   -1,   -1,
   -1,   -1,   -1,   -1,  468,  469,  470,  471,  472,  473,
  474,  475,  476,  477,  478,  479,  480,   -1,  482,   -1,
   -1,  485,  486,   -1,  488,  489,  490,   -1,  492,  493,
  494,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,
  514,  515,   -1,  517,   -1,  519,  520,  521,   -1,  523,
  524,   -1,  526,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,   -1,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,   -1,  607,  608,  609,  610,  611,  612,   -1,
  614,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
   -1,  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,  267,
  268,  269,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,
   -1,   -1,  280,  281,   -1,  283,   -1,  285,  286,   -1,
  288,   -1,   -1,  291,  292,  293,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,
  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  319,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,
   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,  347,
   -1,  349,  350,  351,   -1,  353,   -1,  355,   -1,   -1,
  358,  359,   -1,   -1,  362,  363,  364,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,
   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,
  388,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,
  398,  399,   -1,   -1,   -1,  403,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,  417,
  418,  419,  420,  421,  422,  423,   -1,   -1,   -1,  427,
   -1,  429,   -1,   -1,   -1,  433,   -1,   -1,   40,   -1,
   -1,   43,  440,   45,   -1,   -1,   -1,  445,  446,  447,
  448,  449,  450,  451,  452,  453,   58,  455,  456,  457,
  458,   63,  460,  461,   -1,   -1,   -1,   -1,   -1,   -1,
  468,  469,  470,  471,  472,  473,  474,  475,  476,  477,
  478,  479,  480,   -1,  482,  483,  484,  485,  486,   -1,
  488,  489,  490,   -1,  492,  493,  494,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,  517,
   -1,  519,  520,  521,   -1,  523,  524,   -1,  526,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,   -1,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,   -1,  607,
  608,  609,  610,  611,  612,   -1,  614,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,
   -1,   -1,   -1,  265,   -1,  267,  268,  269,   -1,   -1,
   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,  280,  281,
   -1,  283,   -1,  285,  286,   -1,  288,   -1,   -1,  291,
  292,  293,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  319,   -1,  321,
  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,
   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,  347,   -1,  349,  350,  351,
   -1,  353,   -1,  355,   -1,   -1,  358,  359,   -1,   -1,
  362,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,
  382,  383,  384,   -1,  386,   -1,  388,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,
   -1,  403,   -1,   -1,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,  417,  418,  419,  420,  421,
  422,  423,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,
   -1,  433,   -1,   -1,   40,   -1,   -1,   43,  440,   45,
   -1,   -1,   -1,  445,  446,  447,  448,  449,  450,  451,
  452,  453,   58,  455,  456,  457,  458,   63,  460,  461,
   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,  470,  471,
  472,  473,  474,  475,  476,  477,  478,  479,  480,   -1,
  482,  483,  484,  485,  486,   -1,  488,  489,  490,   -1,
  492,  493,  494,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,
   -1,  513,  514,  515,   -1,  517,   -1,  519,  520,  521,
   -1,  523,  524,   -1,  526,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,   -1,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,   -1,  607,  608,  609,  610,  611,
  612,   -1,  614,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  257,   -1,  259,   -1,   -1,   -1,   -1,   -1,  265,
   -1,  267,  268,  269,   -1,   -1,   -1,   -1,  274,   -1,
   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,
  286,   -1,  288,   -1,   -1,  291,  292,  293,   -1,   -1,
   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,
   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  319,   -1,  321,  322,   -1,   -1,   -1,
   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,
   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,  347,   -1,  349,  350,  351,   -1,  353,   -1,  355,
   -1,   -1,  358,  359,   -1,   -1,  362,  363,  364,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,
  386,   -1,  388,   -1,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,   -1,   -1,   -1,  403,   -1,   -1,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,
  416,  417,  418,  419,  420,  421,  422,  423,   -1,   -1,
   -1,  427,   -1,  429,   -1,   -1,   -1,  433,   -1,   -1,
   40,   -1,   -1,   43,  440,   45,   -1,   -1,   -1,  445,
  446,  447,  448,  449,  450,  451,  452,  453,   58,  455,
  456,  457,  458,   63,  460,  461,   -1,   -1,   -1,   -1,
   -1,   -1,  468,  469,  470,  471,  472,  473,  474,  475,
  476,  477,  478,  479,  480,   -1,  482,  483,  484,  485,
  486,   -1,  488,  489,  490,   -1,  492,  493,  494,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,
   -1,  517,   -1,  519,  520,  521,   -1,  523,  524,   -1,
  526,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,   -1,  582,  583,  584,  585,
   -1,  587,  588,  589,  590,  591,   -1,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
   -1,  607,  608,  609,  610,  611,  612,   -1,  614,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,  259,
   -1,   -1,   -1,   -1,   -1,  265,   -1,  267,  268,  269,
   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,   -1,   -1,
  280,  281,   -1,  283,   -1,  285,  286,   -1,  288,   -1,
   -1,  291,  292,  293,   -1,   -1,   -1,   -1,  298,   -1,
  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,
   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  319,
   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,
   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,
   -1,   -1,   -1,  343,   -1,   -1,   -1,  347,   -1,  349,
  350,  351,   -1,  353,   -1,  355,   -1,   -1,  358,  359,
   -1,   -1,  362,  363,  364,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,
  380,  381,  382,  383,  384,   -1,  386,   -1,  388,   -1,
   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,
   -1,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,  409,
  410,  411,  412,   -1,  414,   -1,  416,  417,  418,  419,
  420,  421,  422,  423,   -1,   -1,   -1,  427,   -1,  429,
   -1,   -1,   -1,  433,   -1,   -1,   40,   -1,   -1,   43,
  440,   45,   -1,   -1,   -1,  445,  446,  447,  448,  449,
  450,  451,  452,  453,   58,  455,  456,  457,  458,   63,
  460,  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,
  470,  471,  472,  473,  474,  475,  476,  477,  478,  479,
  480,   -1,  482,  483,  484,  485,  486,   -1,  488,  489,
  490,   -1,  492,  493,  494,  495,   -1,   -1,  498,  499,
  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,
  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,  519,
  520,  521,   -1,  523,  524,   -1,  526,  527,  528,  529,
  530,  531,  532,  533,  534,  535,  536,  537,  538,  539,
  540,  541,  542,  543,  544,  545,  546,  547,   -1,  549,
  550,  551,  552,  553,  554,   -1,  556,  557,  558,  559,
   -1,  561,   -1,  563,  564,  565,  566,  567,  568,  569,
  570,  571,  572,  573,  574,  575,  576,  577,  578,  579,
  580,   -1,  582,  583,  584,  585,   -1,  587,  588,  589,
  590,  591,   -1,  593,  594,  595,  596,  597,  598,  599,
  600,  601,  602,  603,  604,  605,   -1,  607,  608,  609,
  610,  611,  612,   -1,  614,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,   -1,  259,   -1,   -1,   -1,   -1,
   -1,  265,   -1,  267,  268,  269,   -1,   -1,   -1,   -1,
  274,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,
   -1,  285,  286,   -1,  288,   -1,   -1,  291,  292,  293,
   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,
   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  319,   -1,  321,  322,   -1,
   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,
   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,
   -1,   -1,   -1,  347,   -1,  349,  350,  351,   -1,  353,
   -1,  355,   -1,   -1,  358,  359,   -1,   -1,  362,  363,
  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,
  384,   -1,  386,   -1,  388,   -1,   -1,   -1,  392,   -1,
  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,  403,
   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,
  414,   -1,  416,  417,  418,  419,  420,  421,  422,  423,
   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,  433,
   -1,   -1,   40,   -1,   -1,   43,  440,   45,   -1,   -1,
   -1,  445,  446,  447,  448,  449,  450,  451,  452,  453,
   58,  455,  456,  457,  458,   63,  460,  461,   -1,   -1,
   -1,   -1,   -1,   -1,  468,  469,  470,  471,  472,  473,
  474,  475,  476,  477,  478,  479,  480,   -1,  482,  483,
  484,  485,  486,   -1,  488,  489,  490,   -1,  492,  493,
  494,  495,   -1,   -1,  498,  499,  500,  501,  502,  503,
  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,
  514,  515,   -1,  517,   -1,  519,  520,  521,   -1,  523,
  524,   -1,  526,  527,  528,  529,  530,  531,  532,  533,
  534,  535,  536,  537,  538,  539,  540,  541,  542,  543,
  544,  545,  546,  547,   -1,  549,  550,  551,  552,  553,
  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,
  564,  565,  566,  567,  568,  569,  570,  571,  572,  573,
  574,  575,  576,  577,  578,  579,  580,   -1,  582,  583,
  584,  585,   -1,  587,  588,  589,  590,  591,   -1,  593,
  594,  595,  596,  597,  598,  599,  600,  601,  602,  603,
  604,  605,   -1,  607,  608,  609,  610,  611,  612,   -1,
  614,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,
   -1,  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,  267,
  268,  269,   -1,   -1,   -1,   -1,  274,   -1,   -1,   -1,
   -1,   -1,  280,  281,   -1,  283,   -1,  285,  286,   -1,
  288,   -1,   -1,  291,  292,  293,   -1,   -1,   -1,   -1,
  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,
  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  319,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,
   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,
   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,  347,
   -1,  349,  350,  351,   -1,  353,   -1,  355,   -1,   -1,
  358,  359,   -1,   -1,  362,  363,  364,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,
   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,
  388,   -1,   -1,   -1,  392,   -1,  394,  395,   40,   -1,
  398,  399,   -1,   -1,   -1,  403,   -1,   -1,  406,   -1,
   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,  417,
  418,  419,  420,  421,  422,  423,   -1,   -1,   -1,  427,
   -1,  429,   -1,   -1,   -1,  433,   -1,   -1,   -1,   -1,
   -1,   -1,  440,   -1,   -1,   -1,   -1,  445,  446,  447,
  448,  449,  450,  451,  452,  453,   -1,  455,  456,  457,
  458,   -1,  460,  461,   -1,   -1,   -1,   -1,   -1,   -1,
  468,  469,  470,  471,  472,  473,  474,  475,  476,  477,
  478,  479,  480,   -1,  482,  483,  484,  485,  486,   -1,
  488,  489,  490,   -1,  492,  493,  494,  495,   -1,   -1,
  498,  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,
   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,  517,
   -1,  519,  520,  521,   -1,  523,  524,   -1,  526,  527,
  528,  529,  530,  531,  532,  533,  534,  535,  536,  537,
  538,  539,  540,  541,  542,  543,  544,  545,  546,  547,
   -1,  549,  550,  551,  552,  553,  554,   -1,  556,  557,
  558,  559,   -1,  561,   -1,  563,  564,  565,  566,  567,
  568,  569,  570,  571,  572,  573,  574,  575,  576,  577,
  578,  579,  580,   -1,  582,  583,  584,  585,   -1,  587,
  588,  589,  590,  591,   -1,  593,  594,  595,  596,  597,
  598,  599,  600,  601,  602,  603,  604,  605,   -1,  607,
  608,  609,  610,  611,  612,  257,  614,  259,   -1,   -1,
   -1,   -1,   -1,  265,   -1,   -1,  268,  269,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,
   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,
   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,
   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,
  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,
  332,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,
   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,
   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,
   -1,  363,  364,   -1,  366,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  376,   -1,  378,   -1,  380,  381,
  382,  383,  384,   -1,  386,   -1,   -1,   -1,   -1,   -1,
  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,
   -1,   -1,   -1,   40,  406,   -1,   -1,  409,  410,  411,
  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,
  422,   58,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,   -1,
   -1,   -1,   -1,  445,  446,   -1,   -1,   -1,  450,   -1,
   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,
  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,   -1,
  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,
  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,
   -1,  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,
  532,  533,  534,  535,  536,  537,  538,  539,  540,  541,
  542,  543,  544,  545,  546,  547,   -1,  549,  550,  551,
  552,  553,  554,   -1,  556,  557,  558,  559,   -1,  561,
   -1,  563,  564,  565,  566,  567,  568,  569,  570,  571,
  572,  573,  574,  575,  576,  577,  578,  579,  580,   -1,
  582,  583,  584,  585,   -1,  587,  588,  589,  590,  591,
   -1,  593,  594,  595,  596,  597,  598,  599,  600,  601,
  602,  603,  604,  605,   -1,  607,  608,  609,  610,  611,
  612,   -1,  614,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  257,   -1,  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,
   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,
   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,
  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,   -1,   -1,  355,   -1,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,
   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   40,
   -1,  398,  399,   -1,   -1,   -1,   -1,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,   -1,   -1,
  427,   -1,  429,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,   -1,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,   -1,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,   -1,
  607,  608,  609,  610,  611,  612,  257,  614,  259,   -1,
   -1,   -1,   -1,   -1,  265,   -1,   -1,  268,  269,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,
  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,
  381,  382,  383,  384,   -1,  386,   -1,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,   40,   -1,  398,  399,   -1,
   -1,   -1,   -1,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
   -1,   -1,   -1,  444,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
   -1,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,
  511,   -1,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
   -1,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,   -1,  607,  608,  609,  610,
  611,  612,  257,  614,  259,   -1,   -1,   -1,   -1,   -1,
  265,   -1,   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,
  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,
   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,   -1,   -1,
  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,   40,   -1,  398,  399,   -1,   -1,   -1,   -1,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,   -1,   -1,  489,  490,   -1,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,   -1,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,   -1,  607,  608,  609,  610,  611,  612,  257,  614,
  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,   -1,  268,
  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,
   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,   -1,   -1,  355,   -1,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,
   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,   42,   -1,   -1,   -1,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,   -1,   -1,  427,   -1,
  429,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,   -1,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,
  509,  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,   -1,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,   -1,  607,  608,
  609,  610,  611,  612,   -1,  614,  257,   -1,  259,   -1,
   -1,   -1,   -1,   -1,  265,   -1,   -1,  268,  269,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,  293,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,
  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,
  381,  382,  383,  384,   -1,  386,   -1,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,   42,
   -1,   -1,   -1,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
   -1,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,
  511,   -1,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
   -1,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,   -1,  607,  608,  609,  610,
  611,  612,   -1,  614,  257,   -1,  259,   -1,   -1,   -1,
   -1,   -1,  265,   -1,   -1,  268,  269,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,
   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,
  383,  384,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,   44,   -1,   -1,
   -1,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,
   -1,   -1,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   -1,  489,  490,   -1,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,   -1,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,   -1,  607,  608,  609,  610,  611,  612,
  257,  614,  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,
   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,
   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,  316,
   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,
  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,   -1,   -1,  355,   -1,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,
   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,   -1,   45,   -1,   -1,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,   -1,   -1,
  427,   -1,  429,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,   -1,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,   -1,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,   -1,
  607,  608,  609,  610,  611,  612,  257,  614,  259,   -1,
   -1,   -1,   -1,   -1,  265,   -1,   -1,  268,  269,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,
  311,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,
  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,   -1,   -1,  355,   41,   -1,  358,   44,   -1,
   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   59,   -1,  376,   -1,   -1,   -1,  380,
  381,  382,  383,  384,   -1,  386,   -1,   -1,   -1,    0,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,
   -1,   -1,    0,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,
   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,  440,
   -1,   -1,   -1,   41,  445,  446,   44,  448,   59,  450,
   61,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,   59,   -1,   61,   -1,   -1,   -1,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   91,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
   -1,  492,  493,   91,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,
  511,   -1,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
    0,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,   -1,  607,  608,  609,  610,
  611,  612,   -1,  614,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,  314,   -1,
   -1,  317,   -1,   -1,   -1,   -1,   -1,   -1,  324,   59,
  326,   61,   -1,   -1,  330,   -1,   -1,  258,   -1,  335,
   -1,   -1,  338,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  258,   -1,  273,   -1,   -1,  276,  277,  353,   -1,   -1,
  281,   91,   -1,  284,   -1,  273,   -1,   -1,  276,  277,
  366,   -1,   -1,  281,   -1,  296,  284,   -1,  374,   -1,
   -1,  302,  378,   -1,  305,   -1,   -1,   -1,  296,   -1,
   -1,  387,   -1,   -1,  302,   -1,   -1,  305,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  403,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  347,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  430,   -1,   -1,   -1,   -1,  347,
   -1,   -1,   -1,   -1,   -1,   -1,  442,   -1,  444,  370,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  370,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  391,   -1,   -1,   -1,   -1,   -1,  397,   -1,   -1,   -1,
  401,   -1,   58,  391,   -1,   -1,   -1,  408,   -1,  397,
   -1,   -1,   -1,  401,   -1,  491,   -1,   -1,   -1,   -1,
  408,   -1,   -1,   -1,   -1,  426,   -1,   -1,   -1,   -1,
  431,   -1,  508,   -1,   -1,   -1,  512,   -1,  426,   -1,
   -1,   -1,   -1,  431,   -1,   -1,   -1,   -1,  258,   -1,
   -1,  527,   -1,   -1,   -1,  456,   -1,   -1,   -1,  460,
   -1,   -1,   -1,  273,   -1,   -1,  276,  277,  456,   -1,
   -1,  281,  460,   -1,  284,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  296,   -1,   -1,   -1,
   -1,   -1,  302,   -1,   -1,  305,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  347,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  559,   -1,
  370,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  559,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  391,   -1,   -1,   -1,   -1,   -1,  397,   -1,   -1,
   -1,  401,   -1,   -1,   -1,   -1,   -1,   -1,  408,   -1,
   -1,  257,   -1,  259,   -1,   -1,   -1,   -1,   -1,  265,
   -1,   -1,  268,  269,   -1,   -1,  426,   -1,   -1,   -1,
   -1,  431,   -1,   -1,  280,  281,   -1,  283,   -1,  285,
   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,
   -1,   -1,  298,   -1,  300,  301,  456,   -1,   -1,  305,
  460,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,   -1,
   -1,  327,   -1,  329,    0,  331,   -1,   -1,   -1,   -1,
   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  351,   -1,   -1,   -1,  355,
   -1,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,
   -1,   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,
  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,
  386,   -1,   -1,   59,   -1,   -1,  392,   -1,  394,  395,
   -1,   -1,  398,  399,   -1,   -1,   -1,   -1,   -1,  559,
  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,
  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,   -1,
    0,  427,   -1,  429,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,  445,
  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,
  456,  457,  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,
   -1,   41,  468,  469,   44,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,   59,
   -1,   -1,   -1,  489,  490,   -1,  492,  493,   -1,  495,
   -1,   -1,  498,  499,  500,  501,  502,  503,  504,   -1,
   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,
   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  527,  528,  529,  530,  531,  532,  533,  534,  535,
  536,  537,  538,  539,  540,  541,  542,  543,  544,  545,
  546,  547,   -1,  549,  550,  551,  552,  553,  554,   -1,
  556,  557,  558,  559,   -1,  561,   -1,  563,  564,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  574,  575,
  576,  577,  578,  579,  580,   -1,  582,  583,  584,  585,
    0,  587,  588,  589,  590,  591,  262,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
   -1,  607,  608,  609,  610,  611,  612,   -1,  614,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   41,   -1,   -1,   44,    0,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  314,   59,
   -1,  317,   -1,   -1,   -1,   -1,   -1,   -1,  324,   -1,
  326,   -1,   -1,   -1,  330,   -1,   -1,   -1,   -1,  335,
   -1,   -1,  338,   -1,   -1,   -1,   41,   -1,   -1,   44,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  353,   -1,   -1,
   -1,   -1,  262,   -1,   59,   -1,   -1,   -1,   -1,   -1,
  366,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  374,   -1,
   -1,  377,  378,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  387,   -1,   -1,   -1,   -1,   -1,   -1,   -1,    0,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  403,   -1,   -1,
   -1,   -1,   -1,   -1,  314,   -1,   -1,  317,   -1,   -1,
   -1,   -1,   -1,   -1,  324,   -1,  326,   -1,   -1,  425,
  330,    0,   -1,   -1,  430,  335,   -1,   -1,  338,   -1,
   41,   -1,   -1,   44,   -1,  441,  442,   -1,  444,   -1,
   -1,   -1,   -1,  353,   -1,   -1,   -1,   -1,   59,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  366,   -1,   -1,   -1,
   -1,   -1,   41,   -1,  374,   44,   -1,  377,  378,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  387,   -1,   -1,
   59,   -1,   -1,   -1,   -1,  491,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  403,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  508,   -1,   -1,   -1,  512,   -1,   -1,   -1,
   -1,   -1,  262,   -1,   -1,  425,   -1,   -1,   -1,   -1,
  430,  527,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  441,  442,   -1,  444,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  262,   -1,   -1,
   -1,   -1,   -1,   -1,  314,   -1,   -1,  317,   -1,   -1,
   -1,   -1,   -1,   -1,  324,   -1,  326,   -1,   -1,    0,
  330,  491,   -1,   -1,   -1,  335,   -1,   -1,  338,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  508,   -1,
   -1,   -1,  512,  353,   -1,   -1,   -1,   -1,   -1,  314,
   -1,    0,  317,   -1,   -1,   -1,  366,  527,   -1,  324,
   41,  326,   -1,   44,  374,  330,   -1,  377,  378,   -1,
  335,   -1,   -1,  338,   -1,   -1,   -1,  387,   59,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  353,   -1,
   -1,  262,   41,  403,   -1,   44,   -1,   -1,   -1,   -1,
   -1,  366,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  374,
   59,   -1,  377,  378,   -1,  425,   -1,   -1,   -1,   -1,
  430,   -1,  387,  262,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  441,  442,   -1,  444,   -1,   -1,   -1,  403,   -1,
   -1,   -1,   -1,  314,   -1,    0,  317,   -1,   -1,   -1,
   -1,   -1,   -1,  324,   -1,  326,   -1,   -1,   -1,  330,
  425,   -1,   -1,   -1,  335,  430,   -1,  338,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  314,  441,  442,  317,  444,
   -1,  491,  353,   -1,   -1,  324,   41,  326,   -1,   44,
    0,  330,   -1,   -1,   -1,  366,  335,   -1,  508,  338,
   -1,   -1,  512,  374,   59,   -1,  377,  378,   -1,   -1,
   -1,   -1,   -1,   -1,  353,   -1,  387,  527,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  491,  366,   -1,   -1,
   -1,   41,  403,   -1,   44,  374,   -1,   -1,  377,  378,
   -1,   -1,   -1,  508,   -1,   -1,   -1,  512,  387,   59,
   -1,   -1,   -1,   -1,  425,   -1,   -1,   -1,   -1,  430,
   -1,   -1,  527,   -1,  403,   -1,   -1,   -1,   -1,   -1,
  441,  442,   -1,  444,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  262,   -1,   -1,   -1,   -1,  425,   -1,    0,   -1,
   -1,  430,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  441,  442,   -1,  444,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,   -1,   -1,   -1,   -1,   -1,
  491,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,
   -1,   -1,   44,  314,   -1,   -1,  317,  508,   -1,   -1,
   -1,  512,   -1,  324,   -1,  326,   -1,   59,   -1,  330,
   -1,   -1,  491,   -1,  335,   -1,  527,  338,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  314,   -1,   -1,  317,  508,
   -1,   -1,  353,  512,   -1,  324,   -1,  326,   -1,   -1,
   -1,  330,   -1,   -1,   -1,  366,  335,   -1,  527,  338,
   -1,   -1,   -1,  374,   -1,   -1,  377,  378,    0,   -1,
   -1,   -1,   -1,   -1,  353,   -1,  387,  262,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  366,   -1,   -1,
   -1,   -1,  403,   -1,   -1,  374,   -1,   -1,  377,  378,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  387,   41,
   -1,   -1,   44,   -1,  425,   -1,   -1,   -1,   -1,  430,
   -1,   -1,  262,   -1,  403,   -1,    0,   59,   -1,  314,
  441,  442,  317,  444,   -1,   -1,   -1,   -1,   -1,  324,
   -1,  326,   -1,   -1,   -1,  330,  425,   -1,   -1,   -1,
  335,  430,   -1,  338,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  441,  442,    0,  444,   -1,   41,  353,   -1,
   44,   -1,   -1,   -1,  314,   -1,   -1,  317,   -1,   -1,
  491,  366,   -1,   -1,  324,   59,  326,   -1,   -1,  374,
  330,   -1,  377,  378,   -1,  335,   -1,  508,  338,   -1,
   -1,  512,  387,   -1,   -1,   41,   -1,   -1,   44,   -1,
   -1,   -1,  491,  353,   -1,   -1,  527,   -1,  403,   -1,
  262,   -1,   -1,   59,   -1,   -1,  366,   -1,   -1,  508,
   -1,   -1,   -1,  512,  374,   -1,   -1,  377,  378,   -1,
  425,   -1,   -1,   -1,   -1,  430,   -1,  387,  527,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  441,  442,   -1,  444,
   -1,   -1,   -1,  403,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  314,   -1,    0,  317,   -1,   -1,   -1,   -1,
   -1,   -1,  324,   -1,  326,  425,   -1,   -1,  330,   -1,
  430,   -1,   -1,  335,   -1,   -1,  338,   -1,   -1,   -1,
   -1,  441,  442,   -1,  444,   -1,  491,   -1,   -1,   -1,
   -1,  353,   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,
   -1,   -1,   -1,  508,  366,   -1,   -1,  512,   -1,   -1,
  262,   -1,  374,   59,   -1,  377,  378,   -1,   -1,   -1,
   -1,   -1,  527,   -1,   -1,  387,   -1,   -1,   -1,   -1,
   -1,  491,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  403,   -1,   -1,   -1,   -1,   -1,   -1,  508,   -1,
    0,   -1,  512,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  314,  425,   -1,  317,   -1,  527,  430,   -1,
   -1,   -1,  324,   -1,  326,   -1,   -1,   -1,  330,  441,
  442,   -1,  444,  335,   -1,   -1,  338,   -1,   -1,   -1,
   -1,   41,   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,
   -1,  353,   -1,   -1,   -1,   -1,  262,   -1,    0,   59,
   -1,   -1,   -1,   -1,  366,   -1,   -1,   -1,   -1,   -1,
  314,   -1,  374,  317,   -1,  377,  378,   -1,   -1,  491,
  324,   -1,  326,   -1,   -1,  387,  330,   -1,   -1,   -1,
   -1,  335,   -1,   -1,  338,   -1,  508,   -1,   -1,   41,
  512,  403,   44,   -1,   -1,   -1,   -1,   -1,  314,  353,
   -1,  317,   -1,   -1,   -1,  527,   -1,   59,  324,   -1,
  326,   -1,  366,  425,  330,   -1,   -1,   -1,  430,  335,
  374,   -1,  338,   -1,  378,   -1,   -1,   -1,   -1,  441,
  442,   -1,  444,  387,   -1,   -1,   -1,  353,   -1,   -1,
   -1,   -1,    0,   -1,   -1,   -1,   -1,   -1,   -1,  403,
  366,   -1,   -1,   -1,   -1,   -1,  262,   -1,  374,   -1,
   -1,  377,  378,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  387,   -1,   -1,   -1,   -1,  430,   -1,   -1,  491,
   -1,   -1,   -1,   41,   -1,   -1,   44,  403,  442,   -1,
  444,   -1,   -1,   -1,   -1,   -1,  508,   -1,   -1,   -1,
  512,   59,   -1,   -1,   -1,   -1,   -1,   -1,  314,  425,
   -1,  317,   -1,   -1,  430,  527,   -1,   -1,  324,   -1,
  326,   -1,   -1,    0,  330,  441,  442,   -1,  444,  335,
   -1,   -1,  338,   -1,   -1,   -1,   -1,  491,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  353,   -1,   -1,
   -1,   -1,  262,   -1,  508,   -1,   -1,   -1,  512,   -1,
  366,   -1,   -1,   -1,   41,   -1,   -1,   44,  374,   -1,
   -1,  377,  378,  527,   -1,  491,   -1,   -1,   -1,   -1,
   -1,  387,   59,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  508,   -1,   -1,   -1,  512,  403,   -1,   -1,
   -1,   -1,   -1,   -1,  314,   -1,   -1,  317,   -1,   -1,
  262,  527,   -1,   -1,  324,   -1,  326,    0,   -1,  425,
  330,   -1,   -1,   -1,  430,  335,   -1,   -1,  338,   -1,
   -1,   -1,   -1,   -1,   -1,  441,  442,   -1,  444,   -1,
   -1,   -1,   -1,  353,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  366,   -1,   41,   -1,
   -1,   44,  314,   -1,  374,  317,   -1,  377,  378,   -1,
   -1,   -1,  324,   -1,  326,   -1,   59,  387,  330,   -1,
   -1,   -1,   -1,  335,   -1,  491,  338,   -1,   -1,   -1,
   -1,   -1,   -1,  403,   -1,   -1,   -1,   -1,    0,   -1,
   -1,  353,  508,   -1,  262,   -1,  512,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  366,  425,   -1,   -1,   -1,   -1,
  430,  527,  374,   -1,   -1,  377,  378,   -1,   -1,   -1,
   -1,  441,  442,   -1,  444,  387,   -1,   -1,   -1,   41,
   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  403,   -1,   -1,   -1,   -1,  314,   59,   -1,  317,
   -1,   -1,   -1,   -1,   -1,   -1,  324,   -1,  326,   -1,
   -1,   -1,  330,  425,   -1,   -1,   -1,  335,  430,   -1,
  338,  491,   -1,   -1,   -1,  262,   -1,   -1,   -1,  441,
  442,   -1,  444,   -1,   -1,  353,   -1,   -1,  508,   -1,
   -1,   -1,  512,   -1,   -1,   -1,   -1,   -1,  366,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  374,  527,   -1,  377,
  378,    0,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  387,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  314,   -1,  491,
  317,   -1,   -1,   -1,   -1,  403,   -1,  324,   -1,  326,
   -1,   -1,   -1,  330,   -1,   -1,  508,   -1,  335,   -1,
  512,  338,   41,   -1,   -1,   44,   -1,  425,   -1,   -1,
   -1,   -1,  430,   -1,   -1,  527,  353,   -1,   -1,  262,
   59,   -1,   -1,  441,  442,   -1,  444,   -1,   -1,  366,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  374,   -1,   -1,
  377,  378,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  387,   -1,   -1,   -1,   -1,    0,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  403,   -1,   -1,   -1,
   -1,  314,   -1,  491,  317,   -1,   -1,   -1,   -1,   -1,
   -1,  324,   -1,  326,   -1,   -1,   -1,  330,  425,   -1,
  508,   -1,  335,  430,  512,  338,   41,   -1,   -1,   44,
  262,   -1,   -1,   -1,  441,  442,   -1,  444,   -1,  527,
  353,   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  366,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  374,   -1,   -1,  377,  378,    0,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  387,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  314,   -1,  491,  317,   -1,   -1,   -1,   -1,
  403,   -1,  324,   -1,  326,   -1,   -1,   -1,  330,   -1,
   -1,  508,   -1,  335,   -1,  512,  338,   41,   -1,   -1,
   44,   -1,  425,   -1,   -1,   -1,   -1,  430,   -1,   -1,
  527,  353,   -1,   -1,    0,   59,   -1,   -1,  441,  442,
   -1,  444,   -1,   -1,  366,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  374,   -1,   -1,  377,  378,   -1,   -1,   -1,
   -1,   -1,   -1,  262,   -1,  387,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,   -1,
   -1,  403,   -1,   -1,   -1,   -1,   -1,   -1,  491,   -1,
   -1,   -1,   -1,   59,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  425,   -1,  508,   -1,   -1,  430,  512,
   -1,   -1,   -1,   -1,   -1,  314,   -1,   -1,  317,  441,
  442,   -1,  444,   -1,  527,  324,   -1,  326,   -1,   -1,
    0,  330,   -1,   -1,   -1,   -1,  335,   -1,   -1,  338,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  353,   -1,   -1,  262,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  366,   -1,  491,
   -1,   41,   -1,   -1,   44,  374,   -1,   -1,  377,  378,
   -1,   -1,   -1,   -1,   -1,   -1,  508,   -1,  387,   59,
  512,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  403,  527,   -1,   -1,   -1,  314,
   -1,   -1,  317,   -1,   -1,   -1,   -1,   -1,   -1,  324,
   -1,  326,   -1,   -1,    0,  330,  425,   -1,   -1,   -1,
  335,  430,   -1,  338,   -1,   -1,   -1,   -1,  262,   -1,
   -1,   -1,  441,  442,   -1,  444,   -1,   -1,  353,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  366,   -1,   -1,   -1,   41,   -1,   -1,   44,  374,
   -1,   -1,  377,  378,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  387,   59,   -1,   -1,   -1,   -1,   -1,   -1,
  314,   -1,  491,  317,   -1,   -1,  262,   -1,  403,   -1,
  324,   -1,  326,   -1,   -1,   -1,  330,   -1,   -1,  508,
   -1,  335,   -1,  512,  338,   -1,   -1,   -1,   -1,   -1,
  425,   -1,   -1,   -1,   -1,  430,    0,   -1,  527,  353,
   -1,   -1,   -1,   -1,   -1,   -1,  441,  442,   -1,  444,
   -1,   -1,  366,   -1,   -1,   -1,   -1,   -1,  314,   -1,
  374,  317,   -1,  377,  378,   -1,   -1,   -1,  324,   -1,
  326,   -1,   -1,  387,  330,   -1,   40,   41,   -1,  335,
   44,   -1,  338,   -1,   -1,   -1,   -1,   -1,   -1,  403,
   -1,   -1,   -1,   -1,   -1,   59,  491,  353,   -1,   -1,
   -1,   -1,  262,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  366,  425,   -1,  508,   -1,   -1,  430,  512,  374,   -1,
   -1,  377,  378,   -1,   -1,   -1,   -1,  441,  442,   -1,
  444,  387,  527,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  403,   -1,   -1,
   -1,   -1,   -1,   -1,  314,   -1,   -1,  317,   -1,   -1,
   -1,   -1,   -1,   -1,  324,   -1,  326,   -1,   -1,  425,
  330,   -1,   -1,   -1,  430,  335,   -1,  491,  338,   -1,
   -1,   -1,   -1,   -1,   -1,  441,  442,   -1,  444,   -1,
   -1,   -1,   -1,  353,  508,   -1,  262,   -1,  512,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  366,   -1,   -1,   -1,
   -1,   -1,   -1,  527,  374,   -1,   -1,  377,  378,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  387,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  491,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  403,   -1,   -1,   -1,   -1,  314,   -1,
   -1,  317,  508,   -1,   -1,   -1,  512,   -1,  324,   -1,
  326,   -1,   -1,   -1,  330,  425,   -1,   -1,   -1,  335,
  430,  527,  338,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  441,  442,   -1,  444,   -1,   -1,  353,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  366,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  374,   -1,
   -1,  377,  378,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  387,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  491,   -1,   -1,   -1,   -1,   -1,  403,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  508,   -1,
  314,   -1,  512,  317,   -1,   -1,   -1,   -1,   -1,  425,
  324,   -1,  326,   -1,  430,   -1,  330,  527,   -1,   -1,
   -1,  335,   -1,   -1,  338,  441,  442,   -1,  444,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  353,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  366,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  374,   -1,   -1,   -1,  378,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  387,   -1,  491,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  403,
   -1,   -1,  508,   -1,   -1,   -1,  512,   -1,  257,   -1,
  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,   -1,  268,
  269,  527,   -1,   -1,   -1,   -1,  430,   -1,   -1,   -1,
   -1,  280,  281,   -1,  283,   -1,  285,   -1,  442,  288,
  444,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,
   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,  491,  337,   -1,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,  508,   -1,  355,   -1,  512,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,
   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,   -1,   -1,   -1,   -1,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,   -1,   -1,  427,   -1,
  429,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,  454,  455,  456,  457,  458,
  459,  460,  461,  462,  463,  464,  465,  466,  467,  468,
  469,  470,  471,  472,  473,  474,   -1,   -1,  477,  478,
  479,  480,  481,  482,  483,  484,  485,  486,  487,  488,
  489,  490,  491,  492,  493,  494,  495,  496,  497,  498,
  499,  500,  501,  502,  503,  504,  505,  506,  507,  508,
  509,  510,  511,  512,  513,  514,  515,  516,  517,  518,
  519,  520,  521,  522,  523,  524,  525,  526,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,  548,
  549,  550,  551,  552,  553,  554,  555,  556,  557,  558,
  559,  560,  561,  562,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,  582,  583,  584,  585,  586,  587,  588,
  589,  590,  591,  592,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,  606,  607,  608,
  609,  610,  611,  612,  257,  614,  259,   -1,   -1,   -1,
   -1,   -1,  265,   -1,   -1,  268,  269,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,
   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,
  383,  384,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,
   -1,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,
   -1,   -1,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,  454,  455,  456,  457,  458,   -1,  460,  461,  462,
  463,  464,  465,  466,  467,  468,  469,  470,  471,  472,
  473,  474,   -1,   -1,  477,  478,  479,  480,  481,  482,
  483,  484,  485,  486,  487,  488,  489,  490,  491,  492,
  493,  494,  495,  496,  497,  498,  499,  500,  501,  502,
  503,  504,  505,  506,  507,  508,  509,  510,  511,  512,
  513,  514,  515,  516,  517,  518,  519,  520,  521,  522,
  523,  524,  525,  526,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,  548,  549,  550,  551,  552,
  553,  554,  555,  556,  557,  558,  559,  560,  561,  562,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,  581,  582,
  583,  584,  585,  586,  587,  588,  589,  590,  591,  592,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,  606,  607,  608,  609,  610,  611,  612,
  257,  614,  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,
   -1,  268,  269,  270,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
  297,  298,   -1,  300,  301,   -1,   -1,  304,  305,   -1,
   -1,  308,  309,   -1,  311,   -1,   -1,  314,   -1,   -1,
   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,
  327,  328,  329,   -1,  331,   -1,  333,   -1,   -1,   -1,
  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,  349,   -1,  351,   -1,  353,   -1,  355,   -1,
   -1,  358,   -1,   -1,  361,   -1,  363,  364,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,
   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,
   -1,  388,  389,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,   -1,   -1,   -1,  403,   -1,   -1,  406,
  407,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,   -1,   -1,
  427,   -1,  429,   -1,   -1,  432,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,  441,   -1,  443,  444,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,  461,   -1,   -1,   -1,   -1,   -1,
   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,   -1,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,  505,  506,
  507,   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,
  517,   -1,  519,  520,  521,   -1,  523,  524,   -1,  526,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,   -1,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,   -1,
  607,  608,  609,  610,  611,  612,  257,  614,  259,   -1,
   -1,   -1,   -1,   -1,  265,   -1,   -1,  268,  269,  270,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,  297,  298,   -1,  300,
  301,   -1,   -1,  304,  305,   -1,   -1,  308,  309,   -1,
  311,   -1,   -1,  314,   -1,   -1,   -1,   -1,   -1,   -1,
  321,  322,   -1,   -1,   -1,   -1,  327,  328,  329,   -1,
  331,   -1,  333,   -1,   -1,   -1,  337,   -1,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,  349,   -1,
  351,   -1,  353,   -1,  355,   -1,   -1,  358,   -1,   -1,
  361,   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,
  381,  382,  383,  384,   -1,  386,   -1,  388,  389,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,
   -1,   -1,  403,   -1,   -1,  406,  407,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,
   -1,  432,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
   -1,   -1,  443,  444,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
   -1,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,  505,  506,  507,   -1,  509,  510,
  511,   -1,  513,  514,  515,   -1,  517,   -1,  519,  520,
  521,   -1,  523,  524,   -1,  526,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
   -1,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,   -1,  607,  608,  609,  610,
  611,  612,  257,  614,  259,   -1,   -1,   -1,   -1,   -1,
  265,   -1,   -1,  268,  269,  270,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,  297,  298,   -1,  300,  301,   -1,   -1,  304,
  305,   -1,   -1,  308,  309,   -1,  311,   -1,   -1,  314,
   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,
   -1,   -1,  327,  328,  329,   -1,  331,   -1,  333,   -1,
   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,   -1,  349,   -1,  351,   -1,  353,   -1,
  355,   -1,   -1,  358,   -1,   -1,  361,   -1,  363,  364,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,
   -1,  386,   -1,  388,  389,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,   -1,   -1,   -1,  403,   -1,
   -1,  406,  407,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
   -1,   -1,  427,   -1,  429,   -1,   -1,  432,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,  443,  444,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,  461,   -1,   -1,   -1,
   -1,   -1,   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,   -1,   -1,  489,  490,   -1,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
  505,  506,  507,   -1,  509,  510,  511,   -1,  513,  514,
  515,   -1,  517,   -1,  519,  520,  521,   -1,  523,  524,
   -1,  526,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,   -1,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,   -1,  607,  608,  609,  610,  611,  612,  257,  614,
  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,   -1,  268,
  269,  270,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,  297,  298,
   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,
  309,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,  328,
  329,   -1,  331,   -1,  333,   -1,   -1,   -1,  337,   -1,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
  349,   -1,  351,   -1,  353,   -1,  355,   -1,   -1,  358,
   -1,   -1,  361,   -1,  363,  364,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,
   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,  388,
  389,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,   -1,   -1,   -1,  403,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,   -1,   -1,  427,   -1,
  429,   -1,   -1,  432,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,   -1,   -1,   -1,  444,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,  461,   -1,   -1,   -1,   -1,   -1,   -1,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,   -1,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,  505,  506,  507,   -1,
  509,  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,
  519,  520,  521,   -1,  523,  524,   -1,  526,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,   -1,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,   -1,  607,  608,
  609,  610,  611,  612,  257,  614,  259,   -1,   -1,   -1,
   -1,   -1,  265,   -1,   -1,  268,  269,   -1,   -1,  272,
   -1,   -1,  275,   -1,   -1,   -1,   -1,  280,  281,   -1,
  283,   -1,  285,   -1,   -1,  288,   -1,  290,  291,  292,
   -1,  294,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,
   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,  334,   -1,   -1,  337,   -1,  339,  340,  341,  342,
  343,  344,  345,  346,   -1,  348,   -1,   -1,  351,   -1,
   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,  365,   -1,  367,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,
  383,  384,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,  396,   -1,  398,  399,   -1,   -1,   -1,
   -1,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
  413,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,
   -1,   -1,  435,   -1,   -1,   -1,   -1,  440,   -1,   -1,
   -1,   -1,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  468,  469,  470,  471,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,  487,   -1,  489,  490,   -1,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,   -1,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,   -1,  607,  608,  609,  610,  611,  612,
  257,  614,  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,
   -1,  268,  269,   -1,   -1,  272,   -1,   -1,  275,   -1,
   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,  292,   -1,  294,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,
   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,  334,   -1,   -1,
  337,   -1,  339,  340,  341,  342,  343,  344,  345,  346,
   -1,  348,   -1,   -1,  351,   -1,   -1,   -1,  355,   -1,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,  365,   -1,
  367,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,
   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,  396,
   -1,  398,  399,   -1,   -1,   -1,   -1,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,  413,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,   -1,   -1,
  427,   -1,  429,   -1,   -1,   -1,   -1,   -1,  435,   -1,
   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  468,  469,  470,  471,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
  487,   -1,  489,  490,   -1,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,   -1,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,   -1,
  607,  608,  609,  610,  611,  612,  257,  614,  259,   -1,
   -1,   -1,   -1,   -1,  265,   -1,   -1,  268,  269,   -1,
   -1,  272,   -1,   -1,  275,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,  292,   -1,  294,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,
  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,  334,   -1,   -1,  337,   -1,  339,  340,
  341,  342,  343,  344,  345,  346,   -1,  348,   -1,   -1,
  351,   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,  365,   -1,  367,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,
  381,  382,  383,  384,   -1,  386,   -1,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,  396,   -1,  398,  399,   -1,
   -1,   -1,   -1,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,  413,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,
   -1,   -1,   -1,   -1,  435,   -1,   -1,   -1,   -1,  440,
   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,  470,
  471,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,  487,   -1,  489,  490,
   -1,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,
  511,   -1,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
   -1,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,   -1,  607,  608,  609,  610,
  611,  612,  257,  614,  259,   -1,   -1,   -1,   -1,   -1,
  265,   -1,   -1,  268,  269,   -1,   -1,  272,   -1,   -1,
  275,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,  292,   -1,  294,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,
  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,
   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,  334,
   -1,   -1,  337,   -1,  339,  340,  341,  342,  343,  344,
  345,  346,   -1,  348,   -1,   -1,  351,   -1,   -1,   -1,
  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
  365,   -1,  367,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,  396,   -1,  398,  399,   -1,   -1,   -1,   -1,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,  413,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,   -1,   -1,
  435,   -1,   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  468,  469,  470,  471,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,  487,   -1,  489,  490,   -1,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,   -1,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,   -1,  607,  608,  609,  610,  611,  612,  257,  614,
  259,  260,   -1,   -1,   -1,   -1,  265,   -1,   -1,  268,
  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,  297,  298,
   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,
  309,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,
  329,   -1,  331,   -1,  333,   -1,   -1,   -1,  337,   -1,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,   -1,   -1,  355,   -1,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,
   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,  397,  398,
  399,   -1,   -1,   -1,   -1,   -1,   -1,  406,  407,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,   -1,   -1,  427,   -1,
  429,   -1,   -1,  432,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,   -1,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,
  509,  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,   -1,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,   -1,  607,  608,
  609,  610,  611,  612,  257,  614,  259,   -1,   -1,   -1,
   -1,   -1,  265,   -1,   -1,  268,  269,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,  297,  298,   -1,  300,  301,   -1,
   -1,   -1,  305,   -1,   -1,  308,  309,   -1,  311,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,
   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,
  333,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,
  383,  384,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,  397,  398,  399,   -1,   -1,   -1,
   -1,   -1,   -1,  406,  407,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,  432,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,
   -1,   -1,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   -1,  489,  490,   -1,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,   -1,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,   -1,  607,  608,  609,  610,  611,  612,
  257,  614,  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,
   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,
   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  321,  322,   -1,  324,   -1,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,
  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,   -1,   -1,  355,   -1,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,
   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,  393,  394,  395,   -1,
   -1,  398,  399,   -1,   -1,   -1,   -1,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,   -1,   -1,
  427,  428,  429,   -1,   -1,   -1,  433,   -1,   -1,   -1,
   -1,   -1,  439,  440,   -1,   -1,   -1,   -1,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,   -1,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,   -1,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,   -1,
  607,  608,  609,  610,  611,  612,  257,  614,  259,   -1,
   -1,   -1,   -1,   -1,  265,   -1,   -1,  268,  269,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,
  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,   -1,  337,  338,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,
  361,   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,
  381,  382,  383,  384,   -1,  386,   -1,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,
   -1,   -1,   -1,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
   -1,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,
  511,   -1,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
   -1,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,   -1,  607,  608,  609,  610,
  611,  612,  257,  614,  259,   -1,   -1,   -1,   -1,   -1,
  265,   -1,   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,
  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,
   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,   -1,   -1,
  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  376,  377,   -1,   -1,  380,  381,  382,  383,  384,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,   -1,   -1,   -1,   -1,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,   -1,   -1,  489,  490,   -1,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,   -1,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,   -1,  607,  608,  609,  610,  611,  612,  257,  614,
  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,   -1,  268,
  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,
   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,   -1,   -1,  355,   -1,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,
   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,   -1,   -1,   -1,   -1,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,   -1,   -1,  427,   -1,
  429,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,   -1,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,
  509,  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,  581,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,   -1,  607,  608,
  609,  610,  611,  612,  257,  614,  259,   -1,   -1,   -1,
   -1,   -1,  265,   -1,   -1,  268,  269,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,
   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,
  383,  384,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,
   -1,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,
  433,   -1,   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,
   -1,   -1,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   -1,  489,  490,   -1,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,   -1,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,   -1,  607,  608,  609,  610,  611,  612,
  257,  614,  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,
   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  280,  281,   -1,  283,  284,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,
   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,
  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,   -1,   -1,  355,   -1,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,
   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,   -1,   -1,   -1,   -1,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,   -1,   -1,
  427,   -1,  429,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,   -1,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,   -1,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,   -1,
  607,  608,  609,  610,  611,  612,  257,  614,  259,   -1,
   -1,   -1,   -1,   -1,  265,   -1,   -1,  268,  269,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,  284,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,
  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,
  381,  382,  383,  384,   -1,  386,   -1,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,
   -1,   -1,   -1,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
   -1,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,
  511,   -1,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
   -1,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,   -1,  607,  608,  609,  610,
  611,  612,  257,  614,  259,   -1,   -1,   -1,   -1,   -1,
  265,   -1,   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,
  305,   -1,   -1,  308,   -1,   -1,  311,  312,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,
   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,   -1,   -1,
  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,   -1,   -1,   -1,   -1,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,   -1,   -1,  489,  490,   -1,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,   -1,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,   -1,  607,  608,  609,  610,  611,  612,  257,  614,
  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,   -1,  268,
  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,
   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,   -1,   -1,  355,   -1,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,
   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,   -1,   -1,   -1,   -1,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,   -1,   -1,  427,   -1,
  429,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
  459,  460,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,   -1,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,
  509,  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,   -1,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,   -1,  607,  608,
  609,  610,  611,  612,  257,  614,  259,   -1,   -1,   -1,
   -1,   -1,  265,   -1,   -1,  268,  269,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,
   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,
  383,  384,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,
   -1,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,
   -1,   -1,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,  459,  460,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   -1,  489,  490,   -1,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,   -1,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,   -1,  607,  608,  609,  610,  611,  612,
  257,  614,  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,
   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,
   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,
  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,   -1,   -1,  355,   -1,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,
   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,   -1,   -1,   -1,   -1,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,   -1,   -1,
  427,   -1,  429,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,   -1,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,   -1,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,  601,  602,  603,  604,  605,   -1,
  607,  608,  609,  610,  611,  612,  257,  614,  259,   -1,
   -1,   -1,   -1,   -1,  265,   -1,   -1,  268,  269,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,
  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,
  381,  382,  383,  384,   -1,  386,   -1,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,
   -1,   -1,   -1,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
   -1,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,
  511,   -1,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
   -1,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,   -1,  607,  608,  609,  610,
  611,  612,  257,  614,  259,   -1,   -1,   -1,   -1,   -1,
  265,   -1,   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,  283,   -1,
  285,   -1,   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,
   -1,   -1,   -1,  298,   -1,  300,  301,   -1,   -1,   -1,
  305,   -1,   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,
   -1,   -1,  327,   -1,  329,   -1,  331,   -1,   -1,   -1,
   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,  343,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,   -1,   -1,
  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,  363,  364,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  376,   -1,   -1,   -1,  380,  381,  382,  383,  384,
   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,   -1,  394,
  395,   -1,   -1,  398,  399,   -1,   -1,   -1,   -1,   -1,
   -1,  406,   -1,   -1,  409,  410,  411,  412,   -1,  414,
   -1,  416,   -1,  418,  419,  420,  421,  422,   -1,   -1,
   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,
  445,  446,   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,
  455,  456,  457,  458,   -1,  460,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  479,  480,   -1,  482,  483,  484,
   -1,   -1,   -1,   -1,  489,  490,   -1,  492,  493,   -1,
  495,   -1,   -1,  498,  499,  500,  501,  502,  503,  504,
   -1,   -1,   -1,   -1,  509,  510,  511,   -1,  513,  514,
  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  527,  528,  529,  530,  531,  532,  533,  534,
  535,  536,  537,  538,  539,  540,  541,  542,  543,  544,
  545,  546,  547,   -1,  549,  550,  551,  552,  553,  554,
   -1,  556,  557,  558,  559,   -1,  561,   -1,  563,  564,
  565,  566,  567,  568,  569,  570,  571,  572,  573,  574,
  575,  576,  577,  578,  579,  580,   -1,  582,  583,  584,
  585,   -1,  587,  588,  589,  590,  591,   -1,  593,  594,
  595,  596,  597,  598,  599,  600,  601,  602,  603,  604,
  605,   -1,  607,  608,  609,  610,  611,  612,  257,  614,
  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,   -1,  268,
  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  280,  281,   -1,  283,   -1,  285,   -1,   -1,  288,
   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,
   -1,  300,  301,   -1,   -1,   -1,  305,   -1,   -1,  308,
   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,  327,   -1,
  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,
  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  351,   -1,   -1,   -1,  355,   -1,   -1,  358,
   -1,   -1,   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,
   -1,  380,  381,  382,  383,  384,   -1,  386,   -1,   -1,
   -1,   -1,   -1,  392,   -1,  394,  395,   -1,   -1,  398,
  399,   -1,   -1,   -1,   -1,   -1,   -1,  406,   -1,   -1,
  409,  410,  411,  412,   -1,  414,   -1,  416,   -1,  418,
  419,  420,  421,  422,   -1,   -1,   -1,   -1,  427,   -1,
  429,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  440,   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,
   -1,  450,   -1,   -1,  453,   -1,  455,  456,  457,  458,
   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,
  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  479,  480,   -1,  482,  483,  484,   -1,   -1,   -1,   -1,
  489,  490,   -1,  492,  493,   -1,  495,   -1,   -1,  498,
  499,  500,  501,  502,  503,  504,   -1,   -1,   -1,   -1,
  509,  510,  511,   -1,  513,  514,  515,   -1,  517,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  527,  528,
  529,  530,  531,  532,  533,  534,  535,  536,  537,  538,
  539,  540,  541,  542,  543,  544,  545,  546,  547,   -1,
  549,  550,  551,  552,  553,  554,   -1,  556,  557,  558,
  559,   -1,  561,   -1,  563,  564,  565,  566,  567,  568,
  569,  570,  571,  572,  573,  574,  575,  576,  577,  578,
  579,  580,   -1,  582,  583,  584,  585,   -1,  587,  588,
  589,  590,  591,   -1,  593,  594,  595,  596,  597,  598,
  599,  600,  601,  602,  603,  604,  605,   -1,  607,  608,
  609,  610,  611,  612,  257,  614,  259,   -1,   -1,   -1,
   -1,   -1,  265,   -1,   -1,  268,  269,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,  281,   -1,
  283,   -1,  285,   -1,   -1,  288,   -1,   -1,  291,   -1,
   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,  301,   -1,
   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,  311,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  321,  322,
   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,  331,   -1,
   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,   -1,   -1,
  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  351,   -1,
   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,   -1,   -1,
  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,  381,  382,
  383,  384,   -1,  386,   -1,   -1,   -1,   -1,   -1,  392,
   -1,  394,  395,   -1,   -1,  398,  399,   -1,   -1,   -1,
   -1,   -1,   -1,  406,   -1,   -1,  409,  410,  411,  412,
   -1,  414,   -1,  416,   -1,  418,  419,  420,  421,  422,
   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,   -1,   -1,
   -1,   -1,  445,  446,   -1,   -1,   -1,  450,   -1,   -1,
  453,   -1,  455,  456,  457,  458,   -1,  460,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,   -1,  482,
  483,  484,   -1,   -1,   -1,   -1,  489,  490,   -1,  492,
  493,   -1,  495,   -1,   -1,  498,  499,  500,  501,  502,
  503,  504,   -1,   -1,   -1,   -1,  509,  510,  511,   -1,
  513,  514,  515,   -1,  517,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  527,  528,  529,  530,  531,  532,
  533,  534,  535,  536,  537,  538,  539,  540,  541,  542,
  543,  544,  545,  546,  547,   -1,  549,  550,  551,  552,
  553,  554,   -1,  556,  557,  558,  559,   -1,  561,   -1,
  563,  564,  565,  566,  567,  568,  569,  570,  571,  572,
  573,  574,  575,  576,  577,  578,  579,  580,   -1,  582,
  583,  584,  585,   -1,  587,  588,  589,  590,  591,   -1,
  593,  594,  595,  596,  597,  598,  599,  600,  601,  602,
  603,  604,  605,   -1,  607,  608,  609,  610,  611,  612,
  257,  614,  259,   -1,   -1,   -1,   -1,   -1,  265,   -1,
   -1,  268,  269,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  280,  281,   -1,  283,   -1,  285,   -1,
   -1,  288,   -1,   -1,  291,   -1,   -1,   -1,   -1,   -1,
   -1,  298,   -1,  300,  301,   -1,   -1,   -1,  305,   -1,
   -1,  308,   -1,   -1,  311,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  321,  322,   -1,   -1,   -1,   -1,
  327,   -1,  329,   -1,  331,   -1,   -1,   -1,   -1,   -1,
  337,   -1,  339,   -1,   -1,   -1,  343,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  351,   -1,   -1,   -1,  355,   -1,
   -1,  358,   -1,   -1,   -1,   -1,  363,  364,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  376,
   -1,   -1,   -1,  380,  381,  382,  383,  384,   -1,  386,
   -1,   -1,   -1,   -1,   -1,  392,   -1,  394,  395,   -1,
   -1,  398,  399,   -1,   -1,   -1,   -1,   -1,   -1,  406,
   -1,   -1,  409,  410,  411,  412,   -1,  414,   -1,  416,
   -1,  418,  419,  420,  421,  422,   -1,   -1,   -1,   -1,
  427,   -1,  429,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  440,   -1,   -1,   -1,   -1,  445,  446,
   -1,   -1,   -1,  450,   -1,   -1,  453,   -1,  455,  456,
  457,  458,   -1,  460,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  468,  469,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  479,  480,   -1,  482,  483,  484,   -1,   -1,
   -1,   -1,  489,  490,   -1,  492,  493,   -1,  495,   -1,
   -1,  498,  499,  500,  501,  502,  503,  504,   -1,   -1,
   -1,   -1,  509,  510,  511,   -1,  513,  514,  515,   -1,
  517,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  527,  528,  529,  530,  531,  532,  533,  534,  535,  536,
  537,  538,  539,  540,  541,  542,  543,  544,  545,  546,
  547,   -1,  549,  550,  551,  552,  553,  554,   -1,  556,
  557,  558,  559,   -1,  561,   -1,  563,  564,  565,  566,
  567,  568,  569,  570,  571,  572,  573,  574,  575,  576,
  577,  578,  579,  580,   -1,  582,  583,  584,  585,   -1,
  587,  588,  589,  590,  591,   -1,  593,  594,  595,  596,
  597,  598,  599,  600,   -1,  602,  603,  604,  605,   -1,
  607,  608,  609,  610,  611,  612,  257,  614,  259,   -1,
   -1,   -1,   -1,   -1,  265,   -1,   -1,  268,  269,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  280,
  281,   -1,  283,   -1,  285,   -1,   -1,  288,   -1,   -1,
  291,   -1,   -1,   -1,   -1,   -1,   -1,  298,   -1,  300,
  301,   -1,   -1,   -1,  305,   -1,   -1,  308,   -1,   -1,
  311,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  321,  322,   -1,   -1,   -1,   -1,  327,   -1,  329,   -1,
  331,   -1,   -1,   -1,   -1,   -1,  337,   -1,  339,   -1,
   -1,   -1,  343,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  351,   -1,   -1,   -1,  355,   -1,   -1,  358,   -1,   -1,
   -1,   -1,  363,  364,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  376,   -1,   -1,   -1,  380,
  381,  382,  383,  384,   -1,  386,   -1,   -1,   -1,   -1,
   -1,  392,   -1,  394,  395,   -1,   -1,  398,  399,   -1,
   -1,   -1,   -1,   -1,   -1,  406,   -1,   -1,  409,  410,
  411,  412,   -1,  414,   -1,  416,   -1,  418,  419,  420,
  421,  422,   -1,   -1,   -1,   -1,  427,   -1,  429,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  440,
   -1,   -1,   -1,   -1,  445,  446,   -1,   -1,   -1,  450,
   -1,   -1,  453,   -1,  455,  456,  457,  458,   -1,  460,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  468,  469,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  479,  480,
   -1,  482,  483,  484,   -1,   -1,   -1,   -1,  489,  490,
   -1,  492,  493,   -1,  495,   -1,   -1,  498,  499,  500,
  501,  502,  503,  504,   -1,   -1,   -1,   -1,  509,  510,
  511,   -1,  513,  514,  515,   -1,  517,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  528,  529,  530,
  531,  532,  533,  534,  535,  536,  537,  538,  539,  540,
  541,  542,  543,  544,  545,  546,  547,   -1,  549,  550,
  551,  552,  553,  554,   -1,  556,  557,  558,  559,   -1,
  561,   -1,  563,  564,  565,  566,  567,  568,  569,  570,
  571,  572,  573,  574,  575,  576,  577,  578,  579,  580,
   -1,  582,  583,  584,  585,   -1,  587,  588,  589,  590,
  591,   -1,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,   -1,  607,  608,  609,  610,
  611,  612,   -1,  614,
};
static int yyctable[] = {                                    304,
   56,   -1,  832,  864,   -1,  573,  816,   -1,  574,  816,
   -1,  574,  814,   -1, 1071, 1204,   -1, 1172,  750,   -1,
 1178,  765,   -1, 1045, 1327,   -1, 1046, 1328,   -1, 1047,
 1329,   -1, 1435, 1107,   -1,  832,  859,   -1,  279, 1315,
   -1,  212,  843,   -1,
};
#define YYFINAL 21
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 616
#if YYDEBUG
static const char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,0,0,0,0,0,
"':'","';'","'<'","'='","'>'","'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,"'['",0,"']'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"ACTIVE","ADD","AFTER","ALL","ALTER","AND","ANY",
"AS","ASC","AT","AVG","AUTO","BEFORE","BEGIN","BETWEEN","BLOB","BY","CAST",
"CHARACTER","CHECK","COLLATE","COMMA","COMMIT","COMMITTED","COMPUTED",
"CONCATENATE","CONDITIONAL","CONSTRAINT","CONTAINING","COUNT","CREATE",
"CSTRING","CURRENT","CURSOR","DATABASE","DATE","DB_KEY","DECIMAL","DECLARE",
"DEFAULT","KW_DELETE","DESC","DISTINCT","DO","DOMAIN","DROP","ELSE","END",
"ENTRY_POINT","EQL","ESCAPE","EXCEPTION","EXECUTE","EXISTS","EXIT","EXTERNAL",
"FILTER","FOR","FOREIGN","FROM","FULL","FUNCTION","GDSCODE","GEQ","GENERATOR",
"GEN_ID","GRANT","GROUP","GTR","HAVING","IF","KW_IN","INACTIVE","INNER",
"INPUT_TYPE","INDEX","INSERT","INTEGER","INTO","IS","ISOLATION","JOIN","KEY",
"KW_CHAR","KW_DEC","KW_DOUBLE","KW_FILE","KW_FLOAT","KW_INT","KW_LONG",
"KW_NULL","KW_NUMERIC","KW_UPPER","KW_VALUE","LENGTH","LPAREN","LEFT","LEQ",
"LEVEL","LIKE","LSS","MANUAL","MAXIMUM","MAX_SEGMENT","MERGE","MINIMUM",
"MODULE_NAME","NAMES","NATIONAL","NATURAL","NCHAR","NEQ","NO","NOT","NOT_GTR",
"NOT_LSS","OF","ON","ONLY","OPTION","OR","ORDER","OUTER","OUTPUT_TYPE",
"OVERFLOW","PAGE","PAGES","KW_PAGE_SIZE","PARAMETER","PASSWORD","PLAN",
"POSITION","POST_EVENT","PRECISION","PRIMARY","PRIVILEGES","PROCEDURE",
"PROTECTED","READ","REAL","REFERENCES","RESERVING","RETAIN","RETURNING_VALUES",
"RETURNS","REVOKE","RIGHT","RPAREN","ROLLBACK","SEGMENT","SELECT","SET",
"SHADOW","KW_SHARED","SINGULAR","KW_SIZE","SMALLINT","SNAPSHOT","SOME","SORT",
"SQLCODE","STABILITY","STARTING","STATISTICS","SUB_TYPE","SUSPEND","SUM",
"TABLE","THEN","TO","TRANSACTION","TRIGGER","UNCOMMITTED","UNION","UNIQUE",
"UPDATE","USER","VALUES","VARCHAR","VARIABLE","VARYING","VERSION","VIEW","WAIT",
"WHEN","WHERE","WHILE","WITH","WORK","WRITE","FLOAT_NUMBER","NUMBER","NUMERIC",
"SYMBOL","STRING","INTRODUCER","ACTION","ADMIN","CASCADE","FREE_IT","RESTRICT",
"ROLE","COLUMN","KW_TYPE","EXTRACT","YEAR","MONTH","DAY","HOUR","MINUTE",
"SECOND","WEEKDAY","YEARDAY","TIME","TIMESTAMP","CURRENT_DATE","CURRENT_TIME",
"CURRENT_TIMESTAMP","NUMBER64BIT","SCALEDINT","CURRENT_USER","CURRENT_ROLE",
"KW_BREAK","SUBSTRING","RECREATE","KW_DESCRIPTOR","FIRST","SKIP",
"CURRENT_CONNECTION","CURRENT_TRANSACTION","BIGINT","CASE","NULLIF","COALESCE",
"USING","NULLS","LAST","ROW_COUNT","LOCK","SAVEPOINT","RELEASE","STATEMENT",
"LEAVE","INSERTING","UPDATING","DELETING","BACKUP","KW_DIFFERENCE","OPEN",
"CLOSE","FETCH","ROWS","BLOCK","IIF","SCALAR_ARRAY","CROSS","NEXT","SEQUENCE",
"RESTART","BOTH","COLLATION","COMMENT","BIT_LENGTH","CHAR_LENGTH",
"CHARACTER_LENGTH","LEADING","KW_LOWER","OCTET_LENGTH","TRAILING","TRIM",
"RETURNING","KW_IGNORE","LIMBO","UNDO","REQUESTS","TIMEOUT","ABS","ACCENT",
"ACOS","ALWAYS","ASCII_CHAR","ASCII_VAL","ASIN","ATAN","ATAN2","BIN_AND",
"BIN_OR","BIN_SHL","BIN_SHR","BIN_XOR","CEIL","CONNECT","COS","COSH","COT",
"DATEADD","DATEDIFF","DECODE","DISCONNECT","EXP","FLOOR","GEN_UUID","GENERATED",
"GLOBAL","HASH","INSENSITIVE","LIST","LN","LOG","LOG10","LPAD","MATCHED",
"MATCHING","MAXVALUE","MILLISECOND","MINVALUE","MOD","OVERLAY","PAD","PI",
"PLACING","POWER","PRESERVE","RAND","RECURSIVE","REPLACE","REVERSE","ROUND",
"RPAD","SENSITIVE","SIGN","SIN","SINH","SPACE","SQRT","START","TAN","TANH",
"TEMPORARY","TRUNC","WEEK","AUTONOMOUS","CHAR_TO_UUID","FIRSTNAME","GRANTED",
"LASTNAME","MIDDLENAME","MAPPING","OS_NAME","SIMILAR","UUID_TO_CHAR","CALLER",
"COMMON","DATA","SOURCE","TWO_PHASE","BIND_PARAM","BIN_NOT","UMINUS","UPLUS",
};
static const char *yyrule[] = {
"$accept : top",
"top : statement",
"top : statement ';'",
"statement : alter",
"statement : blob_io",
"statement : comment",
"statement : commit",
"statement : create",
"statement : create_or_alter",
"statement : declare",
"statement : delete",
"statement : drop",
"statement : grant",
"statement : insert",
"statement : merge",
"statement : exec_procedure",
"statement : exec_block",
"statement : recreate",
"statement : revoke",
"statement : rollback",
"statement : savepoint",
"statement : select",
"statement : set",
"statement : update",
"statement : update_or_insert",
"grant : GRANT privileges ON table_noise simple_table_name TO non_role_grantee_list grant_option granted_by",
"grant : GRANT proc_privileges ON PROCEDURE simple_proc_name TO non_role_grantee_list grant_option granted_by",
"grant : GRANT role_name_list TO role_grantee_list role_admin_option granted_by",
"table_noise : TABLE",
"table_noise :",
"privileges : ALL",
"privileges : ALL PRIVILEGES",
"privileges : privilege_list",
"privilege_list : privilege",
"privilege_list : privilege_list ',' privilege",
"proc_privileges : EXECUTE",
"privilege : SELECT",
"privilege : INSERT",
"privilege : KW_DELETE",
"privilege : UPDATE column_parens_opt",
"privilege : REFERENCES column_parens_opt",
"grant_option : WITH GRANT OPTION",
"grant_option :",
"role_admin_option : WITH ADMIN OPTION",
"role_admin_option :",
"granted_by : granted_by_text grantor",
"granted_by :",
"granted_by_text : GRANTED BY",
"granted_by_text : AS",
"grantor : role_grantee",
"simple_proc_name : symbol_procedure_name",
"revoke : REVOKE rev_grant_option privileges ON table_noise simple_table_name FROM non_role_grantee_list granted_by",
"revoke : REVOKE rev_grant_option proc_privileges ON PROCEDURE simple_proc_name FROM non_role_grantee_list granted_by",
"revoke : REVOKE rev_admin_option role_name_list FROM role_grantee_list granted_by",
"revoke : REVOKE ALL ON ALL FROM non_role_grantee_list",
"rev_grant_option : GRANT OPTION FOR",
"rev_grant_option :",
"rev_admin_option : ADMIN OPTION FOR",
"rev_admin_option :",
"non_role_grantee_list : grantee_list",
"non_role_grantee_list : user_grantee_list",
"grantee_list : grantee",
"grantee_list : grantee_list ',' grantee",
"grantee_list : grantee_list ',' user_grantee",
"grantee_list : user_grantee_list ',' grantee",
"grantee : PROCEDURE symbol_procedure_name",
"grantee : TRIGGER symbol_trigger_name",
"grantee : VIEW symbol_view_name",
"grantee : ROLE symbol_role_name",
"user_grantee_list : user_grantee",
"user_grantee_list : user_grantee_list ',' user_grantee",
"user_grantee : symbol_user_name",
"user_grantee : USER symbol_user_name",
"user_grantee : GROUP symbol_user_name",
"role_name_list : role_name",
"role_name_list : role_name_list ',' role_name",
"role_name : symbol_role_name",
"role_grantee_list : role_grantee",
"role_grantee_list : role_grantee_list ',' role_grantee",
"role_grantee : symbol_user_name",
"role_grantee : USER symbol_user_name",
"declare : DECLARE declare_clause",
"declare_clause : FILTER filter_decl_clause",
"declare_clause : EXTERNAL FUNCTION udf_decl_clause",
"udf_decl_clause : symbol_UDF_name arg_desc_list1 RETURNS return_value1 ENTRY_POINT sql_string MODULE_NAME sql_string",
"udf_data_type : simple_type",
"udf_data_type : BLOB",
"udf_data_type : CSTRING '(' pos_short_integer ')' charset_clause",
"arg_desc_list1 :",
"arg_desc_list1 : arg_desc_list",
"arg_desc_list1 : '(' arg_desc_list ')'",
"arg_desc_list : arg_desc",
"arg_desc_list : arg_desc_list ',' arg_desc",
"arg_desc : init_data_type udf_data_type param_mechanism",
"param_mechanism :",
"param_mechanism : BY KW_DESCRIPTOR",
"param_mechanism : BY SCALAR_ARRAY",
"param_mechanism : KW_NULL",
"return_value1 : return_value",
"return_value1 : '(' return_value ')'",
"return_value : init_data_type udf_data_type return_mechanism",
"return_value : PARAMETER pos_short_integer",
"return_mechanism :",
"return_mechanism : BY KW_VALUE",
"return_mechanism : BY KW_DESCRIPTOR",
"return_mechanism : FREE_IT",
"return_mechanism : BY KW_DESCRIPTOR FREE_IT",
"filter_decl_clause : symbol_filter_name INPUT_TYPE blob_filter_subtype OUTPUT_TYPE blob_filter_subtype ENTRY_POINT sql_string MODULE_NAME sql_string",
"blob_filter_subtype : symbol_blob_subtype_name",
"blob_filter_subtype : signed_short_integer",
"create : CREATE create_clause",
"create_clause : EXCEPTION exception_clause",
"create_clause : unique_opt order_direction INDEX symbol_index_name ON simple_table_name index_definition",
"create_clause : PROCEDURE procedure_clause",
"create_clause : TABLE table_clause",
"create_clause : GLOBAL TEMPORARY TABLE gtt_table_clause",
"create_clause : TRIGGER trigger_clause",
"create_clause : VIEW view_clause",
"create_clause : GENERATOR generator_clause",
"create_clause : SEQUENCE generator_clause",
"create_clause : DATABASE db_clause",
"create_clause : DOMAIN domain_clause",
"create_clause : SHADOW shadow_clause",
"create_clause : ROLE role_clause",
"create_clause : COLLATION collation_clause",
"create_clause : USER create_user_clause",
"recreate : RECREATE recreate_clause",
"recreate_clause : PROCEDURE rprocedure_clause",
"recreate_clause : TABLE rtable_clause",
"recreate_clause : GLOBAL TEMPORARY TABLE gtt_recreate_clause",
"recreate_clause : VIEW rview_clause",
"recreate_clause : TRIGGER rtrigger_clause",
"recreate_clause : EXCEPTION rexception_clause",
"create_or_alter : CREATE OR ALTER replace_clause",
"replace_clause : PROCEDURE replace_procedure_clause",
"replace_clause : TRIGGER replace_trigger_clause",
"replace_clause : VIEW replace_view_clause",
"replace_clause : EXCEPTION replace_exception_clause",
"exception_clause : symbol_exception_name sql_string",
"rexception_clause : symbol_exception_name sql_string",
"replace_exception_clause : symbol_exception_name sql_string",
"alter_exception_clause : symbol_exception_name sql_string",
"unique_opt : UNIQUE",
"unique_opt :",
"index_definition : column_list",
"index_definition : column_parens",
"index_definition : computed_by '(' begin_trigger value end_trigger ')'",
"shadow_clause : pos_short_integer manual_auto conditional sql_string first_file_length sec_shadow_files",
"manual_auto : MANUAL",
"manual_auto : AUTO",
"manual_auto :",
"conditional :",
"conditional : CONDITIONAL",
"first_file_length :",
"first_file_length : LENGTH equals long_integer page_noise",
"sec_shadow_files :",
"sec_shadow_files : db_file_list",
"db_file_list : db_file",
"db_file_list : db_file_list db_file",
"domain_clause : column_def_name as_opt data_type domain_default_opt domain_constraint_clause collate_clause",
"as_opt : AS",
"as_opt :",
"domain_default : DEFAULT begin_trigger default_value end_default",
"domain_default_opt : domain_default",
"domain_default_opt :",
"domain_constraint_clause : domain_constraint_list",
"domain_constraint_clause :",
"domain_constraint_list : domain_constraint_def",
"domain_constraint_list : domain_constraint_list domain_constraint_def",
"domain_constraint_def : domain_constraint",
"domain_constraint : null_constraint",
"domain_constraint : check_constraint",
"null_constraint : NOT KW_NULL",
"check_constraint : CHECK begin_trigger '(' search_condition ')' end_trigger",
"generator_clause : symbol_generator_name",
"role_clause : symbol_role_name",
"collation_clause : symbol_collation_name FOR symbol_character_set_name collation_sequence_definition collation_attribute_list_opt collation_specific_attribute_opt",
"collation_sequence_definition : FROM symbol_collation_name",
"collation_sequence_definition : FROM EXTERNAL '(' sql_string ')'",
"collation_sequence_definition :",
"collation_attribute_list_opt :",
"collation_attribute_list_opt : collation_attribute_list",
"collation_attribute_list : collation_attribute",
"collation_attribute_list : collation_attribute_list collation_attribute",
"collation_attribute : collation_pad_attribute",
"collation_attribute : collation_case_attribute",
"collation_attribute : collation_accent_attribute",
"collation_pad_attribute : NO PAD",
"collation_pad_attribute : PAD SPACE",
"collation_case_attribute : CASE SENSITIVE",
"collation_case_attribute : CASE INSENSITIVE",
"collation_accent_attribute : ACCENT SENSITIVE",
"collation_accent_attribute : ACCENT INSENSITIVE",
"collation_specific_attribute_opt :",
"collation_specific_attribute_opt : sql_string",
"alter_charset_clause : symbol_character_set_name SET DEFAULT COLLATION symbol_collation_name",
"db_clause : db_name db_initial_desc1 db_rem_desc1",
"equals :",
"equals : '='",
"db_name : sql_string",
"db_initial_desc1 :",
"db_initial_desc1 : db_initial_desc",
"db_initial_desc : db_initial_option",
"db_initial_desc : db_initial_desc db_initial_option",
"db_initial_option : KW_PAGE_SIZE equals pos_short_integer",
"db_initial_option : LENGTH equals long_integer page_noise",
"db_initial_option : USER sql_string",
"db_initial_option : PASSWORD sql_string",
"db_initial_option : SET NAMES sql_string",
"db_rem_desc1 :",
"db_rem_desc1 : db_rem_desc",
"db_rem_desc : db_rem_option",
"db_rem_desc : db_rem_desc db_rem_option",
"db_rem_option : db_file",
"db_rem_option : DEFAULT CHARACTER SET symbol_character_set_name",
"db_rem_option : DEFAULT CHARACTER SET symbol_character_set_name COLLATION symbol_collation_name",
"db_rem_option : KW_DIFFERENCE KW_FILE sql_string",
"db_file : file1 sql_string file_desc1",
"file1 : KW_FILE",
"file_desc1 :",
"file_desc1 : file_desc",
"file_desc : file_clause",
"file_desc : file_desc file_clause",
"file_clause : STARTING file_clause_noise long_integer",
"file_clause : LENGTH equals long_integer page_noise",
"file_clause_noise :",
"file_clause_noise : AT",
"file_clause_noise : AT PAGE",
"page_noise :",
"page_noise : PAGE",
"page_noise : PAGES",
"table_clause : simple_table_name external_file '(' table_elements ')'",
"rtable_clause : simple_table_name external_file '(' table_elements ')'",
"gtt_table_clause : simple_table_name '(' table_elements ')' gtt_scope",
"gtt_recreate_clause : simple_table_name '(' table_elements ')' gtt_scope",
"gtt_scope : ON COMMIT PRESERVE ROWS",
"gtt_scope : ON COMMIT KW_DELETE ROWS",
"gtt_scope :",
"external_file : EXTERNAL KW_FILE sql_string",
"external_file : EXTERNAL sql_string",
"external_file :",
"table_elements : table_element",
"table_elements : table_elements ',' table_element",
"table_element : column_def",
"table_element : table_constraint_definition",
"column_def : column_def_name data_type_or_domain domain_default_opt column_constraint_clause collate_clause",
"column_def : column_def_name non_array_type def_computed",
"column_def : column_def_name def_computed",
"def_computed : computed_clause '(' begin_trigger value end_trigger ')'",
"computed_clause : computed_by",
"computed_clause : GENERATED ALWAYS AS",
"computed_by : COMPUTED BY",
"computed_by : COMPUTED",
"data_type_or_domain : data_type",
"data_type_or_domain : simple_column_name",
"collate_clause : COLLATE symbol_collation_name",
"collate_clause :",
"column_def_name : simple_column_name",
"simple_column_def_name : simple_column_name",
"data_type_descriptor : init_data_type data_type",
"data_type_descriptor : KW_TYPE OF column_def_name",
"data_type_descriptor : KW_TYPE OF COLUMN symbol_column_name '.' symbol_column_name",
"data_type_descriptor : column_def_name",
"init_data_type :",
"default_value : constant",
"default_value : current_user",
"default_value : current_role",
"default_value : internal_info",
"default_value : null_value",
"default_value : datetime_value_expression",
"column_constraint_clause :",
"column_constraint_clause : column_constraint_list",
"column_constraint_list : column_constraint_def",
"column_constraint_list : column_constraint_list column_constraint_def",
"column_constraint_def : constraint_name_opt column_constraint",
"column_constraint : null_constraint",
"column_constraint : check_constraint",
"column_constraint : REFERENCES simple_table_name column_parens_opt referential_trigger_action constraint_index_opt",
"column_constraint : UNIQUE constraint_index_opt",
"column_constraint : PRIMARY KEY constraint_index_opt",
"table_constraint_definition : constraint_name_opt table_constraint",
"constraint_name_opt : CONSTRAINT symbol_constraint_name",
"constraint_name_opt :",
"table_constraint : unique_constraint",
"table_constraint : primary_constraint",
"table_constraint : referential_constraint",
"table_constraint : check_constraint",
"unique_constraint : UNIQUE column_parens constraint_index_opt",
"primary_constraint : PRIMARY KEY column_parens constraint_index_opt",
"referential_constraint : FOREIGN KEY column_parens REFERENCES simple_table_name column_parens_opt referential_trigger_action constraint_index_opt",
"constraint_index_opt : USING order_direction INDEX symbol_index_name",
"constraint_index_opt :",
"referential_trigger_action : update_rule",
"referential_trigger_action : delete_rule",
"referential_trigger_action : delete_rule update_rule",
"referential_trigger_action : update_rule delete_rule",
"referential_trigger_action :",
"update_rule : ON UPDATE referential_action",
"delete_rule : ON KW_DELETE referential_action",
"referential_action : CASCADE",
"referential_action : SET DEFAULT",
"referential_action : SET KW_NULL",
"referential_action : NO ACTION",
"procedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string local_declaration_list full_proc_block end_trigger",
"rprocedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string local_declaration_list full_proc_block end_trigger",
"replace_procedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string local_declaration_list full_proc_block end_trigger",
"alter_procedure_clause : symbol_procedure_name input_parameters output_parameters AS begin_string local_declaration_list full_proc_block end_trigger",
"input_parameters : '(' input_proc_parameters ')'",
"input_parameters :",
"output_parameters : RETURNS '(' output_proc_parameters ')'",
"output_parameters :",
"input_proc_parameters : input_proc_parameter",
"input_proc_parameters : input_proc_parameters ',' input_proc_parameter",
"input_proc_parameter : simple_column_def_name domain_or_non_array_type collate_clause default_par_opt",
"output_proc_parameters : proc_parameter",
"output_proc_parameters : output_proc_parameters ',' proc_parameter",
"proc_parameter : simple_column_def_name domain_or_non_array_type collate_clause",
"default_par_opt : DEFAULT begin_trigger default_value end_default",
"default_par_opt : '=' begin_trigger default_value end_default",
"default_par_opt :",
"local_declaration_list : local_declarations",
"local_declaration_list :",
"local_declarations : local_declaration",
"local_declarations : local_declarations local_declaration",
"local_declaration : stmt_start_line stmt_start_column DECLARE var_decl_opt local_declaration_item ';'",
"local_declaration_item : var_declaration_item",
"local_declaration_item : cursor_declaration_item",
"var_declaration_item : column_def_name domain_or_non_array_type collate_clause default_par_opt",
"var_decl_opt : VARIABLE",
"var_decl_opt :",
"cursor_declaration_item : symbol_cursor_name CURSOR FOR '(' select ')'",
"proc_block : proc_statement",
"proc_block : full_proc_block",
"full_proc_block : stmt_start_line stmt_start_column BEGIN full_proc_block_body END",
"full_proc_block_body : proc_statements",
"full_proc_block_body : proc_statements excp_hndl_statements",
"full_proc_block_body :",
"proc_statements : proc_block",
"proc_statements : proc_statements proc_block",
"proc_statement : stmt_start_line stmt_start_column simple_proc_statement ';'",
"proc_statement : stmt_start_line stmt_start_column complex_proc_statement",
"stmt_start_line :",
"stmt_start_column :",
"simple_proc_statement : assignment",
"simple_proc_statement : insert",
"simple_proc_statement : merge",
"simple_proc_statement : update",
"simple_proc_statement : update_or_insert",
"simple_proc_statement : delete",
"simple_proc_statement : singleton_select",
"simple_proc_statement : exec_procedure",
"simple_proc_statement : exec_sql",
"simple_proc_statement : exec_into",
"simple_proc_statement : exec_function",
"simple_proc_statement : excp_statement",
"simple_proc_statement : raise_statement",
"simple_proc_statement : post_event",
"simple_proc_statement : cursor_statement",
"simple_proc_statement : breakleave",
"simple_proc_statement : SUSPEND",
"simple_proc_statement : EXIT",
"complex_proc_statement : in_autonomous_transaction",
"complex_proc_statement : if_then_else",
"complex_proc_statement : while",
"complex_proc_statement : for_select",
"complex_proc_statement : for_exec_into",
"in_autonomous_transaction : KW_IN AUTONOMOUS TRANSACTION DO proc_block",
"excp_statement : EXCEPTION symbol_exception_name",
"excp_statement : EXCEPTION symbol_exception_name value",
"raise_statement : EXCEPTION",
"for_select : label_opt FOR select INTO variable_list cursor_def DO proc_block",
"exec_sql : EXECUTE STATEMENT exec_stmt_inputs exec_stmt_options",
"exec_into : EXECUTE STATEMENT exec_stmt_inputs exec_stmt_options INTO variable_list",
"for_exec_into : label_opt FOR EXECUTE STATEMENT exec_stmt_inputs exec_stmt_options INTO variable_list DO proc_block",
"exec_stmt_inputs : value",
"exec_stmt_inputs : '(' value ')' '(' named_params_list ')'",
"exec_stmt_inputs : '(' value ')' '(' not_named_params_list ')'",
"named_params_list : named_param",
"named_params_list : named_params_list ',' named_param",
"named_param : symbol_variable_name BIND_PARAM value",
"not_named_params_list : not_named_param",
"not_named_params_list : not_named_params_list ',' not_named_param",
"not_named_param : value",
"exec_stmt_options : exec_stmt_options_list",
"exec_stmt_options :",
"exec_stmt_options_list : exec_stmt_options_list exec_stmt_option",
"exec_stmt_options_list : exec_stmt_option",
"exec_stmt_option : ext_datasrc",
"exec_stmt_option : ext_user",
"exec_stmt_option : ext_pwd",
"exec_stmt_option : ext_role",
"exec_stmt_option : ext_tran",
"exec_stmt_option : ext_privs",
"ext_datasrc : ON EXTERNAL DATA SOURCE value",
"ext_datasrc : ON EXTERNAL value",
"ext_user : AS USER value",
"ext_pwd : PASSWORD value",
"ext_role : ROLE value",
"ext_tran : WITH AUTONOMOUS TRANSACTION",
"ext_tran : WITH COMMON TRANSACTION",
"ext_privs : WITH CALLER PRIVILEGES",
"if_then_else : IF '(' search_condition ')' THEN proc_block ELSE proc_block",
"if_then_else : IF '(' search_condition ')' THEN proc_block",
"post_event : POST_EVENT value event_argument_opt",
"event_argument_opt :",
"singleton_select : select INTO variable_list",
"variable : ':' symbol_variable_name",
"variable_list : variable",
"variable_list : column_name",
"variable_list : variable_list ',' column_name",
"variable_list : variable_list ',' variable",
"while : label_opt WHILE '(' search_condition ')' DO proc_block",
"label_opt : symbol_label_name ':'",
"label_opt :",
"breakleave : KW_BREAK",
"breakleave : LEAVE",
"breakleave : LEAVE symbol_label_name",
"cursor_def : AS CURSOR symbol_cursor_name",
"cursor_def :",
"excp_hndl_statements : excp_hndl_statement",
"excp_hndl_statements : excp_hndl_statements excp_hndl_statement",
"excp_hndl_statement : WHEN errors DO proc_block",
"errors : err",
"errors : errors ',' err",
"err : SQLCODE signed_short_integer",
"err : GDSCODE symbol_gdscode_name",
"err : EXCEPTION symbol_exception_name",
"err : ANY",
"cursor_statement : open_cursor",
"cursor_statement : fetch_cursor",
"cursor_statement : close_cursor",
"open_cursor : OPEN symbol_cursor_name",
"close_cursor : CLOSE symbol_cursor_name",
"fetch_cursor : FETCH fetch_opt symbol_cursor_name INTO variable_list",
"fetch_opt :",
"exec_procedure : EXECUTE PROCEDURE symbol_procedure_name proc_inputs proc_outputs_opt",
"proc_inputs : value_list",
"proc_inputs : '(' value_list ')'",
"proc_inputs :",
"proc_outputs_opt : RETURNING_VALUES variable_list",
"proc_outputs_opt : RETURNING_VALUES '(' variable_list ')'",
"proc_outputs_opt :",
"exec_block : EXECUTE BLOCK block_input_params output_parameters AS local_declaration_list full_proc_block",
"block_input_params : '(' block_parameters ')'",
"block_input_params :",
"block_parameters : block_parameter",
"block_parameters : block_parameters ',' block_parameter",
"block_parameter : proc_parameter '=' parameter",
"view_clause : symbol_view_name column_parens_opt AS begin_string select_expr check_opt end_trigger",
"rview_clause : symbol_view_name column_parens_opt AS begin_string select_expr check_opt end_trigger",
"replace_view_clause : symbol_view_name column_parens_opt AS begin_string select_expr check_opt end_trigger",
"alter_view_clause : symbol_view_name column_parens_opt AS begin_string select_expr check_opt end_trigger",
"begin_string :",
"begin_trigger :",
"end_trigger :",
"end_default :",
"check_opt : WITH CHECK OPTION",
"check_opt :",
"trigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"trigger_clause : symbol_trigger_name FOR simple_table_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"trigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position ON simple_table_name trigger_action end_trigger",
"rtrigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"rtrigger_clause : symbol_trigger_name FOR simple_table_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"rtrigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position ON simple_table_name trigger_action end_trigger",
"replace_trigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"replace_trigger_clause : symbol_trigger_name FOR simple_table_name trigger_active trigger_type trigger_position trigger_action end_trigger",
"replace_trigger_clause : symbol_trigger_name trigger_active trigger_type trigger_position ON simple_table_name trigger_action end_trigger",
"trigger_active : ACTIVE",
"trigger_active : INACTIVE",
"trigger_active :",
"trigger_type : trigger_type_prefix trigger_type_suffix",
"trigger_type : ON trigger_db_type",
"trigger_db_type : CONNECT",
"trigger_db_type : DISCONNECT",
"trigger_db_type : TRANSACTION START",
"trigger_db_type : TRANSACTION COMMIT",
"trigger_db_type : TRANSACTION ROLLBACK",
"trigger_type_prefix : BEFORE",
"trigger_type_prefix : AFTER",
"trigger_type_suffix : INSERT",
"trigger_type_suffix : UPDATE",
"trigger_type_suffix : KW_DELETE",
"trigger_type_suffix : INSERT OR UPDATE",
"trigger_type_suffix : INSERT OR KW_DELETE",
"trigger_type_suffix : UPDATE OR INSERT",
"trigger_type_suffix : UPDATE OR KW_DELETE",
"trigger_type_suffix : KW_DELETE OR INSERT",
"trigger_type_suffix : KW_DELETE OR UPDATE",
"trigger_type_suffix : INSERT OR UPDATE OR KW_DELETE",
"trigger_type_suffix : INSERT OR KW_DELETE OR UPDATE",
"trigger_type_suffix : UPDATE OR INSERT OR KW_DELETE",
"trigger_type_suffix : UPDATE OR KW_DELETE OR INSERT",
"trigger_type_suffix : KW_DELETE OR INSERT OR UPDATE",
"trigger_type_suffix : KW_DELETE OR UPDATE OR INSERT",
"trigger_position : POSITION nonneg_short_integer",
"trigger_position :",
"trigger_action : AS begin_trigger local_declaration_list full_proc_block",
"alter : ALTER alter_clause",
"alter_clause : EXCEPTION alter_exception_clause",
"alter_clause : TABLE simple_table_name alter_ops",
"alter_clause : VIEW alter_view_clause",
"alter_clause : TRIGGER alter_trigger_clause",
"alter_clause : PROCEDURE alter_procedure_clause",
"alter_clause : DATABASE init_alter_db alter_db",
"alter_clause : DOMAIN alter_column_name alter_domain_ops",
"alter_clause : INDEX alter_index_clause",
"alter_clause : SEQUENCE alter_sequence_clause",
"alter_clause : EXTERNAL FUNCTION alter_udf_clause",
"alter_clause : ROLE alter_role_clause",
"alter_clause : USER alter_user_clause",
"alter_clause : CHARACTER SET alter_charset_clause",
"alter_domain_ops : alter_domain_op",
"alter_domain_ops : alter_domain_ops alter_domain_op",
"alter_domain_op : SET domain_default",
"alter_domain_op : ADD CONSTRAINT check_constraint",
"alter_domain_op : ADD check_constraint",
"alter_domain_op : DROP DEFAULT",
"alter_domain_op : DROP CONSTRAINT",
"alter_domain_op : TO simple_column_name",
"alter_domain_op : KW_TYPE init_data_type non_array_type",
"alter_ops : alter_op",
"alter_ops : alter_ops ',' alter_op",
"alter_op : DROP simple_column_name drop_behaviour",
"alter_op : DROP CONSTRAINT symbol_constraint_name",
"alter_op : ADD column_def",
"alter_op : ADD table_constraint_definition",
"alter_op : col_opt simple_column_name POSITION pos_short_integer",
"alter_op : col_opt alter_column_name TO simple_column_name",
"alter_op : col_opt alter_col_name KW_TYPE alter_data_type_or_domain",
"alter_op : col_opt alter_col_name KW_TYPE non_array_type def_computed",
"alter_op : col_opt alter_col_name def_computed",
"alter_op : col_opt alter_col_name SET domain_default",
"alter_op : col_opt alter_col_name DROP DEFAULT",
"alter_column_name : keyword_or_column",
"keyword_or_column : valid_symbol_name",
"keyword_or_column : ADMIN",
"keyword_or_column : COLUMN",
"keyword_or_column : EXTRACT",
"keyword_or_column : YEAR",
"keyword_or_column : MONTH",
"keyword_or_column : DAY",
"keyword_or_column : HOUR",
"keyword_or_column : MINUTE",
"keyword_or_column : SECOND",
"keyword_or_column : TIME",
"keyword_or_column : TIMESTAMP",
"keyword_or_column : CURRENT_DATE",
"keyword_or_column : CURRENT_TIME",
"keyword_or_column : CURRENT_TIMESTAMP",
"keyword_or_column : CURRENT_USER",
"keyword_or_column : CURRENT_ROLE",
"keyword_or_column : RECREATE",
"keyword_or_column : CURRENT_CONNECTION",
"keyword_or_column : CURRENT_TRANSACTION",
"keyword_or_column : BIGINT",
"keyword_or_column : CASE",
"keyword_or_column : RELEASE",
"keyword_or_column : ROW_COUNT",
"keyword_or_column : SAVEPOINT",
"keyword_or_column : OPEN",
"keyword_or_column : CLOSE",
"keyword_or_column : FETCH",
"keyword_or_column : ROWS",
"keyword_or_column : USING",
"keyword_or_column : CROSS",
"keyword_or_column : BIT_LENGTH",
"keyword_or_column : BOTH",
"keyword_or_column : CHAR_LENGTH",
"keyword_or_column : CHARACTER_LENGTH",
"keyword_or_column : COMMENT",
"keyword_or_column : LEADING",
"keyword_or_column : KW_LOWER",
"keyword_or_column : OCTET_LENGTH",
"keyword_or_column : TRAILING",
"keyword_or_column : TRIM",
"keyword_or_column : CONNECT",
"keyword_or_column : DISCONNECT",
"keyword_or_column : GLOBAL",
"keyword_or_column : INSENSITIVE",
"keyword_or_column : RECURSIVE",
"keyword_or_column : SENSITIVE",
"keyword_or_column : START",
"keyword_or_column : SIMILAR",
"col_opt : ALTER",
"col_opt : ALTER COLUMN",
"alter_data_type_or_domain : non_array_type",
"alter_data_type_or_domain : simple_column_name",
"alter_col_name : simple_column_name",
"drop_behaviour : RESTRICT",
"drop_behaviour : CASCADE",
"drop_behaviour :",
"alter_index_clause : symbol_index_name ACTIVE",
"alter_index_clause : symbol_index_name INACTIVE",
"alter_sequence_clause : symbol_generator_name RESTART WITH signed_long_integer",
"alter_sequence_clause : symbol_generator_name RESTART WITH NUMBER64BIT",
"alter_sequence_clause : symbol_generator_name RESTART WITH '-' NUMBER64BIT",
"alter_udf_clause : symbol_UDF_name entry_op module_op",
"alter_role_clause : symbol_role_name alter_role_enable AUTO ADMIN MAPPING",
"alter_role_enable : SET",
"alter_role_enable : DROP",
"entry_op : ENTRY_POINT sql_string",
"entry_op :",
"module_op : MODULE_NAME sql_string",
"module_op :",
"init_alter_db :",
"alter_db : db_alter_clause",
"alter_db : alter_db db_alter_clause",
"db_alter_clause : ADD db_file_list",
"db_alter_clause : ADD KW_DIFFERENCE KW_FILE sql_string",
"db_alter_clause : DROP KW_DIFFERENCE KW_FILE",
"db_alter_clause : BEGIN BACKUP",
"db_alter_clause : END BACKUP",
"alter_trigger_clause : symbol_trigger_name trigger_active new_trigger_type trigger_position begin_trigger new_trigger_action end_trigger",
"new_trigger_type : trigger_type",
"new_trigger_type :",
"new_trigger_action : trigger_action",
"new_trigger_action :",
"drop : DROP drop_clause",
"drop_clause : EXCEPTION symbol_exception_name",
"drop_clause : INDEX symbol_index_name",
"drop_clause : PROCEDURE symbol_procedure_name",
"drop_clause : TABLE symbol_table_name",
"drop_clause : TRIGGER symbol_trigger_name",
"drop_clause : VIEW symbol_view_name",
"drop_clause : FILTER symbol_filter_name",
"drop_clause : DOMAIN symbol_domain_name",
"drop_clause : EXTERNAL FUNCTION symbol_UDF_name",
"drop_clause : SHADOW pos_short_integer",
"drop_clause : ROLE symbol_role_name",
"drop_clause : GENERATOR symbol_generator_name",
"drop_clause : SEQUENCE symbol_generator_name",
"drop_clause : COLLATION symbol_collation_name",
"drop_clause : USER drop_user_clause",
"data_type : non_array_type",
"data_type : array_type",
"domain_or_non_array_type : domain_or_non_array_type_name",
"domain_or_non_array_type : domain_or_non_array_type_name NOT KW_NULL",
"domain_or_non_array_type_name : non_array_type",
"domain_or_non_array_type_name : domain_type",
"domain_type : KW_TYPE OF symbol_column_name",
"domain_type : KW_TYPE OF COLUMN symbol_column_name '.' symbol_column_name",
"domain_type : symbol_column_name",
"non_array_type : simple_type",
"non_array_type : blob_type",
"array_type : non_charset_simple_type '[' array_spec ']'",
"array_type : character_type '[' array_spec ']' charset_clause",
"array_spec : array_range",
"array_spec : array_spec ',' array_range",
"array_range : signed_long_integer",
"array_range : signed_long_integer ':' signed_long_integer",
"simple_type : non_charset_simple_type",
"simple_type : character_type charset_clause",
"non_charset_simple_type : national_character_type",
"non_charset_simple_type : numeric_type",
"non_charset_simple_type : float_type",
"non_charset_simple_type : BIGINT",
"non_charset_simple_type : integer_keyword",
"non_charset_simple_type : SMALLINT",
"non_charset_simple_type : DATE",
"non_charset_simple_type : TIME",
"non_charset_simple_type : TIMESTAMP",
"integer_keyword : INTEGER",
"integer_keyword : KW_INT",
"blob_type : BLOB blob_subtype blob_segsize charset_clause",
"blob_type : BLOB '(' unsigned_short_integer ')'",
"blob_type : BLOB '(' unsigned_short_integer ',' signed_short_integer ')'",
"blob_type : BLOB '(' ',' signed_short_integer ')'",
"blob_segsize : SEGMENT KW_SIZE unsigned_short_integer",
"blob_segsize :",
"blob_subtype : SUB_TYPE signed_short_integer",
"blob_subtype : SUB_TYPE symbol_blob_subtype_name",
"blob_subtype :",
"charset_clause : CHARACTER SET symbol_character_set_name",
"charset_clause :",
"national_character_type : national_character_keyword '(' pos_short_integer ')'",
"national_character_type : national_character_keyword",
"national_character_type : national_character_keyword VARYING '(' pos_short_integer ')'",
"character_type : character_keyword '(' pos_short_integer ')'",
"character_type : character_keyword",
"character_type : varying_keyword '(' pos_short_integer ')'",
"varying_keyword : VARCHAR",
"varying_keyword : CHARACTER VARYING",
"varying_keyword : KW_CHAR VARYING",
"character_keyword : CHARACTER",
"character_keyword : KW_CHAR",
"national_character_keyword : NCHAR",
"national_character_keyword : NATIONAL CHARACTER",
"national_character_keyword : NATIONAL KW_CHAR",
"numeric_type : KW_NUMERIC prec_scale",
"numeric_type : decimal_keyword prec_scale",
"prec_scale :",
"prec_scale : '(' signed_long_integer ')'",
"prec_scale : '(' signed_long_integer ',' signed_long_integer ')'",
"decimal_keyword : DECIMAL",
"decimal_keyword : KW_DEC",
"float_type : KW_FLOAT precision_opt",
"float_type : KW_LONG KW_FLOAT precision_opt",
"float_type : REAL",
"float_type : KW_DOUBLE PRECISION",
"precision_opt : '(' nonneg_short_integer ')'",
"precision_opt :",
"set : set_transaction",
"set : set_generator",
"set : set_statistics",
"set_generator : SET GENERATOR symbol_generator_name TO signed_long_integer",
"set_generator : SET GENERATOR symbol_generator_name TO NUMBER64BIT",
"set_generator : SET GENERATOR symbol_generator_name TO '-' NUMBER64BIT",
"savepoint : set_savepoint",
"savepoint : release_savepoint",
"savepoint : undo_savepoint",
"set_savepoint : SAVEPOINT symbol_savepoint_name",
"release_savepoint : RELEASE SAVEPOINT symbol_savepoint_name release_only_opt",
"release_only_opt : ONLY",
"release_only_opt :",
"undo_savepoint : ROLLBACK optional_work TO optional_savepoint symbol_savepoint_name",
"optional_savepoint : SAVEPOINT",
"optional_savepoint :",
"commit : COMMIT optional_work optional_retain",
"rollback : ROLLBACK optional_work optional_retain",
"optional_work : WORK",
"optional_work :",
"optional_retain : RETAIN opt_snapshot",
"optional_retain :",
"opt_snapshot : SNAPSHOT",
"opt_snapshot :",
"set_transaction : SET TRANSACTION tran_opt_list_m",
"tran_opt_list_m : tran_opt_list",
"tran_opt_list_m :",
"tran_opt_list : tran_opt",
"tran_opt_list : tran_opt_list tran_opt",
"tran_opt : access_mode",
"tran_opt : lock_wait",
"tran_opt : isolation_mode",
"tran_opt : tra_misc_options",
"tran_opt : tra_timeout",
"tran_opt : tbl_reserve_options",
"access_mode : READ ONLY",
"access_mode : READ WRITE",
"lock_wait : WAIT",
"lock_wait : NO WAIT",
"isolation_mode : ISOLATION LEVEL iso_mode",
"isolation_mode : iso_mode",
"iso_mode : snap_shot",
"iso_mode : READ UNCOMMITTED version_mode",
"iso_mode : READ COMMITTED version_mode",
"snap_shot : SNAPSHOT",
"snap_shot : SNAPSHOT TABLE",
"snap_shot : SNAPSHOT TABLE STABILITY",
"version_mode : VERSION",
"version_mode : NO VERSION",
"version_mode :",
"tra_misc_options : NO AUTO UNDO",
"tra_misc_options : KW_IGNORE LIMBO",
"tra_misc_options : RESTART REQUESTS",
"tra_timeout : LOCK TIMEOUT nonneg_short_integer",
"tbl_reserve_options : RESERVING restr_list",
"lock_type : KW_SHARED",
"lock_type : PROTECTED",
"lock_type :",
"lock_mode : READ",
"lock_mode : WRITE",
"restr_list : restr_option",
"restr_list : restr_list ',' restr_option",
"restr_option : table_list table_lock",
"table_lock : FOR lock_type lock_mode",
"table_lock :",
"table_list : simple_table_name",
"table_list : table_list ',' simple_table_name",
"set_statistics : SET STATISTICS INDEX symbol_index_name",
"comment : COMMENT ON ddl_type0 IS ddl_desc",
"comment : COMMENT ON ddl_type1 symbol_ddl_name IS ddl_desc",
"comment : COMMENT ON ddl_type2 symbol_ddl_name ddl_subname IS ddl_desc",
"ddl_type0 : DATABASE",
"ddl_type1 : DOMAIN",
"ddl_type1 : TABLE",
"ddl_type1 : VIEW",
"ddl_type1 : PROCEDURE",
"ddl_type1 : TRIGGER",
"ddl_type1 : EXTERNAL FUNCTION",
"ddl_type1 : FILTER",
"ddl_type1 : EXCEPTION",
"ddl_type1 : GENERATOR",
"ddl_type1 : SEQUENCE",
"ddl_type1 : INDEX",
"ddl_type1 : ROLE",
"ddl_type1 : CHARACTER SET",
"ddl_type1 : COLLATION",
"ddl_type2 : COLUMN",
"ddl_type2 : PARAMETER",
"ddl_subname : '.' symbol_ddl_name",
"ddl_desc : sql_string",
"ddl_desc : KW_NULL",
"select : select_expr for_update_clause lock_clause",
"for_update_clause : FOR UPDATE for_update_list",
"for_update_clause :",
"for_update_list : OF column_list",
"for_update_list :",
"lock_clause : WITH LOCK",
"lock_clause :",
"select_expr : with_clause select_expr_body order_clause rows_clause",
"with_clause : WITH RECURSIVE with_list",
"with_clause : WITH with_list",
"with_clause :",
"with_list : with_item",
"with_list : with_item ',' with_list",
"with_item : symbol_table_alias_name derived_column_list AS '(' select_expr ')'",
"column_select : with_clause select_expr_body order_clause rows_clause",
"column_singleton : with_clause select_expr_body order_clause rows_clause",
"select_expr_body : query_term",
"select_expr_body : select_expr_body UNION distinct_noise query_term",
"select_expr_body : select_expr_body UNION ALL query_term",
"query_term : query_spec",
"query_spec : SELECT limit_clause distinct_clause select_list from_clause where_clause group_clause having_clause plan_clause",
"limit_clause : first_clause skip_clause",
"limit_clause : first_clause",
"limit_clause : skip_clause",
"limit_clause :",
"first_clause : FIRST long_integer",
"first_clause : FIRST '(' value ')'",
"first_clause : FIRST parameter",
"skip_clause : SKIP long_integer",
"skip_clause : SKIP '(' value ')'",
"skip_clause : SKIP parameter",
"distinct_clause : DISTINCT",
"distinct_clause : all_noise",
"select_list : select_items",
"select_list : '*'",
"select_items : select_item",
"select_items : select_items ',' select_item",
"select_item : value",
"select_item : value as_noise symbol_item_alias_name",
"as_noise : AS",
"as_noise :",
"from_clause : FROM from_list",
"from_list : table_reference",
"from_list : from_list ',' table_reference",
"table_reference : joined_table",
"table_reference : table_primary",
"table_primary : table_proc",
"table_primary : derived_table",
"table_primary : '(' joined_table ')'",
"derived_table : '(' select_expr ')' as_noise correlation_name derived_column_list",
"correlation_name : symbol_table_alias_name",
"correlation_name :",
"derived_column_list : '(' alias_list ')'",
"derived_column_list :",
"alias_list : symbol_item_alias_name",
"alias_list : alias_list ',' symbol_item_alias_name",
"joined_table : cross_join",
"joined_table : natural_join",
"joined_table : qualified_join",
"cross_join : table_reference CROSS JOIN table_primary",
"natural_join : table_reference NATURAL join_type JOIN table_primary",
"qualified_join : table_reference join_type JOIN table_reference join_specification",
"join_specification : join_condition",
"join_specification : named_columns_join",
"join_condition : ON search_condition",
"named_columns_join : USING '(' column_list ')'",
"table_proc : symbol_procedure_name table_proc_inputs as_noise symbol_table_alias_name",
"table_proc : symbol_procedure_name table_proc_inputs",
"table_proc_inputs : '(' value_list ')'",
"table_proc_inputs :",
"table_name : simple_table_name",
"table_name : symbol_table_name as_noise symbol_table_alias_name",
"simple_table_name : symbol_table_name",
"join_type : INNER",
"join_type : LEFT outer_noise",
"join_type : RIGHT outer_noise",
"join_type : FULL outer_noise",
"join_type :",
"outer_noise : OUTER",
"outer_noise :",
"group_clause : GROUP BY group_by_list",
"group_clause :",
"group_by_list : group_by_item",
"group_by_list : group_by_list ',' group_by_item",
"group_by_item : value",
"having_clause : HAVING search_condition",
"having_clause :",
"where_clause : WHERE search_condition",
"where_clause :",
"plan_clause : PLAN plan_expression",
"plan_clause :",
"plan_expression : plan_type '(' plan_item_list ')'",
"plan_type : JOIN",
"plan_type : SORT MERGE",
"plan_type : MERGE",
"plan_type : SORT",
"plan_type :",
"plan_item_list : plan_item",
"plan_item_list : plan_item ',' plan_item_list",
"plan_item : table_or_alias_list access_type",
"plan_item : plan_expression",
"table_or_alias_list : symbol_table_name",
"table_or_alias_list : symbol_table_name table_or_alias_list",
"access_type : NATURAL",
"access_type : INDEX '(' index_list ')'",
"access_type : ORDER symbol_index_name extra_indices_opt",
"index_list : symbol_index_name",
"index_list : symbol_index_name ',' index_list",
"extra_indices_opt : INDEX '(' index_list ')'",
"extra_indices_opt :",
"order_clause : ORDER BY order_list",
"order_clause :",
"order_list : order_item",
"order_list : order_list ',' order_item",
"order_item : value order_direction nulls_clause",
"order_direction : ASC",
"order_direction : DESC",
"order_direction :",
"nulls_clause : NULLS nulls_placement",
"nulls_clause :",
"nulls_placement : FIRST",
"nulls_placement : LAST",
"rows_clause : ROWS value",
"rows_clause : ROWS value TO value",
"rows_clause :",
"insert : INSERT INTO simple_table_name ins_column_parens_opt VALUES '(' value_list ')' returning_clause",
"insert : INSERT INTO simple_table_name ins_column_parens_opt select_expr returning_clause",
"insert : INSERT INTO simple_table_name DEFAULT VALUES returning_clause",
"merge : MERGE INTO table_name USING table_reference ON search_condition merge_when_clause",
"merge_when_clause : merge_when_matched_clause merge_when_not_matched_clause",
"merge_when_clause : merge_when_not_matched_clause merge_when_matched_clause",
"merge_when_clause : merge_when_matched_clause",
"merge_when_clause : merge_when_not_matched_clause",
"merge_when_matched_clause : WHEN MATCHED THEN merge_update_specification",
"merge_when_not_matched_clause : WHEN NOT MATCHED THEN merge_insert_specification",
"merge_update_specification : UPDATE SET assignments",
"merge_insert_specification : INSERT ins_column_parens_opt VALUES '(' value_list ')'",
"delete : delete_searched",
"delete : delete_positioned",
"delete_searched : KW_DELETE FROM table_name where_clause plan_clause order_clause rows_clause returning_clause",
"delete_positioned : KW_DELETE FROM table_name cursor_clause",
"update : update_searched",
"update : update_positioned",
"update_searched : UPDATE table_name SET assignments where_clause plan_clause order_clause rows_clause returning_clause",
"update_positioned : UPDATE table_name SET assignments cursor_clause",
"update_or_insert : UPDATE OR INSERT INTO simple_table_name ins_column_parens_opt VALUES '(' value_list ')' update_or_insert_matching_opt returning_clause",
"update_or_insert_matching_opt : MATCHING ins_column_parens",
"update_or_insert_matching_opt :",
"returning_clause : RETURNING value_list",
"returning_clause : RETURNING value_list INTO variable_list",
"returning_clause :",
"cursor_clause : WHERE CURRENT OF symbol_cursor_name",
"assignments : assignment",
"assignments : assignments ',' assignment",
"assignment : update_column_name '=' value",
"exec_function : udf",
"exec_function : non_aggregate_function",
"blob_io : READ BLOB simple_column_name FROM simple_table_name filter_clause_io segment_clause_io",
"blob_io : INSERT BLOB simple_column_name INTO simple_table_name filter_clause_io segment_clause_io",
"filter_clause_io : FILTER FROM blob_subtype_value_io TO blob_subtype_value_io",
"filter_clause_io : FILTER TO blob_subtype_value_io",
"filter_clause_io :",
"blob_subtype_value_io : blob_subtype_io",
"blob_subtype_value_io : parameter",
"blob_subtype_io : signed_short_integer",
"segment_clause_io : MAX_SEGMENT segment_length_io",
"segment_clause_io :",
"segment_length_io : unsigned_short_integer",
"segment_length_io : parameter",
"column_parens_opt : column_parens",
"column_parens_opt :",
"column_parens : '(' column_list ')'",
"column_list : simple_column_name",
"column_list : column_list ',' simple_column_name",
"ins_column_parens_opt : ins_column_parens",
"ins_column_parens_opt :",
"ins_column_parens : '(' ins_column_list ')'",
"ins_column_list : update_column_name",
"ins_column_list : ins_column_list ',' update_column_name",
"column_name : simple_column_name",
"column_name : symbol_table_alias_name '.' symbol_column_name",
"column_name : symbol_table_alias_name '.' '*'",
"simple_column_name : symbol_column_name",
"update_column_name : simple_column_name",
"update_column_name : symbol_table_alias_name '.' symbol_column_name",
"search_condition : predicate",
"search_condition : search_condition OR search_condition",
"search_condition : search_condition AND search_condition",
"search_condition : NOT search_condition",
"predicate : comparison_predicate",
"predicate : distinct_predicate",
"predicate : between_predicate",
"predicate : like_predicate",
"predicate : in_predicate",
"predicate : null_predicate",
"predicate : quantified_predicate",
"predicate : exists_predicate",
"predicate : containing_predicate",
"predicate : similar_predicate",
"predicate : starting_predicate",
"predicate : singular_predicate",
"predicate : trigger_action_predicate",
"predicate : '(' search_condition ')'",
"comparison_predicate : value '=' value",
"comparison_predicate : value '<' value",
"comparison_predicate : value '>' value",
"comparison_predicate : value GEQ value",
"comparison_predicate : value LEQ value",
"comparison_predicate : value NOT_GTR value",
"comparison_predicate : value NOT_LSS value",
"comparison_predicate : value NEQ value",
"quantified_predicate : value '=' ALL '(' column_select ')'",
"quantified_predicate : value '<' ALL '(' column_select ')'",
"quantified_predicate : value '>' ALL '(' column_select ')'",
"quantified_predicate : value GEQ ALL '(' column_select ')'",
"quantified_predicate : value LEQ ALL '(' column_select ')'",
"quantified_predicate : value NOT_GTR ALL '(' column_select ')'",
"quantified_predicate : value NOT_LSS ALL '(' column_select ')'",
"quantified_predicate : value NEQ ALL '(' column_select ')'",
"quantified_predicate : value '=' some '(' column_select ')'",
"quantified_predicate : value '<' some '(' column_select ')'",
"quantified_predicate : value '>' some '(' column_select ')'",
"quantified_predicate : value GEQ some '(' column_select ')'",
"quantified_predicate : value LEQ some '(' column_select ')'",
"quantified_predicate : value NOT_GTR some '(' column_select ')'",
"quantified_predicate : value NOT_LSS some '(' column_select ')'",
"quantified_predicate : value NEQ some '(' column_select ')'",
"some : SOME",
"some : ANY",
"distinct_predicate : value IS DISTINCT FROM value",
"distinct_predicate : value IS NOT DISTINCT FROM value",
"between_predicate : value BETWEEN value AND value",
"between_predicate : value NOT BETWEEN value AND value",
"like_predicate : value LIKE value",
"like_predicate : value NOT LIKE value",
"like_predicate : value LIKE value ESCAPE value",
"like_predicate : value NOT LIKE value ESCAPE value",
"in_predicate : value KW_IN in_predicate_value",
"in_predicate : value NOT KW_IN in_predicate_value",
"containing_predicate : value CONTAINING value",
"containing_predicate : value NOT CONTAINING value",
"similar_predicate : value SIMILAR TO value",
"similar_predicate : value NOT SIMILAR TO value",
"similar_predicate : value SIMILAR TO value ESCAPE value",
"similar_predicate : value NOT SIMILAR TO value ESCAPE value",
"starting_predicate : value STARTING value",
"starting_predicate : value NOT STARTING value",
"starting_predicate : value STARTING WITH value",
"starting_predicate : value NOT STARTING WITH value",
"exists_predicate : EXISTS '(' select_expr ')'",
"singular_predicate : SINGULAR '(' select_expr ')'",
"null_predicate : value IS KW_NULL",
"null_predicate : value IS NOT KW_NULL",
"trigger_action_predicate : INSERTING",
"trigger_action_predicate : UPDATING",
"trigger_action_predicate : DELETING",
"in_predicate_value : table_subquery",
"in_predicate_value : '(' value_list ')'",
"table_subquery : '(' column_select ')'",
"create_user_clause : symbol_user_name passwd_clause firstname_opt middlename_opt lastname_opt grant_admin_opt",
"alter_user_clause : symbol_user_name passwd_opt firstname_opt middlename_opt lastname_opt admin_opt",
"alter_user_clause : symbol_user_name SET passwd_opt firstname_opt middlename_opt lastname_opt admin_opt",
"drop_user_clause : symbol_user_name",
"passwd_clause : PASSWORD sql_string",
"passwd_opt : passwd_clause",
"passwd_opt :",
"firstname_opt : FIRSTNAME sql_string",
"firstname_opt :",
"middlename_opt : MIDDLENAME sql_string",
"middlename_opt :",
"lastname_opt : LASTNAME sql_string",
"lastname_opt :",
"admin_opt : revoke_admin",
"admin_opt : grant_admin",
"admin_opt :",
"grant_admin_opt : grant_admin",
"grant_admin_opt :",
"revoke_admin : REVOKE ADMIN ROLE",
"grant_admin : GRANT ADMIN ROLE",
"value : column_name",
"value : array_element",
"value : function",
"value : u_constant",
"value : parameter",
"value : variable",
"value : cast_specification",
"value : case_expression",
"value : next_value_expression",
"value : udf",
"value : '-' value",
"value : '+' value",
"value : value '+' value",
"value : value CONCATENATE value",
"value : value COLLATE symbol_collation_name",
"value : value '-' value",
"value : value '*' value",
"value : value '/' value",
"value : '(' value ')'",
"value : '(' column_singleton ')'",
"value : current_user",
"value : current_role",
"value : internal_info",
"value : DB_KEY",
"value : symbol_table_alias_name '.' DB_KEY",
"value : KW_VALUE",
"value : datetime_value_expression",
"value : null_value",
"datetime_value_expression : CURRENT_DATE",
"datetime_value_expression : CURRENT_TIME sec_precision_opt",
"datetime_value_expression : CURRENT_TIMESTAMP sec_precision_opt",
"sec_precision_opt : '(' nonneg_short_integer ')'",
"sec_precision_opt :",
"array_element : column_name '[' value_list ']'",
"value_list_opt : value_list",
"value_list_opt :",
"value_list : value",
"value_list : value_list ',' value",
"constant : u_constant",
"constant : '-' u_numeric_constant",
"u_numeric_constant : NUMERIC",
"u_numeric_constant : NUMBER",
"u_numeric_constant : FLOAT_NUMBER",
"u_numeric_constant : NUMBER64BIT",
"u_numeric_constant : SCALEDINT",
"u_constant : u_numeric_constant",
"u_constant : sql_string",
"u_constant : DATE STRING",
"u_constant : TIME STRING",
"u_constant : TIMESTAMP STRING",
"parameter : '?'",
"current_user : USER",
"current_user : CURRENT_USER",
"current_role : CURRENT_ROLE",
"internal_info : CURRENT_CONNECTION",
"internal_info : CURRENT_TRANSACTION",
"internal_info : GDSCODE",
"internal_info : SQLCODE",
"internal_info : ROW_COUNT",
"sql_string : STRING",
"sql_string : INTRODUCER STRING",
"signed_short_integer : nonneg_short_integer",
"signed_short_integer : '-' neg_short_integer",
"nonneg_short_integer : NUMBER",
"neg_short_integer : NUMBER",
"pos_short_integer : nonneg_short_integer",
"unsigned_short_integer : NUMBER",
"signed_long_integer : long_integer",
"signed_long_integer : '-' long_integer",
"long_integer : NUMBER",
"function : aggregate_function",
"function : non_aggregate_function",
"non_aggregate_function : numeric_value_function",
"non_aggregate_function : string_value_function",
"non_aggregate_function : system_function_expression",
"aggregate_function : COUNT '(' '*' ')'",
"aggregate_function : COUNT '(' all_noise value ')'",
"aggregate_function : COUNT '(' DISTINCT value ')'",
"aggregate_function : SUM '(' all_noise value ')'",
"aggregate_function : SUM '(' DISTINCT value ')'",
"aggregate_function : AVG '(' all_noise value ')'",
"aggregate_function : AVG '(' DISTINCT value ')'",
"aggregate_function : MINIMUM '(' all_noise value ')'",
"aggregate_function : MINIMUM '(' DISTINCT value ')'",
"aggregate_function : MAXIMUM '(' all_noise value ')'",
"aggregate_function : MAXIMUM '(' DISTINCT value ')'",
"aggregate_function : LIST '(' all_noise value delimiter_opt ')'",
"aggregate_function : LIST '(' DISTINCT value delimiter_opt ')'",
"delimiter_opt : ',' value",
"delimiter_opt :",
"numeric_value_function : extract_expression",
"numeric_value_function : length_expression",
"extract_expression : EXTRACT '(' timestamp_part FROM value ')'",
"length_expression : bit_length_expression",
"length_expression : char_length_expression",
"length_expression : octet_length_expression",
"bit_length_expression : BIT_LENGTH '(' value ')'",
"char_length_expression : CHAR_LENGTH '(' value ')'",
"char_length_expression : CHARACTER_LENGTH '(' value ')'",
"octet_length_expression : OCTET_LENGTH '(' value ')'",
"system_function_expression : system_function_std_syntax '(' value_list_opt ')'",
"system_function_expression : system_function_special_syntax",
"system_function_std_syntax : ABS",
"system_function_std_syntax : ACOS",
"system_function_std_syntax : ASCII_CHAR",
"system_function_std_syntax : ASCII_VAL",
"system_function_std_syntax : ASIN",
"system_function_std_syntax : ATAN",
"system_function_std_syntax : ATAN2",
"system_function_std_syntax : BIN_AND",
"system_function_std_syntax : BIN_NOT",
"system_function_std_syntax : BIN_OR",
"system_function_std_syntax : BIN_SHL",
"system_function_std_syntax : BIN_SHR",
"system_function_std_syntax : BIN_XOR",
"system_function_std_syntax : CEIL",
"system_function_std_syntax : CHAR_TO_UUID",
"system_function_std_syntax : COS",
"system_function_std_syntax : COSH",
"system_function_std_syntax : COT",
"system_function_std_syntax : EXP",
"system_function_std_syntax : FLOOR",
"system_function_std_syntax : GEN_UUID",
"system_function_std_syntax : HASH",
"system_function_std_syntax : LEFT",
"system_function_std_syntax : LN",
"system_function_std_syntax : LOG",
"system_function_std_syntax : LOG10",
"system_function_std_syntax : LPAD",
"system_function_std_syntax : MAXVALUE",
"system_function_std_syntax : MINVALUE",
"system_function_std_syntax : MOD",
"system_function_std_syntax : PI",
"system_function_std_syntax : POSITION",
"system_function_std_syntax : POWER",
"system_function_std_syntax : RAND",
"system_function_std_syntax : REPLACE",
"system_function_std_syntax : REVERSE",
"system_function_std_syntax : RIGHT",
"system_function_std_syntax : ROUND",
"system_function_std_syntax : RPAD",
"system_function_std_syntax : SIGN",
"system_function_std_syntax : SIN",
"system_function_std_syntax : SINH",
"system_function_std_syntax : SQRT",
"system_function_std_syntax : TAN",
"system_function_std_syntax : TANH",
"system_function_std_syntax : TRUNC",
"system_function_std_syntax : UUID_TO_CHAR",
"system_function_special_syntax : DATEADD '(' value timestamp_part TO value ')'",
"system_function_special_syntax : DATEADD '(' timestamp_part ',' value ',' value ')'",
"system_function_special_syntax : DATEDIFF '(' timestamp_part FROM value TO value ')'",
"system_function_special_syntax : DATEDIFF '(' timestamp_part ',' value ',' value ')'",
"system_function_special_syntax : OVERLAY '(' value PLACING value FROM value FOR value ')'",
"system_function_special_syntax : OVERLAY '(' value PLACING value FROM value ')'",
"system_function_special_syntax : POSITION '(' value KW_IN value ')'",
"string_value_function : substring_function",
"string_value_function : trim_function",
"string_value_function : KW_UPPER '(' value ')'",
"string_value_function : KW_LOWER '(' value ')'",
"substring_function : SUBSTRING '(' value FROM value string_length_opt ')'",
"string_length_opt : FOR value",
"string_length_opt :",
"trim_function : TRIM '(' trim_specification value FROM value ')'",
"trim_function : TRIM '(' value FROM value ')'",
"trim_function : TRIM '(' trim_specification FROM value ')'",
"trim_function : TRIM '(' value ')'",
"trim_specification : BOTH",
"trim_specification : TRAILING",
"trim_specification : LEADING",
"udf : symbol_UDF_call_name '(' value_list ')'",
"udf : symbol_UDF_call_name '(' ')'",
"cast_specification : CAST '(' value AS data_type_descriptor ')'",
"case_expression : case_abbreviation",
"case_expression : case_specification",
"case_abbreviation : NULLIF '(' value ',' value ')'",
"case_abbreviation : IIF '(' search_condition ',' value ',' value ')'",
"case_abbreviation : COALESCE '(' value ',' value_list ')'",
"case_abbreviation : DECODE '(' value ',' decode_pairs ')'",
"case_abbreviation : DECODE '(' value ',' decode_pairs ',' value ')'",
"case_specification : simple_case",
"case_specification : searched_case",
"simple_case : CASE case_operand simple_when_clause END",
"simple_case : CASE case_operand simple_when_clause ELSE case_result END",
"simple_when_clause : WHEN when_operand THEN case_result",
"simple_when_clause : simple_when_clause WHEN when_operand THEN case_result",
"searched_case : CASE searched_when_clause END",
"searched_case : CASE searched_when_clause ELSE case_result END",
"searched_when_clause : WHEN search_condition THEN case_result",
"searched_when_clause : searched_when_clause WHEN search_condition THEN case_result",
"when_operand : value",
"case_operand : value",
"case_result : value",
"decode_pairs : value ',' value",
"decode_pairs : decode_pairs ',' value ',' value",
"next_value_expression : NEXT KW_VALUE FOR symbol_generator_name",
"next_value_expression : GEN_ID '(' symbol_generator_name ',' value ')'",
"timestamp_part : YEAR",
"timestamp_part : MONTH",
"timestamp_part : DAY",
"timestamp_part : HOUR",
"timestamp_part : MINUTE",
"timestamp_part : SECOND",
"timestamp_part : MILLISECOND",
"timestamp_part : WEEK",
"timestamp_part : WEEKDAY",
"timestamp_part : YEARDAY",
"all_noise : ALL",
"all_noise :",
"distinct_noise : DISTINCT",
"distinct_noise :",
"null_value : KW_NULL",
"symbol_UDF_call_name : SYMBOL",
"symbol_UDF_name : valid_symbol_name",
"symbol_blob_subtype_name : valid_symbol_name",
"symbol_character_set_name : valid_symbol_name",
"symbol_collation_name : valid_symbol_name",
"symbol_column_name : valid_symbol_name",
"symbol_constraint_name : valid_symbol_name",
"symbol_cursor_name : valid_symbol_name",
"symbol_domain_name : valid_symbol_name",
"symbol_exception_name : valid_symbol_name",
"symbol_filter_name : valid_symbol_name",
"symbol_gdscode_name : valid_symbol_name",
"symbol_generator_name : valid_symbol_name",
"symbol_index_name : valid_symbol_name",
"symbol_item_alias_name : valid_symbol_name",
"symbol_label_name : valid_symbol_name",
"symbol_ddl_name : valid_symbol_name",
"symbol_procedure_name : valid_symbol_name",
"symbol_role_name : valid_symbol_name",
"symbol_table_alias_name : valid_symbol_name",
"symbol_table_name : valid_symbol_name",
"symbol_trigger_name : valid_symbol_name",
"symbol_user_name : valid_symbol_name",
"symbol_variable_name : valid_symbol_name",
"symbol_view_name : valid_symbol_name",
"symbol_savepoint_name : valid_symbol_name",
"valid_symbol_name : SYMBOL",
"valid_symbol_name : non_reserved_word",
"non_reserved_word : ACTION",
"non_reserved_word : CASCADE",
"non_reserved_word : FREE_IT",
"non_reserved_word : RESTRICT",
"non_reserved_word : ROLE",
"non_reserved_word : KW_TYPE",
"non_reserved_word : KW_BREAK",
"non_reserved_word : KW_DESCRIPTOR",
"non_reserved_word : SUBSTRING",
"non_reserved_word : COALESCE",
"non_reserved_word : LAST",
"non_reserved_word : LEAVE",
"non_reserved_word : LOCK",
"non_reserved_word : NULLIF",
"non_reserved_word : NULLS",
"non_reserved_word : STATEMENT",
"non_reserved_word : INSERTING",
"non_reserved_word : UPDATING",
"non_reserved_word : DELETING",
"non_reserved_word : FIRST",
"non_reserved_word : SKIP",
"non_reserved_word : BLOCK",
"non_reserved_word : BACKUP",
"non_reserved_word : KW_DIFFERENCE",
"non_reserved_word : IIF",
"non_reserved_word : SCALAR_ARRAY",
"non_reserved_word : WEEKDAY",
"non_reserved_word : YEARDAY",
"non_reserved_word : SEQUENCE",
"non_reserved_word : NEXT",
"non_reserved_word : RESTART",
"non_reserved_word : COLLATION",
"non_reserved_word : RETURNING",
"non_reserved_word : KW_IGNORE",
"non_reserved_word : LIMBO",
"non_reserved_word : UNDO",
"non_reserved_word : REQUESTS",
"non_reserved_word : TIMEOUT",
"non_reserved_word : ABS",
"non_reserved_word : ACCENT",
"non_reserved_word : ACOS",
"non_reserved_word : ALWAYS",
"non_reserved_word : ASCII_CHAR",
"non_reserved_word : ASCII_VAL",
"non_reserved_word : ASIN",
"non_reserved_word : ATAN",
"non_reserved_word : ATAN2",
"non_reserved_word : BIN_AND",
"non_reserved_word : BIN_OR",
"non_reserved_word : BIN_SHL",
"non_reserved_word : BIN_SHR",
"non_reserved_word : BIN_XOR",
"non_reserved_word : CEIL",
"non_reserved_word : COS",
"non_reserved_word : COSH",
"non_reserved_word : COT",
"non_reserved_word : DATEADD",
"non_reserved_word : DATEDIFF",
"non_reserved_word : DECODE",
"non_reserved_word : EXP",
"non_reserved_word : FLOOR",
"non_reserved_word : GEN_UUID",
"non_reserved_word : GENERATED",
"non_reserved_word : HASH",
"non_reserved_word : LIST",
"non_reserved_word : LN",
"non_reserved_word : LOG",
"non_reserved_word : LOG10",
"non_reserved_word : LPAD",
"non_reserved_word : MATCHED",
"non_reserved_word : MATCHING",
"non_reserved_word : MAXVALUE",
"non_reserved_word : MILLISECOND",
"non_reserved_word : MINVALUE",
"non_reserved_word : MOD",
"non_reserved_word : OVERLAY",
"non_reserved_word : PAD",
"non_reserved_word : PI",
"non_reserved_word : PLACING",
"non_reserved_word : POWER",
"non_reserved_word : PRESERVE",
"non_reserved_word : RAND",
"non_reserved_word : REPLACE",
"non_reserved_word : REVERSE",
"non_reserved_word : ROUND",
"non_reserved_word : RPAD",
"non_reserved_word : SIGN",
"non_reserved_word : SIN",
"non_reserved_word : SINH",
"non_reserved_word : SPACE",
"non_reserved_word : SQRT",
"non_reserved_word : TAN",
"non_reserved_word : TANH",
"non_reserved_word : TEMPORARY",
"non_reserved_word : TRUNC",
"non_reserved_word : WEEK",
"non_reserved_word : AUTONOMOUS",
"non_reserved_word : CHAR_TO_UUID",
"non_reserved_word : FIRSTNAME",
"non_reserved_word : MIDDLENAME",
"non_reserved_word : LASTNAME",
"non_reserved_word : MAPPING",
"non_reserved_word : OS_NAME",
"non_reserved_word : UUID_TO_CHAR",
"non_reserved_word : GRANTED",
"non_reserved_word : CALLER",
"non_reserved_word : COMMON",
"non_reserved_word : DATA",
"non_reserved_word : SOURCE",
"non_reserved_word : TWO_PHASE",
"non_reserved_word : BIN_NOT",
"non_reserved_word : ACTIVE",
"non_reserved_word : AFTER",
"non_reserved_word : ASC",
"non_reserved_word : AUTO",
"non_reserved_word : BEFORE",
"non_reserved_word : COMMITTED",
"non_reserved_word : COMPUTED",
"non_reserved_word : CONDITIONAL",
"non_reserved_word : CONTAINING",
"non_reserved_word : CSTRING",
"non_reserved_word : DATABASE",
"non_reserved_word : DESC",
"non_reserved_word : DO",
"non_reserved_word : DOMAIN",
"non_reserved_word : ENTRY_POINT",
"non_reserved_word : EXCEPTION",
"non_reserved_word : EXIT",
"non_reserved_word : KW_FILE",
"non_reserved_word : GENERATOR",
"non_reserved_word : GEN_ID",
"non_reserved_word : IF",
"non_reserved_word : INACTIVE",
"non_reserved_word : INPUT_TYPE",
"non_reserved_word : ISOLATION",
"non_reserved_word : KEY",
"non_reserved_word : LENGTH",
"non_reserved_word : LEVEL",
"non_reserved_word : MANUAL",
"non_reserved_word : MODULE_NAME",
"non_reserved_word : NAMES",
"non_reserved_word : OPTION",
"non_reserved_word : OUTPUT_TYPE",
"non_reserved_word : OVERFLOW",
"non_reserved_word : PAGE",
"non_reserved_word : PAGES",
"non_reserved_word : KW_PAGE_SIZE",
"non_reserved_word : PASSWORD",
"non_reserved_word : PRIVILEGES",
"non_reserved_word : PROTECTED",
"non_reserved_word : READ",
"non_reserved_word : RESERVING",
"non_reserved_word : RETAIN",
"non_reserved_word : SEGMENT",
"non_reserved_word : SHADOW",
"non_reserved_word : KW_SHARED",
"non_reserved_word : SINGULAR",
"non_reserved_word : KW_SIZE",
"non_reserved_word : SNAPSHOT",
"non_reserved_word : SORT",
"non_reserved_word : STABILITY",
"non_reserved_word : STARTING",
"non_reserved_word : STATISTICS",
"non_reserved_word : SUB_TYPE",
"non_reserved_word : SUSPEND",
"non_reserved_word : TRANSACTION",
"non_reserved_word : UNCOMMITTED",
"non_reserved_word : WAIT",
"non_reserved_word : WORK",
"non_reserved_word : WRITE",
};
#endif
#ifndef YYSTYPE
typedef int YYSTYPE;
#endif

#ifdef YYREDUCEPOSNFUNC
#define YYCALLREDUCEPOSN(e)   \
	if (reduce_posn) {     \
	  YYREDUCEPOSNFUNC(yyps->pos, &(yyps->psp)[1 - yym], &(yyps->vsp)[1 - yym], \
			   yym, yyps->psp - yyps->ps, yychar, yyposn, e);       \
	  reduce_posn = 0;    \
	}

#ifndef YYCALLREDUCEPOSNARG
#define YYCALLREDUCEPOSNARG yyps->val
#endif


#define YYPOSNARG(n) ((yyps->psp)[1 - yym + (n) - 1])
#define YYPOSNOUT    (yyps->pos)
#endif

// If delete function is not defined by the user, do not deletions.
#ifndef YYDELETEVAL
#define YYDELETEVAL(v, n) 
#endif

// If delete function is not defined by the user, do not deletions.
#ifndef YYDELETEPOSN
#define YYDELETEPOSN(v, n) 
#endif

#define yyclearin (yychar = (-1))

#define yyerrok (yyps->errflag = 0)

#ifndef YYSTACKGROWTH
#define YYSTACKGROWTH 16
#endif

#ifndef YYDEFSTACKSIZE
#define YYDEFSTACKSIZE 12
#endif

#ifdef YYDEBUG
int yydebug;
#endif


#define YYABORT  goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab
#define YYVALID         do { if (yyps->save)          goto yyvalid; } while(0)
#define YYVALID_NESTED  do { if (yyps->save && \
                                 yyps->save->save == 0) goto yyvalid; } while(0)
//
// For use in generated program
//
#define yytrial (yyps->save)
#define yyvsp   (yyps->vsp)
#define yyval   (yyps->val)
#define yydepth (yyps->ssp - yyps->ss)




/*
 *	PROGRAM:	Dynamic SQL runtime support
 *	MODULE:		lex.c
 *	DESCRIPTION:	Lexical routine
 *
 */


void LEX_dsql_init(MemoryPool& pool)
{
/**************************************
 *
 *	L E X _ d s q l _ i n i t
 *
 **************************************
 *
 * Functional description
 *	Initialize LEX for processing.  This is called only once
 *	per session.
 *
 **************************************/
	for (const TOK* token = KEYWORD_getTokens(); token->tok_string; ++token)
	{
		dsql_sym* symbol = FB_NEW_RPT(pool, 0) dsql_sym;
		symbol->sym_string = token->tok_string;
		symbol->sym_length = strlen(token->tok_string);
		symbol->sym_type = SYM_keyword;
		symbol->sym_keyword = token->tok_ident;
		symbol->sym_version = token->tok_version;
		dsql_str* str = FB_NEW_RPT(pool, symbol->sym_length) dsql_str;
		str->str_length = symbol->sym_length;
		strncpy(str->str_data, symbol->sym_string, symbol->sym_length);
		//str->str_data[str->str_length] = 0; Is it necessary?
		symbol->sym_object = (void *) str;
		HSHD_insert(symbol);
	}
}


const TEXT* Parser::lex_position()
{
/**************************************
 *
 *	l e x _ p o s i t i o n
 *
 **************************************
 *
 * Functional description
 *	Return the current position of LEX
 *	in the input string.
 *
 **************************************/

	return lex.ptr;
}


#ifdef NOT_USED_OR_REPLACED
static bool long_int(dsql_nod* string,
					 SLONG *long_value)
{
/*************************************
 *
 *	l o n g _ i n t
 *
 *************************************
 *
 * Functional description
 *	checks for all digits in the
 *	number and return an atol().
 *
 *************************************/

	const char* data = ((dsql_str*) string)->str_data;
	for (const UCHAR* p = (UCHAR*) data; true; p++)
	{
		if (!(classes(*p) & CHR_DIGIT)) {
			return false;
		}
	}

	*long_value = atol(data);

	return true;
}
#endif


static dsql_fld* make_field (dsql_nod* field_name)
{
/**************************************
 *
 *	m a k e _ f i e l d
 *
 **************************************
 *
 * Functional description
 *	Make a field block of given name.
 *
 **************************************/
	thread_db* tdbb = JRD_get_thread_data();

	if (field_name == NULL)
	{
		dsql_fld* field = FB_NEW(*tdbb->getDefaultPool())
			dsql_fld(*tdbb->getDefaultPool());
		field->fld_name = INTERNAL_FIELD_NAME;
		return field;
	}
	const dsql_str* string = (dsql_str*) field_name->nod_arg[1];
	dsql_fld* field = FB_NEW(*tdbb->getDefaultPool())
		dsql_fld(*tdbb->getDefaultPool());
	field->fld_name = string->str_data;
	field->fld_explicit_collation = false;
	field->fld_not_nullable = false;
	field->fld_full_domain = false;

	return field;
}


static dsql_fil* make_file()
{
/**************************************
 *
 *	m a k e _ f i l e
 *
 **************************************
 *
 * Functional description
 *	Make a file block
 *
 **************************************/
	thread_db* tdbb = JRD_get_thread_data();

	dsql_fil* temp_file = FB_NEW(*tdbb->getDefaultPool()) dsql_fil;

	return temp_file;
}


dsql_nod* Parser::make_list (dsql_nod* node)
{
/**************************************
 *
 *	m a k e _ l i s t
 *
 **************************************
 *
 * Functional description
 *	Collapse nested list nodes into single list.
 *
 **************************************/
	thread_db* tdbb = JRD_get_thread_data();

	if (node)
	{
		DsqlNodStack stack;
		stack_nodes(node, stack);
		USHORT l = stack.getCount();

		const dsql_nod* old = node;
		node = FB_NEW_RPT(*tdbb->getDefaultPool(), l) dsql_nod;
		node->nod_count = l;
		node->nod_type = nod_list;
		node->nod_line = (USHORT) lex.lines_bk;
		node->nod_column = (USHORT) (lex.last_token_bk - lex.line_start_bk + 1);
		if (old->getType() == dsql_type_nod)
		{
			node->nod_flags = old->nod_flags;
		}
		dsql_nod** ptr = node->nod_arg + node->nod_count;

		while (stack.hasData())
			*--ptr = stack.pop();
	}

	return node;
}


dsql_nod* Parser::make_parameter()
{
/**************************************
 *
 *	m a k e _ p a r a m e t e r
 *
 **************************************
 *
 * Functional description
 *	Make parameter node
 *	Any change should also be made to function below
 *
 **************************************/
	thread_db* tdbb = JRD_get_thread_data();

	dsql_nod* node = FB_NEW_RPT(*tdbb->getDefaultPool(), e_par_count) dsql_nod;
	node->nod_type = nod_parameter;
	node->nod_line = (USHORT) lex.lines_bk;
	node->nod_column = (USHORT) (lex.last_token_bk - lex.line_start_bk + 1);
	node->nod_count = e_par_count;
	node->nod_arg[e_par_index] = (dsql_nod*)(IPTR) lex.param_number++;

	return node;
}


dsql_nod* Parser::make_node(NOD_TYPE type, int count, ...)
{
/**************************************
 *
 *	m a k e _ n o d e
 *
 **************************************
 *
 * Functional description
 *	Make a node of given type.
 *	Any change should also be made to function below
 *
 **************************************/
	thread_db* tdbb = JRD_get_thread_data();

	dsql_nod* node = FB_NEW_RPT(*tdbb->getDefaultPool(), count) dsql_nod;
	node->nod_type = type;
	node->nod_line = (USHORT) lex.lines_bk;
	node->nod_column = (USHORT) (lex.last_token_bk - lex.line_start_bk + 1);
	node->nod_count = count;
	dsql_nod** p = node->nod_arg;
	va_list	ptr;
	va_start (ptr, count);

	while (--count >= 0)
		*p++ = va_arg (ptr, dsql_nod*);

	va_end(ptr);
	return node;
}


dsql_nod* Parser::makeClassNode(Node* node)
{
	return make_node(nod_class_node, 1, reinterpret_cast<dsql_nod*>(node));
}


dsql_nod* Parser::make_flag_node(NOD_TYPE type, SSHORT flag, int count, ...)
{
/**************************************
 *
 *	m a k e _ f l a g _ n o d e
 *
 **************************************
 *
 * Functional description
 *	Make a node of given type. Set flag field
 *
 **************************************/
	thread_db* tdbb = JRD_get_thread_data();

	dsql_nod* node = FB_NEW_RPT(*tdbb->getDefaultPool(), count) dsql_nod;
	node->nod_type = type;
	node->nod_flags = flag;
	node->nod_line = (USHORT) lex.lines_bk;
	node->nod_column = (USHORT) (lex.last_token_bk - lex.line_start_bk + 1);
	node->nod_count = count;
	dsql_nod** p = node->nod_arg;
	va_list	ptr;
	va_start (ptr, count);

	while (--count >= 0)
		*p++ = va_arg (ptr, dsql_nod*);

	va_end(ptr);
	return node;
}


#ifdef NOT_USED_OR_REPLACED
static bool short_int(dsql_nod* string,
					  SLONG *long_value,
					  SSHORT range)
{
/*************************************
 *
 *	s h o r t _ i n t
 *
 *************************************
 *
 * Functional description
 *	is the string a valid representation
 *	of a positive short int?
 *
 *************************************/

	if (((dsql_str*) string)->str_length > 5) {
		return false;
	}

	for (UCHAR* p = (UCHAR*)((dsql_str*) string)->str_data; true; p++)
	{
		if (!(classes(*p) & CHR_DIGIT)) {
			return false;
		}
	}

	/* there are 5 or fewer digits, it's value may still be greater
	 * than 32767... */

	SCHAR buf[10];
	buf[0] = ((dsql_str*) string)->str_data[0];
	buf[1] = ((dsql_str*) string)->str_data[1];
	buf[2] = ((dsql_str*) string)->str_data[2];
	buf[3] = ((dsql_str*) string)->str_data[3];
	buf[4] = ((dsql_str*) string)->str_data[4];
	buf[5] = '\0';

	*long_value = atoi (buf);

	bool return_value;

	switch (range)
	{
		case POSITIVE:
			return_value = *long_value > SHRT_POS_MAX;
			break;
		case NEGATIVE:
			return_value = *long_value > SHRT_NEG_MAX;
			break;
		case UNSIGNED:
			return_value = *long_value > SHRT_UNSIGNED_MAX;
			break;
	}
	return !return_value;
}
#endif

static void stack_nodes (dsql_nod*	node,
						 DsqlNodStack& stack)
{
/**************************************
 *
 *	s t a c k _ n o d e s
 *
 **************************************
 *
 * Functional description
 *	Assist in turning a tree of misc nodes into a clean list.
 *
 **************************************/
	if (node->nod_type != nod_list)
	{
		stack.push(node);
		return;
	}

	/* To take care of cases where long lists of nodes are in a chain
	   of list nodes with exactly one entry, this algorithm will look
	   for a pattern of repeated list nodes with two entries, the first
	   being a list node and the second being a non-list node.   Such
	   a list will be reverse linked, and then re-reversed, stacking the
	   non-list nodes in the process.   The purpose of this is to avoid
	   massive recursion of this function. */

	dsql_nod* start_chain = node;
	dsql_nod* end_chain = NULL;
	dsql_nod* curr_node = node;
	dsql_nod* next_node = node->nod_arg[0];
	while ( curr_node->nod_count == 2 &&
			curr_node->nod_arg[0]->nod_type == nod_list &&
			curr_node->nod_arg[1]->nod_type != nod_list &&
			next_node->nod_arg[0]->nod_type == nod_list &&
			next_node->nod_arg[1]->nod_type != nod_list)
	{

		/* pattern was found so reverse the links and go to next node */

		dsql_nod* save_link = next_node->nod_arg[0];
		next_node->nod_arg[0] = curr_node;
		curr_node = next_node;
		next_node = save_link;
		end_chain = curr_node;
	}

	/* see if any chain was found */

	if (end_chain)
	{

		/* first, handle the rest of the nodes */
		/* note that next_node still points to the first non-pattern node */

		stack_nodes (next_node, stack);

		/* stack the non-list nodes and reverse the chain on the way back */

		curr_node = end_chain;
		while (true)
		{
			stack.push(curr_node->nod_arg[1]);
			if ( curr_node == start_chain)
				break;
			dsql_nod* save_link = curr_node->nod_arg[0];
			curr_node->nod_arg[0] = next_node;
			next_node = curr_node;
			curr_node = save_link;
		}
		return;
	}

	dsql_nod** ptr = node->nod_arg;
	for (const dsql_nod* const* const end = ptr + node->nod_count; ptr < end; ptr++)
		stack_nodes (*ptr, stack);
}

static Firebird::MetaName toName(dsql_nod* node)
{
	return Firebird::MetaName(((dsql_str*) node)->str_data);
}

int Parser::yylex()
{
	lex.prev_keyword = yylexAux();
	return lex.prev_keyword;
}

int Parser::yylexAux()
{
/**************************************
 *
 *	y y l e x A u x
 *
 **************************************
 *
 * Functional description: lexer.
 *
 **************************************/
	UCHAR tok_class;
	char string[MAX_TOKEN_LEN];
	SSHORT c;

	/* Find end of white space and skip comments */

	for (;;)
	{
		if (lex.ptr >= lex.end)
			return -1;

		c = *lex.ptr++;

		/* Process comments */

		if (c == '\n') {
			lex.lines++;
			lex.line_start = lex.ptr;
			continue;
		}

		if (c == '-' && lex.ptr < lex.end && *lex.ptr == '-')
		{
			/* single-line */

			lex.ptr++;
			while (lex.ptr < lex.end) {
				if ((c = *lex.ptr++) == '\n') {
					lex.lines++;
					lex.line_start = lex.ptr /* + 1*/; /* CVC: +1 left out. */
					break;
				}
			}
			if (lex.ptr >= lex.end)
				return -1;
			continue;
		}
		else if (c == '/' && lex.ptr < lex.end && *lex.ptr == '*')
		{
			/* multi-line */

			const TEXT& start_block = lex.ptr[-1];
			lex.ptr++;
			while (lex.ptr < lex.end) {
				if ((c = *lex.ptr++) == '*') {
					if (*lex.ptr == '/')
						break;
				}
				if (c == '\n') {
					lex.lines++;
					lex.line_start = lex.ptr /* + 1*/; /* CVC: +1 left out. */

				}
			}
			if (lex.ptr >= lex.end)
			{
				// I need this to report the correct beginning of the block,
				// since it's not a token really.
				lex.last_token = &start_block;
				yyerror("unterminated block comment");
				return -1;
			}
			lex.ptr++;
			continue;
		}

		tok_class = classes(c);

		if (!(tok_class & CHR_WHITE))
			break;
	}

	/* Depending on tok_class of token, parse token */

	lex.last_token = lex.ptr - 1;

	if (tok_class & CHR_INTRODUCER)
	{
		/* The Introducer (_) is skipped, all other idents are copied
		 * to become the name of the character set
		 */
		char* p = string;
		for (; lex.ptr < lex.end && classes(*lex.ptr) & CHR_IDENT; lex.ptr++)
		{
			if (lex.ptr >= lex.end)
				return -1;
			check_copy_incr(p, UPPER7(*lex.ptr), string);
		}

		check_bound(p, string);
		*p = 0;

		/* make a string value to hold the name, the name
		 * is resolved in pass1_constant */

		yylval = (dsql_nod*) (MAKE_string(string, p - string))->str_data;

		return INTRODUCER;
	}

	/* parse a quoted string, being sure to look for double quotes */

	if (tok_class & CHR_QUOTE)
	{
		StrMark mark;
		mark.pos = lex.last_token - lex.start;

		char* buffer = string;
		size_t buffer_len = sizeof (string);
		const char* buffer_end = buffer + buffer_len - 1;
		char* p;
		for (p = buffer; ; ++p)
		{
			if (lex.ptr >= lex.end)
			{
				if (buffer != string)
					gds__free (buffer);
				yyerror("unterminated string");
				return -1;
			}
			// Care about multi-line constants and identifiers
			if (*lex.ptr == '\n') {
				lex.lines++;
				lex.line_start = lex.ptr + 1;
			}
			/* *lex.ptr is quote - if next != quote we're at the end */
			if ((*lex.ptr == c) && ((++lex.ptr == lex.end) || (*lex.ptr != c)))
				break;
			if (p > buffer_end)
			{
				char* const new_buffer = (char*) gds__alloc (2 * buffer_len);
			/* FREE: at outer block */
				if (!new_buffer)		/* NOMEM: */
				{
					if (buffer != string)
						gds__free (buffer);
					return -1;
				}
				memcpy (new_buffer, buffer, buffer_len);
				if (buffer != string)
					gds__free (buffer);
				buffer = new_buffer;
				p = buffer + buffer_len;
				buffer_len = 2 * buffer_len;
				buffer_end = buffer + buffer_len - 1;
			}
			*p = *lex.ptr++;
		}
		if (c == '"')
		{
			stmt_ambiguous = true; /* string delimited by double quotes could be
					**   either a string constant or a SQL delimited
					**   identifier, therefore marks the SQL
					**   statement as ambiguous  */
			if (client_dialect == SQL_DIALECT_V6_TRANSITION)
			{
				if (buffer != string)
					gds__free (buffer);
				yyabandon (-104, isc_invalid_string_constant);
			}
			else if (client_dialect >= SQL_DIALECT_V6)
			{
				if ((p - buffer) >= MAX_TOKEN_LEN)
				{
					if (buffer != string)
						gds__free (buffer);
					yyabandon (-104, isc_token_too_long);
				}
				yylval = (dsql_nod*) MAKE_string(buffer, p - buffer);
				dsql_str* delimited_id_str = (dsql_str*) yylval;
				delimited_id_str->type = dsql_str::TYPE_DELIMITED;
				if (buffer != string)
					gds__free (buffer);
				return SYMBOL;
			}
		}
		yylval = (dsql_nod*) MAKE_string(buffer, p - buffer);
		if (buffer != string)
			gds__free (buffer);

		mark.length = lex.ptr - lex.last_token;
		mark.str = (dsql_str*) yylval;
		strMarks.put(mark.str, mark);

		return STRING;
	}

/*
 * Check for a numeric constant, which starts either with a digit or with
 * a decimal point followed by a digit.
 *
 * This code recognizes the following token types:
 *
 * NUMBER: string of digits which fits into a 32-bit integer
 *
 * NUMBER64BIT: string of digits whose value might fit into an SINT64,
 *   depending on whether or not there is a preceding '-', which is to
 *   say that "9223372036854775808" is accepted here.
 *
 * SCALEDINT: string of digits and a single '.', where the digits
 *   represent a value which might fit into an SINT64, depending on
 *   whether or not there is a preceding '-'.
 *
 * FLOAT: string of digits with an optional '.', and followed by an "e"
 *   or "E" and an optionally-signed exponent.
 *
 * NOTE: we swallow leading or trailing blanks, but we do NOT accept
 *   embedded blanks:
 *
 * Another note: c is the first character which need to be considered,
 *   ptr points to the next character.
 */

	fb_assert(lex.ptr <= lex.end);

	// Hexadecimal string constant.  This is treated the same as a
	// string constant, but is defined as: X'bbbb'
	//
	// Where the X is a literal 'x' or 'X' character, followed
	// by a set of nibble values in single quotes.  The nibble
	// can be 0-9, a-f, or A-F, and is converted from the hex.
	// The number of nibbles should be even.
	//
	// The resulting value is stored in a string descriptor and
	// returned to the parser as a string.  This can be stored
	// in a character or binary item.
	if ((c == 'x' || c == 'X') && lex.ptr < lex.end && *lex.ptr == '\'')
	{
		bool hexerror = false;

		// Remember where we start from, to rescan later.
		// Also we'll need to know the length of the buffer.

		const char* hexstring = ++lex.ptr;
		int charlen = 0;

		// Time to scan the string. Make sure the characters are legal,
		// and find out how long the hex digit string is.

		for (;;)
		{
			if (lex.ptr >= lex.end)	// Unexpected EOS
			{
				hexerror = true;
				break;
			}

			c = *lex.ptr;

			if (c == '\'')			// Trailing quote, done
			{
				++lex.ptr;			// Skip the quote
				break;
			}

			if (!(classes(c) & CHR_HEX))	// Illegal character
			{
				hexerror = true;
				break;
			}

			++charlen;	// Okay, just count 'em
			++lex.ptr;	// and advance...
		}

		hexerror = hexerror || (charlen & 1);	// IS_ODD(charlen)

		// If we made it this far with no error, then convert the string.
		if (!hexerror)
		{
			// Figure out the length of the actual resulting hex string.
			// Allocate a second temporary buffer for it.

			Firebird::string temp;

			// Re-scan over the hex string we got earlier, converting
			// adjacent bytes into nibble values.  Every other nibble,
			// write the saved byte to the temp space.  At the end of
			// this, the temp.space area will contain the binary
			// representation of the hex constant.

			UCHAR byte = 0;
			for (int i = 0; i < charlen; i++)
			{
				c = UPPER7(hexstring[i]);

				// Now convert the character to a nibble

				if (c >= 'A')
					c = (c - 'A') + 10;
				else
					c = (c - '0');

				if (i & 1) // nibble?
				{
					byte = (byte << 4) + (UCHAR) c;
					temp.append(1, (char) byte);
				}
				else
					byte = c;
			}

			dsql_str* string = MAKE_string(temp.c_str(), temp.length());
			string->type = dsql_str::TYPE_HEXA;
			string->str_charset = "BINARY";
			yylval = (dsql_nod*) string;

			return STRING;
		}  // if (!hexerror)...

		// If we got here, there was a parsing error.  Set the
		// position back to where it was before we messed with
		// it.  Then fall through to the next thing we might parse.

		c = *lex.last_token;
		lex.ptr = lex.last_token + 1;
	}

	// Hexadecimal numeric constants - 0xBBBBBB
	//
	// where the '0' and the 'X' (or 'x') are literal, followed
	// by a set of nibbles, using 0-9, a-f, or A-F.  Odd numbers
	// of nibbles assume a leading '0'.  The result is converted
	// to an integer, and the result returned to the caller.  The
	// token is identified as a NUMBER if it's a 32-bit or less
	// value, or a NUMBER64INT if it requires a 64-bit number.
	if (c == '0' && lex.ptr + 1 < lex.end && (*lex.ptr == 'x' || *lex.ptr == 'X') &&
		(classes(lex.ptr[1]) & CHR_HEX))
	{
		bool hexerror = false;

		// Remember where we start from, to rescan later.
		// Also we'll need to know the length of the buffer.

		++lex.ptr;  // Skip the 'X' and point to the first digit
		const char* hexstring = lex.ptr;
		int charlen = 0;

		// Time to scan the string. Make sure the characters are legal,
		// and find out how long the hex digit string is.

		for (;;)
		{
			if (lex.ptr >= lex.end)			// Unexpected EOS
			{
				hexerror = true;
				break;
			}

			c = *lex.ptr;

			if (!(classes(c) & CHR_HEX))	// End of digit string
				break;

			++charlen;			// Okay, just count 'em
			++lex.ptr;			// and advance...

			if (charlen > 16)	// Too many digits...
			{
				hexerror = true;
				break;
			}
		}

		// we have a valid hex token. Now give it back, either as
		// an NUMBER or NUMBER64BIT.
		if (!hexerror)
		{
			// if charlen > 8 (something like FFFF FFFF 0, w/o the spaces)
			// then we have to return a NUMBER64BIT. We'll make a string
			// node here, and let make.cpp worry about converting the
			// string to a number and building the node later.
			if (charlen > 8)
			{
				char cbuff[32];
				cbuff[0] = 'X';
				strncpy(&cbuff[1], hexstring, charlen);
				cbuff[charlen + 1] = '\0';

				char* p = &cbuff[1];

				while (*p != '\0')
				{
					if ((*p >= 'a') && (*p <= 'f'))
						*p = UPPER(*p);
					p++;
				}

				yylval = (dsql_nod*) MAKE_string(cbuff, strlen(cbuff));
				return NUMBER64BIT;
			}
			else
			{
				// we have an integer value. we'll return NUMBER.
				// but we have to make a number value to be compatible
				// with existing code.

				// See if the string length is odd.  If so,
				// we'll assume a leading zero.  Then figure out the length
				// of the actual resulting hex string.  Allocate a second
				// temporary buffer for it.

				bool nibble = (charlen & 1);  // IS_ODD(temp.length)

				// Re-scan over the hex string we got earlier, converting
				// adjacent bytes into nibble values.  Every other nibble,
				// write the saved byte to the temp space.  At the end of
				// this, the temp.space area will contain the binary
				// representation of the hex constant.

				UCHAR byte = 0;
				SINT64 value = 0;

				for (int i = 0; i < charlen; i++)
				{
					c = UPPER(hexstring[i]);

					// Now convert the character to a nibble

					if (c >= 'A')
						c = (c - 'A') + 10;
					else
						c = (c - '0');

					if (nibble)
					{
						byte = (byte << 4) + (UCHAR) c;
						nibble = false;
						value = (value << 8) + byte;
					}
					else
					{
						byte = c;
						nibble = true;
					}
				}

				yylval = (dsql_nod*)(long) value;
				return NUMBER;
			} // integer value
		}  // if (!hexerror)...

		// If we got here, there was a parsing error.  Set the
		// position back to where it was before we messed with
		// it.  Then fall through to the next thing we might parse.

		c = *lex.last_token;
		lex.ptr = lex.last_token + 1;
	} // headecimal numeric constants

	if ((tok_class & CHR_DIGIT) ||
		((c == '.') && (lex.ptr < lex.end) && (classes(*lex.ptr) & CHR_DIGIT)))
	{
		/* The following variables are used to recognize kinds of numbers. */

		bool have_error	 = false;	/* syntax error or value too large */
		bool have_digit	 = false;	/* we've seen a digit			  */
		bool have_decimal   = false;	/* we've seen a '.'				*/
		bool have_exp	   = false;	/* digit ... [eE]				  */
		bool have_exp_sign  = false; /* digit ... [eE] {+-]			 */
		bool have_exp_digit = false; /* digit ... [eE] ... digit		*/
		FB_UINT64 number		= 0;
		FB_UINT64 limit_by_10	= MAX_SINT64 / 10;

		for (--lex.ptr; lex.ptr < lex.end; lex.ptr++)
		{
			c = *lex.ptr;
			if (have_exp_digit && (! (classes(c) & CHR_DIGIT)))
				/* First non-digit after exponent and digit terminates
				 the token. */
				break;
			else if (have_exp_sign && (! (classes(c) & CHR_DIGIT)))
			{
				/* only digits can be accepted after "1E-" */
				have_error = true;
				break;
			}
			else if (have_exp)
			{
				/* We've seen e or E, but nothing beyond that. */
				if ( ('-' == c) || ('+' == c) )
					have_exp_sign = true;
				else if ( classes(c) & CHR_DIGIT )
					/* We have a digit: we haven't seen a sign yet,
					but it's too late now. */
					have_exp_digit = have_exp_sign  = true;
				else
				{
					/* end of the token */
					have_error = true;
					break;
				}
			}
			else if ('.' == c)
			{
				if (!have_decimal)
					have_decimal = true;
				else
				{
					have_error = true;
					break;
				}
			}
			else if (classes(c) & CHR_DIGIT)
			{
				/* Before computing the next value, make sure there will be
				   no overflow.  */

				have_digit = true;

				if (number >= limit_by_10)
				{
				/* possibility of an overflow */
					if ((number > limit_by_10) || (c > '8'))
					{
						have_error = true;
						break;
					}
				}
				number = number * 10 + (c - '0');
			}
			else if ( (('E' == c) || ('e' == c)) && have_digit )
				have_exp = true;
			else
				/* Unexpected character: this is the end of the number. */
				break;
		}

		/* We're done scanning the characters: now return the right kind
		   of number token, if any fits the bill. */

		if (!have_error)
		{
			fb_assert(have_digit);

			if (have_exp_digit)
			{
				yylval = (dsql_nod*) MAKE_string(lex.last_token, lex.ptr - lex.last_token);
				lex.last_token_bk = lex.last_token;
				lex.line_start_bk = lex.line_start;
				lex.lines_bk = lex.lines;

				return FLOAT_NUMBER;
			}
			else if (!have_exp)
			{

				/* We should return some kind (scaled-) integer type
				   except perhaps in dialect 1. */

				if (!have_decimal && (number <= MAX_SLONG))
				{
					yylval = (dsql_nod*) (IPTR) number;
					//printf ("parse.y %p %d\n", yylval, number);
					return NUMBER;
				}
				else
				{
					/* We have either a decimal point with no exponent
					   or a string of digits whose value exceeds MAX_SLONG:
					   the returned type depends on the client dialect,
					   so warn of the difference if the client dialect is
					   SQL_DIALECT_V6_TRANSITION.
					*/

					if (SQL_DIALECT_V6_TRANSITION == client_dialect)
					{
						/* Issue a warning about the ambiguity of the numeric
						 * numeric literal.  There are multiple calls because
						 * the message text exceeds the 119-character limit
						 * of our message database.
						 */
						ERRD_post_warning(Arg::Warning(isc_dsql_warning_number_ambiguous) <<
										  Arg::Str(Firebird::string(lex.last_token, lex.ptr - lex.last_token)));
						ERRD_post_warning(Arg::Warning(isc_dsql_warning_number_ambiguous1));
					}

					yylval = (dsql_nod*) MAKE_string(lex.last_token, lex.ptr - lex.last_token);

					lex.last_token_bk = lex.last_token;
					lex.line_start_bk = lex.line_start;
					lex.lines_bk = lex.lines;

					if (client_dialect < SQL_DIALECT_V6_TRANSITION)
						return FLOAT_NUMBER;
					else if (have_decimal)
						return SCALEDINT;
					else
						return NUMBER64BIT;
				}
			} /* else if (!have_exp) */
		} /* if (!have_error) */

		/* we got some kind of error or overflow, so don't recognize this
		 * as a number: just pass it through to the next part of the lexer.
		 */
	}

	/* Restore the status quo ante, before we started our unsuccessful
	   attempt to recognize a number. */
	lex.ptr = lex.last_token;
	c   = *lex.ptr++;
	/* We never touched tok_class, so it doesn't need to be restored. */

	/* end of number-recognition code */


	if (tok_class & CHR_LETTER)
	{
		char* p = string;
		check_copy_incr(p, UPPER (c), string);
		for (; lex.ptr < lex.end && classes(*lex.ptr) & CHR_IDENT; lex.ptr++)
		{
			if (lex.ptr >= lex.end)
				return -1;
			check_copy_incr(p, UPPER (*lex.ptr), string);
		}

		check_bound(p, string);
		*p = 0;
		dsql_sym* sym =
			HSHD_lookup (NULL, string, (SSHORT)(p - string), SYM_keyword, parser_version);
		if (sym && (sym->sym_keyword != COMMENT || lex.prev_keyword == -1))
		{
			yylval = (dsql_nod*) sym->sym_object;
			lex.last_token_bk = lex.last_token;
			lex.line_start_bk = lex.line_start;
			lex.lines_bk = lex.lines;
			return sym->sym_keyword;
		}
		yylval = (dsql_nod*) MAKE_string(string, p - string);
		lex.last_token_bk = lex.last_token;
		lex.line_start_bk = lex.line_start;
		lex.lines_bk = lex.lines;
		return SYMBOL;
	}

	/* Must be punctuation -- test for double character punctuation */

	if (lex.last_token + 1 < lex.end)
	{
		dsql_sym* sym =
			HSHD_lookup (NULL, lex.last_token, (SSHORT) 2, SYM_keyword, (USHORT) parser_version);
		if (sym)
		{
			++lex.ptr;
			return sym->sym_keyword;
		}
	}

	/* Single character punctuation are simply passed on */

	return (UCHAR) c;
}


void Parser::yyerror_detailed(const TEXT* /*error_string*/, int yychar, YYSTYPE&, YYPOSN&)
{
/**************************************
 *
 *	y y e r r o r _ d e t a i l e d
 *
 **************************************
 *
 * Functional description
 *	Print a syntax error.
 *
 **************************************/
	const TEXT* line_start = lex.line_start;
	SLONG lines = lex.lines;
	if (lex.last_token < lex.line_start)
	{
		line_start = lex.line_start_bk;
		lines--;
	}

	if (yychar < 1)
	{
		ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
				  /* Unexpected end of command */
				  Arg::Gds(isc_command_end_err2) << Arg::Num(lines) <<
													Arg::Num(lex.last_token - line_start + 1));
	}
	else
	{
		ERRD_post (Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
				  /* Token unknown - line %d, column %d */
				  Arg::Gds(isc_dsql_token_unk_err) << Arg::Num(lines) <<
				  									  Arg::Num(lex.last_token - line_start + 1) << /*CVC: +1*/
				  /* Show the token */
				  Arg::Gds(isc_random) << Arg::Str(string(lex.last_token, lex.ptr - lex.last_token)));
	}
}


// The argument passed to this function is ignored. Therefore, messages like
// "syntax error" and "yacc stack overflow" are never seen.
void Parser::yyerror(const TEXT* error_string)
{
	YYSTYPE errt_value =  0;
	YYPOSN errt_posn = -1;
	yyerror_detailed(error_string, -1, errt_value, errt_posn);
}


static void yyabandon (SLONG		sql_code,
					   ISC_STATUS	error_symbol)
{
/**************************************
 *
 *	y y a b a n d o n
 *
 **************************************
 *
 * Functional description
 *	Abandon the parsing outputting the supplied string
 *
 **************************************/

	ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(sql_code) <<
			  Arg::Gds(error_symbol));
}


void Parser::yySCopy(YYSTYPE* to, YYSTYPE* from, int size)
{
  int i;                             
  for (i = size - 1; i >= 0; i--) {
    to[i] = from[i];
  }
}


void Parser::yyPCopy(YYPOSN* to, YYPOSN* from, int size)
{
  int i;                             
  for (i = size - 1; i >= 0; i--) {
    to[i] = from[i];
  }
}


void Parser::yyMoreStack(yyparsestate* yyps)
{
  int p = yyps->ssp - yyps->ss;                               
  Yshort  *tss = yyps->ss;
  YYSTYPE *tvs = yyps->vs;
  YYPOSN  *tps = yyps->ps;
  yyps->ss = new Yshort [yyps->stacksize + YYSTACKGROWTH];   
  yyps->vs = new YYSTYPE[yyps->stacksize + YYSTACKGROWTH];  
  yyps->ps = new YYPOSN [yyps->stacksize + YYSTACKGROWTH];  
  memcpy(yyps->ss, tss, yyps->stacksize * sizeof(Yshort));  
  yySCopy(yyps->vs, tvs, yyps->stacksize);
  yyPCopy(yyps->ps, tps, yyps->stacksize);
  yyps->stacksize += YYSTACKGROWTH;
  delete[] tss;
  delete[] tvs;
  delete[] tps;
  yyps->ssp = yyps->ss + p;                                   
  yyps->vsp = yyps->vs + p;                                   
  yyps->psp = yyps->ps + p;                                   
}


Parser::yyparsestate* Parser::yyNewState(int size)
{
  yyparsestate *p = new yyparsestate;
  p->stacksize = size + 4;
  p->ss = new Yshort [size + 4];
  p->vs = new YYSTYPE[size + 4];
  p->ps = new YYPOSN [size + 4];
  memset(&p->vs[0], 0, (size + 4) * sizeof(YYSTYPE));
  memset(&p->ps[0], 0, (size + 4) * sizeof(YYPOSN));
  return p;
}


void Parser::yyFreeState(Parser::yyparsestate* p)
{
  delete[] p->ss;
  delete[] p->vs;
  delete[] p->ps;
  delete p;
}


int Parser::parseAux()
{
  int yym, yyn, yystate, yychar, yynewerrflag;
  yyparsestate *yyerrctx = NULL;
  int reduce_posn;

#if YYDEBUG
  const char *yys;
  
  if ((yys = getenv("YYDEBUG"))) {
    yyn = *yys;
    if (yyn >= '0' && yyn <= '9')
      yydebug = yyn - '0'; 
  }
#endif
  
  yyps = yyNewState(YYDEFSTACKSIZE);
  yyps->save = 0;
  yynerrs = 0;
  yyps->errflag = 0;
  yychar = (-1);
  
  yyps->ssp = yyps->ss;
  yyps->vsp = yyps->vs;
  yyps->psp = yyps->ps;
  *(yyps->ssp) = yystate = 0;
  

  //
  // Main parsing loop
  //
 yyloop:
  if ((yyn = yydefred[yystate])) {
    goto yyreduce;
  }

  //
  // Read one token
  //
  if (yychar < 0) {
    if ((yychar = yylex1()) < 0) yychar = 0;
#if YYDEBUG
    if (yydebug) {
      yys = 0;
      if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
      if (!yys) yys = "illegal-symbol";
      printf("yydebug[%d,%p]: state %d, reading %d (%s)", 
	     int(yydepth), yytrial, yystate, yychar, yys);
#ifdef YYDBPR
      printf("<");
      YYDBPR(yylval);
      printf(">");
#endif
      printf("\n"); 
    }
#endif
  }

  //
  // Do we have a conflict?
  //
  if ((yyn = yycindex[yystate]) &&
      (yyn += yychar) >= 0 &&
      yyn <= YYTABLESIZE &&
      yycheck[yyn] == yychar) {
    int ctry;

    if (yypath) {
#if YYDEBUG
      if (yydebug) {
        printf("yydebug[%d,%p]: CONFLICT in state %d: following successful trial parse\n", 
	       int(yydepth), yytrial, yystate);
      }
#endif
      // Switch to the next conflict context
      yyparsestate *save = yypath;
      yypath = save->save;
      ctry = save->ctry;
      if (save->state != yystate) 
        goto yyabort;
      yyFreeState(save); 

    } else {

#if YYDEBUG
      if (yydebug) {
        printf("yydebug[%d,%p]: CONFLICT in state %d. ", 
	       int(yydepth), yytrial, yystate);
        if (yyps->save) {
          printf("ALREADY in conflict. Continue trial parse.");
        } else {
          printf("Start trial parse.");
        }
        printf("\n");
      }
#endif
      yyparsestate *save = yyNewState(yyps->ssp - yyps->ss);
      save->save    = yyps->save;
      save->state   = yystate;
      save->errflag = yyps->errflag;
      save->ssp     = save->ss + (yyps->ssp - yyps->ss);
      save->vsp     = save->vs + (yyps->vsp - yyps->vs);
      save->psp     = save->ps + (yyps->psp - yyps->ps);
      memcpy (save->ss, yyps->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
      yySCopy(save->vs, yyps->vs, (yyps->ssp - yyps->ss + 1));
      yyPCopy(save->ps, yyps->ps, (yyps->ssp - yyps->ss + 1));
      ctry = yytable[yyn];
      if (yyctable[ctry] == -1) {
#if YYDEBUG
        if (yydebug && yychar >= 0)
          printf("yydebug[%p]: backtracking 1 token\n", yytrial);
#endif
        ctry++; 
      }
      save->ctry = ctry;
      if (!yyps->save) {
        // If this is a first conflict in the stack, start saving lexemes
        if (!yylexemes) {
          yylexemes = new Yshort[YYSTACKGROWTH];
          yylvals = new YYSTYPE[YYSTACKGROWTH];
          yylvlim = yylvals + YYSTACKGROWTH; 
          yylpsns = new YYPOSN[YYSTACKGROWTH];
          yylplim = yylpsns + YYSTACKGROWTH; 
        }
        if (yylvp == yylve) {
          yylvp = yylve = yylvals;
	  yylpp = yylpe = yylpsns;
          yylexp = yylexemes;
          if (yychar >= 0) {
            *yylve++ = yylval;
            *yylpe++ = yyposn;
            *yylexp = yychar;
            yychar = -1; 
          } 
        } 
      }
      if (yychar >= 0) {
        yylvp--, yylpp--, yylexp--;
        yychar = -1; 
      }
      save->lexeme = yylvp - yylvals;
      yyps->save = save; 
    }
    if (yytable[yyn] == ctry) {
#if YYDEBUG
      if (yydebug)
        printf("yydebug[%d,%p]: state %d, shifting to state %d\n",
               int(yydepth), yytrial, yystate, yyctable[ctry]);
#endif
      if (yychar < 0)
        yylvp++, yylpp++, yylexp++;
      yychar = -1;
      if (yyps->errflag > 0) --yyps->errflag;
      yystate = yyctable[ctry];
      goto yyshift; 
    } else {
      yyn = yyctable[ctry];
      goto yyreduce; 
    } 
  }

  //
  // Is action a shift?
  //
  if ((yyn = yysindex[yystate]) &&
      (yyn += yychar) >= 0 &&
      yyn <= YYTABLESIZE &&
      yycheck[yyn] == yychar) {
#if YYDEBUG
    if (yydebug)
      printf("yydebug[%d,%p]: state %d, shifting to state %d\n",
             int(yydepth), yytrial, yystate, yytable[yyn]);
#endif
    yychar = (-1);
    if (yyps->errflag > 0)  --yyps->errflag;
    yystate = yytable[yyn];
  yyshift:
    if (yyps->ssp >= yyps->ss + yyps->stacksize - 1) {
      yyMoreStack(yyps);
    }
    *++(yyps->ssp) = yystate;
    *++(yyps->vsp) = yylval;
    *++(yyps->psp) = yyposn;
    goto yyloop;
  }
  if ((yyn = yyrindex[yystate]) &&
      (yyn += yychar) >= 0 &&
      yyn <= YYTABLESIZE &&
      yycheck[yyn] == yychar) {
    yyn = yytable[yyn];
    goto yyreduce;
  }

  //
  // Action: error
  //
  if (yyps->errflag) goto yyinrecovery;
  yynewerrflag = 1;
  goto yyerrhandler;
yyerrlab:
  yynewerrflag = 0;
yyerrhandler:
  while (yyps->save) { 
    int ctry; 
    yyparsestate *save = yyps->save;
#if YYDEBUG
    if (yydebug)
      printf("yydebug[%d,%p]: ERROR in state %d, CONFLICT BACKTRACKING to state %d, %d tokens\n",
             int(yydepth), yytrial, yystate, yyps->save->state, int(yylvp - yylvals - yyps->save->lexeme));
#endif
    // Memorize most forward-looking error state in case
    // it's really an error.
    if (yyerrctx == NULL || yyerrctx->lexeme < yylvp-yylvals) {
      // Free old saved error context state
      if (yyerrctx) yyFreeState(yyerrctx);
      // Create and fill out new saved error context state
      yyerrctx = yyNewState(yyps->ssp - yyps->ss);
      yyerrctx->save = yyps->save;
      yyerrctx->state = yystate;
      yyerrctx->errflag = yyps->errflag;
      yyerrctx->ssp = yyerrctx->ss + (yyps->ssp - yyps->ss);
      yyerrctx->vsp = yyerrctx->vs + (yyps->vsp - yyps->vs);
      yyerrctx->psp = yyerrctx->ps + (yyps->psp - yyps->ps);
      memcpy (yyerrctx->ss, yyps->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
      yySCopy(yyerrctx->vs, yyps->vs, (yyps->ssp - yyps->ss + 1));
      yyPCopy(yyerrctx->ps, yyps->ps, (yyps->ssp - yyps->ss + 1));
      yyerrctx->lexeme = yylvp - yylvals;
    }
    yylvp  = yylvals   + save->lexeme;
    yylpp  = yylpsns   + save->lexeme;
    yylexp = yylexemes + save->lexeme;
    yychar = -1;
    yyps->ssp = yyps->ss + (save->ssp - save->ss);
    yyps->vsp = yyps->vs + (save->vsp - save->vs);
    yyps->psp = yyps->ps + (save->psp - save->ps);
    memcpy (yyps->ss, save->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
    yySCopy(yyps->vs, save->vs,  yyps->vsp - yyps->vs + 1);
    yyPCopy(yyps->ps, save->ps,  yyps->psp - yyps->ps + 1);
    ctry = ++save->ctry;
    yystate = save->state;
    // We tried shift, try reduce now
    if ((yyn = yyctable[ctry]) >= 0) {
      goto yyreduce;
    }
    yyps->save = save->save;
    yyFreeState(save);
    //
    // Nothing left on the stack -- error
    //
    if (!yyps->save) {
#if YYDEBUG
      if (yydebug) {
        printf("yydebug[%p]: trial parse FAILED, entering ERROR mode\n", 
	       yytrial);
      }
#endif
      // Restore state as it was in the most forward-advanced error
      yylvp  = yylvals   + yyerrctx->lexeme;
      yylpp  = yylpsns   + yyerrctx->lexeme;
      yylexp = yylexemes + yyerrctx->lexeme;
      yychar = yylexp[-1];
      yylval = yylvp[-1];
      yyposn = yylpp[-1];
      yyps->ssp = yyps->ss + (yyerrctx->ssp - yyerrctx->ss);
      yyps->vsp = yyps->vs + (yyerrctx->vsp - yyerrctx->vs);
      yyps->psp = yyps->ps + (yyerrctx->psp - yyerrctx->ps);
      memcpy (yyps->ss, yyerrctx->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
      yySCopy(yyps->vs, yyerrctx->vs,  yyps->vsp - yyps->vs + 1);
      yyPCopy(yyps->ps, yyerrctx->ps,  yyps->psp - yyps->ps + 1);
      yystate = yyerrctx->state;
      yyFreeState(yyerrctx);
      yyerrctx = NULL;
    }
    yynewerrflag = 1; 
  }
  if (yynewerrflag) {
#ifdef YYERROR_DETAILED
    yyerror_detailed("syntax error", yychar, yylval, yyposn);
#else
    yyerror("syntax error");
#endif
  }
  ++yynerrs;
 yyinrecovery:
  if (yyps->errflag < 3) {
    yyps->errflag = 3;
    for (;;) {
      if ((yyn = yysindex[*(yyps->ssp)]) && 
	  (yyn += YYERRCODE) >= 0 &&
          yyn <= YYTABLESIZE && 
	  yycheck[yyn] == YYERRCODE) {
#if YYDEBUG
        if (yydebug)
          printf("yydebug[%d,%p]: state %d, ERROR recovery shifts to state %d\n",
                 int(yydepth), yytrial, *(yyps->ssp), yytable[yyn]);
#endif
        /* Use label yyerrlab, so that compiler does not warn */
        if (yyps->errflag != yyps->errflag) goto yyerrlab;
        yystate = yytable[yyn];
        goto yyshift; 
      } else {
#if YYDEBUG
        if (yydebug)
          printf("yydebug[%d,%p]: ERROR recovery discards state %d\n",
                 int(yydepth), yytrial, *(yyps->ssp));
#endif
        if (yyps->ssp <= yyps->ss) {
	  goto yyabort;
	}
	if (!yytrial) {
	  YYDELETEVAL(yyps->vsp[0], 1);
	  YYDELETEPOSN(yyps->psp[0], 1);
	}
        --(yyps->ssp);
        --(yyps->vsp);
        --(yyps->psp);
      }
    }
  } else {
    if (yychar == 0) goto yyabort;
#if YYDEBUG
    if (yydebug) {
      yys = 0;
      if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
      if (!yys) yys = "illegal-symbol";
      printf("yydebug[%d,%p]: state %d, ERROR recovery discards token %d (%s)\n",
             int(yydepth), yytrial, yystate, yychar, yys); 
    }
#endif
    if (!yytrial) {
      YYDELETEVAL(yylval, 0);
      YYDELETEPOSN(yyposn, 0);
    }
    yychar = (-1);
    goto yyloop;
  }

  //
  // Reduce the rule
  //
yyreduce:
  yym = yylen[yyn];
#if YYDEBUG
  if (yydebug) {
    printf("yydebug[%d,%p]: state %d, reducing by rule %d (%s)",
           int(yydepth), yytrial, yystate, yyn, yyrule[yyn]);
#ifdef YYDBPR
    if (yym) {
      int i;
      printf("<");
      for (i = yym; i > 0; i--) {
        if (i != yym) printf(", ");
        YYDBPR((yyps->vsp)[1 - i]);
      }
      printf(">");
    }
#endif
    printf("\n");
  }
#endif
  if (yyps->ssp + 1 - yym >= yyps->ss + yyps->stacksize) {
    yyMoreStack(yyps);
  }

  /* default action - assign last argument as in standard yacc */
  yyps->val = yyvsp[1 - yym];

  /* default reduced position is NULL -- no position at all.
     no position will be assigned at trial time and if no position handling is present */
  memset(&yyps->pos, 0, sizeof(yyps->pos));

  reduce_posn = TRUE;

  switch (yyn) {

case 1:
  if (!yytrial)
{ DSQL_parse = yyvsp[0]; }
break;
case 2:
  if (!yytrial)
{ DSQL_parse = yyvsp[-1]; }
break;
case 25:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) e_grant_count,
					yyvsp[-7], yyvsp[-4], make_list(yyvsp[-2]), yyvsp[-1], yyvsp[0]); }
break;
case 26:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) e_grant_count,
					yyvsp[-7], yyvsp[-4], make_list(yyvsp[-2]), yyvsp[-1], yyvsp[0]); }
break;
case 27:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) e_grant_count,
					make_list(yyvsp[-4]), make_list(yyvsp[-2]), NULL, yyvsp[-1], yyvsp[0]); }
break;
case 30:
  if (!yytrial)
{ yyval = make_node (nod_all, (int) 0, NULL); }
break;
case 31:
  if (!yytrial)
{ yyval = make_node (nod_all, (int) 0, NULL); }
break;
case 32:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 34:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 35:
  if (!yytrial)
{ yyval = make_list (make_node (nod_execute, (int) 0, NULL)); }
break;
case 36:
  if (!yytrial)
{ yyval = make_node (nod_select, (int) 0, NULL); }
break;
case 37:
  if (!yytrial)
{ yyval = make_node (nod_insert, (int) 0, NULL); }
break;
case 38:
  if (!yytrial)
{ yyval = make_node (nod_delete, (int) 0, NULL); }
break;
case 39:
  if (!yytrial)
{ yyval = make_node (nod_update, (int) 1, yyvsp[0]); }
break;
case 40:
  if (!yytrial)
{ yyval = make_node (nod_references, (int) 1, yyvsp[0]); }
break;
case 41:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) 0, NULL); }
break;
case 42:
  if (!yytrial)
{ yyval = NULL; }
break;
case 43:
  if (!yytrial)
{ yyval = make_node (nod_grant_admin, (int) 0, NULL); }
break;
case 44:
  if (!yytrial)
{ yyval = NULL; }
break;
case 45:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 46:
  if (!yytrial)
{ yyval = NULL; }
break;
case 49:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 50:
  if (!yytrial)
{ yyval = make_node (nod_procedure_name, (int) 1, yyvsp[0]); }
break;
case 51:
  if (!yytrial)
{ yyval = make_node (nod_revoke, (int) e_grant_count,
					yyvsp[-6], yyvsp[-3], make_list(yyvsp[-1]), yyvsp[-7], yyvsp[0]); }
break;
case 52:
  if (!yytrial)
{ yyval = make_node (nod_revoke, (int) e_grant_count,
					yyvsp[-6], yyvsp[-3], make_list(yyvsp[-1]), yyvsp[-7], yyvsp[0]); }
break;
case 53:
  if (!yytrial)
{ yyval = make_node (nod_revoke, (int) e_grant_count,
					make_list(yyvsp[-3]), make_list(yyvsp[-1]), NULL, yyvsp[-4], yyvsp[0]); }
break;
case 54:
  if (!yytrial)
{ yyval = make_node (nod_revoke, (int) e_grant_count,
					NULL, NULL, make_list(yyvsp[0]), NULL, NULL); }
break;
case 55:
  if (!yytrial)
{ yyval = make_node (nod_grant, (int) 0, NULL); }
break;
case 56:
  if (!yytrial)
{ yyval = NULL; }
break;
case 57:
  if (!yytrial)
{ yyval = make_node (nod_grant_admin, (int) 0, NULL); }
break;
case 58:
  if (!yytrial)
{ yyval = NULL; }
break;
case 62:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 63:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 64:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 65:
  if (!yytrial)
{ yyval = make_node (nod_proc_obj, (int) 1, yyvsp[0]); }
break;
case 66:
  if (!yytrial)
{ yyval = make_node (nod_trig_obj, (int) 1, yyvsp[0]); }
break;
case 67:
  if (!yytrial)
{ yyval = make_node (nod_view_obj, (int) 1, yyvsp[0]); }
break;
case 68:
  if (!yytrial)
{ yyval = make_node (nod_role_name, (int) 1, yyvsp[0]); }
break;
case 70:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 71:
  if (!yytrial)
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 72:
  if (!yytrial)
{ yyval = make_node (nod_user_name, (int) 2, yyvsp[0], NULL); }
break;
case 73:
  if (!yytrial)
{ yyval = make_node (nod_user_group, (int) 1, yyvsp[0]); }
break;
case 75:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 76:
  if (!yytrial)
{ yyval = make_node (nod_role_name, (int) 1, yyvsp[0]); }
break;
case 78:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 79:
  if (!yytrial)
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 80:
  if (!yytrial)
{ yyval = make_node (nod_user_name, (int) 1, yyvsp[0]); }
break;
case 81:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 82:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 83:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 84:
  if (!yytrial)
{ yyval = make_node (nod_def_udf, (int) e_udf_count,
				yyvsp[-7], yyvsp[-2], yyvsp[0], make_list (yyvsp[-6]), yyvsp[-4]); }
break;
case 86:
  if (!yytrial)
{ lex.g_field->fld_dtype = dtype_blob; }
break;
case 87:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_cstring;
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-2]; }
break;
case 88:
  if (!yytrial)
{ yyval = NULL; }
break;
case 90:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 92:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 93:
  if (!yytrial)
{ yyval = make_node (nod_udf_param, (int) e_udf_param_count,
							  yyvsp[-2], yyvsp[0]); }
break;
case 94:
  if (!yytrial)
{ yyval = NULL; }
break;
case 95:
  if (!yytrial)
{ yyval = MAKE_const_slong (FUN_descriptor); }
break;
case 96:
  if (!yytrial)
{ yyval = MAKE_const_slong (FUN_scalar_array); }
break;
case 97:
  if (!yytrial)
{ yyval = MAKE_const_slong (FUN_ref_with_null); }
break;
case 99:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 100:
  if (!yytrial)
{ yyval = make_node (nod_udf_return_value, (int) e_udf_param_count,
							  yyvsp[-2], yyvsp[0]); }
break;
case 101:
  if (!yytrial)
{ yyval = make_node (nod_udf_return_value, (int) e_udf_param_count,
				NULL, MAKE_const_slong ((IPTR) yyvsp[0]));}
break;
case 102:
  if (!yytrial)
{ yyval = MAKE_const_slong (FUN_reference); }
break;
case 103:
  if (!yytrial)
{ yyval = MAKE_const_slong (FUN_value); }
break;
case 104:
  if (!yytrial)
{ yyval = MAKE_const_slong (FUN_descriptor); }
break;
case 105:
  if (!yytrial)
{ yyval = MAKE_const_slong (-1 * FUN_reference); }
break;
case 106:
  if (!yytrial)
{ yyval = MAKE_const_slong (-1 * FUN_descriptor); }
break;
case 107:
  if (!yytrial)
{ yyval = make_node (nod_def_filter, (int) e_filter_count,
						yyvsp[-8], yyvsp[-6], yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 108:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_STRING); }
break;
case 109:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 110:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 111:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 112:
  if (!yytrial)
{ yyval = make_node (nod_def_index, (int) e_idx_count,
					yyvsp[-6], yyvsp[-5], yyvsp[-3], yyvsp[-1], yyvsp[0]); }
break;
case 113:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 114:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 115:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 116:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 117:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 118:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 119:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 120:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 121:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 122:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 123:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 124:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 125:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 126:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 127:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 128:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 129:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 130:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 131:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 132:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 133:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 134:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 135:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 136:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 137:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 138:
  if (!yytrial)
{ yyval = make_node (nod_def_exception, (int) e_xcp_count,
						yyvsp[-1], yyvsp[0]); }
break;
case 139:
  if (!yytrial)
{ yyval = make_node (nod_redef_exception, (int) e_xcp_count,
						yyvsp[-1], yyvsp[0]); }
break;
case 140:
  if (!yytrial)
{ yyval = make_node (nod_replace_exception, (int) e_xcp_count,
						yyvsp[-1], yyvsp[0]); }
break;
case 141:
  if (!yytrial)
{ yyval = make_node (nod_mod_exception, (int) e_xcp_count,
						yyvsp[-1], yyvsp[0]); }
break;
case 142:
  if (!yytrial)
{ yyval = make_node (nod_unique, 0, NULL); }
break;
case 143:
  if (!yytrial)
{ yyval = NULL; }
break;
case 144:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 146:
  if (!yytrial)
{ yyval = make_node (nod_def_computed, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 147:
  if (!yytrial)
{ yyval = make_node (nod_def_shadow, (int) e_shadow_count,
				 yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], make_list (yyvsp[0])); }
break;
case 148:
  if (!yytrial)
{ yyval = MAKE_const_slong (1); }
break;
case 149:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 150:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 151:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 152:
  if (!yytrial)
{ yyval = MAKE_const_slong (1); }
break;
case 153:
  if (!yytrial)
{ yyval = (dsql_nod*) 0;}
break;
case 154:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 155:
  if (!yytrial)
{ yyval = NULL; }
break;
case 158:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 159:
  if (!yytrial)
{ yyval = make_node (nod_def_domain, (int) e_dom_count, yyvsp[-5], yyvsp[-2], make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 160:
  if (!yytrial)
{ yyval = NULL; }
break;
case 161:
  if (!yytrial)
{ yyval = NULL; }
break;
case 162:
  if (!yytrial)
{ yyval = make_node (nod_def_default, (int) e_dft_count, yyvsp[-1], yyvsp[0]); }
break;
case 164:
  if (!yytrial)
{ yyval = NULL; }
break;
case 166:
  if (!yytrial)
{ yyval = NULL; }
break;
case 168:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 169:
  if (!yytrial)
{ yyval = make_node (nod_rel_constraint, (int) 2, NULL, yyvsp[0]);}
break;
case 172:
  if (!yytrial)
{ yyval = make_node (nod_null, (int) 0, NULL); }
break;
case 173:
  if (!yytrial)
{ yyval = make_node (nod_def_constraint, (int) e_cnstr_count,
					NULL, NULL, yyvsp[-2], NULL, yyvsp[0]); }
break;
case 174:
  if (!yytrial)
{ yyval = make_node (nod_def_generator, (int) e_gen_count, yyvsp[0]); }
break;
case 175:
  if (!yytrial)
{ yyval = make_node (nod_def_role, (int) 1, yyvsp[0]); }
break;
case 176:
  if (!yytrial)
{ yyval = make_node (nod_def_collation,
						(int) e_def_coll_count, yyvsp[-5], yyvsp[-3], yyvsp[-2], make_list(yyvsp[-1]), yyvsp[0]); }
break;
case 177:
  if (!yytrial)
{ yyval = make_node(nod_collation_from, 1, yyvsp[0]); }
break;
case 178:
  if (!yytrial)
{ yyval = make_node(nod_collation_from_external, 1, yyvsp[-1]); }
break;
case 179:
  if (!yytrial)
{ yyval = NULL; }
break;
case 180:
  if (!yytrial)
{ yyval = NULL; }
break;
case 183:
  if (!yytrial)
{ yyval = make_node(nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 187:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, -TEXTTYPE_ATTR_PAD_SPACE); }
break;
case 188:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, TEXTTYPE_ATTR_PAD_SPACE); }
break;
case 189:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, -TEXTTYPE_ATTR_CASE_INSENSITIVE); }
break;
case 190:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, TEXTTYPE_ATTR_CASE_INSENSITIVE); }
break;
case 191:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, -TEXTTYPE_ATTR_ACCENT_INSENSITIVE); }
break;
case 192:
  if (!yytrial)
{ yyval = make_node(nod_collation_attr, 1, TEXTTYPE_ATTR_ACCENT_INSENSITIVE); }
break;
case 193:
  if (!yytrial)
{ yyval = NULL; }
break;
case 194:
  if (!yytrial)
{ yyval = make_node(nod_collation_specific_attr, 1,
				MAKE_constant((dsql_str*)yyvsp[0], CONSTANT_STRING)); }
break;
case 195:
  if (!yytrial)
{
			yyval = makeClassNode(FB_NEW(getPool())
					AlterCharSetNode(getPool(), toName(yyvsp[-4]), toName(yyvsp[0])));
		}
break;
case 196:
  if (!yytrial)
{ yyval = make_node (nod_def_database, (int) e_cdb_count,
				 yyvsp[-2], make_list(yyvsp[-1]), make_list (yyvsp[0]));}
break;
case 199:
  if (!yytrial)
{ yyval = (dsql_nod*) yyvsp[0]; }
break;
case 200:
  if (!yytrial)
{yyval = NULL;}
break;
case 203:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 204:
  if (!yytrial)
{ yyval = make_node (nod_page_size, 1, yyvsp[0]);}
break;
case 205:
  if (!yytrial)
{ yyval = make_node (nod_file_length, 1, yyvsp[-1]);}
break;
case 206:
  if (!yytrial)
{ yyval = make_node (nod_user_name, 1, yyvsp[0]);}
break;
case 207:
  if (!yytrial)
{ yyval = make_node (nod_password, 1, yyvsp[0]);}
break;
case 208:
  if (!yytrial)
{ yyval = make_node (nod_lc_ctype, 1, yyvsp[0]);}
break;
case 209:
  if (!yytrial)
{yyval = NULL;}
break;
case 212:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 214:
  if (!yytrial)
{ yyval = make_node (nod_dfl_charset, 1, yyvsp[0]);}
break;
case 215:
  if (!yytrial)
{ yyval = make_node (nod_list, 2,
				make_node (nod_dfl_charset, 1, yyvsp[-2]),
				make_node (nod_dfl_collate, 1, yyvsp[0]));
			}
break;
case 216:
  if (!yytrial)
{ yyval = make_node (nod_difference_file, 1, yyvsp[0]); }
break;
case 217:
  if (!yytrial)
{ lex.g_file->fil_name = (dsql_str*) yyvsp[-1];
			  yyval = (dsql_nod*) make_node (nod_file_desc, (int) 1,
						(dsql_nod*) lex.g_file); }
break;
case 218:
  if (!yytrial)
{ lex.g_file  = make_file();}
break;
case 223:
  if (!yytrial)
{ lex.g_file->fil_start = (IPTR) yyvsp[0];}
break;
case 224:
  if (!yytrial)
{ lex.g_file->fil_length = (IPTR) yyvsp[-1];}
break;
case 231:
  if (!yytrial)
{ yyval = make_flag_node (nod_def_relation, NOD_PERMANENT_TABLE,
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-1]), yyvsp[-3]); }
break;
case 232:
  if (!yytrial)
{ yyval = make_flag_node (nod_redef_relation, NOD_PERMANENT_TABLE,
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-1]), yyvsp[-3]); }
break;
case 233:
  if (!yytrial)
{ yyval = make_flag_node (nod_def_relation, (SSHORT) (IPTR) (yyvsp[0]),
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-2]), NULL); }
break;
case 234:
  if (!yytrial)
{ yyval = make_flag_node (nod_redef_relation, (SSHORT) (IPTR) (yyvsp[0]),
				(int) e_drl_count, yyvsp[-4], make_list (yyvsp[-2]), NULL); }
break;
case 235:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_GLOBAL_TEMP_TABLE_PRESERVE_ROWS; }
break;
case 236:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_GLOBAL_TEMP_TABLE_DELETE_ROWS; }
break;
case 237:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_GLOBAL_TEMP_TABLE_DELETE_ROWS; }
break;
case 238:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 239:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 240:
  if (!yytrial)
{ yyval = NULL; }
break;
case 242:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 245:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count,
					yyvsp[-4], yyvsp[-2], make_list (yyvsp[-1]), yyvsp[0], yyvsp[-3], NULL); }
break;
case 246:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count,
					yyvsp[-2], NULL, NULL, NULL, NULL, yyvsp[0]); }
break;
case 247:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count,
					yyvsp[-1], NULL, NULL, NULL, NULL, yyvsp[0]); }
break;
case 248:
  if (!yytrial)
{
				lex.g_field->fld_flags |= FLD_computed;
				yyval = make_node (nod_def_computed, 2, yyvsp[-2], yyvsp[-1]);
			}
break;
case 253:
  if (!yytrial)
{ yyval = NULL; }
break;
case 254:
  if (!yytrial)
{ yyval = make_node (nod_def_domain, (int) e_dom_count, yyvsp[0], NULL, NULL, NULL); }
break;
case 255:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 256:
  if (!yytrial)
{ yyval = NULL; }
break;
case 257:
  if (!yytrial)
{
				lex.g_field_name = yyvsp[0];
				lex.g_field = make_field (yyvsp[0]);
				yyval = (dsql_nod*) lex.g_field;
			}
break;
case 258:
  if (!yytrial)
{
				lex.g_field = make_field (yyvsp[0]);
				yyval = (dsql_nod*) lex.g_field;
			}
break;
case 259:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 260:
  if (!yytrial)
{
				((dsql_fld*) yyvsp[0])->fld_type_of_name = ((dsql_fld*) yyvsp[0])->fld_name;
				yyval = yyvsp[0];
			}
break;
case 261:
  if (!yytrial)
{
				lex.g_field = make_field(NULL);
				lex.g_field->fld_type_of_table = ((dsql_str*) yyvsp[-2]);
				lex.g_field->fld_type_of_name = ((dsql_str*) yyvsp[0])->str_data;
				yyval = (dsql_nod*) lex.g_field;
			}
break;
case 262:
  if (!yytrial)
{
				((dsql_fld*) yyvsp[0])->fld_type_of_name = ((dsql_fld*) yyvsp[0])->fld_name;
				((dsql_fld*) yyvsp[0])->fld_full_domain = true;
				yyval = yyvsp[0];
			}
break;
case 263:
  if (!yytrial)
{ lex.g_field = make_field (NULL);
			  yyval = (dsql_nod*) lex.g_field; }
break;
case 270:
  if (!yytrial)
{ yyval = NULL; }
break;
case 273:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 274:
  if (!yytrial)
{ yyval = make_node (nod_rel_constraint, (int) 2, yyvsp[-1], yyvsp[0]);}
break;
case 277:
  if (!yytrial)
{ yyval = make_node (nod_foreign, (int) e_for_count,
						make_node (nod_list, (int) 1, lex.g_field_name), yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 278:
  if (!yytrial)
{ yyval = make_node (nod_unique, 2, NULL, yyvsp[0]); }
break;
case 279:
  if (!yytrial)
{ yyval = make_node (nod_primary, (int) e_pri_count, NULL, yyvsp[0]); }
break;
case 280:
  if (!yytrial)
{ yyval = make_node (nod_rel_constraint, (int) 2, yyvsp[-1], yyvsp[0]);}
break;
case 281:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 282:
  if (!yytrial)
{ yyval = NULL; }
break;
case 287:
  if (!yytrial)
{ yyval = make_node (nod_unique, 2, yyvsp[-1], yyvsp[0]); }
break;
case 288:
  if (!yytrial)
{ yyval = make_node (nod_primary, (int) e_pri_count, yyvsp[-1], yyvsp[0]); }
break;
case 289:
  if (!yytrial)
{ yyval = make_node (nod_foreign, (int) e_for_count, yyvsp[-5], yyvsp[-3],
					 yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 290:
  if (!yytrial)
{ yyval = make_node (nod_def_index, (int) e_idx_count,
					NULL, yyvsp[-2], yyvsp[0], NULL, NULL); }
break;
case 291:
  if (!yytrial)
{ yyval = make_node (nod_def_index, (int) e_idx_count,
					NULL, NULL, NULL, NULL, NULL); }
break;
case 292:
  if (!yytrial)
{ yyval = make_node (nod_ref_upd_del, (int) e_ref_upd_del_count, yyvsp[0], NULL);}
break;
case 293:
  if (!yytrial)
{ yyval = make_node (nod_ref_upd_del, (int) e_ref_upd_del_count, NULL, yyvsp[0]);}
break;
case 294:
  if (!yytrial)
{ yyval = make_node (nod_ref_upd_del, (int) e_ref_upd_del_count, yyvsp[0], yyvsp[-1]); }
break;
case 295:
  if (!yytrial)
{ yyval = make_node (nod_ref_upd_del, (int) e_ref_upd_del_count, yyvsp[-1], yyvsp[0]);}
break;
case 296:
  if (!yytrial)
{ yyval = NULL;}
break;
case 297:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 298:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 299:
  if (!yytrial)
{ yyval = make_flag_node (nod_ref_trig_action,
			 REF_ACTION_CASCADE, (int) e_ref_trig_action_count, NULL);}
break;
case 300:
  if (!yytrial)
{ yyval = make_flag_node (nod_ref_trig_action,
			 REF_ACTION_SET_DEFAULT, (int) e_ref_trig_action_count, NULL);}
break;
case 301:
  if (!yytrial)
{ yyval = make_flag_node (nod_ref_trig_action,
			 REF_ACTION_SET_NULL, (int) e_ref_trig_action_count, NULL);}
break;
case 302:
  if (!yytrial)
{ yyval = make_flag_node (nod_ref_trig_action,
			 REF_ACTION_NONE, (int) e_ref_trig_action_count, NULL);}
break;
case 303:
  if (!yytrial)
{ yyval = make_node (nod_def_procedure,
						(int) e_prc_count, yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 304:
  if (!yytrial)
{ yyval = make_node (nod_redef_procedure,
						(int) e_prc_count, yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 305:
  if (!yytrial)
{ yyval = make_node (nod_replace_procedure,
						(int) e_prc_count, yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 306:
  if (!yytrial)
{ yyval = make_node (nod_mod_procedure,
						(int) e_prc_count, yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 307:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 308:
  if (!yytrial)
{ yyval = NULL; }
break;
case 309:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 310:
  if (!yytrial)
{ yyval = NULL; }
break;
case 312:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 313:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count,
				yyvsp[-3], yyvsp[0], NULL, yyvsp[-1], NULL, NULL); }
break;
case 315:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 316:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count,
				yyvsp[-2], NULL, NULL, yyvsp[0], NULL, NULL); }
break;
case 317:
  if (!yytrial)
{ yyval = make_node (nod_def_default, (int) e_dft_count, yyvsp[-1], yyvsp[0]); }
break;
case 318:
  if (!yytrial)
{ yyval = make_node (nod_def_default, (int) e_dft_count, yyvsp[-1], yyvsp[0]); }
break;
case 319:
  if (!yytrial)
{ yyval = NULL; }
break;
case 320:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 321:
  if (!yytrial)
{ yyval = NULL; }
break;
case 323:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 324:
  if (!yytrial)
{
				yyval = yyvsp[-1];
				yyval->nod_line = (IPTR) yyvsp[-5];
				yyval->nod_column = (IPTR) yyvsp[-4];
			}
break;
case 327:
  if (!yytrial)
{ yyval = make_node (nod_def_field, (int) e_dfl_count,
				yyvsp[-3], yyvsp[0], NULL, yyvsp[-1], NULL, NULL); }
break;
case 328:
  if (!yytrial)
{ yyval = NULL; }
break;
case 329:
  if (!yytrial)
{ yyval = NULL; }
break;
case 330:
  if (!yytrial)
{ yyval = make_flag_node (nod_cursor, NOD_CURSOR_EXPLICIT,
				(int) e_cur_count, yyvsp[-5], yyvsp[-1], NULL, NULL); }
break;
case 333:
  if (!yytrial)
{
				yyval = make_node (nod_src_info, e_src_info_count, yyvsp[-4], yyvsp[-3], yyvsp[-1]);
			}
break;
case 334:
  if (!yytrial)
{ yyval = make_node (nod_block, (int) e_blk_count, make_list (yyvsp[0]), NULL); }
break;
case 335:
  if (!yytrial)
{ yyval = make_node (nod_block, (int) e_blk_count, make_list (yyvsp[-1]), make_list (yyvsp[0])); }
break;
case 336:
  if (!yytrial)
{ yyval = make_node (nod_block, (int) e_blk_count, NULL, NULL);}
break;
case 338:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 339:
  if (!yytrial)
{
				yyval = make_node (nod_src_info, e_src_info_count, yyvsp[-3], yyvsp[-2], yyvsp[-1]);
			}
break;
case 340:
  if (!yytrial)
{
				yyval = make_node (nod_src_info, e_src_info_count, yyvsp[-2], yyvsp[-1], yyvsp[0]);
			}
break;
case 341:
  if (!yytrial)
{ yyval = (dsql_nod*) (IPTR) lex.lines_bk; }
break;
case 342:
  if (!yytrial)
{
			const USHORT column = (lex.last_token_bk - lex.line_start_bk + 1);
			yyval = (dsql_nod*) (IPTR) column;
		}
break;
case 359:
  if (!yytrial)
{ yyval = make_node (nod_return, (int) e_rtn_count, NULL); }
break;
case 360:
  if (!yytrial)
{ yyval = make_node (nod_exit, 0, NULL); }
break;
case 366:
  if (!yytrial)
{
			InAutonomousTransactionNode* node = FB_NEW(getPool())
				InAutonomousTransactionNode(getPool());
			node->dsqlAction = yyvsp[0];
			yyval = makeClassNode(node);
		}
break;
case 367:
  if (!yytrial)
{ yyval = make_node (nod_exception_stmt, (int) e_xcp_count, yyvsp[0], NULL); }
break;
case 368:
  if (!yytrial)
{ yyval = make_node (nod_exception_stmt, (int) e_xcp_count, yyvsp[-1], yyvsp[0]); }
break;
case 369:
  if (!yytrial)
{ yyval = make_node (nod_exception_stmt, (int) e_xcp_count, NULL, NULL); }
break;
case 370:
  if (!yytrial)
{ yyval = make_node (nod_for_select, (int) e_flp_count, yyvsp[-5],
					  make_list (yyvsp[-3]), yyvsp[-2], yyvsp[0], yyvsp[-7]); }
break;
case 371:
  if (!yytrial)
{
			yyval = make_node (nod_exec_stmt, int (e_exec_stmt_count),
					(yyvsp[-1])->nod_arg[0], (yyvsp[-1])->nod_arg[1], NULL, NULL, NULL, make_list(yyvsp[0]), NULL, NULL, NULL, NULL, NULL, NULL);
		}
break;
case 372:
  if (!yytrial)
{
			yyval = make_node (nod_exec_stmt, int (e_exec_stmt_count),
					(yyvsp[-3])->nod_arg[0], (yyvsp[-3])->nod_arg[1], make_list(yyvsp[0]), NULL, NULL, make_list(yyvsp[-2]), NULL, NULL, NULL, NULL, NULL, NULL);
		}
break;
case 373:
  if (!yytrial)
{
			yyval = make_node (nod_exec_stmt, int (e_exec_stmt_count),
					(yyvsp[-5])->nod_arg[0], (yyvsp[-5])->nod_arg[1], make_list(yyvsp[-2]), yyvsp[0], yyvsp[-9], make_list(yyvsp[-4]), NULL, NULL, NULL, NULL, NULL, NULL);
		}
break;
case 374:
  if (!yytrial)
{ yyval = make_node (nod_exec_stmt_inputs, e_exec_stmt_inputs_count, yyvsp[0], NULL); }
break;
case 375:
  if (!yytrial)
{ yyval = make_node (nod_exec_stmt_inputs, e_exec_stmt_inputs_count, yyvsp[-4], make_list (yyvsp[-1])); }
break;
case 376:
  if (!yytrial)
{ yyval = make_node (nod_exec_stmt_inputs, e_exec_stmt_inputs_count, yyvsp[-4], make_list (yyvsp[-1])); }
break;
case 378:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 379:
  if (!yytrial)
{ yyval = make_node (nod_named_param, e_named_param_count, yyvsp[-2], yyvsp[0]); }
break;
case 381:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 382:
  if (!yytrial)
{ yyval = make_node (nod_named_param, e_named_param_count, NULL, yyvsp[0]); }
break;
case 384:
  if (!yytrial)
{ yyval = NULL; }
break;
case 385:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 393:
  if (!yytrial)
{ yyval = make_node (nod_exec_stmt_datasrc, 1, yyvsp[0]); }
break;
case 394:
  if (!yytrial)
{ yyval = make_node (nod_exec_stmt_datasrc, 1, yyvsp[0]); }
break;
case 395:
  if (!yytrial)
{ yyval = make_node (nod_exec_stmt_user, 1, yyvsp[0]); }
break;
case 396:
  if (!yytrial)
{ yyval = make_node (nod_exec_stmt_pwd, 1, yyvsp[0]); }
break;
case 397:
  if (!yytrial)
{ yyval = make_node (nod_exec_stmt_role, 1, yyvsp[0]); }
break;
case 398:
  if (!yytrial)
{ yyval = make_flag_node(nod_tran_params, NOD_TRAN_AUTONOMOUS, 1, NULL); }
break;
case 399:
  if (!yytrial)
{ yyval = make_flag_node(nod_tran_params, NOD_TRAN_COMMON, 1, NULL); }
break;
case 400:
  if (!yytrial)
{ yyval = make_node (nod_exec_stmt_privs, 1, NULL); }
break;
case 401:
  if (!yytrial)
{ yyval = make_node (nod_if, (int) e_if_count, yyvsp[-5], yyvsp[-2], yyvsp[0]); }
break;
case 402:
  if (!yytrial)
{ yyval = make_node (nod_if, (int) e_if_count, yyvsp[-3], yyvsp[0], NULL); }
break;
case 403:
  if (!yytrial)
{ yyval = make_node (nod_post, (int) e_pst_count, yyvsp[-1], yyvsp[0]); }
break;
case 404:
  if (!yytrial)
{ yyval = NULL; }
break;
case 405:
  if (!yytrial)
{ yyval = make_node (nod_for_select, (int) e_flp_count, yyvsp[-2],
					  make_list (yyvsp[0]), NULL, NULL, NULL); }
break;
case 406:
  if (!yytrial)
{ yyval = make_node (nod_var_name, (int) e_vrn_count,
							yyvsp[0]); }
break;
case 409:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 410:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 411:
  if (!yytrial)
{ yyval = make_node (nod_while, (int) e_while_count, yyvsp[-3], yyvsp[0], yyvsp[-6]); }
break;
case 412:
  if (!yytrial)
{ yyval = make_node (nod_label, (int) e_label_count, yyvsp[-1], NULL); }
break;
case 413:
  if (!yytrial)
{ yyval = NULL; }
break;
case 414:
  if (!yytrial)
{ yyval = make_node (nod_breakleave, (int) e_breakleave_count, NULL); }
break;
case 415:
  if (!yytrial)
{ yyval = make_node (nod_breakleave, (int) e_breakleave_count, NULL); }
break;
case 416:
  if (!yytrial)
{ yyval = make_node (nod_breakleave, (int) e_breakleave_count,
				make_node (nod_label, (int) e_label_count, yyvsp[0], NULL)); }
break;
case 417:
  if (!yytrial)
{ yyval = make_flag_node (nod_cursor, NOD_CURSOR_FOR,
				(int) e_cur_count, yyvsp[0], NULL, NULL, NULL); }
break;
case 418:
  if (!yytrial)
{ yyval = NULL; }
break;
case 420:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 421:
  if (!yytrial)
{ yyval = make_node (nod_on_error, (int) e_err_count,
					make_list (yyvsp[-2]), yyvsp[0]); }
break;
case 423:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 424:
  if (!yytrial)
{ yyval = make_node (nod_sqlcode, 1, yyvsp[0]); }
break;
case 425:
  if (!yytrial)
{ yyval = make_node (nod_gdscode, 1, yyvsp[0]); }
break;
case 426:
  if (!yytrial)
{ yyval = make_node (nod_exception, 1, yyvsp[0]); }
break;
case 427:
  if (!yytrial)
{ yyval = make_node (nod_default, 1, NULL); }
break;
case 431:
  if (!yytrial)
{ yyval = make_node (nod_cursor_open, (int) e_cur_stmt_count, yyvsp[0], NULL, NULL); }
break;
case 432:
  if (!yytrial)
{ yyval = make_node (nod_cursor_close, (int) e_cur_stmt_count, yyvsp[0], NULL, NULL); }
break;
case 433:
  if (!yytrial)
{ yyval = make_node (nod_cursor_fetch, (int) e_cur_stmt_count, yyvsp[-2], yyvsp[-3], make_list (yyvsp[0])); }
break;
case 434:
  if (!yytrial)
{ yyval = NULL; }
break;
case 435:
  if (!yytrial)
{ yyval = make_node (nod_exec_procedure, (int) e_exe_count,
					yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 436:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 437:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 438:
  if (!yytrial)
{ yyval = NULL; }
break;
case 439:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 440:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 441:
  if (!yytrial)
{ yyval = NULL; }
break;
case 442:
  if (!yytrial)
{ yyval = make_node (nod_exec_block,
						  (int) e_exe_blk_count,
					          yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[0], make_node (nod_all, (int) 0, NULL)); }
break;
case 443:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 444:
  if (!yytrial)
{ yyval = NULL; }
break;
case 446:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 447:
  if (!yytrial)
{ yyval = make_node (nod_param_val, e_prm_val_count, yyvsp[-2], yyvsp[0]); }
break;
case 448:
  if (!yytrial)
{ yyval = make_node (nod_def_view, (int) e_view_count,
					  yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 449:
  if (!yytrial)
{ yyval = make_node (nod_redef_view, (int) e_view_count,
					  yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 450:
  if (!yytrial)
{ yyval = make_node (nod_replace_view, (int) e_view_count,
					  yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 451:
  if (!yytrial)
{ yyval = make_node (nod_mod_view, (int) e_view_count,
					  yyvsp[-6], yyvsp[-5], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 452:
  if (!yytrial)
{ lex.beginnings.push(lex_position()); }
break;
case 453:
  if (!yytrial)
{ lex.beginnings.push(lex.last_token); }
break;
case 454:
  if (!yytrial)
{
				const TEXT* start = lex.beginnings.pop();
				string str;
				transformString(start, lex_position() - start, str);
				yyval = (dsql_nod*) MAKE_string(str.c_str(), str.length());
			}
break;
case 455:
  if (!yytrial)
{
				const TEXT* start = lex.beginnings.pop();
				yyval = (dsql_nod*) MAKE_string(start,
					(yychar <= 0 ? lex_position() : lex.last_token) - start);
			}
break;
case 456:
  if (!yytrial)
{ yyval = make_node (nod_def_constraint, (int) e_cnstr_count,
					NULL, NULL, NULL, NULL, NULL); }
break;
case 457:
  if (!yytrial)
{ yyval = 0; }
break;
case 458:
  if (!yytrial)
{
			yyval = make_node (nod_def_trigger, (int) e_trg_count,
				yyvsp[-5], NULL, yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 459:
  if (!yytrial)
{
			yyval = make_node (nod_def_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 460:
  if (!yytrial)
{
			yyval = make_node (nod_def_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-2], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-1], yyvsp[0]);
		}
break;
case 461:
  if (!yytrial)
{
			yyval = make_node (nod_redef_trigger, (int) e_trg_count,
				yyvsp[-5], NULL, yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 462:
  if (!yytrial)
{
			yyval = make_node (nod_redef_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 463:
  if (!yytrial)
{
			yyval = make_node (nod_redef_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-2], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-1], yyvsp[0]);
		}
break;
case 464:
  if (!yytrial)
{
			yyval = make_node (nod_replace_trigger, (int) e_trg_count,
				yyvsp[-5], NULL, yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 465:
  if (!yytrial)
{
			yyval = make_node (nod_replace_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]);
		}
break;
case 466:
  if (!yytrial)
{
			yyval = make_node (nod_replace_trigger, (int) e_trg_count,
				yyvsp[-7], yyvsp[-2], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-1], yyvsp[0]);
		}
break;
case 467:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 468:
  if (!yytrial)
{ yyval = MAKE_const_slong (1); }
break;
case 469:
  if (!yytrial)
{ yyval = NULL; }
break;
case 470:
  if (!yytrial)
{ yyval = MAKE_trigger_type (yyvsp[-1], yyvsp[0]); }
break;
case 471:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 472:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_CONNECT); }
break;
case 473:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_DISCONNECT); }
break;
case 474:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_TRANS_START); }
break;
case 475:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_TRANS_COMMIT); }
break;
case 476:
  if (!yytrial)
{ yyval = MAKE_const_slong (TRIGGER_TYPE_DB | DB_TRIGGER_TRANS_ROLLBACK); }
break;
case 477:
  if (!yytrial)
{ yyval = MAKE_const_slong (0); }
break;
case 478:
  if (!yytrial)
{ yyval = MAKE_const_slong (1); }
break;
case 479:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 0, 0)); }
break;
case 480:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 0, 0)); }
break;
case 481:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 0, 0)); }
break;
case 482:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 2, 0)); }
break;
case 483:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 3, 0)); }
break;
case 484:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 1, 0)); }
break;
case 485:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 3, 0)); }
break;
case 486:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 1, 0)); }
break;
case 487:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 2, 0)); }
break;
case 488:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 2, 3)); }
break;
case 489:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (1, 3, 2)); }
break;
case 490:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 1, 3)); }
break;
case 491:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (2, 3, 1)); }
break;
case 492:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 1, 2)); }
break;
case 493:
  if (!yytrial)
{ yyval = MAKE_const_slong (trigger_type_suffix (3, 2, 1)); }
break;
case 494:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 495:
  if (!yytrial)
{ yyval = NULL; }
break;
case 496:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) e_trg_act_count, yyvsp[-1], yyvsp[0]); }
break;
case 497:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 498:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 499:
  if (!yytrial)
{ yyval = make_node (nod_mod_relation, (int) e_alt_count,
						yyvsp[-1], make_list (yyvsp[0])); }
break;
case 500:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 501:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 502:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 503:
  if (!yytrial)
{ yyval = make_node (nod_mod_database, (int) e_adb_count,
				make_list (yyvsp[0])); }
break;
case 504:
  if (!yytrial)
{ yyval = make_node (nod_mod_domain, (int) e_alt_count,
										  yyvsp[-1], make_list (yyvsp[0])); }
break;
case 505:
  if (!yytrial)
{ yyval = make_node (nod_mod_index, (int) e_mod_idx_count, yyvsp[0]); }
break;
case 506:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 507:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 508:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 509:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 510:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 512:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 513:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 514:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 515:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 516:
  if (!yytrial)
{yyval = make_node (nod_del_default, (int) 0, NULL); }
break;
case 517:
  if (!yytrial)
{ yyval = make_node (nod_delete_rel_constraint, (int) 1, NULL); }
break;
case 518:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 519:
  if (!yytrial)
{ yyval = make_node (nod_mod_domain_type, 2, yyvsp[-1]); }
break;
case 521:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 522:
  if (!yytrial)
{ yyval = make_node (nod_del_field, 2, yyvsp[-1], yyvsp[0]); }
break;
case 523:
  if (!yytrial)
{ yyval = make_node (nod_delete_rel_constraint, (int) 1, yyvsp[0]);}
break;
case 524:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 525:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 526:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_pos, 2, yyvsp[-2],
				MAKE_const_slong((IPTR) yyvsp[0])); }
break;
case 527:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_name, 2, yyvsp[-2], yyvsp[0]); }
break;
case 528:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_type, e_mod_fld_type_count, yyvsp[-2], yyvsp[0], NULL, NULL); }
break;
case 529:
  if (!yytrial)
{
				/* Due to parser hacks, we should not pass $4 (non_array_type) to make_node.*/
				yyval = make_node(nod_mod_field_type, e_mod_fld_type_count, yyvsp[-3], NULL, NULL, yyvsp[0]);
			}
break;
case 530:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_type, e_mod_fld_type_count, yyvsp[-1], NULL, NULL, yyvsp[0]); }
break;
case 531:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_type, e_mod_fld_type_count, yyvsp[-2], NULL, yyvsp[0], NULL); }
break;
case 532:
  if (!yytrial)
{ yyval = make_node(nod_mod_field_type, e_mod_fld_type_count, yyvsp[-2], NULL,
					make_node(nod_del_default, (int) 0, NULL), NULL); }
break;
case 533:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count,
						NULL, yyvsp[0]); }
break;
case 583:
  if (!yytrial)
{ yyval = NULL; }
break;
case 584:
  if (!yytrial)
{ yyval = NULL; }
break;
case 585:
  if (!yytrial)
{ yyval = NULL; }
break;
case 586:
  if (!yytrial)
{ yyval = make_node (nod_def_domain, (int) e_dom_count, yyvsp[0], NULL, NULL, NULL); }
break;
case 587:
  if (!yytrial)
{ lex.g_field_name = yyvsp[0];
			  lex.g_field = make_field (yyvsp[0]);
			  yyval = (dsql_nod*) lex.g_field; }
break;
case 588:
  if (!yytrial)
{ yyval = make_node (nod_restrict, 0, NULL); }
break;
case 589:
  if (!yytrial)
{ yyval = make_node (nod_cascade, 0, NULL); }
break;
case 590:
  if (!yytrial)
{ yyval = make_node (nod_restrict, 0, NULL); }
break;
case 591:
  if (!yytrial)
{ yyval = make_node (nod_idx_active, 1, yyvsp[-1]); }
break;
case 592:
  if (!yytrial)
{ yyval = make_node (nod_idx_inactive, 1, yyvsp[-1]); }
break;
case 593:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-3],
				MAKE_const_slong ((IPTR) yyvsp[0])); }
break;
case 594:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-3],
				MAKE_constant((dsql_str*) yyvsp[0], CONSTANT_SINT64)); }
break;
case 595:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-4],
				make_node(nod_negate, 1, MAKE_constant((dsql_str*) yyvsp[0], CONSTANT_SINT64))); }
break;
case 596:
  if (!yytrial)
{ yyval = make_node(nod_mod_udf, e_mod_udf_count, yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 597:
  if (!yytrial)
{ yyval = make_node(nod_mod_role, e_mod_role_count, NULL, yyvsp[-4], yyvsp[-3]); }
break;
case 598:
  if (!yytrial)
{ yyval = MAKE_const_slong (isc_dyn_automap_role); }
break;
case 599:
  if (!yytrial)
{ yyval = MAKE_const_slong (isc_dyn_autounmap_role); }
break;
case 600:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 601:
  if (!yytrial)
{ yyval = NULL; }
break;
case 602:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 603:
  if (!yytrial)
{ yyval = NULL; }
break;
case 604:
  if (!yytrial)
{ yyval = NULL; }
break;
case 606:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 607:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 608:
  if (!yytrial)
{ yyval = make_node (nod_difference_file, (int) 1, yyvsp[0]); }
break;
case 609:
  if (!yytrial)
{ yyval = make_node (nod_drop_difference, (int) 0, NULL); }
break;
case 610:
  if (!yytrial)
{ yyval = make_node (nod_begin_backup, (int) 0, NULL); }
break;
case 611:
  if (!yytrial)
{ yyval = make_node (nod_end_backup, (int) 0, NULL); }
break;
case 612:
  if (!yytrial)
{ yyval = make_node (nod_mod_trigger, (int) e_trg_count,
				yyvsp[-6], NULL, yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[0]); }
break;
case 614:
  if (!yytrial)
{ yyval = NULL; }
break;
case 616:
  if (!yytrial)
{ yyval = NULL; }
break;
case 617:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 618:
  if (!yytrial)
{ yyval = make_node (nod_del_exception, 1, yyvsp[0]); }
break;
case 619:
  if (!yytrial)
{ yyval = make_node (nod_del_index, (int) 1, yyvsp[0]); }
break;
case 620:
  if (!yytrial)
{ yyval = make_node (nod_del_procedure, (int) 1, yyvsp[0]); }
break;
case 621:
  if (!yytrial)
{ yyval = make_node (nod_del_relation, (int) 1, yyvsp[0]); }
break;
case 622:
  if (!yytrial)
{ yyval = make_node (nod_del_trigger, (int) 1, yyvsp[0]); }
break;
case 623:
  if (!yytrial)
{ yyval = make_node (nod_del_view, (int) 1, yyvsp[0]); }
break;
case 624:
  if (!yytrial)
{ yyval = make_node (nod_del_filter, (int) 1, yyvsp[0]); }
break;
case 625:
  if (!yytrial)
{ yyval = make_node (nod_del_domain, (int) 1, yyvsp[0]); }
break;
case 626:
  if (!yytrial)
{ yyval = make_node (nod_del_udf, (int) 1, yyvsp[0]); }
break;
case 627:
  if (!yytrial)
{ yyval = make_node (nod_del_shadow, (int) 1, yyvsp[0]); }
break;
case 628:
  if (!yytrial)
{ yyval = make_node (nod_del_role, (int) 1, yyvsp[0]); }
break;
case 629:
  if (!yytrial)
{ yyval = make_node (nod_del_generator, (int) 1, yyvsp[0]); }
break;
case 630:
  if (!yytrial)
{ yyval = make_node (nod_del_generator, (int) 1, yyvsp[0]); }
break;
case 631:
  if (!yytrial)
{ yyval = make_node (nod_del_collation, (int) 1, yyvsp[0]); }
break;
case 632:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 636:
  if (!yytrial)
{ lex.g_field->fld_not_nullable = true; }
break;
case 639:
  if (!yytrial)
{ lex.g_field->fld_type_of_name = ((dsql_str*) yyvsp[0])->str_data; }
break;
case 640:
  if (!yytrial)
{
				lex.g_field->fld_type_of_name = ((dsql_str*) yyvsp[0])->str_data;
				lex.g_field->fld_type_of_table = ((dsql_str*) yyvsp[-2]);
			}
break;
case 641:
  if (!yytrial)
{
				lex.g_field->fld_type_of_name = ((dsql_str*) yyvsp[0])->str_data;
				lex.g_field->fld_full_domain = true;
			}
break;
case 644:
  if (!yytrial)
{ lex.g_field->fld_ranges = make_list (yyvsp[-1]);
			  lex.g_field->fld_dimensions = lex.g_field->fld_ranges->nod_count / 2;
			  lex.g_field->fld_element_dtype = lex.g_field->fld_dtype;
			  yyval = yyvsp[-3]; }
break;
case 645:
  if (!yytrial)
{ lex.g_field->fld_ranges = make_list (yyvsp[-2]);
			  lex.g_field->fld_dimensions = lex.g_field->fld_ranges->nod_count / 2;
			  lex.g_field->fld_element_dtype = lex.g_field->fld_dtype;
			  yyval = yyvsp[-4]; }
break;
case 647:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 648:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] < 1)
			 		yyval = make_node (nod_list, (int) 2,
					MAKE_const_slong ((IPTR) yyvsp[0]),
					MAKE_const_slong (1));
				  else
			 		yyval = make_node (nod_list, (int) 2,
			   		MAKE_const_slong (1),
					MAKE_const_slong ((IPTR) yyvsp[0]) ); }
break;
case 649:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2,
			 	MAKE_const_slong ((IPTR) yyvsp[-2]),
				MAKE_const_slong ((IPTR) yyvsp[0])); }
break;
case 655:
  if (!yytrial)
{
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
					Arg::Gds(isc_sql_dialect_datatype_unsupport) << Arg::Num(client_dialect) <<
																	Arg::Str("BIGINT"));
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post (Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
					Arg::Gds(isc_sql_db_dialect_dtype_unsupport) << Arg::Num(db_dialect) <<
																	Arg::Str("BIGINT"));
			lex.g_field->fld_dtype = dtype_int64;
			lex.g_field->fld_length = sizeof (SINT64);
			}
break;
case 656:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_long;
			lex.g_field->fld_length = sizeof (SLONG);
			}
break;
case 657:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_short;
			lex.g_field->fld_length = sizeof (SSHORT);
			}
break;
case 658:
  if (!yytrial)
{
			stmt_ambiguous = true;
			if (client_dialect <= SQL_DIALECT_V5)
				{
				/* Post warning saying that DATE is equivalent to TIMESTAMP */
				ERRD_post_warning(Arg::Warning(isc_sqlwarn) << Arg::Num(301) <<
								  Arg::Warning(isc_dtype_renamed));
				lex.g_field->fld_dtype = dtype_timestamp;
				lex.g_field->fld_length = sizeof (GDS_TIMESTAMP);
				}
			else if (client_dialect == SQL_DIALECT_V6_TRANSITION)
				yyabandon (-104, isc_transitional_date);
			else
				{
				lex.g_field->fld_dtype = dtype_sql_date;
				lex.g_field->fld_length = sizeof (ULONG);
				}
			}
break;
case 659:
  if (!yytrial)
{
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_dialect_datatype_unsupport) << Arg::Num(client_dialect) <<
																		  Arg::Str("TIME"));
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_db_dialect_dtype_unsupport) << Arg::Num(db_dialect) <<
																		  Arg::Str("TIME"));
			lex.g_field->fld_dtype = dtype_sql_time;
			lex.g_field->fld_length = sizeof (SLONG);
			}
break;
case 660:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_timestamp;
			lex.g_field->fld_length = sizeof (GDS_TIMESTAMP);
			}
break;
case 663:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_blob;
			lex.g_field->fld_length = sizeof(ISC_QUAD);
			}
break;
case 664:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_blob;
			lex.g_field->fld_length = sizeof(ISC_QUAD);
			lex.g_field->fld_seg_length = (USHORT)(IPTR) yyvsp[-1];
			lex.g_field->fld_sub_type = 0;
			}
break;
case 665:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_blob;
			lex.g_field->fld_length = sizeof(ISC_QUAD);
			lex.g_field->fld_seg_length = (USHORT)(IPTR) yyvsp[-3];
			lex.g_field->fld_sub_type = (USHORT)(IPTR) yyvsp[-1];
			}
break;
case 666:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_blob;
			lex.g_field->fld_length = sizeof(ISC_QUAD);
			lex.g_field->fld_seg_length = 80;
			lex.g_field->fld_sub_type = (USHORT)(IPTR) yyvsp[-1];
			}
break;
case 667:
  if (!yytrial)
{
			lex.g_field->fld_seg_length = (USHORT)(IPTR) yyvsp[0];
		  	}
break;
case 668:
  if (!yytrial)
{
			lex.g_field->fld_seg_length = (USHORT) 80;
		  	}
break;
case 669:
  if (!yytrial)
{
			lex.g_field->fld_sub_type = (USHORT)(IPTR) yyvsp[0];
			}
break;
case 670:
  if (!yytrial)
{
			lex.g_field->fld_sub_type_name = yyvsp[0];
			}
break;
case 671:
  if (!yytrial)
{
			lex.g_field->fld_sub_type = (USHORT) 0;
			}
break;
case 672:
  if (!yytrial)
{
			lex.g_field->fld_character_set = yyvsp[0];
			}
break;
case 674:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_text;
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-1];
			lex.g_field->fld_flags |= FLD_national;
			}
break;
case 675:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_text;
			lex.g_field->fld_character_length = 1;
			lex.g_field->fld_flags |= FLD_national;
			}
break;
case 676:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_varying;
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-1];
			lex.g_field->fld_flags |= FLD_national;
			}
break;
case 677:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_text;
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-1];
			}
break;
case 678:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_text;
			lex.g_field->fld_character_length = 1;
			}
break;
case 679:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_varying;
			lex.g_field->fld_character_length = (USHORT)(IPTR) yyvsp[-1];
			}
break;
case 688:
  if (!yytrial)
{
			  lex.g_field->fld_sub_type = dsc_num_type_numeric;
			}
break;
case 689:
  if (!yytrial)
{
			   lex.g_field->fld_sub_type = dsc_num_type_decimal;
			   if (lex.g_field->fld_dtype == dtype_short)
				{
				lex.g_field->fld_dtype = dtype_long;
				lex.g_field->fld_length = sizeof (SLONG);
				}
			}
break;
case 690:
  if (!yytrial)
{
				lex.g_field->fld_dtype = dtype_long;
				lex.g_field->fld_length = sizeof (SLONG);
				lex.g_field->fld_precision = 9;
			}
break;
case 691:
  if (!yytrial)
{
			if ( ((IPTR) yyvsp[-1] < 1) || ((IPTR) yyvsp[-1] > 18) )
				yyabandon (-842, isc_precision_err);
				/* Precision most be between 1 and 18. */
			if ((IPTR) yyvsp[-1] > 9)
			{
				if ( ( (client_dialect <= SQL_DIALECT_V5) &&
				   (db_dialect > SQL_DIALECT_V5) ) ||
				 ( (client_dialect > SQL_DIALECT_V5) &&
				   (db_dialect <= SQL_DIALECT_V5) ) )
					ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-817) <<
							  Arg::Gds(isc_ddl_not_allowed_by_db_sql_dial) << Arg::Num(db_dialect));
				if (client_dialect <= SQL_DIALECT_V5)
				{
					lex.g_field->fld_dtype = dtype_double;
					lex.g_field->fld_length = sizeof (double);
				}
				else
				{
					if (client_dialect == SQL_DIALECT_V6_TRANSITION)
					{
						ERRD_post_warning(Arg::Warning(isc_dsql_warn_precision_ambiguous));
						ERRD_post_warning(Arg::Warning(isc_dsql_warn_precision_ambiguous1));
						ERRD_post_warning(Arg::Warning(isc_dsql_warn_precision_ambiguous2));
					}
					lex.g_field->fld_dtype = dtype_int64;
					lex.g_field->fld_length = sizeof (SINT64);
				}
			}
			else
			{
				if ((IPTR) yyvsp[-1] < 5)
				{
					lex.g_field->fld_dtype = dtype_short;
					lex.g_field->fld_length = sizeof (SSHORT);
				}
				else
				{
					lex.g_field->fld_dtype = dtype_long;
					lex.g_field->fld_length = sizeof (SLONG);
				}
			}
			lex.g_field->fld_precision = (USHORT)(IPTR) yyvsp[-1];
			}
break;
case 692:
  if (!yytrial)
{
			if ( ((IPTR) yyvsp[-3] < 1) || ((IPTR) yyvsp[-3] > 18) )
				yyabandon (-842, isc_precision_err);
				/* Precision should be between 1 and 18 */
			if (((IPTR) yyvsp[-1] > (IPTR) yyvsp[-3]) || ((IPTR) yyvsp[-1] < 0))
				yyabandon (-842, isc_scale_nogt);
				/* Scale must be between 0 and precision */
			if ((IPTR) yyvsp[-3] > 9)
			{
				if ( ( (client_dialect <= SQL_DIALECT_V5) &&
				   (db_dialect > SQL_DIALECT_V5) ) ||
				 ( (client_dialect > SQL_DIALECT_V5) &&
				   (db_dialect <= SQL_DIALECT_V5) ) )
				{
					ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-817) <<
							  Arg::Gds(isc_ddl_not_allowed_by_db_sql_dial) << Arg::Num(db_dialect));
				}
				if (client_dialect <= SQL_DIALECT_V5)
				{
					lex.g_field->fld_dtype = dtype_double;
					lex.g_field->fld_length = sizeof (double);
				}
				else
				{
					if (client_dialect == SQL_DIALECT_V6_TRANSITION)
					{
						ERRD_post_warning(Arg::Warning(isc_dsql_warn_precision_ambiguous));
						ERRD_post_warning(Arg::Warning(isc_dsql_warn_precision_ambiguous1));
						ERRD_post_warning(Arg::Warning(isc_dsql_warn_precision_ambiguous2));
					}
					/* client_dialect >= SQL_DIALECT_V6 */
					lex.g_field->fld_dtype = dtype_int64;
					lex.g_field->fld_length = sizeof (SINT64);
				}
			}
			else
			{
				if ((IPTR) yyvsp[-3] < 5)
				{
					lex.g_field->fld_dtype = dtype_short;
					lex.g_field->fld_length = sizeof (SSHORT);
				}
				else
				{
					lex.g_field->fld_dtype = dtype_long;
					lex.g_field->fld_length = sizeof (SLONG);
				}
			}
			lex.g_field->fld_precision = (USHORT)(IPTR) yyvsp[-3];
			lex.g_field->fld_scale = - (SSHORT)(IPTR) yyvsp[-1];
			}
break;
case 695:
  if (!yytrial)
{
			if ((IPTR) yyvsp[0] > 7)
				{
				lex.g_field->fld_dtype = dtype_double;
				lex.g_field->fld_length = sizeof (double);
				}
			else
				{
				lex.g_field->fld_dtype = dtype_real;
				lex.g_field->fld_length = sizeof (float);
				}
			}
break;
case 696:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_double;
			lex.g_field->fld_length = sizeof (double);
			}
break;
case 697:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_real;
			lex.g_field->fld_length = sizeof (float);
			}
break;
case 698:
  if (!yytrial)
{
			lex.g_field->fld_dtype = dtype_double;
			lex.g_field->fld_length = sizeof (double);
			}
break;
case 699:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 700:
  if (!yytrial)
{ yyval = 0; }
break;
case 704:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-2],
				MAKE_const_slong ((IPTR) yyvsp[0])); }
break;
case 705:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-2],
				MAKE_constant((dsql_str*) yyvsp[0], CONSTANT_SINT64)); }
break;
case 706:
  if (!yytrial)
{ yyval = make_node (nod_set_generator2, e_gen_id_count, yyvsp[-3],
				make_node(nod_negate, 1, MAKE_constant((dsql_str*) yyvsp[0], CONSTANT_SINT64))); }
break;
case 710:
  if (!yytrial)
{ yyval = make_node (nod_user_savepoint, 1, yyvsp[0]); }
break;
case 711:
  if (!yytrial)
{ yyval = make_node (nod_release_savepoint, 2, yyvsp[-1], yyvsp[0]); }
break;
case 712:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 713:
  if (!yytrial)
{ yyval = 0; }
break;
case 714:
  if (!yytrial)
{ yyval = make_node (nod_undo_savepoint, 1, yyvsp[0]); }
break;
case 717:
  if (!yytrial)
{ yyval = make_node (nod_commit, e_commit_count, yyvsp[0]); }
break;
case 718:
  if (!yytrial)
{ yyval = make_node (nod_rollback, e_rollback_count, yyvsp[0]); }
break;
case 721:
  if (!yytrial)
{ yyval = make_node (nod_retain, 0, NULL); }
break;
case 722:
  if (!yytrial)
{ yyval = NULL; }
break;
case 724:
  if (!yytrial)
{ yyval = NULL; }
break;
case 725:
  if (!yytrial)
{yyval = make_node (nod_trans, 1, make_list (yyvsp[0])); }
break;
case 727:
  if (!yytrial)
{ yyval = NULL; }
break;
case 729:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-1], yyvsp[0]); }
break;
case 736:
  if (!yytrial)
{ yyval = make_flag_node (nod_access, NOD_READ_ONLY, (int) 0, NULL); }
break;
case 737:
  if (!yytrial)
{ yyval = make_flag_node (nod_access, NOD_READ_WRITE, (int) 0, NULL); }
break;
case 738:
  if (!yytrial)
{ yyval = make_flag_node (nod_wait, NOD_WAIT, (int) 0, NULL); }
break;
case 739:
  if (!yytrial)
{ yyval = make_flag_node (nod_wait, NOD_NO_WAIT, (int) 0, NULL); }
break;
case 740:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 742:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 743:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_READ_COMMITTED, 1, yyvsp[0]); }
break;
case 744:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_READ_COMMITTED, 1, yyvsp[0]); }
break;
case 745:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_CONCURRENCY, 0, NULL); }
break;
case 746:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_CONSISTENCY, 0, NULL); }
break;
case 747:
  if (!yytrial)
{ yyval = make_flag_node (nod_isolation, NOD_CONSISTENCY, 0, NULL); }
break;
case 748:
  if (!yytrial)
{ yyval = make_flag_node (nod_version, NOD_VERSION, 0, NULL); }
break;
case 749:
  if (!yytrial)
{ yyval = make_flag_node (nod_version, NOD_NO_VERSION, 0, NULL); }
break;
case 750:
  if (!yytrial)
{ yyval = 0; }
break;
case 751:
  if (!yytrial)
{ yyval = make_flag_node(nod_tra_misc, NOD_NO_AUTO_UNDO, 0, NULL); }
break;
case 752:
  if (!yytrial)
{ yyval = make_flag_node(nod_tra_misc, NOD_IGNORE_LIMBO, 0, NULL); }
break;
case 753:
  if (!yytrial)
{ yyval = make_flag_node(nod_tra_misc, NOD_RESTART_REQUESTS, 0, NULL); }
break;
case 754:
  if (!yytrial)
{ yyval = make_node(nod_lock_timeout, 1, MAKE_const_slong ((IPTR) yyvsp[0])); }
break;
case 755:
  if (!yytrial)
{ yyval = make_node (nod_reserve, 1, make_list (yyvsp[0])); }
break;
case 756:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_SHARED; }
break;
case 757:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_PROTECTED; }
break;
case 758:
  if (!yytrial)
{ yyval = (dsql_nod*) 0; }
break;
case 759:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_READ; }
break;
case 760:
  if (!yytrial)
{ yyval = (dsql_nod*) NOD_WRITE; }
break;
case 762:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 763:
  if (!yytrial)
{ yyval = make_node (nod_table_lock, (int) 2, make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 764:
  if (!yytrial)
{ yyval = make_flag_node (nod_lock_mode, (SSHORT) ((SSHORT)(IPTR) yyvsp[-1] | (SSHORT)(IPTR) yyvsp[0]), (SSHORT) 0, NULL); }
break;
case 765:
  if (!yytrial)
{ yyval = 0; }
break;
case 767:
  if (!yytrial)
{ yyval = make_node (nod_list, (int) 2, yyvsp[-2], yyvsp[0]); }
break;
case 768:
  if (!yytrial)
{ yyval = make_node (nod_set_statistics, (int) e_stat_count, yyvsp[0]); }
break;
case 769:
  if (!yytrial)
{ yyval = make_node(nod_comment, e_comment_count, yyvsp[-2], NULL, NULL, yyvsp[0]); }
break;
case 770:
  if (!yytrial)
{ yyval = make_node(nod_comment, e_comment_count, yyvsp[-3], yyvsp[-2], NULL, yyvsp[0]); }
break;
case 771:
  if (!yytrial)
{ yyval = make_node(nod_comment, e_comment_count, yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[0]); }
break;
case 772:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_database); }
break;
case 773:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_domain); }
break;
case 774:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_relation); }
break;
case 775:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_view); }
break;
case 776:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_procedure); }
break;
case 777:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_trigger); }
break;
case 778:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_udf); }
break;
case 779:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_blob_filter); }
break;
case 780:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_exception); }
break;
case 781:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_generator); }
break;
case 782:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_generator); }
break;
case 783:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_index); }
break;
case 784:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_role); }
break;
case 785:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_charset); }
break;
case 786:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_collation); }
break;
case 787:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_relation); }
break;
case 788:
  if (!yytrial)
{ yyval = MAKE_const_slong(ddl_procedure); }
break;
case 789:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 791:
  if (!yytrial)
{ yyval = NULL; }
break;
case 792:
  if (!yytrial)
{ yyval = make_node (nod_select, (int) e_select_count, yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 793:
  if (!yytrial)
{ yyval = make_node (nod_for_update, (int) e_fpd_count, yyvsp[0]); }
break;
case 794:
  if (!yytrial)
{ yyval = NULL; }
break;
case 795:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 796:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 797:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 798:
  if (!yytrial)
{ yyval = NULL; }
break;
case 799:
  if (!yytrial)
{ yyval = make_node (nod_select_expr, (int) e_sel_count, yyvsp[-2], yyvsp[-1], yyvsp[0], yyvsp[-3]); }
break;
case 800:
  if (!yytrial)
{ yyval = make_flag_node (nod_with, NOD_UNION_RECURSIVE, 1, make_list(yyvsp[0])); }
break;
case 801:
  if (!yytrial)
{ yyval = make_node (nod_with, 1, make_list(yyvsp[0])); }
break;
case 802:
  if (!yytrial)
{ yyval = NULL; }
break;
case 804:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 805:
  if (!yytrial)
{ yyval = make_node (nod_derived_table, (int) e_derived_table_count, yyvsp[-1], yyvsp[-5], yyvsp[-4], NULL); }
break;
case 806:
  if (!yytrial)
{ yyval = make_flag_node (nod_select_expr, NOD_SELECT_EXPR_VALUE,
					(int) e_sel_count, yyvsp[-2], yyvsp[-1], yyvsp[0], yyvsp[-3]); }
break;
case 807:
  if (!yytrial)
{ yyval = make_flag_node (nod_select_expr, NOD_SELECT_EXPR_VALUE | NOD_SELECT_EXPR_SINGLETON,
					(int) e_sel_count, yyvsp[-2], yyvsp[-1], yyvsp[0], yyvsp[-3]); }
break;
case 809:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-3], yyvsp[0]); }
break;
case 810:
  if (!yytrial)
{ yyval = make_flag_node (nod_list, NOD_UNION_ALL, 2, yyvsp[-3], yyvsp[0]); }
break;
case 812:
  if (!yytrial)
{ yyval = make_node (nod_query_spec, (int) e_qry_count,
					yyvsp[-7], yyvsp[-6], yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 813:
  if (!yytrial)
{ yyval = make_node (nod_limit, (int) e_limit_count, yyvsp[0], yyvsp[-1]); }
break;
case 814:
  if (!yytrial)
{ yyval = make_node (nod_limit, (int) e_limit_count, NULL, yyvsp[0]); }
break;
case 815:
  if (!yytrial)
{ yyval = make_node (nod_limit, (int) e_limit_count, yyvsp[0], NULL); }
break;
case 816:
  if (!yytrial)
{ yyval = 0; }
break;
case 817:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 818:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 819:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 820:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 821:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 822:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 823:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 824:
  if (!yytrial)
{ yyval = 0; }
break;
case 825:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 826:
  if (!yytrial)
{ yyval = 0; }
break;
case 828:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 830:
  if (!yytrial)
{ yyval = make_node (nod_alias, 2, yyvsp[-2], yyvsp[0]); }
break;
case 833:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 835:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 840:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 841:
  if (!yytrial)
{ yyval = make_node(nod_derived_table, (int) e_derived_table_count, yyvsp[-4], yyvsp[-1], yyvsp[0], NULL); }
break;
case 843:
  if (!yytrial)
{ yyval = NULL; }
break;
case 844:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 845:
  if (!yytrial)
{ yyval = NULL; }
break;
case 847:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 851:
  if (!yytrial)
{ yyval = make_node (nod_join, (int) e_join_count, yyvsp[-3],
				make_node (nod_join_inner, (int) 0, NULL), yyvsp[0], NULL); }
break;
case 852:
  if (!yytrial)
{ yyval = make_node (nod_join, (int) e_join_count, yyvsp[-4], yyvsp[-2], yyvsp[0],
					make_node (nod_flag, 0, NULL)); }
break;
case 853:
  if (!yytrial)
{ yyval = make_node (nod_join, (int) e_join_count, yyvsp[-4], yyvsp[-3], yyvsp[-1], yyvsp[0]); }
break;
case 856:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 857:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 858:
  if (!yytrial)
{ yyval = make_node (nod_rel_proc_name,
					(int) e_rpn_count, yyvsp[-3], yyvsp[0], yyvsp[-2]); }
break;
case 859:
  if (!yytrial)
{ yyval = make_node (nod_rel_proc_name,
					(int) e_rpn_count, yyvsp[-1], NULL, yyvsp[0]); }
break;
case 860:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 861:
  if (!yytrial)
{ yyval = NULL; }
break;
case 863:
  if (!yytrial)
{ yyval = make_node (nod_relation_name,
						(int) e_rln_count, yyvsp[-2], yyvsp[0]); }
break;
case 864:
  if (!yytrial)
{ yyval = make_node (nod_relation_name,
						(int) e_rln_count, yyvsp[0], NULL); }
break;
case 865:
  if (!yytrial)
{ yyval = make_node (nod_join_inner, (int) 0, NULL); }
break;
case 866:
  if (!yytrial)
{ yyval = make_node (nod_join_left, (int) 0, NULL); }
break;
case 867:
  if (!yytrial)
{ yyval = make_node (nod_join_right, (int) 0, NULL); }
break;
case 868:
  if (!yytrial)
{ yyval = make_node (nod_join_full, (int) 0, NULL); }
break;
case 869:
  if (!yytrial)
{ yyval = make_node (nod_join_inner, (int) 0, NULL); }
break;
case 872:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 873:
  if (!yytrial)
{ yyval = NULL; }
break;
case 875:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 877:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 878:
  if (!yytrial)
{ yyval = NULL; }
break;
case 879:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 880:
  if (!yytrial)
{ yyval = NULL; }
break;
case 881:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 882:
  if (!yytrial)
{ yyval = NULL; }
break;
case 883:
  if (!yytrial)
{ yyval = make_node (nod_plan_expr, 2, yyvsp[-3], make_list (yyvsp[-1])); }
break;
case 884:
  if (!yytrial)
{ yyval = 0; }
break;
case 885:
  if (!yytrial)
{ yyval = make_node (nod_merge_plan, (int) 0, NULL); }
break;
case 886:
  if (!yytrial)
{ yyval = make_node (nod_merge_plan, (int) 0, NULL); }
break;
case 887:
  if (!yytrial)
{ yyval = 0; }
break;
case 888:
  if (!yytrial)
{ yyval = 0; }
break;
case 890:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 891:
  if (!yytrial)
{ yyval = make_node (nod_plan_item, 2, make_list (yyvsp[-1]), yyvsp[0]); }
break;
case 894:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-1], yyvsp[0]); }
break;
case 895:
  if (!yytrial)
{ yyval = make_node (nod_natural, (int) 0, NULL); }
break;
case 896:
  if (!yytrial)
{ yyval = make_node (nod_index, 1, make_list (yyvsp[-1])); }
break;
case 897:
  if (!yytrial)
{ yyval = make_node (nod_index_order, 2, yyvsp[-1], yyvsp[0]); }
break;
case 899:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 900:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 901:
  if (!yytrial)
{ yyval = 0; }
break;
case 902:
  if (!yytrial)
{ yyval = make_list (yyvsp[0]); }
break;
case 903:
  if (!yytrial)
{ yyval = 0; }
break;
case 905:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 906:
  if (!yytrial)
{ yyval = make_node (nod_order, (int) e_order_count, yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 907:
  if (!yytrial)
{ yyval = 0; }
break;
case 908:
  if (!yytrial)
{ yyval = make_node (nod_flag, 0, NULL); }
break;
case 909:
  if (!yytrial)
{ yyval = 0; }
break;
case 910:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 911:
  if (!yytrial)
{ yyval = 0; }
break;
case 912:
  if (!yytrial)
{ yyval = MAKE_const_slong(NOD_NULLS_FIRST); }
break;
case 913:
  if (!yytrial)
{ yyval = MAKE_const_slong(NOD_NULLS_LAST); }
break;
case 914:
  if (!yytrial)
{ yyval = make_node (nod_rows, (int) e_rows_count, NULL, yyvsp[0]); }
break;
case 915:
  if (!yytrial)
{ yyval = make_node (nod_rows, (int) e_rows_count,
				make_node (nod_subtract, 2, yyvsp[-2],
					MAKE_const_slong (1)),
				make_node (nod_add, 2,
					make_node (nod_subtract, 2, yyvsp[0], yyvsp[-2]),
					MAKE_const_slong (1))); }
break;
case 916:
  if (!yytrial)
{ yyval = NULL; }
break;
case 917:
  if (!yytrial)
{ yyval = make_node (nod_insert, (int) e_ins_count,
				yyvsp[-6], yyvsp[-5], make_list (yyvsp[-2]), NULL, yyvsp[0]); }
break;
case 918:
  if (!yytrial)
{ yyval = make_node (nod_insert, (int) e_ins_count,
				yyvsp[-3], yyvsp[-2], NULL, yyvsp[-1], yyvsp[0]); }
break;
case 919:
  if (!yytrial)
{ yyval = make_node (nod_insert, (int) e_ins_count,
				yyvsp[-3], NULL, NULL, NULL, yyvsp[0]); }
break;
case 920:
  if (!yytrial)
{
			yyval = make_node(nod_merge, e_mrg_count, yyvsp[-5], yyvsp[-3], yyvsp[-1], yyvsp[0]);
		}
break;
case 921:
  if (!yytrial)
{ yyval = make_node(nod_merge_when, e_mrg_when_count, yyvsp[-1], yyvsp[0]); }
break;
case 922:
  if (!yytrial)
{ yyval = make_node(nod_merge_when, e_mrg_when_count, yyvsp[0], yyvsp[-1]); }
break;
case 923:
  if (!yytrial)
{ yyval = make_node(nod_merge_when, e_mrg_when_count, yyvsp[0], NULL); }
break;
case 924:
  if (!yytrial)
{ yyval = make_node(nod_merge_when, e_mrg_when_count, NULL, yyvsp[0]); }
break;
case 925:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 926:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 927:
  if (!yytrial)
{ yyval = make_node(nod_merge_update, e_mrg_update_count, make_list(yyvsp[0])); }
break;
case 928:
  if (!yytrial)
{ yyval = make_node(nod_merge_insert, e_mrg_insert_count, make_list(yyvsp[-4]), make_list(yyvsp[-1])); }
break;
case 931:
  if (!yytrial)
{ yyval = make_node (nod_delete, (int) e_del_count,
				yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], NULL, yyvsp[0]); }
break;
case 932:
  if (!yytrial)
{ yyval = make_node (nod_delete, (int) e_del_count,
				yyvsp[-1], NULL, NULL, NULL, NULL, yyvsp[0], NULL); }
break;
case 935:
  if (!yytrial)
{ yyval = make_node (nod_update, (int) e_upd_count,
				yyvsp[-7], make_list (yyvsp[-5]), yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], NULL, yyvsp[0], NULL); }
break;
case 936:
  if (!yytrial)
{ yyval = make_node (nod_update, (int) e_upd_count,
				yyvsp[-3], make_list (yyvsp[-1]), NULL, NULL, NULL, NULL, yyvsp[0], NULL, NULL); }
break;
case 937:
  if (!yytrial)
{
			yyval = make_node (nod_update_or_insert, (int) e_upi_count,
				yyvsp[-7], make_list (yyvsp[-6]), make_list (yyvsp[-3]), yyvsp[-1], yyvsp[0]);
		}
break;
case 938:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 939:
  if (!yytrial)
{ yyval = NULL; }
break;
case 940:
  if (!yytrial)
{ yyval = make_node (nod_returning, (int) e_ret_count,
					make_list (yyvsp[0]), NULL); }
break;
case 941:
  if (!yytrial)
{ yyval = make_node (nod_returning, (int) e_ret_count,
					make_list (yyvsp[-2]), make_list (yyvsp[0])); }
break;
case 942:
  if (!yytrial)
{ yyval = NULL; }
break;
case 943:
  if (!yytrial)
{ yyval = make_node (nod_cursor, (int) e_cur_count, yyvsp[0], NULL, NULL, NULL); }
break;
case 945:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 946:
  if (!yytrial)
{ yyval = make_node (nod_assign, e_asgn_count, yyvsp[0], yyvsp[-2]); }
break;
case 947:
  if (!yytrial)
{ yyval = make_node (nod_assign, e_asgn_count, yyvsp[0], make_node (nod_null, 0, NULL)); }
break;
case 948:
  if (!yytrial)
{ yyval = make_node (nod_assign, e_asgn_count, yyvsp[0], make_node (nod_null, 0, NULL)); }
break;
case 949:
  if (!yytrial)
{ yyval = make_node (nod_get_segment, (int) e_blb_count, yyvsp[-4], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 950:
  if (!yytrial)
{ yyval = make_node (nod_put_segment, (int) e_blb_count, yyvsp[-4], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 951:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 952:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, NULL, yyvsp[0]); }
break;
case 953:
  if (!yytrial)
{ yyval = NULL; }
break;
case 956:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 957:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 958:
  if (!yytrial)
{ yyval = NULL; }
break;
case 959:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 962:
  if (!yytrial)
{ yyval = NULL; }
break;
case 963:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 965:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 967:
  if (!yytrial)
{ yyval = NULL; }
break;
case 968:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 970:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 972:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count,
							yyvsp[-2], yyvsp[0]); }
break;
case 973:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count,
							yyvsp[-2], NULL); }
break;
case 974:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count,
						NULL, yyvsp[0]); }
break;
case 976:
  if (!yytrial)
{ yyval = make_node (nod_field_name, (int) e_fln_count,
							yyvsp[-2], yyvsp[0]); }
break;
case 978:
  if (!yytrial)
{ yyval = make_node (nod_or, 2, yyvsp[-2], yyvsp[0]); }
break;
case 979:
  if (!yytrial)
{ yyval = make_node (nod_and, 2, yyvsp[-2], yyvsp[0]); }
break;
case 980:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, yyvsp[0]); }
break;
case 994:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 995:
  if (!yytrial)
{ yyval = make_node (nod_eql, 2, yyvsp[-2], yyvsp[0]); }
break;
case 996:
  if (!yytrial)
{ yyval = make_node (nod_lss, 2, yyvsp[-2], yyvsp[0]); }
break;
case 997:
  if (!yytrial)
{ yyval = make_node (nod_gtr, 2, yyvsp[-2], yyvsp[0]); }
break;
case 998:
  if (!yytrial)
{ yyval = make_node (nod_geq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 999:
  if (!yytrial)
{ yyval = make_node (nod_leq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1000:
  if (!yytrial)
{ yyval = make_node (nod_leq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1001:
  if (!yytrial)
{ yyval = make_node (nod_geq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1002:
  if (!yytrial)
{ yyval = make_node (nod_neq, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1003:
  if (!yytrial)
{ yyval = make_node (nod_eql_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1004:
  if (!yytrial)
{ yyval = make_node (nod_lss_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1005:
  if (!yytrial)
{ yyval = make_node (nod_gtr_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1006:
  if (!yytrial)
{ yyval = make_node (nod_geq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1007:
  if (!yytrial)
{ yyval = make_node (nod_leq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1008:
  if (!yytrial)
{ yyval = make_node (nod_leq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1009:
  if (!yytrial)
{ yyval = make_node (nod_geq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1010:
  if (!yytrial)
{ yyval = make_node (nod_neq_all, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1011:
  if (!yytrial)
{ yyval = make_node (nod_eql_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1012:
  if (!yytrial)
{ yyval = make_node (nod_lss_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1013:
  if (!yytrial)
{ yyval = make_node (nod_gtr_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1014:
  if (!yytrial)
{ yyval = make_node (nod_geq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1015:
  if (!yytrial)
{ yyval = make_node (nod_leq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1016:
  if (!yytrial)
{ yyval = make_node (nod_leq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1017:
  if (!yytrial)
{ yyval = make_node (nod_geq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1018:
  if (!yytrial)
{ yyval = make_node (nod_neq_any, 2, yyvsp[-5], yyvsp[-1]); }
break;
case 1021:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_equiv, 2, yyvsp[-4], yyvsp[0])); }
break;
case 1022:
  if (!yytrial)
{ yyval = make_node (nod_equiv, 2, yyvsp[-5], yyvsp[0]); }
break;
case 1023:
  if (!yytrial)
{ yyval = make_node (nod_between, 3, yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 1024:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_between,
						3, yyvsp[-5], yyvsp[-2], yyvsp[0])); }
break;
case 1025:
  if (!yytrial)
{ yyval = make_node (nod_like, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1026:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_like, 2, yyvsp[-3], yyvsp[0])); }
break;
case 1027:
  if (!yytrial)
{ yyval = make_node (nod_like, 3, yyvsp[-4], yyvsp[-2], yyvsp[0]); }
break;
case 1028:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_like,
						3, yyvsp[-5], yyvsp[-2], yyvsp[0])); }
break;
case 1029:
  if (!yytrial)
{ yyval = make_node (nod_eql_any, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1030:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_eql_any, 2, yyvsp[-3], yyvsp[0])); }
break;
case 1031:
  if (!yytrial)
{ yyval = make_node (nod_containing, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1032:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_containing, 2, yyvsp[-3], yyvsp[0])); }
break;
case 1033:
  if (!yytrial)
{ yyval = make_node(nod_similar, e_similar_count, yyvsp[-3], yyvsp[0], NULL); }
break;
case 1034:
  if (!yytrial)
{ yyval = make_node(nod_not, 1, make_node(nod_similar, e_similar_count, yyvsp[-4], yyvsp[0], NULL)); }
break;
case 1035:
  if (!yytrial)
{ yyval = make_node(nod_similar, e_similar_count, yyvsp[-5], yyvsp[-2], yyvsp[0]); }
break;
case 1036:
  if (!yytrial)
{ yyval = make_node(nod_not, 1, make_node(nod_similar, e_similar_count, yyvsp[-6], yyvsp[-2], yyvsp[0])); }
break;
case 1037:
  if (!yytrial)
{ yyval = make_node (nod_starting, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1038:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_starting, 2, yyvsp[-3], yyvsp[0])); }
break;
case 1039:
  if (!yytrial)
{ yyval = make_node (nod_starting, 2, yyvsp[-3], yyvsp[0]); }
break;
case 1040:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_starting, 2, yyvsp[-4], yyvsp[0])); }
break;
case 1041:
  if (!yytrial)
{ yyval = make_node (nod_exists, 1, yyvsp[-1]); }
break;
case 1042:
  if (!yytrial)
{ yyval = make_node (nod_singular, 1, yyvsp[-1]); }
break;
case 1043:
  if (!yytrial)
{ yyval = make_node (nod_missing, 1, yyvsp[-2]); }
break;
case 1044:
  if (!yytrial)
{ yyval = make_node (nod_not, 1, make_node (nod_missing, 1, yyvsp[-3])); }
break;
case 1045:
  if (!yytrial)
{ yyval = make_node (nod_eql, 2,
					make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_trigger_action)),
						MAKE_const_slong (1)); }
break;
case 1046:
  if (!yytrial)
{ yyval = make_node (nod_eql, 2,
					make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_trigger_action)),
						MAKE_const_slong (2)); }
break;
case 1047:
  if (!yytrial)
{ yyval = make_node (nod_eql, 2,
					make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_trigger_action)),
						MAKE_const_slong (3)); }
break;
case 1049:
  if (!yytrial)
{ yyval = make_list (yyvsp[-1]); }
break;
case 1050:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 1051:
  if (!yytrial)
{ yyval = make_node(nod_add_user, (int) e_user_count, yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 1052:
  if (!yytrial)
{ yyval = make_node(nod_mod_user, (int) e_user_count, yyvsp[-5], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 1053:
  if (!yytrial)
{ yyval = make_node(nod_mod_user, (int) e_user_count, yyvsp[-6], yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[-1], yyvsp[0]); }
break;
case 1054:
  if (!yytrial)
{ yyval = make_node(nod_del_user, (int) e_del_user_count, yyvsp[0]); }
break;
case 1055:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1056:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1057:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1058:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1059:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1060:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1061:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1062:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1063:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1064:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1065:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1066:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1067:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1068:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1069:
  if (!yytrial)
{ yyval = (dsql_nod*) MAKE_cstring("0"); }
break;
case 1070:
  if (!yytrial)
{ yyval = (dsql_nod*) MAKE_cstring("1"); }
break;
case 1081:
  if (!yytrial)
{ yyval = make_node (nod_negate, 1, yyvsp[0]); }
break;
case 1082:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1083:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_add2, 2, yyvsp[-2], yyvsp[0]);
			  else
				  yyval = make_node (nod_add, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 1084:
  if (!yytrial)
{ yyval = make_node (nod_concatenate, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1085:
  if (!yytrial)
{ yyval = make_node (nod_collate, (int) e_coll_count, (dsql_nod*) yyvsp[0], yyvsp[-2]); }
break;
case 1086:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_subtract2, 2, yyvsp[-2], yyvsp[0]);
			  else
				  yyval = make_node (nod_subtract, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 1087:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				   yyval = make_node (nod_multiply2, 2, yyvsp[-2], yyvsp[0]);
			  else
				   yyval = make_node (nod_multiply, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 1088:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_divide2, 2, yyvsp[-2], yyvsp[0]);
			  else
				  yyval = make_node (nod_divide, 2, yyvsp[-2], yyvsp[0]);
			}
break;
case 1089:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 1090:
  if (!yytrial)
{ yyval = yyvsp[-1]; }
break;
case 1094:
  if (!yytrial)
{ yyval = make_node (nod_dbkey, 1, NULL); }
break;
case 1095:
  if (!yytrial)
{ yyval = make_node (nod_dbkey, 1, yyvsp[-2]); }
break;
case 1096:
  if (!yytrial)
{
			  yyval = make_node (nod_dom_value, 0, NULL);
						}
break;
case 1099:
  if (!yytrial)
{
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
			{
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_dialect_datatype_unsupport) << Arg::Num(client_dialect) <<
						  												  Arg::Str("DATE"));
			}
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
			{
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_db_dialect_dtype_unsupport) << Arg::Num(db_dialect) <<
						  												  Arg::Str("DATE"));
			}
			yyval = make_node (nod_current_date, 0, NULL);
			}
break;
case 1100:
  if (!yytrial)
{
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
			{
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_dialect_datatype_unsupport) << Arg::Num(client_dialect) <<
						  												  Arg::Str("TIME"));
			}
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
			{
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_db_dialect_dtype_unsupport) << Arg::Num(db_dialect) <<
						  												  Arg::Str("TIME"));
			}
			yyval = make_node (nod_current_time, 1, yyvsp[0]);
			}
break;
case 1101:
  if (!yytrial)
{ yyval = make_node (nod_current_timestamp, 1, yyvsp[0]); }
break;
case 1102:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[-1]); }
break;
case 1103:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1104:
  if (!yytrial)
{ yyval = make_node (nod_array, (int) e_ary_count, yyvsp[-3], make_list (yyvsp[-1])); }
break;
case 1106:
  if (!yytrial)
{ yyval = NULL; }
break;
case 1108:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1110:
  if (!yytrial)
{ yyval = make_node (nod_negate, 1, yyvsp[0]); }
break;
case 1111:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_STRING); }
break;
case 1112:
  if (!yytrial)
{ yyval = MAKE_const_slong ((IPTR) yyvsp[0]); }
break;
case 1113:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_DOUBLE); }
break;
case 1114:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_SINT64); }
break;
case 1115:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_SINT64); }
break;
case 1117:
  if (!yytrial)
{ yyval = MAKE_str_constant ((dsql_str*) yyvsp[0], lex.att_charset); }
break;
case 1118:
  if (!yytrial)
{
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
			{
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_dialect_datatype_unsupport) << Arg::Num(client_dialect) <<
						  												  Arg::Str("DATE"));
			}
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
			{
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_db_dialect_dtype_unsupport) << Arg::Num(db_dialect) <<
						  												  Arg::Str("DATE"));
			}
			yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_DATE);
			}
break;
case 1119:
  if (!yytrial)
{
			if (client_dialect < SQL_DIALECT_V6_TRANSITION)
			{
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_dialect_datatype_unsupport) << Arg::Num(client_dialect) <<
						  												  Arg::Str("TIME"));
			}
			if (db_dialect < SQL_DIALECT_V6_TRANSITION)
			{
				ERRD_post(Arg::Gds(isc_sqlerr) << Arg::Num(-104) <<
						  Arg::Gds(isc_sql_db_dialect_dtype_unsupport) << Arg::Num(db_dialect) <<
						  												  Arg::Str("TIME"));
			}
			yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_TIME);
			}
break;
case 1120:
  if (!yytrial)
{ yyval = MAKE_constant ((dsql_str*) yyvsp[0], CONSTANT_TIMESTAMP); }
break;
case 1121:
  if (!yytrial)
{ yyval = make_parameter (); }
break;
case 1122:
  if (!yytrial)
{ yyval = make_node (nod_user_name, 0, NULL); }
break;
case 1123:
  if (!yytrial)
{ yyval = make_node (nod_user_name, 0, NULL); }
break;
case 1124:
  if (!yytrial)
{ yyval = make_node (nod_current_role, 0, NULL); }
break;
case 1125:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_connection_id)); }
break;
case 1126:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_transaction_id)); }
break;
case 1127:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_gdscode)); }
break;
case 1128:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_sqlcode)); }
break;
case 1129:
  if (!yytrial)
{ yyval = make_node (nod_internal_info, (int) e_internal_info_count,
						MAKE_const_slong (internal_rows_affected)); }
break;
case 1130:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1131:
  if (!yytrial)
{
			dsql_str* str = (dsql_str*) yyvsp[0];
			str->str_charset = (TEXT*) yyvsp[-1];
			if (str->type == dsql_str::TYPE_SIMPLE)
			{
				StrMark* mark = strMarks.get(str);
				fb_assert(mark);
				if (mark)
					mark->introduced = true;
			}
			yyval = yyvsp[0];
		}
break;
case 1133:
  if (!yytrial)
{ yyval = (dsql_nod*) - (IPTR) yyvsp[0]; }
break;
case 1134:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] > SHRT_POS_MAX)
				yyabandon (-842, isc_expec_short);
				/* Short integer expected */
			  yyval = yyvsp[0];}
break;
case 1135:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] > SHRT_NEG_MAX)
				yyabandon (-842, isc_expec_short);
				/* Short integer expected */
			  yyval = yyvsp[0];}
break;
case 1136:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] == 0)
				yyabandon (-842, isc_expec_positive);
				/* Positive number expected */
			  yyval = yyvsp[0];}
break;
case 1137:
  if (!yytrial)
{ if ((IPTR) yyvsp[0] > SHRT_UNSIGNED_MAX)
				yyabandon (-842, isc_expec_ushort);
				/* Unsigned short integer expected */
			  yyval = yyvsp[0];}
break;
case 1139:
  if (!yytrial)
{ yyval = (dsql_nod*) - (IPTR) yyvsp[0]; }
break;
case 1140:
  if (!yytrial)
{ yyval = yyvsp[0];}
break;
case 1146:
  if (!yytrial)
{ yyval = make_node (nod_agg_count, 0, NULL); }
break;
case 1147:
  if (!yytrial)
{ yyval = make_node (nod_agg_count, 1, yyvsp[-1]); }
break;
case 1148:
  if (!yytrial)
{ yyval = make_flag_node (nod_agg_count,
									   NOD_AGG_DISTINCT, 1, yyvsp[-1]); }
break;
case 1149:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_agg_total2, 1, yyvsp[-1]);
			  else
				  yyval = make_node (nod_agg_total, 1, yyvsp[-1]);
			}
break;
case 1150:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_flag_node (nod_agg_total2,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			  else
				  yyval = make_flag_node (nod_agg_total,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			}
break;
case 1151:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_agg_average2, 1, yyvsp[-1]);
			  else
				  yyval = make_node (nod_agg_average, 1, yyvsp[-1]);
			}
break;
case 1152:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_flag_node (nod_agg_average2,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			  else
				  yyval = make_flag_node (nod_agg_average,
						   NOD_AGG_DISTINCT, 1, yyvsp[-1]);
			}
break;
case 1153:
  if (!yytrial)
{ yyval = make_node (nod_agg_min, 1, yyvsp[-1]); }
break;
case 1154:
  if (!yytrial)
{ yyval = make_node (nod_agg_min, 1, yyvsp[-1]); }
break;
case 1155:
  if (!yytrial)
{ yyval = make_node (nod_agg_max, 1, yyvsp[-1]); }
break;
case 1156:
  if (!yytrial)
{ yyval = make_node (nod_agg_max, 1, yyvsp[-1]); }
break;
case 1157:
  if (!yytrial)
{ yyval = make_node (nod_agg_list, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 1158:
  if (!yytrial)
{ yyval = make_flag_node (nod_agg_list, NOD_AGG_DISTINCT, 2, yyvsp[-2], yyvsp[-1]); }
break;
case 1159:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1160:
  if (!yytrial)
{ yyval = MAKE_str_constant (MAKE_cstring(","), lex.att_charset); }
break;
case 1163:
  if (!yytrial)
{ yyval = make_node (nod_extract, (int) e_extract_count, yyvsp[-3], yyvsp[-1]); }
break;
case 1167:
  if (!yytrial)
{ yyval = make_node(nod_strlen, (int) e_strlen_count,
					MAKE_const_slong(blr_strlen_bit), yyvsp[-1]); }
break;
case 1168:
  if (!yytrial)
{ yyval = make_node(nod_strlen, (int) e_strlen_count,
					MAKE_const_slong(blr_strlen_char), yyvsp[-1]); }
break;
case 1169:
  if (!yytrial)
{ yyval = make_node(nod_strlen, (int) e_strlen_count,
					MAKE_const_slong(blr_strlen_char), yyvsp[-1]); }
break;
case 1170:
  if (!yytrial)
{ yyval = make_node(nod_strlen, (int) e_strlen_count,
					MAKE_const_slong(blr_strlen_octet), yyvsp[-1]); }
break;
case 1171:
  if (!yytrial)
{ yyval = make_node(nod_sys_function, e_sysfunc_count, yyvsp[-3], make_list(yyvsp[-1])); }
break;
case 1220:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-6], make_node(nod_list, 3, yyvsp[-4], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1221:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-7], make_node(nod_list, 3, yyvsp[-3], yyvsp[-5], yyvsp[-1]));
		}
break;
case 1222:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-7], make_node(nod_list, 3, yyvsp[-5], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1223:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-7], make_node(nod_list, 3, yyvsp[-5], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1224:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-9], make_node(nod_list, 4, yyvsp[-7], yyvsp[-5], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1225:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-7], make_node(nod_list, 3, yyvsp[-5], yyvsp[-3], yyvsp[-1]));
		}
break;
case 1226:
  if (!yytrial)
{
			yyval = make_flag_node(nod_sys_function, NOD_SPECIAL_SYNTAX, e_sysfunc_count,
				yyvsp[-5], make_node(nod_list, 2, yyvsp[-3], yyvsp[-1]));
		}
break;
case 1229:
  if (!yytrial)
{ yyval = make_node (nod_upcase, 1, yyvsp[-1]); }
break;
case 1230:
  if (!yytrial)
{ yyval = make_node (nod_lowcase, 1, yyvsp[-1]); }
break;
case 1231:
  if (!yytrial)
{ yyval = make_node (nod_substr, (int) e_substr_count, yyvsp[-4],
				make_node (nod_subtract, 2, yyvsp[-2],
					MAKE_const_slong (1)), yyvsp[-1]); }
break;
case 1232:
  if (!yytrial)
{ yyval = yyvsp[0]; }
break;
case 1233:
  if (!yytrial)
{ yyval = MAKE_const_slong (SHRT_POS_MAX); }
break;
case 1234:
  if (!yytrial)
{ yyval = make_node (nod_trim, (int) e_trim_count, yyvsp[-4], yyvsp[-3], yyvsp[-1]); }
break;
case 1235:
  if (!yytrial)
{ yyval = make_node (nod_trim, (int) e_trim_count,
				MAKE_const_slong (blr_trim_both), yyvsp[-3], yyvsp[-1]); }
break;
case 1236:
  if (!yytrial)
{ yyval = make_node (nod_trim, (int) e_trim_count, yyvsp[-3], NULL, yyvsp[-1]); }
break;
case 1237:
  if (!yytrial)
{ yyval = make_node (nod_trim, (int) e_trim_count,
				MAKE_const_slong (blr_trim_both), NULL, yyvsp[-1]); }
break;
case 1238:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_trim_both); }
break;
case 1239:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_trim_trailing); }
break;
case 1240:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_trim_leading); }
break;
case 1241:
  if (!yytrial)
{ yyval = make_node (nod_udf, 2, yyvsp[-3], yyvsp[-1]); }
break;
case 1242:
  if (!yytrial)
{ yyval = make_node (nod_udf, 1, yyvsp[-2]); }
break;
case 1243:
  if (!yytrial)
{ yyval = make_node (nod_cast, (int) e_cast_count, yyvsp[-1], yyvsp[-3]); }
break;
case 1246:
  if (!yytrial)
{ yyval = make_node (nod_searched_case, 2,
				make_node (nod_list, 2, make_node (nod_eql, 2, yyvsp[-3], yyvsp[-1]),
				make_node (nod_null, 0, NULL)), yyvsp[-3]); }
break;
case 1247:
  if (!yytrial)
{ yyval = make_node (nod_searched_case, 2,
				make_node (nod_list, 2, yyvsp[-5], yyvsp[-3]), yyvsp[-1]); }
break;
case 1248:
  if (!yytrial)
{ yyval = make_node (nod_coalesce, 2, yyvsp[-3], yyvsp[-1]); }
break;
case 1249:
  if (!yytrial)
{ yyval = make_node(nod_simple_case, 3, yyvsp[-3], make_list(yyvsp[-1]), make_node(nod_null, 0, NULL)); }
break;
case 1250:
  if (!yytrial)
{ yyval = make_node(nod_simple_case, 3, yyvsp[-5], make_list(yyvsp[-3]), yyvsp[-1]); }
break;
case 1253:
  if (!yytrial)
{ yyval = make_node (nod_simple_case, 3, yyvsp[-2], make_list(yyvsp[-1]), make_node (nod_null, 0, NULL)); }
break;
case 1254:
  if (!yytrial)
{ yyval = make_node (nod_simple_case, 3, yyvsp[-4], make_list(yyvsp[-3]), yyvsp[-1]); }
break;
case 1255:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1256:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-4], make_node (nod_list, 2, yyvsp[-2], yyvsp[0])); }
break;
case 1257:
  if (!yytrial)
{ yyval = make_node (nod_searched_case, 2, make_list(yyvsp[-1]), make_node (nod_null, 0, NULL)); }
break;
case 1258:
  if (!yytrial)
{ yyval = make_node (nod_searched_case, 2, make_list(yyvsp[-3]), yyvsp[-1]); }
break;
case 1259:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1260:
  if (!yytrial)
{ yyval = make_node (nod_list, 2, yyvsp[-4], make_node (nod_list, 2, yyvsp[-2], yyvsp[0])); }
break;
case 1264:
  if (!yytrial)
{ yyval = make_node(nod_list, 2, yyvsp[-2], yyvsp[0]); }
break;
case 1265:
  if (!yytrial)
{ yyval = make_node(nod_list, 2, yyvsp[-4], make_node(nod_list, 2, yyvsp[-2], yyvsp[0])); }
break;
case 1266:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_gen_id2, 2, yyvsp[0],
						MAKE_const_slong(1));
			  else
				  yyval = make_node (nod_gen_id, 2, yyvsp[0],
						MAKE_const_slong(1));
			}
break;
case 1267:
  if (!yytrial)
{
			  if (client_dialect >= SQL_DIALECT_V6_TRANSITION)
				  yyval = make_node (nod_gen_id2, 2, yyvsp[-3], yyvsp[-1]);
			  else
				  yyval = make_node (nod_gen_id, 2, yyvsp[-3], yyvsp[-1]);
			}
break;
case 1268:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_year); }
break;
case 1269:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_month); }
break;
case 1270:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_day); }
break;
case 1271:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_hour); }
break;
case 1272:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_minute); }
break;
case 1273:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_second); }
break;
case 1274:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_millisecond); }
break;
case 1275:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_week); }
break;
case 1276:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_weekday); }
break;
case 1277:
  if (!yytrial)
{ yyval = MAKE_const_slong (blr_extract_yearday); }
break;
case 1282:
  if (!yytrial)
{ yyval = make_node (nod_null, 0, NULL); }
break;

  default:
    break;
  }

#if YYDEBUG && defined(YYDBPR)
  if (yydebug) {
    printf("yydebug[%d]: after reduction, result is ", yytrial);
    YYDBPR(yyps->val);
    printf("\n");
  }
#endif

  // Perform user-defined position reduction
#ifdef YYREDUCEPOSNFUNC
  if (!yytrial) {
    YYCALLREDUCEPOSN(YYREDUCEPOSNFUNCARG);
  }
#endif

  yyps->ssp -= yym;
  yystate = *(yyps->ssp);
  yyps->vsp -= yym;
  yyps->psp -= yym;

  yym = yylhs[yyn];
  if (yystate == 0 && yym == 0) {
#if YYDEBUG
    if (yydebug) {
      printf("yydebug[%d,%p]: after reduction, shifting from state 0 to state %d\n", 
	     int(yydepth), yytrial, YYFINAL);
    }
#endif
    yystate = YYFINAL;
    *++(yyps->ssp) = YYFINAL;
    *++(yyps->vsp) = yyps->val;
    yyretlval = yyps->val;	// return value of root non-terminal to yylval
    *++(yyps->psp) = yyps->pos;
    yyretposn = yyps->pos;	// return value of root position to yyposn
    if (yychar < 0) {
      if ((yychar = yylex1()) < 0) {
        yychar = 0;
      }
#if YYDEBUG
      if (yydebug) {
        yys = 0;
        if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
        if (!yys) yys = "illegal-symbol";
        printf("yydebug[%d,%p]: state %d, reading %d (%s)\n", 
	       int(yydepth), yytrial, YYFINAL, yychar, yys); 
      }
#endif
    }
    if (yychar == 0) goto yyaccept;
    goto yyloop;
  }

  if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
      yyn <= YYTABLESIZE && yycheck[yyn] == yystate) {
    yystate = yytable[yyn];
  } else {
    yystate = yydgoto[yym];
  }
#if YYDEBUG
  if (yydebug)
    printf("yydebug[%d,%p]: after reduction, shifting from state %d to state %d\n",
           int(yydepth), yytrial, *(yyps->ssp), yystate);
#endif
  if (yyps->ssp >= yyps->ss + yyps->stacksize - 1) {
    yyMoreStack(yyps);
  }
  *++(yyps->ssp) = yystate;
  *++(yyps->vsp) = yyps->val;
  *++(yyps->psp) = yyps->pos;
  goto yyloop;


  //
  // Reduction declares that this path is valid.
  // Set yypath and do a full parse
  //
yyvalid:
  if (yypath) {
    goto yyabort;
  }
  while (yyps->save) {
    yyparsestate *save = yyps->save;
    yyps->save = save->save;
    save->save = yypath;
    yypath = save;
  }
#if YYDEBUG
  if (yydebug)
    printf("yydebug[%d,%p]: CONFLICT trial successful, backtracking to state %d, %d tokens\n",
           int(yydepth), yytrial, yypath->state, int(yylvp - yylvals - yypath->lexeme));
#endif
  if (yyerrctx) {
    yyFreeState(yyerrctx);
    yyerrctx = NULL;
  }
  yychar = -1;
  yyps->ssp = yyps->ss + (yypath->ssp - yypath->ss);
  yyps->vsp = yyps->vs + (yypath->vsp - yypath->vs);
  yyps->psp = yyps->ps + (yypath->psp - yypath->ps);
  memcpy (yyps->ss, yypath->ss, (yyps->ssp - yyps->ss + 1) * sizeof(Yshort));
  yySCopy(yyps->vs, yypath->vs,  yyps->vsp - yyps->vs + 1);
  yyPCopy(yyps->ps, yypath->ps,  yyps->psp - yyps->ps + 1);
  yylvp = yylvals + yypath->lexeme;
  yylpp = yylpsns + yypath->lexeme;
  yylexp = yylexemes + yypath->lexeme;
  yystate = yypath->state;
  goto yyloop;


yyabort:
  if (yyerrctx) {
    yyFreeState(yyerrctx);
    yyerrctx = NULL;
  }

  YYSTYPE *pv;
  for(pv = yyps->vs; pv < yyps->vsp; pv++) {
    YYDELETEVAL(*pv, 2);
  }

  YYPOSN *pp;
  for(pp = yyps->ps; pp < yyps->psp; pp++) {
    YYDELETEPOSN(*pp, 2);
  }

  while (yyps) {
    yyparsestate *save = yyps;
    yyps = save->save;
    yyFreeState(save);
  }
  while (yypath) {
    yyparsestate *save = yypath;
    yypath = save->save;
    yyFreeState(save); 
  }
  return (1);


yyaccept:
  if (yyps->save) goto yyvalid;
  if (yyerrctx) {
    yyFreeState(yyerrctx);
    yyerrctx = NULL;
  }
  while (yyps) {
    yyparsestate *save = yyps;
    yyps = save->save;
    yyFreeState(save);
  }
  while (yypath) {
    yyparsestate *save = yypath;
    yypath = save->save;
    yyFreeState(save); 
  }
  return (0);
}


int Parser::yylex1()
{
  if (yylvp < yylve) {
    yylval = *yylvp++;
    yyposn = *yylpp++;
    return *yylexp++;
  } else {
    if (yyps->save) {
      if (yylvp == yylvlim) {
	yyexpand();
      }
      *yylexp = yylex();
      *yylvp++ = yylval;
      yylve++;
      *yylpp++ = yyposn;
      yylpe++;
      return *yylexp++;
    } else {
      return yylex();
    }
  }
}


int Parser::yyexpand()
{
  int p = yylvp - yylvals;
  int s = yylvlim - yylvals;
  s += YYSTACKGROWTH;
  { Yshort  *tl = yylexemes; 
    YYSTYPE *tv = yylvals;
    YYPOSN  *tp = yylpsns;
    yylvals = new YYSTYPE[s];
    yylpsns = new YYPOSN[s];
    yylexemes = new Yshort[s];
    memcpy(yylexemes, tl, (s - YYSTACKGROWTH) * sizeof(Yshort));
    yySCopy(yylvals, tv, s - YYSTACKGROWTH);
    yyPCopy(yylpsns, tp, s - YYSTACKGROWTH);
    delete[] tl;
    delete[] tv;
    delete[] tp;
  }
  yylvp = yylve = yylvals + p;
  yylvlim = yylvals + s;
  yylpp = yylpe = yylpsns + p;
  yylplim = yylpsns + s;
  yylexp = yylexemes + p;
  return 0;
}

